function [IN] = i0105_PwithinT (Pp, TV, tR, sP, nv, dim)

% RETURNS:
% IN = 1 if Pp lies within the triangle, = 0 if not

IN = 1 ;

% checks the 3 vector-sides

r = [TV(tR,1) TV(tR,2) TV(tR,3) TV(tR,1)];

v1 = zeros(dim,1);
v2 = zeros(dim,1);

for i = 1:1:3
    
    for di = 1:1:dim
        v1(di,1) = sP(r(i+1),di) - sP(r(i),di) ;
        v2(di,1) = Pp(di,1) - sP(r(i),di) ;
    end

    v = cross(v1,v2);
    v = v/norm(v);
    
    C = dot(nv,v);
    
    if C < 0
        IN = 0 ;
        break
    end
    
end



end

