function [nvv] = i0106_nVtx (vR, VT, Ae, PNe, dim)

% RETURNS:
% nvx(dim,1): normal to vertex

% INPUTS:
% vR: vtx ref where compute normal at
% VT: conn. matrix
% Ae: area of triangles
% PNe: normals of triangles


Aacc = 0;
Nacc = zeros(dim,1);
    
for t = 1:1:size(VT,2)
        
    if VT(vR,t) == 0
        
        break
        
    else
        
        tr = VT(vR,t);
        
        for di = 1:1:dim
            Nacc(di,1) = Nacc(di,1) + Ae(tr)*PNe(tr,di); 
        end
        
        Aacc = Aacc + Ae(tr);
        
    end
    
end
  

nvv = zeros(dim,1);
for di = 1:1:dim
    nvv(di,1) = Nacc(di,1)/Aacc; 
end

end

