function [Spatches] = i0107_PrefNURBS (FSpatches, Npa, padd, nX, nIn)

% applies refinement in each patch if required:



% TRANSFERS FROM "FIRST PATCHES":

Spatches(Npa,1) = cPatch;

for pa = 1:1:Npa
   
    Spatches(pa,1).pudim = FSpatches(pa,1).pudim;
    Spatches(pa,1).nbe   = FSpatches(pa,1).nbe;
    Spatches(pa,1).Rbe   = FSpatches(pa,1).Rbe;
    
    Spatches(pa,1).mGskin = FSpatches(pa,1).mGskin ;
    Spatches(pa,1).Ngsk   = FSpatches(pa,1).Ngsk;

    Spatches(pa,1).trpF = FSpatches(pa,1).trpF  ;
   
end


% REFINEMENT:

for pa = 1:1:Npa
    
    % 1.- Un-refined patch NURBS features:
    
    pudim = 3;
    pxdim = 3;

    uNcp    = FSpatches(pa,1).INS(1,1).mNcp;
    uDegree = FSpatches(pa,1).INS(1,1).mDegree;
    uKnotV  = FSpatches(pa,1).INS(1,1).mKnotV;
    uP      = FSpatches(pa,1).INS(1,1).mP;
    uw      = FSpatches(pa,1).INS(1,1).mw;
    uUsize  = FSpatches(pa,1).INS(1,1).mUsize;
    
    
    % 2.- Reduces cps if indicated:
    
    [uNcp, uDegree, uKnotV, uP, uw, uUsize] = GEN_0390_kRem_approx ...
	(uNcp, uDegree, uKnotV, uP, uw, uUsize, nX, pudim, pxdim, pa);
    
    
    tINS = cPINS;
    unoc = prod(uNcp);
    

    % 3.- Refines:
    
    [rNcp, rDegree, rKnotV, rP, rw, rnoc, rUsize] = GEN_0300_NURBSrefnt...
    (uNcp, uDegree, uKnotV, uP, uw, unoc, uUsize, padd, nX, nIn, pudim, pxdim, pa);


    % 4.- computes expanded cp's coords and allocates:
    
    [rEw,rEP] = GEN_12_ExpandBw (rw, rP ,pxdim, pudim, rNcp);
    
    tINS.mDegree = rDegree ;
    tINS.mKnotV  = rKnotV;
    tINS.mUsize  = rUsize;

    tINS.mNcp   = rNcp;
    tINS.mP     = rP;
    tINS.mw     = rw;
    tINS.mEP    = rEP;
    tINS.mEw    = rEw;
    
    tINS.mNsk = FSpatches(pa,1).INS(1).mNsk;
    tINS.skin = FSpatches(pa,1).INS(1).skin ;
    
    tINS.mNacp = prod(rNcp);
    

    Spatches(pa,1).INS(1,1) = tINS ;
    
    clearvars 'tINS';
    
    %{
    Spatches(pa,1).INS(1).mDegree = rDegree;
    Spatches(pa,1).INS(1).mKnotV  = rKnotV;
    Spatches(pa,1).INS(1).mUsize  = rUsize;

    Spatches(pa,1).INS(1).mNcp   = rNcp;
    Spatches(pa,1).INS(1).mP     = rP;
    Spatches(pa,1).INS(1).mw     = rw;
    Spatches(pa,1).INS(1).mEP    = rEP;
    Spatches(pa,1).INS(1).mEw    = rEw;
    %}
 
end



end

