function [Spatches] = i0109_iniPatch (Npa, FgPatch, tFace)

pudim = 3 ;
pxdim = 3 ;

Spatches(Npa,1) = cPatch ;

for pa = 1:1:Npa
    
    Spatches(pa,1).pudim = 3;
  	Spatches(pa,1).nbe   = FgPatch(pa).nbe;
    Spatches(pa,1).Rbe   = FgPatch(pa).Rbe;
    
    % trimming flag:
    
    Spatches(pa,1).trpF = 0 ; % assumes untrimmed, changes if any tFace is trimming

    for s = 1:1:tFace(pa).Nfa
        
        if tFace(pa).mSur(s).Tr == 1
            Spatches(pa,1).trpF = 1 ;
            break
        end
        
    end 
   

    % NURBS features:
    
    fNcp    = FgPatch(pa,1).Ncp;
    fDegree = FgPatch(pa,1).Degree;
    fKnotV  = FgPatch(pa,1).KnotV;
    fP      = FgPatch(pa,1).P;
    fw      = FgPatch(pa,1).w;
    fUsize  = FgPatch(pa,1).Usize;
    
    [fEw,fEP] = GEN_12_ExpandBw (fw, fP ,pxdim, pudim, fNcp);
    
    tINS = cPINS;
    
	tINS.mDegree = fDegree ;
    tINS.mKnotV  = fKnotV;
    tINS.mUsize  = fUsize;

    tINS.mNcp   = fNcp;
    tINS.mP     = fP;
    tINS.mw     = fw;
    tINS.mEP    = fEP;
    tINS.mEw    = fEw;
    
    Nacp = 1 ;
    for di = 1:1:pudim
        Nacp = Nacp*fNcp(di);
    end
    tINS.mNacp = Nacp ;
    
    Spatches(pa,1).INS(1,1) = tINS ;
    
    clearvars 'tINS';
  
end



end

