function [R, dRpa] = a0112_RdRgp (Nicp, Ricp, BF, BFdir, dBFdir, pw, udim)

% RETURNS:
% R(Nicp,1): NURBS basis functions at that GP


% 0.- PRELIMINARY SIZES:

W = 0 ;

% derivatives wrt u(1), u(2), u(3)
dW      = zeros(udim, 1); 

B = BF ;
Bdir = BFdir ;
dBdir = dBFdir ;

dB = zeros(Nicp,udim); % derivative of B-spline BF's w.r.t each direction

% 1.- WEIGHT AND ITS DERIVATIVES, AND DERIVATIVES:

for i = 1:1:Nicp

    % anchor ref.
    aR = Ricp(i); 
    
    
    % weight:
	W = W + B(i) * pw(aR);
    

    % derivatives of B-spline function and weight:
    for di=1:1:udim

        dB(i,di) = 1 ; 

        for di2 = 1:1:udim
            if di2 == di
                dB(i,di) = dB(i,di) * dBdir(i,di2);
            else
                dB(i,di) = dB(i,di) * Bdir(i,di2);
            end
        end
        
        dW(di,1) = dW(di,1) + dB(i,di)* pw(aR);

    end

    
end


% 2.- NURBS BASIS FUNCTIONS AND ITS DERIVATIVES wrt PARAM. DIRS:

R    = zeros(Nicp,1);
dRpa = zeros(Nicp,udim);

for i = 1:1:Nicp
    
    % anchor ref.
    aR = Ricp(i); 
    
    % basis function:
    R(i,1) = B(i)*pw(i)/W;
    
    % derivatives:
    for di = 1:1:udim
        dRpa(i,di) =  pw(aR)/W^2 * ( dB(i,di) * W - B(i)*dW(di) )  ;
    end
    
end





end

