function [elem] = a0113_icpEinitial (elem, Anet, Degree, Ncp, udim)

% RETURNS:
% elem(e) object with
% icp's for each element in index space at the begining, when the domain is
% as B-spline defined

% INPUTS:
% Anet(i,j,k): anchor ref. according to position, initially is as B-splines


Ndir = zeros(udim,1); % No. anchors in each direction
dir = zeros(udim,1); % direction of anchors in Anet, '1' might grow to Ndir

contaEi = 0 ;

for i = 1:1:Ncp(1)+Degree(1)
    
    [Ndir(1), dirBF] = a0114_NRicpOneDir (Degree(1), Ncp(1), i);
    for a = 1:1:Ndir(1)
   	dir(1,a) = dirBF(a);
    end
    
    for j = 1:1:Ncp(2)+Degree(2)
    
        [Ndir(2), dirBF] = a0114_NRicpOneDir (Degree(2), Ncp(2), j);
        for a = 1:1:Ndir(2)
      	dir(2,a) = dirBF(a);
        end
   
        for k = 1:1:Ncp(3)+Degree(3)
            
            [Ndir(3), dirBF] = a0114_NRicpOneDir (Degree(3), Ncp(3), k);
            for a = 1:1:Ndir(3)
           	dir(3,a) = dirBF(a);
            end
            

            % allocates:
            
            contaEi = contaEi + 1 ;
            
            Nicp = 1 ;
            for d = 1:1:udim
                Nicp = Nicp * Ndir(d);
            end
     
            RicpA = zeros(1,1); % '1' will grow up to Nicp
            contaA = 0 ;
            for i2 = 1:1:Ndir(1)
           	for j2 = 1:1:Ndir(2)
          	for k2 = 1:1:Ndir(3)
                
                contaA = contaA + 1 ;
                RicpA(contaA,1) = Anet(dir(1,i2), dir(2,j2), dir(3,k2));
            end
           	end
            end
            
            elem(contaEi).mNicp  = Nicp ;
            elem(contaEi).mRicpA = RicpA ;
            
        end
    end
end




end

