function [aLKV, aULims, kc] = a0115_aLKV (p, U, i)

% RETURNS:
% aLKV: Local knot vector for one anchor
% aULims(2,1): its limits
% kc: central position within the global knot vector

% INPUTS:
% p,U: degree and knot vector
% i: order of anchor in the NURBS

% center in U
kc = (p+1)/2 + 1 + (i-1);

% No. position each side:
nps = (p+1)/2;

% first and last positions:
fp = kc-nps;
lp = kc+nps;




% fills responses:

aLKV = zeros(2*nps,1);
aULims = zeros(2,1);

k = 0 ;
for j = fp:1:lp
    
    k = k+1;
    aLKV(k,1) = U(j);
    
    if j==fp
        aULims(1) = U(j);
    elseif j==lp
        aULims(2) = U(j);
    end
end



end

