function [ON, NEsk, EskR] = a0116_aON_sks (pR, pnbe, pRbe, Eskin, TTR, aULims, pudim)

% RETURNS:
% ON = 1 if anchor is activated
% EskR(NEsk): Eskins that trim the anchor ULims 


% works in patch param. space

ON = 0 ;
Tr = 0 ;
NEsk = 0 ;
EskR = zeros(1,1);

% center of anchor in parameter space
Actr= zeros(pudim,1);
for di = 1:1:pudim
    Actr(di) = (aULims(di,1) + aULims(di,2))/2;
end

% 1.- CHECKS B.E. SKINS:

% the purpose is:
% - store Eskins that trim the anchor
% - find out if is a trimmed anchor
% - store the closest point of the closest BE

dmin = 9999 ;
cb = 0; % closest BE 



for b = 1:1:pnbe  
    
    bR  = pRbe(b);
    
    % detects coupling and if is master or slave
    couR = Eskin(bR).mCou; 

    epaR = Eskin(bR).mPa ;
    
    flagSP = 0; % flag of slave patch
    
    if couR > 0
        
        if epaR(1) == pR
            
            flagSP = 0;
            
        elseif epaR(2) == pR
            
            flagSP = 1;
            
        end
        
    end
    

    % 1.1.- Checks skin integration points:
    
    Ngp =  Eskin(bR).mNgp;
    u = zeros(pudim,1);

    for g = 1:1:Ngp
    
        if flagSP==0
            
            u(:,1) = Eskin(bR).mGP(g).mAcoor(:);
            
        elseif flagSP==1
            
            u(:,1) = Eskin(bR).mGP(g).mAcoorS(:);
            
        end
        
        d = norm(u-Actr);
        if d < dmin
            cb = bR ;
            dmin = d ;
        end
        
        sIN = GEN_08_Orthodom_Pin_ndec (u, aULims, pudim, 'closed', 9);
        
        if sIN == 1
            
        	NEsk = NEsk + 1;
            EskR(NEsk,1) = bR;
            Tr = 1 ;
            break   
            
        end     
    end
end


% 2.- THEN CHECKS IF IS IN:

if Tr == 1
    
    % 2.1.- If is trimmed is IN:
    
    ON = 1 ;

elseif Tr == 0
    
    % 2.2.- If not trimmed needs further check:
    % uses TTR
    
	tNV = TTR.tNV;
 	tTVcon = TTR.tTVcon;        % NEED IMPROVEMENT WITH SLAVE CASE !!!!1
 	tVTcon = TTR.tVTcon;
  	tAv = TTR.tAv;
  	tANv = TTR.tANv;
   	tANe = TTR.tANe;
    
    ON = i0102_pIN_3 (Actr, tNV, tTVcon, tVTcon, tAv, tANv, tANe, 3, 'closed');

end


end

