function [Spatches] = a0117_IniAnchors (Spatches, Npa)

% RETURNS:
% Spatches: with anchors data (except those that are In/OUt)

pxdim = 3 ;
pudim = 3 ;

for pa = 1:1:Npa

    Ncp     = Spatches(pa,1).INS(1).mNcp;
    Degree  = Spatches(pa,1).INS(1).mDegree;
    KnotV   = Spatches(pa,1).INS(1).mKnotV;
    Usize   = Spatches(pa,1).INS(1).mUsize;
    P       = Spatches(pa,1).INS(1).mP;
    w       = Spatches(pa,1).INS(1).mw;
    Nacp    = Spatches(pa,1).INS(1).mNacp;
    

    % 1.- INITIATES ANCHORS CLASS & AUX. VECTORS:

    CP(Nacp,1) = cCpoint ;
    U = zeros(1,max(Usize)); % global knot vector in one direction


    % 2.- PARAM. COORD'S. and INDEXES:

    a = 0 ;
    
    for i=1:1:Ncp(1)

        for j=1:1:Ncp(2)
        for k=1:1:Ncp(3)  

            a = a+1;
            IX = [i,j,k];

            Acoor = zeros(pudim,1);
            
            for di=1:1:pudim

                if di==1
                    x = i ;
                elseif di==2
                    x = j ;
                elseif di==3
                    x = k ;
                end

                U(:) = KnotV(di,:);
                index = (Degree(di)+3)/2 + x - 1 ;

                u = GEN_34_ParamFromIndex (index, U);

                Acoor(di,1) = round (u,5) ;

            end

            CP(a,1).mAcoor = Acoor ;
            CP(a,1).mIX = IX;

        end    
        end
    end


    %CP(11,1).mAcoor
    
    % 3.- PHYSICAL COORD'S:

    for a = 1:1:Nacp

        CP(a,1).mw = w(a);

        for di=1:1:pxdim
            CP(a,1).mXcoor(di)  = P(a,di);
        end

    end



    % 4.- PARAM. LIMITS:

    a = 0 ;
    U = KnotV(1,1:Usize(1));
    V = KnotV(2,1:Usize(2));
    W = KnotV(3,1:Usize(3));

    for i = 1:1:Ncp(1) 

        [~,ALims,~] = a0115_aLKV (Degree(1), U, i);

        for j = 1:1:Ncp(2)

            [~,VLims,~] = a0115_aLKV (Degree(2), V, j);

            for k = 1:1:Ncp(3)

                [~,WLims,~] = a0115_aLKV (Degree(3), W, k);

                a = a + 1;

                CP(a,1).mAcoLi(1,1)= ALims(1);
                CP(a,1).mAcoLi(1,2)= ALims(2);
                CP(a,1).mAcoLi(2,1)= VLims(1);
                CP(a,1).mAcoLi(2,2)= VLims(2);
                CP(a,1).mAcoLi(3,1)= WLims(1);
                CP(a,1).mAcoLi(3,2)= WLims(2);
 
            end 
        end
    end

    
    % 5.- ALLOCATES:
    
    Spatches(pa,1).INS(1).mNacp = Nacp;
    Spatches(pa,1).INS(1).mCP  = CP;

    clearvars('Nacp','CP');
    
end


end