function [Spatches] = a0118_VPicp (Spatches, pR, tol)

% RETURNS:
% Patches with vertex of skins with icp's and parameter variables computed.

% 1.- PRELIMINARIES:

pudim = 3 ;

pNcp     = Spatches(pR,1).INS(1,1).mNcp ;
pDegree  = Spatches(pR,1).INS(1,1).mDegree ;
pKnotV   = Spatches(pR,1).INS(1,1).mKnotV ;
pw       = Spatches(pR,1).INS(1,1).mw ;

Nacp     = Spatches(pR,1).INS(1,1).mNacp ;
CP       = Spatches(pR,1).INS(1,1).mCP; 

Nsk      = Spatches(pR,1).INS(1,1).mNsk ;
skin     = Spatches(pR,1).INS(1,1).skin ;



for s = 1:1:Nsk
    
    NV = skin(s,1).mNV ;
    VP = skin(s,1).mVP ;
    
  	vNicp = zeros(NV,1);
	vRicp = zeros(NV,1); % "1" will grow

	vBF   = zeros(NV,1); % influential B-spline basis functions value at each point

	vBFdir  = zeros(NV,1,pudim); % influential B-splines basis function values at each GP, but separated by pram. direction
	vdBFdir = zeros(NV,1,pudim); % and 1st derivatives in each direction


    
    % 2.- COMPUTES icp's, AND B-SPLINE BF's & THEIR DERIVATIVES:

    for v = 1:1:NV
        


        vAcoor = VP(v,1).mAcoor;

        % searches icp's (only considers those ones ON):
        
        for c = 1:1:Nacp
        if CP(c,1).ON == 1
            
            cALims = zeros(pudim,2);
            cALims(:,:) = CP(c,1).mAcoLi(:,:);
            
            IN = GEN_08_Orthodom_Pin_ndec (vAcoor, cALims, pudim, 'closed', 6);
            
            if IN==1
            
                br = CP(c,1).mIX;

                % evaluates b. function and its derivatives:
                [d1Ni, Ni] = z2702_d1NML (vAcoor, br, pNcp, pDegree, pKnotV, pudim);

                % accounts only if any derivative Or fucntion > 0
                if sum(abs(d1Ni)) > tol || abs(prod(Ni)) > tol

                    vNicp(v,1) = vNicp(v,1) + 1 ;
                    vRicp(v,vNicp(v,1)) = c ;
                    
                    vBF(v,vNicp(v,1)) = prod(Ni) ;

                    for di = 1:1:pudim
                        vdBFdir(v,vNicp(v,1),di) = d1Ni(di);
                        vBFdir (v,vNicp(v,1),di) = Ni(di);
                    end
                end
                
            end
        end    
        end
    end


    
    % 3.- COMPUTES BF'S AND DERIVATIVES, OF NURBS, AND ALLOCATES:
    
    for v = 1:1:NV
    
        % Extracts vertex info:

        Nicp = vNicp(v,1);
        Ricp = vRicp(v,1:Nicp);
        BF   = vBF(v,1:Nicp);
        
        dBFdir = zeros(Nicp,pudim);
        BFdir  = zeros(Nicp,pudim);
        
        for c = 1:1:Nicp
            dBFdir(c,:) = vdBFdir(v,c,:);
            BFdir(c,:)  = vBFdir(v,c,:);
        end
        
        % Computes Bf's and drivatives:

        [R, dRpa] = a0112_RdRgp (Nicp, Ricp, BF, BFdir, dBFdir, pw, pudim);


        % Allocates:

        VP(v,1).mNicp = vNicp(v,1);

        for i = 1:1:vNicp(v,1)

            VP(v,1).mRicp(i,1) = vRicp(v,i);
            VP(v,1).Rrel(i,1) = R(i);

            for di = 1:1:pudim
                VP(v,1).dRpa(i,di) = dRpa(i,di);
            end
        end

    
    end
    
    
    % allocates:
    
    skin(s,1).mVP = VP ;
    
    clearvars 'VP' ;
    
end


% allocates:
Spatches(pR,1).INS(1,1).skin = skin ;


end