function [sg, Nps] = im0142_Segments (pNcp, pEP, Nmin, Rt, pxdim, pudim)

% RETURNS;

% sg(u,i,j,h,N, pxdim): segments points coordinates
%   u: 3 param directs
%   i,j: perp. directions location
%   h: No. segments in u direction
%   N: No. points of that segment

% Nps(u,i,j,n): No. points per segment 

% INPUTS:
% pd1: perpendicular direction 1
% pd2: perpendicular direction 2
% ld: long. direction

sg = zeros(pudim,max(pNcp),max(pNcp),max(pNcp)-1,1,pxdim);
Nps = zeros(pudim,max(pNcp),max(pNcp),max(pNcp)-1); % No. points for each segment

x1 = zeros(pxdim,1);
x2 = zeros(pxdim,1);

pd = [2 3 ; 1 3 ; 1 2 ]; % perp. directions

for ld = 1:1:pudim

    pd1 = pd(ld,1);
    pd2 = pd(ld,2);
    
    % loop on perp. directions
    for i = 1:1:pNcp(pd1)
    for j = 1:1:pNcp(pd2)

        % runs on segments
        for h = 1:1:pNcp(ld)-1

            if ld==1
             	x1(:,1) = pEP(h+0,i,j,:);
                x2(:,1) = pEP(h+1,i,j,:);
            elseif ld==2
             	x1(:,1) = pEP(i,h+0,j,:);
                x2(:,1) = pEP(i,h+1,j,:); 
            elseif ld==3
             	x1(:,1) = pEP(i,j,h+0,:);
                x2(:,1) = pEP(i,j,h+1,:); 
            end
            
            Lp = 0 ;
            if h == pNcp(ld)-1 % last point flag
                Lp = 1 ;
            end

            [N, sd] = go2531_DivSegment (x1, x2, Nmin, Rt, pxdim, Lp);
            Nps(1,i,j,h) = N ;

            for po = 1:1:N
                for di = 1:1:pxdim
                sg(ld, i,j,h, po, di) = sd(po,di);
                end
            end

        end
    end
    end

end

end

