function [Ngp, GP] = im0144_patchGPs ...
    (NE, EVcon, Nve, Eiem, tAnod, pKnotV, pNcp, pDegree, pUsize, pEw, pEP, pudim, pxdim)

% RETURNS:
% Ngp: No. integration points of the patch
% GP(Ngp,1): matrix of GP's object

Ngp = 0 ;
GP(1,1) = cGPpa ;

iem = zeros(4,4);

for e = 1:1:NE
    
    % No. integration points per element: 1 or 4 for linear and quadratic
    
    if Nve(e,1) == 4   
        Nge = 1 ;
    elseif Nve(e,1) > 4  
        Nge = 4 ;
    end

    % inserted-edges matrix:
    iem(:,:) = Eiem(e,:,:);
    
    % nodes Acoord:
    Anod = zeros(Nve(e,1),pudim);
    for i = 1:1:Nve(e,1)
        Anod(i,:) = tAnod(EVcon(e,i),:);
    end
    
    % gp's in parent space & weights:
    
    [GPpc, GPw] = ip2304_GP_tet(Nge); 

    r = zeros(pudim,1); % parent coordinates
    
    for g = 1:1:Nge
        
        Ngp = Ngp + 1 ;
        
        r(:,1) = GPpc(g,:);

        % computes GP in parameter space:
        [Acoor, ~, detJ2] = mp1353_TETmapp (r, Anod, pudim, pudim, iem);
        
        
        
        % computes in physical space:
        Xcoor = b2601_BNURBS_Xcoord (Acoor, pKnotV, pNcp,pDegree,pUsize, pEw,pEP, pudim,pxdim);
        
        % Allocates:
        
        GP(Ngp,1).mAcoor = Acoor ;
        GP(Ngp,1).mXcoor = Xcoor ;

        GP(Ngp,1).dJ2a = abs(detJ2)*GPw(g) ;
        
        % internal variables:  
        GP(Ngp,1).mSv = zeros(6,1); % stresses
    	GP(Ngp,1).mVM = 0;
     	GP(Ngp,1).mPst = zeros(3,1);
    	GP(Ngp,1).mPdi = zeros(3,3);
            
    end
end


end

