function [pNn, pNE,  pXv, pAv, pEVcon, pDT] = im0145_tetGross (NGd, KnotV, Ncp, Degree, Usize, Ew, EP, xdim, udim)

% RETURNS: 
% preliminary location of tet's nodes without considering trimming surfaces
% i.e. for gross surfaces

% INPUTS:
% NGd(udim,1): no. rquired gps in each direction


% 1.- PRELIMINARIES:

[V, Vsize] = GEN_18_UnonVoid (KnotV, Usize, Degree, udim); % knots of non-void spans

NR = NGd; % No,. req'd GPs in each direciton

ULims = [ 0 1 ; 0 1 ; 0 1 ];



% 2.- TETRAHEDRALATION: 

[pNn, pNE, pAv, pEVcon, pDT] = im0155_untrimTets(NR, ULims, V, Vsize);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% %%%%%%%%%%%%%%%%%%%%%%%%%
% represents the whole tets:
%{
fr = 1 ;
unod = zeros(4,3);
dim = 3 ;

for e = 1:1:pNE
    
    for i = 1:1:4
        unod(i,:) = pAv(pEVcon(e,i),:);
    end
    pt1362_pTet (unod, dim, fr, 'k', 1, 1,0);

end

if gg==0
end

%}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% %%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% %%%%%%%%%%%%%%%%%%%%%%%%%
% represents face tets:
%{

fr = 2 ;

figure(fr)

unod = zeros(4,3);
pudim = 3 ;

u1 = zeros(pudim,1);
u2 = zeros(pudim,1);

r = [ 1 2 3 4 4 4 ; 2 3 1 1 2 3 ] ;

ULims = [0 0 1 ] ;

for e = 1:1:pNE
    
    for i = 1:1:4
        unod(i,:) = pAv(pEVcon(e,i),:);
    end
    
    for j = 1:1:6
     
        u1(:,1) = unod(r(1,j),:);
        u2(:,1) = unod(r(2,j),:);
        
        pF = 0 ;
        for k = 1:1:pudim
            if (u1(k)==u2(k)) && (u1(k)==ULims(k) || u2(k)==ULims(k)) 
                pF = 1 ;
                break
            end
        end
        
        if pF==1
        plot3( [u1(1) u2(1)] , [u1(2) u2(2)] , [u1(3) u2(3)] ,'k'); hold on
        end
    end
    
end

axis equal

if gg==0
end

%}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% %%%%%%%%%%%%%%%%%%%%%%%%%


% 3.- PHYSICAL COORDINATES:

pXv = zeros(pNn, xdim);
a = zeros(udim,1);

for i = 1:1:pNn

    a(:,1) = pAv(i,:);
 
    x = b2601_BNURBS_Xcoord (a, KnotV, Ncp, Degree,Usize, Ew,EP, udim, xdim);
    pXv(i,:) = x(:,1);

end


end

