function [NBT, BTVcon, BTScon] = im0150_TetbTri (NE, NV, Xv, Av, EVcon, DUtol)

udim = 3 ;
xdim = 3 ;
ULims = [ 0 1 ; 0 1 ; 0 1 ];

NBT = 0 ;               % No. boundary triangles
BTVcon = zeros(1,3) ;   % b-triang to vertexes conn.
BTScon = zeros(1,1); % b-triang to boundary surface conn. (1 to 6, perp to: chi, ita, xi)

r = [1 2 3 ; 4 3 2 ; 4 1 3 ; 4 2 1 ]; % nodes refs for each tet-face

for e = 1:1:NE
    
    % searches faces at the boundary
    for f = 1:1:4
        
        nR = [EVcon(e,r(f,1)) EVcon(e,r(f,2)) EVcon(e,r(f,3))];
        Anod = zeros(3,udim);
        
        % stores nodes of that face:
        for i = 1:1:3
            for di = 1:1:udim  
                a = go2532_RoundToR (Av(nR(i),di) , 2*DUtol);
                Anod(i,di) = a ;  
            end
        end
        
        % checks if it is at boudnary (compares if any coord is the same),
        % also stores which surface belongs to.
        
        bF = 0 ;  % boundary flag
        for col = 1:1:udim
            
            f1 = Anod(1,col);
            conta = 1 ;
            
            for fil = 2:1:3 
                if Anod(fil,col)==f1
                    conta = conta + 1;
                end
            end
            
            
            if conta == udim && f1 == (ULims(col,1) || f1 == ULims(col,2))
                
                bF = 1 ;
                
                if     col==3 && f1==ULims(col,1)
                    sR = 1 ;
                elseif col==3 && f1==ULims(col,2)
                    sR = 2 ;
                elseif col==2 && f1==ULims(col,1)
                    sR = 3 ;
                elseif col==2 && f1==ULims(col,2)
                    sR = 4 ;
                elseif col==1 && f1==ULims(col,1)
                    sR = 5 ;
                elseif col==1 && f1==ULims(col,2)
                    sR = 6 ;
                end
                
                break
                
            end
            
        end

        
        % adds triangle if it is at boundary:
        
        if bF == 1
            
            NBT = NBT + 1 ;
            
            for i = 1:1:3
                BTVcon(NBT,i) = nR(i) ;
            end

            BTScon(NBT,1) = sR ;
            
        end
        
        
        
    end
    
end



end

