function [Ngp, GP] = rm0161_Rmesh (NGd, Degree, Ncp, KnotV, Usize, Ew,EP)

xdim = 3 ;
udim = 3 ;

% No. non-void elements and total No. required Gauss points:

[nvU, nvUsize] = GEN_18_UnonVoid (KnotV, Usize, Degree, udim);

Ngp = prod(NGd);

NGEd = zeros(udim,1);
for di = 1:1:udim
    NGEd(di,1) = NGd(di)/(nvUsize(di)-1);
end


% Parent coord's and weight in each direction:

Rg = zeros(udim,1); % '1' will grow
wg = zeros(udim,1);

for di = 1:1:udim
    
    [GPpc, GPw] = ip2301_GP_1D (NGEd(di));
    
    for g = 1:1:NGEd(di)   
        Rg(di,g) = GPpc(g);
        wg(di,g) = GPw(g);
    end
end




% Declares GP and fills its members:

Nve = 8 ;               % No. vertexes per element
Av = zeros(Nve,udim);   % vertexes parameter coords (arranged hierarchically)

uN = 0 ;

GP(Ngp,1) = cGPpa ;

g = 0 ;

for a = 1:1:nvUsize(1)-1
for b = 1:1:nvUsize(2)-1
for c = 1:1:nvUsize(3)-1
    
    % elemetn vtx param coords:
    Av(1,1) = nvU(1,a);     Av(1,2) = nvU(2,b);     Av(1,3) = nvU(3,c);
	Av(2,1) = nvU(1,a);     Av(2,2) = nvU(2,b);     Av(2,3) = nvU(3,c+1);
	Av(3,1) = nvU(1,a);     Av(3,2) = nvU(2,b+1);   Av(3,3) = nvU(3,c);
 	Av(4,1) = nvU(1,a);     Av(4,2) = nvU(2,b+1);   Av(4,3) = nvU(3,c+1);
    
    Av(5,1) = nvU(1,a+1);   Av(5,2) = nvU(2,b);     Av(5,3) = nvU(3,c);
	Av(6,1) = nvU(1,a+1);   Av(6,2) = nvU(2,b);     Av(6,3) = nvU(3,c+1);
	Av(7,1) = nvU(1,a+1);   Av(7,2) = nvU(2,b+1);   Av(7,3) = nvU(3,c);
 	Av(8,1) = nvU(1,a+1);   Av(8,2) = nvU(2,b+1);   Av(8,3) = nvU(3,c+1);
    
    
    for i = 1:1:NGEd(1)
    for j = 1:1:NGEd(2)
    for k = 1:1:NGEd(3)

        g = g+1;
        
        % parent coordinates and weight:
        
        r = [Rg(1,i);Rg(2,j);Rg(3,k)];
        w = wg(1,i)*wg(2,j)*wg(3,k);
        
        
        % Param. and phys. coordinates:
        
        Acoor = m2321_parentMapping (r, Av, udim, Nve);
        Xcoor = b2601_BNURBS_Xcoord (Acoor, KnotV, Ncp, Degree,Usize, Ew,EP, udim, xdim);

        
        % Aggregated Jacobian J2a:

        [~, dJ2] = j2314_Jcuboid (r, Av) ;
        dJ2a = dJ2*w ;
  
        
    	% Allocates:
        
        GP(g,1).mAcoor = Acoor ;
        GP(g,1).mXcoor = Xcoor ;

        GP(g,1).dJ2a = dJ2a ;
        
        % internal variables:  
        GP(g,1).mSv = zeros(6,1); % stresses
    	GP(g,1).mVM = 0;
     	GP(g,1).mPst = zeros(3,1);
    	GP(g,1).mPdi = zeros(3,3);
        
    end
    end 
    end
    
end
end
end





end

