function [ur] = pd0170_prescribedDispl (DoF, pNcp, pDegree, pKnotV, pUsize, pEP, pEw, pP, pw, pxdim, Xtol, DUtol)


% 1.- PRELIMINARY OPERATIONS:

ur = zeros(DoF,1);

ARcon = zeros(pNcp(1),pNcp(2),pNcp(3)); % Abs. to relative references

conta = 0;
for i = 1:1:pNcp(1)
for j = 1:1:pNcp(2)
for k = 1:1:pNcp(3)
    conta = conta + 1 ;
    ARcon(i,j,k) = conta;
end
end
end


% 2.- EDGES CURVES CP's:

rdi = 1 ; % relevant direction

for j = 1:pNcp(2)-1:pNcp(2)
for k = 1:pNcp(3)-1:pNcp(3)
    
    n = pNcp(rdi) ;
    
	% abs. refences of involved nodes:
   	r = zeros(n-2,1);
    for i = 2:1:n-1
        r(i-1,1) = ARcon(i,j,k);
    end
    
    % extracts curve and updates displacement vector:
    [P,w,p,n,U] = sx1501_edgeCurve (rdi, [i k], pNcp, pDegree, pKnotV, pUsize, pEP, pEw, pxdim);
    [ur] = pd0171_pdEdgeCurves (ur, r, P,w,p,n,U, pxdim, Xtol, DUtol);
    
end
end


rdi = 2 ; % relevant direction

for i = 1:pNcp(1)-1:pNcp(1)
for k = 1:pNcp(3)-1:pNcp(3)
    
    n = pNcp(rdi) ;
    
	% abs. refences of involved nodes:
   	r = zeros(n-2,1);
    for j = 2:1:n-1
        r(j-1,1) = ARcon(i,j,k);
    end
    
    % extracts curve and updates displacement vector:
    [P,w,p,n,U] = sx1501_edgeCurve (rdi, [i k], pNcp, pDegree, pKnotV, pUsize, pEP, pEw, pxdim);
    [ur] = pd0171_pdEdgeCurves (ur, r, P,w,p,n,U, pxdim, Xtol, DUtol);
    
end
end



rdi = 3 ; % relevant direction

for i = 1:pNcp(1)-1:pNcp(1)
for j = 1:pNcp(2)-1:pNcp(2)
    
    n = pNcp(rdi) ;
    
	% abs. refences of involved nodes:
   	r = zeros(n-2,1);
    for k = 2:1:n-1
        r(k-1,1) = ARcon(i,j,k);
    end
    
    % extracts curve and updates displacement vector:
    [P,w,p,n,U] = sx1501_edgeCurve (rdi, [i j], pNcp, pDegree, pKnotV, pUsize, pEP, pEw, pxdim);
    [ur] = pd0171_pdEdgeCurves (ur, r, P,w,p,n,U, pxdim, Xtol, DUtol);
    
end
end


% 3.- SURFACES CP'S:

sdi = [ 2 3 ; 1 3 ; 1 2 ];

%{
rdi = 3 ;
for k = 1:pNcp(rdi)-1:pNcp(rdi)
    
    d1 = sdi(rdi,1);
    d2 = sdi(rdi,2);
    
    n = pNcp(d1);
    m = pNcp(d2);
    
	% abs. ref's of involved nodes:
    
   	r = zeros((n-2)*(m-2),1);
    conta = 0;
    for i = 2:1:n-1
    for j = 2:1:m-1
        
        conta = conta+1;
        r(conta,1) = ARcon(i,j,k);
        
    end  
    end
    
    % extracts surface and updates displacement vector:
    [sP, sw, sEP, sEw, sDegree, sNcp, sKnotV, sUsize] = sx1502_Surface (rdi, k, pNcp, pDegree, pKnotV, pUsize, pEP, pEw, pxdim);
    [ur] = pd0172_pdSurfaces (ur, r, sP, sw, sEP, sEw, sDegree, sNcp, sKnotV, sUsize, pxdim, Xtol, DUtol);

end


rdi = 2 ;
for j = 1:pNcp(rdi)-1:pNcp(rdi)
    
    d1 = sdi(rdi,1);
    d2 = sdi(rdi,2);
    
    n = pNcp(d1);
    m = pNcp(d2);
    
	% abs. ref's of involved nodes:
    
   	r = zeros((n-2)*(m-2),1);

    conta = 0;
    for i = 2:1:n-1
    for k = 2:1:m-1
        
        conta = conta+1;
        r(conta,1) = ARcon(i,j,k);
        
    end  
    end
    
    % extracts surface and updates displacement vector:
    [sP, sw, sEP, sEw, sDegree, sNcp, sKnotV, sUsize] = sx1502_Surface (rdi, j, pNcp, pDegree, pKnotV, pUsize, pEP, pEw, pxdim);
    [ur] = pd0172_pdSurfaces (ur, r, sP, sw, sEP, sEw, sDegree, sNcp, sKnotV, sUsize, pxdim, Xtol, DUtol);

end

%}

for rdi = 3:-1:1
    
    for a = 1:pNcp(rdi)-1:pNcp(rdi)

        d1 = sdi(rdi,1);
        d2 = sdi(rdi,2);

        n = pNcp(d1);
        m = pNcp(d2);

        % abs. ref's of involved nodes:

        r = zeros((n-2)*(m-2),1);

        conta = 0;
        for i = 2:1:n-1
        for j = 2:1:m-1

            conta = conta+1;
            
            if rdi == 1
                r(conta,1) = ARcon(a,i,j);
            elseif rdi == 2
                r(conta,1) = ARcon(i,a,j);
            elseif rdi == 3
                r(conta,1) = ARcon(i,j,a);
            end
            
        end  
        end

        % extracts surface and updates displacement vector:
        [sP, sw, sEP, sEw, sDegree, sNcp, sKnotV, sUsize] = sx1502_Surface (rdi, a, pNcp, pDegree, pKnotV, pUsize, pEP, pEw, pxdim);
        [ur] = pd0172_pdSurfaces (ur, r, sP, sw, sEP, sEw, sDegree, sNcp, sKnotV, sUsize, pxdim, Xtol, DUtol);

    end

end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%{
figure(22)

noc = pNcp(1)*pNcp(2)*pNcp(3);
pPd = zeros(noc,pxdim);

for i = 1:1:noc
    for di = 1:1:pxdim
        pPd(i,di) = pP(i,di)+ur(i*pxdim-(pxdim-di));
    end
end


scatter3(pP(:,1),  pP(:,2),  pP(:,3), 'b'); hold on
scatter3(pPd(:,1), pPd(:,2), pPd(:,3), 'r'); hold on

axis equal

%}

end

