function [Nicp, RicpA] = a0201_icpE (nAN, mA, Ncor, Cor, udim)

% RETURNS: for a certain element for corners 'Cor'. Note! for rect-mesh
% Nicp:             No. icp's
% RicpA(Nicp,1):    icp's references

% INPUTS:
% nAN,mA: No anchors and anchors object
% Ncor:     No. corners of the element
% Cor:      corner coord's 
% checks if any corner of the element is in the influential area of the anchor

domA = zeros(udim,2);   % anchor domain limits
P = zeros(udim,1);      % point to evaluate

Nicp = 0;
RicpA = zeros(1,1); % '1' will grow up to Nicp

for a=1:1:nAN
           
    for di=1:1:udim
        domA(di,1) = mA(a).mIcoLi(di,1);
    	domA(di,2) = mA(a).mIcoLi(di,2);
    end
        
  	IN = 0;
  	for c=1:1:Ncor
            
        P(:,1) = Cor(c,:);
      	IN = GEN_08_Orthodomain_Pin (P, domA, udim, 'closed');
            
    	if IN==1
      	break;
    	end
    end
        
  	if IN==1
        Nicp = Nicp + 1 ;
    	RicpA(Nicp,1) = a ;
  	end

end % loop on anchors



end

