function [rTskin, Nts, tsR] = st0301_rTskin (Spatches, pR, GPT, tFace, ccTp, Xtol, DUtol, Ks)

% RETUNRS:
% rTskin: refined of trimmed skins for integration-tet-mesh:

% 1.- IDENTIFIES TRIMMING SURFACES AND THE PATCH ATTACHED TO:

% 1.1.- Surfaces:
% For coupling surfaces, if trims both patches, uses the master patch.
% tsR(Nts,3): surface ref. , patch that trims, master/slave patch (1 or 2)

[Nts, tsR] = st0305_tsR (pR, tFace);


% 1.2.- Curves: those ones attached to trimming surfaces
% tcR(Ntc,2): curve ref. 

[Ntc, tcR] = st0308_tcR (Nts, tsR, ccTp, pR);




% 2.- SKINS APPROX. FOR T-SURFACES: 
%     Approximates Q to T-surfaces

tolSt = 100 * Ks * DUtol / 1.73 ; % rTskin surface error (in patch parameter space), is K times greater than DUtol

[rTskin] = fs0700_fit2surf ...
(Spatches, pR, GPT, tFace, Ntc, tcR, Nts, tsR, ccTp, tolSt, Xtol, DUtol);



end