function [Ngp, GP] = st0304_GPBEskin ...
        (s, NGPe, skin, couR, Pa, Spatches, Xtol, DUtol)

% RETURNS:
% Ngp and GP of one skin of one Bentity
    
% INPUTS:
% couR: coupling ref, if not coupling then couR = 0

eudim = 2;
pudim = 3;
xdim  = 3;

    
% 1.- INVOLVED PATCHES FEATURES:

[pR, pDegree,  pNcp,  pKnotV,  pUsize,  pP,  pw,  pCD , pEw,  pEP, pULims, ...
spR, spDegree, spNcp, spKnotV, spUsize, spP, spw, spCD, spEw, spEP, spULims] = ...
so2938_patchNURBS (couR, Pa, Spatches, xdim);
    

% 2.- COMPUTES Ngp, COORDINATES IN SURFACE PARAMETER SPACE 
% AND AGREGATED JACOBIAN FOR EACH GAUSS POINT:
    
[Ngp, Ug, aJ2, Amid, AmidS] = st0398_aJ2Ucoor (skin, NGPe, pudim, eudim, DUtol);


    
% 3.- COMPUTES COORDINATES (Xcoor and Acoor):
    
aJ1 = zeros(Ngp,1); % jacobian-1 is to be computed in the analysis loop
Xg  = zeros(Ngp,xdim);
Ag  = zeros(Ngp,pudim);
AgS = zeros(Ngp,pudim);
    
eKnotV  = skin.mKnotV ;
eNcp    = skin.mNcp ;
eDegree = skin.mDegree ;
eUsize  = skin.mUsize ;
eP      = skin.mP ;
ew      = skin.mw ;

[eEw,eEP] = GEN_12_ExpandBw (ew, eP,xdim, eudim, eNcp);
    
for g = 1:1:Ngp
        
	u(:,1) = Ug(g,:);
        
	Am(:,1) = Amid(g,:);
	AmS = zeros(xdim,1);
        
    if couR > 0
        AmS(:,1) = AmidS(g,:);
    end
            
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
	% needs to be done in analysis:
	% [~, detJ1] = j2315_J1_Bspline (u, eKnotV, eNcp, eDegree, eUsize, eP, ew, eudim, xdim);
	% aJ1(g,1) = detJ1;  
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
           
	[X, A, sA] = su2925_XAcoords ...
	(u, eKnotV, eNcp, eDegree, eUsize, eEw,eEP,...
	Am,   pDegree,  pNcp,  pKnotV,  pUsize,  pP , pw, pEP , pEw,  pCD,  pULims,...
 	AmS, spDegree, spNcp, spKnotV, spUsize, spP ,spw, spEP ,spEw, spCD, spULims, ...
	couR, eudim, xdim, Xtol, DUtol);
          
    for di = 1:1:xdim
        Xg(g,di) = X(di);
        Ag(g,di) = A(di);
    end
    
	if couR>0
        AgS(g,:) = sA(1,:);
	end 
        
end
 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%{
if s==1
    
    figure(7)
    
    scatter3( Ag(:,1) ,  Ag(:,2) , Ag(:,3) , 'r'); hold on
    
    axis equal
    
    xlim([0 1])
    ylim([0 1])
    zlim([0 1])
    
  	figure(8)
    
    scatter3( AgS(:,1) ,  AgS(:,2) , AgS(:,3) , 'r'); hold on
    
    axis equal
    
        xlim([0 1])
    ylim([0 1])
    zlim([0 1])
    
end
%}  
    


% 4.- ICP's and BASIS FUNCTIONS:
 
% 4.1.- No. cps from each patch:


Nacp = Spatches(pR).INS(1).mNacp;
CP = Spatches(pR).INS(1).mCP;

if couR > 0
    NacpS = Spatches(spR).INS(1).mNacp;
    CPS =  Spatches(spR).INS(1).mCP;
end


% 4.2.- Icp's from patch and Bf's values:
    
gNicp = zeros(Ngp,1);
gRicp = zeros(Ngp,1);
gRrel = zeros(Ngp,1);
    
gNicpS = zeros(Ngp,1);
gRicpS = zeros(Ngp,1);
gRrelS = zeros(Ngp,1);
    
bgAcoor = zeros(pudim,1);
    
for g = 1:1:Ngp
    
	bgAcoor(:,1) = Ag(g,:);
        
	[Nicp, Ricp, ~, Rrel, ~] = su2926_IcpBf (s, Pa, bgAcoor, pNcp, pKnotV, pUsize, Nacp, CP, pDegree, pudim);

	gNicp(g,1)  = Nicp;
        
    for i = 1:1:Nicp
        gRicp(g,i) = Ricp(i);
        gRrel(g,i) = Rrel(i);
    end
        

	if couR > 0

        bgAcoor(:,1) = AgS(g,:);
            
        [Nicp, Ricp, ~, Rrel, ~] = su2926_IcpBf (s, Pa, bgAcoor, spNcp, spKnotV, spUsize, NacpS, CPS, spDegree, pudim);

      	gNicpS(g,1)  = Nicp;
            
        for i = 1:1:Nicp
            gRicpS(g,i) = Ricp(i);
            gRrelS(g,i) = Rrel(i);
        end
            
	end
    
end
    
%%%%%%%%%%%%%%%%%%%%%%  %%%%%%%%%%%%%%%%%%%
% plots GPs
%{
if s==1
    
    figure(33)
    
    scatter3(Ag(:,1), Ag(:,2),Ag(:,3),'b'); hold on
    
    axis equal
    
    
  	figure(34)
    
    scatter3(AgS(:,1), AgS(:,2),AgS(:,3),'r'); hold on
    
    axis equal

end
%}
%%%%%%%%%%%%%%%%%%%%%%  %%%%%%%%%%%%%%%%%%%


% 5.- ALLOCATES TO GAUSS POINTS:
  
GP(Ngp,1) = cGPbe; 

for g = 1:1:Ngp
        
        GP(g,1).mUcoor = zeros(eudim,1);
        GP(g,1).mXcoor = zeros(xdim,1);
        
        GP(g,1).mUcoor(:,1) = Ug(g,:);
        GP(g,1).mXcoor(:,1) = Xg(g,:);
        
        GP(g,1).mAcoor(:,1) = Ag(g,:);
        
        if couR>0
            GP(g,1).mAcoorS(:,1) = AgS(g,:);
        end
        
        GP(g,1).dJ1 = aJ1(g,1);
        GP(g,1).dJ2a = aJ2(g,1);
        
        % icps:
        
        GP(g,1).mNicp = gNicp(g,1);
        
        for i = 1:1:gNicp(g,1)
         	GP(g,1).mRicp(i,1) = gRicp(g,i);
            GP(g,1).Rrel(i,1)  = gRrel(g,i);
        end
          
        % icps from slave patch:
        
        if couR > 0
            
            GP(g,1).mNicpS = gNicpS(g,1);
            
            for i = 1:1:gNicpS(g,1)
                GP(g,1).mRicpS(i,1) = gRicpS(g,i);
                GP(g,1).RrelS(i,1)  = gRrelS(g,i);
            end
        end
end
 

end

