function [sRt] = st0307_sTarget (GPT, Eskin, Nts, tsR)

% RETURNS:
% sRt(Nts,1): target distace of trimming surfaces

% Averate of N tets. Lax where the curve pass through:

sRt = zeros(Nts,1);

for i = 1:1:Nts

    % surface and attached patch:

    sR = tsR(i,1);
    pR = tsR(i,2);

    
    % tets and average of edges length:
    
    pDT  = GPT(pR,1).DT;
    pLax = GPT(pR,1).Lax;

    
    % uses the skin points:
    
    NV = Eskin(sR,1).mNV;
    if tsR(i,3) == 1
        Av = Eskin(sR,1).mAv;
    elseif tsR(i,3) == 2
        Av = Eskin(sR,1).mAvS;
    end
    
    
    % detects where each point lies and stores tet. ID
    tID = pointLocation(pDT,Av);


    
    % computes average of Lax and allocates to R:
    R = 0 ;
    for j = 1:1:NV
        R = R + pLax(tID(j))/NV;
    end
    
    sRt(i,1) = R ;

end

