function [Ngp, Ug, aJ2, Amid, AmidS] = st0398_aJ2Ucoor ...
    (skin, NGPe, pudim, eudim, DUtol)

% RETURNS:
% 

NE      = skin.mNE;
TVcon   = skin.mTVcon;
Uv      = skin.mUv;
Av      = skin.mAv;
AvS     = skin.mAvS;
couR    = skin.mCou; % coupling flag = coup. ref. If not couling BE couR = 0

Ngp = 0 ;
    
Ug = zeros(1,eudim); % surface parent space of GP's
aJ2 = zeros(1,1); % aggregated jacobians (determinants)
    
% mid triangle coordinates in patch parameter space, used for MPP
Amid = zeros(1,pudim); 
AmidS = zeros(1,pudim);

iem  = zeros(3,3);
rs   = zeros(2,1);
uExtg = zeros(eudim,1);


[GPpc, GPw, ~] = ip2303_GP_tri (NGPe); 

for e = 1:1:NE

	% 2.1.- Average coord's of nodes in patch param. space and nodes coord's
	% in surface parameter space:
        
	[Am, AmS, Unod] = st0399_eAav (TVcon, e, Av, AvS, couR, Uv, pudim, eudim);
        
        
	% 2.2.- Computes GP's of this element:
    
	for g = 1:1:NGPe
            
        rs(:,1) = GPpc(g,:);
            
        [u, ~, detJ2] = mp1352_TRImapp (rs, Unod, 2, eudim, iem);
            
        [u] = go2532_RoundToR (u, DUtol);
        detJ2 = abs(detJ2);
            
        % evaluates if 'u' is already stored or not => adds a new one
        % or updates the accumulated jacobian
            
        if Ngp == 0 %(first point always is new)
                
            Ngp = Ngp + 1;
                    
          	Ug(Ngp,:) = u(:,1);
          	aJ2(Ngp,1) = GPw(g)*detJ2;
                
          	Amid(Ngp,:) = Am(:,1);
          	if couR>0
             	AmidS(Ngp,:) = AmS(:,1);
            end     
            
        else
            % compares candidate 'u' against already stored:
            CO = 0;
                
            for j = 1:1:Ngp
  
                uExtg(:,1) = Ug(j,:);

             	CO = go2542_coincidentP (u, uExtg, eudim, 12);

              	if CO==1 % in case of extg. point => adds to agregated dJ2
                	aJ2(j,1) = aJ2(j,1) + GPw(g)*detJ2;
                  	break
                end
                    
            end
                
            if CO==0 % in case of new point => adds

                Ngp = Ngp + 1;

            	Ug(Ngp,:) = u(:,1);
            	aJ2(Ngp,1) = GPw(g)*detJ2;
                        
            	Amid(Ngp,:) = Am(:,1);
              	if couR>0
                    AmidS(Ngp,:) = AmS(:,1);
                end
                    
            end
        end 
        
	end

end

end

