function [ ] = gf0500_main ()

% Options:

op      = 3 ;
ns      = 20 ;	% No. sample points
Ncp     = 7 ;	% No. cp of the NEA
Degree  = 3 ;	% Degree of the NEA

r = 4 ;

% Generates sample points, that are obtained from exact expression (NEE):

[xs, NEE, xdim, udim] = gf0501_samplePoints (op, ns);

%{
figure(9)
scatter( xs(:,1) , xs(:,2) ,'r' ); hold on
axis equal
%}


% Generates approximation (NEA):
% [NEA] = gf0510_LSM (xs, Ncp, Degree, xdim, udim);

% Removes one cp:
%[NER] = gf0511_removeLSM (NEE, r, ns, xdim, udim);

% Removes alternatively cps:
[NERn] = gf0512_removeLSMn (NEE, ns, xdim, udim);


% Plots control net:

figure(1)

scatter3( NEE.P(:,1), NEE.P(:,2), NEE.P(:,3), 'k' ); hold on
% scatter( NEA.P(:,1), NEA.P(:,2), 'r' ); hold on
% scatter( NER.P(:,1), NER.P(:,2), 'r' ); hold on
scatter3( NERn.P(:,1), NERn.P(:,2),NERn.P(:,3), 'r' ); hold on

plot3( NEE.P(:,1), NEE.P(:,2),NEE.P(:,3), '--k' ); hold on
% plot( NEA.P(:,1), NEA.P(:,2), '--r' ); hold on
% plot( NER.P(:,1), NER.P(:,2), '--r' ); hold on
plot3( NERn.P(:,1), NERn.P(:,2),NERn.P(:,3), '--r' ); hold on

axis equal


% Plots curves:

st = 0.02 ;

ce = zeros(1,xdim);
ca = zeros(1,xdim);
cr = zeros(1,xdim);



conta = 0 ;
for u = 0:st:1
    
    conta = conta + 1 ;
    
	[X] = b2601_BNURBS_Xcoord (u, NEE.KnotV, NEE.Ncp, NEE.Degree, NEE.Usize, NEE.w, NEE.P, udim, xdim);
    ce(conta,:) = X(:,1);
    
 	%[X] = b2601_BNURBS_Xcoord (u, NEA.KnotV, NEA.Ncp, NEA.Degree, NEA.Usize, NEA.w, NEA.P, udim, xdim);
    %ca(conta,:) = X(:,1);
    
	%[X] = b2601_BNURBS_Xcoord (u, NER.KnotV, NER.Ncp, NER.Degree, NER.Usize, NER.w, NER.P, udim, xdim);
    %cr(conta,:) = X(:,1);
    
    [X] = b2601_BNURBS_Xcoord (u, NERn.KnotV, NERn.Ncp, NERn.Degree, NERn.Usize, NERn.w, NERn.P, udim, xdim);
    cr(conta,:) = X(:,1);

end

figure(2)

plot3(ce(:,1),ce(:,2),ce(:,3),'k'); hold on
%plot(ca(:,1),ca(:,2),'r'); hold on
plot3(cr(:,1),cr(:,2),cr(:,3),'r'); hold on

axis equal

end

