function [AtetIN, AtetOU, XtetIN, Dtet] = mt0605_opTetPos ...
            (e, Spatches, pR, tTVcon, tAv, rIN, rOU)

% RETURNS:
% parameters of MLT related to optimal tets

% INPUTS:
% e: reference of the triangle of MLT
% rIN, rOU: ratio of optimal tet. distances to 4th node to consider (they are less than 1)

xdim = 3 ;
pudim = 3 ;

pNcp     = Spatches(pR,1).INS(1).mNcp ;
pDegree  = Spatches(pR,1).INS(1).mDegree ;
pUsize   = Spatches(pR,1).INS(1).mUsize ;
pKnotV   = Spatches(pR,1).INS(1).mKnotV ;

pEP      = Spatches(pR,1).INS(1).mEP ;
pEw      = Spatches(pR,1).INS(1).mEw ;

Snod = zeros(3,pudim);

    j = 0 ;
    for i = 3:-1:1
        
        j = j+1;
        
        nR = tTVcon(e,i);
        
        Snod(j,:) = tAv(nR,:);
        
    end
    
    [P, GP] = tm1310_opTet (Snod);
    
    G = P - GP ;
    
    AtetIN = G + rIN*GP;
    AtetOU = G - rOU*GP;
    
    % before computing physical coordinates checks if lies within the domain:
    IN = GEN_08_Orthodom_Pin_ndec (AtetIN, [0 1 ; 0 1 ; 0 1 ], pudim, 'opened', 3);
    
    if IN == 1
        
        XtetIN = b2601_BNURBS_Xcoord (AtetIN, pKnotV, pNcp, pDegree, pUsize, pEw, pEP, pudim, xdim);
        
    else
        XtetIN = zeros(pudim,1);
    end

    Dtet = rIN * norm(GP);

end

