function [connT, THC, NE, MLT] = um0623_tVSm ...
    (pR, Spatches, rTskin, agCurv, connT, THC, NE, MLT, Xtol, DUtol, tolL, tolA, nd)


% RETURNS:
% connT, THC, NE, MLT: updated with intersections btwn tets lines and MLT added

pudim = 3 ;

[connS,~,~] = th1381_connS (NE, connT); % sides conn. matrices

intF = 1 ;

contaSL = 0 ;

while intF > 0

    contaSL = contaSL + 1 ;
    
    PcontaSL = 3 ;
    ScontaSL = 0 ;
    
    oMLT    = MLT ;
    oconnT  = connT;
    oTHC    = THC;
    
    % 1.- DETECTS INTERSECTION:

    [intF, intR, aeR1, csM, A0, U0, B0] = um0624_TiM (connT, THC, MLT);

    
    [ contaSL intF ]
    
    
    tLR = intR(1); % intersecting line ref (of tets)
    mTR = intR(2); % triangle ref of MLT
    mLR = intR(3); % line ref of MLT (in case intersction is on line)
    

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %{
    if contaSL == PcontaSL || contaSL > 0
       
        fr = PcontaSL ;
        fr =  contaSL ;
        figure(fr)
        
        for e = 1:1:size(aeR1,1)
            pt1373_pTetConn (aeR1(e), connT, THC.Av, fr, 'b', 0.33, 3.25, 1, 0);
        end
        
        pt1374_pSidConn (mTR, MLT.tTVcon, MLT.tAv, fr, 'k', 1, 3.2, 0, 0);
        
        pt1375_pLinConn (tLR, connT.LV, THC.Av, fr, 'r', 1, 1.2, 0);
        
        axis equal

        scatter3 ( A0(1),  A0(2), A0(3),'r'); hold on
 
    end
    %}
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    if intF == 0
        return % returns in case no more intersections are found
    end


    % 2.- ASSESSES 3-2 FLIP:
    
    % 2.1.- Checks if it is possible to do the flip:
    
    [f32F] = tf1680_check32 (tLR, mTR, aeR1, connT, MLT, THC, nd);
    
    % 2.2.- Carries on with the 32 flip:
    
    if f32F == 1

        tp = "flip 3=>2";
        
        [NE, connT, aeR2] = tf1681_flip32 (NE, connT, tLR);

    end
    
    
    % 3.- ASSESSES NODES MERGING (BY DELETING THE ATTACHED TETS):
    %  Merging may be done if IP is too close to MLT node
    
    meF = 0;
    if f32F == 0

        pL = 20 ; % percentaje
        [NE, connT, aeR2, meF] = mp1630_closeIP (contaSL, aeR1, tLR, NE, connT, THC, A0, mTR, MLT, pL, nd);

    end
    
    %[f32F meF]
    
    % (insertion of node: in clase 3-2 flip and merging close nodes are not doable)
    
    if f32F == 0 && meF == 0


        oMLT = MLT ;
        
        %{
        % Finds N for U0, such that insertion is as close as possible to isi common line:
        tolP = 0.5 ;
        [MLT, THC, NE, connT, tp] = tn3600_EdgeSplit ...
        (contaSL, isi, ILn, mLR, THC, connS, connT, Spatches, pR, rTskin, agCurv, MLT, Xtol, DUtol, tolP, pL);
        %}

        %if tp == "split edge"
            
        %else
            
            % 4.- COMPUTES COORD and NCS OF INTERSECTION POINT:

            [eTHC] = ei1643_eTHCm (contaSL, Spatches, pR, rTskin, agCurv, csM, B0, U0, A0, Xtol, DUtol);
            eTHC.rm = MLT.tNV+1;

            %{
            if contaSL == 3

                figure(contaSL)
                pm0650_plotMLT (MLT, 'A', contaSL, 'g', 2.3, 0, 0, 0, 0, 0, 0, 0, 0)

                scatter3(A0(1),A0(2),A0(3),'r'); hold on

                scatter3(eTHC.Av(1),eTHC.Av(2),eTHC.Av(3),'b'); hold on
                
                pt1368_pTetLinMesh (THC.Av, size(connT.LV,1), connT.LV, contaSL, 1, 0.55, 0);
                
                axis equal

            end
            %}
            

            % 4.- UPDATES TETS: by insertion of new node

            [THC, NE, connT, meR, aeR1, aeR2] = ts1613_inNodTET (contaSL, eTHC, NE, connT, connS, THC, tolL, tolA, nd);

            %{

            if contaSL == PcontaSL % || contaSL > 0

                fr = contaSL ;
                figure(fr)

                for e = 1:1:size(aeR1,1)
                    eR = aeR1(e);
                    pt1373_pTetConn (eR, oconnT, oTHC.Av, fr, 'k', 1, 1.2, 0, 0);
                end
                scatter3(eTHC.Av(1), eTHC.Av(2), eTHC.Av(3), 'r'); hold on
                axis equal


                fr = contaSL + 100  ;
                figure(fr)

                for e = 1:1:size(aeR2,1)
                    eR = aeR2(e);
                    pt1373_pTetConn (eR, connT, THC.Av, fr, 'k', 1, 1.2, 0, 0);
                end
                scatter3(eTHC.Av(1), eTHC.Av(2), eTHC.Av(3), 'r'); hold on
                axis equal

            end
            %}

            % 5.- UPDATES MLT: by insertion of new node:

            % 5.1.- Selects closest line to eTHC in case its not already
            % selected
            
            if mLR == 0
            
                ndm = zeros(MLT.tNV,2); % MLT node ref and distance to eTHC:

                for l = 1:1:MLT.tNV
                    ndm(l,1) = l ;
                    ndm(l,2) = norm(eTHC.Av - MLT.tAv(l,:));
                end

                ndm = sortrows(ndm,2); % uses the closest three nodes

                Nl = 0 ;
                ldm = zeros(1,2); % line ref and distance

                for k = 1:1:3

                    nR = ndm(k,1);

                    for i = 1:1:size(MLT.tVLcon,2)

                        lR = MLT.tVLcon(nR,i);

                        if lR > 0

                            n1 = MLT.tLVcon(lR,1);
                            n2 = MLT.tLVcon(lR,2);

                            a1 = (MLT.tAv(n1,:))';
                            a2 = (MLT.tAv(n2,:))';
                            vr = a2-a1;

                            [dist, d] = go2527_distPtoRecta (eTHC.Av, a1, vr, pudim);

                            Q = eTHC.Av + d ;

                            [ON] = go2520_PonSegment (Q, a1,a2, pudim, 1.5);

                            if ON > 0

                                Nl = Nl + 1 ;
                                ldm(Nl,1) = lR ;
                                ldm(Nl,2) = dist ;
                            end

                        end

                    end

                end

                ldm = sortrows(ldm,2);

                mLR = ldm(1,1);
            
            end
            
            % 5.2.- Updates MLT:

           
            [MLT, slF] = ts1603_insertMLT (contaSL, eTHC, Spatches, pR, mLR, MLT, pL);

            NV = size(THC.Av,1);
            tNV = MLT.tNV ;

            %{
            
            if contaSL == PcontaSL % || contaSL > 0
            
                fr = contaSL;

                figure(fr)
                scatter3(eTHC.Av(1),eTHC.Av(2),eTHC.Av(3),'r'); hold on
                scatter3(A0(1),A0(2),A0(3),'b'); hold on
                pm0650_plotMLT (oMLT, 'A', fr, 'k', 1, 0, 0, 0, 0, 0, 0, 0, 0);
                
                pt1375_pLinConn (mLR, oMLT.tLVcon, oMLT.tAv, fr, 'r', 0.5, 5.5, 0);
                axis equal
                
                
                fr = 100+contaSL;

                figure(fr)
                scatter3(eTHC.Av(1),eTHC.Av(2),eTHC.Av(3),'r'); hold on
                pm0650_plotMLT (MLT, 'A', fr, 'k', 1, 0, 0, 0, 0, 0, 0, 0, 0);
                axis equal

                if jj==0
                end

            end
            
            %}

            for di = 1:1:pudim
                THC.ANv(NV,di) = MLT.tANv(tNV,di);
            end
        
        %end
        
        


    end
    
    
  	% 6.- UPDATES THE REST OF THE CONN. MATRICES:

    NV = size(THC.Av,1); 
    [connT] = th1333_oConnL (NE, NV, connT.EV);
    [connS,~,~] = th1381_connS (NE, connT); 
    
     
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %{
    if contaSL == PcontaSL ||  contaSL > 0

        figure(contaSL)
        scatter3(A0(1), A0(2), A0(3), 'r'); hold on
        pm0650_plotMLT (oMLT, 'A', contaSL, 'k', 1.2, 0, 0, 0, 0, 0, 0, 0, 0)
        pm0650_plotMLT (MLT, 'A', 100+contaSL, 'k', 1.2, 0, 0, 0, 0, 0, 0, 0, 0)

    end
    %}
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    % JUST A STOPPER:
    if contaSL == ScontaSL
        if jj==0
        end
    end
     
end



end

