function [intF, intR, aeR, csM, A0, U0, B0] = um0624_TiM (connT, THC, MLT)

% RETURNS:
% intersections between lines of tets and triangles of MLT

tolL    = 1 ;
tolA    = 1 ;
nd      = 3 ;
pudim   = 3 ;
sudim   = 3 ;
cudim   = 3 ;

% intersections storage
intF = 0 ;              % intersection flag => turns to 1 if finds intersection, 2 if intersection is on triangle edge
intR = zeros(3,1);      % LR of tets, triangle of MLT, line of MLT (in case intF = 2)
aeR  = zeros(1,1);      % Affected tets elements (tets attached to LR)
csM  = zeros(2,1);      % curve and surface ref of MLT where the insertion lies on    
A0   = zeros(pudim,1);	% A-coords of intersection, prior to pp on surface. i.e. intersectio with the linear triangle
U0   = zeros(sudim,1);
B0   = zeros(cudim,1);


% INPUTS:
% LR1: last line of tets modified
% connT,THC,MLT: updates features

a1 = zeros(pudim,1);
a2 = zeros(pudim,1);

NLI = size(connT.LV,1);

for LR = 1:1:NLI
    
    n1 = connT.LV(LR,1);
    n2 = connT.LV(LR,2);
    
    if (THC.NCS(n1,1)>0 || THC.NCS(n1,2)>0) || (THC.NCS(n2,1)>0 || THC.NCS(n2,2)>0)
    
    % if Lnm(LR) > 0

        % checks intersection with all involved triangles of MLT: 
        % if lies within a triangle, then insert new node

        % point and vector of line, and its limits:
        [Lv, Lp1, Lp2, Lnod, Llims] = um0625_THline (connT, THC, LR);
        

        % loops on MLT triangles:

        for t = 1:1:MLT.tNE

            
            % coords of nodes of triangle and its limits:
            [Tnod, Tlims, tv1, tv2, tp] = um0626_MLTtri (MLT,t);
  

            % conditions for potential intersection:
            [conF] = um0628_conF (Tlims, Llims, Tnod, Lnod, nd);


            if conF == 1

                % intersection point:
                [IP,~] = go2545_PlaneLineIntersec (tv1, tv2, tp, Lv, Lp1);

                % inside the triangle?
                IN = go2546_PinTriang (Tnod, IP, tolL, tolA, nd);

                % inside the line limits?
                ON = go2520_PonSegment (IP, Lp1, Lp2, pudim, tolL);

                if IN > 0 && ON > 0

                    intF = 1 ;
                    
                    intR(1,1) = LR ;
                    intR(2,1) = t ;

                    % finds MTL intersected line (in case it applies)
                    if IN == 2
                        
                        intF = 2 ;
                        
                        for l = 1:1:3
                            
                            lR = MLT.tTLcon(t,l);
                            
                            n1 = MLT.tLVcon(lR,1);
                            n2 = MLT.tLVcon(lR,2);
                            
                            a1(:,1) = MLT.tAv(n1,:);
                            a2(:,1) = MLT.tAv(n2,:);
                            
                            ON = go2520_PonSegment (IP, a1, a2, pudim, tolL);
                            
                            if ON > 0
                                intR(3,1) = lR ;
                                break
                            end
                            
                        end
                        
                    end
                    
                    conta = 0;
                    for i = 1:1:size(connT.LE,2)
                        
                        eR = connT.LE(LR,i);
                        
                        if eR > 0
                            conta = conta + 1 ;
                            aeR(conta,1) = eR ;
                        end
                        
                    end
                    
                    A0 = IP(:,1);

                    % evaluates which curve and surface are involved and the initial trial point:

                    [csM, U0, B0] = um0629_csM (MLT, IN, t, IP, tolL);
                    
                    return
                end

            end

        end

    end
end




end

