function [csM, U0, B0] = um0629_csM (MLT, IN, t, IP, tolL)

pudim = 3 ;
sudim = 2 ;



csM = zeros(2,1); % MLT curve and surface involved

% extracts nodes, curves and surfaces refs:

nr = zeros(3,1);
cr = zeros(3,1);
sr = zeros(3,1);

for i = 1:1:3
      
    nr(i,1) = MLT.tTVcon(t,i);
    cr(i,1) = MLT.tNCS(nr(i),1); 
    sr(i,1) = MLT.tNCS(nr(i),2);
        
end




% for surface searches 2 nodes that share same surface
    
sr = sortrows(sr,1);
    
for i = 1:1:2
       
	if sr(i)==sr(i+1)
        csM(2) = sr(i);
        break
	end
        
end
    

% initial trial point:

U0 = zeros(1,sudim);

for i = 1:1:3
	nR = MLT.tTVcon(t,i);
	U0(1,:) = U0(1,:) + MLT.tUv(nR,:)/3;
end
U0 = U0';  



% in case there is POTENTIALLY a curve involved:

B0 = 0 ;
nd = 5 ;

if IN == 2
     
    % checks if the point lies within the edge with both nodes at curve:
    
    a1 = zeros(pudim,1);
    a2 = zeros(pudim,1);
    
    r = [ 1 2 3 1 ];
    
    for i = 1:1:3
        
        n1 = MLT.tTVcon(t,r(i));
        n2 = MLT.tTVcon(t,r(i+1));
        
        a1(:,1) = MLT.tAv(n1,:);
        a2(:,1) = MLT.tAv(n2,:);
        
        ON = go2520_PonSegment (IP, a1, a2, pudim, tolL);
        
        if ON == 1
            
            if cr(r(i)) > 0 && cr(r(i+1)) > 0 % in case both nodes have curve attached
            
                % for curve ref chooses the node ref that does not have end B coord

                csM(1) = cr(r(i)) ;
                B0 = round(MLT.tBv(n1,:),nd);
                
                if B0 == 0 || B0 == 1
                    
                    csM(1) = cr(r(i+1)) ;
                    B0 = round(MLT.tBv(n2,:),nd);
                    
                end
               
                
                %{
                tm = [ [n1;n2] , [cr(r(i));cr(r(i+1))] ];
                tm = sortrows(tm,1);
                csM(1) = tm(1,2);

                % initial searching point:

                B0 = MLT.tBv(n1,:) + MLT.tBv(n2,:);
                csM
                B0
                %}
                
            end
             
            
            break
            
        end
        
    end
    
    
    %{
    
    % for curve chooses the lowest node ref with curve ref non empty
    
    tm = [nr, cr];
    
    tm = sortrows(tm,1);
    
    for i = 1:1:3
        
        if tm(i,2) > 0
            
            csM(1) = tm(i,2);
            
            nR = tm(i,1);
            
            B0 = MLT.tBv(nR,:);
            
            break
            
        end
    end
      
    %}
end



end

