function [utANv, utANe, utXNv, utXNe] = um0631_upNvects (tANv, tANe, tXNv, tXNe, utTVcon, utAv, utXv, Nti, itr)

% RETURNS:
% updates normal vectors due to insertion of one node

% INPUTS:
% MLT features, with tANv, tANe, tXNv, tXNe NOT UPDATED, coz they are updated here
% utTVcon, utAv, utXv: already updated considering the insertion
% Nit: No. involved triangles
% itr(Nit,1): refs of involved triangles

pudim = 3 ;
xdim  = 3 ;

utANv = [ tANv ; zeros(1,pudim) ] ;
utANe = [ tANe ; zeros(1,pudim) ] ;

utXNv = [ tXNv ; zeros(1,xdim) ] ;
utXNe = [ tXNe ; zeros(1,xdim) ] ;

Anod = zeros(3,pudim);
Xnod = zeros(3,xdim);

ANv = zeros(pudim,1);
XNv = zeros(xdim,1);
Aat = 0;
Axt = 0;


for t = 1:1:Nti
    
    tR = itr(t);
    
    for i = 1:1:3   
        nR = utTVcon(tR,i);
        Anod(i,:) = utAv(nR,:);
        Xnod(i,:) = utXv(nR,:);
    end
    
    [Aa, na] = tm1306_tArea_n (0, 0, 0, Anod, pudim);
    [Ax, nx] = tm1306_tArea_n (0, 0, 0, Xnod, xdim);
    
    na = na/norm(na);
    nx = nx/norm(nx);
    
    utANe(tR,:) = na(:,1) ;
    utXNe(tR,:) = nx(:,1) ;
    
    ANv(:,1) = ANv(:,1) + Aa*na(:,1) ;
    XNv(:,1) = XNv(:,1) + Ax*nx(:,1) ;

    Aat = Aat + Aa ;
    Axt = Axt + Ax ;
    
end

na = ANv / Aat;
nx = XNv / Axt;

nr = size(utAv,1);

utANv(nr,:) = na(:,1);
utXNv(nr,:) = nx(:,1);


end

