function [utVTcon] = um0632_upTVcon (tVTcon, utTVcon, Na, ate, Nti, itr, Nni, inr)

% RETURNS:
% tVTcon: updates due to one node insertion.

% INPUTS:
% tTVcon already updated considering the new insertion
% etR: ref. of triangle of original MLT where the new node to insert lies in
% itr(Nti): refs of triangles involved in the new insetion. Includes etR and new triangles generated due to the insertion
% Nni: No. involved nodes, including the one to insert
% inr(Nni): refs of nodes involved


utVTcon = [tVTcon ; zeros(1,size(tVTcon,2)) ] ;

for k = 1:1:Nni
    
    nR = inr(k);
    
    % transfers all elements to nR except modified:
    
    tmT = zeros(1,1);
    conta = 0 ;
    
    for i = 1:1:size(utVTcon,2)
        
        r = utVTcon(nR,i);
        
        adF = 1 ;
        for j = 1:1:Na
            if r == ate(1,j)
                adF = 0 ;
            end
        end
        
        if r > 0 && adF == 1
            
            conta = conta + 1 ;
            tmT(conta,1) = utVTcon(nR,i);
            
        end
        
        utVTcon(nR,i) = 0 ; % resets
    end
    
    
    % evaluates if any itr has the node nR, is so => adds the triangle ref.
    
    for t = 1:1:Nti
    
        tR = itr(t);
        
        for i = 1:1:3

            nC = utTVcon(tR,i); % candidate node
            
            if nC == nR
                
                conta = conta + 1 ;
                tmT(conta,1) = tR;
                break
                
            end
        end
    end
    
    
    % transfers:
    
    if size(utVTcon,2) < size(tmT,2)
        utVTcon = [ utVTcon , zeros(tNV,1) ] ;
    end
    
    for i = 1:1:conta
        utVTcon(nR,i) = tmT(i);
    end

end


end

