function [uLTcon] = um0635_upLTcon (tLTcon, tTLcon, uTLcon, Nti, itr, Nnli, ilr, Na, ate, DNL)

% Checks directly affected lines and originla adjacent lines to aff'd elems:


uLTcon = [ tLTcon ; zeros(DNL,2) ] ; % expands size to allow for new lines


% 1.- Directly affected lines:

for k = 1:1:Nnli
    
    LR = ilr(k); % line ref
    
    % searches for LR in itr
    
    conta = 0 ;
    
    for t = 1:1:Nti
        
        tR = itr(t);
        
        for i = 1:1:3
            
            r = uTLcon(tR,i);
            
            if r == LR
                conta = conta + 1 ;
                uLTcon(LR,conta) = tR;
                break
            end
            
        end
        
        if conta==2
            break
        end
    end
    
end



% 2.- Checks the other lines that were attached to itr originally:

oilr = zeros(1,1); % original lines refs

conta = 0 ;
for t = 1:1:Na

    tR = ate(t);
    for l = 1:1:3

        lR = tTLcon(tR,l);

        conta = conta + 1 ;
        oilr(conta,1) = lR;
    end

end

[oilr,~] = GEN_16_RemoveRepeatedRows (oilr, 1, 0.1);
oNli = size(oilr,1);


oitr = zeros(1,1); % elems affected

conta = 0 ;
for k = 1:1:oNli
    
    LR = oilr(k);
    
    for i = 1:1:2
        
        r = tLTcon(LR,i);
        if r > 0
            conta = conta + 1 ;
            oitr(conta,1) = r;
        end
    end
    
end

[oitr,~] = GEN_16_RemoveRepeatedRows (oitr, 1, 0.1);
oNti = size(oitr,1);

aitr = [oitr ; itr'];
[aitr,~] = GEN_16_RemoveRepeatedRows (aitr, 1, 0.1);
aNti = size(aitr,1);


for k = 1:1:oNli
    
	LR = oilr(k); % line ref
    
    % searches for LR in all aff'd triangles
    
    conta = 0 ;
    
    for t = 1:1:aNti
        
        tR = aitr(t);
        
        for i = 1:1:3
            
            r = uTLcon(tR,i);
            
            if r == LR
                conta = conta + 1 ;
                uLTcon(LR,conta) = tR;
                break
            end
            
        end
        
        if conta==2
            break
        end
    end
    
    
end



end

