function [] = pm0650_plotMLT (MLT, sp, fr, Mcolr, Mthk, nvF, neF, sc, Ncolr, lrF, vrF, erF, otF)

% otF: optimal tetrahedrons flag
    
if sp == 'X'
    
    tCv = MLT.tXv ;
   	Nvx = MLT.tXNv ;
    Nel = MLT.tXNe ;
    
elseif sp == 'A'
    
    tCv = MLT.tAv ;
    Nvx = MLT.tANv ;
    Nel = MLT.tANe ;
end


tLVcon  = MLT.tLVcon ;
tTVcon  = MLT.tTVcon ;
tNV     = MLT.tNV ;
tNE     = MLT.tNE ;

   
tAtetIN   = MLT.tAtetIN ;
tAtetOU   = MLT.tAtetOU ;

NLI = size(tLVcon,1);
dim = 3 ;

        

pt1366_pTriLinMesh_nD ...
(tCv, NLI, tLVcon, tTVcon, dim, fr, Mcolr, Mthk, nvF, tNV, Nvx, neF, tNE, Nel, sc, Ncolr, lrF, vrF, erF);


% optimal tetrahedrons:

if otF == 1
    
    figure(fr)
    

    Tcolr = 'r';
    Ttrs = 0.5;
    Tthk = 2.5 ;
    
    AnodIN = zeros(4,dim);
    AnodOU = zeros(4,dim);
    
    for e = 1:1:tNE
    
        for i = 1:1:3
            nR = tTVcon(e,i);
            AnodIN(i,:) = tCv(nR,:);
            AnodOU(i,:) = tCv(nR,:);
        end
        
        AnodIN(4,:) = tAtetIN(e,:);
        AnodOU(4,:) = tAtetOU(e,:);
        
        pt1362_pTet (AnodIN, dim, fr, Tcolr, Ttrs, Tthk, 0);
        pt1362_pTet (AnodOU, dim, fr, Tcolr, Ttrs, Tthk, 0);
        
    end
    
end


axis equal

  

end

