function [MLT] = um0660_inNodMLT (pR, Spatches, MLT, eTHC, TR)

% RETURNS: MLT with added end-node
 
% INPUTS:
% MLT: initial
% eTHC: coordinates of new node to insert already pp to MLT surface
% eAt(pudim,1): coordinates of new insertion previous to pp. This is the
%               one used to find out in which triangle / edge the new point lies
% TR: triangle affec'd in the MLT

% 1.- PRELIMINARIES:

pudim = 3 ;
xdim  = 3 ;

% extracts arrays to facilitate coding:

tNE = MLT.tNE ;
tNV = MLT.tNV ;
tNL = MLT.tNL ;
tTVcon = MLT.tTVcon ;
tLVcon = MLT.tLVcon ;
tVLcon = MLT.tVLcon ;
tTLcon = MLT.tTLcon ;
tVTcon = MLT.tVTcon ;
tLTcon = MLT.tLTcon ;

tBv  = MLT.tBv ;
tUv  = MLT.tUv ;
tAv  = MLT.tAv ;
tXv  = MLT.tXv ;

tANv = MLT.tANv ;
tXNv = MLT.tXNv ;
tANe = MLT.tANe ;
tXNe = MLT.tXNe ;
tNCS = MLT.tNCS ;


tAtetIN = MLT.tAtetIN ;
tAtetOU = MLT.tAtetOU ;
tXtetIN = MLT.tXtetIN ;
tDtet   = MLT.tDtet ;


% 2.- DETECTS TRIANGLES and COMMON-LINES WHERE THE NEW NODE LIES IN:

[Na, ate, cLR] = um0661_affTL (TR, eTHC, tTVcon, tTLcon, tLVcon, tLTcon, tAv);

%{
%if TR==3
    
    Na
    ate
    cLR
    
    for a = 1:1:2
    
        fr = 87 ;
        figure(fr)

        pt1374_pSidConn (ate(a), tTVcon, tAv, fr, 'k', 1, 1, 1, 0);

        axis equal
    
    end
    
    if kk==0
    end
    
%end

%}

% 3.- CHARACTERIZATION OF INSERTION:

[inr, itr, ilr, Nti, Nni, Nnli, DNE, DNV, DNL] = um0662_ChrtIns (Na, ate, cLR, tNE, tNV, tNL, tTVcon);


% 4.- UPDATES COORDINATES AND NUMBERS:
    
[nr, tNE, tNV, tNL, tBv, tUv, tAv, tXv, tNCS] = um0664_uCoords ...
    (tNE, tNV, tNL, tBv, tUv, tAv, tXv, tNCS, DNE, DNV, DNL, eTHC);


% 5.- CONNECTIVITY MATRICES:

[tTVcon, tLVcon, tVLcon, tTLcon, tVTcon, tLTcon] = um0665_uConn ...
(tTVcon, tLVcon, tVLcon, tTLcon, tVTcon, tLTcon, tNE, tNL, Nni, inr, Nti, itr, Nnli, ilr, Na, ate, cLR, nr, DNE, DNL);


% 6.- VECTORS:
[tANv, tANe, tXNv, tXNe] = um0631_upNvects (tANv, tANe, tXNv, tXNe, tTVcon, tAv, tXv, Nti, itr);


% 7.- OPTIMAL TETS NODES: I think they are not used, but we need to have
% them coz Dtet will be called in the removal of outside tets

[tAtetIN, tAtetOU, tXtetIN, tDtet] = um0666_uOtets ...
(tAtetIN, tAtetOU, tXtetIN, tDtet, DNE, tNE, Na, ate, Spatches, pR, tTVcon, tAv);


% 8.- RE-ALLOCATES:

MLT.tNE = tNE;
MLT.tNV = tNV;
MLT.tNL = tNL;
MLT.tTVcon = tTVcon;
MLT.tLVcon = tLVcon;
MLT.tVLcon = tVLcon;
MLT.tTLcon = tTLcon;
MLT.tVTcon = tVTcon;
MLT.tLTcon = tLTcon;

MLT.tBv = tBv;
MLT.tUv = tUv;
MLT.tAv = tAv;
MLT.tXv = tXv;

MLT.tANv = tANv;
MLT.tXNv = tXNv;
MLT.tANe = tANe;
MLT.tXNe = tXNe;
MLT.tNCS = tNCS ;

MLT.tAtetIN = tAtetIN ;
MLT.tAtetOU = tAtetOU  ;
MLT.tXtetIN = tXtetIN;
MLT.tDtet = tDtet;



end

