function [inr, itr, ilr, Nti, Nni, Nnli, DNE, DNV, DNL] = um0662_ChrtIns (Na, ate, cLR, tNE, tNV, tNL, tTVcon)

% RETURNS: params that characterize the insertion in the MLT
% (see meaning below)

if Na == 1 && cLR == 0
    
    % 1.- Interior within one triangle
    
    TR = ate(1,1);
    
    inr = [ tTVcon(TR,1), tTVcon(TR,2), tTVcon(TR,3), tNV+1 ] ; % involved nodes refs (new ones at rear)
    itr = [ TR , tNE+1 , tNE+2] ;   	% involved triangles refs , new ones are rear
    ilr = [ tNL+1 , tNL+2, tNL+3 ] ;    % involved lines refs, that are new or modified

    Nti = 3; % No. involved triangles, including the new ones

    Nni = 4 ; % No. involved nodes, considering the new inserted

    Nnli = 3 ; % No. modified / new lines involved
    
    % increments: number of new added items
    
    DNE = 2 ; 
    DNV = 1 ;
    DNL = 3 ;
    
    
elseif Na == 1 && cLR > 0
    
    % 2.- At line, and line is at edge of MLT:

    TR = ate(1,1);
    
    inr = [ tTVcon(TR,1), tTVcon(TR,2), tTVcon(TR,3), tNV+1 ] ;
    itr = [ TR , tNE+1 ] ;         
    ilr = [ cLR, tNL+1 , tNL+2 ] ; 

    Nti = 2; 

    Nni = 4 ; 

    Nnli = 3 ;  %%%%%%%%%%%%%% = 2
    
    % increments:
    
    DNE = 1 ; 
    DNV = 1 ;
    DNL = 2 ;
    
elseif Na == 2 && cLR > 0
    
    % 3.- At line, and the line is interior to MLT:
    
    TR1 = ate(1,1);
    TR2 = ate(1,2);

    inr = zeros(6,1);
    conta = 0 ;
    for t = 1:1:Na
        
        r = ate(1,t);
        
        for i = 1:1:3
        	conta = conta + 1 ;
            inr(conta,1) = tTVcon(r,i);
        end
    end
    
    [inr,~] = GEN_16_RemoveRepeatedRows (inr, 1, 0.1);
    inr = inr';
    
    inr = [ inr, tNV+1 ] ;                 
    itr = [ TR1, TR2, tNE+1, tNE+2 ] ;    	
    ilr = [ cLR, tNL+1 , tNL+2 , tNL+3 ] ;  

    Nti = 4; 

    Nni = 5 ; 

    Nnli = 4 ;
    
    % increments:
    
    DNE = 2 ; 
    DNV = 1 ;
    DNL = 3 ;
    
end
end

