function [iNv, iUv] = fs0721_iNodes (Us, Ns, cDu, cR)

%cULims = [0 1];

iNv = 0;
iUv = zeros(1,1);

% transfers to x-y names, like coordinates:
nd = 6 ;
x = round(Us,nd);
y = round(cDu,nd);

% front advancing:
%c1 = 0;
%tu1 = zeros(2,1);



% 1.- SPECIAL CASES:
    
spF = 0; % special case flag
    
% 1.1.- Minimum step is greater that 0.475 => just inserts mid-node:
    
if  0.475 < min(y)
        
	iNv = 3 ;
        
	iUv(1,1) = 0 ;
	iUv(2,1) = 0.5 ;
	iUv(3,1) = 1 ;
        
	spF = 1 ;
        
end
    
    
% 1.2.- All steps vary less than +- c portion of the Uspan => uses average
    
avy = sum(y)/Ns;
c = 0.05 ;
    
if spF == 0
    if (avy-c <= min(y) && min(y) <=avy+c) && ...
       (avy-c <= max(y) && max(y) <=avy+c)  
        
        % computes No. segments (mininum 2)
        n = round(1/avy,0);
        if n<2
            n = 2 ;
        end
        
        % corrects (n+1) to be odd number:
        if mod(n+1,2)==0
            n = n+1;
        end
        
        d = 1/n;
        
        iNv = n+1;
        
        acc = 0 ;
        for i = 1:1:n
            iUv(i,1) = acc ;
            acc = acc + d;
        end
        
        iUv(n+1,1) = 1 ;
        
        spF = 2 ;
    end
end   
    
    
% 2.- REST OF THE CASES:
    
if spF == 0
    
    endF = 0 ;
    
    iNv = 3 ; % initial step
    iUv = [0 ; 0.5 ; 1];
    
    while endF == 0
        
        endF = 1 ;
        
        % checks intervals
        for i = 1:1:iNv-1
            
            iDu = iUv(i+1) - iUv(i);
            
            % check sample points:
            
            spF = 0 ; % sample point found flag
            dvF = 0 ; % divide flag
            
            for j = 1:1:Ns
                
                if iUv(i) <= Us(j) && Us(j) <= iUv(i+1)

                    spF = 1 ;
                    
                    if cDu(j) < iDu
                        dvF = 1 ;
                        break
                    end
                    
                end
            end
            
            % in case no sample point is within the interval, interpolates
            % at the interval limits:
            
            if spF == 0 && dvF == 0
                
                % finds sample where the interval is in
                for j = 1:1:Ns-1
                    
                    if Us(j) <= iUv(i) && iUv(i) <= Us(j+1)
                        
                        % interpolates at both interval limits
                        
                        m = (cDu(j+1) - cDu(j)) / (Us(j+1) - Us(j));
                        
                        cDui1 = cDu(j) + m * (iUv(i) - Us(j));
                        cDui2 = cDu(j) + m * (iUv(i+1) - Us(j));
                        
                        if cDui1 < iDu || cDui2 < iDu
                            dvF = 1 ;
                        end
                        
                        break
                    end
                end
            end
            
            
            if dvF==1
                
                iNv = iNv + 1 ;
                
                tUv1 = iUv(1:i,1);
                iu = (iUv(i) + iUv(i+1))/2;
                tUv2 = iUv(i+1:end,1);
                
                iUv = [ tUv1 ; iu ; tUv2 ];
                
                endF = 0;
                
            end
            
            
        end

    end
    


	% in case of No. nodes even , adds another one:
    
	if mod(iNv,2)==0
        
        [iUv] = fs0722_addtoEven (iUv, iNv);
        iNv = iNv + 1 ;
        
	end


end


% 3.- MOVES MID-NODES TO THE CENTER OF THE SEGMENT:

for i = 2:2:iNv
    
    n1 = i-1;
    n2 = i+1;
   
    um = (iUv(n1,1) + iUv(n2,1))/2 ;
    
    iUv(i,1) = um ;
    
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% plots profile and inserted nodes
%{

if cR==1

    figure(34)
    
    % profile:
    
    plot(x,2*y,'k'); hold on 
    
    plot([0 1],[0 0] ,'k'); hold on 
    
    % nodes:
    
    wnod = zeros(1,2);
    conta = 0 ;
    for i = 1:2:iNv
        conta = conta + 1 ;
        wnod(conta,1) = iUv(i,1);
    end
    
    scatter( wnod(:,1), wnod(:,2), 'k', 'filled');
    
    axis equal
    
    xlim([0 1])
    ylim([-0.1 0.6])
 
end
%}





end

