function [xe] = fs0722_addtoEven (x, n)

% RETURNS:
% x(n+1,1) with one extra node added, which is required since n is even

% INPUTS:
% x(n,1) original array with n being even

xe = zeros(n+1,1);

% The longest segment lenght is Lm,
% and its adjacent sements are L1 and L2, left and right respectively.
% Inserts in the mid-point of the longest segment, and moves the other
% nodes repartiendo una distancia de 0.25*Lm a cada lado

% Detects longest span:

Lm = 0 ;
r = 0 ;

for i = 1:1:n-1
    
    l = x(i+1)-x(i);
    
    if Lm < l
        r = i ;
        Lm = l ;
    end
end



% 1.- SPECIAL CASES:

scF = 0 ; % special case flag

if r == 1
    
    % 1.1.- First segment:
    
    scF = 1;
    
    % nodes from 3rd to end
    nr = [2 3];
    
    [xe] = fs0723_mForw (nr, x, n, xe);
    
    % first and second nodes:
    xe(1,1) = x(1,1);
    xe(2,1) = (x(1,1) + xe(3,1))/2;
    
    % last node:
    %xe(n+1,1) = x(n,1);
    
elseif r == n-1
    
    % 1.2.- Last segment:
    
	scF = 2;
    
    % nodes first to pre-last:
    nr = [n-1 n];
    
    [xe] = fs0724_mBack (nr, x, n, xe);
    
	% last two nodes:
    xe(n,1) = (x(n,1) + xe(n-1,1))/2;
    xe(n+1,1) = x(n,1) ;
    
	% first node:
    %xe(1,1) = x(1,1);
    
end



% 2.- REST OF THE CASES:

if scF == 0
    
    % backwards:
    nr = [r r+1];
    [xe] = fs0724_mBack (nr, x, n, xe);
    

    % forward:
    nr = [r+1 r+2];
    [xe] = fs0723_mForw (nr, x, n, xe);
    

    % mid node:
    xe(r+1,1) = (xe(r,1)+xe(r+2,1)) / 2 ;
    
    
end



end

