function [Ncn, cBn, cAn, cXn, uNFC] = fs0725_tetDis ...
       (pR, cR, Spatches, tFace, agCurv, rcaL, fNcn, fcBn, fcXn, fcAn, uNFC, GPT, Xtol, DUtol)

% RETURNS:
% contour curves coords in all spaces updated to consider tet sizes

sudim = 2 ;
pudim = 3 ;
xdim = 3 ;

cDegree = agCurv(cR,1).Degree ;
cNcp    = agCurv(cR,1).Ncp ;
cKnotV  = agCurv(cR,1).KnotV ;
cP      = agCurv(cR,1).P ;
cw      = agCurv(cR,1).w ;
    
pDegree = Spatches(pR,1).INS(1).mDegree ;
pNcp    = Spatches(pR,1).INS(1).mNcp ;
pKnotV  = Spatches(pR,1).INS(1).mKnotV ;
pUsize  = Spatches(pR,1).INS(1).mUsize;
pP      = Spatches(pR,1).INS(1).mP ;
pw      = Spatches(pR,1).INS(1).mw ;
pCD     = zeros(pudim,1);
[pEw,pEP] = GEN_12_ExpandBw (pw, pP, xdim, pudim, pNcp);
pULims = [0 1 ; 0 1 ; 0 1 ];


Ar = zeros(1,pudim);
A1 = zeros(pudim,1);
A3 = zeros(pudim,1);


% extracts coordinates of the curve in temporary arrays:
% (they will be updated)

cBn = zeros(fNcn(cR),1);
cXn = zeros(fNcn(cR),xdim);
cAn = zeros(fNcn(cR),pudim);
    
cUn = zeros(uNFC(cR,1).Nsr, fNcn(cR), sudim);



tr = 0 ; % temporary ref

% only considers end-nodes, i.e. checks each segment
for v = 1:2:fNcn(cR)-2 
        
	% representative point of the segment is the mid-node
        
	Ar(1,:) = fcAn(cR,v+1,:);

        
	% finds tet where Ar lies in:
        
	ID = pointLocation(GPT.DT,Ar);
        
        
	% average length (in param. space) of the ID tet.
        
	La = GPT.Lax(ID,1);
        
        
	% current lenght of the curve segment:
        
	A1(:,1) = fcAn(cR,v+0,:);
	A3(:,1) = fcAn(cR,v+2,:);
        
	Lc = norm(A1-A3);

	% compares and inserts nodes if required:
        
	if Lc/La >= rcaL
            
        % INSERTION: computes new nodes 
            
        ns = round(Lc/La); % No. new sub-segments (within the current segment)
            

        % recalculates coordinates, in curve param space (and then  
        % computes the other coords) including inital and finalend-nodes:

        B1 = fcBn(cR,v+0);
        B3 = fcBn(cR,v+2);
            
        DB = (B3 - B1)/ns;
            
        m = 2*ns+1; % note that m is always odd (required for mid-nodes corresct location)
            
        Bss = [B1:DB/2:B3]'; % new nodes (end and mid-nodes)

            
        
        for k = 1:1:m-1
                
            b = Bss(k); 
            
            x = b2601_BNURBS_Xcoord (b, cKnotV, cNcp,cDegree, cNcp+cDegree+1 , cw,cP, 1, xdim);
            
            [a,~] = v2865b_onePoint (x, Ar, pDegree, pNcp, pKnotV, pUsize, pP ,pw, pEP ,pEw, pCD, pULims, xdim, Xtol, DUtol);

            tr = tr + 1 ;

            cBn(tr,1) = b ;
            cAn(tr,:) = a(1,:);
            cXn(tr,:) = x(:,1);
            
            for s = 1:1:uNFC(cR,1).Nsr
 
                sR = uNFC(cR,1).sr(s,1);
                
                u0 = zeros(1,sudim);
                u0(1,:) = round(uNFC(cR,1).Un(s,v,:),6) ;
                
                sDegree = tFace(1,pR).mSur(sR,1).Degree;
                sNcp    = tFace(1,pR).mSur(sR,1).Ncp;
                sKnotV  = tFace(1,pR).mSur(sR,1).KnotV;
                sUsize  = tFace(1,pR).mSur(sR,1).Usize;
                sP      = tFace(1,pR).mSur(sR,1).P;
                sw      = tFace(1,pR).mSur(sR,1).w;
                sCD     = tFace(1,pR).mSur(sR,1).CS;

                [sEw, sEP] = GEN_12_ExpandBw (sw, sP,xdim, sudim, sNcp);
                ULims = [ 0 1 ; 0 1 ];
                
                [u,~] = s2835b_onePoint (x, u0, sDegree, sNcp, sKnotV, sUsize, sP ,sw, sEP ,sEw, sCD, ULims, xdim, Xtol, DUtol);
                cUn(s,tr,:) = u(1,:);
                
            end
            
        end
 
    else
            
        % NO INSERTION: just pass nodes values
            
        for k = 1:1:2
                
            tr = tr + 1 ;
                
            cBn(tr,1) =  fcBn(cR,v-1+k); 
            cAn(tr,:) =  fcAn(cR,v-1+k,:);
            cXn(tr,:) =  fcXn(cR,v-1+k,:);
                
            for s = 1:1:uNFC(cR,1).Nsr
                cUn(s,tr,:) = uNFC(cR,1).Un(s,v-1+k,:); 
            end
            
        end  
	end
           
end
     
    
% last node:
    
tr = tr+1;
    
cBn(tr,1) = fcBn(cR,v+2);
cAn(tr,:) = fcAn(cR,v+2,:);
cXn(tr,:) = fcXn(cR,v+2,:);
  
for s = 1:1:uNFC(cR,1).Nsr
    cUn(s,tr,:) = uNFC(cR,1).Un(s,v+2,:); 
end

uNFC(cR,1).Un = cUn;

Ncn = tr ;
   
  

end

