function [ccTp] = fs0726_NFC2ccTp (pR, ccTp, NFC, uNFC)

% RETURNS:
% ccPp with NCF allocated

Nc = ccTp(pR,1).Nc;

cNFC(Nc,1) = struct( 'n',0, 'Nsr', 0, 'sr',[], 'Un',[] , 'Bn',[], 'An',[],  'Xn',[]);

% Nsr: No. surfaces attached to the curve
% sr(Nsr,1): surfaces refs (the second might be zero)
% Un(Nsr,n,sudim):  coords in surface param space


for c = 1:1:Nc
    
    n = NFC.Nc(c,1);
    
    Bnc = zeros(n,1);
    Anc = zeros(n,3);
    Xnc = zeros(n,3);

    for i = 1:1:n
        
        Bnc(i,1) = NFC.Bn(c,i);
        Anc(i,:) = NFC.An(c,i,:);
        Xnc(i,:) = NFC.Xn(c,i,:);
        
    end
    
    cNFC(c,1).n = n ;
    
 	cNFC(c,1).Bn = Bnc;
    cNFC(c,1).An = Anc;
    cNFC(c,1).Xn = Xnc;
    
    
    % U-coords:
    
    cNFC(c,1).Nsr = uNFC(c,1).Nsr ;
    cNFC(c,1).sr  = uNFC(c,1).sr ;
    cNFC(c,1).Un  = uNFC(c,1).Un ;
    
end



ccTp(pR,1).NFC = cNFC;



end

