function [sDu, Us, Ns] = fs0731_SreqdS ...
    (Spatches, pR, tFace, sR, Nsd, cU, Nc, tolSt, Xtol, DUtol)

% RETURNS: 
% sDu(Ns,sudim): required distance in one surface param space to reduce below tolerance
% Us(Ns,sudim): sample points location in surface parameter space
% Ns: No. sample points

% INPUTS:


% 1.- EXTRACTS DATA FROM RELEVANT PATCH, SURFACE and COMPUTES TOLERANCE:
   
sudim = 2 ;
pudim = 3 ;
xdim  = 3 ;

% Param. limits and admisible error in absolute value

Udiag = 3^0.5 ;
Eadm = Udiag*tolSt / 100;
    

% 2.- SAMPLE POINTS.
% Only those ones within the envelope of contours 1:

Nc1 = Nc(1,1);
cU1 = zeros(Nc1,sudim);

cU1(:,:) = cU(1,1:Nc1,:);

[EAs, Us, Ns, h, Sref] = fs0732_SampleP (Spatches, pR, tFace, sR, Nc1, cU1, Nsd, Xtol, DUtol);



%{
% plots EAs

if sR == 1

    figure(102)

    for i=1:1:Ns

        scatter3( EAs(i,:,1) , EAs(i,:,2) , EAs(i,:,3) , 'b'); hold on

    end

    axis equal

    if ff==0
    end

end

%}

% 3.- COMPUTES MAX. ALLOWABLE DISTANCE to 
% reduce error < tolS in patch param. space.
% Evaluates distance in both direciton, u and v, and stores both

sDu  = zeros(Ns,2);

conta = 0;
for i = 1:1:Nsd
    
    for j = 1:1:Nsd
    
        conta = conta + 1 ;
        
        % 3.1.- Sample points:
        
        [Au1, Au2, Av1, Av2] = fs0733_Sdi (EAs, Nsd, i, j);
        
    
        % 3.2.- Req'd distance bt'n nodes to reduce it to tolS:
  
        [smax1,ndS3] = fs0794_SmaxC (Au1,Au2, h(1), Eadm, xdim, sR);
        [smax2,~] = fs0794_SmaxC (Av1,Av2, h(2), Eadm, xdim, sR);


        if smax1 > 1
            smax1 = 1 ; 
        end

        if smax2 > 1
            smax2 = 1 ; 
        end

        sDu(conta,1)  = smax1 ;
        sDu(conta,2)  = smax2 ;
        
    end
    
    
end


end

