function [EAs, Us, Ns, h, Sref] = fs0732_SampleP (Spatches, pR, tFace, sR, Nc, cU, Nsd, Xtol, DUtol)

sudim = 2 ;
pudim = 3 ;
xdim  = 3 ;


% Patch:

pDegree = Spatches(pR,1).INS(1).mDegree ;
pNcp    = Spatches(pR,1).INS(1).mNcp ;
pKnotV  = Spatches(pR,1).INS(1).mKnotV ;
pUsize  = Spatches(pR,1).INS(1).mUsize;
pP      = Spatches(pR,1).INS(1).mP ;
pw      = Spatches(pR,1).INS(1).mw ;
pCD     = zeros(pudim,1);
    
% Surface:

sDegree = tFace(pR).mSur(sR).Degree ;
sNcp    = tFace(pR).mSur(sR).Ncp ;
sKnotV  = tFace(pR).mSur(sR).KnotV ;
sUsize  = tFace(pR).mSur(sR).Usize ;
sP     = tFace(pR).mSur(sR).P ;
sw     = tFace(pR).mSur(sR).w ;
sCD    = tFace(pR).mSur(sR).CS ;
[sEw,sEP] = GEN_12_ExpandBw (sw, sP, xdim, sudim, sNcp);   


% 1.- TEMPORARY SAMPLE POINTS (RECTANGLE ENVELOPING THE CONTOUR)

cLim = [min(cU(:,1)) max(cU(:,1)) ; min(cU(:,2)) max(cU(:,2)) ];

h = zeros(sudim,1);

for di = 1:1:sudim
    h(di,1) = (cLim(di,2) - cLim(di,1)) / (Nsd-1) ; % step
end



tNs = 0 ;
tUs  = zeros(1, sudim);
tSref = zeros(1, sudim);

EAs = zeros(Nsd,Nsd,pudim);

acc = zeros(sudim,1);

acc(1) = cLim(1,1);
for i = 1:1:Nsd
    
    Xs  = zeros(1, xdim);
    
    acc(2) = cLim(2,1);
    for j = 1:1:Nsd

        tNs = tNs + 1 ;
        
        tUs(tNs,1) = acc(1) ; 
        tUs(tNs,2) = acc(2) ; 
        
        tSref(tNs,1) = i ;
        tSref(tNs,2) = j ;
        
        [X] = b2601_BNURBS_Xcoord (acc, sKnotV, sNcp, sDegree, sUsize, sEw, sEP, sudim, xdim);
        
        Xs(j,:) = X(:,1);
        
        
        acc(2) = acc(2) + h(2);
        if j == Nsd-1
            acc(2) = cLim(2,2);
        end
        
    end
    
    % param. coordinates of that row:
    [Asr] = v2861b_PPvol (Xs, j, pDegree, pNcp, pKnotV, pUsize, pP, pw, pCD, xdim, Xtol, DUtol);
    
    %{
    figure(77)
    scatter3( Asr(:,1),  Asr(:,2),  Asr(:,3), 'r'); hold on
    axis equal
    %}
    
    for j = 1:1:Nsd
        EAs(i,j,:) = Asr(j,:);
    end
    
    acc(1) = acc(1) + h(1);
    if i == Nsd-1
        acc(1) = cLim(1,2);
    end
    
end


% patch param. coordinates:



% 2.- LOCALIZES POINTS WITHIN THE CONTOUR and ALLOCATES ANSWERS: CANCELLED

Ns = tNs ;
Us = tUs ;
Sref = tSref ;

%{
Nc1 = Nc ;
cU1 = zeros(1,Nc,sudim);

for i = 1:1:Nc1
    cU1(1,i,:) = cU(i,:);
end

NL = 1 ;
pc = 5 ;

[Ns, Us] = fs0739_nodesIN (tNs, tUs, Nc1, cU1, NL, pc);

%}

%{
figure(sR)

plot(cU(:,1), cU(:,2), 'k'); hold on
scatter(Us(:,1),Us(:,2),'b'); hold on

axis equal
%}

end

