function [NE, Nn, ENc, Cm, rF, viF] = fs0743_Mref (eR, NE, Nn, ENc, Cm, Du, viF)

% RETURNS:
% refined mesh if required
% rF: refining flag, rF = 1 if refinement happened

sudim = 2 ;

rF = 0 ;

% initial element nodes refs:

n1 = ENc(eR,1);
n2 = ENc(eR,2);
n3 = ENc(eR,3);
n4 = ENc(eR,4);
 
% increments in the element:
De = [ Cm(n4,1) - Cm(n1,1) ; Cm(n4,2) - Cm(n1,2) ]; 
      
% DEFINES WHICH TYPE OF INSERTION. In case it wants to insert in a single
% direction, if it its virgin in the perpendicular then inserts in both.

Icase = 0 ; % 1 for direction in DIR 1, 2 for DIR 2 , and 3 for both

if Du(1) < De(1) && Du(2) < De(2) 
    
    Icase = 3 ;
    
	viF(1) = 0 ; % deactivates virgin flag in both directions
    viF(1) = 0 ;
    
elseif Du(1) < De(1)

    Icase = 1 ;
    
    if viF(2)==1 
        Icase = 3 ;
        viF(1) = 0 ;
        viF(2) = 0 ; 
    end
    
elseif Du(2) < De(2) 
        
    Icase = 2 ;
    
    if viF(1)==1 
        Icase = 3 ;
        viF(1) = 0 ;
        viF(2) = 0 ; 
    end
end





if Icase == 3  

    % INSERTS IN BOTH DIRECTIONS:
    
    % add nodes:
            
    for di = 1:1:sudim 
        Cm(Nn+1,di) = (Cm(n1,di) + Cm(n3,di)) / 2;
     	Cm(Nn+2,di) = (Cm(n1,di) + Cm(n2,di)) / 2;
     	Cm(Nn+3,di) = (Cm(n1,di) + Cm(n4,di)) / 2;
      	Cm(Nn+4,di) = (Cm(n3,di) + Cm(n4,di)) / 2;
     	Cm(Nn+5,di) = (Cm(n2,di) + Cm(n4,di)) / 2;
    end
            
	% updates current element:
            
	ENc(eR,1) = n1 ; ENc(eR,2) = Nn+2 ; ENc(eR,3) = Nn+1 ; ENc(eR,4) = Nn+3 ;
            
	% adds 3 new elements:
            
 	ENc(NE+1,1) = Nn+1 ; ENc(NE+1,2) = Nn+3 ; ENc(NE+1,3) = n3   ; ENc(NE+1,4) = Nn+4 ;
  	ENc(NE+2,1) = Nn+2 ; ENc(NE+2,2) = n2   ; ENc(NE+2,3) = Nn+3 ; ENc(NE+2,4) = Nn+5 ;
  	ENc(NE+3,1) = Nn+3 ; ENc(NE+3,2) = Nn+5 ; ENc(NE+3,3) = Nn+4 ; ENc(NE+3,4) = n4  ;
            
	% No.:
  	NE = NE + 3 ;
 	Nn = Nn + 5 ;
            
	rF = 1 ;
    
elseif Icase == 1
    
    % INSERTS IN DIR 1, i.e. vertical line:
        
	% add nodes:
            
    for di = 1:1:sudim 
        Cm(Nn+1,di) = (Cm(n1,di) + Cm(n3,di)) / 2;
     	Cm(Nn+2,di) = (Cm(n2,di) + Cm(n4,di)) / 2;
    end
    
	% updates current element:
            
	ENc(eR,1) = n1 ; ENc(eR,2) = n2 ; ENc(eR,3) = Nn+1 ; ENc(eR,4) = Nn+2 ;
            
	% adds 3 new elements:
            
 	ENc(NE+1,1) = Nn+1 ; ENc(NE+1,2) = Nn+2 ; ENc(NE+1,3) = n3   ; ENc(NE+1,4) = n4 ;

	% No.:
  	NE = NE + 1 ;
 	Nn = Nn + 2 ;
    
    rF = 1 ;
        
elseif Icase == 2  
          
    % INSERTS IN DIR 2, i.e. horizt. line:
       
	% add nodes:
            
    for di = 1:1:sudim 
        Cm(Nn+1,di) = (Cm(n1,di) + Cm(n2,di)) / 2;
     	Cm(Nn+2,di) = (Cm(n3,di) + Cm(n4,di)) / 2;
    end
    
	% updates current element:
            
	ENc(eR,1) = n1 ; ENc(eR,2) = Nn+1 ; ENc(eR,3) = n3 ; ENc(eR,4) = Nn+2 ;
    
	% adds 3 new elements:
            
 	ENc(NE+1,1) = Nn+1 ; ENc(NE+1,2) = n2 ; ENc(NE+1,3) = Nn+2   ; ENc(NE+1,4) = n4 ;

	% No.:
  	NE = NE + 1 ;
 	Nn = Nn + 2 ;
    
	rF = 1 ;   
   
end

end

