function [Nn, Uin] = fs0744_nodesIN2 (tNs, tUs, Nc, cU, NL)

% RETURNS:
% Nn: No. nodes within the contour cU and with longer distance to contour than md
% Uin(Nn,sudim): coordinates of those nodes

% INPUTS:
% tNs:              No. nodes to check
% tUs(tNs,sudim):   their coordinates
% Nc:               No. nodes of the contour, the first and last node coincides
% cU(NL,Nc, sudim):    contour nodes coordinates
% NL: No. loops
% pc: percentaje of envelope distance to compute md

sudim = 2 ;

Nn = 0 ;
Uin = zeros(1,sudim);


% 1.- Constraint polygons (as many as NL):

xv = cU(1,1:Nc(1),1);
yv = cU(1,1:Nc(1),2);

if NL > 1
    for i = 2:1:NL
        
        xt =  cU(i,1:Nc(i),1);
        yt =  cU(i,1:Nc(i),2);
        
        xv = [xv NaN xt ] ;
        yv = [yv NaN yt ] ;
        
    end
end



% 2.- Determines which are IN:

xq = tUs(1:tNs,1);
yq = tUs(1:tNs,2);

[in] = inpolygon(xq,yq,xv,yv);



% 3.- Stores nodes IN:

uc = zeros(sudim,1);

for i = 1:1:tNs
    
    if in(i)==1
        
        uc(:,1) = tUs(i,:); % candidate

        Nn = Nn + 1 ;
        Uin(Nn,:) = uc(:,1);

    end
    
end



end

