function [NFS, endF] = fs0745_StetDis ...
         (contaL, GPT, pR, sR, Spatches, tFace, NL, NFS, eCNT, ccTp, Xtol, DUtol, rcaL)
% included previously CNT

endF = 1 ;

pudim = 3 ;
sudim = 2 ;
xdim = 3 ;

sDegree = tFace(pR).mSur(sR).Degree ;
sNcp    = tFace(pR).mSur(sR).Ncp ;
sKnotV  = tFace(pR).mSur(sR).KnotV ;
sUsize  = tFace(pR).mSur(sR).Usize ;
sP     = tFace(pR).mSur(sR).P ;
sw     = tFace(pR).mSur(sR).w ;
[sEw,sEP] = GEN_12_ExpandBw (sw, sP, xdim, sudim, sNcp);   
    
pDegree = Spatches(pR,1).INS(1).mDegree ;
pNcp    = Spatches(pR,1).INS(1).mNcp ;
pKnotV  = Spatches(pR,1).INS(1).mKnotV ;
pUsize  = Spatches(pR,1).INS(1).mUsize;
pP      = Spatches(pR,1).INS(1).mP ;
pw      = Spatches(pR,1).INS(1).mw ;
pCD     = zeros(pudim,1);
[pEw,pEP] = GEN_12_ExpandBw (pw, pP, xdim, pudim, pNcp);  

pULims = [ 0 1 ; 0 1 ; 0 1 ] ; 



% 1.- LINEAR TRIANGULATION:

% 2.1.- Initial triangulation:
[NV, NE, TRC, conn, NL, Nlv] = fs0751_LinTrin (sR, eCNT, NFS, NL);
% included previously CNT  

%%%%%%%%%%%%%%%%%   %%%%%%%%%%%%%%
% plots triangulation
%{

if pR == 1 && contaL == 3

    fr = contaL ;
    
    figure(fr)

    Cv = TRC.Av;

    NLI = size(conn.LV,1);
    dim = size(Cv,2);

    if dim == 2
        scatter( Cv(:,1), Cv(:,2),'r'); hold on
    elseif dim == 3
        %scatter3( Cv(:,1), Cv(:,2), Cv(:,3),'r'); hold on
    end
    
    lrF = 0;
    vrF = 0;
    erF = 0;

    pt1366_pTriLinMesh_nD ...
    (Cv, NLI, conn.LV, conn.TV, dim, fr, 'r', 1.3, 0, 0, 0, 0, NE, 0, 0, 0, lrF, vrF, erF);

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %{
    % normals to triangles:
    
    for t = 1:1:NE
        
        u = zeros(pudim,1);
        v = zeros(pudim,1);
        r = zeros(3,1);
        
        Anod = zeros(3,pudim);
        Ct =  zeros(pudim,1);
        
        for i = 1:1:3
            
            r(i) = conn.TV(t,i);
            
            for di = 1:1:pudim
            Anod(i,di) = Avm(r(i),di);
            Ct(di,1) = Ct(di,1) + Avm(r(i),di)/3;
            end
            
        end
        
        for di = 1:1:3
            u(di,1) = Anod(2,di) - Anod(1,di);
            v(di,1) = Anod(3,di) - Anod(2,di);
        end
        
        n = cross(u,v);

        quiver3(Ct(1),Ct(2),Ct(3),n(1),n(2),n(3),'k'); hold on
        
    end
    
    %}
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


end

%}
%%%%%%%%%%%%%%%%%   %%%%%%%%%%%%%%


% 2.2.- Improvement in patch parameter space:

pL = 60 ;

[NV, NE, TRC, conn, NL, Nlv] = fs0754_IMPRVtri1 ...
(NV, NE, TRC, conn, NL, Nlv, ccTp, Spatches, pR, tFace, sR, Xtol, DUtol, pL, contaL);


%%%%%%%%%%%%%%%%%   %%%%%%%%%%%%%%
% plots triangulation
%{

if pR == 1 && contaL == 3

    fr = 100+contaL ;
    
    figure(fr)

    Cv = TRC.Av;

    NLI = size(conn.LV,1);
    NV = size(Cv,1);
    dim = size(Cv,2);

    if dim == 2
        scatter( Cv(:,1), Cv(:,2),'r'); hold on
    elseif dim == 3
        %scatter3( Cv(:,1), Cv(:,2), Cv(:,3),'r'); hold on
    end
    
    lrF = 0;
    vrF = 0;
    erF = 0;

    pt1366_pTriLinMesh_nD ...
    (Cv, NLI, conn.LV, conn.TV, dim, fr, 'b', 1.3, 0, NV, 0, 0, NE, 0, 0, 0, lrF, vrF, erF);


    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %{
    % normals to triangles:
    
    for t = 1:1:NE
        
        u = zeros(pudim,1);
        v = zeros(pudim,1);
        r = zeros(3,1);
        
        Anod = zeros(3,pudim);
        Ct =  zeros(pudim,1);
        
        for i = 1:1:3
            
            r(i) = conn.TV(t,i);
            
            for di = 1:1:pudim
            Anod(i,di) = Avm(r(i),di);
            Ct(di,1) = Ct(di,1) + Avm(r(i),di)/3;
            end
            
        end
        
        for di = 1:1:3
            u(di,1) = Anod(2,di) - Anod(1,di);
            v(di,1) = Anod(3,di) - Anod(2,di);
        end
        
        n = cross(u,v);

        quiver3(Ct(1),Ct(2),Ct(3),n(1),n(2),n(3),'k'); hold on
        
    end
    
    %}
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

end


%}
%%%%%%%%%%%%%%%%%   %%%%%%%%%%%%%%


% 2.- INSERTS NODES AT TRIANGLES LINES (NOT AT LINES THAT LIE AT CONTOURS)
    
Ar = zeros(1,pudim);
A1 = zeros(pudim,1);
A2 = zeros(pudim,1);

U1 = zeros(sudim,1);
U2 = zeros(sudim,1);

NLI = size(conn.LV,1);
    
for i = 1:1:NLI   
    if conn.LT(i,2) > 0 % only for internal lines

        n1 = conn.LV(i,1);
        n2 = conn.LV(i,2);
        
        % representative point of the segment is the mid-location
        Ar(1,:) = (TRC.Av(n1,:) + TRC.Av(n2,:))/2;
 
        % finds tet where Ar lies in:
        ID = pointLocation(GPT.DT,Ar);

        % average length (in param. space) of the ID tet.
        La = GPT.Lax(ID,1);

        % current lenght of the segment:
        A1(:,1) = TRC.Av(n1,:);
        A2(:,1) = TRC.Av(n2,:);
        Lc = norm(A1-A2);

        
        % compares and inserts nodes if required:

        if Lc/La >= rcaL
                

            % INSERTION: computes new nodes 
            ns = round(Lc/La); % No. new sub-segments (within the current segment)

            if ns > 1
                endF = 0 ; % only if divides at least one line switches the flag
            end
            
            % recalculates coordinates, in curve param space (and then  
            % computes the other coords) including inital and final end-nodes:

            U1(:,1) = TRC.Uv(n1,:);
            U2(:,1) = TRC.Uv(n2,:);

            DU = (U2 - U1)/ns;

            for k = 1:1:ns-1
                
                NFS.Ns(sR,1) = NFS.Ns(sR,1) + 1 ;
                
                r = NFS.Ns(sR,1);
                
                U1 = U1 + DU ;
                x = b2601_BNURBS_Xcoord (U1, sKnotV, sNcp, sDegree, sUsize , sEw, sEP, sudim, xdim);
                [a,~] = v2865b_onePoint (x, Ar, pDegree, pNcp, pKnotV, pUsize, pP ,pw, pEP ,pEw, pCD, pULims, xdim, Xtol, DUtol);

                NFS.Un(sR,r,:) = U1(:,1);
                NFS.Xn(sR,r,:) = x(:,1);
                NFS.An(sR,r,:) = a(1,:);
                NFS.Bn(sR,r)   = 0;
            end
            
        end
        
        
        
    end   
end
    

end

