function [Un, An, Xn, Nn] = fs0746_DelNclo (iUn, iAn, iXn, iNn, NL, Nc, cA, pc, nd)

% RETURNS:
% nodes valid, after removal nodes that are too close to the contours

sudim = 2 ;
pudim = 3 ;
xdim = 3 ;

Un = zeros(1,sudim);
An = zeros(1,pudim);
Xn = zeros(1,xdim);

Nn = 0 ;

ac = zeros(pudim,1); % candidate

Pr1 = zeros(pudim,1); % point of the segment (initial and final)
Pr2 = zeros(pudim,1);


for v = 1:1:iNn
    
    ac(:,1) = iAn(v,:); % candidate

    % Finds closest distance to the contour and the length of the segment involved: 
        
   	dmin  = 9999999;
    
    for L = 1:1:NL
    for j = 1:1:Nc(L)-1
            
        Pr1(:,1) = cA(L,j,:);
    	Pr2(:,1) = cA(L,j+1,:);
      	vr = Pr2-Pr1;

    	[dL, d] = go2527_distPtoRecta (ac, Pr1, vr, pudim);
     	d1 = norm(Pr2-ac);
      	d2 = norm(Pr1-ac);
                
        % checks if the closest point of the line is within the segment:
                
       	Q = ac+d;   
     	[ON] = go2520_PonSegment (Q, Pr1,Pr2, pudim, nd);
            
        % stores min. distance:
        
        if ON==1
            dist = dL ;
        else
        	dist = min(d1, d2);
        end
                
        % allocates in case dist is less:
                
        if dist < dmin 

         	dmin = dist ;
         	Lseg = norm(Pr2-Pr1);
            
            Prmin = [Pr1' ; Pr2'];
            
        end
        
    end
    end
    

    
    % Evaluates and includes if distance is more than threshold:
    
    dthr = Lseg * pc/100; % threshold distance
    
    if dmin > dthr
        
        Nn = Nn + 1 ;
        
        Un(Nn,:) = iUn(v,:);
        An(Nn,:) = iAn(v,:);
        Xn(Nn,:) = iXn(v,:);
    end

end


end

