function [NV, NE, TRC, conn, NL, Nlv] = fs0751_LinTrin (sR, eCNT, NFS, NL)
% included previously CNT

    
% 1.- GENERATES MERGED ARRAY OF NODES AND CONSTRAINTS FOR TRIANGULATION:
% Note the coordiantes do not include at the moment the mid-nodes

[Bvm, Uvm, Avm, Xvm, mNC, Cnst] = fs0752_merX_Cnst (eCNT, NL, NFS, sR);

TRC = struct ( 'Bv',[], 'Uv',[], 'Av',[], 'Xv',[], 'NC',[] );

TRC.Bv = Bvm;
TRC.Uv = Uvm;
TRC.Av = Avm;
TRC.Xv = Xvm;
TRC.NC = mNC;


% 2.- PRELIMINARY TRIANGULATION (ALL TRIANGLES):

NV = size(Uvm,1);
DT = delaunayTriangulation(Uvm,Cnst);
tTVcon = DT.ConnectivityList;
tNE = size(tTVcon,1);

% plots prelim. triangulation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%{

%if sR==4
    
    fr = 9 ;
    
    figure(fr)

    Cv = Uvm ;
    dim = size(Cv,2);
    
    if dim==2
        scatter( Cv(:,1),  Cv(:,2), 'k', 'filled'); hold on
    elseif dim==3
        scatter3( Cv(:,1),  Cv(:,2),  Cv(:,3), 'k', 'filled'); hold on
    end
    
    

    axis equal

    for t = 1:1:tNE
        
        Cnod = zeros(3,dim);
        
        for i = 1:1:3
            Cnod(i,:) = Cv(tTVcon(t,i),:);
        end
        
        pt1361_plotTri_nD (Cnod, dim, fr, 'k') ;
    end
    
    xlim([0 1])
    ylim([0 1])
    
%end


%}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



% 3.- REMOVES TRIANGLES THAT ARE QUASI-PLANE OR OUTSIDE Cnst:

%[NE, TVcon, ~] = fs0753_INtri (DT, tNE, NV, NL, CNT.Nc, CNT.cU, Uvm, tTVcon);
[NE, TVcon, ~] = fs0753_INtri (DT, tNE, NV, NL, eCNT.Nc, eCNT.cU, Uvm, tTVcon);



% plots after removal triangulation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%{

%if sR==4
    
    fr = 11 ;
    
    figure(fr)

    Cv = Avm ;
    dim = size(Cv,2);
    
    if dim==2
        scatter( Cv(:,1),  Cv(:,2), 'k', 'filled'); hold on
    elseif dim==3
        scatter3( Cv(:,1),  Cv(:,2),  Cv(:,3), 'k', 'filled'); hold on
    end
    
    

    axis equal

    for t = 1:1:NE
        
        Cnod = zeros(3,dim);
        
        for i = 1:1:3
            Cnod(i,:) = Cv(TVcon(t,i),:);
        end
        
        pt1361_plotTri_nD (Cnod, dim, fr, 'k') ;
    end
    
    
    
    %xlim([0 1])
    %ylim([0 1])
    %zlim([0 1])
    
    if gg==0
    end
%end


%}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



% 4.- OTHER CONN. MATRICES:

Nlv = zeros(NL,1);
for L = 1:1:NL
    Nlv(L,1)= eCNT.Nc(L,1)-1;
end

[LVcon, LTcon, VLcon, TLcon, VTcon] = tr1347_otherConn (NL, Nlv, NE, NV, TVcon, Uvm);

conn = struct ('TV',[], 'LV',[], 'LT',[], 'VL',[], 'TL',[],'VT',[]);

conn.TV = TVcon;
conn.LV = LVcon;
conn.LT = LTcon;
conn.VL = VLcon;
conn.TL = TLcon;
conn.VT = VTcon;


end

