function [Bvm, Uvm, Avm, Xvm, mNC, Cnst] = fs0752_merX_Cnst (eCNT, NL, NFS, sR)

cudim = 1 ;
sudim = 2 ;
pudim = 3 ;
xdim  = 3 ;
     
Bvm = zeros(1,cudim);
Uvm = zeros(1,sudim);
Xvm = zeros(1,xdim);
Avm = zeros(1,pudim);

mNC = zeros(1,1);

% First loop:

ct = zeros(eCNT.Nc(1)-1,sudim);
acc = 0 ;
conta = 0 ;

for i = 1:1:eCNT.Nc(1)-1

	conta = conta + 1 ;
        
	ct(i,1) = conta ;
	ct(i,2) = conta+1 ;
       
    Bvm(conta,:) = eCNT.cB(1,i);
	Uvm(conta,:) = eCNT.cU(1,i,:);
	Avm(conta,:) = eCNT.cA(1,i,:);
	Xvm(conta,:) = eCNT.cX(1,i,:);
        
    mNC(conta,1) = eCNT.cRef(1,i);
    
    if i == eCNT.Nc(1)-1
        ct(i,2) = acc + 1 ;
    end
    
end

Cnst = ct ;


% Next loops:

if NL > 1

    for j = 2:1:NL

        ct = zeros(eCNT.Nc(j)-1,sudim);
        acc = acc + eCNT.Nc(j-1)-1 ;
        
        for i = 1:1:eCNT.Nc(j)-1
            
            conta = conta + 1 ;

            ct(i,1) = conta ;
        	ct(i,2) = conta+1 ;
                
            Bvm(conta,:) = eCNT.cB(j,i);
            Uvm(conta,:) = eCNT.cU(j,i,:);
         	Avm(conta,:) = eCNT.cA(j,i,:);
        	Xvm(conta,:) = eCNT.cX(j,i,:);
                
            mNC(conta,1) = eCNT.cRef(j,i);
            
            if i == eCNT.Nc(j)-1
                ct(i,2) = acc + 1 ;
            end
            
        end
        
        Cnst = [Cnst ; NaN NaN ; ct];
        
    end
    
end



% Adds nodes from interior of surface:

for i = 1:1:NFS.Ns(sR)
    
    conta = conta + 1 ;
    
    Bvm(conta,1) = NFS.Bn(sR,i);
	Uvm(conta,:) = NFS.Un(sR,i,:);
    Avm(conta,:) = NFS.An(sR,i,:);
	Xvm(conta,:) = NFS.Xn(sR,i,:);

    mNC(conta,1) = 0;
    
end



end

