function [NE, TVcon, VTcon] = fs0753_INtri (DT, tNE, NV, NL, Nc, cU, Uvm, tTVcon)


% 1.- Contours:

xv = zeros(1,Nc(1));
yv = zeros(1,Nc(1));

xv(1,:) = cU(1,:,1);
yv(1,:) = cU(1,:,2);

if NL > 1
    for L = 2:1:NL

        xvt = zeros(Nc(L),1);
        yvt = zeros(Nc(L),1);
        
        xvt(1,:) = cU(L,:,1);
        yvt(1,:) = cU(L,:,2);
        
        xv = [ xv , NaN , xvt ] ;
        yv = [ yv , NaN , yvt ] ;
        
    end
end




% 2.- Triangles incentres:

tC = incenter(DT);

xq = zeros(1,tNE);
yq = zeros(1,tNE);

xq(1,:) = tC(:,1);
yq(1,:) = tC(:,2);




% 3.- Stores triangles inside the contour AND are not quasi-plane:

sudim = 2 ;

ALim = 0.1 ; % fraction of equalteral area to consider quasi-plane triangle
Nn = 3 ;

TVcon = zeros(1,3);
VTcon = zeros(NV,1);

nev = zeros(NV,1); % No. elms attached to each vtx

NE = 0;

INu = inpolygon(xq,yq, xv,yv) ;

for e = 1:1:tNE 

	if INu(e) == 1  % IN condition
        
        
        [At, ~] = tm1306_tArea_n (tTVcon, e, Uvm, 0, sudim); % triangle area
        
        Unod = zeros(Nn,sudim);
        for i = 1:1:3
            nr = tTVcon(e,i);
            Unod(i,:) = Uvm(nr,:);
        end
        Lav = tm1309_avEL (Unod, Nn, sudim); % edges aver. length
        Ate = 0.433*Lav^2 ; % equivalent equilateral triangle area
        
        
        if At > ALim*Ate % quasi-plane condition
        
            NE = NE+1;

            % conn. matrices:

            TVcon(NE,:) = tTVcon(e,:);

            for i = 1:1:3
                vr = TVcon(NE,i);

                nev(vr) = nev(vr)+1;
                VTcon(vr,nev(vr)) = NE ;
            end
            
        end
        
	end
end

end

