function [tR, nR] = fs0755_NTrefs (conn, LR)

% RETURNS:
% tR(2,1): triangles refs attached to that line ref (LR)
% nR(4,1): nodes involved arranged as follows:
    % 1,3:      LR end-nodes
    % 2,4:      vrtx of triangles tR(1) and tR(2)

    
% 1.- TRIANGLES INVOLVED:

tR = [conn.LT(LR,1); conn.LT(LR,2)]; 
 
nR = zeros(4,1); 

if tR(2) > 0  % only for internal lines

    
    % 2.- NODES:
    
    % 2.1.- Nodes at LR:

    nR(1) = conn.LV(LR,1); % ends
    nR(3) = conn.LV(LR,2);


    % 2.2.- Nodes at triangles 'free' vtx:

    for i = 1:1:3

        r1 = conn.TV(tR(1),i);
        r2 = conn.TV(tR(2),i);

        if r1~=nR(1) && r1~=nR(3)
            nR(2) = r1 ;
        end
        if r2~=nR(1) && r2~=nR(3)
            nR(4) = r2 ;
        end
    end


end

end

