function coF = fs0757_alterContr(nR, mNC, Bvm, Xvm, ccTp, pR)

coF = 0; % turns to 1 if all alternatives nodes belong to the same contour curve.


xdim = 3 ;
nd = 3 ;

arnR = [ 1 4 2 ; 3 2 4 ]; % alternative relative nodes refereces


% checks the three nodes of the alternative triangle:

for k = 1:1:2

    % 1.- Curves refs. of the nodes:
    
    cr = zeros(3,2); % two cols for two potential curves
    
    for i = 1:1:3
        
        % node ref and physical coordinates:
        
        r = nR(arnR(k,i));
        Xn = zeros(xdim,1);
        Xn(:,1) = round(Xvm(r,:),nd);
        
        
        % curve reference
        
        cr(i,1) = mNC(r,1);
        
        if cr(i,1) > 0 % checks if it is end-node, the other curve
            
            if round(Bvm(r),3)==0 || round(Bvm(r),3)==1 % end node => checks the other curve
                % searches other curve
                
                P1 = zeros(xdim,1);
                P2 = zeros(xdim,1);
                
                for c = 1:1:ccTp(pR).Nc
                    
                    Ncp = ccTp(pR).agCurv(c).Ncp ;
                    
                    P1(:,1) = round ( ccTp(pR).agCurv(c).P(1,:),   nd ) ;
                    P2(:,1) = round ( ccTp(pR).agCurv(c).P(Ncp,:), nd ) ;
                    
                    CO1 = go2542_coincidentP (P1, Xn, xdim, nd);
                    CO2 = go2542_coincidentP (P2, Xn, xdim, nd);
                    
                    if ( CO1==1 || CO2==1 ) && c~=cr(i,1)
                        cr(i,2) = c ;
                        break
                    end
                end 
            end
        end
    end
    
    
    % 2.- Checks if the three alternative nodes lie on the same curve:
    

    % no zeros in first col
    
    nzF = 1 ;
    for i = 1:1:3
        if cr(i,1) == 0
            nzF = 0;
            break
        end
    end
    
    
    if nzF == 1 % no zeros flag
        
        % finds node with only one curve
        
        ir = 0 ;
        
        for i = 1:1:3
            if cr(i,2) == 0
                dcr = cr(i,1); % driving curve ref.
                ir = i ;
                break
            end
        end
        
        
        % Checks if all nodes belong to dcr:
        
        coF = 1 ;
        
        if ir > 0

            for i = 1:1:3
            if i~=ir
                
                if cr(i,1) ~= dcr && cr(i,2) ~= dcr
                    coF=0;
                    break
                end
    
          	end
            end
            
        end

    end
    
    
    if coF==1
        break
    end
    
    
end



end

