function [ucF] = fs0759_UlinCoin (nR, Uvm, dg)

% RETURNS:
% ucF: flag of coincident lines in surface parameter space = 1 in case finds coincidence.

% INPUTS:
% nR(4,1): nodes involved
% Uvm: coords of all nodes
% dg: max. angle in degrees to assume the lines are coincident

ucF = 0 ;
sudim = 2 ;

a = zeros(sudim,1); % aux. vectors
b = zeros(sudim,1);


% Constructs the 4 vectors surrounding the contour of the 2 triangles:

r = [1 2 3 4 1];
vc = zeros(4,sudim);

for i = 1:1:4
    
    a(:,1) = Uvm(nR(r(i+0)),:);
    b(:,1) = Uvm(nR(r(i+1)),:);
    
    a = b-a;
    vc(i,:) = a(:,1);
    
end


% Vector of alternative line:

a(:,1) = Uvm(nR(2),:);
b(:,1) = Uvm(nR(4),:);

va = b-a;
va = [va ; 0 ] ;


% Checks if any of the contour vectors forms an angle equal or less than dg with 'va' vector:

for i = 1:1:4
    
    v = [ vc(i,1) ; vc(i,2) ; 0 ] ;
    
    angu = go2511_angleUV (va, v);
    angu = angu * 57.2958 ;
    
    if angu < dg 
        ucF = 1 ;
    else
        
        angu = abs(angu-180);
        
        if angu < dg
           ucF = 1; 
        end
        
    end

end


end

