function [niF] = fs0760_NodIN (nR, Uvm)

niF = 0 ; % 'node IN flag', turns to 1 if one node becomes insdie in the alternative arrangement

% the contour lines at that node form an angle smaller than 180 degrees in
% surface parameter space. That angle is called 'ac' (for angle at corner)

% To measure 'ac': sums a1 and a2 angles. They are at corner node, btwn
% contour and current diagonal

sudim = 2 ;

a = zeros(sudim,1);
b = zeros(sudim,1);
c = zeros(sudim,1);
o = zeros(sudim,1);

% First corner:

r = [   
    1 3 2 4 ; 
	3 1 4 2 
    ];

for i = 1:1:2

    c(:,1) = Uvm(nR(r(i,1)),:);

    o(:,1) = Uvm(nR(r(i,2)),:);

    a(:,1) = Uvm(nR(r(i,3)),:);
    b(:,1) = Uvm(nR(r(i,4)),:);

    v1 = a-c;
    v2 = b-c;
    vd = o-c;

    ac1 = go2511_angleUV (v1, vd);
    ac2 = go2511_angleUV (v2, vd);
    ac = (ac1 + ac2) * 57.3 ;

    if ac > 175
        niF = 1 ;
    end

end


%{


niF

Ut = zeros(5,2);
r = [1 2 3 4 1];

for i = 1:1:5
    Ut(i,:) = Uvm(nR(r(i)),:);
end

Uc = [ Uvm(nR(1),:) ; Uvm(nR(3),:) ] ;

figure(4)

plot(Ut(:,1), Ut(:,2), 'k'); hold on
plot(Uc(:,1), Uc(:,2), 'r'); hold on

axis node

if hh==0
end

%}

end

