function [NVm, Bvm, Uvm, Avm, Xvm, econn, mNC] = fs0762_iMnodes ...
    (NLI, NVm, Bvm, Uvm, Avm, Xvm, conn, mNC, NE, NL, CNT, tFace, sR, Spatches, pR, Xtol, DUtol)

% RETURNS: updated triangulation with mid-nodes inserted


% 0.- PRELIMINARIES:

sudim = 2 ;

econn = struct ('TV',[], 'LV',[], 'LT',[], 'VL',[], 'TL',[],'VT',[]);

eTV = [ conn.TV  zeros(NE,3) ];
eLV = [ conn.LV(1:NLI,1) zeros(NLI,1) conn.LV(1:NLI,2)]; % sets for mid-node insertion


% 1.- CONN. MATRIX eLV:

% 1.1.- Contour curves: 
% inherit mid-points from curves, that were already computed previously

accL = 0 ; % accumulated line ref.

for L = 1:1:NL

    Ncmid = (CNT.Nc(L,1)-1)/2 ;
    
    j = 0 ;
    for i = 1:1:Ncmid
        
        accL = accL + 1 ;
        
        j = j+2;
        
        NVm = NVm+1;
        
        Bvm(NVm,1) = CNT.cB(L,j);
        Uvm(NVm,:) = CNT.cU(L,j,:);
        Xvm(NVm,:) = CNT.cX(L,j,:);
        Avm(NVm,:) = CNT.cA(L,j,:);

        mNC(NVm,1) = CNT.cRef(L,j);

        eLV(accL,2) = NVm ;
 
    end
end


%%%%%%%%%%%%%%%%%%%%%%%%%%
% plot contour lines quadratic
%{

fr = 80;

for k = 1:1:accL


    Lnod = zeros(2,pudim);
    Qnod = zeros(3,pudim);
    
	n1 = eLV(k,1);
  	n2 = eLV(k,2);
  	n3 = eLV(k,3);
    
    Lnod(1,:) = Avm(n1,:);
    Lnod(2,:) = Avm(n3,:);
    
  	Qnod(1,:) = Avm(n1,:);
	Qnod(2,:) = Avm(n2,:);
 	Qnod(3,:) = Avm(n3,:);
   
 	pt1364_pLin (Lnod, 1.00, 2, fr, 'm', 0, pudim);
    pt1364_pLin (Qnod, 0.25, 3, fr, 'k', 0, pudim);

end
    
if kk==0
end

%}
%%%%%%%%%%%%%%%%%%%%%%%%%%


% 1.2.- Internal lines: 

Ntem = NVm ;

for r = accL+1:1:NLI
    
    Ntem = Ntem + 1 ;
    eLV(r,2) = Ntem;

end



% 2.- eTV MATRIX:

r = [ 1 2 ; 2 3 ; 3 1 ];

for e = 1:1:NE
    
    % loop on edges:
    
    for i = 1:1:3
    
        nt1 = eTV(e,r(i,1));
        nt2 = eTV(e,r(i,2));
        

        % searches line with those end nodes:
        
        for j = 1:1:3
            
            lr = conn.TL(e,j);
            
            nl1 = eLV(lr,1);
            nl2 = eLV(lr,3);
            
            if (nt1==nl1 && nt2==nl2) || (nt1==nl2 && nt2==nl1)
                eTV(e,3+i) = eLV(lr,2);
                break 
            end

        end
        
    end
    
end


% 3.- COMPUTES COORDINATES:

for r = accL+1:1:NLI
    
    NVm = NVm + 1 ;
    
    n1 = eLV(r,1);
    n3 = eLV(r,3);

    [Uf, Af, Xf] = fs0779_innerMn (n1, n3, tFace, sR, Spatches, pR, Uvm, Avm, Xvm, Xtol, DUtol);
    
    eLV(r,2) = NVm;
    
	Uvm(NVm,:) = Uf(:,1);
	Xvm(NVm,:) = Xf(:,1);
 	Avm(NVm,:) = Af(:,1);
    
end


% 5.- UPDATES CONN MATRIX:

econn.TV = eTV;
econn.LV = eLV;
econn.LT = conn.LT;
econn.VL = conn.VL;
econn.TL = conn.TL;
econn.VT = conn.VT;


end

