function [fpF] = fs0763_evaFlip (Lc, La, roc, roa, Ltol, Rtol)

% RETURNS:
% swF = 1 if flipping is to occur

% INPUTS:
% caR: ratio Lc/La. The lower the more quality
% ncv: average condition number for current
% ncM: max. condition number for current
% nav, naM: for alternative arrangement

fpF = 0 ;

% ratios:

caR = Lc / La ;

rocM = min(roc); % minimum of current ro (min. is worst case)
roaM = min(roa); % minimum of alternative ro


fr = 1 + Rtol/100 ;
fl = 1 + Ltol/100 ;

if caR >= 1
    
    % 1.- FIRST CASE:
    % Triangles obtained improve shape, this drives the situations. 
    % The length of alternative line is more or less the same
    
    if roaM > rocM * fr
        fpF = 1 ;
    end
    
    
elseif caR >= fl
    
    % 2.- SECOND CASE:
    % The lenght is reduced by Ltol %, leads the situation.
    
    if roaM > rocM / (fr/2)
        fpF = 1 ;
    end
    
    
end


end

