function [Lc, La] = fs0772_condA (sR, LR, nR, Avm, Aa, Nne)

% RETURNS:
% caR: current Diag / alternative legth ratio in patch parameter space
% (the higher the better)

pudim = 3 ;
x1 = zeros(pudim,1);
x2 = zeros(pudim,1);
x3 = zeros(pudim,1);

% 1.- CURRENT LINE LENGTH:  Lc

if Nne == 2

    x1(:,1) = Avm(nR(1),:);
    x2(:,1) = Avm(nR(3),:);
    Lc = norm(x2-x1);

elseif Nne == 3
    
	x1(:,1) = Avm(nR(1),:);
    x2(:,1) = Avm(nR(9),:);
    x3(:,1) = Avm(nR(3),:);
    Xa = [x1, x2, x3]' ;

    Lc = go2537_ArcL (Xa, pudim);
end

% 2.- ALTERNATIVE LENGTH:   La

if Nne == 2

    x1(:,1) = Avm(nR(2),:);
    x2(:,1) = Avm(nR(4),:);
    La = norm(x2-x1);

elseif Nne == 3
    
	x1(:,1) = Avm(nR(4),:);
    %x2(:,1) = Avm(nR(9),:);
    x2 = Aa';
    x3(:,1) = Avm(nR(2),:);
    Xa = [x1, x2, x3]' ;
    
    La = go2537_ArcL (Xa, pudim);
end



%{
% 3.- CHECKS EXCEPTION OF CONDITION A IN CASE IS CANDIDATE: cancelled so
% far, to account for mid-modes, that are checked in condition B, in the
% regularity

if La < Lc

    caF = 1 ;
    
    %{
    
	% Condition A, not permitted if: 
	% both nRa are edge and one nRc in between, all three consecutive, and 
	% one of the alternative nodes is far from the plane of the other 3 ndes
    % (further more than 20% of the equlateral triangle side)
       
	pc = 10 ;
	c1aF = 1 ;
        
    % points coordinates, 'current' and 'alternatives':
    
	c1 = zeros(pudim,1); 
	c2 = zeros(pudim,1);
    
	a1 = zeros(pudim,1);
	a2 = zeros(pudim,1);
        
    for di = 1:1:pudim
        
        c1(di,1) = Avm(nRc(1)); 
        c2(di,1) = Avm(nRc(2)); 
        
        a1(di,1) = Avm(nRa(1)); 
        a2(di,1) = Avm(nRa(2)); 
        
    end
        
	for cL = 1:1:NL
           
        % first condition
            
           if (ieL(cL,1) <= nRa(1) &&  nRa(1) <= ieL(cL,2)) && ...
              (ieL(cL,1) <= nRa(2) &&  nRa(2) <= ieL(cL,2))
               
                if (min(nRa)+2 == max(nRa)) && ...
                  ((min(nRa)<nRc(1) && nRc(1)<max(nRa)) || (min(nRa)<nRc(2) && nRc(2)<max(nRa)))
               
                    % second condition:
                    
                    [A,B,C,D] = go2506_Plane3P (c1,c2,a1);
                    [d,~,~] = go2534_distPtoPlan (a2, A, B, C, D);
                    
                    [At, ~] = tm1306_tArea_n (0,0,0,[c1';c2';a1'],pudim);
                    
                    dmin = (At/0.433)^0.5 * pc/100;
                    
                    if d > dmin
                        c1aF = 0 ;
                    end

                end
          
           end
	end
     
    %}
    
end

%}
end

