function [ncv,ncM , nav,naM] = fs0773_condB (nR, Avm, Aa, Nne, LR)

% RETURNS:
% ncv,ncM , nav,naM: average and max. CV of both options (current and alternative)

% INPUTS:
% L:        line reference (the one between both triangles)
% tR(2):    ref of involved triangles

pudim = 3 ;

Nnt = 3*(Nne-1); % No. nodes per triangle

Anod1 = zeros(Nnt,pudim);
Anod2 = zeros(Nnt,pudim);


% 1.- LCV-number OF CURRENT OPTION:

nc = zeros(2,1);
  
nr1 = [ nR(1) nR(2) nR(3) nR(5) nR(6) nR(9) ];
nr2 = [ nR(1) nR(3) nR(4) nR(9) nR(7) nR(8) ];

for i = 1:1:Nnt 
	Anod1(i,:) = Avm(nr1(i) , :);
	Anod2(i,:) = Avm(nr2(i) , :);
end
   


nc(1) = tm1305_LCVnumber (Anod1, Nne, pudim);
nc(2) = tm1305_LCVnumber (Anod2, Nne, pudim);

ncv = sum(nc)/2;    % average
ncM = max(nc);      % max
      

% 2.- LCV-number OF ALTERNATIVE:        

na = zeros(2,1);

nr1 = [ nR(1) nR(2) nR(4) nR(5) nR(9) nR(8) ];
nr2 = [ nR(4) nR(2) nR(3) nR(9) nR(6) nR(7) ];
           
for i = 1:1:Nnt
	Anod1(i,:) = Avm(nr1(i),:);
	Anod2(i,:) = Avm(nr2(i),:);
end

for di = 1:1:pudim
    Anod1(5,di) = Aa(di);
    Anod2(4,di) = Aa(di);
end

%{
if LR==22
    
    figure(55)
    
    for i = 1:1:3
        plot3( [Anod1(i,1) Anod1(i+3,1)] ,[Anod1(i,2) Anod1(i+3,2)] ,[Anod1(i,3) Anod1(i+3,3)] ,'r'); hold on
        
    end
    
    axis equal
    
end

%}

na(1) = tm1305_LCVnumber (Anod1, Nne, pudim); 
na(2) = tm1305_LCVnumber (Anod2, Nne, pudim);
           
nav = sum(na)/2 ;   % average
naM = max(na);      % maximum


end

