function [swF] = fs0774_evaSwap (caR, ncv, ncM , nav, naM, Ltol, CVtol)

% RETURNS:
% swF = 1 if swapping is to occur

% INPUTS:
% caR: ratio Lc/La. The lower the more quality
% ncv: average condition number for current, the higher the better
% ncM: max. condition number for current
% nav, naM: for alternative arrangement

swF = 0 ;

fl = 1 + Ltol/100 ;
fc = 1 + CVtol/100 ;

if caR >= 1
    
    % 1.- FIRST CASE:
    % Triangles obtained improve shape, this drives the situations. 
    % The length of alternative line is more or less the same
    
    if nav < ncv/fc && naM < ncM/fc
        swF = 1 ;
    end
    
    
elseif caR >= fl
    
    % 2.- SECOND CASE:
    % The lenght is reduced by 20 %, leads the situation.
    
    if nav < ncv && naM < ncM
        swF = 1 ;
    end
    
    
end


end

