function [Ua, Aa, Xa, coF] = fs0776_MnodeAlte (LR, nRa, Bvm, Uvm, Avm, Xvm, mNC, ccTp, tFace, sR, Spatches, pR, Xtol, DUtol)

% RETURNS:
% Aa(pudim,1): alternative edge mid-node location in patch parameter space
% coF: contour flag = 1 if mid-node lies on contour line => the alternative is not possible

% INPUTS:
% nRa(2): alternative line end-nodes refs

cudim = 1 ;
sudim = 2 ;
pudim = 3 ;
xdim = 3 ;

% 1.- NODES AND CURVES REFS (if applies):

Ua = zeros(sudim,1);
Aa = zeros(pudim,1);
Xa = zeros(xdim,1);

n1 = nRa(1);
n2 = nRa(2);

cR = [ mNC(n1) , mNC(n2) ] ;

eB = [ Bvm(n1,:) ; Bvm(n2,:) ] ;
eU = [ Uvm(n1,:) ; Uvm(n2,:) ] ;
eA = [ Avm(n1,:) ; Avm(n2,:) ] ;
eX = [ Xvm(n1,:) ; Xvm(n2,:) ] ;


% 2.- CONTOUR CHECK

if cR(1)~=0 && cR(2)~=0
    [coF] = fs0777_ContoCheck (LR, cR, eB, eX, pR, sR, ccTp);
else
    coF = 0 ;
end

if coF==1
	return
end
 


% 3.- CARRIES ON IF NOT AT CONTOUR:

[Uf, Af, Xf] = fs0779_innerMn (n1, n2, tFace, sR, Spatches, pR, Uvm, Avm, Xvm, Xtol, DUtol);

Ua = Uf ;
Aa = Af ;
Xa = Xf ;



end

