function [coF] = fs0777_ContoCheck (LR, cR, eB, eX, pR, sR, ccTp)

% RETURNS:
% conF: contour flag = 1 if mid-node lies on contour, otherwise = 0

% INPUTS:
% 
% cR(2): refs of curves where the end-nodes lie in
% eB(2,1): end-nodes coords


xdim = 3 ;
nd = 3 ;
coF = 0 ;



% 1.- BOTH CURVES THE SAME:

if cR(1)==cR(2)
   
    coF = 1 ; % mid-node on line
    
    
    
% 2.- REFS DIFFER => MORE RESEARCH:

elseif cR(1)~=cR(2)

	% 2.1.- Detects which nodes are extremes:
    
    enF = zeros(2,1);
    
    for i = 1:1:2 
        if round(eB(i,1),nd)==0 || round(eB(i,1),nd)==1 
            enF(i)=1;
        end
    end
    

    % CASE A: both nodes are not at extreme of curve => 
    % mid-node is internal.
    
    if sum(enF)==0
        
        coF = 0 ;
        
        
    % CASE B: one node is at extreme of curve:
    
    elseif sum(enF)==1
        
        % node a is extreme and b is not
        if enF(1)==1
        	a = 1; b = 2 ;
        elseif enF(2)==1
            a = 2; b = 1 ;
        end
        
        X = zeros(1,xdim);
        X(1,:) = eX(a,:);
        
        % searches if a lies also in curve where b is:
        [nc, cRs] = fs0778_seachC (X, ccTp, pR, sR);
        
        for i = 1:1:nc
            
            if cRs(i)==cR(b)
                coF = 1 ; % mid-node is on the line
                break
            end
            
        end
        
        
        
    % CASE C: both nodes are at extreme of curve:
    
    elseif sum(enF)==2  
        
        % searches curves for both, in they hace a common curve => mid-node
        % on curve
        
        X1 = zeros(1,xdim);
        X1(1,:) = eX(1,:);
        
        X2 = zeros(1,xdim);
        X2(1,:) = eX(2,:);
        
        [nc1, cRs1] = fs0778_seachC (X1, ccTp, pR, sR);
        [nc2, cRs2] = fs0778_seachC (X2, ccTp, pR, sR);
        
        for i = 1:1:nc1
        for j = 1:1:nc2
            
            if cRs1(i)==cRs2(2)
                coF = 1 ; % mid-node is on the line
                break
            end
            
        end    
        end 
        
    end
    
    
end



end

