function [Era, Nal] = fs0781_Era (nR, Uvm, VLcon, LVcon, eNn, nd, sudim)

% RETURNS:
% Era(Ned,3): edge local ref. (1,2 or 3), angle at edge-node and Initial point within the 3-nodes arrangement (1 or 3)
% Nal: No. attached lines (internals only)

        Nal = 0 ;
        Era = zeros(1,3); % stores edge ref., angle at edge-node and its ref within the 3-nodes arrangement (1 or 3)

        for k = 1:1:size(VLcon,2)
            
            lR = VLcon(nR,k);
            if (lR > 0 &&  lR > eNn) % (line not at edge)
 
                Nal = Nal+1;
                
              	Era(Nal,1) = k ; % local reference
                
                % collects the 3 nodes coordinates and its edge-node ref.
                
                Un = zeros(3,sudim);
                for j = 1:1:3

                    nRt = LVcon(lR,j);
                    
                    if nRt == nR
                        rs = j ;
                        Era(Nal,3) = j ;
                    end
                    
                    Un(j,:) = Uvm(nRt,:);
                    
                end
                
                % computes angle w.r.t. horizontal:

                a = fs0782_dP2 (Un, rs, nd);
                Era(Nal,2) = a ; % angle
                
            end
        end

end

