function [a, dP, dP2] = fs0782_dP2 (Un, rs, nd)

% RETURNS:
% a: angle in radians at the rs ref. point of the tangent (derivative) of 2-Lagrange polynomial
% dP(sudim,1) , dP2(sudim,1): derivative and second derivative vectors

% INPUTS:
% Un(3,sudim): nodes coordinates
% rs; reference of starting point (1 or 3)

sudim = 2 ;


% reverses Un in case rs = 3
if rs == 3
    [Un] = GEN_40_invertRowsOrder (Un);
end

dP = zeros(sudim,1); % derivative at rs node (this node is 1st or 3rd)
dP2 = zeros(sudim,1);

for di = 1:1:sudim
    dP(di,1)  =  -3/2 * Un(1,di) + 2 * Un(2,di) - 1/2 * Un(3,di);
    dP2(di,1) = Un(1,di) - 2*Un(2,di) + Un(3,di);
end
     
a = go2525_vAngle2D (dP(1),dP(2), nd); % angle


end

