function [N, Era] = fs0784_recAngle (nR, Era, Nal, a1, a2, pc)

% RETURNS:
% N(Nal,2): shape function to interpolate angles between a1 and a2


% INPUTS:
% Era: local ref in VLcon / initial angle / rs
% a1,a2: angles of edges
% pc: percntaje of margin in angles

% angles are interpolated between a2 and a1


% 1.- Extract angles:

ia = zeros(Nal,1); % intermediate angle vector
ia(:,1) = Era(:,2);


% 2.- Computes effective angles:
% i.e. abanico of edge-angles where Era are to
% be in, sets a2=0 and refers all of them to a2.
% (The idea is to have all angles positive to facilitate the interpolation)

% arranges angles:

a0 = a2 ;

ea1 = a1-a2;
ea1 = fs0785_regAngle (ea1);

for i = 1:1:Nal
    
    ia(i,1) = ia(i,1) - a2;
    ia(i,1) = fs0785_regAngle (ia(i,1));
    
end

ea2 = 0;

% adds margins:

Da = ea1-ea2;
ma = Da * pc/100;

a1 = ea1 ;
a2 = ea2 ;

ea1 = ea1 - ma ;
ea2 = ea2 + ma ;

ia1 = min(ia);
ia2 = max(ia);



% 3.- Modifies angles in case one lies outside limits [ea2,ea1]:

% scales about the centre point

if ia1 < ea2 || ea1 < ia2

    amid = (ea2 + ea1)/2 ;
    La = (ea1 - ea2) / 2 ;
    
    % works out the scale:
    
    if  ia1 < ea2 && ea1 < ia2
        
        Da1 = amid - ia1 ;
        Da2 = ia2 - amid ;
        sc = La / max(Da1,Da2) ;
        
    elseif ia1 < ea2
 
        Da = amid - ia1 ;
        sc = La / Da ;
        
    elseif ea1 < ia2
        
      	Da = ia2 - amid ;
        sc = La / Da ;
        
    end
    
    
    % re-locates:
    
    for i = 1:1:Nal
        
        d = ia(i) - amid ;
        d = d * sc ;
        ia(i) = amid + d ;
        
        a = ia(i)+a0;
        a = fs0785_regAngle (a);
        Era(i,2) = a;
        
    end
 
end


% 4.- Computes shape functions for each intermediate angle:

N = zeros(Nal,2);

Da = a1-a2 ;

for i = 1:1:Nal
    N(i,1) = (a1 - ia(i)) / Da;
    N(i,2) = (ia(i) - a2) / Da;
end



end

