function Uvm = fs0786_reU2 (nR, Uvm, Nal, Era, t1, t2, VLcon, LVcon, sudim)

% RETURNS:
% Uvm: with updated mid-node to comply with tangent condition

for i = 1:1:Nal
    
    % 1.- Line data:
    
 	llR = Era(i,1); % local ref in VLcon
    a   = Era(i,2); % updated angle
    rs  = Era(i,3); % if = 3 starts from the end node (needs reversal)
    
    LR = VLcon(nR,llR); % line ref.
    
    
    % 2.- Line nodes arranged:
    
    Un = zeros(3,sudim);
    
    for j = 1:1:3 
        L = LVcon(LR,j);
        Un(j,:) = Uvm(L,:);
    end
    
    % reverses Un in case rs = 3
    if rs == 3
        [Un] = GEN_40_invertRowsOrder (Un);
    end

    
    % 3.- Computes module of tangent as it is:
    
    ti = zeros(sudim,1);
    
    for di = 1:1:sudim
        ti(di,1) = -3/2*Un(1,di) + 2*Un(2,di) - 1/2*Un(3,di);
    end
    
    nti = norm(ti);
    
    
    % 4.- Re-orientes tangent acc. to updated angle:
    
    uti = [ nti*cos(a) ; nti*sin(a) ];
    
    
    % 5.- Moves central node to achieve that tangent at initial point (ref. rs):
    
    u1 = zeros(sudim,1);
    u2 = zeros(sudim,1);
    u3 = zeros(sudim,1);
    
    u1(:,1) = Un(1,:);
    u3(:,1) = Un(3,:);
    
    u2(:,1) = (uti(:,1) + 3/2*u1(:,1) + 1/2*u3(:,1)) / 2 ;
    
    mnR = LVcon(LR,2);
    
    Uvm(mnR,:) = u2(:,1);
    
    
    %{
    if nR==7

        figure(1)
        
        plot( [0 t1(1)] , [0 t1(2)], 'k'); hold on
        plot( [0 t2(1)] , [0 t2(2)], 'k'); hold on
        
        plot( [0 ti(1)] , [0 ti(2)], 'b'); hold on
        plot( [0 uti(1)] , [0 uti(2)], 'r'); hold on
        ti
        uti
        
        
        axis equal
        
    end
    %}
    
end




end

