function [Ai1, Ai2] = fs0793_Cdi (cAi, Ns, r)

% RETURNS:
% Ai(4,pudim): Points to estimate 3rd derivative in curves
% Ai1 is centred about prev. segment
% Ai2 is centred about next  segment

% INPUTS:
% cAi(Ns,pudim): sample points patch param. coordinates
% Ns: No. sample points
% r: ref. of point to compute

nd = 6 ;
pudim = 3 ;

Ai1 = zeros(4,pudim);
Ai2 = zeros(4,pudim);

if r <= 2
   
    % first two points: uses only the first 4 nodes
    
    for i = 1:1:4
        Ai1(i,:) = cAi(i,:);
        Ai2(i,:) = cAi(i,:);
    end
    
elseif 2 < r && r < Ns-1
    
    % intermediates: computes centred at prev. and next segments
    
    for i = 1:1:4
        Ai1(i,:) = cAi(r-3+i,:);
        Ai2(i,:) = cAi(r-2+i,:); 
    end
    
elseif Ns-1 <= r
    
    % last two points: uses only the last 4 nodes
    
	for i = 1:1:4
        
        j = Ns-4+i;
        
        Ai1(i,:) = cAi(j,:);
        Ai2(i,:) = cAi(j,:);
	end

end


end
