function [smax, nC3d] = fs0794_SmaxC (Ci1, Ci2, h, Eadm, xdim, cR)

% RETURNS:
% smax: max. allowable step to comply with admissible error Eadm

% Ci: sample points (curve values) to estimate the derivative
% h : step for derivative estimation
% Eadm: max. allowable error

%C1d = zeros(xdim,1);
%C2d = zeros(xdim,1);
C3d1 = zeros(xdim,1);
C3d2 = zeros(xdim,1);

for di = 1:1:xdim
    
    % 0.- FIRST AND SECOND DERIVATIVES:
    
    %C1d(di,1) = (Ci(3,di) - Ci(2,di))/h ;
    %C2d(di,1) = (Ci(3,di) - 2*Ci(2,di)+ Ci(1,di))/h^2 ;
    
    % 1.- THIRD DERIVATIVE:
    
	C3d1(di,1) = (Ci1(4,di) - 3*Ci1(3,di) + 3*Ci1(2,di) - Ci1(1,di))/h^3 ;
    C3d2(di,1) = (Ci2(4,di) - 3*Ci2(3,di) + 3*Ci2(2,di) - Ci2(1,di))/h^3 ;
end



% 3.- NORM OF 3rd DERIVATIVE:

nC3d = norm((C3d1+C3d2)/2);

%{
if cR==10
   
    A = 0.300 ;
    B = 0.165 ;
    
    h = 0.51 ;
    k = 0.43 ;
    
    e   = zeros(1,3);
    de3 = zeros(1,3);
    nde = zeros(1,1);
    bs = zeros(1,1);
    
    conta = 0 ;
    for t = 0:0.05:1
        
        conta = conta + 1 ;
        
        e(conta,1) = 0 ;
        e(conta,2) = A * cos(t) + h ;
        e(conta,3) = B * sin(t) + k ;
        
     	de3(conta,1) = 0 ;
        de3(conta,2) =  6.3^3 * A * sin(6.3*t) ;
        de3(conta,3) = 6.3^3 * (-B) * cos(6.3*t) ;
        
        nde(conta,1) = norm( [ de3(conta,1), de3(conta,2),de3(conta,3) ] );
        
        bs(conta,1) = t ;
        
    end
    
    figure(11)
    plot(bs,nde,'k'); hold on

end
%}

% 4.- MAX. STEP:

smax = ( 15.6*Eadm / nC3d )^(1/3);

end

