function [] = fs0795_PlotScomparison ...
    (pR, sR, Spatches, tFace, rTskin, ccTp, Xtol, DUtol)

xdim = 3 ;
sudim = 2 ;
pudim = 3 ;

nd = 6 ;


% 1.- EXTRACTS DATA:

sDegree = tFace.mSur(sR).Degree ;
sKnotV = tFace.mSur(sR).KnotV ;
sUsize = tFace.mSur(sR).Usize ;
sNcp   = tFace.mSur(sR).Ncp ;
sP     = tFace.mSur(sR).P ;
sw     = tFace.mSur(sR).w ;
[sEw,sEP] = GEN_12_ExpandBw (sw, sP, xdim, sudim, sNcp);

pDegree = Spatches(pR).INS(1).mDegree;
pKnotV  = Spatches(pR).INS(1).mKnotV;
pUsize  = Spatches(pR).INS(1).mUsize;
pNcp    = Spatches(pR).INS(1).mNcp;
pP      = Spatches(pR).INS(1).mP;
pw      = Spatches(pR).INS(1).mw;
[pEw,pEP] = GEN_12_ExpandBw (pw, pP, xdim, pudim, pNcp);
pCD     = [ 0 0 0 ];

NEt = rTskin(sR,1).mNE ;
Uvt = rTskin(sR,1).mUv ;
Avt = rTskin(sR,1).mAv ;
Xvt = rTskin(sR,1).mXv ;
TVt = rTskin(sR,1).mTVcon ;
VTt = rTskin(sR,1).mVTcon ;
LVt = rTskin(sR,1).mLVcon ;
LTt = rTskin(sR,1).mLTcon ;
VLt = rTskin(sR,1).mVLcon ;



% 2.- TRIANGULATION (QIT) and EXACT SURFACE: Qe

Qe = struct('NV', 0, 'NE', 0, 'Xv',[], 'Av',[], 'Uv',[], 'LV', [], 'TV', [] ); 

% 2.1.- Triangulation:

tolRc   = 1.50 ;
tolRs   = 4.00 ;
tolD    = 20 ;
Nvx     = 3 ;
R       = 4 ;
pesw    = 30 ;

Nf = 1 ; % No. faces & surf features:

sf = struct('Degree', [], 'Ncp', [],'KnotV', [],'Usize', [],'P', [],'w', [],'Ew', [],'EP', [],'CS', [] ) ;

sf.Degree = sDegree ;
sf.Ncp = sNcp;
sf.KnotV = sKnotV;
sf.Usize = sUsize;
sf.P = sP ;
sf.w = sw ;
sf.Ew = sEw ;
sf.EP = sEP ;
sf.CS = tFace.mSur(sR).CS ;


agCurv  = ccTp.agCurv ;
nlo     = ccTp.nlo ;
ncu     = ccTp.ncu ;
SCcon   = ccTp.SCcon ;
TNcu    = ccTp.Nc ;

[cLXv, cLUv, Ncv, ~] = ts3312_Cvertexes (agCurv, TNcu, R, Nvx, tolRc, xdim);

ndig    = 5 ;
wbF     = 1 ;
DerC    = 'ip' ;

[QITst] = ts3330_QITst ...
(tolRc, tolRs, tolD, Nvx, R, pesw, Nf, sf, agCurv, cLXv, cLUv, Ncv, nlo, ncu, SCcon, xdim, ndig, 0,0,0, wbF, DerC);

NV = size(QITst(1).mXv,1);
Xv = QITst(1).mXv;
Uv  = QITst(1).mUv;


% 2.2.- Computes vertexes coords (these are the exact ones, i.e. Q-surface):

NV = size(QITst(1).mXv,1);
Xv = QITst(1).mXv;

Av = v2861b_PPvol (Xv, NV, pDegree, pNcp, pKnotV, pUsize, pP, pw, pCD, xdim, Xtol, DUtol);


% 2.3.- Allocates exact surface:

Qe.NV = NV ;
Qe.NE = QITst(1).mNE ;

Qe.Xv = Xv ;
Qe.Av = Av ;
Qe.Uv = Uv ;

Qe.LV = QITst(1).mLVcon ;
Qe.TV = QITst(1).mTVcon ;

 

    
% 3.- APPROXIMATED SURFACE:

Qa = struct('NV', 0, 'NE', 0, 'Xv',[], 'Av',[], 'Uv',[], 'LV', [], 'TV', [] ); 

Qa.NV = Qe.NV ;
Qa.NE = Qe.NE ;

Qa.Uv = Qe.Uv ;

Qa.LV = Qe.LV ;
Qa.TV = Qe.TV ;


% 3.1.- Computes approximated coordinates:

Ava = zeros(NV,pudim);
Xva = zeros(NV,xdim);

for i = 1:1:NV
    
    u = Qa.Uv(i,:);

    nr = i ;
    
    [Aa] = fs0796_Aestimd (nr, u, rTskin, sR);
    Ava(i,:) = Aa(:,1);
    
    Xa = b2601_BNURBS_Xcoord (Aa, pKnotV, pNcp, pDegree, pUsize, pEw, pEP, pudim, xdim);
    Xva(i,:) = Xa(:,1);
    
end

Qa.Av = Ava ;
Qa.Xv = Xva ;




% 4.- PLOTS:

% 4.1.- Plots quadratic triangulation:
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% {

    fr =  11 ;
    
    stL = 0.25 ;
    stT = 0.25 ;
    
    Cv = Uvt ;
    dim = size(Cv,2);
    
    NLI = size(LVt,1);
    
    eF = 1 ; 
    sF = 0 ; 
    nF = 0 ; 
    lrF = 0 ; 
    vrF = 0 ; 
    erF = 1 ; 

    pt1367_pTriQuaMesh (stL, stT, Cv, NLI, LVt, TVt, fr, NEt, eF, sF, nF, lrF, vrF, erF, dim, 'k');


	%}
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   
% 4.2.- Plots Qe:
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% {
    
        fr =  2 ;
        Cv = Qe.Av ;

        LVe = Qe.LV ;
        TVe = Qe.TV ;

        NLI = size(Qe.LV,1);
        NE = Qe.NE ;

        NV  = Qe.NV;
        dim = size(Cv,2);
        
        pt1366_pTriLinMesh_nD...
        (Cv, NLI, LVe, TVe, dim, fr, '--k', 0.5, 0, NV, 0, 0, NE, 0, 0, 0, 0, 0, 0);

	%}
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   

% 4.3.- Plots Qa:
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% {
    
        fr =  2 ;
        Cv = Qa.Av ;

        LVe = Qa.LV ;
        TVe = Qa.TV ;

        NLI = size(Qa.LV,1);
        NE = Qa.NE ;

        NV  = Qa.NV;
        dim = size(Cv,2);
        
        pt1366_pTriLinMesh_nD...
        (Cv, NLI, LVe, TVe, dim, fr, 'k', 0.05, 0, NV, 0, 0, NE, 0, 0, 0, 0, 0, 0);

	%}
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% 4.4.- Absolute error in Q^ space:

E = zeros(Qa.NV,3);

for k = 1:1:Qa.NV

    DA = Qa.Av(k,:) - Qe.Av(k,:);
    
    E(k,1) = Qa.Uv(k,1);
    E(k,2) = Qa.Uv(k,2);
    
    E(k,3) = norm(DA);
  
end


sc = 100 ;
fr =  5 ;


figure(fr)

for i = 1:1:Qa.NV
    plot3 ( [E(i,1) E(i,1)], [E(i,2) E(i,2)], [0 E(i,3)*sc], 'k'); hold on
    scatter3( E(i,1) , E(i,2), E(i,3)*sc, 5 , 'r' , 'filled'); hold on
end

axis equal






end

