function [Ae] = fs0796_Aestimd (nr, u, rTskin, sR)


NEt = rTskin(sR,1).mNE ;
Uvt = rTskin(sR,1).mUv ;
Avt = rTskin(sR,1).mAv ;
TVt = rTskin(sR,1).mTVcon ;
VTt = rTskin(sR,1).mVTcon ;
LVt = rTskin(sR,1).mLVcon ;
LTt = rTskin(sR,1).mLTcon ;
VLt = rTskin(sR,1).mVLcon ;

pudim = 3 ;
sudim = 2 ;
rdim = 2 ;

Ae = zeros(pudim,1);

NLIt = size(LTt,1);

Unod = zeros(3,sudim);

wst = 0.2 ;

w = [-1:wst:1];
ns = size(w,2); % No. sample points


% 1.- FINDS CLOSEST LINE OF rTskin IN U-space:

dmin = 999 ;
cLR = 0 ; % ref. of line

for L = 1:1:NLIt
    
    for i = 1:1:3
        
        nR = LVt(L,i);
        Unod(i,:) = Uvt(nR,:);
        
    end
    
    for j = 1:1:ns
        
        [uc] = mp1350_1Dmapp (Unod, 3, w(j), sudim);

        %{
        if nr == 107
            
            figure(1)
            scatter(uc(1),uc(2),'k'); hold on
            if j==3
                text(uc(1),uc(2),num2str(L)); hold on
            end
            
        end
        
        %}

        if norm(uc-u') < dmin
            
            dmin = norm(uc-u');
            cLR = L ;
            
        end
    end
 
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%{

if nr == 107
    figure(1)

    scatter(u(1),u(2),'r'); hold on

    uL = zeros(ns,sudim);

    for i = 1:1:3
        nR = LVt(cLR,i);
        Unod(i,:) = Uvt(nR,:);
    end

    for j = 1:1:ns

        [uc] = mp1350_1Dmapp (Unod, 3, w(j), sudim);

        uL(j,:) = uc(:,1);

    end


    plot( uL(:,1),  uL(:,2), 'g'); hold on

    axis equal

end

%}


for i = 1:1:3
	nR = LVt(cLR,i);
	Unod(i,:) = Uvt(nR,:);
end


% 2.- FINDS THE POINT within the line BY SAMPLING and DERIVATIVES:

% 2.1.- Coordinates in curve param. space.

wst = 0.01 ;
wi = [-1:wst:1];
ns = size(wi,2);

dmin = 99 ;
wc = 0 ;

for i = 1:1:ns
    
   [uc] = mp1350_1Dmapp (Unod, 3, wi(i), sudim);

	if norm(uc-u') < dmin
        dmin = norm(uc-u');
        wc = wi(i) ;
    end
end


% 2.2.- Derivative and vector u-uc:

wcp = wc - wst;
wcn = wc + wst;

if wcp < -1 
    wcp = wcp + wst;
    wcn = wcn + wst;
elseif wcn > 1
	wcp = wcp - wst;
    wcn = wcn - wst;
end

[ucp] = mp1350_1Dmapp (Unod, 3, wcp, sudim);
[uc ] = mp1350_1Dmapp (Unod, 3, wc , sudim);
[ucn] = mp1350_1Dmapp (Unod, 3, wcn, sudim);

duw = (ucn - ucp) / wst ;   % deriv. at closest point
uuc = uc - u' ;             % d vector

c3rd = uuc(1)*duw(2);       % 3rd component of the cross product


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%{
if nr == 107
    
    figure(1)
    scatter( uc(1), uc(2), 'b'); hold on
    
    quiver(uc(1),uc(2),duw(1),duw(2)); hold on
    
end
%}


% 3.- FINDS THE TRIANGLE:

stR = 0 ; % selected triangle ref.

for t = 1:1:2
    
    tR = LTt(cLR,t); 
    
    if tR > 0
        
        % 3.1.- Identifies sense of the line of the triangle:

        snL = 0 ; % sense of line 

        tnr = [ TVt(tR,1), TVt(tR,2), TVt(tR,3), TVt(tR,1) ] ;

        for i = 1:1:4
            if LVt(cLR,1)==tnr(i) && LVt(cLR,3)==tnr(i+1)
                snL = 1 ;
                break
            elseif LVt(cLR,3)==tnr(i) && LVt(cLR,1)==tnr(i+1)
                snL = -1 ;
                break
            end
        end


        % 3.2.- Checks if it is in:
        
        if (c3rd > 0 && snL > 0) || (c3rd < 0 && snL < 0)
            stR = tR;
            break
        end

    end
    
end


% If no triangle is found => assumes it is slighly outside and 
% takes the closest triangle:

if stR == 0
    stR = LTt(cLR,1);
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%{

if nr==107

    figure(1)

    Tnod = zeros(3,sudim);

    for i = 1:1:3

        nR = TVt(stR,i);
        Tnod(i,:) = Uvt(nR,:);

    end

    plot( Tnod(:,1), Tnod(:,2), 'r'); hold on

    scatter(u(1), u(2), 'b'); hold on
    
end

%}



% 4.- WITHIN THE TRIANGLE ESTIMATES THE PARENT POSITIONS:

ut = u' ;

Unod = zeros(6,sudim);
Anod = zeros(6,pudim);

for i = 1:1:6
    
    nR = TVt(stR,i);
    Unod(i,:) = Uvt(nR,:);
    Anod(i,:) = Avt(nR,:);
    
end

[r] = fs0798_ppQtri (nr, ut, Unod, sudim);


% 5.- MAPPS ONTO Q-space:

iem = [0 4 6 ; 4 0 5 ; 6 5 0 ] ;

[Ae, ~, ~] = mp1352_TRImapp (r, Anod, rdim, pudim, iem);

for di = 1:1:pudim
   
    if Ae(di) < 0 
        Ae(di) = 0 ;
    elseif Ae(di) > 1
        Ae(di) = 1 ;
    end
    
end


end

