function [r] = fs0798_ppQtri (nr, ut, Unod, udim)

% point projection for quadratic triangle
% RETURNS:
% r(rdim,1): parent space of ut coords 

% INPUTS:
% r0(rdim,1):   initial point
% ut(udim,1):   target Ucoords
% Unod(6,udim): triangle nodes coords
% udim          coords of parent space

rdim = 2 ;

r0 = zeros(udim,1);
tmp2 = zeros(udim,1);
uk = zeros(udim,1);
Qr = zeros(udim,1);
Qs = zeros(udim,1);
Qrr = zeros(udim,1);
Qss = zeros(udim,1);
Qrs = zeros(udim,1);

f = zeros(udim, 1);
J = zeros(rdim, udim);


% preselects:

rp = [0 0 ; 0.5 0 ; 1 0 ; 0 0.5 ; 0.5 0.5 ; 0 1 ];

dmin = 99 ;

for i = 1:1:size(rp,1)
    
    [tmp] = mp1357_dTrirs ( [rp(i,1);rp(i,2)] , Unod, udim);
    
    tmp2(:,1) = tmp(1,1,:);
    
    if norm(tmp2-ut)<dmin
        dmin = norm(tmp2-ut);
        r0(:,1) = rp(i,:);
    end
    
end





% N-R:

rk = r0 ;

endF = 0 ;
conta = 0 ;

while (endF==0)
    
    conta = conta + 1 ;
    
    dTri = mp1357_dTrirs (rk, Unod, udim);

    for di = 1:1:udim

        uk(di,1) = dTri(1,1,di);

        Qr(di,1) = dTri(2,1,di);
        Qs(di,1) = dTri(1,2,di);

        Qrr(di,1) = dTri(3,1,di);
        Qss(di,1) = dTri(1,3,di);
        Qrs(di,1) = dTri(2,2,di);
    end

    uut = ut - uk ;

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %{
    
    if nr==2
    
    fr = 85 ;
    
    iem = [ 0 4 6 ; 4 0 5 ; 6 5 0 ] ;
    st = 0.1 ;
    nodON = 1 ;
    
    pt1372_pTri_iem (Unod, iem, st, fr, 'k', nodON, rdim);

    for i = 1:1:3
        text ( Unod(i,1), Unod(i,2),num2str(i)); hold on
    end
    
    scatter(ut(1),ut(2),'b'); hold on
    scatter(uk(1),uk(2),'b','filled'); hold on
    
    %quiver(uk(1),uk(2),Qr(1),Qr(2)); hold on
    %quiver(uk(1),uk(2),Qs(1),Qs(2)); hold on
    
    end
    
    %}


    % f-vector:

    f(1,1) = dot(uut,Qr)  ;
    f(2,1) = dot(uut,Qs)  ;


    % Jacobian:

    J(1,1) = dot(Qr,Qr) + dot(uut,Qrr);
    J(1,2) = dot(Qr,Qs) + dot(uut,Qrs);

    J(2,1) = dot(Qr,Qs) + dot(uut,Qrs);
    J(2,2) = dot(Qs,Qs) + dot(uut,Qss);


    % increment and updates:

    Dr = J^(-1)*f;

    rk = rk + Dr ;
    
    
    if norm(Dr) < 0.005
        endF = 1;
    end
    
    if conta == 2
        endF = 1;
    end
    
end



r = rk ;

end

