function [rTskin] = fs0700_fit2surf...
    (Spatches, pR, GPT, tFace, Ntc, tcR,  Nts, tsR, ccTp, tolSt, Xtol, DUtol)

% RETURNS:
% rTskin: updated with sufficient No. vtx to reduce error in patch param. space < Eadm

%fr = 10 ;
%tolSt = 1 * tolSt ; %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% BORRAR !!




% 1.- ADD NODES TO CONTROL THE ERROR IN CONTOUR CURVES:

% 1.1.- Contour lines:
% These arrays content all nodes, i.e. end and mid-nodes.

Ns = 21; % No. sample points in each curve

[NFC, uNFC] = fs0710_fit2conto ...
(Spatches, pR, GPT, tFace, ccTp, Ntc, tcR, Ns, tolSt, Xtol, DUtol);

[ccTp] = fs0726_NFC2ccTp (pR, ccTp, NFC, uNFC);


%{

fr = 3 ;
SP = 'A';
vrF = 1 ;
crF = 1;
sc2902_plotTC (fr, SP, vrF, crF, ccTp, pR);

if jj==0
end

%}




% 1.2.- Constructs curves with only end-nodes, i.e. removes mid-nodes:
% (useful in the next step)

TNcu = ccTp(pR,1).Nc; 
[eNFC] = fs0791_ceNodes (NFC, TNcu);


% plots contour curves
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%{


figure(200)

for c = 1:1:Ntc
    
    cR = tcR(c);
    
    % all nodes:
    %{
    Av = zeros(NFC.Nc(cR),3);
    
    for i = 1:1:NFC.Nc(cR)
        Av(i,:) = NFC.An(cR,i,:);
    end
    
    plot3( Av(:,1) ,  Av(:,2) , Av(:,3) ,'r'); hold on
    scatter3( Av(:,1) ,  Av(:,2) , Av(:,3) ,'r'); hold on
    
    %}
    
    % end-nodes:
    Av = zeros(eNFC.Nc(cR),3);
    
  	for i = 1:1:eNFC.Nc(cR)
        Av(i,:) = eNFC.An(cR,i,:);
    end

    scatter3( Av(:,1) ,  Av(:,2) , Av(:,3) ,'r', 'filled'); hold on
    plot3( Av(:,1) ,  Av(:,2) , Av(:,3) ,'r'); hold on
    
end

axis equal

if gg==0
end

%}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% 2.- ADD NODES TO CONTROL THE ERROR IN CONTOUR SURFACES:
% (Inner nodes of surfaces)

% Works on the whole surfaces, without considering the trimming curves.
% Then, selects only those one within the computable surface (considering the trimming curves)

% These arrays content only ed nodes, i.e. NO mid-nodes.

Ns = 11 ; % No. sample points in each direction of the surface



[NFS] = fs0730_fit2inner ...
(GPT, Spatches, pR, tFace, Nts, tsR, Ns, eNFC, NFC, ccTp, tolSt, Xtol, DUtol);


% plots internal nodes
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%{

fr = 202 ;
figure(fr)

NFC
Cv = eNFC.Un;
Sv = NFS.Un ;

dim = size(Cv,3);


% surface nodes: 

for s = 1:1:Nts
    
    sR = tsR(s);
    
    if NFS.Ns(sR) > 0
    
        Rv = zeros(1,dim);

        for i = 1:1:NFS.Ns(sR)
            Rv(i,:) = Sv(sR,i,:);
        end

        if dim == 2
            scatter( Rv(:,1) ,  Rv(:,2) ,'b', 'filled'); hold on
        elseif dim == 3
            scatter3( Rv(:,1) ,  Rv(:,2) , Rv(:,3) ,'b', 'filled'); hold on
        end

    end
    
end

% curves nodes:

for c = 1:1:Ntc
    
    cR = tcR(c);
    
    Nc = eNFC.Nc(cR,1);
    
    x = zeros(Nc,dim);
    for i = 1:1:Nc
        x(i,:) = Cv(cR,i,:);
    end
    
    if dim == 2
        
        plot ( x(:,1), x(:,2), 'r'); hold on
        scatter( x(:,1) ,  x(:,2)  ,'r', 'filled'); hold on
        
    elseif dim ==3
        
        plot3 ( x(:,1), x(:,2), x(:,3), 'r'); hold on
        scatter3( x(:,1) ,  x(:,2) , x(:,3) ,'r', 'filled'); hold on
        
    end
    
    
end

axis equal

if jj==r
end

%}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% 3.- TRIMMING SKIN DEFINITION:

Nf = tFace(pR).Nfa;

rTskin(Nf,1) = cTskin ;

for s = 1:1:Nts

    % patch and surface references:
    
	sR = tsR(s,1); % abs. reference

    % triangulation:
    
    [rskin] = fs0750_triangSkin ...
    (pR, sR, Spatches, tFace, NFC, eNFC, NFS, ccTp, Xtol, DUtol);


    % allocation:

    rTskin(sR,1) = rskin; 
    clearvars('rskin');
    
end



% X.- COMPARISON OF SURFACE: only for chapter figures
% plots sample points in Q and Qapprox:

%{
sR = tsR(1,1);


fs0795_PlotScomparison ...
(pR, sR, Spatches, tFace, rTskin, ccTp, Xtol, DUtol);

%}



end
