function [Spatches] = b0802_BCcps(Spatches, Npa, Bentities)

% RETURNS:
% Patch-instances with anchors influenced by B.E.

% just sums up icp's from each Gp of the entity

for pa = 1:1:Npa
   
    pnbe = Spatches(pa).nbe ;
    pRbe = Spatches(pa).Rbe ;

   	NicpE = zeros(pnbe,1) ;
    RicpE = zeros(pnbe,1) ; % '1' will grow
    
    % loop on attached B.E.s to this patch:
    
    for b = 1:1:pnbe
        
        bR = pRbe(b);
        
        couR = Bentities(bR).mCOU;
        mPa = Bentities(bR).mPa;
        
        slvF = 0 ; % slave-patch flag = 1 if this patch is the slave
        if couR > 0
            
            if pa == mPa(1)
                slvF = 0 ;
            elseif pa == mPa(2)
                slvF = 1 ;
            end
            
        end
        
        

        % only considers the B.E. that has attached one boundary condition
        
        if Bentities(bR).mDIR~=0 || couR ~= 0

            Ngp = Bentities(bR).INS(1,1).skin.mNgp ;
            mGP = Bentities(bR).INS(1,1).skin.mGP ;
            
            for g = 1:1:Ngp

                if slvF == 0
                    
                    Nicp  = mGP(g).mNicp ; 
                    Ricp  = mGP(g).mRicp ;  
                    
                elseif slvF == 1
                    
                    Nicp  = mGP(g).mNicpS ;
                    Ricp  = mGP(g).mRicpS ;  
                    
                end
                
                
                for a = 1:1:Nicp
                    
                    aR = Ricp(a);
                    
                    if NicpE(b) == 0
                        
                        % first cp:
                        
                        NicpE(b) = NicpE(b)+1;
                        RicpE(b,NicpE(b)) = aR ;
                        
                    else
                        
                        % other cp's:
                        
                        alreadyIN = 0 ; 
                        
                        for ai = 1:1:NicpE(b)
                            if RicpE(b,ai) == aR 
                                alreadyIN=1;
                                break
                            end
                        end
                        
                        % only adds if wasn't add previously:
                        
                        if alreadyIN==0  
                            NicpE(b) = NicpE(b)+1;
                            RicpE(b,NicpE(b)) = aR ;
                        end
                        
                    end    
                
                end

            end
        
        end
        
    end

    Spatches(pa).INS(1).mNicpE = NicpE ;
    Spatches(pa).INS(1).mRicpE = RicpE ;
    
    
end


end

