function [Bentities] = bs0812_BCvals (Bentities, Nbe, dF, nF, d, t)

% RETURNS:
% Bentities with BC values introduced by the user

% INPUTS:

% dF(Nbe,1): Dirichlet flag = 1 if the boundary surface has attached Dirc. B.C.
% nF(Nba,1): same with Neumann

% d(Nbe,xdim): Dirichlet BC values, for non-dirichlet just ignore coz of the flag.
% t(Nbe,xdim): same with Neumann B.C.


xdim = 3 ;

for b = 1:1:Nbe
    
    
    if dF(b,1) == 1
        
        % Dirichlet:
        
        Bentities(b,1).mDIR = 1 ; % flag
        
        for di = 1:1:xdim
      	Bentities(b,1).INS(1,1).md(di,1) = d(b,di); % values
        end
        

    elseif nF(b,1) == 1
        
        % Neumann:
        
        Bentities(b,1).mNEU = 1 ; % flag

        for di = 1:1:xdim
      	Bentities(b,1).INS(1,1).mt(di,1) = t(b,di); % values
        end
        
    end

end



end
