function [BCk, BCf] = b0821_BCkf (Spatches, DoF, PFpos, Bentities, thk, Npa, insR, xdim)

% RETURNS: rows to add to K and F due to BC's
% and stores in BCk and BCf matrix and vector respectively
            
% INPUTS:
% NGPe:     No. GP's for the entity integration in each direction
% Npa:      No. patches
% Nts:      No. time steps
% insR:     instance reference where take the info from
% DoF:      total size of stiffness matrix       


% 1.- STARTS ANSWERS

BCk = zeros(2,2);
BCf = zeros(2,1);


% 2.- LOOP ON PATCHES / B.E.'s to detect which one has BC's:
            
for pa = 1:1:Npa
           
   	nbe = Spatches(pa).nbe;
    Rbe = Spatches(pa).Rbe;
    
    for b = 1:1:nbe

     	bR = Rbe(b);
           
      	% conditions attached to that B.E., if =0 no condition
       	DBC = Bentities(bR,1).mDIR ;
       	COU = Bentities(bR,1).mCOU ;


      	% 2.1.- Dirichlet BC:
        
      	if DBC > 0  
  
            NicpE = Spatches(pa).INS(insR).mNicpE(b);
            RicpE = zeros(NicpE,1);
            
            for i=1:1:NicpE
                RicpE(i,1)  = Spatches(pa).INS(insR).mRicpE(b,i);
            end

            CPref = Spatches(pa).INS(insR).mCPref;
            pfP = PFpos(pa);

            rdv = Bentities(bR,1).INS(insR,1).md; % restrained directions vector
            
            [bf, bk] = b0822_addDirichlet ...
            (NicpE, RicpE, pfP, CPref, Bentities, bR, rdv, thk, xdim, DoF, insR);
        
            assignin ('base','bk', bk);
        
            % updates:
            [BCf, BCk] = b0824_upBC (BCf, BCk, bk, bf);

        end 

                    
    	% 2.2.- Coupling:
        

        if COU > 0  

            patCou = Bentities(bR,1).mPa ; % patches ref's coupled


            % check that is the master patch (firs position in the patCou array)
            
            if patCou(1) == pa % 1st surface ref = patch ref. => carries on
                
                Mpa = patCou(1); 
                Spa = patCou(2); 
                
                NicpE  = Spatches(Mpa).INS(insR).mNicpE(b);
                RicpE = zeros(NicpE,1);
                for i=1:1:NicpE
                    RicpE(i,1) = Spatches(pa).INS(insR).mRicpE(b,i);
                end
                
                MpfPos = PFpos(Mpa);
                SpfPos = PFpos(Spa);
                
                MAref  = Spatches(Mpa).INS(insR).mCPref;
                SAref  = Spatches(Spa).INS(insR).mCPref;
                
                % slave Bentity ref.
                SbR = bR ;
                
                [bf, bk] = b0823_addCoupling ...
                (NicpE, RicpE, MpfPos, SpfPos, MAref, SAref, b, bR, SbR, Bentities, thk, xdim, DoF, insR);
            
                % updates:
                [BCf, BCk] = b0824_upBC (BCf, BCk, bk, bf);
                
            end          
        end

    
        
    end % loop on boundary curves
end % loop on patches
    



end

