function [bf, bk] = b0823_addCoupling ...
    (MNicpE, MRicpE, MpfPos, SpfPos, MAref, SAref, b, bR, SbR, Bentities, thk, pxdim, DoF, insR)
            
% RETURNS:
% bf, bk: vector / matrix of coupling for B.E. 'b' (local ref.)
            
% INPUTS:
% NicpE:    No. anchors influential on B.E. 'b' or 'bR'
% b/bR:     B.C. reference, in patch realtive terms and in absolute terms

% Note: 'S' for slave and 'M' for master patches


% No. rows to add to K : Nrows = Constrained DoF x Nicp on that B.E.
% in coupling, cDoF = pxdim
% and relative position of each anchor within AbcR:

Nrows = pxdim * MNicpE;
[sorA] = b0841_AnchorRelDir (MNicpE, MRicpE);


% on couplings all DoF are restrained in each anchor
restr = ones(pxdim,1);
cDoF = 3 ;

% prepares matrix and vector to add to K and F

bf = zeros (Nrows,1); % vector is all zeros, is not modified any more
bk = zeros (Nrows,DoF); 
     

%%%%% MASTER PATCH %%%%%

% loop on GP's:

M_Ngp = Bentities(bR).INS(insR,1).skin.mNgp;
M_GP  = Bentities(bR).INS(insR,1).skin.mGP;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%{

%if bR==4
            fr = 2 ;
            dim = 3 ;
            
            NE  = Bentities(bR,1).skin.mNE;
            Xv  = Bentities(bR,1).skin.mXv;
            TVcon = Bentities(bR,1).skin.mTVcon;
            
            figure(fr)
            
            col='r';
            if bR==4
                col='b';
            end
            
            
            for g = 1:1:M_Ngp
                
                X = M_GP(g,1).mXcoor;

                scatter3(X(1),X(2),X(3),col); hold on
                text(X(1),X(2),X(3),num2str(g)); hold on
            end

            
            xnod = zeros(3,dim);
            
            for e = 1:1:NE
                
                for i = 1:1:3
                    
                    xnod(i,:) = Xv(TVcon(e,i),:);
                    
                end
                
                pt1361_plotTri_nD (xnod, dim, fr, 'k');
            end
            
            
            
            
            axis equal
            
%end

%}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  


for g = 1:1:M_Ngp

    gNicp = M_GP(g).mNicp;
    gRicp = M_GP(g).mRicp;
    gRrel = M_GP(g).Rrel ;

    dJ1 = M_GP(g).dJ1 ;
    dJ2a = M_GP(g).dJ2a ;

    for Lr1 = 1:1:gNicp
    [filR] = b0842_rowsRef (gRicp, Lr1, sorA, cDoF, restr, pxdim);
    for Lr2 = 1:1:gNicp

        aR = gRicp(Lr2);
        col = c0952_AbsFrow (MpfPos, MAref, aR, pxdim); % First col position with in the whole system (K)

        R1 = gRrel(Lr1);
        R2 = gRrel(Lr2);

        cte1 = dJ1 *  dJ2a * R1 * R2 * thk ;

        for di=1:1:pxdim
            bk (filR(di) , (col + (di-1)) ) = bk (filR(di) , (col + (di-1)) ) + cte1 ;
        end
    end
    end
end

  


            
%%%%% SLAVE PATCH %%%%%
     
S_Ngp = Bentities(SbR).INS(insR,1).skin.mNgp;
S_GP = Bentities(SbR).INS(insR,1).skin.mGP;

M_GP = Bentities(bR).INS(insR,1).skin.mGP;

for g = 1:1:S_Ngp
    
    MgNicp  = M_GP(g).mNicp;
    MRicp   = M_GP(g).mRicp;
    SgNicp  = S_GP(g).mNicpS;
    SRicp   = S_GP(g).mRicpS;
    
    dJ1     = S_GP(g).dJ1 ;
    dJ2a	= S_GP(g).dJ2a ;
    
  	SRrel  = S_GP(g).RrelS ;
    MRrel  = M_GP(g).Rrel ;
      
   	for Lr1 = 1:1:MgNicp
    [filR] = b0842_rowsRef (MRicp, Lr1, sorA, cDoF, restr, pxdim);
    for Lr2 = 1:1:SgNicp
        
        aR = SRicp(Lr2);
        col = c0952_AbsFrow (SpfPos, SAref, aR, pxdim); % First col position with in the whole system (K)

        R1 = MRrel(Lr1);
        R2 = SRrel(Lr2);
        
        cte1 = - dJ1 *  dJ2a * R1 * R2 * thk ;

        for di=1:1:pxdim
            bk(filR(di), (col + (di-1)) ) = bk(filR(di), (col + (di-1)) ) + cte1 ;
        end
    end
  	end
    
end


            
end

