function [DoFr] = c0902_DoFr (Spatches, Npa, Bentities, insR, PFpos, xdim)

% RETURNS:
% DoFr: vector with DoF restrained by Dir or Cou conditions

DoFr = zeros(1,1);

conta = 0;

for pa = 1:1:Npa
    
    pRbe = Spatches(pa).Rbe;
    pnbe = Spatches(pa).nbe;

    
    for b = 1:1:pnbe
        
        rdir = zeros(xdim,1);
        
        beR = pRbe(b);
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %{
        if pa==2 && b==1
            Spatches(pa).INS(insR).mRicpE(b,:)
        end
        %}
        
        
        DBC = Bentities(beR,1).mDIR;
        COU = Bentities(beR,1).mCOU;
            
        if DBC~=0 || COU~=0 % if exists Dir or Cou at B.E.

            % sets rDir vector
            
            Dir = Bentities(beR,1).INS(insR,1).md;
            
            if DBC~=0
                
                for di = 1:1:xdim
                    if isnan(Dir(di)) == 1
                        rdir(di) = 0 ;
                    else
                        rdir(di) = 1 ;
                    end
                end

            end

            if COU~=0
                rdir = ones(xdim,1);
            end

            % extracts restrained cp's and computes DoFr

            NicpE = Spatches(pa).INS(insR).mNicpE(b); % No. cp's influential on that B.E.

            for a = 1:1:NicpE
                
                aRef = Spatches(pa).INS(insR).mRicpE(b,a);
                
                for di=1:1:xdim
                    if rdir(di)==1
                        conta = conta + 1;
                        DoFr(conta,1) = PFpos(pa)-1 + aRef*xdim - (xdim-di) ;
                    end
                end
            end
        
        
        end % Dir / Cou condition
 
    end % loop on patch bc

 
end % loop on patches


% Removes repeated components:
[DoFr, ~] = GEN_16_RemoveRepeatedRows( DoFr, 1, 0.01 );


% Tidies from lower to greater:
DoFr = sort(DoFr);


end

