function [Spatches] = c0912_CT_Operator (Spatches, Npa, yModel, Anty, MTL, insR)

% RETURNS: consistent tangent operator for all points of the patch

% INPUTS:
% insR: actual instance
% NL:   actual loop iteration

% Note: uses latest iteration parameters, if is the 1st loop considers
% the latest value of the latest force step.

% [P, q, Z, ~, ~ ] = ho2002_HoMatr( yLims, OrtElas );

P  = 0 ;
aH = 0;
q  = 0 ;
Z  = 0 ;


% ONLY FOR ELASTIC REGIMe it does not change 
% and it is constatnt for all points:

D = e2405_3DmatrixOrthoElastic (MTL);

% Loop on patches:


for pa = 1:1:Npa


    % 1.- Gauss points:
    
    Ngp = Spatches(pa,1).INS(insR,1).mIM.mNgp ;

    for g = 1:1:Ngp
        
        %{
        
        % THIS IS FOR PLASTICITY:
        
        % 2.1.- Select point and prev. point:
        
        Po  = Spatches(pa).INS(insR).mIM.mGP(g);
        
        if insR==1
            pPo = 0;
        else
            pPo = Spatches(pa).INS(insR-1).mIM.mGP(g);
        end
        
        
        % 2.2.- Prev. variables according to where we are in the iterations:
        
        [Vsc,Vve,~] = c0913_SetsPrevious (Po, pPo, yModel, insR, NL, pri);
        
        
        % 2.3.- Computes D and allocates to Gp:
        
        D = e2403_Dmatrix (yModel, Anty, MTL, Vsc, Vve, aH, P, q, Z, udim);

        %}
        
        Spatches(pa).INS(insR).mIM.mGP(g).mD = D ;

        %clearvars Po pPo ;
        
    end
  
    
    % 2.- Verteces of skins:
    
    for s = 1:1:Spatches(pa,1).INS(insR,1).mNsk

        for v = 1:1:Spatches(pa,1).INS(insR,1).skin(s,1).mNV
            
            Spatches(pa,1).INS(insR,1).skin(s,1).mVP(v,1).mD = D ;

        end
        
    end
    
end



end

