function [Vsc, Vve, caso] = c0913_SetsPrevious (Po, pPo, yModel, insR, NL, pri)

% RETURNS:
% Vsc, Vve: point vbles.: scalar and vectors from direct previous iteration
% Vsc (nVsc)
% Vve (nVve,6)

% INPUTS:
% Po:   Point where evaluate
% pPo:  prev. point to Po
    

% 1.- NUMBER OF VBLES, ACCORDING TO MODEL SELECTED:

if strcmp(yModel , 'Ho') == true  
    ns = 7 ; % No. scalar vbles.
    nv = 3 ; % No. vector vbles.
end

Vsc = zeros(ns,1);
Vve = zeros(nv,6) ;


% 2.- IF FIRST ABSOLUTE ITERATION:

if insR==1 && NL == 1 
           
    % keeps the initial values
    caso = 1 ;
    
    Vsc = Po.mVsc ;
    for i=1:1:nv
        for j=1:1:6
           Vve(i,j) = Po.mVve(i,1,j) ;    
        end
    end
        
    
    
% 3.- FIRST ITERATION OF THE FORCE INCREMENT (but not absolute first value):

elseif NL==1     
    
    % retrieves the latest value of latest force step (insR-1, nIT)       
    caso = 2 ;
    
    nIT = pPo.nIT ; % No. total iterations of prev. instance
    
    for vble=1:1:ns
        Vsc(vble) = pPo.mVsc(vble,nIT); 
    end
        
    for vble=1:1:nv
        for i=1:1:6
            Vve(vble,i) = pPo.mVve(vble,nIT,i);
        end
    end
  
    
    
% 4.- OTHER ITERATIONS THAN FIRST:

else  
    
    % uses latest iteration values
    caso = 3 ;
    
    for vble=1:1:ns
        Vsc(vble) = Po.mVsc(vble,NL-1); 
    end
        
    for vble=1:1:nv
        for i=1:1:6
            Vve(vble,i) = Po.mVve(vble,NL-1,i);
        end
    end

end


if pri>0
   %casoFy = [caso Vsc']
   %Vve
end


end

