function [Spatches] = c0916_ESt (Spatches, PFpos, Duacc, Npa, insR, xdim)

% RETURNS:
% computes stresses at GP's using elastic behaviour exclusively

niR = insR + 1 ;

for pa = 1:1:Npa
   
    pudim = Spatches(pa,1).pudim;

    
    % 1.- GAUSS POINTS:

    % 1.1.- Extracts points:

    Ngp = Spatches(pa,1).INS(niR,1).mIM.mNgp ;

    IM = Spatches(pa,1).INS(niR,1).mIM ;


    % 1.2.- Computes stresses in each GP:
    
    for g = 1:1:Ngp

        %tGP = cGPpa ;
      	tGP = IM.mGP(g,1) ;
        
        Nicp    = tGP.mNicp;
        Ricp    = tGP.mRicp;  
        dRx     = tGP.dRfi; 
        D       = tGP.mD; 


        
        % deformation matrix
        % and displacement vector of icps' on this GP
        [B] = s1013_Bmatrix (Nicp, [1:1:Nicp], dRx, xdim);
        [icpu] = c0953_icpU (Nicp, Ricp, Spatches, PFpos, Duacc, pa, insR, xdim);
        

        
        % Stresses:
        stv = D*B*icpu ;
        
        
        % derived values from stresses:
        [ sp, dp, VM ] = s1235_StPrin_vm (stv);
         
        
        % Allocates:
        
        tGP.mSv = stv;
        tGP.mVM = VM;
      	tGP.mPst = sp;
    	tGP.mPdi = dp;
            
    	% Spatches(pa,1).INS(niR,1).mIM.mGP = tGP;
        
        IM.mGP(g,1) = tGP;
        clearvars 'tGP';
        
    end

	Spatches(pa,1).INS(niR,1).mIM = IM ;
	clearvars 'IM';
    
    
    

	% 2.- SKIN NODES:

    % 1.1.- Extracts points:

    Nsk  = Spatches(pa,1).INS(niR,1).mNsk ;
    
    

    % 1.2.- Computes stresses in each node:
    
    % {
    
    for s = 1:1:Nsk
         
        skin = Spatches(pa,1).INS(niR,1).skin(s,1) ;
        
        NV = skin.mNV ;
         
        for i = 1:1:NV
            
            tVP = cVP ;
            tVP = skin.mVP(i,1) ;
            
            Nicp = tVP.mNicp;
            Ricp = tVP.mRicp;
            dRx  = tVP.dRfi; 
            D    = tVP.mD; 
            
            % deformation matrix
            % and displacement vector of icps' on this GP
            [B] = s1013_Bmatrix (Nicp, [1:1:Nicp], dRx, xdim);
            [icpu] = c0953_icpU (Nicp, Ricp, Spatches, PFpos, Duacc, pa, insR, xdim);
            

            % Stresses:
            stv = D*B*icpu ;

      
            
            % derived values from stresses:
            [ sp, dp, VM ] = s1235_StPrin_vm (stv);

            % Allocates:
            
            tVP.mSv = stv;
            tVP.mVM = VM;
            tVP.mPst = sp;
            tVP.mPdi = dp;
            
            skin.mVP(i,1) = tVP;
            clearvars 'tVP';
            
        end
 
        Spatches(pa,1).INS(niR,1).skin(s,1) = skin ;
        clearvars 'skin';
    end
    
    %}
    
    clearvars Ngp tGP;
 

end


end

