function [Spatches] = c0916_uP (UsInse,yModel, Spatches, PatchPos, du, nop, insR, ...
                                 Anty, yLims, OrtElas, H, ty0,pxdim, pudim, NL)

% RETURNS:
% update points after allocation of increment of force (and displacement): either GP's and nodes

% 0.- Some preliminary values:

pri = 0 ;

Dtrial = GEN_1002_3Dmatrix( yModel, OrtElas, 0,0,0,0,0,0) ;
 
uiA = 1;
for pa=1:1:nop
   
    
    % 1.- CREATES 'hmA' ANCHORS: where copy only updated Xcoor with: portion * displacement
    
    portion = 0.5;
    [hmA, uiA] = f0914_AnchorsHalfD (Spatches, pa, insR, pxdim, uiA, du, portion);

    

    % 2.- EXTRACTS GP's AND SF POINTS FOR COMFORT:
    
    %{
    %Gnet = Spatches(pa).mRefin(insR).Gnet ;
    %nGv  = Spatches(pa).mRefin(insR).nGv ;
    %mGre = Spatches(pa).mRefin(insR).mGre ;
    
    %Bsp = Spatches(pa).mRefin(insR).mBsp ;
    %Bfd = Bsp.mBfd ;
    %Ncpd = Bsp.mNcpd;
    %}
    
    nGP = Spatches(pa).mRefin(insR).mTM.nGP ;
    mGP = Spatches(pa).mRefin(insR).mTM.mGP ;
    
    nNO = Spatches(pa).mRefin(insR).mTM.nNO ;
    mN  = Spatches(pa).mRefin(insR).mTM.mN ;

    nSP = Spatches(pa).mRefin(insR).nSP ;
    Sf  = Spatches(pa).mRefin(insR).mSf ;
    
    
    % 3.- GAUSS POINTS:
    
    for g = 1:1:nGP
         
        % defines point (Po):
        Po = mGP(g);

        Nicp  = Po.mNicp;
        RicpA = Po.mRicpA;  
        
        % updates point:
        [Po] = p1207_updPo...
        (UsInse,Spatches, Po,'g', insR, NL, Nicp, RicpA, du, PatchPos, pa, ...
        g, yModel,yLims, OrtElas, hmA, Anty, H, ty0, Dtrial, pxdim, pudim, pri); 
    
        % allocates and clears Po object:
        mGP(g) = Po ;
        clearvars Po; 
    end

    
    % 4.- SF POINTS:
    
    % 4.1.- Stresses computation:
    
    for sp = 1:1:nSP
        
        % defines point (Po):
        Po = Sf(sp);

        Nicp  = Po.mNicp;
        RicpA = Po.mRicpA;  
        

        % updates point:
        [Po] = p1207_updPo...
        (UsInse,Spatches, Po,'s', insR, NL, Nicp, RicpA, du, PatchPos, pa, ...
        sp, yModel,yLims, OrtElas, hmA, Anty, H, ty0, Dtrial, pxdim, pudim, pri);  
        
        % allocates and clears Po object:
        Sf(sp) = Po ;
        clearvars Po; 
    end
    
    
    
    % 4.2.- For singular points just workout stresses as average of surrounding points:
    
    [Sf] = c1306_singSp (Sf, nSP);


    % 5.- Nodes:
    %{
    for nod = 1:1:nNO
        
        Nicp = mN(nod).mNicp ;
        RicpA = mN(nod).mRicpA ;
        
        % RM at that point:
        Po = mN(nod);
   
            
        % updates point:
        [Po] = p1207_updPo...
        (UsInse,Spatches, Po,'n', insR, NL, Nicp, RicpA, du, PatchPos, pa, ...
        nod, yModel,yLims, OrtElas, hmA, Anty, H, ty0, Dtrial, pxdim, pudim, pri);

        
        mN(nod) = Po ;
    
        clearvars Po; 
    end % end of nodes
    %}
    
    
    % 6.- Transfers changed objects to Spatches and delete vbles: (NOT SURE ABOUT THIS!)
    
    Spatches(pa).mRefin(insR).mSf       = Sf ;
    Spatches(pa).mRefin(insR).mTM.mGP   = mGP ;
    Spatches(pa).mRefin(insR).mTM.mN    = mN  ;
    
    clearvars nAN hmA nGP nNO mGP mN mSf;
    
 
end


        





end

