function [Spatches] = c0918_XbfVP (Spatches, Npa, insR, xdim)

% RETURNS:
% Spatches with GP's Xbf's updated to latest anchors position

for pa = 1:1:Npa
    
    udim = Spatches(pa,1).pudim;

    CP  = Spatches(pa,1).INS(insR,1).mCP;
    Nsk = Spatches(pa,1).INS(insR,1).mNsk;
    
    
    for s = 1:1:Nsk
        
        NV  = Spatches(pa,1).INS(insR,1).skin(s,1).mNV;

        skin = Spatches(pa,1).INS(insR,1).skin(s,1);
        
        for v = 1:1:NV
            
            tVP = skin.mVP(v,1);
            
            Ricp  = Spatches(pa,1).INS(insR,1).skin(s,1).mVP(v,1).mRicp ;
            Nicp  = Spatches(pa,1).INS(insR,1).skin(s,1).mVP(v,1).mNicp ;
            dRpa  = Spatches(pa,1).INS(insR,1).skin(s,1).mVP(v,1).dRpa ;

            [J1, detJ1] = j2316_J1_BTsp_dRpa (CP, Ricp, Nicp, dRpa, udim, xdim);
            dRfi = J1\dRpa';
            
            Spatches(pa,1).INS(insR,1).skin(s,1).mVP(v,1).dRfi = dRfi;
            Spatches(pa,1).INS(insR,1).skin(s,1).mVP(v,1).dJ1 = detJ1;
            
        end

    end
    
end


end

