function [icpu] = c0953_icpU (Nicp, Ricp, Spatches, PFpos, du, pa, insR, xdim)

% RETURNS:
% icpu:     vector with all displacements of icps on a point

% INPUTS:
% Nicp,Ricp:    No. icp's and absolute references
% du:         	anchors displacement vector (either patch or total), if patch vector, then introduce 1 for "PatchPos" and "pa"
% PatchPos:     matrix with first position of each patch in the system
% pa:        	patch reference


CPref = Spatches(pa,1).INS(insR,1).mCPref;


% 0.- Pre-sizes response:

icpu = zeros(Nicp*xdim,1); 


% 1.- Loop on icps:

conta=0;
for a = 1:1:Nicp
            
    aRef = Ricp(a);      % anchor ref.
    rpa = CPref(aRef,1); % relative position of the anchor (among the anchors ON)
    
    
    fil = PFpos(pa) - 1  +  rpa*xdim - (xdim);

    % assemblies icpu:
    for di = 1:1:xdim  
        icpu(conta+di,1) = du(fil+di,1) ;
    end

    conta=conta+xdim;
end


end

