function [ Npr, bfr, bfd] = c0956_allBFcomb (Spatches, pa)

% RETURNS: all bf combs for the stiffness matrix
% Npr: No. pairs of functions to derivate
% bfr(Npr,2): basis functions refs
% bfd(Npr,2): direction of derivatives: 1, 2 o 3

% e.g.: Npair = 3 ; bfr = [2 4; 4 4 ; 4 6]; bfd = [1 1 ; 1 2 ; 3 2];
% corresponds to: dR2,x * dR4,x ; dR4,x * dR4,y ; dR4,z * dR6,y ; 


% 1.- COMPUTES No. COMBINATIONS AND SIZES THE MATRICES:

%{
% No. combinations without xyz components 'Nc':

Nacp = Spatches(pa,1).INS(1).mNacp;

Nc = (1+Nacp)/2*Nacp;

% Total No. combinations 'Nct':

Nct = Nc*9;

%}

Nacp = Spatches(pa,1).INS(1).mNacp;

% Prelim. sizing :
Npr = 1 ; % '1' will grow
bfr = zeros(Npr,2);
bfd = zeros(Npr,2);


% 2.- FILLS THE MATRICES:
% only those whose pair of functions intersect in param. space

udim = 3 ;

CP = Spatches(pa,1).INS(1,1).mCP;

conta = 0 ;
for i = 1:1:Nacp
    
    for j = i:1:Nacp
         
        % only considers if both bf's intersect:
        Acoor = CP(i,1).mAcoor;
        AcoLi = CP(j,1).mAcoLi;

        IN = GEN_08_Orthodom_Pin_ndec (Acoor, AcoLi, udim, 'closed', 6);

        if IN == 1


            for d1 = 1:1:3
            for d2 = 1:1:3

                conta = conta+1 ;

                bfr(conta,1) = i ;
                bfr(conta,2) = j ;

                bfd(conta,1) = d1 ;
                bfd(conta,2) = d2 ;

            end
            end

        end
    end
    
end


Npr = conta ;





end

