function [Spatches] = c0900_Analysis (yModel, MTL, Spatches, Npa, Bentities, Nbe, Nts)

% pending parameters:
thk = 1 ; % to be defined for each patch (Spatches(pa).thk), at the  moment is equal to 1 as it is 3D
rtol = 0.001 ;
Anty = 1 ;
Ts = 1 ;

lambda = [1/Nts : 1/Nts : 1 ];

xdim = 3 ;


% 1.- FIRST INSTANCE X-VARIABLES:

insR = 1 ;

% 1.1.- Updated Jacobian 1 for B. surfaces 

% (IT IS pending to updated B.E. control points Xcoords => Bentities.skin.mP):
[Bentities] = c0914_J1be (Bentities, Nbe, insR, xdim);

% 1.2.- Computes GP's Xbf:
[Spatches] = c0915_XbfGP (Spatches, Npa, insR, xdim);
    

while Ts <= Nts 
    
    % STEP = Ts
    insR = Ts ;  % Note: "Ts" (time step) is the instance worked in each loop
    

    % 1.- PRELIMINARY OPERATIONS:
     
    % 1.1.- Total DoF and first patch-position of each patch in K matrix:
    [DoF, PFpos] = c0901_FppDoF (Spatches, Npa, insR, xdim);

    
    % 1.2.- DoF restrained -> DoFr (Dir or Coup):
    [DoFr] = c0902_DoFr (Spatches, Npa, Bentities, insR, PFpos, xdim);

    
    % 1.3.- Total applied force and force steps:
    [Tfe, Dfe] = c0904_FextTstep (MTL, Spatches, Bentities, Npa, PFpos, insR, thk, lambda, DoF, xdim);

    

    % 1.4.- Boundary conditions matrix and vector
    [BCk, BCf] = b0821_BCkf (Spatches, DoF, PFpos, Bentities, thk, Npa, insR, xdim);
    
    % assignin ('base','BCk', BCk);

    % 3.- COMPUTES CP's DIPLACEMENTS AND NODES STRESSES:
    
    [Spatches, Bentities] = c0911_DS ...
    (BCk, BCf, MTL, yModel, Spatches, Npa,  PFpos, insR, DoF, DoFr, Anty, thk, rtol, Dfe, Tfe, Bentities, Nbe, xdim);
    

    
    
    % 3.- COPY DATA TO NEXT INSTACE:
    % [Spatches] = c1401_CopyNextIns (UsInte, Spatches, nop, pudim, pxdim, insR+1);
  
                       
    % 4.- LOCAL REFINEMENT IF REQURIED:
    
    
    % 5.- RECOMPUTES PATCHES ANALYSIS PARAMETERS AT B.E. GP's:
    
                       
    % 6.- ADD TIME STEP AND CLEAR VARS:
        
	Ts = Ts+1;

	clearvars FextTstep DFext ;
    
end



end

