classdef cBskin

    
    properties
        
        % NURBS surface features:
        
        mDegree ;
        mKnotV ;
        mUsize ;
        mNcp ;
        mP ;
        mw ;
        
        mCS ; % closed surface flag
        mPN ; % plane surface flag
        
        
        % triangulation variables:
        
        mNE ;   % No. triangles or elements
        mNV ;   % No. vertexes (with no mid-edges vtx)
        mNVm;   % No. vertexes with mid-edge vtx, for quadratic triangles
        mAv ;   % Vertexes param. space coordinates (in terms of solid space)
        mUv ;   % Vertexes param. space coordinates (in terms of surface space)
      	
        mAvS ;  % Vertexes param. space coordinates (in terms of solid space), for slave patch, in case of coupling
 
        %{
        mNec;   % number of edge curves (migh be 2 for corner vertexes)
        mEv ;   % (Nec,1) Vertexes param. space coordinates (in terms of edge curve space, in case it applies)
        mER;    % (Nec,1) curve edge ref (local), in case it applies
        %}
        
        mXv ;   % Vertexes phys. space coordinates

        mTVcon; % connectiviy matrix (triangle to vertexes)
        mVTcon; % (vertex to triangles)
        
      	mLVcon; % connectiviy matrix (edge lines to vertexes)
        mVLcon; % 
        
        mTLcon; % triangle-line edge
        
        %{
        
    	iem; % inserted edges matrix, for mixed degree triangles
        
        mArea ; % (NE,1) in phys. space
        
        
        % normal vectors in patch param. and phys spaces, for vtx and triangles:
        
        mANv ;
        mANe ;
        mXNv ;
        mXNe ;
        
                
    	mANvS ; % for slave patch
        mANeS ;
        mXNvS ;
        mXNeS ;

        %}
        
        % No. loops and points per loop
        mNlo;
        mNlv;
        mNCL;   % (mNlo,1) No. curves per loop
        mNlcv; % (Nlo,NCL)
        
        % Integration points:
        
        mNgp ;
        mGP ;
        
        
        % patch where the skin belongs to and coupling
        
        mPa; 
        mCou;
        
        
    end
    

    methods
        
    end
    
    
end

