classdef cCpoint < handle
    
    properties
        
        mAcoor; % param. coord's 
        mXcoor; % physical coord's
        mw;     % weight
        
        mAcoLi; % param. coord's limits (scope of the anchor) (udim,2)
        
        ON;     % 1 if active, 0 if no influential
        
        mIX; % mIX(udim), indexes within the tensor arrangement
        
        
        %{
        
        mUsize; % size of local knot vector in each direction (udim)
        mLKV;   % local knot vectors (udim, mUsize)
        mLKVI;  % local knot vector for indexes (udim,mUsize)
        
        mANcoor; % Anet coordinates (udim)
        mIcoor;  % index coordinates (udim)
        
        mIcoLi; % indexes limits (scope of the anchor) (udim,2)
        
        mTj;    % indicates if there is T-joint at that anchor (udim)
                % +1:   T-junction, face extension in pos. dir
                % 0:   no T-junction, 'standard' anchor
                % -1:   T-junction, face extension in neg. dir
        
        mNEsk;  % No. Eskins that trim that anchor domain
        mEskR;  % Eskin ref's that trim the anchor domain mBskR(mNBsk)     
                
        mUsingu; % (udim) if -1 no singularity, otherwise indicates what location the singularity is
                
        % properties involved during refinement:
        
        mKtrim; % indicates if old knot vector is trimmed by new insertion (1) or not (0), mKtrim(udim)
        mInva ; % anchors related to the affected anchor during the refinement
        
        % parameters of anchor in each instance, note that some of them can
        % have several iterations ( N-R )
        nIT ;   % No. iterations
        nPA ;   % No. parameters = 3 : Fext, Fint, dua, can vary in the future
        mPar ;  % (nPA, No. iter , xdim)
        
        %}
        
    end
    
    methods
        
        function obj = cCpoint
            
            % constructor:
            %obj.mIcoor = zeros(3,1);  % makes sure Icoor's are 3D for the most general case
            
        end
        
        %{
        function InitiatesParams(obj, xdim)
            
            % initiates nPA, mPar
            nPar = 3 ;
            obj.nPA = nPar ;
            nIter = 1 ;
            obj.mPar = zeros(nPar,nIter,xdim);

        end
        %}
        
        function cor = cornersUcoor (obj, udim)
            
            %{
            % RETURNS: cor(Ncor,udim)
            % corner param. coordinates of anchor influence zone
            % arranged according to hierarchy of udim directions
            
            Ncor = 2^udim;

            cor = zeros(Ncor,udim);

            if udim==2
            
                Nc=1;
                for i=1:1:2
                for j=1:1:2  
                    
                    cor(Nc,1) = obj.mPcoLi(1,i);
                    cor(Nc,2) = obj.mPcoLi(2,j);
                    
                    Nc = Nc+1;
                end
                end
            
            
            elseif udim ==3
                
                Nc=1;
                for i=1:1:2
                for j=1:1:2  
                for k=1:1:2 
                    
                    cor(Nc,1) = obj.mPcoLi(1,i);
                    cor(Nc,2) = obj.mPcoLi(2,j);
                    cor(Nc,3) = obj.mPcoLi(3,k);
                    
                    Nc = Nc+1;
                end
                end
                end

            end
            %}
            
            
        end
        
    end
    
end

