classdef cTskin

    properties
        
        % skin %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        % NURBS surface features:
        
        mDegree ;
        mKnotV ;
        mUsize ;
        mNcp ;
        mP ;
        mw ;
        
        mCS ; % closed surface flag
        mPN ; % plane surface flag
        
        % triangulation variables:
        
        mNE ;   % No. triangles or elements
        mNV ;   % No. vertexes (with no mid-edges vtx)
        mNVm;   % No. vertexes with mid-edge vtx, for quadratic triangles
        
        mAv ;   % Vertexes param. space coordinates (in terms of solid space)
        mUv ;   % Vertexes param. space coordinates (in terms of surface space)
        mBv ;   % Vertexes param. space coordinates (in terms of curve space)
        
        mXv ;   % Vertexes phys. space coordinates

        mTVcon; % connectiviy matrix (triangle to vertexes)
        mVTcon; % (vertex to triangles)
        
    	mLVcon; % connectiviy matrix (edge lines to vertexes)
        mLTcon;
        mVLcon; % 
        
        mTLcon; % triangle-line edge
        
        % derivatives at nodes and triangle centers (w.r.t. xi and ita)
        mArea ; % (NE,1) in phys. space
        
        % normal vectors in patch param. and phys spaces, for vtx and triangles:
        
        mANv ;
        mANe ;
        mXNv ;
        mXNe ;
        

        % Others %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        mNlo ; % No. loops
        mNlv ; % (mNlo, * ) No. verteces per loop. Last node, that coincides with first, is not repeated

        mNC ;  % (mNVm,1): curve ref where the node belongs, 0 if not applies
        
    end
    
    methods
    end
    
end

