function [K] = s1011_KfromGP (Npa, Spatches, PFpos, insR, Anty, thk, DoF, xdim)

% construct stiffness matrix K but looping on Gp's, not element-wise
            
% INPUTS:
% Npa:      No. patches
% insR:     instance reference
% Anty:     analysis type. (1) p. stress, (2) p. strain, for 2D
% thk:      thickness
% DoF:      No. components of the stiffness matrix            
            
wb = waitbar(0,'calculating K with no constraints');
set(wb,'Name','K computation');
wbPos = [10 250 300 70]; % left bottom wide height
set(wb,'position', wbPos);


% 1.- INITIATES STIFFNESS MATRIX K:
    
K = zeros(DoF,DoF);
            
    

% 2.- CALCULATES EACH INTEGRATION POINTS CONTRIBUTION TO EACH ANCHOR AND STORES IN K:

for pa = 1:1:Npa % Loop on patches

    pfr = PFpos(pa);
    CPref  = Spatches(pa,1).INS(insR,1).mCPref;    
    
    % 2.1.- Integration points information of the patch:
    
    Ngp = Spatches(pa,1).INS(insR,1).mIM.mNgp ; % No. Gauss points in that patch
	GP  = Spatches(pa,1).INS(insR,1).mIM.mGP ; % Gp's object 
    
  
	% 2.2.- Loop on Gauss points:
                
 	wbE = waitbar(0, strcat ('calculating K with no constraints, patch ',num2str(pa)));
  	set(wbE,'Name','elements integration');
  	wbEPos = [10 150 300 70]; % left bottom wide height
  	set(wbE,'position', wbEPos);
         
    VOL = 0 ;
    

 	for g = 1:1:Ngp

        dJ2a = GP(g).dJ2a ;
        dJ1  = GP(g).dJ1 ;
        dRx  = GP(g).dRfi;
        D    = GP(g).mD ;
        Sv   = GP(g).mSv ;
        
        Nicp  = GP(g).mNicp;
        Ricp  = GP(g).mRicp;
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %{
        for j = 1:1:NL
        if g == Lis(j)
            
            for i = 1:1:Nicp
            if Ricp(i) == cpR
                
                dR(:,j) = dRx(:,i);
                
            end 
            end        
        end 
        end
        %}
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        
        %{
        for i = 1:1:Nicp
            
            cr = Ricp(i);
            
            if cr==11 || cr==209
            
                Nigp(cr,1) = Nigp(cr,1)+1;

                CGcon(cr,Nigp(cr)) = g ;
            
            end
            
        end
        %}
        
        VOL = VOL + dJ2a*dJ1 ;

        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %{
        if pa==1 && (g==19 || g==46)
            
            g
            
            GP(g).mAcoor
            
            %Nicp
            
            %[Ricp dRx']
               
        end
        %}
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        for a = 1:1:Nicp % loop on icp's of the point

            aR = Ricp(a);
            fil = c0952_AbsFrow (pfr, CPref, aR, xdim); % First fil position with in the whole system (K)

            for b = 1:1:Nicp % (same steps as cp "a")

                bR = Ricp(b);
                col = c0952_AbsFrow (pfr, CPref, bR, xdim); % First col position with in the whole system (K)

              	% computes Elem local stiffness sub-matrix for cp's a-b: 
              	addNL = 'no' ; % 'yes' ; % considers geom. non-linearities, otherwise 'no'
                        
                kL = s1012_subK ...
                (a,b, xdim ,thk, addNL, dJ2a, dJ1, dRx, D, Sv);
           
                
             	% stores kL values with in K:
              	for i=0:1:xdim-1
                for j=0:1:xdim-1

                    K(fil + i, col + j) = K(fil + i, col + j) + kL(1 + i, 1 + j);

                end
                end
                        
            end
        end

        % progress bar for elements
        wbEPos = [10 150 300 70]; % left bottom wide height
        set(wbE,'position', wbEPos);
        waitbar(g/Ngp,wbE, strcat('integration point = ',num2str(g+1))) ; 

        clearvars Elem ;

	end  % loop on Gauss points
             
    

    
	delete (wbE);
                
	% progress bar for patches
	waitbar(pa/Npa,wb, strcat('patch= ',num2str(pa+1))) ; 
            
                
	clearvars nGP mGP ;
                
end % loop on patches
 


delete (wb);
            
            
            
            

            
       
        


end

