function kL = s1012_subK ...
    (a,b, xdim ,thk, addNL, dJ2a, dJ1, dRx, D, Sv)

% calculates the contributuion of GP, i.e. its sub-matrix (xdim,xdim relating cp's a-b)

% INPUTS:
% a,b:  basis functions references, correspondant to dRgp_ph references

% thk:  thickness, for 3D cases assume = 1
% addNL:    if 'yes' adds KNL stiffness matrix
% GP prop: nE, edJ2(nE), dJ1, ...         
      

%PRE-SIZING:
kLgNL = zeros(xdim,xdim);


% 2.1.- K contributuion from that GP:  

Ba = s1013_Bmatrix (1,a, dRx, xdim); % B matrices for cp's 'a' and 'b'
Bb = s1013_Bmatrix (1,b, dRx, xdim);
    
kLg = Ba' * D ;
kLg = kLg * Bb ;

      


% 2.2.- Computes kLgNL for that point (if selected):  

if strcmp(addNL,'yes')==true

	BaNL = s1014_BNLmatrix (1, a, dRx, xdim);
	BbNL = s1014_BNLmatrix (1, b, dRx, xdim);
        
	STm = s1015_STmatrix (Sv, xdim);
        
	kLgNL = BaNL' * STm ;
	kLgNL = kLgNL * BbNL ;
end
                  
                
% 2.3.- Constant:

cte = (dJ1 * dJ2a * thk) ;
                
                
% 2.4.- Summs to compute kL:
            
kL = (kLg + kLgNL).* cte ; 
            
end
        