function [B] = s1013_Bmatrix (Nia, ia, dRx, xdim)

% RETURNS:
% B : deformation matrix at one location for anchors ia

% INPUTS:
% Nia:  No. included anchors, to consider in B calculation
% ia:   included anchors references, relative references for dRx !
% dRx:  deriv's of R about physical coord's dRx(Nicp,xdim)

%  B = [ Bia1 | Bia2 | Bia3 .... ]

% 0.- Makes sure dRx is (Nicp,xdim)

if size(dRx,2) ~= xdim
   dRx = dRx'; 
end


% 1.- Preliminary size for B:

Bfil = (xdim-1)*3;
B = zeros(Bfil, xdim*Nia); % deformation matrices for each cp

aC = 0 ;
for a=1:1:Nia

    aRef = ia(a);

    for fil= 1 : 1 : xdim                
        B(fil,fil+aC) = dRx(aRef,fil);
    end

    fil = (xdim+1);
        B(fil,1+aC) = dRx(aRef,2);  B(fil,2+aC) = dRx(aRef,1);

    if xdim == 3                
        B(5,2+aC) = dRx(aRef,3);    B(5,3+aC) = dRx(aRef,2);
        B(6,1+aC) = dRx(aRef,3);    B(6,3+aC) = dRx(aRef,1);
    end

    aC = aC+xdim;

end


end

