function [BNL] = s1014_BNLmatrix (Nia, ia, dRx, xdim)


% RETURNS:
% B : deformation matrix for geometrical nL at one location for anchors iA

% INPUTS:
% Nia:  No. included anchors, to consider in B calculation
% ia:   included anchors references, relative references for dRx !
% dRx:  deriv's of R about physical coord's dRx(Nicp,xdim)

%  B = [ Bia1 | Bia2 | Bia3 .... ]


% 0.- Makes sure dRx is (Nicp,xdim)

if size(dRx,2) ~= xdim
   dRx = dRx'; 
end


% 1.- Preliminary size for B:

BNL = zeros(2*xdim, xdim*Nia); % deformation matrices for each cp


% 2.- Computes BNL:

aC = 0 ;
for a=1:1:Nia

    aRef = ia(a);

    for fil = 1:1:xdim
        
        BNL(fil,1+aC)       = dRx(aRef,fil);
        BNL(xdim+fil,2+aC)  = dRx(aRef,fil);
        
        if xdim==3
        BNL(2*xdim+fil,3+aC)= dRx(aRef,fil);
        end
        
    end
    
    aC = aC+xdim;

end


end

