function [STm] = s1015_STmatrix (Sv, xdim)

% RETURNS:
% tm:   stress matrix for non-linear geometries (xdim^xdim , xdim^xdim)

% INPUTS:
% Sv:   stress vector


% 0.- Preliminary sizes:

STm = zeros(xdim^xdim, xdim^xdim);
sSTm = zeros(xdim, xdim); % submatrix


% 1.- Populates submatrix:

for i=1:1:xdim
sSTm(i,i) = Sv(i);
end

sSTm(1,2) = Sv(4);
sSTm(2,1) = Sv(4);

if xdim==3
    sSTm(1,3) = Sv(6);
    sSTm(3,1) = Sv(6);
    
    sSTm(2,3) = Sv(5);
    sSTm(3,2) = Sv(5);
end


% 2.- Populates tm with stm:

pos=0;
for m = 1:1:xdim
    
    for i=1:1:xdim
    for j=1:1:xdim    
        STm( i + pos*xdim , j + pos*xdim ) = sSTm(i,j);
    end    
    end
    
    pos = pos+1;
end



end

