function [Spatches] = p1101_LinTri (Spatches, Npa, insR)

% RETURNS:
% skins with stresses at mP, using 1 Gp per triangle

for pa=1:1:Npa
        
    nBS = Spatches(pa).mRefin(insR).nBS;
    
    for sk = 1:1:nBS
        
        nP = Spatches(pa).mRefin(insR).mBskin(sk).nP;
        nGP = Spatches(pa).mRefin(insR).mBskin(sk).nGP;
        conM   = Spatches(pa).mRefin(insR).mBskin(sk).conM;
        
        % extracts data from GP's and stores for each node:
        
        Nvs = zeros(nP,1); % No. values to compute stress in each node
        asv = zeros(nP,7,1); % aggregated stress values in each node, from each GP, 1 to 6 + VM
        
        for g = 1:1:nGP

            nE     = Spatches(pa).mRefin(insR).mBskin(sk).mGP(g).nE;
            conGEp = Spatches(pa).mRefin(insR).mBskin(sk).mGP(g).conGEp;

            for e = 1:1:nE
                
                eR = conGEp(e);
                
                for nod = 1:1:3
                    
                    nR = conM(eR,nod);
                    Nvs(nR) = Nvs(nR) + 1 ;
                    
                    for i = 1:1:6
                        t(i) = Spatches(pa).mRefin(insR).mBskin(sk).mGP(g).mSv(i);
                        asv(nR,i,Nvs(nR)) = t(i);
                    end

                    [~,~,VM] = s1235_StPrin_vm (t);
                    asv(nR,7,Nvs(nR)) = VM;
                    
                end
            end
        end
        
        
        % computes average in each node and allocates:
        
        for po = 1:1:nP
            
            ave = zeros(7,1);
            
            for gn = 1:1:Nvs(po)
            for i=1:1:7    
                ave(i) = ave(i) + asv(po,i,gn);
            end
            end
            
            ave = ave / Nvs(po);
            
            for i = 1:1:6
                Spatches(pa).mRefin(insR).mBskin(sk).mP(po).mSv(i) = ave(i);
            end
            
            Spatches(pa).mRefin(insR).mBskin(sk).mP(po).mVM = ave(7);
            
        end
        
        
        
        
    end
    
    
    clearvars nBS;
    
end


end

