function [Nabs, N, Rrel, Usingu] = p1202_B_basisFuncts ...
    (Ncp, KnotV, Usize, nAN, mA, Degree, aNicp, aRicpA, Ucoor, udim)

% RETURNS:
% Nabs(udim, nAN, max(Degree)+1, max(Degree)+1)
% N(icp):   tensor product of bf's for each icp at Ucoor
% Rrel(icp):    NURBS values at Ucoor
% Usingu(nAN,udim)

Nabs = zeros(udim, nAN, max(Degree)+1, max(Degree)+1);
N = zeros(aNicp,1);
Rrel = zeros(aNicp,1);
Usingu = zeros(aNicp,udim);

conta=1;
for a=1:1:nAN
if a == aRicpA(conta)
    
	% Nabs and NML product:
        
	N(conta) = 1 ;
	bf = mA(a).mIX;
        
    for di=1:1:udim

        U = zeros(1,Usize(di));
        
        for i = 1:1:Usize(di)
            U(1,i) = KnotV(di,i);
        end
        
        [~,bR] = GEN_01_CalcBF (bf(di),Ucoor(di),Degree(di),U, Ncp(di));
            
        for i=1:1:Degree(di)+1
            for j=1:1:Degree(di)+1  
                Nabs(di,a,i,j) = bR(i,j);
            end   
        end   

        N(conta) = N(conta) * Nabs(di,a,Degree(di)+1,1);   
    end
        
        
	% Usingu: at the moment all smooth
        
    for di=1:1:udim
           
        Usingu(conta,di) = 0 ;
        %{
        U = zeros(Degree(di)+2,1);
        for i=1:1:Degree(di)+2
            U(i) = mA(a).mLKV(di,i);
        end
        KVini = KnotV(di,1);
        KVend = KnotV(di,Usize(di));

        [~,Usingu(conta,di)] = ...
        p1205_uatPeak (KVini, KVend, U, Degree(di), Ucoor(di));
        %} 
    end
        
	conta = conta + 1 ;
 	if conta > aNicp
    	conta = aNicp ; 
	end
        
end
end



% Rrel:

for a = 1:1:aNicp
    
    aR = aRicpA(a);
    Rrel(a) = p1207_RBi (aR, aNicp, aRicpA, Nabs, mA, Degree, udim);
end


end

