function [Nicp, RicpA] = p1204_icpsPo (nAN, mA, u, udim, modo)


% RETURNS:
% Nicp:     No. icps (or anchors) on the point
% RicpA:    influential anchors abs. referneces


% INPUTS:
% nAN, mA:  No. anchors and features
% u:        param. location of the point to compute icp's for
% modo: 'opened' or 'closed' (in the past was 'closed' by default)

domL = zeros(udim,2);

Nicp = 0;

for a=1:1:nAN

    for di=1:1:udim
        domL(di,1) = round(mA(a).mPcoLi(di,1),9);
    	domL(di,2) = round(mA(a).mPcoLi(di,2),9);
    end

    IN = GEN_08_Orthodomain_Pin (u, domL, udim, modo);
        
    if IN==1
        Nicp = Nicp + 1 ;
        RicpA(Nicp) = a ;
    end
        
end


end

