function [ singular, posi ] = p1205_uatPeak (KVini, KVend, U, p, u )

% RETURNS:
% singular: 0 if smooth, 1 if is singular (posseses a peak) at u
% posi:     indicates where the peak is: -1 / 2 / 1 : start, mid, end


% INPUTS:
% KVini, KVend: initial and final global knot vector knots
% U:            original local knot vector
% p:            degree
% u:            location where compute the derivative (non-vector, is scalar)


% it's expected to be only repetition for one value



% 1.- Values initiation
% and rounds to make sure u is not out os scope:

UP = zeros(p+2,1); % if 1: repeated knot
uR = -1000 ; % for store repeated knot value
u = round(u,6);
U = round (U,6);
posLR = 0 ; % position of last repeated knot

% 2.- Check if u belongs to a repeated knot interval;
% also counts No. repetitions and stores location:

conta=0;


for i=1:1:p+1
    
    % 2.1.- Finds the interval
    if U(i)<=u && u<=U(i+1)
        
        % checks if it is repeated
        if U(i)==U(i+1)
            uR = U(i);
        end
    end 
    
    % 2.2.- Counts how many times is uR repeated and positions (UP=1)
     if U(i)==uR
       conta=conta+1; 
       UP(i) = 1 ;
       posLR = i ;
    end
end

% 2.3.- Modifies posLR and add another repetition if last knot is also repeated:
if (U(p+2)==U(3)) && U(p+2)~=KVend
    posLR = p+2 ;
    conta=conta+1;
end

posFR = posLR-conta+1 ; % pos. of first repeated knot


% 3.- Is singular if:

% (uR stored knot value) OR 
% (No. repetitions is >= p) OR 
% (posFR or posRL are not at the ends of global vector)

if (uR == -1000 || conta < p) || (U(posFR)==KVini || U(posLR)==KVend)
    
    singular=0;
    posi=0;
    
else
    
    singular=1;
    
    % position
    if posFR==1
        posi = -1 ;
    elseif posLR == p+2
        posi = 1 ;
    else
        posi = 2 ;
    end
    
end



%{
if (U(2) == 0.25 && U(3)==0.25) && (U(1) == 0.25 && u==0.25)
    
    u
    p
    U
    
    posFR
    posLR
    singular
    posi
    
end
%}









end

