function [RTa] = p1206_RTi (aRef, Nicp, Ricp, Nabs, mA, Degree, udim)

% RETURNS: 
% RTi:   NURtS basis function ref. aRef at location u. u is given implicitly by Ni

% INPUTS:

% aRef:         anchor ref. where RTa is to be computed
% Nicp:         no. icps
% Ricp:         references of anchors
% Nabs:         basis functions previously computed! Ni(a,p+1,p+1), all contains anchors
% mA:           for weights of all anchors

% 1.- Computes total weigth: W

W = 0 ;
for i=1:1:Nicp

    a = Ricp(i);
    suma=1;
    for di =1:1:udim
        suma = suma * Nabs(di, a , Degree(di)+1, 1 ) ;
    end
    W = W + suma * mA(a).mWeig;
end

% 2.- Computes RTa:

suma=1;
for di =1:1:udim
    suma = suma * Nabs( di, aRef , Degree(di)+1, 1 ) ;
end
RTa = suma * mA(aRef).mWeig / W ;


end