function [RBa] = p1207_RBi (aR, Nicp, Ricp, Nabs, mA, Degree, udim)

% RETURNS: 
% RBa:   NURBS basis function ref. aR at location u (given implicitly by Nabs)

% INPUTS:

% aR:         anchor ref. where RTa is to be computed
% Nicp:         no. icps
% Ricp:         references of anchors
% Nabs:         basis functions previously computed! Ni(a,p+1,p+1), all contains anchors
% mA:           for weights of all anchors

% 1.- Computes total weigth: W

W = 0 ;
for i=1:1:Nicp

    a = Ricp(i);
    suma=1;
    for di =1:1:udim
        suma = suma * Nabs(di, a , Degree(di)+1, 1 ) ;
    end
    W = W + suma * mA(a).mw;
end

% 2.- Computes RBa:

suma=1;
for di =1:1:udim
    suma = suma * Nabs( di, aR , Degree(di)+1, 1 ) ;
end
RBa = suma * mA(aR).mw / W ;


end