function [Nabs, N, Rrel, Usingu] = p1209_T_basisFuncts ...
    (KnotV, Usize, nAN, mA, Degree, aNicp, aRicpA, Ucoor, udim)

% RETURNS:
% Nabs(udim, nAN, max(Degree)+1, max(Degree)+1)
% N(icp):   tensor product of bf's for each icp at Ucoor
% Rrel(icp):    NURBS values at Ucoor
% Usingu(nAN,udim)

Nabs = zeros(udim, nAN, max(Degree)+1, max(Degree)+1);
N = zeros(aNicp,1);
Rrel = zeros(aNicp,1);
Usingu = zeros(aNicp,udim);

conta=1;
for a=1:1:nAN
    
    for di=1:1:udim

        % Nabs :
        bR = t2604_Tspline_u (a, Degree, mA,Ucoor(di),di);
        
        for i=1:1:Degree(di)+1
        for j=1:1:Degree(di)+1  
            Nabs(di,a,i,j) = bR(i,j);
        end   
        end   

    end
    

    if a == aRicpA(conta)
    
        % N :
        N(conta) = 1 ;
        for di=1:1:udim
            N(conta) = N(conta) * Nabs(di,a,Degree(di)+1,1);
        end
    
        % Usingu:
        for di=1:1:udim
            
            U = zeros(Degree(di)+2,1);
            for i=1:1:Degree(di)+2
                U(i) = mA(a).mLKV(di,i);
            end
            KVini = KnotV(di,1);
            KVend = KnotV(di,Usize(di));

            [~,Usingu(conta,di)] = ...
            p1205_uatPeak (KVini, KVend, U, Degree(di), Ucoor(di));
        
        end
        
        conta = conta + 1 ;
        if conta > aNicp
            conta = aNicp ; 
        end
        
    end

end



% Rrel:

for a=1:1:aNicp
    
    aRef = aRicpA(a);
    Rrel(a) = p1206_RTi (aRef, aNicp, aRicpA, Nabs, mA, Degree, udim);
    
end


end

