function [dRfi,J1, detJ1] = p1211_Xbf (UsInte,Usingu, mA, Ricp, Nicp, dRpa, dRpaRHS, udim, xdim)

% RETURNS:
% Xbf parameters


% 1.- There is no singular bf:

if norm(Usingu)== 0
    
    
    [J1, detJ1] = j2316_J1_BTsp_dRpa (mA, Ricp, Nicp, dRpa, udim, xdim);
    dRfi = J1\dRpa';


% 2.- For singular location:

else
    
    % 2.1.- LHS:
    
    if UsInte==-1
            
        [J1LHS, detJ1LHS] = j2316_J1_Tspline (mA, Ricp,Nicp, dRpa, udim, xdim);
        dRfiLHS = J1LHS\dRpa';
        
      	J1 = J1LHS;
        detJ1 = detJ1LHS ;
     	dRfi = dRfiLHS;
    
    % 2.2.- Average:
    
 	elseif UsInte==0
            

        [J1LHS, detJ1LHS] = j2316_J1_Tspline (mA, Ricp,Nicp, dRpa, udim, xdim);
        [J1RHS, detJ1RHS] = j2316_J1_Tspline (mA, Ricp,Nicp, dRpaRHS, udim, xdim);
        
        J1 = (J1LHS + J1RHS) / 2 ;
        
        % solution 1
        % in case of one Jacobian is singular, it cannot compute dRfiLHS
        % and dRfiRHS separately , then it has to compute:
        % dRfi = inv(aveJ1)* ave(dRpa)
        
        if abs(detJ1LHS) < 0.001 * norm(J1LHS) || abs(detJ1RHS) < 0.001 * norm(J1RHS)
            
            %%%% solution 1
            %dRfi = J1\(dRpa' + dRpaRHS') * 0.5;
            
            
            %%%% solution 2: only takes the non-singular option
            
            if abs(detJ1LHS) < 0.001 * norm(J1LHS) % singularity on the LHS
                
                J1 = J1RHS ;
                dRfi = J1\dRpaRHS';
                
            elseif abs(detJ1RHS) < 0.001 * norm(J1RHS) % singularity on the RHS
                
                J1 = J1LHS ;
                dRfi = J1\dRpa';

            end
            
        else
            dRfiLHS = J1LHS\dRpa';
            dRfiRHS = J1RHS\dRpaRHS';
            dRfi = (dRfiLHS + dRfiRHS) / 2;
        end
     
        
        detJ1 = det(J1);
        
    % 2.3.- RHS:
        
  	elseif UsInte==1
            
        [J1RHS, detJ1RHS] = j2316_J1_Tspline (mA, Ricp,Nicp, dRpaRHS, udim, xdim);
        dRfiRHS = J1RHS\dRpaRHS';
        
        J1 = J1RHS;
        dRfi = dRfiRHS;
        detJ1 = detJ1RHS; 
    end


end

dRfi = dRfi';



end

