function [ hp, s ] = s1233_hydro_dev(t)


% RETURNS: decomposition of stress tensor
% hp:       hydrostratic stress vector
% s :       deviatoric stress vector

% INPUTS:
% stress tensor t:  size (6)
% type of analysis Anty 1 p. stres, 2 p. strain relevant if xdim = 2


% 1.- Hydrostratic pressure:

hp = (t(1) + t(2) + t(3)) / 3 ; 


% 2.- Deviatoric:

s = t ;
for i=1:1:3
    s(i) = t(i)-hp ;
end



end