function [ et ] = s1234_tzPlane(t, Anty, nu, xdim)

% RETURNS: for 2D elasticity, in case of 3D returns the same vector
% et:   expanded stress tensor

% INPUTS:
% stress tensor t with 3 components 
% type of analysis Anty 1 p. stres, 2 p. strain relevant if xdim = 2


if xdim==3
    
    et = t ;
    
elseif xdim==2
    
    % 1.- Stress in z:

    if Anty==1 % p. stress
        tz = 0 ;
    else       % p. strain
        tz = nu * (t(1) + t(2)) ;
    end


    % 2.- Extends:

    et = zeros(6,1);

    et(1) = t(1);
    et(2) = t(2);
    et(3) = tz;
    et(4) = t(3);
    
end



end