function [DT, NT, TVcon] = tm1301_genTri (Vc, B)


% RETURNS: for a 2D triangulation to a cloud of points
% DT: triangualtion object
% NT: No. triangles
% TVcon(NT,3): conn. matrix triangle - vertex


% INPUTS:
% NV: No. vertexes
% Vc(NV,2): vertexes coord's in plane
% B: to consider bound perimeter (B=1) or not (B=0)


if B==1
    
    % 1.- BOUNDED TRIANG:
    
    % 1.1.- Generates contraint witht he bounding contour:
    
    ubo = boundary(Vc);
    Nb = size(ubo,1);
    
    Cnst = [ ubo(1:Nb-1) ubo(2:Nb) ]; % constraint
    
    % 1.2.- Triangulates with the constraint:
    
    DT = delaunayTriangulation(Vc,Cnst);
    
    
    % 1.3.- Computes conn. matrix and No. triangles considering only inside
    % constraint:
    
	conMtemp = DT.ConnectivityList;

    TVcon = zeros(1,3);
    NEtemp = size(conMtemp);


    ieF = DT.isInterior(); % interior element flag

    NT = 0;
    for e = 1:1:NEtemp 
        if ieF(e) == 1
            NT = NT+1;
            TVcon(NT,:) = conMtemp(e,:);
        end
    end
    
    
elseif B==0
    
    
    % 2.- UN-BOUNDED:
    
    DT = delaunayTriangulation(Vc);
    
    TVcon = DT.ConnectivityList;

    NT = size(TVcon);
    
end







   


end

