function [cevR] = tm1303_closerEdge (Vc, c)

% RETURNS:
% cevR(2): closest edge-vertex referecnes to c


% 1.- COMPUTES BOUNDARY VERTEXES: ubo starts and ends at same ref.

ubo = boundary(Vc);
Nb = size(ubo,1);


% 2.- FINDS CLOSEST VERTEX:

ubop1 = 1 ;
ref1 = ubo(1);
ct = [Vc(ref1,1) , Vc(ref1,2)]; % temporary vtx coor's
dmin = norm(c-ct); 

for i = 2:1:Nb-1
    
    ubopt = i ;     % temp. position in ubo column
    reft = ubo(i);  % temporary vtx ref.
    ct = [Vc(reft,1) , Vc(reft,2)]; % temporary vtx coor's
    dmint = norm(c-ct);  % temporary min distance
    
    if dmint < dmin
        ubop1 = ubopt;
        ref1 = reft;
        dmin = dmint ;
    end

end


% 3.- FINDS THE CLOSEST BOUND-EDGE: 
% finds the adjacent vertex to ref1 that is closest to c

% ref2: second point selected

if ubop1 == 1
   
    % .- Special case of 1st vtx:
    tmpRef(1) = ubo(Nb-1);
    tmpRef(2) = ubo(ubop1+1);
    
else
    
    % .- rest of cases:
  	tmpRef(1) = ubo(ubop1-1);
    tmpRef(2) = ubo(ubop1+1);
    
end


% norm to temporary second point 1

ref2 = tmpRef(1);
c2t = [ Vc(tmpRef(1),1) , Vc(tmpRef(1),2) ];
tnorm2 = norm(c-c2t);


% check temporary second point 2

c2t = [ Vc(tmpRef(2),1) , Vc(tmpRef(2),2) ];
if norm(c-c2t) < tnorm2
    ref2 = tmpRef(2);
end


% transfers answer:
cevR = [ref1,ref2];



end

