function [cfR, dmin] = tm1303b_closerFacet (Anod, eA, tolL, tolA, nd)

% RETURNS:
% cfR: closest face ref (local ref) of at tet to one point
% dmin: distante to such facet

% INPUTS:
% Anod(4,pudim): tet. nodes coords
% eA(pudim,1): coords of the point to evaluate

% If the projection of the point doesnt lie within the facet triangle, is
% nos considered. Hence, if cfR == 0 is because there is not facet perp.
% to the point

cfR = 0 ;
pudim = 3 ;

% facet ref is the opposite node:

r = [2 3 4;
     1 3 4;
     1 2 4;
     1 2 3 ];
 
a = zeros(pudim,1);
b = zeros(pudim,1);
c = zeros(pudim,1);

dmin = 99 ;

for k = 1:1:4
    
    a(:,1) = Anod(r(k,1),:);
    b(:,1) = Anod(r(k,2),:);
    c(:,1) = Anod(r(k,3),:);
    
	[A,B,C,D] = go2506_Plane3P (a,b,c);
    [dist,~,Q] = go2534_distPtoPlan (eA, A, B, C, D);
    
    if dist < dmin
        
        tv = [a' ; b' ; c' ];
        IN = go2546_PinTriang (tv, Q, tolL, tolA, nd);

        if IN > 0
        
            dmin = dist;
            cfR = k;
        
        end
        
    end
end
 


end

