function [CV] = tm1305_LCVnumber (Anod, Nne, ndim)

% RETURNS:
% CV (%):   coefficient of variation of triangle lines lengths 
%           w.r.t. equilateral triangle line length (Leq)

% the lower CV the better

% INPUTS:
% Anod(6,ndim): nodes coordinates, 1,2,3 corner, 4,5,6 mid-nodes (they might not exist)
% Nne:  No. nodes per line (or edge)
% ndim: No. dims

% 1.- COMPUTES EQUIVALENT TRIANGLE AND ITS LINE LENGTH:

% 1.1.- Extracts vectors and points:

v12 = zeros(ndim,1);
v13 = zeros(ndim,1);

for di = 1:1:ndim
	v12(di,1) = (Anod(2,di) - Anod(1,di));
	v13(di,1) = (Anod(3,di) - Anod(1,di));
end

% 1.2.- Area of triangle and equilateral length:

nv = cross(v12,v13);
A = norm(nv)/2;

Leq = 1.52 * A^0.50 ;


% 2.- COMPUTES CURRENT LENGTHS and CV:

r = [ 1 2 4 ; 2 3 5 ; 3 1 6 ] ;

CV = 0 ;

Lc = zeros(3,1);

ta = zeros(ndim,1);
tb = zeros(ndim,1);
tc = zeros(ndim,1);

for i = 1:1:3
    
    if Nne ==2
        
        ta(:,1) = Anod(r(i,1),:);
        tb(:,1) = Anod(r(i,2),:);
        Lc(i,1) = norm(tb-ta);
        
    elseif Nne == 3
        
        ta(:,1) = Anod(r(i,1),:);
        tb(:,1) = Anod(r(i,3),:);
        tc(:,1) = Anod(r(i,2),:);
        
        Lc(i,1) = go2537_ArcL ([ta tb tc]', ndim);
        
    end
    
    CV = CV + (Lc(i)-Leq)^2 ;
end

CV = (CV/3)^0.5 * 100/Leq ;



end

