function [At, nv] = tm1306_tArea_n (TVcon, tr, Cv, Cnod, dim)

% RETURNS:
% At: area of triangle
% nv(dim,1): normal to triangle (with norm = 2*At)

% INPUTS:
% TVcon(NE,3): conn. matrix triangle-nodes
% tr: triang. ref 
% Cv(NV,dim): all nodes coord's
%    OR
% Cnod(3,dim): nodes coordinates

% if tr==0 uses Cnod, if not uses TVcon,tr,Cv

% Vectors 1-2 and 1-3:

v1 = zeros(3,1);
v2 = zeros(3,1);

if tr == 0
    
    for di = 1:1:dim
        v1(di,1) = Cnod(2,di) - Cnod(1,di);
        v2(di,1) = Cnod(3,di) - Cnod(1,di);
    end
    
else
    
    n1 = TVcon(tr,1);
    n2 = TVcon(tr,2);
    n3 = TVcon(tr,3);
    
    for di = 1:1:dim
        v1(di,1) = (Cv(n2,di)-Cv(n1,di));
        v2(di,1) = (Cv(n3,di)-Cv(n1,di));
    end
    
end

% normal and area:

nv = cross(v1,v2);
At = norm(nv)/2;

end