function [D12, eD12, eLims] = tm1307_maxD1D2 (xnod)

% RETURNS:
% D12(2): max increment of horiz and vert inside one triangle (in 2D plane)
% eD12(2): envelope amplitude of triangle (in 2D plane)
% eLims(dim,2): limits of envelope

D12 = zeros(2,1);
eD12 = zeros(2,1);
eLims = zeros(2,2);

xnod1 = sortrows(xnod,1);
xnod2 = sortrows(xnod,2);

midP = [xnod1(2,1) xnod2(2,2)];


% finds D12:

for di = 1:1:2

    for i = 1:1:3

        if xnod(i,di) == midP(di)

            % vertex coord and direction
            xv = [xnod(i,1);xnod(i,2)];

            if di == 1
                u1 = [0;1];
            elseif di == 2
                u1 = [1;0];
            end


            % opp. line coord and direction:
            conta = 0 ;
            for j = 1:1:3

                if j~=i

                    conta = conta + 1 ;

                    if conta==1

                        xo = [xnod(j,1);xnod(j,2)];

                    elseif conta==2

                        u2 =  [xnod(j,1)-xo(1);xnod(j,2)-xo(2)];
                        u2 = u2/norm(u2);

                    end
                end
            end


            [IP, ~] = go2526b_TwoLinInterParam (xv,u1, xo,u2, 6, 2);

            d = IP-xv;

            if di == 1
                D12(2) = norm(d);
            elseif di == 2
                D12(1) = norm(d);
            end

            break

        end

    end

end


% envelopes:

di=1;
eLims(di,1) = xnod1(1,1) ;
eLims(di,2) = xnod1(3,1) ;
eD12(di) = eLims(di,2)-eLims(di,1);

di=2;
eLims(di,1) = xnod2(1,2) ;
eLims(di,2) = xnod2(3,2) ;
eD12(di) = eLims(di,2)-eLims(di,1);



end

