function [Ae, Ne, Nv] = tm1308_TmeshNA (spF, NE, NV, TVcon, VTcon, Cv, dim)

% RETURNS: in relevant space
% Ae: areas of each triangle 
% Ne: normals to each triangle, at center
% Nv: normals at each node (considers attached triangles areas to weight the average)

% INPUTS:
% spF = 1 is it is slave patch (normals are to be inverted)
% Cv(NV,dim): vtzx coordiantes

Ae  = zeros(NE,1);
Ne = zeros(NE,dim);
Nv = zeros(NV,dim);

if spF == 0
    f = 1 ;
elseif spF == 1
    f = -1;
end

for e = 1:1:NE 
    
	% normals to triangles (norm=1) and area:
        
	[nv, ~, At] = i0103_nTriang (TVcon, e, Cv, dim);
        
    if e == 123 || e == 121
        
        And = zeros(3,1);
        for i = 1:1:3
        
           And(i) = TVcon(e,i);
            
        end
        
    end
    
    
 	Ae(e,1) = At;
    
    for di = 1:1:dim
        Ne(e,di) = f*nv(di);
    end
end




% Normals to vertexes (averages attached triangles weighting the area):

for v = 1:1:NV
    
    [nvv] = i0106_nVtx (v, VTcon, Ae, Ne, dim);
    
    for di = 1:1:dim
        Nv(v,di) = nvv(di); 
    end
    
end

end

