function [otpS, U0, B0, mNCS] = th1317_curveB2 (li, NCS, connT, agCurv, Xv, Uv, Bv, n, enF, cR, sR, nd)

xdim = 3 ;
sudim = 2 ;

% 1.- Node 'a' is extreme and 'b' is internal
            
if enF(1)==1
    a = 1; b = 2 ;
elseif enF(2)==1
	a = 2; b = 1 ;
end
  


% 2.- Checks if 'a' and 'b' belong to the same curve:

scF = 0 ; % same line flag = 1 if a and b are on the same curve

cRb = cR(b);

cNcp = agCurv(cRb).Ncp;
cP   = agCurv(cRb).P;

Xa  = zeros(xdim,1);
Xc1 = zeros(xdim,1);
Xc2 = zeros(xdim,1);

for di = 1:1:xdim
    
    Xa(di,1) = Xv(n(a),di);
    
    Xc1(di,1) = cP(1,di);
    Xc2(di,1) = cP(cNcp,di);
    
end

CO1 = go2542_coincidentP (Xa, Xc1, xdim, nd);
CO2 = go2542_coincidentP (Xa, Xc2, xdim, nd);

if CO1==1 || CO2==1
    scF = 1 ;
end




if scF == 1

    % 3.- Both nodes are in the same curve:
    
    otpS = "C" ;

    U0 = zeros(1,sudim);
    
    B0(1,1) = Bv(n(b),1);

    mNCS(1,1) = cR(b);
    mNCS(1,2) = sR(b);
          
    
elseif scF == 0
    
    % 4.- Both nodes are in different curves => mid-node is on surface
    
    B0 = 0 ;
    
    [otpS, U0, mNCS] = th1316_curveB1 (Xv, Uv, n, NCS, connT);
    
    
end

end

