function [R, bave, b] = th1319_tetR (Cnod)

% RETURNS:
% R: tet regularity by comparing its volume with the regular version, the
% higher the better

% INPUTS:
% Cnod(4,dim): Tet coordinates

dim = 3 ;


% 1.- CURRENT VOLUME:

% determinant of vectors that form the edges, one vector per row
D = zeros(3,dim); 

for i = 2:1:4
    for di = 1:1:dim
        D(i-1,di) = Cnod(i,di) - Cnod(1,di);
    end
end

Vc = det(D)/6;


% 2.- REGULAR TET VOL:

b = zeros(6,1);
bave = 0 ;

n = [ 1 2 3 4 4 4 ; 
      2 3 1 1 2 3 ];

for i = 1:1:6
    
    v = zeros(di,1);
    
    for di = 1:1:dim
        v(di,1) = Cnod(n(1,i),di) - Cnod(n(2,i),di) ;
    end
    
    b(i,1) = norm(v);
    
    bave = bave + norm(v)/6;
    
end

Vr = ( 2^0.5 / 12 ) * bave^3 ;



% 3.- RATIO:

R = abs(Vc)/Vr ;


end


