function [mBv, mUv, mAv, mXv] = th1324b_midCoords ...
    (li, otpS, B0, U0, At, tn, mNCS, Spatches, pR, rTskin, agCurv, Xtol, DUtol)

% INPUTS:
% At (1,pudim)
% tn (2,1): to compute alternative mid-point

% 1.- EXTRACTS DATA:

cR = mNCS(1,1);
sR = mNCS(1,2);

cudim = 1 ;
sudim = 2 ;
pudim = 3 ;
xdim = 3 ;

if cR > 0

    cDegree = agCurv(cR).Degree;
    cNcp    = agCurv(cR).Ncp;
    cKnotV  = agCurv(cR).KnotV;
    cP      = agCurv(cR).P;
    cw      = agCurv(cR).w;
    cUsize  = agCurv(cR).Usize;
    cCD     = agCurv(cR).CD;
    cULims  = [ 0 1 ];

end

sDegree = rTskin(sR).mDegree;
sNcp    = rTskin(sR).mNcp;
sKnotV  = rTskin(sR).mKnotV;
sP      = rTskin(sR).mP;
sw      = rTskin(sR).mw;
sUsize  = rTskin(sR).mUsize;
sCD     = rTskin(sR).mCS;
[sEw,sEP] = GEN_12_ExpandBw (sw, sP, xdim, sudim, sNcp);
sULims  = [ 0 1 ; 0 1 ];
        
pDegree = Spatches(pR).INS(1).mDegree;
pNcp    = Spatches(pR).INS(1).mNcp;
pKnotV  = Spatches(pR).INS(1).mKnotV;
pP      = Spatches(pR).INS(1).mP;
pw      = Spatches(pR).INS(1).mw;
pUsize  = Spatches(pR).INS(1).mUsize;
pULims  = [0 1 ; 0 1 ; 0 1 ];
pEP     = Spatches(pR).INS(1).mEP;
pEw     = Spatches(pR).INS(1).mEw;
pCD     = [ 0 0 0 ];


% 2.- INITIAL TRIAL POINT: maps from At to Xt

Xt = b2601_BNURBS_Xcoord (At, pKnotV, pNcp, pDegree, pUsize, pEw, pEP, pudim, xdim);

A0 = At ; % initial searching point for patch param. space coincides with trial




% 3.- CASES:

if otpS=="C" 
    
    % pp from Xt to curve, using B0 as starting point
    [mBv,~] = c2815b_onePoint (Xt, B0, cDegree, cNcp, cKnotV, cP ,cw, cULims, cCD, xdim, Xtol, DUtol);

    % X coord from curve:
    Xm = b2601_BNURBS_Xcoord (mBv, cKnotV, cNcp, cDegree, cUsize, cw, cP, cudim, xdim);
    mXv(1,:) = Xm(:,1);
    
    % pp to surface and solid:
    [mAv, ~] = v2865b_onePoint (Xm, A0, pDegree, pNcp, pKnotV, pUsize, pP ,pw, pEP ,pEw, pCD, pULims, xdim, Xtol, DUtol);
    [mUv, ~] = s2835b_onePoint (Xm, U0, sDegree, sNcp, sKnotV, sUsize, sP ,sw, sEP ,sEw, sCD, sULims, xdim, Xtol, DUtol);

elseif otpS=="S" 
    
    mBv = zeros(1,1);
    
    % Two options: a & b
    
    % a) Xt => mUv => mXv => mAv 
    
	% pp from Xt to surface, using U0 as starting point
    [mUv1, ~] = s2835b_onePoint (Xt, U0, sDegree, sNcp, sKnotV, sUsize, sP ,sw, sEP ,sEw, sCD, sULims, xdim, Xtol, DUtol);
    
    % X coord from surface:
    Xm1 = b2601_BNURBS_Xcoord (mUv1, sKnotV, sNcp, sDegree, sUsize, sEw, sEP, sudim, xdim);
    mXv1(1,:) = Xm1(:,1);
    
    % pp to solid:
    [mAv1, ~] = v2865b_onePoint (Xm1, A0, pDegree, pNcp, pKnotV, pUsize, pP ,pw, pEP ,pEw, pCD, pULims, xdim, Xtol, DUtol);
        
    
    % b) mUv=U0 => mXv => mAv 
    
    mUv2 = U0 ;
    
    Xm2 = b2601_BNURBS_Xcoord (mUv2, sKnotV, sNcp, sDegree, sUsize, sEw, sEP, sudim, xdim);
    mXv2(1,:) = Xm2(:,1);
    
    [mAv2, ~] = v2865b_onePoint (Xm2, A0, pDegree, pNcp, pKnotV, pUsize, pP ,pw, pEP ,pEw, pCD, pULims, xdim, Xtol, DUtol);
        
    
    % Chooses the closest mAv to A0:

    dA1 = norm(mAv1 - A0);
    dA2 = norm(mAv2 - A0);
    
    
    
    if dA1 <= dA2
        
        mUv = mUv1;
        mAv = mAv1;
        mXv = mXv1;
        
    elseif dA2 < dA1
        
     	mUv = mUv2;
        mAv = mAv2;
        mXv = mXv2;
        
    end
    

    
end


end

