function [U0] = th1325_mSU0 (sR, THC, n1, n2, connT, Uvm, NCSm)

% RETURNS: initial location in U-coords for pp for mid-point

nfF = 0;
            
if THC.NCS(n1,1)==0 && THC.NCS(n2,1)==0
    
    % Both nodes are NOT in contour: 
	% U0 at mid-location in U-coords
                
	nfF = 1 ;
	U0(1,:) = ( THC.Uv(n1,:) + THC.Uv(n2,:) ) / 2 ;
                
elseif THC.NCS(n1,1)==0 || THC.NCS(n2,1)==0
          
    % One of the nodes is at contour, and one interior:
	% U0 is the interior node
                
	nfF = 1 ;
                
	if THC.NCS(n1,1)==0
        U0(1,:) = THC.Uv(n1,:);
    else
        U0(1,:) = THC.Uv(n2,:);
	end
                
else
        
    % Both nodes at contour:
    
	% searches the opp. node of a line (with n1 or n2) such that node lies
	% within surface sR.
                
	n = [ n1 n2 ];
                
    for i = 1:1:2
                    
        for j = 1:1:size(connT.VL,2)
                        
            LR = connT.VL(n(i),j);
                        
            if LR > 0
                            
                for k = 1:1:2
                            
                    if connT.LV(LR,k)~=n1 && connT.LV(LR,k)~=n2

                        nR = connT.LV(LR,k);

                        if NCSm(nR,2)==sR 
                                        
                            U0(1,:) = Uvm(nR,:);
                            nfF = 1 ;
                            break
                                        
                        end
                                    
                    end
                end
            end
                        
            if nfF == 1
            break
            end
        end
                    
        if nfF == 1
        break
        end
    end
    
end
            
if nfF==0
    U0 = [ 0.5 0.5 ] ;
end
            
end

