function [pnR, apexR] = th1326_apexSide (Av, connT, ILn, sr)

pudim = 3 ;

% 1.- Point and direction of missing line

mp = zeros(pudim,1);
mu = zeros(pudim,1);
        
mp(:,1) = Av(ILn(1,1),:);
mu(:,1) = Av(ILn(2,1),:) - Av(ILn(1,1),:);


% 2.- Searches among the three lines:

cp = zeros(pudim,1); % candidate
cu = zeros(pudim,1);
        
tr = [ connT.SV(sr,1) connT.SV(sr,2) connT.SV(sr,3) connT.SV(sr,1) connT.SV(sr,2) ]; % temp. refs

apexR = 0 ;
pnR = zeros(2,1); % nodes in plane of missing line
        
for i = 1:1:3
            
	cp(:,1) = Av(tr(i),:);
  	cu(:,1) = Av(tr(i+1),:) - Av(tr(i),:);
 
	[IP, fNI] = go2530_LinInters_nD (mp, mu, cp, cu, pudim, 6);
            
    if fNI==0 % finds intersection
        apexR = i+2;
     	break
    end
            
end
   

% In case does not find intersction (precission issue)
% selects the closest line to the missing:

if apexR == 0
    
    ns = 5 ; % No. segments to check
    
    % points of missing line:
    
    mLp = zeros(ns+1,pudim);
    mLp(1,:) = Av(ILn(1,1),:);
    Dp = mu/ns;
    
    for j = 1:1:ns
        for di = 1:1:pudim
            mLp(j+1,di) = mLp(j,di) + Dp(di,1);
        end
    end
    
    %{
	figure(28)
	plot3( mLp(:,1), mLp(:,2),mLp(:,3),'r'); hold on
	axis equal
    %}
    
    % points of candidate lines:
    
    cLp = zeros(3,ns+1,pudim);
    
    for i = 1:1:3
        
        cLu(:,1) = Av(tr(i+1),:) - Av(tr(i),:);
       	cLp(i,1,:) = Av(tr(i),:);
        Dp = cLu/ns;
        
        for j = 1:1:ns
            for di = 1:1:pudim
                cLp(i,j+1,di) = cLp(i,j,di) + Dp(di,1);
            end
        end
        
        %{
        figure(28)
     	plot3( cLp(s,:,1), cLp(s,:,2),cLp(s,:,3),'b'); hold on
      	axis equal
        %}
    end
     
    
    % searches the closest candidate line:
    
    Dmin = 999 ;
    
    SL = 0 ; % selected line
    
    d = zeros(pudim,1);
    
    for i = 1:1:3
        
        for kc = 1:1:ns+1
        for km = 1:1:ns+1
        
            for di = 1:1:pudim
                d(di,1) = mLp(km,di) - cLp(i,kc,di);
            end
            
            if norm(d) < Dmin
                Dmin = norm(d) ;
                SL = i ;
            end 
            
        end
        end
    end
    
    apexR = SL + 2;

end


% 3.- Establishes the apex and  refs

if apexR == 3
            
    pnR(1) = connT.SV(sr,1);
	pnR(2) = connT.SV(sr,2);
	apexR  = connT.SV(sr,3);
            
elseif apexR == 4
        
  	pnR(1) = connT.SV(sr,2);
   	pnR(2) = connT.SV(sr,3);
   	apexR  = connT.SV(sr,1);
            
elseif apexR == 5
             
  	pnR(1) = connT.SV(sr,3);
  	pnR(2) = connT.SV(sr,1);
   	apexR  = connT.SV(sr,2);
            
end


end

