function [Unn, Ann, Xnn] = th1327_newCnode (agCurv, cR, rTskin, sR, Spatches, pR, Bnn, U0, A0, Xtol, DUtol)

% RETURNS:
% Coordinates of new node inserted when it lies at contour curve:

% INPUTS:
% Bnn: curve param coordinates is known
% U0,A0(1,dim): initial locations for searching

cudim = 1 ;
sudim = 2 ;
pudim = 3 ;
xdim = 3 ;

Unn = zeros(1,sudim);
Ann = zeros(1,pudim);
Xnn = zeros(1,xdim);

cDegree = agCurv(cR).Degree;
cNcp    = agCurv(cR).Ncp;
cKnotV  = agCurv(cR).KnotV;
cP      = agCurv(cR).P;
cw      = agCurv(cR).w;
cUsize  = agCurv(cR).Usize;
cCD     = agCurv(cR).CD;
   

sDegree = rTskin(sR).mDegree;
sNcp    = rTskin(sR).mNcp;
sKnotV  = rTskin(sR).mKnotV;
sP      = rTskin(sR).mP;
sw      = rTskin(sR).mw;
sUsize  = rTskin(sR).mUsize;
sCD     = rTskin(sR).mCS;
[sEw,sEP] = GEN_12_ExpandBw (sw, sP, xdim, sudim, sNcp);
sULims  = [0 1 ; 0 1 ];
        

pDegree = Spatches(pR).INS(1).mDegree;
pNcp    = Spatches(pR).INS(1).mNcp;
pKnotV  = Spatches(pR).INS(1).mKnotV;
pP      = Spatches(pR).INS(1).mP;
pw      = Spatches(pR).INS(1).mw;
pUsize  = Spatches(pR).INS(1).mUsize;
pULims  = [0 1 ; 0 1 ; 0 1 ];
pEP     = Spatches(pR).INS(1).mEP;
pEw     = Spatches(pR).INS(1).mEw;
pCD     = [0 0 0 ];

% X-coords and pp to U and A-coords
 
x = b2601_BNURBS_Xcoord (Bnn, cKnotV, cNcp, cDegree, cUsize, cw, cP, cudim, xdim);
     
Xnn(1,:) = x(:,1);

[Ann, ~] = v2865b_onePoint (x, A0, pDegree, pNcp, pKnotV, pUsize, pP ,pw, pEP ,pEw, pCD, pULims, xdim, Xtol, DUtol);
[Unn, ~] = s2835b_onePoint (x, U0, sDegree, sNcp, sKnotV, sUsize, sP ,sw, sEP ,sEw, sCD, sULims, xdim, Xtol, DUtol);

end

