function [Unn, Ann, Xnn] = th1329_mSnode (rTskin, sR, Spatches, pR, Xt, U0, A0, Xtol, DUtol)

% RETURNS:
% Coordinates of new node inserted when it lies at T-surface:

% INPUTS:
% Unn: T-surface param coordinates is known
% A0(1,dim): initial locations for searching

sudim = 2 ;
pudim = 3 ;
xdim = 3 ;

Unn = zeros(1,sudim);
Ann = zeros(1,pudim);
Xnn = zeros(1,xdim);

sDegree = rTskin(sR).mDegree;
sNcp    = rTskin(sR).mNcp;
sKnotV  = rTskin(sR).mKnotV;
sP      = rTskin(sR).mP;
sw      = rTskin(sR).mw;
sUsize  = rTskin(sR).mUsize;
sCD     = rTskin(sR).mCS;
[sEw,sEP] = GEN_12_ExpandBw (sw, sP, xdim, sudim, sNcp);
sULims  = [0 1 ; 0 1 ];
        

pDegree = Spatches(pR).INS(1).mDegree;
pNcp    = Spatches(pR).INS(1).mNcp;
pKnotV  = Spatches(pR).INS(1).mKnotV;
pP      = Spatches(pR).INS(1).mP;
pw      = Spatches(pR).INS(1).mw;
pUsize  = Spatches(pR).INS(1).mUsize;
pULims  = [0 1 ; 0 1 ; 0 1 ];
pEP     = Spatches(pR).INS(1).mEP;
pEw     = Spatches(pR).INS(1).mEw;
pCD     = [0 0 0 ];


% pp to U-coord:

[Unn, ~] = s2835b_onePoint (Xt, U0, sDegree, sNcp, sKnotV, sUsize, sP ,sw, sEP ,sEw, sCD, sULims, xdim, Xtol, DUtol);


% physical coordinates:

x = b2601_BNURBS_Xcoord (Unn, sKnotV, sNcp, sDegree, sUsize, sEw, sEP, sudim, xdim);  
Xnn(1,:) = x(:,1);


% pp to U-coord and A-coords
[Ann, ~] = v2865b_onePoint (x, A0, pDegree, pNcp, pKnotV, pUsize, pP ,pw, pEP ,pEw, pCD, pULims, xdim, Xtol, DUtol);
  


 

end

