function [NE, EVcon] = th1331_delPlanes (Vthr, pNE, pEVcon, THC)

% Compares its current volume 'Vc' against the volume of the regular tetrahedron
% whose side length a = average(sides) 'Vr'. If Va/Vr< treshold disregard that tet.
% Works in parameter space => key for eliminating tets outiside the domain !


xdim = 3 ;
pudim = 3 ;


NE = 0;
EVcon = zeros(1,4);


for e = 1:1:pNE

    % tet. coordinates:
    
    Anod = zeros(4,pudim);
    Xnod = zeros(4,xdim);
    
    for v = 1:1:4
        
        vR = pEVcon(e,v);
        
        for di = 1:1:xdim
            Anod(v,di) = THC.Av(vR,di);
            Xnod(v,di) = THC.Xv(vR,di);
        end
    end
    

    
    % current volume:
    
    Ma = zeros(xdim,3);

    for di = 1:1:pudim

        Ma(di,1) = Anod(2,di)-Anod(1,di);
        Ma(di,2) = Anod(3,di)-Anod(1,di);
        Ma(di,3) = Anod(4,di)-Anod(1,di);
        
    end

   	Vc = abs(det(Ma)/6);
    
    

    % volume of tetrahedron with all edges same length (= a): 'regular tetrahedron'
    
    r = [1 2 3 4 4 4; 
         2 3 1 1 2 3];
    
    a = 0 ;
    for s = 1:1:6
        v = zeros(pudim,1);
        v(:,1) = Anod(r(1,s),:) - Anod(r(2,s),:);
        a = a + norm(v)/6;
    end
    
    Vr = 0.11785 * a^3;
    
    
    % checks:
    
    if Vc/Vr < Vthr
        
        % disregarded
         
        %fr = 71 ;
        %pt1373_pTetConn (e, connT, Av, fr, 'b', 1, 0.6, 0, 0);
        
    else
        
        % considered
        
        NE = NE + 1 ;
        
        for i=1:1:4
            EVcon(NE,i) = pEVcon(e,i);
        end

    end 
    
end




end

