function [connT] = th1333_oConnL (NE, NV, EVcon)

% Tetrahedrons must be linear

connT = struct('LV',[],'EL',[],'SV',[],'ES',[],'VL',[],'VE',[],'EV',[], 'LE', [], 'tsF', []);

% tsF(NL,1) = 0 if the TET line does not lie on MLT, otherwise is  the MLT line ref.


% 1.- LINES MATRICES:

LVcon = zeros(1,2);
ELcon = zeros(NE,6);

NLI = 0 ;
r = [1 2 ; 2 3 ; 3 1 ; 4 1 ; 4 2 ; 4 3 ];

% 1.1.- First element:

e = 1 ;
for i = 1:1:6
    
    NLI = NLI + 1 ;
   
    n1 = EVcon(e,r(i,1)); 
    n2 = EVcon(e,r(i,2));
    
    LVcon(NLI,1) = n1 ;
    LVcon(NLI,2) = n2 ;
    
    ELcon(1,i) = NLI ;
    
end



% 1.2.- Rest of elements:

for e = 2:1:NE
    
    for i = 1:1:6
        
        % candidate line:
     	n1 = EVcon(e,r(i,1)); 
        n2 = EVcon(e,r(i,2));


        % compares with already stored:
        addF = 1 ;
        for j = 1:1:NLI
            if (LVcon(j,1)==n1 && LVcon(j,2)==n2) || ...
               (LVcon(j,1)==n2 && LVcon(j,2)==n1)
                addF = 0;
                lR = j ;
                break
            end
        end

        % adds if no extg:
        if addF == 1
            
            NLI = NLI + 1 ;
            lR = NLI ;
            
            LVcon(NLI,1) = n1 ;
            LVcon(NLI,2) = n2 ;
        end
        
        % updates ELcon:
        for j = 1:1:6   
            if ELcon(e,j)==0
                ELcon(e,j) = lR;
                break
            end    
        end

    end

end



% 2.- SIDE MATRICES:

SVcon = zeros(1,3); % side-verteces
EScon = zeros(NE,4); % side-elements

NSI = 0 ;
r = [1 2 3 ; 4 1 2 ; 4 2 3 ; 4 1 3 ];

% 2.1.- First element:

e = 1 ;
for i = 1:1:4
    
    NSI = NSI + 1 ;
   
    n1 = EVcon(e,r(i,1)); 
    n2 = EVcon(e,r(i,2));
    n3 = EVcon(e,r(i,3));
    
    SVcon(NSI,1) = n1 ;
    SVcon(NSI,2) = n2 ;
    SVcon(NSI,3) = n3 ;
    
    EScon(e,i) = NSI ;

end


% 2.2.- Rest of elements:

for e = 2:1:NE
    
    for i = 1:1:4
        
        % candidate side:
     	n1 = EVcon(e,r(i,1)); 
        n2 = EVcon(e,r(i,2));
        n3 = EVcon(e,r(i,3));
        
        % compares with already stored:
        addF = 1 ;
        for j = 1:1:NSI
            if  (SVcon(j,1)==n1 && SVcon(j,2)==n2  && SVcon(j,3)==n3 ) || ...
                (SVcon(j,1)==n3 && SVcon(j,2)==n1  && SVcon(j,3)==n2 ) || ... 
                (SVcon(j,1)==n2 && SVcon(j,2)==n3  && SVcon(j,3)==n1 ) || ... 
                (SVcon(j,1)==n1 && SVcon(j,2)==n3  && SVcon(j,3)==n2 ) || ... 
                (SVcon(j,1)==n3 && SVcon(j,2)==n2  && SVcon(j,3)==n1 ) || ...     
                (SVcon(j,1)==n2 && SVcon(j,2)==n1  && SVcon(j,3)==n3 ) 
           
                addF = 0;
                sR = j ;
                break
                
            end
        end

        % adds if no extg:
        if addF == 1
            
            NSI = NSI + 1 ;
            sR = NSI ;
            
            SVcon(NSI,1) = n1 ;
            SVcon(NSI,2) = n2 ;
            SVcon(NSI,3) = n3 ;
        end
        
        % updates ELcon:
        for j = 1:1:4   
            if EScon(e,j)==0
                EScon(e,j) = sR;
                break
            end    
        end

    end

end




% 3.- VERTEX MATRICES:

VEcon = zeros(NV,2);

% 3.1.- First element:

e = 1 ;

for i = 1:1:4
    vr = EVcon(e,i);
    VEcon(vr,1) = e ;
end


% 3.2.- Rest of elements:

for e = 2:1:NE
    
    for i = 1:1:4
        
        vr = EVcon(e,i);

        adcF = 1 ; % add column flag
        ainF = 0 ; % already IN flag
        
        % searches if is already stored
        for j = 1:1:size(VEcon,2)

            if VEcon(vr,j)== e
                ainF = 1 ;
                break
            end
            
            if VEcon(vr,j)==0 
                cr = j ;
                adcF = 0 ;
                break
            end
             
        end
        

        % adds element, and col. in case reaches the end of VEcon:
        
        if ainF == 0
            
            if adcF == 1 
                VEcon = [ VEcon zeros(NV,1) ];
                cr = size(VEcon,2); 
            end
            
            VEcon(vr,cr) = e ;
        end
        
    end
  
end


% 3.3.- VLcon and LEcon:

VLcon = zeros(NV,1);
LEcon = zeros(NLI,1);

nL = zeros(NV,1); % No. lines per node

ne = zeros(NLI,1) ; % No. elements per line

for i = 1:1:NLI
   
    r1 = LVcon(i,1);
    r2 = LVcon(i,2);
    
    % VLcon :
    
    nL(r1) = nL(r1) + 1;
    nL(r2) = nL(r2) + 1;
    
    VLcon(r1,nL(r1)) = i ;
    VLcon(r2,nL(r2)) = i ;
    

    % ELcon :
    
    for a = 1:1:size(VEcon,2)
        
        e1 = VEcon(r1,a);
        
        if e1 > 0
            
            for b = 1:1:size(VEcon,2)
                
                e2 = VEcon(r2,b);
                
                if e2 == 0
                    break
                elseif e1==e2
                    ne(i) = ne(i)+1;
                    LEcon(i,ne(i)) = e1 ;
                end
                
            end
            
        end
        
    end
    
    
end





% ALLOCATES:

connT.LV = LVcon ;
connT.EL = ELcon ;
connT.SV = SVcon ;
connT.ES = EScon ;
connT.VL = VLcon ;
connT.VE = VEcon ;
connT.EV = EVcon ;
connT.LE = LEcon ;
%connT.tsF = itsF ;

end

