function [losF] = th1335_mLineSide (ILn, Av, sR, SVcon)

% RETURNS:
% losF: line on side flag 
% losF = 0 if does not intersect the triangular face
% loSF = 1 if the missing line intersects inside the the triangular face
% losF = 2 if the missing line intersects the face right at the edge

% INPUTS:
% ILn(2,udim): end-nodes of missing line refs
% Av: nodes coordinates
% sR: side reference
% SVcon

udim = 3 ;

% 1.- INTERSECTION LINE-PLANE OF FACE:

% vectors and point defining the face:

u = zeros(udim,1);
v = zeros(udim,1);
P = zeros(udim,1);

u(:,1) = Av(SVcon(sR,3),:) - Av(SVcon(sR,1),:);
v(:,1) = Av(SVcon(sR,2),:) - Av(SVcon(sR,1),:);
P(:,1) = Av(SVcon(sR,1),:);

% missing line vector and point:

rv = zeros(udim,1);
rP = zeros(udim,1);

rv(:,1) = Av(ILn(2,1),:) - Av(ILn(1,1),:);
rP(:,1) = Av(ILn(1,1),:);

[IP,~] = go2545_PlaneLineIntersec (u, v, P, rv, rP);



% 2.- DETECTS IF THE INTERSECTION POINT IS WITHIN THE TRIANGLE:

tolA = 0.5 ; % percentage of segment length
tolL = 1.0 ; % percentage of triangle area
nd = 3 ;

tv = zeros(3,udim); % triangular vertex coordinates:

for i = 1:1:3
    tv(i,:) = Av(SVcon(sR,i),:);
end


[losF] = go2546_PinTriang (tv, IP, tolL, tolA, nd);





end