function [pNE, connT] = th1338_splitTets (ILn, pNE, pNV, connT, Ncs, csR, Av, MLT)

% RETURNS:
% tets featrues after dividing 2 tets into 3

% INPUTS:
% csR(Ncs,4): tet1, tet2, side ref, losF



pudim = 3 ;
losF = csR(1,4); % 1 for missing line within the side, 2 at the edge of the side
    

if Ncs == 1

    % % 1.- ONE SINGLE SIDE IS INVOLVED:
    
    if losF == 1
    
        % 1.1.- Missing intersects the common side inside:
        
        % Divides the couple of tets into three tets with the line as common
        % edge between them. Divides into 'rear', 'front' and 'base' tets:
        
        pNE = pNE + 1 ;

        % original elemetns refs
        ot1 = csR(1,1); 
        ot2 = csR(1,2);

        % new elements refs:

        rt = ot1 ;
        ft = ot2 ;
        bt = pNE ;
        ner = [ rt, ft, bt ] ;
        
        sr = csR(1,3); % common side reference

        
        % local refs of nodes:

        r = [ ILn(1,1) ILn(2,1) connT.SV(sr,1) connT.SV(sr,2) connT.SV(sr,3) ];

        
        % updates conn. matrix:

        connT.EV(rt,1) = r(1); connT.EV(rt,2) = r(2); connT.EV(rt,3) = r(3); connT.EV(rt,4) = r(4) ;
        connT.EV(ft,1) = r(1); connT.EV(ft,2) = r(2); connT.EV(ft,3) = r(3); connT.EV(ft,4) = r(5) ;
        connT.EV(bt,1) = r(1); connT.EV(bt,2) = r(2); connT.EV(bt,3) = r(4); connT.EV(bt,4) = r(5) ;

        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %{
        fr = 71 ;
        
        for i = 1:1:3
            
            eR = ner(i) ;
            
            unod = zeros(4,pudim);
            for k = 1:1:4 
                nR = connT.EV(eR,k);
                unod(k,:) = Av(nR,:);
            end
            
            pt1362_pTet (unod, pudim, fr, 0, 1.2) ;
            
        end
        
        axis equal
        
        if gg==0
        end
        
        %}
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
    elseif losF == 2
        
        % 1.2.- Missing intersects the common side right at edge:
        % In this case the missing line lies at boundary and the tets side
        % just is flipped:
        
        % original elemetns refs
        ot1 = csR(1,1); 
        ot2 = csR(1,2);
        
        oer = [ ot1 , ot2 ];
        
        sr = csR(1,3); % common side reference
        
        
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %{
        fr = 70 ;
        
        for i = 1:1:2
            
            eR = oer(i) ;
            
            unod = zeros(4,pudim);
            for k = 1:1:4 
                nR = connT.EV(eR,k);
                unod(k,:) = Av(nR,:);
            end
            
            pt1362_pTet (unod, pudim, fr, 0, 1.2) ;
            
            for k = 1:1:5
                
                % text( Av(r(k),1) , Av(r(k),2) ,Av(r(k),3) ,num2str(r(k))) ; hold on
                
            end
            
        end
        
        axis equal
        
        %}

        % Searches for 'apex' node: the one to form the new side with ILn(1) and ILn(2).
        % If line jointing two nodes intersects the missing line, those nodes are not the 'apex'
        
        [pnR, apexR] = th1326_apexSide (Av, connT, ILn, sr);
            

        % updates conn. matrix:
        connT.EV(ot1,1) = ILn(1,1); connT.EV(ot1,2) = ILn(2,1); connT.EV(ot1,3) = pnR(1); connT.EV(ot1,4) = apexR ;
        connT.EV(ot2,1) = ILn(1,1); connT.EV(ot2,2) = ILn(2,1); connT.EV(ot2,3) = pnR(2); connT.EV(ot2,4) = apexR ;
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %{
        fr = 71 ;
        
        for i = 1:1:2
            
            eR = oer(i) ;
            
            unod = zeros(4,pudim);
            for k = 1:1:4 
                nR = connT.EV(eR,k);
 
                unod(k,:) = Av(nR,:);
            end
            
            pt1362_pTet (unod, pudim, fr, 0, 1.2) ;
            
            for k = 1:1:5
                
                %text( Av(r(k),1) , Av(r(k),2) ,Av(r(k),3) ,num2str(r(k))) ; hold on
                
            end
            
        end
        
        axis equal
        
        if gg==0
        end
        
        %}
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
    end
    
elseif Ncs == 2
    
    % % 2.- TWO SIDES ARE INVOLVED:

    if losF == 2
        
        % 2.1.- Missing intersects the common side at shared edge by them:
        % In this case the missing line lies at boundary and the tets sides
        % just are flipped:
        
        for s = 1:1:Ncs
            
            % original elemetns refs:
            ot1 = csR(s,1); 
            ot2 = csR(s,2);
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            % prev tets:
            %{
            
                fr = 77 ;
                figure(fr)
                
                Anod1 = zeros(4,pudim);
                Anod2 = zeros(4,pudim);
                
                for i = 1:1:4
                    nR1 =connT.EV(ot1,i);
                    Anod1(i,:) = Av(nR1,:);
                    
                    nR2 =connT.EV(ot2,i);
                    Anod2(i,:) = Av(nR2,:);
                end
                
                pt1362_pTet (Anod1, pudim, fr, 0, 1.5);
                pt1362_pTet (Anod2, pudim, fr, 0, 1.5);
                
                axis equal
            %}
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            sr = csR(s,3); % common side reference
            
            % Searches for 'apex' node: the one to form the new side with ILn(1) and ILn(2).
            % If line jointing two nodes intersects the missing line, those nodes are not the 'apex'
        
            [pnR, apexR] = th1326_apexSide (Av, connT, ILn, sr);
            

            % updates conn. matrix:
            connT.EV(ot1,1) = ILn(1,1); connT.EV(ot1,2) = ILn(2,1); connT.EV(ot1,3) = pnR(1); connT.EV(ot1,4) = apexR ;
            connT.EV(ot2,1) = ILn(1,1); connT.EV(ot2,2) = ILn(2,1); connT.EV(ot2,3) = pnR(2); connT.EV(ot2,4) = apexR ;
   
         	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            % prev tets:
            %{
            
                fr = 78 ;
                figure(fr)
                
                Anod1 = zeros(4,pudim);
                Anod2 = zeros(4,pudim);
                
                for i = 1:1:4
                    nR1 =connT.EV(ot1,i);
                    Anod1(i,:) = Av(nR1,:);
                    
                    nR2 =connT.EV(ot2,i);
                    Anod2(i,:) = Av(nR2,:);
                end
                
                pt1362_pTet (Anod1, pudim, fr, 0, 1.5);
                pt1362_pTet (Anod2, pudim, fr, 0, 1.5);
                
                axis equal
            %}
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            
            
        end
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % MLT:
        %{
     	
        tAv     = MLT.tAv ;
        tLVcon  = MLT.tLVcon ;
        tTVcon  = MLT.tTVcon ;
        tNV     = MLT.tNV ;
        tNE     = MLT.tNE ;
        tANv     = MLT.tANv ;
        tANe     = MLT.tANe ;
        
        NLI = size(tLVcon,1);
        dim = 3 ;
        Mcolr = '--k';
        Mthk = 0.5 ;
        Ncolr = 'r';

        lrF = 0 ; % line ref. flag
        vrF = 0 ; % vertex ref. flag
        erF = 0 ; % elems. ref. flag

        nvF = 0 ; % normal to vtx flag
        neF = 0 ; % normal to elem flag

        Nvx = tANv ;
        Nel = tANe ;
        
        sc = 0.12 ; 

        pt1366_pTriLinMesh_nD ...
        (tAv, NLI, tLVcon, tTVcon, dim, fr, Mcolr, Mthk, nvF, tNV, Nvx, neF, tNE, Nel, sc, Ncolr, lrF, vrF, erF);


        axis equal

        if gg==0
        end
        %}
        
        
    end
    
end


% updates the rest of conn. matrices:

[connT] = th1333_OtherConnLin (pNE, pNV, connT.EV);


end

