function [ro] = tr1343_Ronumber (Unod, ndim)

% RETURNS:
% ro = 0.606 / rA

% where:    0606 is rA for equilateral one
%           rA is the ratio Ac/A of the current triangle, with:
%               Ac: area of inscribed circle
%               A: area of triangle

% INPUTS:
% Unod(3,ndim): coordinates of triangle nodes

% 1.- EXTRACT VECTORS AND POINTS:

nd = 6 ;

a1 = zeros(3,1); 
a2 = zeros(3,1); 

v12 = zeros(3,1);
v13 = zeros(3,1);
v23 = zeros(3,1);

for di = 1:1:ndim
    
    a1(di,1) = Unod(1,di);
    a2(di,1) = Unod(2,di);
    
	v12(di,1) = (Unod(2,di) - Unod(1,di));
	v13(di,1) = (Unod(3,di) - Unod(1,di));
    v23(di,1) = (Unod(3,di) - Unod(2,di));
    
end
    
v21 = -v12;


% 2.- AREA OF TRIANGLE:

nv = cross(v12,v13);
A = norm(nv)/2;



% 3.- AREA OF INSCRIBED CIRCUMFERENCE:

% Use vectors 1-2 and 1-3, and 2-1 and 2-3, to compute bisectors:

[b1] = go2536_bisector (v12, v13, ndim);
[b2] = go2536_bisector (v21, v23, ndim);

[IP, fNI] = go2530_LinInters_nD (a1,b1, a2,b2, ndim, nd);


% radius is distance to any edge, uses two of them and averages:

[d1, ~] = go2527_distPtoRecta (IP, a1, v12, ndim);
[d2, ~] = go2527_distPtoRecta (IP, a2, v23, ndim);

R = (d1 + d2)/2;


% area of cicle and ratio Ac/A:

Ac = 3.14159*R^2 ;



end

