function [NE, NV, NLI, TVcon, VTcon, LVcon, VLcon, TLcon] = tr1340_globalTriang (NL, Nlv, Cv)

% RETURNS:
% plane triangulation features

% INPUTS:
% NL: No. contour loops
% Nlv(NL,1): No. vtx per loop
% Cv(NV,2): vtx coordinates

% Constraints (by contour loops):

[Cnst] = tr1345_CnstTri (NL, Nlv);


% Triangulation:

[TVcon, ~, NE, NV] = tr1346_triangCnst (Cv, Cnst);


% Other conn. matrices:

[LVcon, VLcon, TLcon, VTcon] = tr1347_otherConn (NL, Nlv, NE, NV, TVcon, Cv);

NLI = size(LVcon,1);

end

