function [R, At, h] = tr1342_Rnh (Cnod, xdim, nd)

% RETURNS: for a triangle
% R:  IN-cincumf radius
% At: area of the triangle
% h:  longest edge lenght

% INPUTS;
% Cnod(3,xdim): nodes coordinates


h = 0 ;

% extends to 3D in case is 2D

if size(Cnod,2)==2
    
    Cnod = [ Cnod, zeros(3,1) ] ;
    xdim = xdim + 1 ;
    
end



v  = zeros(xdim,1);
u  = zeros(xdim,1);

% vector perp. to plane:

for di = 1:1:xdim
    u(di,1) = Cnod(2,di) - Cnod(1,di);
    v(di,1) = Cnod(3,di) - Cnod(1,di);
end
n = cross(u,v);

At = norm(n)/2;

if round(norm(n),nd) == 0 % triangle in a line
    R = 0 ;
    return
end




% Line 1:

P1 = zeros(xdim,1);
ua = zeros(xdim,1);
ub = zeros(xdim,1);

for di = 1:1:xdim
    
    P1(di) = Cnod(1,di);
    
    ua(di) =  Cnod(2,di) - Cnod(1,di);
    ub(di) =  Cnod(3,di) - Cnod(1,di);

end

ua = ua / norm(ua);
ub = ub / norm(ub);
    
Pa = P1 + ua ;
Pb = P1 + ub ;
    
Pm = (Pa + Pb)/2;
    
v1 = Pm - P1 ;
v1 = v1/norm(v1);


% Line 2:

P2 = zeros(xdim,1);
ua = zeros(xdim,1);
ub = zeros(xdim,1);

for di = 1:1:xdim
    
    P2(di) = Cnod(2,di);
    
    ua(di) =  Cnod(1,di) - Cnod(2,di);
    ub(di) =  Cnod(3,di) - Cnod(2,di);

end

ua = ua / norm(ua);
ub = ub / norm(ub);
    
Pa = P2 + ua ;
Pb = P2 + ub ;
    
Pm = (Pa + Pb)/2;
    
v2 = Pm - P2 ;
v2 = v2/norm(v2);


% finds intersection solving the system:
% x = P1 + t1 v1 = P2 + t2 v2, removes 3rd row, only uses rows 1 and 2

A = [   v1(1) -v2(1) ; 
        v1(2) -v2(2) ];
    
b = [ P2(1)-P1(1) ; 
      P2(2)-P1(2) ];

if round(det(A),nd)==0 
    
    A = [ v1(1) -v2(1) ; 
          v1(3) -v2(3) ];
    
    b = [ P2(1)-P1(1) ; 
          P2(3)-P1(3) ];
    
end

if round(det(A),nd)==0 
    
    A = [ v1(2) -v2(2) ; 
          v1(3) -v2(3) ];
    
    b = [ P2(2)-P1(2) ; 
          P2(3)-P1(3) ];
    
end



t = A\b;

C = zeros(xdim,1);

for di = 1:1:xdim
    C(di,1) = P1(di) + v1(di)*t(1);
end



% computes responses:

Rd = zeros(xdim,1);

for di = 1:1:xdim
    Rd(di,1) = C(di,1) - Cnod(1,di);
end

[R, ~] = go2527_distPtoRecta (C, P2, ua, xdim);


r = [1 2 3 1];

for i = 1:1:3
    
    v(:,1) = Cnod(r(i),:) - Cnod(r(i+1),:) ;
    
    if h < norm(v)
        h = norm(v);
    end
    
end



end

