function [IN, dist, upr] = tr1344_PandTri (u, unod, typ, nd)


IN = 0;
dist = 0 ;
upr = zeros(2,1); % projection onto triangle sides (in case that exists)

% triangle area:

v1 = [ unod(2,1)-unod(1,1) ;  unod(2,2)-unod(1,2); 0 ];
v2 = [ unod(3,1)-unod(2,1) ;  unod(3,2)-unod(2,2); 0 ];
At = norm(cross(v1,v2)/2) ;

u1 = zeros(2,1);
u2 = zeros(2,1);

r = [1 2 3 1];

kdis = zeros(3,3); % side ref, distance, ON
kupr = zeros(3,2); % projection in each side, one vector per row

Ai = zeros(3,1); % sub-triangles areas

ndist = zeros(3,2); % node ref and distance

for k = 1:1:3 % loop on sides of triangle and nodes
    
    % relevant nodes:
    u1(:,1) = unod(r(k),:);
	u2(:,1) = unod(r(k+1),:);
       
    % node distance:
    ndist(k,1) = k ;
    ndist(k,2) = norm( [ u1(1)-u(1);  u1(2)-u(2)] ); 
    
    % distance from u to side and projected point:
   	v = u2-u1;
   	v = v / norm(v);
      
  	[dist, d] = go2527_distPtoRecta (u, u1, v, 2);
    

    upr = u + d ;
    
    kupr(k,:) = upr(:,1);
    
    % check if is ON side segment:
    ON = go2520_PonSegment (upr, u1,u2, 2, 0.1);
    
    
    % stores:
    kdis(k,1) = k ;
    kdis(k,2) = dist ;
    kdis(k,3) = ON ;
    
    
    % sub-area:
    
    v1 = [ unod(r(k),1)-u(1)   ;  unod(r(k),2)-u(2)   ; 0 ];
    v2 = [ unod(r(k+1),1)-u(1) ;  unod(r(k+1),2)-u(2) ; 0 ];
    Ai(k) = norm(cross(v1,v2)/2) ;
    
    %{
    figure(1)
    plot( [u1(1) u2(1)],  [u1(2) u2(2)], 'k'); hold on
    scatter(u(1), u(2),'r'); hold on
    axis equal
    %}
end

% arranges by distance:
kdis = sortrows(kdis,2);


if round(sum(Ai),nd) == round(At,nd)
    
    % case is inside:
    
    lr = kdis(1,1);
    dist = kdis(1,2);
    upr(:,1) = kupr(lr,:);
    
    IN = 1 ;

    % special case is at edge or on node
  	if round(dist,nd) == 0 
        
        if strcmp(typ,'closed')==1 
            
            IN = 1;
            return
            
        else
            
            IN = 0;
            return
            
        end
        
    end
    
    
else
    
    % case is outside:
    
    IN = 0 ;
    
    % checks if hsa proj onto side or on node:
    
    oON = 0;
    for i = 1:1:3
        if kdis(i,3) == 1

            lr = kdis(i,1);
            dist = kdis(i,2);
            upr(:,1) = kupr(lr,:);
            oON = 1 ;
            break
        end 
    end
    
    % in this case closest point is a node
    if oON == 0
        
        ndist = sortrows(ndist,2);
        
        nr = ndist(1,1);
        
        upr(:,1) = unod(nr,:);
        
        dist = ndist(1,2);
        
    end

end

%{
figure(1)
plot( [u(1) upr(1)],[u(2) upr(2)],'r'); hold on
axis equal
%}


end

