function [TVcon, VTcon, NE, NV] = tr1346_triangCnst (Rv, Cnst, sR)


% 1.- Temporary triang. with all triangles:

NV = size(Rv,1);

DT = delaunayTriangulation(Rv,Cnst);

tTVcon = DT.ConnectivityList;

tNE = size(tTVcon,1);

%{
if sR==3

    figure(sR)
    scatter(Rv(:,1),Rv(:,2),'r'); hold on
    axis equal



    for i = 1:1:size(Cnst,1)

        r1 = Cnst(i,1);
        r2 = Cnst(i,2);

        plot( [ Rv(r1,1), Rv(r2,1) ], [ Rv(r1,2), Rv(r2,2) ], 'k'); hold on

    end

end
%}

% 2.- Removes triangles outside contraints and assmeblies TV conn. matrices

ieF = DT.isInterior(); % interior element flag

TVcon = zeros(1,3);
VTcon = zeros(NV,1);

nev = zeros(NV,1); % No. elms attached to each vtx

NE = 0;

for e = 1:1:tNE 
    
    if ieF(e) == 1
        
        NE = NE+1;
        
        % conn. matrices:
        
        TVcon(NE,:) = tTVcon(e,:);
        
        for i = 1:1:3
            vr = TVcon(NE,i);

            nev(vr) = nev(vr)+1;
            VTcon(vr,nev(vr)) = NE ;
        end
         
    end
end

end