function [LVcon, LTcon, VLcon, TLcon, VTcon] = tr1347_otherConn (NL, Nlv, NE, NV, TVcon, Uv)


% 1.- Line edges - vtx conn. matrices:

LVcon = zeros(1,2);

NLI = 0 ;

r = [1 2 3 1];

for i = 1:1:3
    
    NLI = NLI + 1 ;
    LVcon(NLI,1) = TVcon(1,r(i));
    LVcon(NLI,2) = TVcon(1,r(i+1));
    
end

for e = 2:1:NE
    
    for i = 1:1:3
        
        % candidate couple of nodes:
        n1 = TVcon(e,r(i));
        n2 = TVcon(e,r(i+1));
        
        % check if they're IN already and adds if not:
        aIN = 0 ;
        for j = 1:1:NLI
            
            if (LVcon(j,1)==n1 && LVcon(j,2)==n2) || (LVcon(j,2)==n1 && LVcon(j,1)==n2) 
                aIN = 1;
                break
            end
            
        end
        
        if aIN == 0
            NLI = NLI + 1 ;
            LVcon(NLI,1) = n1 ;
            LVcon(NLI,2) = n2 ;
        end
        
    end
end


% re-arranges to set first lines as same order as first nodes (contours of surface):

acL = zeros(NLI,1); % already computed lines, to remove from searching
tLVcon = zeros(NLI,2);
contaLI = 0 ;

accv = 0 ;
for lr = 1:1:NL
    
    for v = 1:1:Nlv(lr)

        % defines vertex to find:
        
        v1 = accv + v ;
        
        if v < Nlv(lr)
            v2 = v1+1 ;
        else
            v2 = accv+1 ;
        end
        
        % searches line with those vertexes:
        
        for li =1:1:NLI
            
            if acL(li)==0
                
                if (LVcon(li,1)==v1 && LVcon(li,2)==v2) || (LVcon(li,1)==v2 && LVcon(li,2)==v1)
                    
                    contaLI = contaLI + 1 ;
                    
                    tLVcon(contaLI,1) = v1;
                    tLVcon(contaLI,2) = v2;
                    
                    acL(li) = 1 ;  
                end
            end 
        end 
    end
    
    accv = accv + Nlv(lr);  
end


% add the rest of the lines:

for li = 1:1:NLI
if acL(li)==0
    
    contaLI = contaLI + 1 ;
	tLVcon(contaLI,1) = LVcon(li,1);
  	tLVcon(contaLI,2) = LVcon(li,2);

end  
end

LVcon = tLVcon ;




% 2.- Vertex - lines:

VLcon = zeros(NV,1);


for l = 1:1:NLI
for i = 1:1:2
        
	vR = LVcon(l,i);
  
	addF = 0 ;
    for j = 1:1:size(VLcon,2)
            
        if VLcon(vR,j)==0
                
            VLcon(vR,j) = l ;
            break
                
        elseif j == size(VLcon,2)
                
            addF = 1 ;
                
        end 
    end
        
    if addF == 1
	VLcon(vR,j+1) = l ;
    end  
    
end
end


% 3.- Triangles - lines:

TLcon = zeros(NE,3);

for e = 1:1:NE
    
    contaL = 0 ;

    for i = 1:1:3
        
        n1 = TVcon(e,r(i));
        n2 = TVcon(e,r(i+1));

        for l = 1:1:NLI
            
            conta = 0;
            for j = 1:1:size(LVcon,2)
                
                if LVcon(l,j)==n1 || LVcon(l,j)==n2 
                    conta = conta + 1 ;
                end
                if conta==2
                    break
                end
            end
            
            if conta==2
                contaL = contaL + 1 ;
                TLcon(e,contaL) = l ;
                break
            end
            
        end
        
    end
    
end


% 4.- Triangles - lines:

LTcon = zeros(NLI,2);

% first element

e = 1 ;

for L = 1:1:3 
    LR = TLcon(e,L);
    LTcon(LR,1) = e ;
end


% rest of elements:

for e = 2:1:NE
    
    for L = 1:1:3
        
        LR = TLcon(e,L);
        
        if LTcon(LR,1)==0
            LTcon(LR,1) = e ;
        else
            LTcon(LR,2) = e ;
        end
    
    end
    
end


% 5.- Vtx - triangles:

VTcon = zeros(NV,1);

nev = zeros(NV,1); % No. elms attached to each vtx


for e = 1:1:NE 

	for i = 1:1:3 
        
        vr = TVcon(e,i);
        
        nev(vr) = nev(vr)+1;
        
     	VTcon(vr,nev(vr)) = e ;
        
	end

end







end