function [C] = mp1350_1Dmapp (Cnod, n, xi, ndim)

% RETURNS:
% C(dim,1): coord mapped form parent space using xi coord

% parent space spans from -1 to +1

% INPUTS:
% Cnod(n,dim): phys. coords of nodes
% n: No. nodes
% xi: parent coord of point to map
% ndim: No. dimension of phys. space

% 1.- Basis functions:

N = zeros(n,1);

if n==2
    
    N(1,1) = 1/2*(1-xi);
    N(2,1) = 1/2*(1+xi);  
    
elseif n==3

    N(1,1) = xi/2*(xi-1);
    N(2,1) = 1-xi^2; 
    N(3,1) = xi/2*(xi+1); 

end


% 2.- Computes coordiante (mapping):

C = zeros(ndim,1);

for i = 1:1:n 
    
    for di = 1:1:ndim
        C(di,1) = C(di,1) + N(i,1)*Cnod(i,di);
    end
end



end