function [dC] = mp1352_1Dmapp1D (Cnod, n, xi, ndim)

% RETURNS:
% dC(ndim,1): derivative of Lag-polyn curve of degree (n-1)

% parent space spans from -1 to +1

% INPUTS:
% Cnod(n,dim): phys. coords of nodes
% n: No. nodes
% xi: parent coord of point to map
% ndim: No. dimension of phys. space

% 1.- Basis functions:

N = zeros(n,1);

if n==2
    
    N(1,1) = -1/2 ;
    N(2,1) = +1/2 ;  
    
elseif n==3

    N(1,1) = 1/2*(2*xi-1);
    N(2,1) = -2*xi; 
    N(3,1) = 1/2*(2*xi+1);

end


% 2.- Computes coordiante (mapping):

dC = zeros(ndim,1);

for i = 1:1:n 
    
    for di = 1:1:ndim
        
        dC(di,1) = dC(di,1) + N(i,1)*Cnod(i,di);
        
    end
    
end



end

