function [dN] = mp1356_d4rst (r,i,j)

% RETURNS:
% dN(3,1): derivatives w.r.t. r and s of edge-nodes basis functions
% only for edge-nodes basis funciton of the form 4rs

% INPUTS:
% r(4,1): paretn space coordiantes: r,s,t,u
% i,j: indexes involved in the triangle basis funciton
% e.g.
%       4rt: i=1  j=3
%       4us: i=4  j=2

dN = zeros(3,1);

if (i==1 && j==2) || (i==2 && j==1)
                    
 	dN(1,1) = 4*r(2) ;
 	dN(2,1) = 4*r(1) ;
    dN(3,1) = 0 ;   
    
elseif (i==1 && j==3) || (i==3 && j==1)
                    
 	dN(1,1) = 4*r(3) ;
 	dN(2,1) = 0 ;
    dN(3,1) = 4*r(1) ; 
  
elseif (i==2 && j==3) || (i==3 && j==2)
                    
 	dN(1,1) = 0 ;
 	dN(2,1) = 4*r(3) ;
    dN(3,1) = 4*r(2) ; 
    
elseif (i==1 && j==4) || (i==4 && j==1)  
                    
	dN(1,1) =  4*(1-2*r(1)-r(2)-r(3)) ;
 	dN(2,1) = -4*r(1) ;
    dN(3,1) = -4*r(1) ;
    
elseif (i==2 && j==4) || (i==4 && j==2)  
                    
	dN(1,1) = -4*r(2) ;
 	dN(2,1) =  4*(1-r(1)-2*r(2)-r(3)) ;
    dN(3,1) = -4*r(2) ;
    
    
elseif (i==3 && j==4) || (i==4 && j==3)  
                    
	dN(1,1) = -4*r(3) ;
 	dN(2,1) = -4*r(3) ;
    dN(3,1) =  4*(1-r(1)-r(2)-2*r(3)) ;
                   
end


end

