function [dTrs] = mp1357_dTrirs (rs, Unod, udim)

% RETURNS:
% dTrs(3,3,udim): 1st and 2nd derivatives of quadratic triangulation mapping at r coord in
% parent space. Only 1, 11, 2, 22, 21


nn = 6 ;    % No. nodes

dTrs = zeros(3,3,udim);

r = rs(1);
s = rs(2);
t = 1 - r - s ;

dNrs = zeros(nn,3,3);

% derivatives of bfs:

% Q (1,1):

dNrs(1,1,1) = r*(2*r-1);             
dNrs(2,1,1) = s*(2*s-1);                     
dNrs(3,1,1) = t*(2*t-1);

dNrs(4,1,1) =  4*r*s;              
dNrs(5,1,1) =  4*s*t;              
dNrs(6,1,1) =  4*t*r; 


% Q,r (2,1):

dNrs(1,2,1) = 4*r-1;             
dNrs(2,2,1) = 0;                    
dNrs(3,2,1) = -3 + 4*r + 4*s; 

dNrs(4,2,1) =  4*s;              
dNrs(5,2,1) = -4*s;              
dNrs(6,2,1) = 4 - 8*r - 4*s;  


% Q,s (1,2)

dNrs(1,1,2) = 0;
dNrs(2,1,2) = 4*s - 1;
dNrs(3,1,2) = -3 + 4*r + 4*s;

dNrs(4,1,2) =  4*r;
dNrs(5,1,2) =  4 - 4*r - 8*s;
dNrs(6,1,2) =  - 4*r;


% Q,rr (3,1)

dNrs(1,3,1) =  4;             
dNrs(2,3,1) =  0;                    
dNrs(3,3,1) =  4; 

dNrs(4,3,1) =  0;              
dNrs(5,3,1) =  0;              
dNrs(6,3,1) = -8;  


% Q,ss (1,3)

dNrs(1,1,3) =  0;             
dNrs(2,1,3) =  4;                    
dNrs(3,1,3) =  4; 

dNrs(4,1,3) =  0;              
dNrs(5,1,3) = -8;              
dNrs(6,1,3) =  0;  


% Q,rs (2,2)

dNrs(1,2,2) =  0;             
dNrs(2,2,2) =  0;                    
dNrs(3,2,2) =  4; 

dNrs(4,2,2) =  4;              
dNrs(5,2,2) = -4;              
dNrs(6,2,2) = -4;  


for k = 1:1:nn
    
    for i = 1:1:3
    for j = 1:1:3
        
        for di = 1:1:udim
        
        dTrs(i,j,di) = dTrs(i,j,di) + dNrs(k,i,j)*Unod(k,di);
       
        end
        
    end
    end
 
end



end

