function [ ] = pt1362_pTet (unod, dim, fr, colr, transp, Lthk, filF)

% plots tetrahedral

% transp varies from 0 (transparent) to 1 (solid)

figure(fr);

X = zeros(3,1);
Y = zeros(3,1);
Z = zeros(3,1);
C = ones(3,1);

% octaedral face:

OCTnod = zeros(4,dim);

for i = 1:1:3
    
    OCTnod(i,:) = unod(i,:);
    
    X(i,1) = unod(i,1);
    Y(i,1) = unod(i,2);
    Z(i,1) = unod(i,3);
    
end
OCTnod(4,:) = unod(1,:);


p1 = plot3(OCTnod(:,1),OCTnod(:,2),OCTnod(:,3), colr, 'LineWidth', Lthk); hold on
p1.Color(4) = transp;

if filF == 1
    fill3(X,Y,Z,C); hold on
end


% orthonormal faces:

Onod = zeros(2,dim);

for i = 1:1:3
    
    Onod(1,:) = unod(4,:);
    Onod(2,:) = unod(i,:);
    p2 = plot3(Onod(:,1),Onod(:,2),Onod(:,3), colr, 'LineWidth', Lthk); hold on
    p2.Color(4) = transp;
    
end

if filF == 1
    
    r = [ 4 1 2 ; 4 2 3 ; 4 3 1 ] ;
    
    for t = 1:1:3
        
        for i = 1:1:3
            
            X(i,1) = unod(r(t,i),1);
            Y(i,1) = unod(r(t,i),2);
            Z(i,1) = unod(r(t,i),3); 
            
        end
        
        fill3(X,Y,Z,C); hold on
        
    end
    
    
end


axis equal


end

