function [Lx] = pt1363_lineCoord (li, stL, Cv, LVcon, dim, LinsF)

% RETURNS:
% Lx(Np,dim): line coordinates mapped with stLu step in parent space

% INPUTS:
% li: line ref.
% stL: line step in parent pace
% Cv: all nodes coordinates 
% LVcon(NLI,3)
% LinsF = 1 if linear are simplified just to first and last point

nd = 3 ; % round coords

% No. nodes per side line and xi step used:
NnL = 2 ;

if LVcon(li,3) > 0
	NnL = 3 ;
end
     
stLu = stL ;
if LinsF == 1 && LVcon(li,3) == 0     
    stLu = 2 ;    
end


% Curve nodes coordinates:

Cnod = zeros(NnL,dim);
for i = 1:1:NnL
    
    nR = LVcon(li,i);
    Cnod(i,:) = Cv(nR,:);

end



% computes line coord's in physical space:

conta = 0 ;
Lx = zeros(1,dim);

for xi = -1:stLu:1

	C = mp1350_1Dmapp (Cnod, NnL, xi, dim);

	conta = conta + 1 ;
	Lx(conta,:) = round(C(:,1),nd);
end


end

