function [ ] = pt1366_pTriLinMesh_nD ...
    (Cv, NLI, LVcon, TVcon, dim, fr, Mcolr, Mthk, nvF, NV, Nvx, neF, NE, Nel, sc, Ncolr, lrF, vrF, erF)

% vrF, erF: vtx and elem. refs flags (=1 write refs)

figure(fr);

% triangulation:

cn = zeros(2,dim);

for li = 1:1:NLI
    
    n1 = LVcon(li,1);
    n2 = LVcon(li,2);
    
    cn(1,:) = Cv(n1,:);
    cn(2,:) = Cv(n2,:);
    
    m = zeros(1,dim);
    
    m(1,:) = (cn(1,:) + cn(2,:))/2;
    
    
    if dim==2

        plot(cn(:,1),cn(:,2),Mcolr,'LineWidth', Mthk); hold on

        if lrF == 1
            text(m(1,1), m(1,2), num2str(li)); hold on
        end
        
    elseif dim==3

        plot3(cn(:,1),cn(:,2),cn(:,3),Mcolr,'LineWidth', Mthk); hold on

    	if lrF == 1
            text(m(1,1), m(1,2), m(1,3), num2str(li)); hold on
        end
        
    end
    
end


% normals to vertexes:



if nvF == 1 || vrF==1

    n = zeros(2,dim);

    for v = 1:1:NV

        if nvF==1
            
            %n(1,:) = Cv(v,:);
            %n(2,:) = Cv(v,:) + Nvx(v,:) * sc;
            %plot3(n(:,1), n(:,2), n(:,3), Ncolr); hold on
            
            quiver3( Cv(v,1), Cv(v,2), Cv(v,3), Nvx(v,1), Nvx(v,2), Nvx(v,3), sc, 'r'); hold on
            
            
        end
        

        
        if vrF==1
            
            if dim==2
                text(Cv(v,1), Cv(v,2), num2str(v)); hold on
            elseif dim==3
                text(Cv(v,1), Cv(v,2), Cv(v,3), num2str(v)); hold on
            end

        end
        
    end
    
end


% normals to elements:

if neF == 1 || erF == 1
    
    n = zeros(2,dim);
    for e = 1:1:NE
        
        c = zeros(1,dim);
        for i = 1:1:3
            
            vR = TVcon(e,i);
            c(1,:) = c(1,:) + Cv(vR,:)/3;
        end
        
        if neF==1
            
            %n(1,:) = c(1,:);
            %n(2,:) = c(1,:) + Nel(e,:) * sc;
            %plot3(n(:,1), n(:,2), n(:,3), Ncolr); hold on
            
            quiver3( c(1,1), c(1,2), c(1,3), Nel(e,1), Nel(e,2), Nel(e,3), sc, 'r'); hold on
            
        end
        
        if erF == 1

            if dim==2
                text(c(1,1), c(1,2), num2str(e)); hold on
            elseif dim==3
                text(c(1,1), c(1,2), c(1,3), num2str(e)); hold on
            end
            
            
        end
        
    end
    
end


axis equal

end