function [ ] = pt1367_pTriQuaMesh (stL, stT, Cv, NLI, LVcon, TVcon, fr, NE, eF, sF, nF, lrF, vrF, erF, xdim, eCol)

% eF, sF: edges and surface flags
% vrF, erF: vtx and elem. refs flags (=1 wirte refs)

figure(fr);

NnL  = 3 ; % No. nodes per side line
NnE  = 6 ; % No. nodes per element

NVm = size(Cv,1);

% 1.- EDGES:

if eF == 1

    C = zeros(NnL,xdim);

    for li = 1:1:NLI

        % curve nodes coordinates:
        for i = 1:1:NnL
            nR = LVcon(li,i);
            C(i,:) = Cv(nR,:);
        end


        % computes line coord's in physical space:
        conta = 0 ;
        Lx = zeros(1,xdim);

        for xi = -1:stL:1

            x = mp1350_1Dmapp (C, NnL, xi, xdim);

            conta = conta + 1 ;
            Lx(conta,:) = x(:,1);
        end


        % plots the line
        
        mp = round((conta/2),0);
        
        if xdim == 3
        
            plot3(Lx(:,1),Lx(:,2),Lx(:,3),eCol); hold on

            if lrF == 1
                 text(Lx(mp,1),Lx(mp,2),Lx(mp,3),num2str(li)); hold on
            end
            
        elseif xdim == 2
            
            plot(Lx(:,1),Lx(:,2),eCol); hold on
            
            if lrF == 1
                 text(Lx(mp,1),Lx(mp,2),num2str(li)); hold on
            end
            
        end
        
        % m = zeros(1,dim);
        % m(1,:) = (Cnod(1,:) + Cnod(2,:))/2 ;
    end

end


% 2.- NODES:

if nF == 1

    if xdim == 3
        
        scatter3( Cv(:,1), Cv(:,2), Cv(:,3),'r'); hold on
        
        if vrF==1 
            for i = 1:1:NVm
                text( Cv(i,1), Cv(i,2), Cv(i,3),num2str(i)); hold on
            end
        end
        
        
    elseif xdim == 2
        
        scatter( Cv(:,1), Cv(:,2), 'r'); hold on
        
        if vrF==1 
            for i = 1:1:NVm
                text( Cv(i,1), Cv(i,2),num2str(i)); hold on
            end
        end
        
    end

end


% 3.- ELEMENTS REFS:

if erF==1

    for e = 1:1:NE

        C = zeros(xdim,1);

        for i = 1:1:3
            nR = TVcon(e,i);
            for di = 1:1:xdim
                C(di,1) = C(di,1) + Cv(nR,di)/3;
            end
        end

        if xdim == 2
            text(C(1),C(2),num2str(e)); hold on
        else
            text(C(1),C(2),C(3),num2str(e)); hold on
        end


    end
    
end



% 4.- SURFACE ITSELF:

if sF == 1

    C = zeros(NnE,xdim);

    for e = 1:1:NE

        
        iem = zeros(3,3);
        
        
        % triangle nodes coordinates:
        for i = 1:1:NnE
            nR = TVcon(e,i);
            C(i,:) = Cv(nR,:);
        end

 
        % computes triangle points in physical space

        R = zeros(1,2);
        P = zeros(1,xdim);

        conta = 0 ;

        for r = 0:stT:1

            s0 = 0 ;
            s1 = 1-r;

            Ns = round((s1-s0)/stT,0);
            Ds = (s1-s0)/Ns ;

            
            if r==1
                Ns=0;
            end

            s = 0 ;
            for i = 1:1:Ns+1

                C = mp1352_TRImapp ([r;s], C, 2, xdim, iem);
                                    
                conta = conta + 1 ;

                R(conta,1) = r ;
                R(conta,2) = s ;

                for di = 1:1:xdim
                    P(conta,di) = C(di,1);
                end

                s = s + Ds;
            end

        end

        
        
        % triangulates in parent space and transfers triangles coords:

        TRI = delaunay(R);
        NER = size(TRI,1);

        X = zeros(xdim,NER);
        Y = zeros(xdim,NER);
        Z = zeros(xdim,NER);
        G = zeros(xdim,NER);

        for col = 1:1:NER
            for i = 1:1:3

                %nR = conn(col,i);
                nR = TRI(col,i);

                X(i,col) = P(nR,1);
                Y(i,col) = P(nR,2);
                Z(i,col) = P(nR,3);
            end
        end

        % plots:
        fill3(X,Y,Z,G, 'LineStyle','none'); hold on

    end

end


axis equal





end