function [ ] = pt1370_pTetMDMesh (sp, stL, Cv, NLI, LVcon, KnotV, Ncp,Degree,Usize, Ew, EP, fr, Mcolr, lrF)

% plots tet- mesh with mixed degrees, only lines, not element surfaces !

udim = 3 ;
xdim = 3 ;

if fr > 0
    figure(fr);
end


% expand conn. matrices in case they are just linear:

if size(LVcon,2)==2
    LVcon = [LVcon zeros(NLI,1)];
end


% 1.- EDGES:

LinsF = 0 ;


for li = 1:1:NLI

	% computes the line points 
	[Lx] = pt1363_lineCoord (li, stL, Cv, LVcon, xdim, LinsF);
    
    % mapps to physical is required:
    if strcmp(sp,'x')== true

        n = size(Lx,1);
        u = zeros(udim,1);
        
        for i = 1:1:n
            
            u(:,1) = Lx(i,:);
            
            for di = 1:1:udim
                if u(di)<0
                    u(di) = 0 ;
                elseif u(di)>1
                    u(di) = 1 ;
                end
            end
            
            [X] = b2601_BNURBS_Xcoord (u, KnotV, Ncp, Degree, Usize, Ew,EP, udim, xdim);
            
            Lx(i,:) = X(:,1);
            
        end
        
    end
    

	% plots the line:
	plot3(Lx(:,1),Lx(:,2),Lx(:,3),Mcolr); hold on
    
    
    % line ref:
    if lrF == 1
        Lav = (Lx(1,:) + Lx(end,:))/2 ;
        text(Lav(1),Lav(2),Lav(3),num2str(li)); hold on
    end
    
    
end


if fr > 0
    axis equal
end


end