function [ ] = pt1372_pTri_iem (unod, iem, st, fr, colr, transp, Lthk, nodON, ndim)

% plots tetrahedral of any degree (uses iem matrix)

% st: step to represent
% nodON: if = 1 plots also the nodes

figure(fr);

% contour:

nr = [ 1 2 3 1 ];

for i = 1:1:3
    
    mnr = iem ( nr(i), nr(i+1) ); % ref. of mid-node of the contour line

    if mnr==0   
        n = 2;
        Cnod = zeros(n,ndim);
        Cnod(1,:) = unod(nr(i),:);
        Cnod(2,:) = unod(nr(i+1),:);
    else
        n = 3;
        Cnod = zeros(n,ndim);
        Cnod(1,:) = unod(nr(i),:);
        Cnod(2,:) = unod(mnr,:);
        Cnod(3,:) = unod(nr(i+1),:);
    end

    conta = 0 ;
    CL = zeros(2,ndim);
    
    for r = -1:st:1
        
        conta = conta + 1 ;
        
        C = mp1350_1Dmapp (Cnod, n, r, ndim);
        CL(conta,:) = C(:,1);
        
    end
    
    if ndim==2
       p1 = plot( CL(:,1), CL(:,2), colr, 'LineWidth', Lthk); hold on
       p1.Color(4) = transp;
    elseif ndim==3
        p1 = plot3( CL(:,1), CL(:,2), CL(:,3), colr, 'LineWidth', Lthk); hold on
        p1.Color(4) = transp;
    end
    
end




% nodes:

if nodON == 1
    if ndim == 2
        
        scatter(unod(:,1),unod(:,2),'r'); hold on
        
    elseif ndim == 3
      
        scatter3(unod(:,1),unod(:,2),unod(:,3),'r'); hold on
        
    end
end

axis equal


end

