function [THC, connT] = th1380_tSc (pR, Spatches, NLI, NE, THC, connT, NVm, Eiem, Nve, MLT)

pudim = 3 ;

% 1.- CONNECTIVITY MATRICES SPECIFICALLY FOR SIDES OF THE TETS:

[connS,~,~] = th1381_connS (NE, connT);


%{
if pR==2
    sR = 3606;
    
    fr = 77 ;
    
    for i = 1:1:2
        
        eR = connS.SE(sR,i);
        
        if eR>0
        
            pt1373_pTetConn (eR, connT, THC.Av, fr, 'k', 1, 1.5, 0, 0);
        
        end
        
    end
    
    
    if jj==0
    end
end
%}


%{
if pR == 2 
    
    nR = 50 ;

    for i = 1:1:size(connT.VE,2)
        
        eR = connT.VE(nR,i);
        
        if eR > 0
            
            fr = 40 ;
            
            pt1373_pTetConn (eR, connT, THC.Av, fr, 'k', 0.5, 1.25, 0,1);
            
        end
        
        
    end
    
end
%}

% plots t-surfaces:
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%{

Anod = zeros(6,pudim);

iem = [ 0 4 6 ; 4 0 5 ; 6 5 0 ];
st = 0.1 ;

fr = 22 ;

nodON = 1 ;

for si = 1:1:NSI
if connS.tsF(si)==1  
    
    for i = 1:1:6
        Anod(i,:) = THC.Av(connS.SV(si,i),:);
    end

    pt1372_pTri_iem (Anod, iem, st, fr, 'k', nodON, pudim) ;
    
end  
end
 

if gg==0
end

%}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% 2.- CHECKS END-NODES AT TRIMMING SURFACES:

angL = zeros(2,1); % angles limits for correction
angL(1) =  95 / 57.3 ;
angL(2) = 120 / 57.3 ;

NV = size(connT.VL,1);

contaK = 0;

for k = 1:1:NV
if THC.NCS(k,2) > 0 % only for nodes at the surface
  
    contaK = contaK + 1 ;
    
    npR = k ; % ref of node pivot
    
    Ap = zeros(pudim,1); % pivot: coords and normal
    np = zeros(pudim,1);
    
    Ap(:,1) = THC.Av(npR,:);
    np(:,1) = THC.ANv(npR,:);
    

    % 2.1.- Attached lines, internal and lines of crown:

    [iLR, niL, sLR, nsL, acL, Nis, NLc, NeL] = th1384_attL (connT, connS, npR, THC) ;
    
    
    if iLR(1) > 0 % only for pivots that have inner lines
    

        % 2.2.- FAN with arranged triangle created from deriv. at pivot of the T-surface lines:

        [FAN] = th1385_FAN (connT, THC, NLc, acL, Nis, npR, NeL, Ap, np);

        % plots FAN
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %{
        if npR == 4
            
            fr = contaK ;
            figure(fr);

            x = zeros(4,pudim);
            r = [ 1 2 3 1 ];

            for t = 1:1:Nis

                for i = 1:1:4
                    x(i,:) = FAN(t).At(r(i),:);
                end

                plot3 ( x(:,1) , x(:,2) ,x(:,3) ,'b'); hold on

                scatter3(FAN(t).Ac(1),FAN(t).Ac(2),FAN(t).Ac(3),'b'); hold on

                quiver3( FAN(t).Ac(1),FAN(t).Ac(2),FAN(t).Ac(3) , FAN(t).n(1),FAN(t).n(2),FAN(t).n(3), 'r'); hold on

            end

            %quiver3( Ap(1),Ap(2),Ap(3) , np(1),np(2),np(3), 'k'); hold on
            
            axis equal

            if ff==0
            end
            
            
        end
        %}
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


        % 2.3.- Computes internal lines tangents and store features in ILF:

        [ILF] = th1386_ILF (iLR, connT, THC, FAN, Nis, npR, Ap);



        % 2.4.- Corrects ILF if necessary: 
        % modifies the angle wrt triangle normal (nta) and the tangent vector accordingly (tg)

        [uILF, uLR, Nu] = th1387_uILF (FAN, ILF, iLR, angL, Ap, contaK);

  
        
        % 2.5.- Inserts mid-node to the internal lines to achieve such modified tangents:

        if Nu > 0


            [THC, Nve,connT, Eiem, NVm] = th1388_midNod ...
            (pR, Spatches, uILF, uLR, Nu, THC, Nve, connT, Eiem, NVm, Ap, contaK);
        

            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            % plots lines attached to npR node:
            %{

            %[iLR, sLR, niL, nsL] = th1398_L2npR (connT, npR);
            
            if npR == 4

                stL = 0.1 ;
                
                % INITIAL ARRANGEMENT
                figure(npR) 
                
                
                
                
                % UPDATED ARRANGEMENT
                figure(100+npR) 

                % internals:

                for i = 1:1:niL

                    lR = iLR(i);
                    
                    if connT.LV(lR,3)==0
                        
                        xnod = zeros(2,pudim);
                        for j = 1:1:2
                            nR = connT.LV(lR,j);
                            xnod(j,:) = THC.Av(nR,:);
                        end
                    
                    else
                        
                    	xnod = zeros(3,pudim);
                        for j = 1:1:3
                            nR = connT.LV(lR,j);
                            xnod(j,:) = THC.Av(nR,:);
                        end
                        
                    end
                    
                    

                    if connT.LV(lR,3)==0

                        plot3(xnod(:,1),xnod(:,2),xnod(:,3),'k','Linewidth',0.25); hold on

                    else
                        
                        x = zeros(1,pudim);

                        conta = 0 ;
                        for w = -1:stL:+1

                            conta = conta + 1 ;
                            [C] = mp1350_1Dmapp (xnod, 3, w, pudim);
                            x(conta,:) = C(:,1);
                        end
                        plot3(x(:,1),x(:,2),x(:,3),'k', 'Linewidth',0.25); hold on

                    end
                    
                end


                % surface lines:

                
                xnod = zeros(3,pudim);

                for i = 1:1:nsL

                    lR = sLR(i);

                    for j = 1:1:3
                        nR = connT.LV(lR,j);
                        xnod(j,:) = THC.Av(nR,:);
                    end

                    x = zeros(1,pudim);

                    conta = 0 ;
                    for w = -1:stL:+1

                        conta = conta + 1 ;
                        [C] = mp1350_1Dmapp (xnod, 3, w, pudim);
                        x(conta,:) = C(:,1);
                    end
                    plot3(x(:,1),x(:,2),x(:,3),'m', 'Linewidth',3); hold on
                    
                end

                axis equal

                if gg==1
                end
                
            end



            %}

    
        end
    
 

    end
    
end
end




end

