function [SIF] = th1382_SIF (THC, connS, NSI, Siem)

pudim = 3 ;
Pdim = 2 ;
sts = 0.20 ; % step for sample points

SIF(1,1) = struct('mN', 0 , 'mNc', 0, 'mAsp',[], 'mPsp',[], 'miem', []); % side features

for s = 1:1:NSI
    
    Asp = zeros(1,pudim);
    Psp = zeros(1,Pdim);
    conta = 0 ;
    

	% iem matrix:
    
    iem = zeros(3,3);
    iem(:,:) = Siem(s,:,:);
    SIF(s,1).miem = iem ;
    
    
    % Parents space coordinates
    
    maxr = max(max(iem));
    ra = maxr-3;
    
    if ra < 0
        
        maxr = 3 ;
        Psp = [ 1 0 ; 0 1 ; 0 0 ];
        
    elseif ra > 0
        
        Psp = [ 1 0 ; 0 1 ; 0 0 ; zeros(ra,Pdim)];
         
        for i = 1:1:2
        for j = i:1:3
            
            if iem(i,j)>0
                
                rr = iem(i,j);

                if i==1 && j==2  
                    tmp = [0.5 0.5] ; 
                elseif i==1 && j==3
                    tmp = [0.5 0.0] ;
              	elseif i==2 && j==3 
                    tmp = [0.0 0.5] ;
                end
                
                Psp(rr,:) = tmp(1,:);
                
            end
        end 
        end
    end
        
 
    % Coords of sample points at contour:
    
    for k = 1:1:maxr
        
        nR = connS.SV(s,k);
    	conta = conta + 1 ;
        
     	Asp(conta,:) = THC.Av(nR,:);  

    end

    SIF(s,1).mNc = conta;
    

    % internal points:
    
    Anod = Asp;
    
    for u = sts:sts:1-sts
        
        for v = sts:sts:1-sts
        if v <= (1-u-sts)
            
         	conta = conta + 1 ;
            
            [a,~,~] = mp1352_TRImapp ([u v], Anod, 2, pudim, iem);
            
            Asp(conta,:) = a(:,1);
            Psp(conta,:) = [u v];
            
        end
        end

    end
    
    SIF(s,1).mN = conta;
    SIF(s,1).mAsp = Asp;
    SIF(s,1).mPsp = Psp;
    
end


end

