function itF = th1383_sidesPos (r1, r2, SIF)

% RETURNS:
% itF = 0/1 f they do not intersecto or YES

pudim = 3 ;
Pdim = 2 ; % parent space No. coords

N1 = SIF(r1).mN; % No. sample points
N2 = SIF(r2).mN;

nd = 2 ;

a1 = zeros(pudim,1);
a2 = zeros(pudim,1);

rs = zeros(Pdim,1);

ptn = zeros(N1,1); % projection to normals of side 2


for i = 1:1:N1
    
    a1(:,1) = SIF(r1).mAsp(i,:);
    
    
    % 1.1.- Find closest point of side r2 to point a1:
    
    dmin = 9999 ;
    cpr2 = 0 ; % closest point ref.
    
    for j = 1:1:N2
        a2(:,1) = SIF(r2).mAsp(j,:);

        if norm(a2-a1) < dmin
            dmin = norm(a2-a1);
            cpr2 = j ;
        end
    end 
    
    a2(:,1) = SIF(r2).mAsp(cpr2,:);
    

    % 1.2.- Checks coincidence:
    
    CO = go2542_coincidentP (a1, a2, pudim, nd);

    if CO==1
        ptn(i,1) = 0;
    end
    
    
    % 1.3.- Projection of a2-a1 on n:
    
    if CO == 0
    
        iem2  = SIF(r2).miem ;
        Nc2   = SIF(r2).mNc ;
        Anod2 = SIF(r2).mAsp(1:Nc2,:);

        rs(:,1) = SIF(r2).mPsp(cpr2,:);

        [~, J2, ~] = mp1352_TRImapp (rs, Anod2, 2, pudim, iem2);
        
        n = cross(J2(:,1),J2(:,2));
        n = n / norm(n);
        
        a21 = a1-a2;

        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        figure(25)
        if r1== 4 && r2 == 102
           
            plot3( [a1(1) a2(1)] , [a1(2) a2(2)] , [a1(3) a2(3)] , 'b'); hold on
            
        end
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        
        ptn(i,1) = round(dot(a21,n),nd);

    end

end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     
if r1== 4 && r2 == 102
    
    scatter3 ( SIF(r2).mAsp(:,1), SIF(r2).mAsp(:,2), SIF(r2).mAsp(:,3), 'b'); hold on
    
    SIF(r1).miem
    SIF(r2).miem
    ptn
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        


% 2.- EVALUATES IF THEY INTERSECT:
% If so, the projections sign changes at some point

itF = 0 ;
sg1 = 0;

% Detects first sign:

for i = 1:1:N1
    
    sgi = sign(ptn(i));
    if sgi~=0 
        sg1 = sgi;
        break
    end
end


% Checks the rest of the signs:

for j = i+1:1:N1
    
    sgi = sign(ptn(j));
    
    if sgi~=0 && sgi==-sg1
        itF = 1 ;
       	break
    end
end


end

