function [iLR, niL, sLR, nsL, acL, Nis, NLc, NeL] = th1384_attL (connT, connS, npR, THC)

% RETURNS:
% iLR(...,1): inner lines that are attached to the pivot
% acL(...,1): lines of crown, already arranged
% Nis: No. involved sides
% NLc: No. lines of the crown
% NeL: No. lines at edge of crown (may be 0 if internal crown)

pudim = 3 ;


% 1.- LINES OF TETS. ATTACHED TO THE NODE:
 
[iLR, sLR, niL, nsL] = th1389_L2npR (connT, npR);




%%%%%%%%%%%%%%%%%%%%%%  %%%%%%%%%%%%%%%%%%%%%%%
% plots lines attached to npR node:
%{

if npR == 4

    
    figure(npR)
    
    % internals:
    
    xnod = zeros(2,pudim);
    
    for i = 1:1:ni
        
        lR = iLR(i);
        
        for j = 1:1:2
            nR = connT.LV(lR,j);
            xnod(j,:) = THC.Av(nR,:);
        end
        
        plot3(xnod(:,1),xnod(:,2),xnod(:,3),'k','Linewidth',0.1); hold on
    end
    
    
    % surface lines:
    
    stL = 0.1 ;
 	xnod = zeros(3,pudim);
    
    
    for i = 1:1:ns
        
        lR = sLR(i);
        
        for j = 1:1:3
            nR = connT.LV(lR,j);
            xnod(j,:) = THC.Av(nR,:);
        end
        
        x = zeros(1,pudim);
        
        conta = 0 ;
        for w = -1:stL:+1
            
            conta = conta + 1 ;
            [C] = mp1350_1Dmapp (xnod, 3, w, pudim);
            x(conta,:) = C(:,1);
        end
        
        
        plot3(x(:,1),x(:,2),x(:,3),'m', 'Linewidth',2); hold on
    end
    
    axis equal
    
    if hh==3
    end
    
end

%}
%%%%%%%%%%%%%%%%%%%%%%  %%%%%%%%%%%%%%%%%%%%%%%



% 2.- SIDES & Q-LINES OF TETS ATTACHED TO THE NODE:
      
contaL = 0 ;
cL = zeros(1,1);
    
Nis = 0 ;           % No. involved sides
isR = zeros(1,1);   % involved side refs
 

for s = 1:1:size(connS.VS,2)
    
	sR = connS.VS(npR,s); % side reference
    
	if sR > 0
        
        %%%%%%%%%%%%%  %%%%%%%%%%%%  %%%%%%%%%%%%%%
     	% plots ALL sides:
        %{
        
        if npR == 6
                        
            fr = 7 ;
            
            pt1374_pSidConn (sR, connS, THC.Av, fr, 'k', 1, 1.25, 1);
            
            
        end
        
        %}
        %%%%%%%%%%%%%  %%%%%%%%%%%%  %%%%%%%%%%%%%%
        
        if connS.tsF(sR)==1

            Nis = Nis + 1 ;
            isR(Nis,1) = sR ;
  
            
            %%%%%%%%%%%%%  %%%%%%%%%%%%  %%%%%%%%%%%%%%
            % plots Q-sides:
            %{
            
            if npR == 6
                
                fr = 8 ;
                
                pt1374_pSidConn (sR, connS, THC.Av, fr, 'r', 1, 1.25, 1);
                
                if gg==0
                end
                
            end
                
            %}
            %%%%%%%%%%%%%  %%%%%%%%%%%%  %%%%%%%%%%%%%%
            
            
            for i = 1:1:3
                    
                LR = connS.SL(sR,i);
                    
                % considers if LR contains the pivot:
                    
                if connT.LV(LR,1) == npR || connT.LV(LR,3) == npR
                    contaL = contaL + 1 ;
                    cL(contaL,1) = LR ;
                end

            end
        end
	end
        
end
  
% 'crown' of lines (intermediate lines are twice, end lines once)
cL = sortrows(cL,1); 



% 3.- IDENTIFIES END AND INTERMEDIATE LINES IN THE CROWN:
% (intermediate are twice in cL):
    
ecL = zeros(1,1);
icL = zeros(1,1);
NeL = 0 ;
NiL = 0 ;
    
i = 1 ;
while(i<=size(cL,1)-1)
    
    if cL(i)==cL(i+1)
        
        NiL = NiL + 1 ;
        icL(NiL,1) = cL(i);
        i = i + 2 ;
        
    else
            
        NeL = NeL + 1 ;
        ecL(NeL,1) = cL(i); 
    	i = i + 1 ;
        
    end
end





% last line 

if cL(end) ~= cL(end-1) 
    
	NeL = NeL + 1 ;
	ecL(NeL,1) = cL(end);
    
end
   

% 4.- ARRANGES LINES TO BE CONSECUTIVE:

if NeL == 0
        
	% Internal fan:
	LRi = icL(1); % first line assumed the first in icL (arbitrarily)
	cL = icL ; 
        
elseif NeL == 2
        
	% Fan at limit:
 	LRi = ecL(1); % first line  = one of the ends
 	cL = [icL ; ecL ];
        
end
    
NLc = NiL + NeL ;  % total No. lines in the crown
    
acL = zeros(NLc,1); % arranged lines of crown
    
contaL = 1 ;
acL(contaL,1) = LRi ;
      
while ( contaL < NLc )
        
        % Localizes side with LRi:

        srow = 0 ;
            
        for s = 1:1:Nis

            sR = isR(s);

            for i = 1:1:3

                LRc1 = connS.SL(sR,i);

                if LRc1 == LRi
                    srow = s ;
                    break
                end
            end

            if srow > 0
                break
            end
        end
        
        
        % Localizes next line to LRi within s1:

        nxLR = 0 ;

        for i = 1:1:3

            LRc2 = connS.SL(sR,i);

          	if LRc2 ~= LRi

                for j = 1:1:NLc
                    if LRc2==cL(j)
                        nxLR = cL(j);
                        break
                    end
                end
            end

            if nxLR > 0
                break
            end
        end
        

            
        % removes side ref from candidates:
            
        tisR = zeros(size(isR,1)-1,1);
    	j = 0 ;
        for i = 1:1:size(isR,1) 
            if i~=srow 
                j = j+1;
                tisR(j,1) = isR(i,1);
            end
        end
            
        isR = tisR ;
            
            
     	% transfer line ref:
            
        LRi = LRc2 ;
            
       	contaL = contaL + 1 ;
        acL(contaL,1) = LRi;
  
end
        
    
    

end

