function [FAN] = th1385_FAN (connT, THC, NLc, acL, Nis, npR, NeL, Ap, np)


FAN(Nis,1) = struct('At',[], 'Ac', [], 'n', [] ); % triang coords (first the pivot), triang centre, normal (points outwards)

pudim = 3 ;
   

% 1.- A-coords of nodes of crown obtained from derivatives (tangents at pivot):
    
R = 1.5 ;
    
Anod = zeros(3,pudim);
    
Acn = zeros(NLc,pudim); 
    
for i = 1:1:NLc
        
	LR = acL(i);
        
    for j = 1:1:3 
        nR = connT.LV(LR,j);
        Anod(j,:) = THC.Av(nR,:);
    end
        
    if connT.LV(LR,3) == npR  
        [Anod] = GEN_40_invertRowsOrder (Anod);
    end

	[dC] = mp1352_1Dmapp1D (Anod, 3, -1, pudim);
 	dC = R * dC/norm(dC);
        
	Acn(i,:) = Ap(:,1) + dC(:,1);
end
    
% 2.- Sets sense of crown points to be consistent with normal (right hand rule)
    
v1 = zeros(pudim,1);
v2 = zeros(pudim,1);
    
    
% normal of first side of FAN:    
for di = 1:1:pudim
    v1(di,1) = Acn(1,di) - Ap(di,1);
    v2(di,1) = Acn(2,di) - Acn(1,di);
end
n = cross(v1,v2);

  
% compares normals and reverse if required:
    
if dot(n,np) < 0 
    Acn = GEN_40_invertRowsOrder (Acn);
end


% 3.- Sets triangles (consecutively)
    
if NeL==0
    Acn = [Acn ; Acn(1,:) ] ; % for internal crowns the first point = last point
end
    
for t = 1:1:Nis
        
        At = zeros(3,pudim);
        Ac = zeros(pudim,1);
        
        At(1,:) = Ap(:,1);
        
        for i = 1:1:2   
            At(i+1,:) = Acn(t+i-1,:);
        end

        for i = 1:1:3
            for di = 1:1:pudim
                Ac(di,1) = Ac(di,1) + At(i,di)/3;
            end
        end

        v1(:,1) = At(2,:) - At(1,:);
        v2(:,1) = At(3,:) - At(2,:);
        n = cross(v1,v2);
        n = n / norm(n);
        
        FAN(t).At = At ;
        FAN(t).Ac = Ac ;
        FAN(t).n = n ;
end

    

end

