function [ILF] = th1386_ILF (iLR, connT, THC, FAN, Nis, npR, Ap)

pudim = 3 ;
tolL = 1 ;
tolA = 1 ;
nd = 3 ;

NiL = size(iLR,1);
  
% internal lines features:
% tR, angle from correspondent nt, tangent vector

ILF(NiL,2) = struct('tR',0,'nta',0,'tg',[], 'LR', 0);

for i = 1:1:NiL
        
	LR = iLR(i);
        
	% line nodes:
        
    if connT.LV(LR,3)==0
            
        n = 2 ;
        r = [1 2];
        if connT.LV(LR,2)==npR
            r = [2 1];
        end
            
    else
            
        n = 3 ;
     	r = [1 2 3];
      	if connT.LV(LR,2)==npR
            r = [3 2 1];
     	end
    end
        
	Cnod = zeros(n,pudim);
        
    for j = 1:1:n
        nR = connT.LV(LR,r(j));
        Cnod(j,:) = THC.Av(nR,:);
    end
        
	% derivative at pivot and location in FAN space:
        
	xi = -1 ;
	tg = mp1352_1Dmapp1D (Cnod, n, xi, pudim);
             
    Ai = zeros(pudim,1); % A-coord of end-point of tangent of internal line
        
    tg1 = tg/norm(tg);
    
	Ai(:,1) = Ap(:,1) + tg1(:,1);

    
	% detects triangle where it lies:
        
	tR = 0;   
	Tnod = zeros(3,pudim);

    for t = 1:1:Nis
            
        Tnod(:,:) = FAN(t).At(:,:);

        [A,B,C,D] = go2506_Plane3P (Tnod(1,:),Tnod(2,:),Tnod(3,:));
            
        [~, d, Q] = go2534_distPtoPlan (Ai, A, B, C, D);
            
        [IN] = go2546_PinTriang (Tnod, Q, tolL, tolA, nd);
            
        if IN>0
            tR = t;
            break
        end  
    end
        

	% Stores:
        
    if tR > 0
    
        nt = zeros(pudim,1);  
        nt(:,1) = FAN(tR).n(:,1);

        nta = go2511_angleUV (tg,nt);

        ILF(i).tR = tR ;
        ILF(i).nta = nta ;
        ILF(i).tg = tg ;
        ILF(i).LR = LR ;
    
    else
        
        ILF(i).tR = 0 ;
        ILF(i).nta = 180/57.3 ;
        ILF(i).tg = tg ;
        ILF(i).LR = LR ;
        
    end
    
end
        
      


end

