function [uILF, uLR, Nu] = th1387_uILF (FAN, ILF, iLR, angL, Ap, contaK)

% RETURNS:
% ILF updated , with tangents corrected
% uLR(Nu,1): updated lines refs.

uLR = zeros(1,1);
Nu = 0 ;

NiL = size(ILF,1);

uILF = ILF ;

% ILF(NiL,2) = struct( 'tR',0, 'nta',0, 'tg',[] );

% runs though lines to compute amax (if applies)

amax = 0 ; % angle from angL(2) to furthest line-tg (among the lines to amend)

for i = 1:1:NiL
if ILF(i).nta < angL(1)
        
	tR  = ILF(i).tR ;
	nta = ILF(i).nta ;
	tg  = ILF(i).tg ;   
	nt = FAN(tR).n ;
        
    % measures angles from angL(2)
    ai = angL(2) - nta ;     % to current tangent
    
    % stores the maximum angle distance
    if amax < ai
  	amax = ai ;
    end
    
    % stores local line ref
    Nu = Nu + 1 ;
    uLR(Nu,1) = i ;
    
end
end



% amends lines (if required)

if amax > 0
    

    
    Da = angL(2) - angL(1);
    
    for i = 1:1:NiL
    if ILF(i).nta < angL(1)

      	tR  = ILF(i).tR ;
        nta = ILF(i).nta ;
        tg  = ILF(i).tg ;   
        nt = FAN(tR).n ;
        
      	% measures angles from angL(2)
        ai = angL(2) - nta ; % to current tangent
        
        % transforms angle:
        aic = ai * Da/amax ;
        
        % recomputes tangent to have such angle (but keeps the norm!)
        
        ntc = angL(2)-aic ; % angle w.r.t. triangle normal
        
        nv = cross(tg,nt); % normal vector to plane
        
        tgc = go2538_UangV (nt, norm(tg), ntc, nv);
        

        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      	
        % plots
        
        %{
        if contaK == 17
            
            i
            
            nta*57.3
            
            
            ai*57.3
            
            amax*57.3
            Da*57.3
            
            
            aic*57.3
            ntc*57.3
            
            
            
            figure(contaK)

            scatter3( Ap(1),Ap(2),Ap(3), 'k' ); hold on

            quiver3(Ap(1),Ap(2),Ap(3), tg(1),tg(2),tg(3),'b'); hold on

            quiver3(Ap(1),Ap(2),Ap(3), tgc(1),tgc(2),tgc(3),'r'); hold on

            quiver3(Ap(1),Ap(2),Ap(3), nt(1),nt(2),nt(3),'k'); hold on

            axis equal
            
        end
        %}

        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        % reallocates:
        
        uILF(i).nta = ntc;
        uILF(i).tg  = tgc ;
        
    end
    end
  
end


end

