function [THC, Nve,connT, Eiem, NVm] = th1388_midNod ...
    (pR, Spatches, ILF, uLR, Nu, THC, Nve, connT, Eiem, NVm, Ap, contaK)

nd = 4 ;

pudim = 3 ;
xdim = 3 ;

pDegree = Spatches(pR).INS(1).mDegree;
pNcp    = Spatches(pR).INS(1).mNcp;
pKnotV  = Spatches(pR).INS(1).mKnotV;
pP      = Spatches(pR).INS(1).mP;
pw      = Spatches(pR).INS(1).mw;
pUsize  = Spatches(pR).INS(1).mUsize;
pULims  = [0 1 ; 0 1 ; 0 1 ];
pEP     = Spatches(pR).INS(1).mEP;
pEw     = Spatches(pR).INS(1).mEw;
pCD     = [0 0 0 ];
    
for i = 1:1:Nu
    
    lr = uLR(i);
    
    % tangent:
    
    tg = ILF(lr).tg ;
    
    
    % line ref:
    
    LR = ILF(lr).LR ;
    
    
    % end coordinates:
    
    a1 = zeros(pudim,1);
    a2 = zeros(pudim,1); % this is the unknown
    a3 = zeros(pudim,1);
    
    nR1 = connT.LV(LR,1);
    nR3 = connT.LV(LR,2);
    
    a1(:,1) = THC.Av(nR1,:);
    a3(:,1) = THC.Av(nR3,:);
    
    CO = go2542_coincidentP (Ap, a1, pudim, nd);
    
    if CO == 0
        a1(:,1) = THC.Av(nR3,:);
        a3(:,1) = THC.Av(nR1,:);
    end
    
    a2(:,1) = (tg(:,1) + 3/2*a1(:,1) + 1/2*a3(:,1)) / 2 ;
    
    
    a2 = round(a2,nd);
    
    for di = 1:1:pudim
        
        if a2(di) < pULims(di,1) 
            a2(di) = pULims(di,1);
        end
        
        if pULims(di,2) < a2(di) 
            a2(di) = pULims(di,2);
        end
  
    end
    
    
    % updates mesh:
    
    NVm = NVm + 1 ;
    

    
    % THC:
    
    x2 = b2601_BNURBS_Xcoord (a2, pKnotV, pNcp, pDegree, pUsize, pEw, pEP, pudim, xdim);
    
    THC.Av(NVm,:) = a2(:,1);
    THC.Xv(NVm,:) = x2(:,1);
    
    THC.Uv(NVm,:) = [ 0 0 ];
    THC.Bv(NVm,1) = 0;
    
    THC.NCS(NVm,:) = [ 0 0 ];
    THC.ANv(NVm,:) = [ 0 0 0 ];
    
    
    % connT:
    
    connT.LV(LR,3) = connT.LV(LR,2);
    connT.LV(LR,2) = NVm;
  

    % Nve, connT, and Eeim:

    for e = size(connT.LE,2)
        
        eR = connT.LE(LR,e);
        
        if eR > 0

            Nve(eR,1) = Nve(eR,1) + 1 ;
            
            for j = 5:1:10
                if connT.EV(eR,j) == 0
                    connT.EV(eR,j) = NVm ;
                    break
                end
            end
            
            % detects end-nodes local refs:
            
            lnR = zeros(2,1); % local nodes ref
            
            for j = 1:1:4
                
                if connT.EV(eR,j) == nR1
                	lnR(1) = j ;
                elseif connT.EV(eR,j) == nR2
                    lnR(2) = j ;
                end
    
            end
            
            % stores local order of insertion:
            
            for j = 5:1:10
                if connT.EV(eR,j) == NVm
                    lnRj = j ;
                    break
                end
            end
            
            % updates iem:
            
            Eiem(eR,nR1,nR2) = lnRj ;
            Eiem(eR,nR2,nR3) = lnRj ;
            
        end

    end
    
 
end
   
 


end

