function [Spatches] = n1401_CopyINSnoX (Spatches, Npa, insR)

% RETURNS:
% Spatches with next instance to insR with all features non-dependant on
% the physical space.


for pa = 1:1:Npa
    
    % Declaration of new instance:
    
    nINS = cPINS;
    
    
    % Copy independant from Xcoor features:
    
	nINS.mDegree    = Spatches(pa,1).INS(insR,1).mDegree ;
	nINS.mUsize     = Spatches(pa,1).INS(insR,1).mUsize ;
	nINS.mKnotVI    = Spatches(pa,1).INS(insR,1).mKnotVI ;
	nINS.mKnotV     = Spatches(pa,1).INS(insR,1).mKnotV ;
	nINS.mNcp	= Spatches(pa,1).INS(insR,1).mNcp ;
	
	nINS.mEw    = Spatches(pa,1).INS(insR,1).mEw ;
    
	nINS.mw     = Spatches(pa,1).INS(insR,1).mw ;
	nINS.mNacp  = Spatches(pa,1).INS(insR,1).mNacp ;

	nINS.mNon   = Spatches(pa,1).INS(insR,1).mNon ;
	nINS.mCPref = Spatches(pa,1).INS(insR,1).mCPref ;
	nINS.mNicpE = Spatches(pa,1).INS(insR,1).mNicpE ;
    nINS.mRicpE = Spatches(pa,1).INS(insR,1).mRicpE ;

	nINS.mNsk   = Spatches(pa,1).INS(insR,1).mNsk ;
	

    
    % skins:
    
    tskin(nINS.mNsk,1) = cPskin ;
    
    for s = 1:1:nINS.mNsk
        
        tskin(s,1).mNE = Spatches(pa,1).INS(insR,1).skin(s,1).mNE ;
        tskin(s,1).mNV = Spatches(pa,1).INS(insR,1).skin(s,1).mNV ;
        
        tskin(s,1).mTVcon = Spatches(pa,1).INS(insR,1).skin(s,1).mTVcon ;
      	tskin(s,1).mVTcon = Spatches(pa,1).INS(insR,1).skin(s,1).mVTcon ;
        tskin(s,1).mLVcon = Spatches(pa,1).INS(insR,1).skin(s,1).mLVcon ;
        tskin(s,1).mVLcon = Spatches(pa,1).INS(insR,1).skin(s,1).mVLcon ;
        tskin(s,1).mTLcon = Spatches(pa,1).INS(insR,1).skin(s,1).mTLcon ;
        
        tskin(s,1).mNlo = Spatches(pa,1).INS(insR,1).skin(s,1).mNlo ;
        tskin(s,1).mNlv = Spatches(pa,1).INS(insR,1).skin(s,1).mNlv ;
        
        tVP(tskin(s,1).mNV,1) = cVP ;
        
        for v = 1:1:tskin(s,1).mNV
            
            tVP(v,1).mAcoor = Spatches(pa,1).INS(insR,1).skin(s,1).mVP(v,1).mAcoor ;
            
            tVP(v,1).mNicp = Spatches(pa,1).INS(insR,1).skin(s,1).mVP(v,1).mNicp ;
            tVP(v,1).mRicp = Spatches(pa,1).INS(insR,1).skin(s,1).mVP(v,1).mRicp ;
            
            tVP(v,1).Rrel = Spatches(pa,1).INS(insR,1).skin(s,1).mVP(v,1).Rrel ;
            tVP(v,1).dRpa = Spatches(pa,1).INS(insR,1).skin(s,1).mVP(v,1).dRpa ;
            
            tVP(v,1).mD = Spatches(pa,1).INS(insR,1).skin(s,1).mVP(v,1).mD ;
            
        end

        tskin(s,1).mVP = tVP ;
        
        clearvars 'tVP';
    end
    
    nINS.skin   = tskin ; % mXv and stresses updated afterwards
    
    clearvars 'tskins';
    
    % Control points:
    
    nCP(nINS.mNacp,1) = cCpoint;
    
    for c = 1:1:nINS.mNacp
        nCP(c,1).mAcoor = Spatches(pa,1).INS(insR,1).mCP(c,1).mAcoor ;
        nCP(c,1).mw     = Spatches(pa,1).INS(insR,1).mCP(c,1).mw ;
        nCP(c,1).mAcoLi = Spatches(pa,1).INS(insR,1).mCP(c,1).mAcoLi ;
        nCP(c,1).ON     = Spatches(pa,1).INS(insR,1).mCP(c,1).ON ;
        nCP(c,1).mIX    = Spatches(pa,1).INS(insR,1).mCP(c,1).mIX ;
    end
    
    nINS.mCP = nCP ;
    
    
    % Integration mesh:
    
    nIM = cIMesh ;
    
    nIM.mNV  = Spatches(pa,1).INS(insR,1).mIM.mNV ;
    nIM.mNVm = Spatches(pa,1).INS(insR,1).mIM.mNVm ;
    nIM.mNE  = Spatches(pa,1).INS(insR,1).mIM.mNE ;
    nIM.mEVcon = Spatches(pa,1).INS(insR,1).mIM.mEVcon ;
    nIM.mLVcon = Spatches(pa,1).INS(insR,1).mIM.mLVcon ;
    nIM.mELcon = Spatches(pa,1).INS(insR,1).mIM.mELcon ;
    
    nIM.mNve    = Spatches(pa,1).INS(insR,1).mIM.mNve ;
    nIM.mAcoor  = Spatches(pa,1).INS(insR,1).mIM.mAcoor ;
    nIM.mXcoor  = Spatches(pa,1).INS(insR,1).mIM.mXcoor ;
    nIM.iem   	= Spatches(pa,1).INS(insR,1).mIM.iem ;
    nIM.mNgp    = Spatches(pa,1).INS(insR,1).mIM.mNgp ;

    % Gauss points of the integration mesh:
    
    nGP(nIM.mNgp,1) = cGPpa ;
    
    for g = 1:1:nIM.mNgp
        nGP(g,1).mAcoor = Spatches(pa,1).INS(insR,1).mIM.mGP(g,1).mAcoor ;
        nGP(g,1).mNicp =  Spatches(pa,1).INS(insR,1).mIM.mGP(g,1).mNicp ;
        nGP(g,1).mRicp =  Spatches(pa,1).INS(insR,1).mIM.mGP(g,1).mRicp ;
        nGP(g,1).Rrel =  Spatches(pa,1).INS(insR,1).mIM.mGP(g,1).Rrel ;
        nGP(g,1).dRpa =   Spatches(pa,1).INS(insR,1).mIM.mGP(g,1).dRpa ;
        nGP(g,1).dJ2a =   Spatches(pa,1).INS(insR,1).mIM.mGP(g,1).dJ2a ;
        nGP(g,1).mD   =   Spatches(pa,1).INS(insR,1).mIM.mGP(g,1).mD ;
    end
    
    nIM.mGP = nGP;
    nINS.mIM = nIM ;
    
    % allocates to next instance:
    
    Spatches(pa,1).INS(insR+1,1) = nINS;
       

    clearvars 'nINS' 'nCP' 'nIM' 'nGP' ;
    
end


end

