function [Spatches] = n1402_Du2INS (Spatches, Npa, insR, Duacc, xdim)

% RETURNS:
% Spatches with next instance to insR with recomputed features that depend
% on Xcoord's, i.e. Du vector

niR = insR+1;

contaDisp = 0;

for pa = 1:1:Npa
    
    % next patch features:
    
    pudim = Spatches(pa,1).pudim ;

	nKnotV  = Spatches(pa,1).INS(niR,1).mKnotV;
	nNcp    = Spatches(pa,1).INS(niR,1).mNcp;
    nDegree = Spatches(pa,1).INS(niR,1).mDegree;
    nUsize  = Spatches(pa,1).INS(niR,1).mUsize;
    nEw     = Spatches(pa,1).INS(niR,1).mEw;
    nw      = Spatches(pa,1).INS(niR,1).mw;
    
    nNsk  = Spatches(pa,1).INS(niR,1).mNsk;

    
    % Control points Xcoord's:
    
    pCP     = Spatches(pa,1).INS(insR,1).mCP; % prev. CP's
    nCP     = Spatches(pa,1).INS(niR,1).mCP;  % next CP's
    Nacp    = Spatches(pa,1).INS(niR,1).mNacp;
    CPref   = Spatches(pa,1).INS(niR,1).mCPref ;
    
    nP = zeros(Nacp,xdim);
    
    pDu = zeros(Nacp*xdim,1); % vector of CP-displacements for this patch
    
    for c = 1:1:Nacp
        
        if CPref(c)>0

            for di = 1:1:xdim

                contaDisp = contaDisp + 1;
                pDu(c*xdim-3+di,1) = Duacc(contaDisp,1);
                
                nCP(c,1).mXcoor(di) = pCP(c,1).mXcoor(di) + Duacc(contaDisp,1);
                nP(c,di) = nCP(c,1).mXcoor(di);

            end

        end
    end
    

    [~,nEP] = GEN_12_ExpandBw (nw, nP,xdim, pudim, nNcp);
    

    
    Spatches(pa,1).INS(niR,1).mCP = nCP ;
    
    Spatches(pa,1).INS(niR,1).mP  = nP  ;
    Spatches(pa,1).INS(niR,1).mEP = nEP ;
    

    % GP's integration mesh: Vertexes and GP Xcoor
    
    NVm = Spatches(pa,1).INS(niR,1).mIM.mNVm;
    
    Acoor = zeros(pudim,1);
    nXcoor = zeros(NVm,xdim);
    
    for v = 1:1:NVm  
        
        Acoor(:,1) = Spatches(pa,1).INS(niR,1).mIM.mAcoor(v,:);
        X = b2601_BNURBS_Xcoord (Acoor, nKnotV, nNcp,nDegree,nUsize, nEw,nEP, pudim,xdim);
        nXcoor(v,:) = X(:,1);
        
    end
    
    Spatches(pa,1).INS(niR,1).mIM.mXcoor = nXcoor ;
    
    
    Ngp = Spatches(pa,1).INS(niR,1).mIM.mNgp ;
    
    for g = 1:1:Ngp
        
        Acoor = Spatches(pa,1).INS(niR,1).mIM.mGP(g,:).mAcoor;
        X = b2601_BNURBS_Xcoord (Acoor, nKnotV, nNcp,nDegree,nUsize, nEw,nEP, pudim,xdim);
        Spatches(pa,1).INS(niR,1).mIM. mGP(g,1).mXcoor = X ;
        
    end
    
    clearvars 'nCP' 'Ngp' ;

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %{
	pEP = Spatches(pa,1).INS(1,1).mEP;
    DP = nEP-pEP ;

    
    pKnotV  = Spatches(pa,1).INS(1,1).mKnotV;
    pNcp    = Spatches(pa,1).INS(1,1).mNcp;
    pDegree = Spatches(pa,1).INS(1,1).mDegree;
    pUsize  = Spatches(pa,1).INS(1,1).mUsize;
    pEw     = Spatches(pa,1).INS(1,1).mEw;


    DK = pKnotV - nKnotV ;
    DN = pNcp - nNcp ;
    Dd = pDegree - nDegree ;
    Du = pUsize - nUsize ;
    Dw = pEw - nEw ;


    %}
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    % skins updated vertexes: 

    for s = 1:1:nNsk
        
        %tskin = cPskin;
        
        tskin = Spatches(pa,1).INS(niR,1).skin(s,1) ;
        
        NV = tskin.mNV;
        
        for v = 1:1:NV
        
            tVP = tskin.mVP(v,1);
            
            Acoor = tVP.mAcoor;

            %{
            figure(88)
            
            scatter3(Acoor(1),Acoor(2),Acoor(3),'r'); hold on

            axis equal
            %}
            
            X = b2601_BNURBS_Xcoord (Acoor, nKnotV, nNcp, nDegree, nUsize, nEw, nEP, pudim,xdim);

            %Xp = b2601_BNURBS_Xcoord (Acoor, pKnotV, pNcp, pDegree, pUsize, pEw, pEP, pudim,xdim);
            
            tVP.mXcoor = X ;
            
            
            %{
            if s==1

                figure(89)

                    scatter3(X(1),X(2),X(3),'k'); hold on

                    % Xp = Spatches(pa,1).INS(1,1).skin(s,1).mVP(v,1).mXcoor ;
                    % Ap = Spatches(pa,1).INS(1,1).skin(s,1).mVP(v,1).mAcoor ;
                    
                    scatter3(Xp(1),Xp(2),Xp(3),'r'); hold on

                    if v==27
                        
                        pKnotV
                        nKnotV
                        
                        pNcp
                        nNcp
                        
                        pDegree
                        nDegree
                        
                        pUsize
                        nUsize
                        
                        nEw
                        pEw
                        
                        nEP
                        pEP
                        
                       X
                       Xp
                    end
                    
                axis equal
                
            end
            %}
            
            tskin.mVP(v,1) = tVP;
            
            clearvars 'tVP';
             
        end
        
        Spatches(pa,1).INS(niR,1).skin(s,1) = tskin ;
        clearvars 'tskin';
    end

end


% GP's physical derivatives and jacobian 1 for GP's and VP's:
    
[Spatches] = c0915_XbfGP (Spatches, Npa, niR, xdim);
[Spatches] = c0918_XbfVP (Spatches, Npa, niR, xdim);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%{
figure(33)

s = 1 ;

ir = 1 ;

NV = Spatches(1,1).INS(ir,1).skin(s,1).mNV ;
VP = Spatches(1,1).INS(ir,1).skin(s,1).mVP ;

P = Spatches(1,1).INS(ir,1).mP ;
scatter3(P(:,1), P(:,2), P(:,3), 'k'); hold on

pw = Spatches(1,1).INS(1,1).mw ;
nw = Spatches(1,1).INS(2,1).mw ;

pw
nw

for v = 1:1:NV  
    Xp = VP(v,1).mAcoor ;
    %scatter3( Xp(1), Xp(2),  Xp(3), 'r'); hold on 
end

axis equal
%}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



end




