function [Bentities] = n1411_CbeINSnoX (Bentities, Nbe, insR)

% RETURNS:
% Bentities with next instance to insR with all features non-dependant on
% the physical space.


for b = 1:1:Nbe
    
    nINS = cBINS;
    tskin = cBskin;
    
    
    % Copy independant from Xcoor features of skin:

	tskin.mDegree   = Bentities(b,1).INS(insR,1).skin.mDegree ;
	tskin.mUsize 	= Bentities(b,1).INS(insR,1).skin.mUsize ;
	tskin.mKnotV 	= Bentities(b,1).INS(insR,1).skin.mKnotV ;
	tskin.mNcp      = Bentities(b,1).INS(insR,1).skin.mNcp ;
	tskin.mw        = Bentities(b,1).INS(insR,1).skin.mw ;
    tskin.mPN = Bentities(b,1).INS(insR,1).skin.mPN ;   
    
    tskin.mNE = Bentities(b,1).INS(insR,1).skin.mNE ;
	tskin.mNV = Bentities(b,1).INS(insR,1).skin.mNV ;

	tskin.mTVcon = Bentities(b,1).INS(insR,1).skin.mTVcon ;
	tskin.mVTcon = Bentities(b,1).INS(insR,1).skin.mVTcon ;
	tskin.mLVcon = Bentities(b,1).INS(insR,1).skin.mLVcon ;
	tskin.mVLcon = Bentities(b,1).INS(insR,1).skin.mVLcon ;
  	tskin.mTLcon = Bentities(b,1).INS(insR,1).skin.mTLcon ;
        
	tskin.mNlo = Bentities(b,1).INS(insR,1).skin.mNlo ;
    tskin.mNCL = Bentities(b,1).INS(insR,1).skin.mNCL ;
 	tskin.mNlv = Bentities(b,1).INS(insR,1).skin.mNlv ;
    tskin.mNlcv = Bentities(b,1).INS(insR,1).skin.mNlcv ;  
    
    tskin.mAv  = Bentities(b,1).INS(insR,1).skin.mAv ;
 	tskin.mAvS = Bentities(b,1).INS(insR,1).skin.mAvS ;
    tskin.mUv  = Bentities(b,1).INS(insR,1).skin.mUv ;

    tskin.mNgp  = Bentities(b,1).INS(insR,1).skin.mNgp ;

    % Gauss points of the skin:
    
    Ngp = Bentities(b,1).INS(insR,1).skin.mNgp ;
    tGP(Ngp,1) = cGPbe ;
    
    for g = 1:1:Ngp
        
        tGP(g,1).mAcoor = Bentities(b,1).INS(insR,1).skin.mGP(g,1).mAcoor ;
        tGP(g,1).mUcoor = Bentities(b,1).INS(insR,1).skin.mGP(g,1).mUcoor ;
        tGP(g,1).mNicp  = Bentities(b,1).INS(insR,1).skin.mGP(g,1).mNicp ;
        tGP(g,1).mRicp  = Bentities(b,1).INS(insR,1).skin.mGP(g,1).mRicp ;
        tGP(g,1).Rrel   = Bentities(b,1).INS(insR,1).skin.mGP(g,1).Rrel ;
        tGP(g,1).dJ2a   = Bentities(b,1).INS(insR,1).skin.mGP(g,1).dJ2a ;
        
        tGP(g,1).mAcoorS = Bentities(b,1).INS(insR,1).skin.mGP(g,1).mAcoorS ;
        tGP(g,1).mNicpS = Bentities(b,1).INS(insR,1).skin.mGP(g,1).mNicpS ;
        tGP(g,1).mRicpS = Bentities(b,1).INS(insR,1).skin.mGP(g,1).mRicpS ;
        tGP(g,1).RrelS  = Bentities(b,1).INS(insR,1).skin.mGP(g,1).RrelS ;
    end
    
    tskin.mGP = tGP ;

    % BC values and allocates:  
    % (mXv updated afterwards)
    
    nINS.mt = Bentities(b,1).INS(insR,1).mt;
    nINS.md = Bentities(b,1).INS(insR,1).md;
    
    nINS.skin = tskin ; 
    

    
    % allocates to next instance:
    
    Bentities(b,1).INS(insR+1,1) = nINS;

    clearvars 'nINS' 'tskin'  'tGP' ;
    
   
end


end

