function [P,w,p,n,U] = sx1501_edgeCurve (rdi, pp, pNcp, pDegree, pKnotV, pUsize, pEP, pEw, pxdim)

% Extracts edge-curve NURBS features from solid

% INPUTS:
% rdi: relevant direction
% pp(2,1): postiion of the curve in the perp. direct's to rdi, e.g. 1 or pNcp(pdir)
% pNcp, pDegree, pKnotV, pUsize: solid patch NURBS features

% control points coord's:
    
P = zeros(pNcp(rdi),pxdim);
w = zeros(pNcp(rdi),1);

if rdi == 1
    
    for i = 1:1:pNcp(rdi)
        
        P(i,:) = pEP(i,pp(1),pp(2),:);
        w(i,1) = pEw(i,pp(1),pp(2));
    end
    
elseif rdi == 2
    
    for j = 1:1:pNcp(rdi)
        
        P(j,:) = pEP(pp(1),j,pp(2),:);
        w(j,1) = pEw(pp(1),j,pp(2));
    end
    
elseif rdi == 3
    
    for k = 1:1:pNcp(rdi)
        
        P(k,:) = pEP(pp(1),pp(2),k,:);
        w(k,1) = pEw(pp(1),pp(2),k);
    end
end


% other features:

p = pDegree(rdi);
n = pNcp(rdi);
U = pKnotV(rdi,1:pUsize(rdi));

end

