function [sP, sw, sEP, sEw, sDegree, sNcp, sKnotV, sUsize] = sx1502_Surface (rdi, pp, pNcp, pDegree, pKnotV, pUsize, pEP, pEw, pxdim)

% Extracts edge-curve NURBS features from solid

% INPUTS:
% rdi: relevant direction (perp. to surface)
% pp: position of the surface : 1 or pNcp(rdi)
% pNcp, pDegree, pKnotV, pUsize: solid patch NURBS features

% surface directions to copy for each rdi:

sdi = [ 2 3 ; 1 3 ; 1 2 ];

% other features:

sDegree = zeros(2,1);
sNcp = zeros(2,1);
sUsize = zeros(2,1);
sKnotV = zeros(2,2);

for di = 1:1:2
    
    d = sdi(rdi,di) ;
    
    sDegree(di,1) = pDegree(d);
    sNcp(di,1) = pNcp(d);
    sUsize(di,1) = pUsize(d);
    
    for i = 1:1:pUsize(d)
        sKnotV(di,i) = pKnotV(d,i);
    end
end


% control points coord's:

d1 = sdi(rdi,1);
d2 = sdi(rdi,2);

sEP = zeros( pNcp(d1), pNcp(d2), pxdim);
sEw = zeros( pNcp(d1), pNcp(d2));

if rdi == 1
    
    for i = 1:1:pNcp(d1)
    for j = 1:1:pNcp(d2)

        sEP(i,j,:) = pEP(pp,i,j,:);
        sEw(i,j,:) = pEw(pp,i,j,:);

    end
    end 
    
elseif rdi == 2
    
    for i = 1:1:pNcp(d1)
    for j = 1:1:pNcp(d2)

        sEP(i,j,:) = pEP(i,pp,j,:);
        sEw(i,j,:) = pEw(i,pp,j,:);

    end
    end 
    
elseif rdi == 3
    
    for i = 1:1:pNcp(d1)
    for j = 1:1:pNcp(d2)

        sEP(i,j,:) = pEP(i,j,pp,:);
        sEw(i,j,:) = pEw(i,j,pp,:);

    end
    end 
end


[sw,sP] = GEN_12_ContractsBw (sEw, sEP, pxdim, 2, sNcp);

end