function [eMLT, slF] = ts1603_insertMLT (contaL, eTHC, Spatches, pR, mLR, MLT, pL)

% RETURNS:
% eMLT:  with new node (eTHC) inserted
% slF: 'small line flag' = 1 if new line is smaller than trehshold distance

pudim = 3 ;

% INPUTS:

% 1.- EXTRACTS ARRAYS:
% (facilitates coding, NOT SURE ABOUT THIS "SIMPLIFICATION")

tNE = MLT.tNE ;
tNV = MLT.tNV ;
tNL = MLT.tNL ;

tTVcon = MLT.tTVcon ;
tLVcon = MLT.tLVcon ;
tVLcon = MLT.tVLcon ;
tTLcon = MLT.tTLcon ;
tVTcon = MLT.tVTcon ;
tLTcon = MLT.tLTcon ;

tBv  = MLT.tBv ;
tUv  = MLT.tUv ;
tAv  = MLT.tAv ;
tXv  = MLT.tXv ;

tANv = MLT.tANv ;
tXNv = MLT.tXNv ;
tANe = MLT.tANe ;
tXNe = MLT.tXNe ;
tNCS = MLT.tNCS ;

tAtetIN = MLT.tAtetIN ;
tAtetOU = MLT.tAtetOU ;
tXtetIN = MLT.tXtetIN ;
tDtet   = MLT.tDtet ;


% 2.- DETECTS TRIANGLES and COMMON-LINES WHERE THE NEW NODE LIES IN:

% Na: No. affected triangles (1 or 2)
% ate(1,2): MLT triangles ref (the latter may be 0 if is interior)
% mLR:  MLT line ref in case there is a line to split

ate = zeros(1,1);

Na = 1 ;

ate(1,1) = tLTcon(mLR,1);

if tLTcon(mLR,2) > 0
    Na = 2 ;
    ate = [ tLTcon(mLR,1) tLTcon(mLR,2) ];
    %ate(1,2) = tLTcon(mLR,2);
end




% 3.- DETECTS IF IT IS SMALL LINE:

% 3.1.- bave = average length of triangles edges & threshold lenght:

[Nl, lR] = GEN_29_SelAtt (ate', tTLcon);

bave = 0 ;
for l = 1:1:Nl
    b = tm1315_egdeLcon (tLVcon, lR(l), 0, tAv);
    bave = bave + b/Nl;
end

tL = bave * pL/100; % threshold length


% 3.2.- 'Length of edges after split':

Les = zeros(2,1);

a = zeros(pudim,1);

for k = 1:1:2
    nR = tLVcon(mLR,k);
    a(:,1) = tAv(nR,:);
    Les(k,1) = norm(a-eTHC.Av);
end


% 3.3.- Checks:

if min(Les) < tL  
    slF = 1;
else
    slF = 0;
end



% 4.- CHARACTERIZATION OF INSERTION:

[inr, itr, ilr, Nti, Nni, Nnli, DNE, DNV, DNL] = um0662_ChrtIns (Na, ate, mLR, tNE, tNV, tNL, tTVcon);




% 5.- UPDATES COORDINATES AND NUMBERS:
    
[nr, tNE, tNV, tNL, tBv, tUv, tAv, tXv, tNCS] = um0664_uCoords ...
    (tNE, tNV, tNL, tBv, tUv, tAv, tXv, tNCS, DNE, DNV, DNL, eTHC);


% 6.- CONNECTIVITY MATRICES:

[tTVcon, tLVcon, tVLcon, tTLcon, tVTcon, tLTcon] = um0665_uConn ...
(tTVcon, tLVcon, tVLcon, tTLcon, tVTcon, tLTcon, tNE, tNL, Nni, inr, Nti, itr, Nnli, ilr, Na, ate, mLR, nr, DNE, DNL);


% 7.- VECTORS:
[tANv, tANe, tXNv, tXNe] = um0631_upNvects (tANv, tANe, tXNv, tXNe, tTVcon, tAv, tXv, Nti, itr);


% 8.- OPTIMAL TETS NODES: I think they are not used, but we need to have
% them coz Dtet will be called in the removal of outside tets

[tAtetIN, tAtetOU, tXtetIN, tDtet] = um0666_uOtets ...
(tAtetIN, tAtetOU, tXtetIN, tDtet, DNE, tNE, Na, ate, Spatches, pR, tTVcon, tAv);


% 9.- ALLOCATES:

eMLT = struct('tNE',0, 'tNV',0, 'tNL', 0 , ...
            'tTVcon', [], 'tLVcon',[], 'tVLcon',[], 'tTLcon',[], 'tVTcon',[], 'tLTcon',[], ...
            'tBv',[], 'tUv',[], 'tAv',[], 'tXv',[], 'tANv',[], 'tANe',[], 'tXNv',[], 'tXNe',[], 'tNCS',[], ...
            'tDtet', [], 'tAtetIN', [], 'tAtetOU', [], 'tXtetIN', []);
        
eMLT.tNE = tNE;
eMLT.tNV = tNV;
eMLT.tNL = tNL;

eMLT.tTVcon = tTVcon;
eMLT.tLVcon = tLVcon;
eMLT.tVLcon = tVLcon;
eMLT.tTLcon = tTLcon;
eMLT.tVTcon = tVTcon;
eMLT.tLTcon = tLTcon;

eMLT.tBv = tBv;
eMLT.tUv = tUv;
eMLT.tAv = tAv;
eMLT.tXv = tXv;

eMLT.tANv = tANv;
eMLT.tXNv = tXNv;
eMLT.tANe = tANe;
eMLT.tXNe = tXNe;
eMLT.tNCS = tNCS ;

eMLT.tAtetIN = tAtetIN ;
eMLT.tAtetOU = tAtetOU  ;
eMLT.tXtetIN = tXtetIN;
eMLT.tDtet = tDtet;





end

