function [mpS] = ts1604_mpState (contaL, THC, pNE, connT, connS, nd)

% RETURNS:
% mpS: [ 1:     intermediate points state, 
%        2:     element where it lies
%        3,4:   local ref of side or edge affected if applies

% INPUTS:
% THC(NV,3): coords including last node taht is the candidate to stay

% Selects option that leads to the most regular tets, for example:
% if lies too close to an edge, assumes it is at the edge

pudim = 3 ;

Av = THC.Av ;
nnR = size(Av,1) ;  % new node ref (recall that THC was already extended)
eAv = zeros(pudim,1);
eAv(:,1) = Av(nnR,:); % candidate node coords

Anod = zeros(4,pudim);

mpS = [ 1 0 0 0 ] ;


% 1.- FINDS ELEMENT WHERE new point LIES IN (OR CLOSER TO):


% 1.1.- Finds closest node ref.:

oNn = size(THC.Xv,1)-1;

cnm = zeros(oNn,2); % node ref and distance to eAv

for k = 1:1:oNn
    
    d = norm(THC.Av(k,:) - THC.Av(oNn+1,:)) ;
    
    cnm(k,1) = k ;
    cnm(k,2) = d ;

end

cnm = sortrows(cnm,2);


% 1.2.- Assesses the elements of closest three nodes:

meR = 0 ;

cnR = cnm(1,1); % initially cnR is the closest unless finds other with tets that have eAv inside its tets.

for i = 1:1:3

    r = cnm(i,1);
    
    for e = 1:1:size(connT.VE,2)

        eR = connT.VE(r,e);

        if eR > 0

            % tet coords:
            for k = 1:1:4 
                nR = connT.EV(eR,k);
                Anod(k,:) = Av(nR,:);
            end

            % evaluates:
            [IN,~,~,~,~] = go2539_PinTet (Anod, eAv, 3*nd);

            if IN > 0
                meR = eR ; % stores in 'main element ref'
                cnR = r ; % stores closest node
                break
            end

        end
    end

    if meR > 0
        break
    end
    
end

% 1.3.- IF lies outside =>
%                       => meR = 0 ;


%{

NE = size(connT.EV,1);

for e = 1:1:NE
    
    % tet coords:
    for k = 1:1:4 
        nR = connT.EV(e,k);
        Anod(k,:) = Av(nR,:);
    end

    % evaluates:
    [IN,~,~,~,~] = go2539_PinTet (Anod, eAv, 3*nd);
    
    if IN > 0
        meR = e ; % stores in 'main element ref'
        break
    end
end
%}





% 2.- CHECKS MOVING TETS NODE TO eA:

% NOT USED 

%{
% Checks first if any vertex is too close to the new point
% If so => moves the tet node to coincide with the new node.
% Compares distance to closest node with threshold distance.
% Threhold distance is a percentaje of average tet edge distance.
    
pL = 35 ; % pecentaje of average edge

[mtF, cnR] = mt1691_chkTnod (eAv, meR, Anod, pL, connT, THC);

if mtF == 1
    mpS = [ 4 meR cnR 0 ] ;
    return 
end
%}


    
% 3.- IF MOVING TET NODE DOES NOT OCCUR, FINDS THE BEST ALTERNATIVE:
% INSIDE, ON SIDE, OR ON EDGE
    
% Evaluates among: inside tet., closer side of tet. and closer edge of tet.:
    
seR = zeros(2,1);
        
[mpS, meR] = ts1605_optState (contaL, cnR, meR, THC, pNE, connT, connS, nnR);

IN = mpS(1);
seR(1) = mpS(3);
seR(2) = mpS(4);
        

if IN == 1
       
	% inside:
	mpS = [ IN meR 0 0 ] ;

elseif IN == 2
         
	% side of  tet:
  	mpS = [ IN meR seR(1) 0 ] ;

elseif IN == 3

	% edge of tet:
	mpS = [ IN meR seR(1) seR(2)];
        
end



end

