function [MLT, THC, pNE, connT, tp, teR1, teR2] = ts1610_integrInTets ...
         (contaL, Spatches, pR, rTskin, agCurv, ILn, mLR, Nte, teR1, pNE, connT, connS, THC, isi, MLT, pL, Xtol, DUtol, tolL, tolA, nd)

% RETURNS:
% MLT and tets uptaded to integrate the MLT missing line
% slF = 1   if one of the new MLT-lines (at least) resulting from node
%           insertion in MLT is small => MLT might be reverse and tets merged 

oconnT = connT ;
tp = "0" ;

% 1.- CHECK FLIPPING & COMMON EDGE INTERSECT:
% Checks if the missing line from MLT trims any tets edge line.

[pNE, connT, MLT, THC, fpF, teR2] = ei1640_flipLine ...
(contaL, teR1, pNE, connT, MLT, THC, connS, ILn, mLR, isi, tolL, nd);

if fpF == 1 
    tp = "flip line" ;
    return
end



% 2.- LINE WITHIN TETS: 
% (initially, coz when intermediate points are re-located may lie at edge, side or outside)

tolP = 0.5 ;

if Nte == 2

    % 2.2.- Single side involved: flip 2=>3 unless partition in Edge is so close:

    [pNE, connT, MLT, THC, teR2, tp] = ts1612_flip23 ...
	(THC, ILn, pNE, connT, connS, MLT, isi, teR1);

    if tp == "flip 2 => 3"
        return
    end

end
    

% 2.3.- More sides involved: tries to insert in one of the edges.
% If not, just inserts and divides.

% Finds N for U0, such that insertion is as close as possible to isi common line:
    
[MLT, THC, pNE, connT, tp, teR2] = tn3600_EdgeSplit ...
(contaL, teR1, isi, ILn, mLR, THC, connS, connT, Spatches, pR, rTskin, agCurv, MLT, Xtol, DUtol, tolP, pL);
    
if tp == "split edge"
	return
end

%[N, clR] = ts1601b_FindsN (isi, ILn, connS, connT, THC);

    
% Projects to MLT: computes the candidate node at U0 (that is given by N):
    
N = [0.5 0.5];
    
[mn, B0, U0, A0, csM] = ts1615_info2projN (rTskin, ILn, THC, N); % data required for projection
    
[eTHC] = ts1614_inU0 (contaL, Spatches, pR, rTskin, agCurv, csM, MLT, B0, U0, A0, Xtol, DUtol);
   

%{
if contaL == 9
    
    fr = 9 ;
    for e = 1:1:size(teR1,2)

        eR = teR1(e);
        pt1373_pTetConn (eR, connT, THC.Av, fr, 'g', 0.95, 1.25, 0, 0);

    end
    
end
%}


% Updates tets:
[THC, pNE, connT, meR, teR1, teR2, mpS] = ts1613_inNodTET ...
(contaL, eTHC, pNE, connT, connS, THC, tolL, tolA, nd);


% Inserts the node on MLT:
[MLT,~] = ts1603_insertMLT (contaL, eTHC, Spatches, pR, mLR, MLT, pL);

    
% Updates the rest of conn matrices
pNV = size(THC.Av,1); 
[connT] = th1333_oConnL (pNE, pNV, connT.EV);

tp = "others" ;
    



%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% involved tets:
%{
if contaL == 13 

    mpS
    
    % before:
    
    fr = 80 ;
    
    for e = 1:1:size(teR1,1)
        eR = teR1(e);
        pt1373_pTetConn (eR, oconnT, THC.Av, fr, 'k', 1, 0.55, 0, 0);
    end
    
    scatter3 ( eTHC.Av(1),  eTHC.Av(2), eTHC.Av(3),'r'); hold on
    
    % after:
    
    fr = 90 ;
    for e = 1:1:size(teR2,1)
        eR = teR2(e);
        pt1373_pTetConn (eR, connT, THC.Av, fr, 'k', 1, 0.55, 0, 0);
    end
    
    pt1375_pLinConn (mLR, MLT.tLVcon, MLT.tAv, fr, 'r', 0.33, 4.2, 0);
    %pt1375_pLinConn (MLT.tNL, MLT.tLVcon, MLT.tAv, fr, 'r', 0.33, 4.2, 0);
    
    if gg==0 % algo falla, inserta en el edge incorrecto , creo
    end
end
%}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




end

