function [eTHC] = ts1614_inU0 (contaL, Spatches, pR, rTskin, agCurv, csM, MLT, B0, U0, A0, Xtol, DUtol)

% RETURNS: coords of insrted node at U0 (or B0) location in MLT surface

cudim = 1 ;
sudim = 2 ;
pudim = 3 ;
xdim  = 3 ;

eTHC = struct...
('Xv',[], 'Av',[], 'Uv',[], 'Bv',[], 'NCS',[], 'rm', 0 );

pDegree = Spatches(pR).INS(1).mDegree;
pNcp    = Spatches(pR).INS(1).mNcp;
pKnotV  = Spatches(pR).INS(1).mKnotV;
pP      = Spatches(pR).INS(1).mP;
pw      = Spatches(pR).INS(1).mw;
pUsize  = Spatches(pR).INS(1).mUsize;
pULims  = [0 1 ; 0 1 ; 0 1 ];
pEP     = Spatches(pR).INS(1).mEP;
pEw     = Spatches(pR).INS(1).mEw;
pCD     = [0 0 0 ];

sR = csM(2);

sDegree = rTskin(sR).mDegree;
sNcp    = rTskin(sR).mNcp;
sKnotV  = rTskin(sR).mKnotV;
sP      = rTskin(sR).mP;
sw      = rTskin(sR).mw;
sUsize  = rTskin(sR).mUsize;
sCD     = rTskin(sR).mCS;
[sEw,sEP] = GEN_12_ExpandBw (sw, sP, xdim, sudim, sNcp);
sULims  = [ 0 1 ; 0 1 ];

if csM(1) > 0 

	% 1.1.- Belongs to a contour curve 'cR'
   
	cR  = csM(1);

	cDegree = agCurv(cR).Degree;
	cNcp    = agCurv(cR).Ncp;
 	cKnotV  = agCurv(cR).KnotV;
  	cP      = agCurv(cR).P;
  	cw      = agCurv(cR).w;
    cUsize  = agCurv(cR).Usize;

    eTHC.Bv = B0;
    
    X = b2601_BNURBS_Xcoord (eTHC.Bv , cKnotV, cNcp, cDegree, cUsize, cw, cP, cudim, xdim);
    eTHC.Xv = X ;
    
    [U, ~] = s2835b_onePoint (X, U0', sDegree, sNcp, sKnotV, sUsize, sP ,sw, sEP ,sEw, sCD, sULims, xdim, Xtol, DUtol);
 	eTHC.Uv = U';
    
    [A, ~] = v2865b_onePoint (X, A0', pDegree, pNcp, pKnotV, pUsize, pP ,pw, pEP ,pEw, pCD, pULims, xdim, Xtol, DUtol);
   	eTHC.Av = A';
        
elseif csM(2) > 0 
        
	% 1.2.- Belongs to a trimming surface 'sR':

    eTHC.Bv = 0 ; % remains = 0

    eTHC.Uv = U0;
    
   	X = b2601_BNURBS_Xcoord (eTHC.Uv , sKnotV, sNcp, sDegree, sUsize, sEw, sEP, sudim, xdim);
    eTHC.Xv = X ;
    
    [A, ~] = v2865b_onePoint (X, A0', pDegree, pNcp, pKnotV, pUsize, pP ,pw, pEP ,pEw, pCD, pULims, xdim, Xtol, DUtol);
   	eTHC.Av = A';

end
   
eTHC.NCS = [csM(1) csM(2)];


eTHC.rm = MLT.tNV + 1 ;


end

