function [NE, connT, aeR2, meF] = mp1630_closeIP (contaSL, aeR1, tLR, NE, connT, THC, A0, mTR, MLT, pL, nd)

% RETURNS:
% NE, connT updated
% aeR2: affected tets by the insertion
% meF = 1 if merging happens

pudim = 3 ;
aeR2 = aeR1 ; 
meF = 0 ;
oconnT = connT ;

% 1.- CHECKS CONDITIONS FOR MERGING TO THE CLOSEST POINT:

% 1.1.- Computes threshold distance of the triangle and distance to each node:

[td, dn] = mp1631_d2nods (MLT, A0, mTR, pL);


if dn(1,1) > td 
    return % STOPS if intersection A0 is too far from mTR nodes
end

% 1.2.- Stores affected nodes of the tet:

cnR = dn(1,2); % closest node ref of MLT

[anR, inR, pnR] = mp1632_invNods (cnR, THC, connT, tLR, aeR1);

if pnR ==0
    return % STOPS unless one of the inR = cnR MLT node => pivot node
end


% 2.- REMOVES TETS IN CASE OF:

% - A0 IS CLOSE ENOUGH cnR AND 
% - cnR COINCIDES WITH ONE OF THE AFFECTED TETS NODES:

% Elems with pnR and anR nodes are to be removed

% 2.1.- Ring nodes:

[rnR] = mp1633_ringNods (connT, aeR1, pnR, inR, anR);


% 2.2.- Elements to remove:

reR = zeros(1,1);
Ner = 0 ;

for e = 1:1:size(aeR1,1)
    
    r = aeR1(e,1);
    
    conta = 0 ;
    for i = 1:1:4
       
        nR = connT.EV(r,i);
        if nR == pnR || (nR == anR(1) || nR == anR(2))
            conta = conta + 1 ;
        end
    end
    
    if conta == 3
        Ner = Ner + 1 ;
        reR(Ner,1) = r;
    end
end


% 2.3.- No. elements to keep and final No. elements:

Ne1 = size(aeR1,1);
Nek = (Ne1-Ner);
Ne2 = Nek * 2 ;

% 2.4.- Final elems refs and new size of EVcon:

aeR1 = sortrows(aeR1,1);

if Ne2 <= Ne1
    
    aeR2 = aeR1(1:Ne2,:);
    
    EVcon = connT.EV;
    
    for i = 1:1:Ne1-Ne2
    
        r = aeR1(Ne2+i);
        
        NEt = size(EVcon,1);
        
        if r == NEt 
            EVcon = EVcon(1:NEt-1,:);
        else
            EVcon = [ EVcon(1:r-1,:) ; EVcon(r+1:NEt,:) ];
        end

    end
    
else
    
    De = Ne2 - Ne1;
    aeR2 = [ aeR1 ; [NE+1:1:NE+De]' ];
    
    EVcon = [connT.EV ; zeros(De,4) ] ;
    
end


%{
% Points to elements to modify/add:

Ne = size(aeR1,1)-2;
De = Ne-2; % increment of elements (to add to NE)

aeR2 = [aeR1 ; [NE+1:1:NE+De] ];
NE = NE + De ;
%}


% 2.2.- Updates connT.EV:

for e = 1:1:Ne2/2
    

    eR1 = aeR2(e,1);
    eR2 = aeR2(e + Ne2/2,1);

    EVcon(eR1,1) = pnR ;
    EVcon(eR1,2) = anR(1) ;
    EVcon(eR1,3) = rnR(e+0) ;
    EVcon(eR1,4) = rnR(e+1) ;
    
 	EVcon(eR2,1) = pnR ;
    EVcon(eR2,2) = anR(2) ;
    EVcon(eR2,3) = rnR(e+0) ;
    EVcon(eR2,4) = rnR(e+1) ;
    
end


NE = size(EVcon,1);

connT.EV = EVcon;

meF = 1 ;


% REPRESENTS (just for checking):

%{


fr = contaSL ;
for e = 1:1:size(aeR1,1)
    
    pt1373_pTetConn (aeR1(e), oconnT, THC.Av, fr, 'k', 1, 0.55, 1, 0);
    
end

pt1375_pLinConn (tLR, connT.LV, THC.Av, fr, 'r', 1, 1, 0);

figure(fr)
scatter3(A0(1),A0(2),A0(3),'r'); hold on


fr = 100+contaSL ;
for e = 1:1:size(aeR2,1)
    
    pt1373_pTetConn (aeR2(e), connT, THC.Av, fr, 'k', 1, 0.55, 1, 0);
    
end

%}





end

