function [td, dn] = mp1631_d2nods (MLT, A0, TR, pL)

% RETURNS:
% td: threshold distance
% dn(3,2): distance and nod ref (arranged from closet to furthest)

pudim = 3 ;

dn = zeros(3,2); % distance and MLT node ref:

r = [ 1 2 3 1 ];

a1 = zeros(pudim,1);
a2 = zeros(pudim,1);

L = 0 ;

for i = 1:1:3
    
    n1 = MLT.tTVcon(TR,r(i));
    n2 = MLT.tTVcon(TR,r(i+1));
    
    a1(:,1) = MLT.tAv(n1,:);
    a2(:,1) = MLT.tAv(n2,:);
    
    L = L + norm(a2-a1)/3;
    
    dn(i,1) = norm(A0-a1);
    dn(i,2) = n1 ;
end

td = L * pL / 100 ; % threshold distance

dn = sortrows(dn,1); % closest node




end

