function [rnR] = mp1633_ringNods (connT, aeR1, pnR, inR, anR)

% RETURNS:
% rnR(*,1): refs of tets nodes that form a ring around the axis nodes (anR)
% but not including the pivot

conta1 = 0 ;
conta2 = 0 ;

% 1.- Tets to remove and to stay:
% Removes those ones with nodes anR and pivot pnR

eRr = zeros(1,1); % elems to remove
eRs = zeros(1,1); % elems to stay

for e = 1:1:size(aeR1,1)
    
    eR = aeR1(e,1);
    
    conta = 0 ;
    for i = 1:1:4
        
        nR = connT.EV(eR,i);
        
        if nR == pnR || (nR == anR(1) || nR == anR(2))
            conta = conta + 1 ;
        end
    end
    
    if conta == 3
        conta1 = conta1 + 1 ;
        eRr(conta1,1) = eR ;
    else
        conta2 = conta2 + 1 ;
        eRs(conta2,1) = eR ;
    end

end

% 2.- Lines involved. It does not consider lines containing axis nodes (anR),
% i.e. it is only 'ring' lines:

ilR = zeros(1,1);
conta = 0 ;

for e = 1:1:size(aeR1,1)
    
    eR = aeR1(e);
    
    for i = 1:1:6
        
        lR = connT.EL(eR,i);
        
        if (connT.LV(lR,1)~=anR(1) && connT.LV(lR,1)~=anR(2)) && ...
           (connT.LV(lR,2)~=anR(1) && connT.LV(lR,2)~=anR(2))
       
            conta = conta + 1 ;
            ilR(conta,1) = lR;
        end
    end
 
end

ilR = sortrows(ilR);
Nl = size(ilR,1);



% 3.- Identifies ring of nodes, start a pnR, but it does not include pnR:

Nrn = size(inR,1)-1;

rnR = zeros(Nrn,1);

bn = pnR ; % 'base node'

tlR = ilR ;
conta = 0 ;

for i = 1:1:Nrn
    
    for j = 1:1:size(tlR,1)
        
        lR = tlR(j);
        
        if connT.LV(lR,1) == bn
            
            conta = conta + 1;
            rnR(conta,1) = connT.LV(lR,2);
            
            tlR = GEN_27_remKrow (tlR,j);
            break
            
        elseif connT.LV(lR,2) == bn
            
            conta = conta + 1;
            rnR(conta,1) = connT.LV(lR,1);
            
            tlR = GEN_27_remKrow (tlR,j);
            break
        end
        
    end
    
    bn = rnR(conta,1);
    
end




end

