function [IP, ilR, atR, Nat] = ei1641_IP (contaL, connT, connS, THC, Nis, isi, tolL, nd)

% RETURNS:
% ilR: intersected edge reference
% asR(Nas,1): attached sides to that intersected edge
% atR(Nat,1): attached tets to that intersected edge

pudim = 3 ;


atR = zeros(1,1);
Nat = 0 ;
asR = zeros(1,1);
Nas = 0 ;

% 1.- INTERSECTED EDGE REFERENCE:

ilR = 0 ;
IP = zeros(pudim,1);
a = zeros(pudim,1);
b = zeros(pudim,1);
c = zeros(pudim,1);
d = zeros(pudim,1);


for k = 1:1:Nis

    if isi(k,1).tp == 2
        
        % searches for the edge of the triangular side:
        
        sR = isi(k,1).R ;
        
        r = [ 1 2 ; 2 3 ; 3 1 ] ;
        
        for i = 1:1:3
            
            IP(:,1) = isi(k,1).Acoor(:,1);
            
            a(:,1) = THC.Av(connS.SV(sR,r(i,1)),:);
            b(:,1) = THC.Av(connS.SV(sR,r(i,2)),:);
            
            ON = go2520_PonSegment (IP, a,b, pudim, tolL);
            
            if ON == 1
                
                % searches the line:
                
                for l = 1:1:3
                    
                    lR = connS.SL(sR,l);
                    
                    c(:,1) =  THC.Av(connT.LV(lR,1),:);
                    d(:,1) =  THC.Av(connT.LV(lR,2),:);
                    
                    CO11 = go2542_coincidentP (a, c, pudim, nd);
                    CO22 = go2542_coincidentP (b, d, pudim, nd);
                    CO21 = go2542_coincidentP (b, c, pudim, nd);
                    CO12 = go2542_coincidentP (a, d, pudim, nd);
                    
                    if (CO11==1 && CO22==1) || (CO21==1 && CO12==1)
                        ilR = lR ;
                        break
                    end
                    
                end
                
            end
            
            if ilR > 0
                break
            end
            
        end
    end
    
    if ilR > 0
        break
    end
    
end


if ilR==0
    return
end


% 2.- ATTACHED SIDES and TETS TO THAT FIRST INTERSECTED EDGE:
% Uses conn. matrices


% 2.1.- Attached tets:

for i = 1:1:size(connT.LE,2)
    
    eR = connT.LE(ilR,i);
    
    if eR > 0   
        Nat = Nat + 1 ;
        atR(Nat,1) = eR;
    end
    
end


% 2.2.- Attached sides:

Stm = zeros(1,1);

conta = 0 ;

for e = 1:1:Nat % prelim. selection
    
    eR = atR(e);
    for s = 1:1:4
        conta = conta + 1 ;
        Stm(conta,1) = connT.ES(eR,s); 
    end
    
end

[Stm,~] = GEN_16_RemoveRepeatedRows (Stm, 1, 0.1);


for s = 1:1:size(Stm,1)
    
    sR = Stm(s);
    
    for i = 1:1:3
        
        lR = connS.SL(sR,i);
        
        if lR == ilR
            
            Nas = Nas + 1 ;
            asR(Nas,1) = sR;
            break
            
        end
        
    end
end



%{

Ac = zeros(pudim,1); % candidate point

for s = 1:1:Nis

    if isi(s,1).tp == 2
        
        Ac(:,1) = isi(s,1).Acoor(:,1);
        
        CO = go2542_coincidentP (IP, Ac, pudim, nd-1);
        
        if CO == 1
            
            Nas = Nas + 1 ;
            
            r = isi(s,1).R;
            asR(Nas,1) = r;
            
            if contaL == 13
                
                r
                pt1374_pSidConn (r, connS, THC.Av, 99, 'm', 0.2, 3.55, 0);
 
            end
            
            for k = 1:1:2
                Nat = Nat + 1 ;
                atR(Nat,1) = connS.SE(r,k);
            end
            
        end
    end
end

if contaL==13
    atR
end

[atR,~] = GEN_16_RemoveRepeatedRows (atR, 1, 0.1);
Nat = size(atR,1);

%}



end

