function [fpF, connT] = ei1642_FlippCase (contaL, ILn, mLR, THC, connT, MLT, ilR, atR, Nat)

% RETURNS:
% fpF = 1 if edge is flipped, otherwise = 0
% connT: updated if flipping happens

fpF = 0 ;

% line to flip if there are:
% - 2 No. tets with one 'free' node
% - 4 No. tets with two 'free' nodes
% 'free' node is not on the quadrilateral of edges to flip.


% 1.- Nodes of the quadrilateral (refs of tet):
    
qnR = zeros(4,1);

%   - intersected line:
qnR(1) = connT.LV(ilR,1);
qnR(3) = connT.LV(ilR,2);
     
%   - missing line:
qnR(2) = ILn(1,1);
qnR(4) = ILn(2,1);



            
if Nat == 2 || Nat == 4
    
    
	% 2.- Searches the 'free' nodes:
    
    fnR = zeros(Nat,1);
    
    for e = 1:1:Nat
        
        eR = atR(e);

        for i = 1:1:4
            
            r = connT.EV(eR,i);

            addF = 1 ;
            for j = 1:1:4
                if r == qnR(j)
                    addF = 0 ;
                    break
                end
            end
            
            if addF == 1
                fnR(e,1) = r ;
                break
            end
            
        end
    end   

    

    
    
    if Nat == 2

        % 3.- Two tets involved:
        
        % free nodes condition:
        
        if fnR(1) == fnR(2) && fnR(1) > 0
            fpF = 1 ;
        end
        

    elseif Nat == 4

        % 4.- Four tets involved:
        
        
        % free nodes must not be jointed by any line:
        
        [fnRu,~] = GEN_16_RemoveRepeatedRows (fnR, 1, 0.1);
        
        for e = 1:1:Nat
            
            conta = 0 ;
            for k = 1:1:4
                
                r = connT.EV(atR(e,1),k);
                
                if  r == fnRu(1) ||  r == fnRu(2)
                    conta = conta + 1 ;
                    if conta==2
                        break
                    end
                end
            end
            if conta==2
           	break
        	end
        end
        
        if conta < 2
        
            % free nodes conditions:

            if (fnR(1)== fnR(2) && fnR(3)==fnR(4)) && (fnR(1)> 0 && fnR(3)> 0) 

                fpF = 1 ;

            elseif (fnR(1)==fnR(3) && fnR(2)==fnR(4)) && (fnR(1)> 0 && fnR(2)> 0)

                fpF = 1 ;

            elseif (fnR(1)==fnR(4) && fnR(2)==fnR(3)) && (fnR(1)> 0 && fnR(2)> 0)

                fpF = 1 ;

            end

        end
        
    end

    
    % 5.- Flips edge:
    
    if fpF == 1
        
        % arranges elements to put togueter them by free node:
        
        x = [ fnR, atR ];
        x = sortrows(x,1);
        
        fn = x(1,1);
        e1 = x(1,2);
        e2 = x(2,2);
        
        connT.EV(e1,1) = fn ; connT.EV(e1,2) = qnR(1) ; connT.EV(e1,3) = qnR(2) ;connT.EV(e1,4) = qnR(4) ;
        connT.EV(e2,1) = fn ; connT.EV(e2,2) = qnR(3) ; connT.EV(e2,3) = qnR(4) ;connT.EV(e2,4) = qnR(2) ;
        
        if Nat == 4
            
            fn = x(3,1);
            e1 = x(3,2);
            e2 = x(4,2);

            connT.EV(e1,1) = fn ; connT.EV(e1,2) = qnR(1) ; connT.EV(e1,3) = qnR(2) ;connT.EV(e1,4) = qnR(4) ;
            connT.EV(e2,1) = fn ; connT.EV(e2,2) = qnR(3) ; connT.EV(e2,3) = qnR(4) ;connT.EV(e2,4) = qnR(2) ;

        end
  
    end

end


end

