function [pNE, connT] = ei1644_TetDiv2 (THC, pNE, connT, atR, Nat, nnR, ilR)

% divides tet into 2, by inserting nnR node into LlR
% RETURNS: updated pNE and connT

% INPUTS:
% pNE, connT
% atR(Nas,1): ref of tets attached to the line to split
% nnR: new node reference
% ilR: intersected edge ref


% nodes of the ilR:

lnR = [ connT.LV(ilR,1) connT.LV(ilR,2) ];


for e = 1:1:Nat
    
    eR = atR(e); % element ref
    
    % prints before:
    %%%%%%%%%%%%%%%%%%%%%%  %%%%%%%%%%%%%%%%%%%%%%
    %{
    fr = 1 ;
    pt1373_pTetConn (eR, connT, THC.Av, fr, 'k', 0.25, 2.1);
    %}
    
    
    r = zeros(2,1);
    
    % find the ref of the tet nodes NOT attached to the missing line:
    
    conta1 = 0 ;
    for i = 1:1:4
        
        nR = connT.EV(eR,i) ;
        if nR ~= lnR(1) && nR ~= lnR(2)
            conta1 = conta1+1;
            r(conta1,1) = nR ;
        end
    end
    
    
    % split the element:
    
    connT.EV(eR,1) = nnR; connT.EV(eR,2) = r(1); connT.EV(eR,3) = r(2); connT.EV(eR,4) = lnR(1); 
    
    pNE = pNE + 1 ;
    connT.EV(pNE,1) = nnR; connT.EV(pNE,2) = r(1); connT.EV(pNE,3) = r(2); connT.EV(pNE,4) = lnR(2);
    
	% prints after:
    %%%%%%%%%%%%%%%%%%%%%%  %%%%%%%%%%%%%%%%%%%%%%
    %{

    fr = 2 ;
    pt1373_pTetConn (eR, connT, THC.Av, fr, 'r', 0.25, 2.1);
    pt1373_pTetConn (pNE, connT, THC.Av, fr, 'r', 0.25, 2.1);
    %}
    


    
end






end

