function [clF, connT, pNE, THC, MLT, uatR, uNat] = ei1645_CLCase ...
     (contaL, connT, pNE, THC, MLT, Spatches, pR, rTskin, agCurv, ILn, mLR, mTR, IP, ilR, atR, Nat, Xtol, DUtol, nd)

% RETURNS:
% clF = 1 if one common edge is inters'd, otherwise = 0
% connT, pNE, THC, MLT: updated if insertion happens
% uatR(uNat,1): refs of affected triangle, including the new ones


% 1.- DETECTS THE TETS THAT CONTAIN ilR :

Na = 0 ;
tR = zeros(1,1);

for k = 1:1:Nat
    
    r = atR(k);
    
    for s = 1:1:6
        
        lR = connT.EL(r,s);
        if lR == ilR
            
            Na = Na + 1 ;
            tR(Na,1) = r ;
            break
        end
        
    end

end

uNat = 0 ;
uatR = [ tR ; [pNE+1:1:pNE+Na]' ] ; % extend the matrix to consider new tets generated by partition of ilR



% 2.- PROJECTS THE INTERSECTION ON THE MLT:

tn = [ ILn(1,1) ; ILn(2,1) ] ; % nodes involved, in tets refs

sudim = 2 ;

U0 = zeros(sudim,1);

B0      = (THC.Bv(tn(1),1) +  THC.Bv(tn(2),1))/2;
U0(:,1) = (THC.Uv(tn(1),:) +  THC.Uv(tn(2),:))/2;
A0      = IP;

csM = zeros(2,1); % T-curves and T-surfaces attached to these tet nodes

csM(1) = 0;
if THC.NCS(tn(1),1)>0 && THC.NCS(tn(2),1)>0
	csM(1) = THC.NCS(min(tn),1);
end
    
csM(2) = THC.NCS(tn(1),2);
    
[eTHC] = ei1643_eTHCm (contaL, Spatches, pR, rTskin, agCurv, csM, B0, U0, A0, Xtol, DUtol);
    


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% {

fr = 33 ;

plotF = 1 ;
[rv, rP1, rP2] = ts1602_mLAspace (ILn, THC.Av, plotF, fr, 'r');

for i = 1:1:Nat
    pt1373_pTetConn (tR(i), connT, THC.Av, fr, 'k', 1, 1, 0, 0);
end


figure(fr)
scatter3( eTHC.Av(1),  eTHC.Av(2), eTHC.Av(3),'m'); hold on
scatter3( eTHC.At(1),  eTHC.At(2), eTHC.At(3),'r'); hold on

%}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



% 3.- CHECKS IT THE PROJECTD POINT STILL LIES WITHIN THE AFF'D TETS:

pudim = 3 ;

Ap = eTHC.Av;
Anod = zeros(4,pudim);

clF = 0 ; % if lies within one thet the process carries on

for k = 1:1:Na
    
    eR = tR(k);
    
    for i = 1:1:4
        nR = connT.EV(eR,i);
        Anod(i,:) = THC.Av(nR,:);
    end
    
    [IN, ~, ~, ~, ~] = go2539_PinTet (Anod, Ap, nd);
    
    if IN > 0
        clF = 1 ; 
        break
    end
    
end


if clF == 0
    return
end



% 4.- ADDS NEW NODE TO TETS:

THC.Bv = [THC.Bv ; eTHC.Bv];
THC.Uv = [THC.Uv ; eTHC.Uv'];
THC.Av = [THC.Av ; eTHC.Av'];
THC.Xv = [THC.Xv ; eTHC.Xv'];
THC.NCS = [THC.NCS ; eTHC.NCS];



% 5.- SPLITS AFF'D TETS INTO TWO, BY THE PROJECTED POINT AT EDGE:

meR = tR(1); % 'main' element ref (not adjacents), any of tR is valid

neR = [connT.LV(ilR,1) ; connT.LV(ilR,2)];

[llR] = ts1620_LedgeR (connT, neR, meR) ; % local ref of intersected line

[pNE, connT] = ei1660_edgeInt (pNE, connT, THC, meR, llR);
  


% 6.- UPDATES MLT:

[MLT] = um0660_inNodMLT (pR, Spatches, MLT, eTHC, mTR);

end

