function [pNE, connT] = ts1653_TetDiv3 (THC, pNE, connT, Ne, eR, nnR, LsRd)

% divides aff'd tets into 3, by inserting nnR node into side LsRd
% RETURNS: updated pNE and connT.EV

% INPUTS:
% pNE, connT
% eR: element ref to divide
% nnR: new node reference (global)
% LsRs(Ne,1): local side ref to split


for e = 1:1:Ne

    EVt = zeros(3,4);
    contaE = 0 ;
    
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %{
    fr = 101 ;
    figure(fr)
    pt1373_pTetConn (eR(e), connT, THC.Av, fr, 'r', 0.2, 3.25, 0);
    scatter3(THC.Av(nnR,1), THC.Av(nnR,2), THC.Av(nnR,3), 'r'); hold on
    %}
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    
    
    for s = 1:1:4

        if s ~= LsRd(e)

            contaE = contaE + 1;

            % Selects nodes of sides to not split:
            r = ts1652_LsideGnodes (s, eR(e), connT);


            % Allocates to temporary matrix:
            EVt(contaE,1) = nnR ;
            EVt(contaE,2) = r(1) ;
            EVt(contaE,3) = r(2) ;
            EVt(contaE,4) = r(3) ;

        end
    end

    pNE = pNE + 2 ;

    connT.EV = [ connT.EV ; zeros(2,4) ] ;


    for k = 1:1:4
        connT.EV(eR(e),k) = EVt(1,k);
        connT.EV(pNE-1,k) = EVt(2,k);
        connT.EV(pNE-0,k) = EVt(3,k);
    end

    
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %{
    pt1373_pTetConn (eR(e), connT, THC.Av, fr, 'k', 0.8, 1.25, 0);
    pt1373_pTetConn (pNE-1, connT, THC.Av, fr, 'k', 0.8, 1.25, 0);
    pt1373_pTetConn (pNE-0, connT, THC.Av, fr, 'k', 0.8, 1.25, 0);
    %}
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    
end

end

