function [pNE, EVcon] = ei1663_TetDiv2 (THC, pNE, EVcon, Ne, eR, nnR, LeRd)

% divides aff'd tets into 2, by inserting nnR node into edge LeRd
% RETURNS: updated pNE and EVcon

% INPUTS:
% eR(Ne,1): element refs to divide
% nnR: new node reference (global)
% LeRd(Ne,2): local edge ref to split, i.e. nodes refs of the edge to split


for e = 1:1:Ne

    EVt = zeros(2,4);
 
    % identifies nodes:
    
    fnR = zeros(2,1); % 'free nodes' (not attached to edge to split)
    anR = zeros(2,1); % 'attached nodes' to the edge
    
    contaF = 0 ;
    contaA = 0 ;
    
    for n = 1:1:4
        
        if (n == LeRd(e,1) || n == LeRd(e,2))
            
            contaA = contaA + 1 ;
            anR(contaA,1) = EVcon(eR(e),n);
            
        else 
            
            contaF = contaF + 1 ;
            fnR(contaF,1) = EVcon(eR(e),n);
            
        end
        
    end
    


    
    
    
    % allocates temporarily:
    
    for i = 1:1:2
        EVt(i,1) = nnR ;
        EVt(i,2) = fnR(1) ;
        EVt(i,3) = fnR(2) ;
        EVt(i,4) = anR(i) ;
    end
    
  
    
    % updates:
    
    pNE = pNE + 1 ;

    EVcon = [ EVcon ; zeros(1,4) ] ;

    for k = 1:1:4
        EVcon(eR(e),k) = EVt(1,k);
        EVcon(pNE,k)   = EVt(2,k);
    end

   
end



end

