function [NE, connT, raeR] = tf1681_flip32 (NE, connT, LR)

% RETURNS: updated tets after 32 flip (line LR is removed)
% 

% NOTE: assumes LR has three tets attached !!


% 1.- IDENTIFIES ITEMS:

% 1.1.- Elements attached to the line:

aeR = zeros(3,1);

for e = 1:1:3
    aeR(e,1) = connT.LE(LR,e);
end


% 1.2.- Free and attached to line nodes:

Ln1 = connT.LV(LR,1);
Ln2 = connT.LV(LR,2);

anR = [Ln1; Ln2];

fnR = zeros(1,1);
conta = 0 ;

for e = 1:1:3
    
    eR = aeR(e,1);
    
    for i = 1:1:4
        
        nR = connT.EV(eR,i);
        
        if nR ~= Ln1 && nR ~= Ln2
            conta = conta + 1 ;
            fnR(conta,1) = nR;
        end
    end 
end


[fnR,~] = GEN_16_RemoveRepeatedRows (fnR, 1, 0.1);


% 2.- CREATES TEMPORARY CONN. MATRIX:

EVt = zeros(2,4);

EVt(1,:) = [ anR(1), fnR' ];
EVt(2,:) = [ anR(2), fnR' ];



% 3.- UPDATES EVconn AND NE:
% The highest element is removed

aeR = sortrows(aeR,1);

raeR = [ aeR(1) ; aeR(2) ]; % remaining element refs

leR = aeR(3); % last element ref, among the three elements to amend

EV = connT.EV ;


% 3.1.- Reduces No. rows of EV:

if leR == NE
    EV = EV(1:NE-1,:);
else
    EV = [ EV(1:leR-1,:) ; EV(leR+1:NE,:) ] ;
end

% 3.2.- Amends EV affected elements:

for e = 1:1:2
   
    eR = aeR(e,1);
    for k = 1:1:4
        EV(eR,k) = EVt(e,k);
    end

end

% 3.3.- Allocates:

connT.EV = EV ;
NE = NE - 1 ;


end

