function [dtR] = ti1600b_identifyOnSet (contaL, teR, THC, connT, connS, Spatches, pR)

% RETURNS:
% dtR: distorted tet ref.: the most distorted tet within a set of given tets.

% INPUTS:
% teR(Ne,1): tets refs to check (the can be extraction of a larger tetrahedralization)

pudim = 3 ;

dtR = 0 ;

Anod = zeros(4,pudim);


Rth = 0.05 ; % threshold to consider as distorted tet.


% loops while there is an element to correct

coF = 1 ; % correction flag
contaLc = 0 ;

while coF == 1

    coF = 0 ;
    
    contaLc = contaLc + 1 ;
    
    for e = 1:1:size(teR,1)

        eR = teR(e) ;

        Aav = zeros(pudim,1);
        for k = 1:1:4
            nR = connT.EV(eR,k);
            Anod(k,:) = THC.Av(nR,:);

            for di = 1:1:pudim
                Aav(di,1) = Aav(di,1) + Anod(k,di)/4;
            end

        end


        [R,bave,~] = th1319_tetR (Anod);


        if R <= Rth


            % asseses the type of distortion:

            [dtT, dtF] = dt3701_typeDistrn (Anod, Aav, bave);


            
            % corrects:
            
            %{
            [ eR dtT ]
            
                figure(contaLc)
                
                pt1373_pTetConn (eR, connT, THC.Av, contaLc, 'k', 1, 1, 0, 0);
                
                %scatter3(pAnod(:,1), pAnod(:,2), pAnod(:,3), 'r'); hold on
                
                title(strcat('element ' , num2str(eR), '  type ', dtT))
                
            %}
            
            NV = size(THC.Av,1);
            
            if dtT == "CAP"

                [connT, connS, aeR, reR] = ts1610b_tetCAP (eR, dtF, connT, NV, connS);

                coF = 1 ;

            elseif dtT == "SLIVER"

           [connT, connS, THC, aeR, reR] = ts1611b_tetSLIVER (eR, dtF, connT, THC, Spatches, pR);

                coF = 1 ; 
            end

            
            % leaves the loop to restart:
            if coF == 1
         	break
            end
                
        end

    end

    
                
    if coF == 1

        teRt = [teR ; aeR];
        [teRt,~] = GEN_16_RemoveRepeatedRows (teRt, 1, 0.1);
        
        teR = zeros(size(teRt,1)-1,1);
        conta = 0 ;
        
        for e = 1:1:size(teRt,1)
            
            if teRt(e,1)~=reR
                conta = conta + 1 ;
                teR(conta,1) = teRt(e,1);
            end
            
        end
        
        %{

        fr = 1 ;
        figure(fr);
        scatter3( pAnod(:,1),  pAnod(:,2),  pAnod(:,3), 'r'); hold on

        for i = 1:1:3
        pt1373_pTetConn (aeR(i), connT, THC.Av, fr, 'k', 0.95, 1.2, 0, 0);
        end

        %}  

    end

    
end

        
        %if RECIENIMPLEMT ==0
        %end


end

