function [connT, connS, aeR, reR] = ts1610b_tetCAP (ceR, ipR, connT, NV, connS)

% RETURNS:
% connT, connS: updated after dividing aff'd tets into three sub-tets
% aeR:          refs of affd elements
% reR:          element removed

% INPUTS:
% ceR: ref. of element that is a cap
% ipR: internal node local ref (within ceR)


% 1.- DETECTS ELEMENT TO DIVIDE:
% (that one attached to the side opp. to internal node)

% detects side that do not contain ipR:

nR = connT.EV(ceR,ipR); % ref. of node that lies inside 

for s = 1:1:4
   
    sR = connT.ES(ceR,s);

    conta = 0;
    for i = 1:1:3
        r = connS.SV(sR,i);

        if r~=nR
            conta = conta+1;
        end
    end
    
    if conta == 3
        break
    end
end


% ref. of element to divide into 3:

edR = 0 ; 
for i = 1:1:2
    if connS.SE(sR,i)~=ceR
        edR = connS.SE(sR,i);
        break
    end
end



% 2.- UPDATES EVcon:

EVcon = connT.EV ;

% 2.1.- just deletes the element
    
[EVcon] = ts1621b_EVdelER (EVcon, ceR);
reR = ceR ;


% 2.2.- modifies the edR and adds two more:

if edR > 0
    
    % detects the node of edR not present in sR:
    
    for i = 1:1:4
        
        rt = connT.EV(edR,i);
        addF = 1;
        
        for j = 1:1:3
            
            rs = connS.SV(sR,j);
            if rs==rt
                addF = 0;
                break
            end
        end
        
        if addF == 1
            fnR = rt; % free node refernce
            break
        end
    end
    
    % divides:
    
    NE = size(EVcon,1);
    
    EVcon(edR,1) = fnR ;  EVcon(edR,2) = nR ;  EVcon(edR,3)  = connS.SV(sR,1) ; EVcon(edR,4)  = connS.SV(sR,2) ;
    EVcon(NE+1,1) = fnR ; EVcon(NE+1,2) = nR ; EVcon(NE+1,3) = connS.SV(sR,2) ; EVcon(NE+1,4) = connS.SV(sR,3) ;
    EVcon(NE+2,1) = fnR ; EVcon(NE+2,2) = nR ; EVcon(NE+2,3) = connS.SV(sR,3) ; EVcon(NE+2,4) = connS.SV(sR,1) ;
    
    aeR = [ edR, NE+1, NE+2 ]';
    
end


% 3.- UPDATES connT and connS:

NE = size(EVcon,1);

connT = th1333_oConnL (NE, NV, EVcon); 
[connS,~,~] = th1381_connS (NE, connT);

end

