function [pR, sR, tR] = pr1702_PST (x, Npa, Spatches, ps, nd)

% RETURNS:
% pR, sR, tR: patch, skin and triangle closest to the point
% for searching uses always in the first instance

% INPUTS:
% ps: patch selected to search. ps =  in case searches in all of them

tolL = 0.5;
tolA = 0.5;


xdim = 3 ;

a = zeros(xdim,1);
b = zeros(xdim,1);
c = zeros(xdim,1);

pR = 0 ;

if ps == 0
    pa1 = 1;
    pa2 = Npa;
else
    pa1 = ps;
    pa2 = ps;
end


for pa = pa1:1:pa2
    
    Nsk = Spatches(pa,1).INS(1,1).mNsk;

    
    for s = 1:1:Nsk
        
        skin = Spatches(pa,1).INS(1,1).skin(s,1);
        
        % closest node of the skin:
        
        dmin = 99999999999;
        vmin = 0 ;
        
        for v = 1:1:skin.mNV
            
            vx = skin.mVP(v,1).mXcoor;
            
            dist = norm(vx-x);
            
            if dist < dmin
                
                dmin = dist;
                vmin = v ;
            end
        end
        

        % closest triangle:
        
        dmin = 9999999999999;
        tmin = 0 ;
        
        for t = 1:1:size(skin.mVTcon,2)
            
            tR = skin.mVTcon(vmin,t);
            
            if tR > 0
                
                for di = 1:1:xdim  
                    n1 = skin.mTVcon(tR,1);
                    n2 = skin.mTVcon(tR,2);
                    n3 = skin.mTVcon(tR,3);
                    
                    a(di,1) = skin.mVP(n1,1).mXcoor(di,1);
                    b(di,1) = skin.mVP(n2,1).mXcoor(di,1);
                    c(di,1) = skin.mVP(n3,1).mXcoor(di,1);
                end
                
                Xnod = [a' ; b' ; c'];
                
                [A,B,C,D] = go2506_Plane3P (a,b,c);
                
                [dist,~,Q] = go2534_distPtoPlan (x, A, B, C, D);
                IN = go2546_PinTriang (Xnod, Q, tolL, tolA, nd);


                if IN > 0
                    if dist < dmin
                        tmin = tR ;
                        dmin = dist ;
                    end
                end

            end
            
        end
        
        % selects the triangle that is at 0 distance from Q
        
        if round(dmin,nd) == 0 
            
            pR = pa ;
            sR = s ;
            tR = tmin;
            break
            
        end  
        
    end
    
    if pR > 0
       break 
    end

end






end

