function [s,u,xd] = pr1703_vbles (x, Spatches, pR, sR, tR, xdim)

% RETURNS: 
% s(7,1): stresses
% u(4,1): displacements
% xd(3,1): position in the deformed configuration

% at location x

skin1 = Spatches(pR,1).INS(1,1).skin(sR,1); % (instance 1)
skin2 = Spatches(pR,1).INS(2,1).skin(sR,1); % (instance 2)


% coords and vbles of vertex of the triangle

Xnod1 = zeros(3,xdim);
Xnod2 = zeros(3,xdim);

Sv = zeros(3,7); % 6 stresses and VM
Uv = zeros(3,4); % 3 displacements and total (norm)

for v = 1:1:3
    
  	vR = skin1.mTVcon(tR,v);
    
    Xnod1(v,:) = skin1.mVP(vR,1).mXcoor(:,1);
    Xnod2(v,:) = skin2.mVP(vR,1).mXcoor(:,1);
    
    for j = 1:1:6
        Sv(v,j) = skin2.mVP(vR,1).mSv(j);
    end
    Sv(v,7) = skin2.mVP(vR,1).mVM;
    
    u = skin2.mVP(vR,1).mXcoor - skin1.mVP(vR,1).mXcoor;

    for di = 1:1:xdim
        Uv(v,di) = u(di,1);
    end
    
    Uv(v,4) = norm(u);
    
end



% shape functions:
[N] = ei1801_LinTri (x, Xnod1, xdim);


% computes parameters:
 
s = zeros(7,1);
u = zeros(4,1);
xd = zeros(xdim,1);

for v = 1:1:3

    for i = 1:1:7
        s(i) = s(i) + N(v)*Sv(v,i);
    end
    
    for i = 1:1:4
        u(i) = u(i) + N(v)*Uv(v,i);
    end
    
    for i = 1:1:3
        xd(i) = xd(i) + N(v)*Xnod2(v,i);
    end
    
end



end

