function [N] = ei1801_LinTri (c, Cnod, dim)


% RETURNS:
% N(3,1): basis functions value

% INPUTS:
% c(dim,1):     point where evaluate N
% Cnod(3,dim):  nodes coords
% dim:          No. dims

% Relevant vectors:

u1 = zeros(dim,1); % contour vectors
u2 = zeros(dim,1);
u3 = zeros(dim,1);

v1 = zeros(dim,1); % vector from each node to c
v2 = zeros(dim,1);
v3 = zeros(dim,1);

for di = 1:1:dim
    
    u1(di,1) = Cnod(2,di) - Cnod(1,di);
    u2(di,1) = Cnod(3,di) - Cnod(2,di);
    u3(di,1) = Cnod(1,di) - Cnod(3,di);
    
    v1(di,1) = c(di,1) - Cnod(1,di);
    v2(di,1) = c(di,1) - Cnod(2,di);
    v3(di,1) = c(di,1) - Cnod(3,di);
    
end


% Areas:

At = norm(cross(u1,u2))/2;

A1 = norm(cross(u2,v3))/2;
A2 = norm(cross(u3,v1))/2;
A3 = norm(cross(u1,v2))/2;

N = [A1/At A2/At A3/At]';



end

