function [NV, NE, NLI, TRC, conn] = uc1900_upconnLR ...
         (NV, NE, NLI, TRC, conn, NL, Nlv, LR, Spatches, pR, tFace, sR, Xtol, DUtol, contaL, cLoop)

% RETURNS:
% conn and nodes coords due to one line removal (line to remove LR)

% 1.- IDENTIFIES AFFECTED ITEMS:

[Er, Ner, Lm, Vr, Va, Em, Ev, Nev] = uc1901_invItems (conn, LR);

%{
if contaL == 2 && cLoop == 3
    
    LR
    Er
    Ner
    Lm
    Vr
    Em
    Ev
    Nev

    
    fr = 99 ;
    
    for e = 1:1:Ner
        
        r = Er(e,1);
        pt1374_pSidConn (r, conn.TV, TRC.Av, fr, 'r', 0.9, 2.5, 1, 1)
        
        for k = 1:1:2
            
            r = Em(e,k);
            pt1374_pSidConn (r, conn.TV, TRC.Av, fr, 'k', 0.9, 1.2, 1, 1)
        end
    end
    
 	for e = 1:1:Nev
        r = Ev(e,1);
        pt1374_pSidConn (r, conn.TV, TRC.Av, fr, 'r', 0.5, 0.5, 1, 1)
    end
    
    
    for k = 1:1:size(Vr,1) 
        text ( TRC.Av(Vr(k),1),  TRC.Av(Vr(k),2), TRC.Av(Vr(k),3), num2str(Vr(k)) );
    end
    
    
    if gg==0
    end
    
end

%}



% 2.- UPDATES NODES COORDS:
% Node to remove is substituted by the last one

[TRC] = uc1902_upCoords(NV, TRC, Vr, Spatches, pR, tFace, sR, Xtol, DUtol);


% 3.- TV & LV CONN. MATRICES:
% elements to remove are substituted by the latest:

% all affected elements that will remain:
Ea = zeros(1,1);

Nea = 0 ;  
for i = 1:1:2
for j = 1:1:2

    if Em(i,j) > 0
        Nea = Nea + 1 ;
        Ea(Nea,1) = Em(i,j);
    end
end
end

for e = 1:1:Nev
    Nea = Nea + 1 ;
    Ea(Nea,1) = Ev(e);
end



[TVt] = uc1903_upTV (conn, NE, NV, Vr, Er, Ner, Ea, Nea, TRC.Av, contaL, cLoop);
[LVt] = uc1908_upLVconto (NL, Nlv, NE-2, TVt, contaL, cLoop);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%{

if contaL == 3

fr = cLoop;
Anod = zeros(3,3);

for e = 1:1:size(TVt,1)
    
    for i = 1:1:3
        nR = TVt(e,i);
        Anod(i,:) = Avm(nR,:);
    end
    
    pt1361_plotTri_nD (Anod, 3, fr, 'k');

end


end

%}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% 4.- NUMBERS:

NV  = NV - 1 ;
NE  = NE - 2 ;
NLI = NLI - 3 ;


% 5.- REST OF CONN.

[LTt, VLt, TLt, VTt] = uc1909_oConn (NE, NV, TVt, LVt);



% 6.- ALLOCATES:

conn.TV = TVt;
conn.TL = TLt;

conn.LV = LVt;
conn.LT = LTt;

conn.VL = VLt;
conn.VT = VTt;







end

