function [Er, Ner, Lm, Vr, Va, Em, Ev, Nev] = uc1901_invItems (conn, LR)

% RETURNS: involved items in the removal of the line
% 

% 1.1.- Elements to remove:

Er = [ conn.LT(LR,1); conn.LT(LR,2)];
Ner = 1 ;
if Er(2) > 0
    Ner = 2;
end

% 1.2.- Lines both sides of LR, that are to merge:

Lm = zeros(2,2); % one side per row

for s = 1:1:2

    conta = 0;
    for i = 1:1:3

        r = conn.TL(Er(s),i);

        if r~=LR
            conta = conta + 1 ;
            Lm(s,conta) = r ;
        end
        
    end
end


% 1.3.- Vertexes to remove and vertexes at both sides that remain (Va):

% From both vertexes, Vr(1) will remain, but with updated position, and 
% Vr(2) will dissapear. Sets Vr(1) to have the lowest ref.

Vr = [ conn.LV(LR,1) ; conn.LV(LR,2) ] ; 

if Vr(2) < Vr(1)
    t = Vr(1);
    Vr(1) = Vr(2);
    Vr(2) = t ;
end


Va = zeros(2,1);

for s = 1:1:2
    
    for i = 1:1:3
         
        nR = conn.TV(Er(s),i);
        
        if nR~=Vr(1) && nR~=Vr(2)
            Va(s,1) = nR ;
            break
        end
        
    end
end


% 1.4.- Elements affected by Lm lines:

Em = zeros(2,2);

for s = 1:1:2

    re = zeros(2,1);
    
    for i = 1:1:2
        
        r = Lm(s,i); % line to merge
        
        re(i) = conn.LT(r,1);

        if re(i) == Er(s)
            re(i) = conn.LT(r,2);
        end
    end
    
    Em(s,1) = re(1);
    Em(s,2) = re(2);

end



% 1.5.- Elements affected by nodes to remove:

Ev = zeros(1,1);
Nev = 0;

Nev = 0 ;
for v = 1:1:2
    
    for i = 1:1:size(conn.VT,2)
    
        r = conn.VT(Vr(v),i);
        
        if r > 0
            
            if (r ~= Em(1,1) && r ~= Em(1,2)) && (r ~= Em(2,1) && r ~= Em(2,2))
          	if (r ~= Er(1,1) && r ~= Er(2,1)) 
                
                Nev = Nev + 1 ;
                Ev(Nev,1) = r;
                
            end    
            end
        end
    
    end
end



end

