function [RLT] = uc1906_RLtri (Cv, TV, dim)


% RETURNS:
% RLT(NE,1): representative length of triangles

NE = size(TV,1);

Cnod = zeros(3,dim);

RLT = zeros(NE,1);

for e = 1:1:NE
    
    for i = 1:1:3
        nR = TV(e,i);
        Cnod(i,:) = Cv(nR,:);
    end
    
    At = tr1301_AreaT (Cnod, dim);
    
    RLT(e,1) = (At/0.433)^0.5 ;

end



end

