function [ THC, connT ] = st1961_tetSLr (contaL, PcontaL, THC, connT, slR, rlR, nnR)

% RETURNS:
% THC,connT: with last node removed and small line removed


% INPUTS:
% slR: small line ref to remove
% nnR: new node ref, to remove
% onR: opposite node ref, towards the slR is shrank to.

% - shrinkages slR until is removed (from nnR to onR) and attached elements are also removed
% - nnR is removed and onR remains


% Identifies nodes at end of lines:

enR = zeros(2,1); % first the node where the nnR is moved to

for i = 1:1:2

    r = connT.LV(slR,i);
    if r~=nnR
        enR(1,1) = r ;
    end
end

for i = 1:1:2

    r = connT.LV(rlR,i);
    if r~=nnR
        enR(2,1) = r ;
    end
end


% Identifies elements to of small line and elements to retain:

Nes = 0 ;   % attached to small line
Ner = 0 ;   % attached to new node but not to small line => to retain
esR = zeros(1,1);
erR = zeros(1,1);

for k = 1:1:size(connT.LE,2)
    
    e1 = connT.LE(slR,k);
    
    if e1 > 0 
        Nes = Nes + 1 ;
        esR(Nes,1) = e1 ;
    elseif e1==0
        break
    end  
end

for k = 1:1:size(connT.VE,2)
    
    e3 = connT.VE(nnR,k);

    if e3 > 0  
        
        addF = 1;
        for i = 1:1:Nes
            if e3==esR(i)
                addF = 0;
                break
            end
        end
        
        if addF == 1
            Ner = Ner + 1 ;
            erR(Ner,1) = e3 ;
        end
        
    elseif e3==0
        break
    end  
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% tets to remove and to stay (initial situation)
% {

if contaL == PcontaL

    fr = 200 ;
    for e = 1:1:Nes
        eR = esR(e);
        pt1373_pTetConn (eR, connT, THC.Av, fr, 'r', 1, 1, 0, 0);
    end

    for e = 1:1:Ner
        eR = erR(e);
        pt1373_pTetConn (eR, connT, THC.Av, fr, 'b', 0.3, 3.8, 1, 0);
    end

    pt1375_pLinConn (slR, connT.LV, THC.Av, fr, 'm', 1, 6, 0);
    pt1375_pLinConn (rlR, connT.LV, THC.Av, fr, 'm', 1, 6, 0);

    axis equal

    pt1373_pTetConn (219, connT, THC.Av, 1001, 'b', 1, 1, 0, 1);
    pt1373_pTetConn (587, connT, THC.Av, 1001, 'r', 1, 2, 0, 0);
    axis equal
end

%}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% In elements to retain change ref of node from nnR to opp. node of slR

onR = connT.LV(slR,1) ;
if onR==nnR
    onR = connT.LV(slR,2) ;
end

for k = 1:1:Ner 
    eR = erR(k);
    for i = 1:1:4 
        if connT.EV(eR,i)==nnR
            
            connT.EV(eR,i) = onR;
            break
            
        end
    end
end


% Removes elements attached to small line in conn.EV:

EVu = zeros(1,4);
erRu = zeros(1,1);

NE = 0 ;
conta = 0 ;

for k = 1:1:size(connT.EV,1)
    

    % updated EV matrix:
    
    addF = 1 ;
    for i = 1:1:Nes
        
        if k==esR(i)
            addF = 0;
            break
        end
    end
    
    if addF == 1
        
        NE = NE + 1 ;
        EVu(NE,:) = connT.EV(k,:);
        
     	% updated refs of remaining elements
        
        for i = conta+1:1:Ner
            if k == erR(i)
                conta = conta+1;
                erRu(conta,1) = NE ;
                break
            end
        end
        
        
    end
 
end


if contaL == PcontaL
    
    pt1373_pTetConn (219, connT, THC.Av, 1002, 'b', 1, 1, 0, 1);
    pt1373_pTetConn (587, connT, THC.Av, 1002, 'r', 1, 2, 0, 0);
    axis equal
end


% Rest of conn. matrices:

NV = size(THC.Bv,1)-1;

[connT] = th1333_oConnL (NE, NV, EVu);
connT.EV = EVu ;


% x.- REMOVES LAST NODE:

n = size(THC.Bv,1);

THC.Bv  = THC.Bv(1:n-1,:);
THC.Uv  = THC.Uv(1:n-1,:);
THC.Av  = THC.Av(1:n-1,:);
THC.Xv  = THC.Xv(1:n-1,:);
THC.NCS = THC.NCS(1:n-1,:);
THC.rm  = THC.rm(1:n-1,:);


% Finds updated ref of line involved (the line that whas rlR)

rlRu = 0 ;
for k = 1:1:size(connT.VL,2)
    
    r1 = connT.VL(enR(1),k);
    
    
    if r1 > 0
    
        if connT.LV(r1,1) == enR(2) || connT.LV(r1,2) == enR(2)
            rlRu = r1 ;
            break
        end
    
    else
        break
    end
end



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% tets to stay (corrected situation)
% {

if contaL == PcontaL

    fr = 201 ;

    for e = 1:1:Ner
        eR = erRu(e);
        pt1373_pTetConn (eR, connT, THC.Av, fr, 'b', 0.3, 3.8, 0, 0);
    end

    pt1375_pLinConn (rlRu, connT.LV, THC.Av, fr, 'm', 1, 6, 0);

    axis equal

end

%}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



end

