function [conE] = p2001_elemConM (PcoLi, mUnod, nNO, Ncor, udim)

% RETURNS:
% conE: list of nodes (corners) of the element, for RECT-mesh !!

% INPUTS:
% PcoLi(udim,2):        limits of the element in param. space
% Unod(Nnods, udim):    param. coord's of nodes
% Nnod:                 No. nodes (size of Unod)
% Ncor:                 No. nodes or corners of the element



% 1.- Extracts element nodes (corners) U coord's:

EnodU = zeros(Ncor,udim);

if udim==2
    
    EnodU(1,1) = PcoLi(1,1) ; EnodU(1,2) = PcoLi(2,1) ;
    EnodU(2,1) = PcoLi(1,1) ; EnodU(2,2) = PcoLi(2,2) ;
    EnodU(3,1) = PcoLi(1,2) ; EnodU(3,2) = PcoLi(2,1) ;
    EnodU(4,1) = PcoLi(1,2) ; EnodU(4,2) = PcoLi(2,2) ;
    
elseif udim==3
    
    EnodU(1,1) = PcoLi(1,1) ; EnodU(1,2) = PcoLi(2,1) ; EnodU(1,3) = PcoLi(3,1) ;
    EnodU(2,1) = PcoLi(1,1) ; EnodU(2,2) = PcoLi(2,1) ; EnodU(2,3) = PcoLi(3,2) ;
    EnodU(3,1) = PcoLi(1,1) ; EnodU(3,2) = PcoLi(2,2) ; EnodU(3,3) = PcoLi(3,1) ;
    EnodU(4,1) = PcoLi(1,1) ; EnodU(4,2) = PcoLi(2,2) ; EnodU(4,3) = PcoLi(3,2) ;
    
    EnodU(5,1) = PcoLi(1,2) ; EnodU(5,2) = PcoLi(2,1) ; EnodU(5,3) = PcoLi(3,1) ;
    EnodU(6,1) = PcoLi(1,2) ; EnodU(6,2) = PcoLi(2,1) ; EnodU(6,3) = PcoLi(3,2) ;
    EnodU(7,1) = PcoLi(1,2) ; EnodU(7,2) = PcoLi(2,2) ; EnodU(7,3) = PcoLi(3,1) ;
    EnodU(8,1) = PcoLi(1,2) ; EnodU(8,2) = PcoLi(2,2) ; EnodU(8,3) = PcoLi(3,2) ;
    
end




% 2.- Searchs each corner in Unod:

conE = zeros(1,Ncor);

for c = 1:1:Ncor  
for nod = 1:1:nNO
        
    acc = 0 ;
    for di=1:1:udim
        acc = acc + abs(EnodU(c,di) - mUnod(nod,di));
    end
        
    % nod coincides with corner
  	if acc == 0
      	conE(1,c) = nod;
        break
   	end

end
end



end

