function [ PcoLi, VoidE ] = p2003_ULims_Vspan ( IcoLi, KnotV, udim )

% RETURNS:
% PcoLi(udim,2):    elem limits in param. space
% VoidE(udim,1):    void/filled spans (0/1)

% for mRM mesh

% INPUTS:
% IcoLi:    index limits
% KnotV:    knot vector
% Udim:     No. dims in param. space


PcoLi = zeros(udim,2);
VoidE = zeros(udim,1); % 0 if the span is void in that direction
    
for di = 1:1:udim
        
        iRef = IcoLi(di,1);
        PcoLi(di,1) = KnotV(di,iRef);

        iRef = IcoLi(di,2);
        PcoLi(di,2) = KnotV(di,iRef);
        
        if PcoLi(di,1) ~= PcoLi(di,2)
           VoidE(di) = 1 ; % stores non-void if is the case
        end
        
end
    

    

end

