function [uIEnet, ueffKV, unE] = im2102_updatesIEnet (IEnet, effKV, nE, iuc, udim)

% RETURNS:
% uIEnet, ueffKV: updated elements net and eff. knot vectors
% unE: updated No. elements
% netCoor(udim): coordinates of relevant element (the one with center 'iuc') in uIEnet matrix

% INPUTS:
% INnet:    current net
% effKV:    current effective knot vectors
% nE:       current No. elements
% iuc(udim): inserted param. coodinate, to be at on of the mid-spans, with 3 directions





% EFFECTIVE KNOT VECTOR:

% netCoor = zeros(udim,1);

idir = zeros(udim,1); % direction of effKV where insertion is located right afterwards or on it (in case of insertion coordinate extg. in effKV)
addF = zeros(udim,1); % flag to add plane of zeros, if = 1 add zeros, if = 0 no
ueffKV = zeros(udim, size(effKV,2));

for di=1:1:udim
    
    conta = 0;
    iFlag = 0 ;
    for i = 1:1:size(IEnet,di)+1
        
        conta = conta+1;
        
        if effKV(di,i) < iuc(di) 
            
            ueffKV(di,conta) = effKV(di,i);
            
        elseif effKV(di,i) == iuc(di)
            
            ueffKV(di,conta) = effKV(di,i);
            iFlag = 1 ;
            idir(di) = i-1 ;
            addF(di) = 0 ;
            %netCoor(di) = i-1 ;
        else
            
            if iFlag == 0
                
                ueffKV(di,conta) = iuc(di);
                conta = conta+1;
                ueffKV(di,conta) = effKV(di,i);
                
                iFlag = 1 ;
                idir(di) = i-1 ;
                addF(di) = 1;
                %netCoor(di) = i-1 ;
                
            elseif iFlag == 1
                
                ueffKV(di,conta) = effKV(di,i);
                
            end
        end
    end 
end


% UPDATES No. ELEMENTS:
unE = nE + 2^udim - 1 ;



% ELEMENTS NET:

newS = zeros(udim,1); % uIEnet sizes

for di=1:1:udim
    
    if addF(di) == 0
        newS(di) = size(IEnet,di);
    else
        newS(di) = size(IEnet,di) + 1 ;
    end
end


uIEnet = zeros (newS(1), newS(2), newS(3)); % some dims. might increase



% fills up , with zeros 'planes' where new insertion is:

copF = zeros(udim,1); % flag to copy from IEnet to uIEnet


ci = 0 ;
for i = 1:1: newS(1)
    
    copF(1) = 0 ;
    if i ~= idir(1)+1 || (i == idir(1)+1 && addF(1)==0)
  	copF(1)=1;
    ci = ci + 1 ;
    end
    
    cj = 0;
    for j = 1:1: newS(2)
        
        copF(2) = 0 ;
        if j ~= idir(2)+1 || (j == idir(2)+1 && addF(2)==0)
       	copF(2)=1;
        cj = cj + 1 ;
        end
        
        ck = 0;
        for k = 1:1: newS(3)
            
            copF(3) = 0 ;
            if k ~= idir(3)+1 || (k == idir(3)+1 && addF(3)==0)   
          	copF(3)=1;
            ck = ck + 1 ;
            end

            if (copF(1)==1) && (copF(2)==1 && copF(3)==1)
                uIEnet(i,j,k) = IEnet(ci,cj,ck);
            end

        end
    end
end



% fills correspondant new elements: recall starting corner is at idir+1


contaE = nE ;

for i=1:1:2
    for j=1:1:2
        for k=1:1:2
            
            if i~=1 || (j~=1 || k~=1)
                
                contaE = contaE + 1 ;
                
                uIEnet(idir(1)+i-1, idir(2)+j-1, idir(3)+k-1) = contaE ;
                
            end
            
            
        end
    end
end




end

