function [uIconENp] = im2106_upConn (IconENp, nNOpp, mNp, ImE, ULims, Unn, affEp, Naep, nse, seR, udim)

% RETURNS: updated connection matrices

% INPUTS:
% IconENp: original con. matrix
% nNOpp: No. nodes previous to insertion
% Ulims(udim,2): original param. limits of part'd element
% Unn(Nnn,udim): Ucoor of new nodes
% affEp(Naep): ref's of affected elements previous to insertion
% seR(nse): new sub-elements references

uIconENp = IconENp ;
Nnn = size(Unn,1); % No. new nodes


% 1.- GENERATES:
% - MATRIX WITH ALL INVOLVED NODES (POTENTIAL NODES OF NEW ELEMENTS): Uin
% - MATRIX WITH their references: inR

% add to Nnn nodes from affEp

% 1.1.- Extracts nodes from affEp and element partitioned itself:

affN = zeros(1,1);

% aff'd elements:
contaN = 0 ;
for e = 1:1:Naep
    
    eR = affEp(e);
    for n = 1:1: 2^udim
        contaN = contaN + 1 ;
        affN(contaN,1) = IconENp(eR,n);
    end
end

% partitioned element itself:
eR = seR(1);
for n = 1:1: 2^udim
    contaN = contaN + 1 ;
	affN(contaN,1) = IconENp(eR,n);
end 

[affN , ~] = GEN_16_RemoveRepeatedRows (affN, 1, 0.1);


% 1.2.- Initiates Uin / inR with new nodes:

Uin = Unn ;
Nin = Nnn;

inR = zeros(Nnn,1);
for n = 1:1:Nnn
inR(n,1) = nNOpp + n ;
end



% 1.3.- Add to Uin / inR the nodes from affEp

u = zeros(udim,1);

for n = 1:1:size(affN,1)

    nR = affN(n);
    for di=1:1:udim
        u(di) = mNp(nR).mUcoor(di);
    end
    
    % only computes if is in teh limits of the original element:
    IN = GEN_08_Orthodomain_Pin (u, ULims, udim, 'closed', 0);
    
    if IN==1
        
        Nin = Nin + 1 ;
        
        for di=1:1:udim
            Uin(Nin,di) = u(di);
        end
        
        inR(Nin,1) = nR;
    end
end



% 2.- LOOP ON SUB-ELEMS REF'S TO ALLOCATE NODES FROM Uin / inR:

for e = 1:1:nse
    
    eR = seR(e);
    
    % corners U coord's of element 'eR'
 	cor =  ImE(eR).cornersPcoor(udim); 
    
    for c = 1:1:2^udim
            
        for di = 1:1:udim
            u(di) = cor(c,di);
        end
            
    	[alreadyIN, loc] = GEN_21_alreadyIN_tol (Uin, Nin, udim, u, 9);
            
        if alreadyIN==1
            uIconENp(eR,c) = inR(loc);
        end
            
    end

end




end

