function [Uclo] = im2199_skinCmP (skin, Xb)

% RETURNS:
% Uclo: Ucoor (in terms of skin param. space)
% of closest point of mP collection of skin to a base point Xb

% INPUTS:
% skin: skin to find it closest mP point
% Xb (xdim,1): physical coord's of base point (ref. to find closest skin point from)
% works in physical space, but gives answer in skin param. space

conM = skin.conM;
mP  = skin.mP; 
nE = size(conM,1);
dXmin = 99999999999999999999;

for e = 1:1:nE
    
    % triangle CoG. xcoord:
    Xctr = (mP(conM(e,1)).mXcoor + mP(conM(e,2)).mXcoor + mP(conM(e,3)).mXcoor) / 3 ;

    dist = norm(Xctr - Xb);
    if dist < dXmin
        dXmin = dist; 
        Uclo = (mP(conM(e,1)).mUcoor + mP(conM(e,2)).mUcoor + mP(conM(e,3)).mUcoor) / 3 ;
    end
end

end

