function [unNOp, umNp, Unn] = im2104_upNodes (gPatch, pa, IconENp, nNOp, mNp, Naea, affEa, ULims, udim)


% RETURNS:
% updated nodes features, considering new nodes and elements

% INPUTS:
% affEp(Naep,1): affected elements prev. to insertion: uses for detect which nodes are new
% affEa(Naea,1): affected elements after insertion: uses for detect which nodes are new

% ULims: original param. limits of elemetns patitioned


% 1.- STORES CANDIDATES NODES Ucoord's: Ncn , Ucn(Ncn,udim)

% No. candidate nodes:
if udim==2
    Ncn = 5 ;
elseif udim==3
    Ncn = 19 ;
end


% set Ucoord's of candidate nodes

Ucn = zeros(Ncn,udim);
contaN = 0 ;

for i = 0:0.5:1
for j = 0:0.5:1
for k = 0:0.5:1
    
    if (i~=0 && i~=1) || ( (j~=0 && j~=1) || (k~=0 && k~=1))
        
        contaN = contaN + 1 ;
        Ucn(contaN,1) = ULims(1,1) + i * (ULims(1,2) - ULims(1,1));
        Ucn(contaN,2) = ULims(2,1) + j * (ULims(2,2) - ULims(2,1));
        Ucn(contaN,3) = ULims(3,1) + k * (ULims(3,2) - ULims(3,1));
    end
end
end
end



% 2.- STORES EXTG. AFF'D ELEMENTS NODES Ucoord's: Nen, Uen(Nen,udim)

% transfer all affd elems nodes ref's to enR

enR  = zeros(1,1); % First '1' will increase to No. nodes ref's
Ncor  = 2^udim;
contaN = 0 ;


for e = 1:1:Naea
    
    eR = affEa(e);
    
    if eR < size(IconENp,1); % only stores nodes of elements pre-extg.!R
        
        for i = 1:1:Ncor
            contaN = contaN + 1;
            nR = IconENp(eR,i);
            enR(contaN,1) = nR;
        end  
    end
end



% No. extg. nodes:

if contaN == 0
    Nen = 0 ;
else
    [enR,~] = GEN_16_RemoveRepeatedRows (enR, 1, 0.1);
    Nen = size(enR,1);
end


% transfers extg. Ucoord's to Uen

Uen = zeros(1,udim);

for n = 1:1:Nen
    
    nR = enR(n);
    for di = 1:1:udim
    Uen(n,di) = mNp(nR).mUcoor(di);
    end
end


% 3.- DETECTS WHICH NODES ARE NOT ALREADY EXTG. STORES IN Unn(Nnn,udim), No. new nodes = Nnn

% 3.1.- Note if Nen=0 transfers directly from Ucn:

if Nen==0
    Unn = Ucn ;
    Nnn = Ncn ;
end


% 3.2.- Otherwise compares with Ucn against Uen:

if Nen > 0

    Unn = zeros(1,udim);
    contaN = 0 ;
    u = zeros(udim,1);

    for ca = 1:1:Ncn

        for di=1:1:udim
        u(di) = Ucn(ca,di); 
        end

        [alreadyIN] = GEN_21_alreadyIN_tol (Uen, Nen, udim, u, 9);

        if alreadyIN==0
            contaN = contaN + 1 ;
            for di=1:1:udim
                Unn(contaN,di) = u(di);
            end
        end
    end

    Nnn =  contaN;
end

% 4 .- UPDATES nNOp and mNp WITH NEW NODES:

unNOp = nNOp + Nnn ;


% add new nodes to mNp (extend it):

umNp = mNp;

for nod = 1:1:Nnn
    
    nR = nNOp + nod ;
    
    % param. coord's:
    for di = 1:1:udim
        u(di) = Unn(nod,di);
        umNp(nR).mUcoor(di) = Unn(nod,di);
    end
    
    % physical coord's:
    [X] = b2602_BNURBS_Xcoord_gPatch (u, gPatch, pa);
    umNp(nR).mXcoor = X;
    
end



end

