function [ Nixi ] = GEN_0603_planeTriN( i, Txi, n, a )

% RETURNS:
% Nixi: value of basis funcion i at xi location for a plane triangle polynomial
% based on Benito's book, eq's (9.34) & (9.35)

% INPUTS:
% i:        Bf or node reference
% Txi(3,1): triangluar coordinates of the point where we want the basis function computed at
% n:        order of triangle = SUM(a)
% a(3,1):   triangular coord's of the node 'i' (alfa, beta, gamma in Benito's book)


L  = ones(3,1); % Lagrange pols.


Nixi = 1;


% Lagrange pols in each. direction
for j = 1:1:3
    
    % computes Lagrange pols in dir. j for each position:
    
   	if a(j)==0
        
       L(j) = 1 ; 
       
    else
 
        for pos = 1:1:a(j)   
            L(j) = L(j) * (n * Txi(j) - pos + 1) / pos ;
        end

    end
       

    
    
    Nixi = Nixi * L(j);

end


    if (Txi(1,1)==1 && Txi(2,1)==0)  && Txi(3,1)==1

                %[i a']
                %L
            %Nixi
    end

    Nixi = Nixi/4;

end

