function [z] = GEN_0605_planeTriPolZ (NCP, pr, Znc)

% RETURNS:
% z:        value of polynomial approx. of plane triangle at pr location


% INPUTS:
% NCP:          No. Newton-cOtes points
% pr(udim):     parent coordinates where compute z
% Znc(Nnc,1):   z coordinates of N-C nodes


% For each case computes Z coord as linear combination of basis funct's N:

N = zeros(NCP,1);

if NCP == 3
    
    N(1,1) = 1 - pr(1,1) - pr(2,1);
    N(2,1) = pr(1,1);
    N(3,1) = pr(2,1);

elseif NCP == 6
    
    N(1,1) = 1 - 3*pr(1,1) - 3*pr(2,1) + 2*pr(1,1)^2 + 4*pr(1,1)*pr(2,1) + 2*pr(2,1)^2 ;
    N(2,1) = - pr(1,1) + 2*pr(1,1)^2 ;
    N(3,1) = - pr(2,1) + 2*pr(2,1)^2 ;
    N(4,1) = 4*pr(1,1) - 4*pr(1,1)^2 - 4*pr(1,1)*pr(2,1);
    N(5,1) = 4*pr(1,1)*pr(2,1);
    N(6,1) = 4*pr(2,1) - 4*pr(2,1)^2 - 4*pr(1,1)*pr(2,1);

end

z = N'*Znc ;

% anod(Nnod,3): triangular coord's of the nodes (alfa, beta, gamma in Benito's book)
% Znod(Nnod):   z coordinate of nodes
% n:            order   
% xVer(3,2):    coord's of triangular vertex
% xi(2,1):      location where compute z




end

