function [ WkG ] = GEN_19_agregatesWgp( Wk, NGPd , udim)

% RETURNS:
% WkG(NGPd^udim):   aggregated weights of Gauss points for IGA standard
%                   elements (lines, rect's, bricks)

% INPUTS:
% Wk(NGPd): desagregated weights in each direction
% NGPd:     No. Gp's in each direction
% udim:     No. dims in param. space



% prepares NGPt matrix, which is 3,1 by default:
NGPt = ones(3,1);
for di=1:1:udim
    NGPt(di,1) = NGPd;
end
  


% Generates Wke, which is = 1 if is not defined
Wke = ones(3,NGPd);
for di = 1:1:udim
for g=1:1:NGPd
    Wke(di,g) = Wk(g);
end
end
            
% computes GP's weights for global g index: 
WkG = ones(NGPd^udim,1);



g=1;


    
    for g1 = 1:1:NGPt(1)
    for g2 = 1:1:NGPt(2)   
    for g3 = 1:1:NGPt(3)

        WkG(g) = Wke(1,g1) * Wke(2,g2) * Wke(3,g3) ;
        g=g+1;
    end
    end    
    end




end

