function [aGPpc, aGPw, aNGP] = ip2302_GP_nD (NGP, udim)

% RETURNS: aggregated GP's, for rect-elems with No. dims: udim = 2 or 3
% aGPpc(aNGP,udim) aGPw(aNGP,1): parent coord's and weights
% aNGP: total No. agregated GP's per element

% INPUTS:
% NGP(udim): No. gp's in each direction

% works hierarchically by dimensions, example for 2D: (1,1), (1,2), (2,1), (2,2)

aNGP = 1 ;
for di=1:1:udim
    aNGP = aNGP * NGP(di);
end

aGPpc = zeros(aNGP,udim);
aGPw  = zeros(aNGP,1);


% parent coord's and weights for each direction:

pc = zeros(udim,1);
w  = zeros(udim,1);
pcd = zeros(udim,1);
wd  = zeros(udim,1);

for di=1:1:udim
    
   [pcd, wd] = ip2301_GP_1D (NGP(di)); 
   
   for i=1:1:NGP(di)
       pc(di,i) = pcd(i);
       w(di,i) = wd(i);
   end
   
end


if udim == 2
    
    g = 0;
    for i=1:1:NGP(1)
    for j=1:1:NGP(2)
          
        g = g+1 ;
        
        aGPpc(g,1) = pc(1,i);
        aGPpc(g,2) = pc(2,j);
        aGPw(g,1)  = w(1,i)*w(2,j);
  	end
    end
    
elseif udim == 3
    
    g = 0;
    for i=1:1:NGP(1)
    for j=1:1:NGP(2)
    for k=1:1:NGP(3)
         
        g = g+1 ;
        
        aGPpc(g,1) = pc(1,i);
        aGPpc(g,2) = pc(2,j);
        aGPpc(g,3) = pc(3,k);
        aGPw(g,1)  = w(1,i)*w(2,j)*w(3,k);
  	end
    end
    end
end

end

