function [ GPpc, GPw ] = ip2304_GP_tet (NGP)

% RETURNS: (for tet. 3D element)
% GPpc: GP parent coordinates
% GPw:  GP weights

GPpc = zeros(NGP,3);
GPw = zeros(NGP,1);

if NGP == 1     % order 1
    
    GPpc(1,1) = 1/4;    GPpc(1,2) = 1/4;    GPpc(1,3) = 1/4;
    
    GPw(1) = 1/6 ;

    
elseif NGP == 4 % order 2
    
    a = 0.58541020 ;
    b = 0.13819660 ;
    
    GPpc(1,1) = a;    GPpc(1,2) = b;    GPpc(1,3) = b;
    GPpc(2,1) = b;    GPpc(2,2) = a;    GPpc(2,3) = b;
    GPpc(3,1) = b;    GPpc(3,2) = b;    GPpc(3,3) = a;
    GPpc(4,1) = b;    GPpc(4,2) = b;    GPpc(4,3) = b;

    for i = 1:1:4
        GPw(i) = (1/4)/6 ;
    end

elseif NGP == 5 % order 3
    
    GPpc(1,1) = 1/4;    GPpc(1,2) = 1/4;    GPpc(1,3) = 1/4;
    GPpc(2,1) = 1/6;    GPpc(2,2) = 1/6;    GPpc(2,3) = 1/6;
    GPpc(3,1) = 1/6;    GPpc(3,2) = 1/6;    GPpc(3,3) = 1/2;
    GPpc(4,1) = 1/6;    GPpc(4,2) = 1/2;    GPpc(4,3) = 1/6;
    GPpc(5,1) = 1/2;    GPpc(5,2) = 1/6;    GPpc(5,3) = 1/6;
    
    GPw(1) = -2/15 ;
    for i=2:1:5
        GPw(i) = 3/40 ;
    end

    
end




end

