function [J, dJ] = j2311_JPlaneRect (Ucoor, Xnodes)

% RETURNS:
% J, dJ:   Jacobian and its determinant for a plane rect. bilinear

% INPUTS:
% Ucoor:    param coord's where compute J
% Xnodes:    elements 4 nodes coord's in physical space (4,2)

% Note assumes nodes counter-clock-wise, starting at top-right

J = zeros(2,2);

u = Ucoor(1);
v = Ucoor(2);

for i=1:1:2
    J(1,i) = ((1+v)*Xnodes(1,i) - (1+v)*Xnodes(2,i) - (1-v)*Xnodes(3,i) + (1-v)*Xnodes(4,i)) / 4 ;    
    J(2,i) = ((1+u)*Xnodes(1,i) + (1-u)*Xnodes(2,i) - (1-u)*Xnodes(3,i) - (1+u)*Xnodes(4,i)) / 4 ;   
end


dJ = det(J);

%{
fcond = norm(J,'fro')^2/dJ;

J
dJ
fcond
%}

end

