function [ J ] = j2312_JPlaneTri (x, Xnod, Nn, udim)

% RETURNS:
% J:    Jacobian for Nn nodes triangle (from parent space to param. space)
% note returns the matrix, not the determinant!

% INPUTS:
% x(udim):          Physical coord's of the point where compute the Jacobian at
% Xnod(Nn,udim):    triangle nodes coord's
% Nn:               No. nodes (Newton-Cotes points)


% 0.- Prelim. size:

% J = zeros(2,2);
Nxi = zeros(udim, Nn);



% 1.- Basis functions derivatives matrix:

if Nn==3
    
    % deriv. about xi
    Nxi(1,1) = -1 ;
    Nxi(1,2) =  1 ;
    Nxi(1,3) =  0 ;

    % deriv. about ita
    Nxi(2,1) = -1 ;
    Nxi(2,2) =  0 ;
    Nxi(2,3) =  1 ;

elseif Nn==6
    
    % deriv. about xi
    Nxi(1,1) = -3 + 4*x(1) + 4*x(2) ;
    Nxi(1,2) = -1 + 4*x(1);
    Nxi(1,3) = 0 ;
    Nxi(1,4) = 4 - 8*x(1) - 4*x(2);
    Nxi(1,5) = 4*x(2) ;
    Nxi(1,6) = -4*x(2) ;

    % deriv. about ita
    Nxi(2,1) = -3 + 4*x(1) + 4*x(2) ;
    Nxi(2,2) = 0 ;
    Nxi(2,3) = -1 + 4*x(2) ;
    Nxi(2,4) = -4*x(1) ;
    Nxi(2,5) = 4*x(1) ;
    Nxi(2,6) = 4 - 4*x(1) - 8*x(2) ;
    
end





% 2.- Computes Jacobian at x:

J = Nxi*Xnod ;





end

