function [J, dJ] = j2314_Jcuboid (Ucoor, Xn)

% RETURNS:
% J, dJ:   Jacobian and its determinant for a linear cuboid

% INPUTS:
% Ucoor:    param coord's where compute J
% Xn:    elements 8 nodes coord's in physical space (8,2)

% Note assumes nodes arranged in parameter hierarchical order

J = zeros(3,3);

u = Ucoor(1);
v = Ucoor(2);
w = Ucoor(3);


% each row of J is one derivative, i.e. J = [ X,u ; X,v ;  X,w ]

for c = 1:1:3
    
    J(1,c)= (- (1-v)*(1-w)*Xn(1,c) - (1-v)*(1+w)*Xn(2,c) - (1+v)*(1-w)*Xn(3,c) - (1+v)*(1+w)*Xn(4,c) ...
             + (1-v)*(1-w)*Xn(5,c) + (1-v)*(1+w)*Xn(6,c) + (1+v)*(1-w)*Xn(7,c) + (1+v)*(1+w)*Xn(8,c))/1 ;  
    
    J(2,c)= (- (1-u)*(1-w)*Xn(1,c) - (1-u)*(1+w)*Xn(2,c) + (1-u)*(1-w)*Xn(3,c) + (1-u)*(1+w)*Xn(4,c) ...
             - (1+u)*(1-w)*Xn(5,c) - (1+u)*(1+w)*Xn(6,c) + (1+u)*(1-w)*Xn(7,c) + (1+u)*(1+w)*Xn(8,c))/1 ;  
        
	J(3,c)= (- (1-u)*(1-v)*Xn(1,c) + (1-u)*(1-v)*Xn(2,c) - (1-u)*(1+v)*Xn(3,c) + (1-u)*(1+v)*Xn(4,c) ...
             - (1+u)*(1-v)*Xn(5,c) + (1+u)*(1-v)*Xn(6,c) - (1+u)*(1+v)*Xn(7,c) + (1+u)*(1+v)*Xn(8,c))/1 ;  
end

J = J / 8;

dJ = det(J);


%{
fcond = norm(J,'fro')^2/dJ;

J
dJ
fcond
%}


end

