function [J2, dJ2] = j2317_J2_tets (Xnod, iem)

% RETURNS:
% J2 from parent to param space of tetrahedron

%           | Xi,r    Ita,r ... |
%   J2 =    |                  |
%           | Xi,s    Ita,s    |
%           | ..

% INPUTS:
% Xnod(Nne,dim): nodal coord's in projected space

pdim = 3 ; % parent dims
udim = 3 ; % param. dims

J2 = zeros(pdim, udim);

Nne = 4 + nnz(iem)/2;


% Computes shape functions:

if nnz(iem)==0 % linear tetrahedral
    
    dN = zeros(Nne,pdim);
    
    dN(1,1) = 1;
    dN(2,2) = 1;
    dN(3,3) = 1;
    
    dN(4,1) = -1 ;
    dN(4,2) = -1 ;
    dN(4,3) = -1 ;
    
end


% Computes derivatives:

for fil = 1:1:pdim
for col = 1:1:udim

    acc = 0 ;
    for i = 1:1:Nne
        acc = acc + dN(i,fil)*Xnod(i,col);
    end

    J2(fil,col) = acc ;
    
end
end




dJ2 = det(J2);



end

