function [D] = e2404_2DmatrixIso (E,nu, Anty)

% RETURNS:
% D for isotropic material

D = zeros(3,3);

if Anty==1  % p. stress
    
    c = E/(1-nu^2);
    
    D(1,1) = c ;
    
    D(1,2) = nu*c;
    
    D(2,1) = nu*c;
    
    D(2,2) = c ;
    
    D(3,3) = c * (1-nu)/2;
    
elseif Anty==2  % p. strain
    
    
 	c = E*(1-nu)/((1+nu)*(1-2*nu));
    
    D(1,1) = c ;
    
    D(1,2) = nu/(1-nu)*c;
    
    D(2,1) = nu/(1-nu)*c;
    
    D(2,2) = c ;
    
    D(3,3) = c * (1-2*nu)/(2-2*nu);
    
    
end


end

