function D = e2405_3DmatrixOrthoElastic (MTL)

% RETURNS: constitutive matrix for 3 dimensions and Ortho-elatic 

% 0.- Prelim. size and constants calculation:

D = zeros(6,6);

E1 = MTL.E(1) ;     E2 = MTL.E(2) ; 	E3 = MTL.E(3) ;
G12 = MTL.G(1) ;    G23 = MTL.G(2) ;    G31 = MTL.G(3) ;
nu12 =  MTL.nu(1);  nu23 = MTL.nu(2);   nu31 = MTL.nu(3) ;

del = ( 1 - nu12^2 - nu23^2  - nu31^2 - 2*nu12*nu23*nu31 ) / (E1*E2*E3) ;

% 1.- Elastic regime:

D(1,1) = ( 1 - nu23^2) / (E2*E3*del) ;
D(2,2) = ( 1 - nu31^2) / (E3*E1*del) ;
D(3,3) = ( 1 - nu12^2) / (E1*E2*del) ;

D(1,2) = (nu12 + nu23*nu31) / (E2*E3*del) ;
D(2,1) = D(1,2) ;

D(1,3) = (nu31 + nu12*nu23) / (E2*E3*del) ;
D(3,1) = D(1,3) ;

D(2,3) = (nu23 + nu12*nu31) / (E1*E3*del) ;
D(3,2) = D(2,3) ;

D(4,4) = 1*G12 ;
D(5,5) = 1*G23 ;
D(6,6) = 1*G31 ;
  

end

