function [PL, A,B,C,D] = go2505_cloudP_plane (np, P)

% RETURNS: 
% PL:       0 / 1  if cloud of points P DO NOT form a plane or YES, form a plane
% A,B,C,D:  plane eq. coefficients, in case P forms a plane


% INPUTS:
% np: No. points
% P(np,xdim): cloud of points coordiantes


xdim = 3 ; % points are in 3D


% 1.- FINDS 3 NON-COPLANAR POINTS: a, b, c

a = zeros(xdim,1);
b = zeros(xdim,1);
c = zeros(xdim,1);

for di=1:1:xdim
    a(di,1) = P(1,di);
    b(di,1) = P(2,di);
end

for po = 3:1:np
    
    for di=1:1:xdim
        c(di,1) = P(po,di);
    end

    % if non-co-linear then CL = 0
    [CL,~,~] = go2508_cloudP_line (3, [a';b';c']);
    
    if CL==0
        break
    end
end


% 2.- COMPUTES PLANE COEFFICIENTS:

[A,B,C,D] = go2506_Plane3P (a,b,c);



% 3.- CHECK IF ALL POINTS MEET THE PLANE EQUATION:

PL = 1 ;         % initially assumes P form plane
tolp = 0.000001; % tolerance for plane equation

for po = 1:1:np
    
    err = A*P(po,1) + B*P(po,2) + C*P(po,3) + D ;
    if abs(err) > tolp
        PL = 0;
        break
    end
    
end



end

