function [A,B,C,D] = go2506_Plane3P (a,b,c)

% RETURNS:
% coeff's of implicit plane equation: Ax + By +Cz + D = 0

% INPUTS:
% a, b, c: points coordiantes in 3D

% u,v:  vectors in plane
xdim = 3 ;
u = zeros(xdim,1);
v = zeros(xdim,1);

for di=1:1:xdim
    u(di) = b(di)-a(di);
    v(di) = c(di)-a(di);
end

% plane implicit equations coefficients:
A = u(2)*v(3) - u(3)*v(2);
B = u(3)*v(1) - u(1)*v(3);
C = u(1)*v(2) - u(2)*v(1);
D = -A*a(1) - B*a(2) - C*a(3);

end

