function [AL] = go2512_TnodAligned (Cnod, dim, tol)

% RETURNS:
% AL = 1 / 0 if three nodes of triangle are aligned or not

% INPUTS:
% Cnod(3,dim): coordiantes of the three nodes
% dim: dimensions of the space
% tol: tolerance in % to consider the 3rd point on the line or not
% applies to D, being D the diameter of the circunscrit circle


% 1.- Evelope distance or external circle diameter: D

v1 = zeros(dim,1);
v2 = zeros(dim,1);

for di=1:1:dim
    v1(di) = Cnod(3,di) - Cnod(1,di);
    v2(di) = Cnod(2,di) - Cnod(1,di);
end


D = norm(v1);
if norm(v2) > D
    D = norm(v2);
end

% 2.- Computes line eq. parameters from 1 to 2 nodes and takes 3rd point:

P3 = zeros(dim,1);
Pr = zeros(dim,1);
vr = v2;

for di = 1:1:dim
    Pr(di) = Cnod(1,di);
    P3(di) = Cnod(3,di);
end


% 3.- Measures distace from 3rd to line:

[dist,~] = go2527_distPtoRecta (P3, Pr, vr, dim);


% 4.- Compares distance with tolerance:

if dist > D*tol/100
    AL = 0;
else
    AL = 1;
end



end

