function [Pc, conMc] = go2513_ClearTetMesh (P, conM)

% RETURNS: tet. mesh parameters deleting those tet. that are almost planar


Ne = size(conM,1);
ndim = 3 ;
nne = 4 ;

F = zeros(nne,ndim);
tol = 0.5 ; % tolerance to consider plane tet. in percenrage of max.length

Pc = P ; % nodes are the same

Nec = 0 ; % No. elements cleared need to be re-computed
conMc = zeros(1,nne);


for e = 1:1:Ne
    
    % extracts tet. nodes to F array
    for nod = 1:1:nne
        nR = conM(e,nod);
        for di=1:1:ndim
            F(nod,di) = P(nR,di);
        end
    end
    
    % determines if plane tet.
    cp = go2514_4Pcoplanar (F, ndim, tol);
    
    % in case of non-planar adds:
    if cp==0
        
        Nec = Nec + 1 ;
        
        for nod = 1:1:nne
        conMc(Nec,nod) = conM(e,nod);
        end

    end
    
end




end

