function [ui, iF] = go2517_ParalelSegmInters2D (ua1, ua2, ub1, ub2, nd)

% RETURNS:
% ui : intersection point
% iF: intersection flag = 1 if intersects, 0 if not

% INPUTS:
% ua1,ua2 / ub1,ub2: end points of segments
% nd: No. digits for rounding

% works in 2D and assumes that the intersection point (if exists) is one of
% the end points of segment 'b'


% 1.- DETERMINES SEARCHING DIRECTION (the one that is constant):

sd = 0 ;

if round(ub1(1),nd) == round(ua1(1),nd) && round(ub2(1),nd) == round(ua2(1),nd)
    sd = 2 ;
elseif round(ub1(2),nd) == round(ua1(2),nd) && round(ub2(2),nd) == round(ua2(2),nd)
    sd = 1 ;
end
   
% 1.1.- If does not find 'sd' is because both segments are parallel but not
% on the same line => returns no intersection:

if sd == 0
    
    ui = zeros(1,2);
    iF = 0 ;
    return 
end




% 2.- DEFINES SEGMENT 'a':

segL = [min(ua1(sd),ua2(sd)) , max(ua1(sd),ua2(sd))];



% 3.- CHECKS IF ANY OF THE TWO 'b' POINTS IS INSIDE THE SEGMENT 'a':

ui = zeros(1,2);
iF = 0 ;

if (segL(1) <= ub1(sd) && ub1(sd) <= segL(2))
    ui = ub1 ;
    iF = 1;
end
                    
if (segL(1) <= ub2(sd) && ub2(sd) <= segL(2))
    ui = ub2 ;
    iF = 1;  
end


end

