function [Pp] = go2518_POntoP(P, n, xp)

% RETURNS:
% Pp:  P projected onto plane

% INPUTS:
% P: point to project
% n: normal to plane
% xp: point that belongs to plane

xdim = 3 ;

u = n/norm(n); % line versor

d = -(n(1)*xp(1) + n(2)*xp(2) + n(3)*xp(3)); % 4th coeff. of plane equation

t = -(n(1)*P(1) + n(2)*P(2) + n(3)*P(3) + d) / (n(1)*u(1) + n(2)*u(2) + n(3)*u(3)) ; % parameter or line where intersects


Pp = zeros(xdim,1);

for di = 1:1:xdim
    Pp(di) = P(di) + t*u(di);
end


end

