function [D] = go2519_planeFit (A, sX, m, xdim)

% RETURNS: plane fitted to a cloud of points

% D: plane normal versor (that plane passes through A)

% uses orthogonal distance instead vertical
% taken from:
% http://www.sci.utah.edu/~balling/FEtools/doc_files/LeastSquaresFitting.pdf

% INPUTS:
% A(xdim,1): one point of the desired plane (suggestion: A = average (sX))
% sX(m,xdim): sample points
% m: No. points
% xdim: No. dimensions, here is always 3 !

% matrix M components:

M = zeros(xdim,xdim);

for fil = 1:1:xdim
for col = 1:1:xdim
        
    for i = 1:1:m
        M(fil,col) = M(fil,col) + ( sX(i,col)-A(col) ) * ( sX(i,fil)-A(fil) )  ;
    end
    
end
end



% finds eigen vectors (selectes the first):

[V,E] = eig(M); % E: eigen values matrix, V 3 cols for each eigen vector

D = V(:,1);



end

