function [ON] = go2520_PonSegment (P, a,b, dim, tolL)

% RETURNS:
% ON = 1 if P on segment a-b
% checks if the point 'P' is on a segment given by 'a' and 'b'

% INPUTS:
% P(dims):      point to check
% a,b(dims):    points of segment
% dims:         No. dims
% tolerance:    in percentage of a-b distance

% to check it: finds projection on line, and then if that Pp is within the segment
% (with in a tolerance)

ON = 0;

% computes tolerance:

dab = a-b;
dtol = norm(dab) * tolL/100;


% distance fom P to a-b , and its projection:

vr = b-a;
[dist, d] = go2527_distPtoRecta (P, a, vr, dim);

Pp = P + d ;

% if distance < dtol carries on

if dist < dtol
    
    % checks if Pp is within the segment:
    
    daP = Pp-a;
    dbP = Pp-b;
  
    
    if (norm(daP) < norm (dab)) && (norm(dbP) < norm (dab)) 
        ON = 1 ;
    end
    
end


end