function [D] = go2521_lineFit (A, sX, m, xdim)

% RETURNS: plane fitted to a cloud of points

% D: line direction versor (that line passes through A)

% uses orthogonal distance instead vertical
% taken from:
% http://www.sci.utah.edu/~balling/FEtools/doc_files/LeastSquaresFitting.pdf

% INPUTS:
% A(xdim,1): one point of the desired line (suggestion: A = average (sX)
% sX(m,xdim): sample points
% m: No. points
% xdim: No. dimensions


I = eye(xdim);

% scalar delta: 'd' 

dtemp = zeros(xdim,1);

for i = 1:1:m
    for di = 1:1:xdim
        dtemp(di) = dtemp(di) + (sX(i,di)-A(di))^2 ;
    end
end

d = sum(dtemp);



% matrix N components:

N = zeros(xdim,xdim);

for fil = 1:1:xdim
for col = 1:1:xdim
        
    for i = 1:1:m
        N(fil,col) = N(fil,col) + ( sX(i,col)-A(col) ) * ( sX(i,fil)-A(fil) )  ;
    end
    
end
end


% assemblies matrix M:

M = d*I-N;


% finds eigen vectors (selectes the first):

[V,E] = eig(M); % E: eigen values matrix, V 3 cols for each eigen vector

D = V(:,1);






end

