function [CP] = go2523_P_to_nLines (a, v, N, xdim)

% RETURNS:
% CP(xdim,1): closest point of a set of n Lines

% INPUTS:
% a(N, xdim): points of each line
% v(N, xdim): versor of each line
% N: No. lines
% xdim: No. dims of the problem

% works out LSM as per Applied Linear Algebra (Olver/Shakiban), p.194


% Assemblies A matrix and b vector:

Nfil = (N-1)*xdim;
Ncol = N ;

A = zeros(Nfil,Ncol);
b = zeros(Nfil,1);


accf = 0;

for di = 1:1:xdim
    
    for c = 1:1:Ncol-1

        f = accf+c;

        A(f,c)   = v(c,di);
        A(f,c+1) = -v(c+1,di);   

        b(f,1) = a(c+1,di)- a(c,di);
    end

    accf = accf + (N-1);
end


% solves LSM:

K = A'*A;
h = A'*b;

t = K\h;


% computes points on lines and works out average

CP = zeros(xdim,1);

for i = 1:1:N
for di = 1:1:xdim
    CP(di) = CP(di) + a(i,di) + t(i)*v(i,di);
end
end

CP = CP/N;

end

