function [IP, inter] = go2524_TwoSegmIntersec (ar,br, at,bt)

% RETUNRS: 
% IP:       2 segments intersection point, even in the projection (if they do not intersect)
% inter:    1 if they insertect, 0 otherwise

% ONLY IN 2D 

% INPUTS:
% ra,rb:    points coord's of segment r
% ta,tb:    points coord's of segment t


% 1.- Computes lines constants for each segment: mr,... , nt

mr = (br(2)-ar(2)) / (br(1)-ar(1));
nr = ar(2) - mr*ar(1);

mt = (bt(2)-at(2)) / (bt(1)-at(1));
nt = at(2) - mt*at(1);


% 2.- Computes insersection point:

IP(1) = (nt-nr) / (mr-mt);
IP(2) = mr * IP(1) + nr ;


% 3.- Corrects if slope is infinite:

if br(1)==ar(1) 
    IP(1) = ar(1);
    IP(2) = mt * IP(1) + nt ;
end

if bt(1)== at(1)
    IP(1) = at(1);
    IP(2) = mr * IP(1) + nr ;
end



% 4.- Determines if IP is inside both segments:

% 4.1.- Case of parallel segments (special):
if mr==mt
    
    IP=zeros(2,1);
    inter = 0 ;
    
% 4.2.- Rest of the cases:
else
    
    ON=zeros(2,1);
    
    ON(1) = go2520_PonSegment ( IP, ar,br, 2 , 0.01);
    ON(2) = go2520_PonSegment ( IP, at,bt, 2 , 0.01);
    
    if sum(ON)==2
       inter = 1 ; 
    else
       inter = 0 ;
    end
    
end


end

