function [IP, iF, pF] = go2526_TwoLinIntersec (ar,br, at,bt, modo, nd)

% RETURNS: 
% IP: 2 lines inters. point, even in the projection (if the segment do not intersect)
% iF(2): 'IN' flag, if IP belongs to segment = 1, otherwise = 0. Two values for 2 segments
% pF: parallel lines flag = 1 if paralell, 0 if not

% ONLY IN 2D 

% INPUTS:
% ra,rb:    points coord's of line r
% ta,tb:    points coord's of line t
% modo: 'open' or 'closed' for computing iF
% nd: No. digits to round up

IP = [0 0];

% 1.- Computes lines constants for each segment: mr,... , nt

mr = (br(2)-ar(2)) / (br(1)-ar(1));
nr = ar(2) - mr*ar(1);

mt = (bt(2)-at(2)) / (bt(1)-at(1));
nt = at(2) - mt*at(1);


% 2.- Checks parallelism:

pF = 0 ;

if (round(mr,nd) == round(mt,nd)) || ( br(1)==ar(1) && bt(1)==at(1) )
    
    iF = [0 0];
    pF = 1 ;
    return
    
end



% 2.- Computes insersection point:

IP(1) = (nt-nr) / (mr-mt);
IP(2) = mr * IP(1) + nr ;



% 3.- Corrects if slope is infinite:

if br(1) == ar(1) 
    IP(1) = ar(1);
    IP(2) = mt * IP(1) + nt ;
end

if bt(1) == at(1)
 
    IP(1) = at(1);
    IP(2) = mr * IP(1) + nr ;

end



% 4.- Determines if is IN:

iF = [0 0];

IPnd = round(IP,nd);
ar   = round(ar,nd);
br   = round(br,nd);
at   = round(at,nd);
bt   = round(bt,nd);


if strcmp(modo,'closed')==1


    % segment 'r'
    if min(ar(1),br(1)) <= IPnd(1) && IPnd(1) <= max(ar(1),br(1))
    if min(ar(2),br(2)) <= IPnd(2) && IPnd(2) <= max(ar(2),br(2)) 
        iF(1) = 1 ;
    end    
    end

    % segment 't'
    if min(at(1),bt(1)) <= IPnd(1) && IPnd(1) <= max(at(1),bt(1))
    if min(at(2),bt(2)) <= IPnd(2) && IPnd(2) <= max(at(2),bt(2)) 
        iF(2) = 1 ;
    end    
    end

    
elseif strcmp(modo,'open')==1
    
    % segment 'r'
    if min(ar(1),br(1)) < IPnd(1) && IPnd(1) < max(ar(1),br(1))
    if min(ar(2),br(2)) < IPnd(2) && IPnd(2) < max(ar(2),br(2)) 
        iF(1) = 1 ;
    end    
    end
    
    % segment 't'
    if min(at(1),bt(1)) < IPnd(1) && IPnd(1) < max(at(1),bt(1))
    if min(at(2),bt(2)) < IPnd(2) && IPnd(2) < max(at(2),bt(2)) 
        iF(2) = 1 ;
    end    
    end

    
end

end

