function [IP, pF] = go2526b_TwoLinInterParam (r,u, s,v, nd, ndim)

% RETUNRS: 
% IP: 2 lines inters. point, even in the projection (if the segment do not intersect)
% pF: parallel lines flag = 1 if paralell, 0 if not

% ONLY IN 2D 

% INPUTS:
% r, s:    points of both lines
% u,v :    versors of each line
% nd: No. digits to round up

IP = zeros(ndim,1);

% 1.- Checks on paralelism:

pF = 1 ;

for di = 1:1:ndim
    if round(u(di),nd) ~= round(v(di),nd)
        pF = 0;
        break
    end
end


if pF == 1
    return
end


% 2.- finds intersection:

A = zeros(2,2);
b = zeros(2,1);

for i = 1:1:2
    
    A(i,1) = u(i); A(i,2) = -v(i);
    b(i,1) = s(i)-r(i) ;
    
end

t = A\b;

for di = 1:1:ndim
    
    IP(di) = r(di) + t(1)*u(di);
    
end


end

