function [ix, tr, ts, pF] = go2526c_parLinInts (vr, vs, br, bs, xdim, nd)

% RETURNS: intersection of two lines given in parametric formulation
% ix(xdim,1): intersection point (in case exists)
% tr, ts,. parameter values of lines at the intersection
% pF: parallel flag = 1, in case lines are parallel

% INPUTS:
% vr, vs: lines versors
% br, bs: lines points

ix = zeros(xdim,1);
tr = 0 ;
ts = 0 ;


[pF] = go2509_ParallelVectors (vr, vs, xdim, nd);


if pF==1

    % parallel vectors (lines do not intersect)

elseif pF==0

        % lines cross point calculation:
        
        M = [vr , -vs];
        b = [bs-br];

        t = M\b ;

        tr = t(1);
     	ts = t(2);
        
        ix = br+vr*t(1);
        
end

end

