function [dist, d] = go2527_distPtoRecta (P, Pr, vr, dim)


% RETURS:
% dist: distance from P to r
% d:    vector P to r (Q - P), Q closest line point to P

% INPUTS:
% P:    point
% Pr:   point of the line
% vr:   vector of the line
% dim: No. dimensions


% 1.- Computes vector PrP:

PrP = zeros(dim,1);
for di=1:1:dim
    PrP(di) = P(di) - Pr(di);
end


% 2.- Computes vector Proy_PrP_vr:

numer = 0 ;
denom = 0 ;
for di=1:1:dim
    numer = numer + vr(di)*PrP(di);
    denom = denom + vr(di)^2 ;
end

Proy = numer/denom * vr ;


% 3.- Computes distance vector from line to P:

d = zeros(dim,1);
for di = 1:1:dim
    d(di) = Proy(di) - PrP(di) ;
end


% 4.- Computes distance:

dist = norm(d);

end

