function [ IN, P ] = GEN_29_OrthoSegInters ( a, b )

% RETURNS:
% IN:   0 / 1 => no-insersect / intersect's
% P(2): location of insertection

% Computes intersection between two ORTHOGONAL segments
% If their prolongations intersect, but not the segment itself, considers IN=0
% Works in 2D

% Considers closed segments limits e.g.: [2 6] , and not (2 6)

% INPUTS:
% a,b:   segments coord's  a ( 2 points, udim)

% Note: a & b coord's do not need to be arranged, the're arranged here


% 0.- Initially considers no intersection:

IN = 0 ;
P = zeros(2,1);


% 1.- Determines which is horizontal and vertical, determines fixed direction for a and b:

if a(1,2) == a(2,2)     % a is horizontal

    af = 2 ;
    bf = 1 ;
    
    xi = b(1,bf); % potential intersection point
    yi = a(1,af);
    
elseif b(1,2) == b(2,2) % b is horizontal  
 
    af = 1 ;
    bf = 2 ;
    
    xi = a(1,af); % potential intersection point
    yi = b(1,bf);
    
end


% 2.- Arranged a and b in raising order:
    
if a(1,bf) > a(2,bf)
    tem = a(2,bf);
    a(2,bf) = a(1,bf);
    a(1,bf) = tem ;
end
    
if b(1,af) > b(2,af)
    tem = b(2,af);
    b(2,af) = b(1,af);
    b(1,af) = tem ;
end
    
    
% 3.- Checks conditions for intersect:
%   a(Dir) belongs to b(1,Dir), b(2,Dir)
%       &&
%   b(pDir) belongs to a(1,pDir), a(2,pDir)

if a(1,bf) <= b(1,bf) && b(1,bf) <= a(2,bf)
if b(1,af) <= a(1,af) && a(1,af) <= b(2,af)
        
    IN = 1 ;
    P(1) = xi;
    P(2) = yi;
        
end    
end



end

