function [IP, fNI] = go2530_LinInters_nD (a1,u1, a2,u2, ndim, nd)

% RETURNS:
% IP(ndim): lines intersection point in n dims
% fNI = 1 if no intersection if found
% nd: No. digits to assume singluar matriz (determinant)

% INPUTS: curves are given in parametric from l(t) = a + ut
% a1, a2(ndim): constants
% u1, u2(ndim): direction versors ( norm(u)=1 !!!)
% ndim: No. dims of the problem


IP = zeros(ndim,1);
fNI = 0 ;
t = zeros(2,1);

% assemblies system:

A = zeros(ndim,2);
b = zeros(ndim,1);

for i = 1:1:ndim
    
    A(i,1) = u1(i);
    A(i,2) = -u2(i);
    
    b(i,1) = a2(i)-a1(i);
    
end




% solves for 2D:

if ndim==2
    
    if abs(det(A))<10^(-nd)  
        fNI = 1;        
    else
        t = A\b; 
    end
end



% solves for 3D:

if ndim==3
    
    A1 = A(1:2,:);
    A2 = A(2:3,:);
    
    b1 = b(1:2,1);
    b2 = b(2:3,1);


    if abs(det(A1))<10^(-nd) && abs(det(A2))<10^(-nd)
        
        fNI = 1;
        
    elseif abs(det(A1))>10^(-nd)
        
        t = A1\b1;
        
  	elseif abs(det(A2))>10^(-nd)
        
        t = A2\b2;
            
    end
end


% computes IP (in case of no interst. uses t=0,0)

i1 = zeros(ndim,1);
i2 = zeros(ndim,1);

for di = 1:1:ndim       
    i1(di) = a1(di) + u1(di) * t(1);  
    i2(di) = a2(di) + u2(di) * t(2);
end

if norm(i1-i2) < 10^(-nd)
    
    IP = (i1+i2)/2;
    fNI = 0;
    
else
    
    fNI = 1;
    
end


%IP(di) = a1(di) + u1(di) * t(1); 


end

