function [N, sd] = go2531_DivSegment (x1, x2, Nmin, R, dim, Lp)

% RETURNS:
% sd(N,dim): N points of segment x1x2 divided acc to Nmin and R distance

% INPUTS:
% x1,x2(dim,1): initial and final points of segment
% Nmin: min. No. points (minimum must be 2!)
% R: target distance of divisions
% dim: dimensions of the problem
% Lp: last point flag: Lp=1 includes x2, Lp=0 x2 is excluded


L = norm(x2-x1); % segment length

N = round(L/R+0.3,0)+1; % No. sub-segments acc to R distance

if N < Nmin
    N = Nmin;
end

Dx = (x2-x1)/(N-1); % increments


if Lp == 0 % effective No. points
    Ne = N-1;
elseif Lp == 1
    Ne = N;
end

sd =  zeros(Ne,dim);


% allocates:

acc = zeros(dim,1);
acc(:,1) = x1(:,1);

for i = 1:1:Ne
    sd(i,:) = acc(:,1);
    acc = acc + Dx;
end


N = Ne;

%{
figure(8)

scatter3( [x1(1) x2(1)], [x1(2) x2(2)], [x1(3) x2(3)], 'r'); hold on
scatter3( sd(:,1), sd(:,2), sd(:,3), 'b'); hold on

axis equal
%}

end

