function [dist, d, Q] = go2534_distPtoPlan (P, A, B, C, D)

% RETURNS:
% dist: distance from P to plane
% d(xdim,1): vector P to plane (Q - P), Q closest plane point to P
% Q(xdim,1): projection onto the plane

% INPUTS:
% P(xdim,1): point coordinates
% A to D: plane equation coefficients

xdim  = 3 ;

% 1.- DISTANCE CALCULATION:

dist = abs( A*P(1) + B*P(2) + C*P(3) + D ) / (A^2 + B^2 + C^2)^0.5 ;


% 2.- PROJECTED POINT FROM P TO PLANE:

Q = zeros(xdim,1);

v = [A, B, C]'; % vector of the line P-Q

% 2.1.- Line parameter 't' that cuts the plane

t = ( A*P(1) + B*P(2) + C*P(3) + D ) / (A^2 + B^2 + C^2) ; 
t = round(t,12);

% 2.2.- Computes Q:

for di = 1:1:xdim
    Q(di,1) = P(di,1) - t*v(di,1);
    %Q(di,1) = P(di,1) + t*v(di,1);
end


% 3.- VECTOR d = Q-P:
 
d = zeros(xdim,1);

for di = 1:1:xdim
    d(di,1) = Q(di,1) - P(di,1);
end

end

