function [o] = go2535_order (n)

% RETURNS:
% o: "order" of number n, i.e. position of largest digit. 
% E.g. 34.223 => o = 2
%       2.363 => o = 1
%       0.636 => o = -1
%       0.023 => o = -2
%       0.0086 => o = -3

% assumes n is positive

if n < 1
    
    eF = 0 ;
    
    o = -1 ;
    while eF == 0
       
        if 10^o< n 
            
            eF = 1 ;
            
        else
            
            o = o-1;
            
        end
        
    end
    
elseif n==1
    
    o = 1 ;
    
elseif n > 1
   
    eF = 0 ;
    
    o = 1 ;
    while eF == 0
       
        if n < 10^o
            
            eF = 1 ;
            
        else
            
            o = o+1;
        end
        
    end
    
end




end

