function [b] = go2536_bisector (u, v, ndim)

% RETURNS:
% b(xdim,1): bisector versor for the angle formed by two vectors u and v
% works for 2D and 3D


b = zeros(ndim,1);


% transforms the input vectors into versors:

nu = norm(u);
nv = norm(v);

u = u/nu;
v = v/nv;


% extracts angles, computes average and cosinus, allocating to response:

au = zeros(ndim,1);
av = zeros(ndim,1);

aa = zeros(ndim,1);

for di = 1:1:ndim
    
    au(di,1) = acos(u(di));
    av(di,1) = acos(v(di));
    
    aa(di,1) = (au(di,1) + av(di,1))/2;
    
    b(di,1) = cos(aa(di));
    
end




b = b/norm(b);


% plots (for checking:

%{
figure(1)

if ndim == 2

    plot( [0 u(1)] ,  [0 u(2)], 'k'); hold on
    plot( [0 v(1)] ,  [0 v(2)], 'k'); hold on

    plot( [0 b(1)] ,  [0 b(2)], 'r'); hold on
    
elseif ndim == 3
    
	plot3( [0 u(1)] ,  [0 u(2)], [0 u(3)], 'k'); hold on
    plot3( [0 v(1)] ,  [0 v(2)], [0 v(3)], 'k'); hold on

    plot3( [0 b(1)] ,  [0 b(2)], [0 b(3)],'r'); hold on
    
end

axis equal

%}

end

