function [u] = go2538_UangV (v, nu, a, n)

% RETURNS:
% u(ndim,1): vector at angle 'a' from v

% INPUTS:
% v(ndim,1)
% nu: norm of u
% a: angle from v to u
% n(ndim,1): normal to both

% assumes 3D, i.e. ndim = 3


ndim = 3 ;

% system of equations come from dot product (first equation) and from cross
% product (three equs, we select two of them)

A = zeros(ndim,ndim);
u = zeros(ndim,1);

b = zeros(ndim,1);


% first equation:

A(1,1) = v(1);	A(1,2) = v(2);	A(1,3) = v(3); 

b(1,1) = nu * norm(v) * cos(a);


% the other two equations:

A(2,1) = 0 ;     A(2,2) = v(3) ; A(2,3) = -v(2) ; 
A(3,1) = -v(3);  A(3,2) = 0    ; A(3,3) =  v(1) ; 

b(2,1) = n(1);
b(3,1) = n(2);


% computes u:

u = A\b;


end

