function [IN] = GEN_43_PinTside (P, sc, nps, dims, mode, tol)

% RETURNS:
% IN = 1/0 for P inside/not inside a triangluar side (line or triangle)

% INPUTS:
% P(dims):   point to evaluate
% sc(ns,udims): Coord's of nodes of side
% nps: 	No. nodes per side: 2 lines, 3 triangles (describe a line or a plane)
% dims:	No. dimensions of coordiantes
% mode: 0 : closed domain
%       1 : closed domain except nodes: if P lies in nodes is not IN, but in edges is IN
%       2 : open domain: if P lies in nodes or triang. edges is not IN


% ONLY prepared for 2D lines!!!


if dims == 2 && nps == 2
    
    % checks close domain:
    IN = GEN_20_PonSegment (P, [sc(1,1) sc(1,2)] ,[sc(2,1) sc(2,2)], dims, tol);
    
    % changes to open domain if necessary:
    if IN==1 && mode==1
        
        for nod=1:1:nps
        if P(1) == sc(nod,1) && P(2) == sc(nod,2)
            
            IN = 0;
            break
            
        end
        end 
    end
    
    
end


end

