function [IP,t] = go2545_PlaneLineIntersec (u, v, P, rv, rP)

% note: works for 3D !!!

% RETURNS:
% IP:   intersection point between plane and line
% t:    parameter value, if < 0 is in opposite to rv direction

% INPUTS:
% u,v:  vectors in plane
% P:    point in plane
% rV:   vector of line
% pR:   point of line

IP = zeros(3,1);

% plane implicit equations coefficients:

A = u(2)*v(3) - u(3)*v(2);
B = u(3)*v(1) - u(1)*v(3);
C = u(1)*v(2) - u(2)*v(1);

D = -A*P(1) - B*P(2) - C*P(3);



% line parameter of intersection:

t = -(A*rP(1) + B*rP(2) + C*rP(3) + D ) / (A*rv(1) + B*rv(2) + C*rv(3));


% IP calculation (from line and t):

for di=1:1:3
   IP(di) = rP(di) + t * rv(di) ; 
end






end

