function [IN] = go2546_PinTriang (tv, P, tolL, tolA, nd)

% RETURNS: if P is inside a triangle in 3D
% IN: 0 out, 1 P is in, 2 P is just at edge, 3 P is just at node

% INPUTS:
% tv:   triangular vertex coord's (3, udims)
% P:    point coord's to evaluate
% tolL, tolA:  tolerance (in % of segment length and triangle area)

dim = 3 ;

% Compares if total area of triangle is lower than the sumation of all sub-areas

a = zeros(3,1);
b = zeros(3,1);

d = [1 2 3 ; 
     2 3 1 ];


IN = 0 ;

% 1.- Checks if P is a node:

for i = 1:1:3

	CO = go2542_coincidentP (P, [tv(i,1), tv(i,2), tv(i,3)], dim, nd);

    if CO == 1
        IN = 3 ;
        return
    end
    
end





% 2.- Check if P is at one segment:

if CO == 0
for se = 1:1:3
    
    a(:,1) = tv(d(1,se),:); % nodes coord's
    b(:,1) = tv(d(2,se),:);

    ON = go2520_PonSegment (P, a,b, dim, tolL);
      
    if ON==1
        IN = 2 ;
        break
    end
    
end
end



% 3.- Checks if is inside:

if CO == 0 && ON == 0 
    
    % total area:
    
    for di=1:1:3
        
        a(di,1) = (tv(2,di) - tv(1,di));
        b(di,1) = (tv(3,di) - tv(2,di));
        
    end
    
    At = 0.5 * norm(cross(a,b));
    
    
    % summation of sub-elements
    
    Aacc = 0;
    
    for se = 1:1:3 
        
        r1 = d(1,se);
     	r2 = d(2,se);

        for di = 1:1:3

            a(di,1) = tv(r2,di) - tv(r1,di); % vector edge
            b(di,1) = P(di) - tv(r1,di); % vector edge
            
        end
        
        Ase = 0.5 * norm(cross(a,b)); 
        
        Aacc = Aacc + Ase;
        
    end

    
    if Aacc < (1+tolA/100)*At
    IN = 1 ;
    end

end


end

