function [B] = b2604_MNL (u, br, KnotV, Ncp, Degree, Usize, udim)

% RETURNS:  
% B: basis function at location u
% B can be: N (1D) , NM (2D) , NML (3D)

% INPUTS:
% u:        param. coord's 
% br:       b. funct's references
% KnotV:  	knot vectors 
% Ncp:      No. cp's
% Degree:   degrees
% Usize:    size of knot vector

B = 1 ;

for di = 1:1:udim
    
    p = Degree(di);
    n = Ncp(di) ;
    U = KnotV(di,1:Usize(di));

	[bF, bR] = GEN_01_CalcBF(br(di),u(di),p,U,n);
    
 	B = B*bR(p+1,1);

    if B == 0
        break
    end
    
end

end

