function [N, Nicp, RicpA] = t2603_N_upIPCs (pNicp, pRicpA, Degree, mA, u, udim)

% RETURNS:
% N(icp):   T-splines tensor product of each icp at location 'u'
% Nicp, RicpA:  No. icps and references, updated (removes those where N(a) = 0

% INPUTS:
% pNicp, pRicpA: preliminary icp's


N  = zeros(1,1);
Nicp = 0 ;
RicpA = zeros(1,1);


% For all the pre-involved CP's, calculates T-splines tensor product:

for a=1:1:pNicp

    % anchor reference:
    aRef = pRicpA(a);

    % computes basis functions:
    pN = 1 ;
    for di=1:1:udim
        bR = t2604_Tspline_u (aRef, Degree, mA, u(di), di);
        pN = pN * bR(Degree(di)+1,1)  ;
    end

    % if pN ~=0 allocates
    if pN~=0
    
        Nicp = Nicp + 1 ;
        RicpA(Nicp,1) = aRef;
        N(Nicp,1) = pN;

    end
 
end


end

