function [N] = t2605_N_givenIcp (Nicp, RicpA, Degree, mA, u, udim)

% RETURNS:
% N(icp):   T-splines tensor product of each icp at location 'u'
% Nicp, RicpA:  No. icps and references, updated (removes those where N(a)=0)

% INPUTS:
% pNicp, pRicpA: preliminary icp's


N  = zeros(Nicp,1);



% For all given CP's, calculates T-splines tensor product:

for a=1:1:Nicp

    % anchor reference:
    aRef = RicpA(a);

    % computes basis functions:
    pN = 1 ;
    for di=1:1:udim
        bR = t2604_Tspline_u (aRef, Degree, mA, u(di), di);
        pN = pN * bR(Degree(di)+1,1)  ;
    end

 	N(a,1) = pN;
 
end


end

