function [dS] = b2701_BNURBS_deriv (Degree, Ncp, KnotV, Usize, P ,w, ord, u, xdim, udim)

% RETURNS:
% dS(ord(1)+1, ord(2)+1, ord(3)+1, xdim): derivatives of patch with respect parameter directions at location u

% INPUTS:
% Degree, Ncp, KnotV, Usize: features in each direction
% P,w: control points coordinates
% ord(udim,1): derivative order in each direction
% u:    location where compute derivative


% 1.- PRELIMINARIES:

% derivative order plus 1 , useful for matrix 
% indexes and extends ord to general case of 3D:

orP = ones(3,1);
eord = zeros(3,1);
for di=1:1:udim
    orP(di) = ord(di)+1; 
    eord(di) = ord(di);
end
%ord = eord;


% expands (or indexed) P and w in case they are not:

if size(w,1)>1 && size(w,2)>1
    Ew = w ;
    EP = P ;
else
    [Ew,EP] = GEN_12_ExpandBw(w,P,xdim, udim, Ncp);
end


% 2.- INITIATES dSp WITH (deriv(0) = Xcoord's) & STORES ICP's:

% dSp(ord(1), ord(2), ord(3)): matrix of prev. derivarives, or lower
% order derivatives, the last value (end,end,end) is dS

dSp = zeros(orP(1), orP(2) ,orP(3), xdim);

[X] = b2601_BNURBS_Xcoord (u, KnotV, Ncp,Degree,Usize, Ew, EP, udim,xdim);

for di=1:1:xdim
    dSp(1,1,1,di) = X(di) ; % Value of patch at u (derivatives 0,0,0)
end




% 3.- COMPUTES VALUES OF dA & dW FOR ALL NECESSARY ORDERS:

%dA = ones(orP(1), orP(2), orP(3), xdim);
%dW = ones(orP(1), orP(2), orP(3));

[dA, dW] = b2702_dA_dW (u, KnotV, Ncp,Degree,Usize, Ew,EP, orP, udim, xdim);

%{
if round(u(1),3)==1 && round(u(2),3)==0.75
if round(P(9,1),4)==17.0431 || round(P(9,1),4)==-57.9569
    
    for i = 1:1:2
    for j = 1:1:2   
        
        for di = 1:1:xdim

            dd(di,1) = dA(i,j,1,di);

        end
        
        [i j]
        
        dd
        ww = dW(i,j,1)
	end
    end
    
end
end
%}


% 4.- Computes dSp, using previous values:

ord = zeros(3,1);

for k = 1:1:orP(1)
ord(2) = 0 ;
for l = 1:1:orP(2)
ord(3) = 0 ;
for m = 1:1:orP(3) 
    
    if sum(ord)>0
        
        [dS] = b2703_dS (dSp, ord, [k l m], dA, dW, udim, xdim);

        for di=1:1:xdim
     	dSp(k,l,m, di) = dS(di) ;
        end
        
    end

ord(3) = ord(3)+1;
end
ord(2) = ord(2)+1;
end
ord(1) = ord(1)+1;
end

dS = dSp ;

%{
if round(u(1),3)==1 && round(u(2),3)==0.75
    
    [dS(1,1,1,1) dS(1,1,1,2)]
    [dS(2,1,1,1) dS(2,1,1,2)]
    
end
%}


for di=1:1:2
    dC(di,1) = dS(2,1,1,di);
end




end

