function [dS] = t2701_TNURBS_deriv (Degree, nAN, mA, ord, u, xdim, udim)

% RETURNS:
% dS(ord(1)+1, ord(2)+1, ord(3)+1, xdim): derivatives of patch with respect param. coord's at location u

% INPUTS:
% ord(udim,1): derivative order in each direction
% u:    location where compute derivative


% 1.- Constructs: derivative order plus 1 , useful for matrix indexes and
% exteds ord to general case of 3D:

orp = ones(3,1);
eord = zeros(3,1);
for di=1:1:udim
    orp(di) = ord(di)+1; 
    eord(di) = ord(di);
end
ord = eord;


% 2.- Initiates dSp and stores icp's:

% dSp(ord(1), ord(2), ord(3)): matrix of prev. derivarives, or lower
% order derivatives, the last value (end,end,end) is dS

dSp = zeros(orp(1), orp(2) ,orp(3), xdim);

[pNicp, pRicpA] = p1204_icpsPo (nAN, mA, u, udim, 'closed');
[N, Nicp, RicpA]= GEN_0908_N_upIPCs (pNicp, pRicpA, Degree, mA, u, udim);
[X, ~]          = t2602_TNURBS_Xcoord_withN (mA, N, Nicp, RicpA, xdim);

for di=1:1:xdim
    dSp(1,1,1,di) = X(di) ; % Value of patch at u (derivatives 0,0,0)
end

Nicp  = pNicp;
RicpA = pRicpA;


% 3.- Computes values of dA and dW for all necessary orders:

%dA = ones(orp(1), orp(2), orp(3), xdim);
%dW = ones(orp(1), orp(2), orp(3));

[dA, dW] = t2702_dA_dW (mA, nAN, Degree, u, Nicp, RicpA, ord, orp, udim, xdim);



% 4.- Computes dSp, using previous values:

ord = zeros(3,1);

for k = 1:1:orp(1)
ord(2) = 0 ;
for l = 1:1:orp(2)
ord(3) = 0 ;
for m = 1:1:orp(3) 
    
    if sum(ord)>0
        
        [dS] = t2703_dS (mA, nAN, Degree, dSp, ord, [k l m], u, dA, dW, udim, xdim);

        for di=1:1:xdim
     	dSp(k,l,m, di) = dS(di) ;
        end
        
    end
    
    
ord(3) = ord(3)+1;
end
ord(2) = ord(2)+1;
end
ord(1) = ord(1)+1;
end


dS = dSp ;



end

