function [sUc] = pc2852_setPPcurves(sX, Ncp, Degree, KnotV, Usize, P, w, CD, xdim, nd, xerrTol)

% RETURNS:
% sUc(nv): row with parameter coordinates in curve of sX points

nv = size(sX,1); % No. vertexes
x = zeros(xdim,1);
sUc = zeros(nv,1);

% curve Ulims
ULims = [round(KnotV(1,1),nd) round(KnotV(1,Usize(1)),nd)];

% 1.- FINDS FIRST SEARCHING POINT u0:
% just measures from trial points and selects the closest
% also stores distance for second point to be used in 1.1

x(:,1) = sX(1,:);
x2(:,1) = sX(2,:);

st = 0.1 ;
for ui = ULims(1):st:ULims(2)
    
    x0 = b2601_BNURBS_Xcoord (ui, KnotV, Ncp,Degree,Usize, w, P, 1, xdim);
    x02 = b2601_BNURBS_Xcoord (ui, KnotV, Ncp,Degree,Usize, w, P, 1, xdim);
    
    if ui==ULims(1) 
        
        DX = norm(x0-x);
        DXmin = DX;
        u0 = ui;
        
        DX2 = norm(x02-x2);
        DXmin2 = DX2;
        u02 = ui;
        
    else

        DX = norm(x0-x);
        if DX<DXmin
            DXmin = DX;
            u0 = ui; 
        end
        
        DX2 = norm(x02-x2);
        if DX2<DXmin2
            DXmin2 = DX2;
            u02 = ui; 
        end
        
    end
    
end



% 1.1.- If closed curve & u0 is at limits, checks second
% point in order to make sure first point is not on the other side:
%{
if CD == 1 && (u0 == ULims(1) || u0 == ULims(2))
    
    u2 = pc2851_PPcurves (x2, u02, Ncp, Degree, KnotV, Usize, P, w, xdim, nd, xerrTol);
    
    d1 = abs(ULims(1)-u2);
    d2 = abs(ULims(2)-u2);
    
    if d1<d2
        u0 = ULims(1);
    else
        u0 = ULims(2);
    end
    
end

u0
%}

% 2.- LOOP ON VTX. Assumes they're given in a ordered row

for v = 1:1:nv
    
    x(:,1) = sX(v,:);

    [u,~] = pc2851_PPcurves (x, u0, Ncp, Degree, KnotV, Usize, P, w, CD, xdim, nd, xerrTol);
    
    sUc(v,1) = u ;
    
    u0 = u ;
    
end



% 3.- CLOSED CURVE CHECK:

% in case first or last points are right at the curve ends might have
% jumped to the other side

if CD==1
    
    % first point:
    if round(sUc(1),nd) == ULims(1) || round(sUc(1),nd) == ULims(2)
         
         % checks second point:
         d1 = abs(sUc(2)-ULims(1));
         d2 = abs(sUc(2)-ULims(2));

         if d1<d2
             sUc(1) = ULims(1);
         else
             sUc(1) = ULims(2);
         end
     end
     
    % last point:
    if round(sUc(nv),nd) == ULims(1) || round(sUc(nv),nd) == ULims(2)
         
        % checks prev. point:
        d1 = abs(sUc(nv-1)-ULims(1));
        d2 = abs(sUc(nv-1)-ULims(2));
         
         if d1<d2
             sUc(nv) = ULims(1);
         else
             sUc(nv) = ULims(2);
         end
    end 
end


end

