function [ULims, seekst, fUcoor, dmin, tolDist] = t2802_preparPProj ...
                            (nsp, sX, KnotV, Degree, Usize, nAN, mA, xdim, udim)

% RETURNS: some vbles. necessary for starting point projection

% Ulims(udim,2): param. space mins and maxs.
% seekst(udim): step to find initial Ucoor for point projection
% fUcoor(udim): first u coord for first sX point projection
% dmin: minimum distance reference in physical space
% tolDist:  tolerance in distance to stop search initial Ucoor in case it
%           coincides with the actual solution

% INPUTS:
% nsp: No. points to project
% sX(nsp,xdim): points physical coord's


% 1.- Sets min. distance as 'diagonal' in physical space and 
% tolerance to consider initial Ucoor is the soution:

temp = sortrows(sX,[1:1:xdim]);
a = zeros(xdim,1);
b = zeros(xdim,1);

for di=1:1:xdim
    a(di) = temp(1,di);
    b(di) = temp(nsp,di);
end
dmin = norm(b-a);
tolDist = dmin * 0.000001 ;



% 2.- U Limits and step for seeking:

ULims = zeros(3,2);
seekst = zeros(3,1);
    
for di = 1:1:udim
        
    ULims(di,1) = KnotV(di,1);
    ULims(di,2) = KnotV(di,Usize(di));

    seekst(di) = (ULims(di,2) - ULims(di,1) )*0.25;
end
   

% 3.- Initial Ucoor of searching ucoord's of first Xcoord's: 

% first point to project:
Xcoor = zeros(3,1);

for di=1:1:xdim
    Xcoor(di) = sX(1,di);
end


% finds closest Ucoor with seekst:
[fUcoor,~] = t2804_intialU (seekst, ULims, Xcoor, dmin, tolDist, Degree, nAN, mA, udim, xdim);
                            


end

