function [Ucoor] = t2803_PP_with_preSel ...
    (Xcoor, Ucoor, ULims, seekst, dmin, tolDist, KnotV, Usize, Degree, nAN, mA, udim,xdim)

% RETURNS:
% Ucoor for a given Xcoor

% INPUTS:
% Xcoor: physical coord's where to find correspondant Ucoor
% Ucoor: initial searchin point
% seekst: initial seeking step in case needs to re-compute it
% dmin: pre-established minimum distance for re-searching initial Ucoor

% Filosophy: if does not converge in contaL loops => varies initial Ucoor 




NOC = 1 ;
divsr = 2;
contaL = 0 ;

Lerr1 = 0.00001;
Lerr2 = 0.0001;

while NOC==1
 
    % Ucoor correspondant to Xcoor, NOC=1 if does not find convergence:
    [Ucoor, NOC] = t2805_UfromX (KnotV, Usize, Degree, nAN, mA, Xcoor, Ucoor, Lerr1, Lerr2, udim, xdim);
    
    % Re-sets initial Ucoor if NOC=1
    if NOC==1
        Dseekst = seekst/divsr;
        [Ucoor, NOC] = t2804_intialU (Dseekst, ULims, Xcoor, dmin, tolDist, Degree, nAN, mA, udim, xdim);
        divsr = divsr+1;
    end

    % Controls No. global loops:
    contaL = contaL+1;
    if contaL == 12
        disp( [ num2str(Xcoor(1)), '  ' , num2str(Xcoor(2)) , '  does not converge, see c1303_INPo'  ] );
        break
        
    end
    

    
end



end


