function [u0, Su] = c2813b_FindsUinterval (x1, Ntp,tpu, p,n,U,P,w, CD, xdim)

% RETURNS:
% Su(2): span of trial where u(x) is to be
% u0; closes point of trials

% INPUTS:
% tpu(Ntp): trial points
% x1(xdim): point to be localixzed
% x2: next point (if applicable)
% p2F=1 if there are two points (current and next)
% NURBS features


% 1.- Computes distance from each tp to x

Dx1 = zeros(Ntp,2); % cols: order and distance
Dx2 = zeros(Ntp,2);

for i = 1:1:Ntp
    
    ut = tpu(i);
    
    xt = b2601_BNURBS_Xcoord (ut, U, n,p,n+p+1, w,P, 1,xdim);
    
    Dx1(i,1) = i ;
    Dx1(i,2) = norm(xt-x1);
    
    %{
    if p2F ==1
        Dx2(i,1) = i ;
        Dx2(i,2) = norm(xt-x2);
    end
    %}
    
end


% 2.- Sorts by distance and selects u0:

sDx = sortrows(Dx1,2);
i1 = sDx(1,1);
u0 = tpu(i1);


% 3.- Selects internal: previous and next orders of u0

Su = zeros(2,1);

if i1==1 % special case of first point
    
    Su(1) = tpu(1);
    Su(2) = tpu(2);
    
elseif i1==Ntp % special case of last point
    
    Su(1) = tpu(Ntp-1);
    Su(2) = tpu(Ntp);
    
else % internmidiate cases
    
    ipr = i1-1;
    inx = i1+1;
    
 	Su(1) = tpu(ipr);
    Su(2) = tpu(inx);

end


end

