function [Due] = c2814b_EstimatesU (u0, xt, p, n, U, P ,w, xdim)

% RETURNS:
% u: param postion correspondant to xt using trapezoidal rule estimation:


% derivatives at u0:
    
dCu = zeros(xdim,1);
[dC] = b2701_BNURBS_deriv (p, n, U, n+p+1, P ,w, [1], u0, xdim, 1);
dCu(:,1) = dC(2,1,1,:);
    
mdCu = norm(dCu); % modulus
dCu = dCu/mdCu; % versor
    
% Xcoor at u0 and vector from X to xt:
    
X = b2601_BNURBS_Xcoord (u0, U, n,p,n+p+1, w,P, 1,xdim);
    
Dx = xt-X;
    
    
% norm of projection of Dx vector onto dCu
    
np = dot(Dx,dCu);
    
    
% angle dCu-Dx:
    
cA = dot(dCu,Dx) / (norm(dCu)*norm(Dx));
angu = acos(cA);
    
    
% computes Dx projected on dCu and its norm:
    
pDx = np*dCu;
npDx = norm(pDx);
    
if angu > 90/57.298
    npDx = -npDx;
end

% estimated increment of u:

Due = npDx/mdCu;


end

