function [Due, alfa] = s2834b_EstimatesU (u0, xt, Degree, Ncp, KnotV, Usize, P ,w, EP ,Ew, xdim, Xtol)

% RETURNS:
% Due: estimated step in parameter space to achieve xt from u0
% alfa: orientaion in parameter space of the increment

udim = 2 ;

% derivatives at u0:

dSu = zeros(xdim,1);
dSv = zeros(xdim,1);
[dS] = b2701_BNURBS_deriv (Degree, Ncp, KnotV, Usize, P ,w, [1 1], u0, xdim, udim);
dSu(:,1) = dS(2,1,1,:);
dSv(:,1) = dS(1,2,1,:);  


% tan plane at u0:

nv = cross(dSu,dSv);
nv = nv / norm(nv);  % normal
X = b2601_BNURBS_Xcoord (u0, KnotV, Ncp, Degree,Usize, Ew,EP, udim, xdim); % point of the plane


% projection of xt onto plane and vector from X:

[xj] = go2518_POntoP(xt, nv, X);
pDx = xj-X;
mpDx = norm(pDx);


if mpDx < Xtol/10
    
    % in case of null projection Due=0:
    
    alfa=0;
    Due = [0 0];
    
else
    
    % 'normal case':
    
    
    % directional derivative and norm:

    [alfa] = ar3307_AngleU (pDx, dSu, dSv, xdim); % angle in param. space
    dSl = cos(alfa)*dSu + sin(alfa)*dSv;
    mdSl = norm(dSl);  


    % estimated increment of u:

    Due = [mpDx/mdSl*cos(alfa) mpDx/mdSl*sin(alfa)] ;

end


%{
	if (round(xt(1,1),4)== 43.4315 && round(xt(2,1),4)== 14.4168) && round(P(1,1),4)==11.5050

        xt
        X
        nv
        pDx
        alfa

	end
%}

end