function [sU] = s2836_PPlineonS (cX, nv, sDegree, sNcp, sKnotV, sUsize, sP, sw, CS, xdim, Xtol, DUtol)

% RETURNS:
% PP of line on surface

% special case of line on surface, when line is on the edge might be wrong
% in closed surfaces


% 1.- Surface edge curves:

% edCurv(4) = struct ('Ncp',0,  'Degree',0, 'Usize',0, 'KnotV',[], 'w',[], 'P',[], 'conF', 0, 'CD', 0);

[edCurv] = ts3313_EdgesContours (sNcp, sDegree, sUsize, sP,sw, sKnotV);



% 2.- Checks if cX lies on one edge:

[conF, eR] = ts3310_conF05_ (edCurv, cX, xdim, Xtol);




% 3.- Searches according to character:

sUdim = 2;

sULims = zeros(sUdim,2);
for di = 1:1:sUdim
    sULims(di,1) = sKnotV(di,1);
    sULims(di,2) = sKnotV(di,sUsize(di));
end

if conF == 0.5 % case of curve coincident with edge (USES SURFACE edge)
        
    [sU] = ts3323_sUconF05_ (nv, cX, edCurv, eR, sULims, xdim, sUdim, Xtol, DUtol);

            
else %if conF == 0 % case of curve with any vertex inside the surface

	[sU] = s2831b_PPsurf (cX, nv, sDegree, sNcp, sKnotV, sUsize, sP, sw, CS, xdim, Xtol, DUtol);

end


end