function [sU, ut, u0, endF] = s2837b_ends (sU, ut, u0, endF, ULims, i, CD)
% RETURNS:
% updates vbles. in case leave or arrive to end point of the curve:

% 1.- PRELIMINARIES:

% note only considers closed direction
% closed direction = z

z = 0 ;

for di = 1:1:2
    if CD(di)==1
        z = di ;
    end
end

if z==0
return
end


% Detects if first point is inside the surface.
% Checks out direction (if any) of current ut.
% Checks out direction of previous sU (if any and applicable)

cdoF = 0 ;	% current point direction out flag
pdoF = 0 ;	% prev. point direction out flag

if (ULims(z,1) < ut(z) && ut(z) < ULims(z,2)) && (endF == 1 && i == 1)
    endF = 0;
end
    
if (ut(z) <= ULims(z,1) || ULims(z,2) <= ut(z))
    cdoF = 1;
end
    
if i > 1
    if (sU(i-1,z) <= ULims(z,1) || ULims(z,2) <= sU(i-1,z)) 
    pdoF = 1;
    end
end
    


% 2.- CASE CURRENT ut IS IN & PREVIOUS AT LIMIT:

% 'leaving end location' check.
% Corrects previous points if they were at wrong end.
        
if cdoF == 0 && (endF == 1 && i > 1)
if pdoF == 1
        
	endF = 0 ;

	% measures dist. to both ends and allocates the closest end to prev. points.
  	% peu: 'previous end u'

  	d1 = ut(z)-ULims(z,1);
  	d2 = ULims(z,2)-ut(z);

    if d1 < d2
        peu = ULims(z,1);
  	elseif d2 < d1
        peu = ULims(z,2);
    end

  	for j = 1:1:i-1
    	sU(j,z) = peu;
 	end 
        
end  
end
        
% 3.- CASE ARRIVE TO LIMIT FROM IN POSITION:

% 'arriving end location' check.
% Corrects current point in case arrives to wrong end.
        
if cdoF == 1 && endF == 0
            
	endF = 1 ;
            
	% measures dist. to previous point and allocates the closest end to that point.
            
	d1 = sU(i-1,z)-ULims(z,1);
 	d2 = ULims(z,2)-sU(i-1,z);
            
 	if d1 < d2
        ut(z) = ULims(z,1);
     	u0(z) = ULims(z,1);
    elseif d2 < d1
        ut(z) = ULims(z,2);
      	u0(z) = ULims(z,2);
	end
            
end 

end

