function [sU] = v2861b_PPvol (sX, N, Degree, Ncp, KnotV, Usize, P, w, CD, xdim, Xtol, DUtol)

xst = [43.4315 15.000 61.5685]'; % for debugging

% RETURNS:
% cU(nx): param. coordinates of curve correspondant to cX 
% it's assumed cX is ordered (as a curve order)

% INPUTS:
% cX(nx,xdim): points to find parameters
% curve NURBS features

udim = 3 ;

[Ew,EP] = GEN_12_ExpandBw (w, P, xdim, udim, Ncp);

sU = zeros(N,udim);
ULims = [...
        KnotV(1,1) KnotV(1,Usize(1));
        KnotV(2,1) KnotV(2,Usize(2));
        KnotV(3,1) KnotV(3,Usize(3))];



% 1.- Extracts non-void knot spans and sets trial points to search first u0

Udiv = [0.25 ; 0.25 ; 0.25 ];

%[Nks, Ntp, tpu] = v2862b_trialU (KnotV, Usize, Degree, Ncp, P, xdim);
[Nks, Ntp, tpu] = v2862b_trialU (Udiv);


% 2.- Detects interval where it is assumed to be the first point and
% closest trial point that will be used as initial u0:

xt = zeros(xdim,1);
xt(:,1) = sX(1,:);

u0 = z2890b_FindsU (xt, Nks, Ntp, tpu, Degree, Ncp, KnotV, Usize, EP, Ew, CD, udim, xdim);



% 3.- LOOP ON ALL POINTS: uses the prev. as u0

for i = 1:1:N
 
    
    % 3.1.- Target point Xcoords:
    xt(:,1) = sX(i,:);
    
    
    % 3.2.- Initla Xcoor
    x0 = b2601_BNURBS_Xcoord (u0, KnotV, Ncp, Degree, Usize, Ew, EP, udim, xdim);
    
    
    % 3.3.- Checks initial point is already target
    if norm(x0-xt) < Xtol
        ut = u0;
        ncF = 0 ; % already coincident (converged)
    else
        ncF = 1 ; % non-converg. flag = 1 when not converges
    end
    
    
    % 3.4.- Loops until converges to ut (correspondent to xt):
    while (ncF==1)
        
        % computes Ucoor:
        [ut, ncF] = ...
        v2865b_onePoint (xt, u0, Degree, Ncp, KnotV, Usize, P ,w, EP ,Ew, CD, ULims, xdim, Xtol, DUtol);
        
        % re-searches if no converges or advances in wrong sense:
        if ncF==1
            u0 = z2890b_FindsU (xt, Nks, Ntp, tpu, Degree, Ncp, KnotV, Usize, EP, Ew, CD, udim, xdim);
        end

    end
    
    
    % 3.5.- Allocates response and initial u for next point:

    for di = 1:1:udim
        sU(i,di) = ut(di);
    end
    u0 = ut ;
 
end




% c2810b_plotDu (Su(1), Su(2), 10, xt,ut, p, n, U, P, w, xdim);




end

