function [Nks, Ntp, tpu] = v2862b_trialU (Udiv)

% RETURNS:
% Nks:                  No. divisions (knot spans originally)
% Ntp(Nks,1):           No. trial points per division
% tpu(Nks,Ntp,udim):    position of trial point,
%                       this position is the centre of the division
udim = 3 ;

% 1.- No. divisions per direction:

Ndiv = zeros(udim,1); 

for di = 1:1:udim
    Ndiv(di,1) = 1/Udiv(di,1);
end


% 2.- Sizes answers:

Nks = prod(Ndiv);
Ntp = ones(Nks,1);
tpu = zeros(Nks,1,udim);


% 3.- Mid-point of each division:

conta = 0 ;
u = zeros(udim,1);

u(1) = Udiv(1)/2;
for i = 1:1:Ndiv(1)
    
    u(2) = Udiv(2)/2;
    for j = 1:1:Ndiv(2)

        u(3) = Udiv(3)/2;
        for k = 1:1:Ndiv(3)

            conta = conta + 1 ;

            tpu(conta,1,:) = u(:,1);
            
            
            u(3) = u(3) + Udiv(3);
            
        end
        u(2) = u(2) + Udiv(2);
    end
    u(1) = u(1) + Udiv(1);
end



end