function [Nks, Ntp, tpu] = v2862b_trialU (KnotV, Usize, Degree, Ncp, P, xdim)

% RETURNS:
% tpu: initial position of trial points

% span with shortest attached control net segments lenght (cnsL) is divided into p partitions
% the others are divided in a No. partitions proportionally to this cnsL

udim = 3 ;

% non-void spans:

[nvU, nvUsize] = GEN_18_UnonVoid (KnotV, Usize, Degree, udim);

Nsp = zeros(udim,1); % No. spans
for di = 1:1:udim
    Nsp(di) = nvUsize(di)-1;
end

Nks = Nsp(1)*Nsp(2)*Nsp(3); % No. knot spans



% each span is divided intro (p * 2) sub-segments (needs improvement)

tpu = zeros(Nks, Degree(1)*Degree(2)*Degree(3), udim); % tp Ucoords in each span
Ntp = zeros(Nks, 1 ); % No. trial points per knot span
pp = 2*ones(Nks, udim); % proportion (now is just 2, needs improvement)

conta1 = 0 ;

for i = 1:1:Nsp(1)
for j = 1:1:Nsp(2)
for k = 1:1:Nsp(3)
    
        conta1 = conta1+1;
        
        % span length in each direction
      	L(1) = nvU(1,i+1)-nvU(1,i);
        L(2) = nvU(2,j+1)-nvU(2,j);
        L(3) = nvU(3,k+1)-nvU(3,k);
        
        % for that knot span in each direction
        for di = 1:1:udim
           
            % No. sub-segments
            Nssg(di) = Degree(di) * pp(conta1,di); 
        
            % length of sub-segements
            DL(di) = L(di)/Nssg(di);
        end
        
        % computes Ucoord's for that knot span:
        
        acc = [nvU(1,i) nvU(2,j) nvU(3,k)]; 
        
        conta2 = 0 ;
        for si = 1:1:Nssg(1)

            acc(2) = nvU(2,j);
            for sj = 1:1:Nssg(2)

                acc(3) = nvU(3,k);
                    for sk = 1:1:Nssg(3)
                
                        conta2 = conta2 + 1 ;
                        for di=1:1:udim
                            tpu(conta1,conta2,di) = acc(di) ;
                        end
                
                        acc(3) = acc(3)+DL(3);
                    end
                acc(2) = acc(2)+DL(2);
            end
            acc(1) = acc(1)+DL(1);
        end

        % {
        
        
        % last rows in chi:
        
        acc = [nvU(1,i) nvU(2,j) nvU(3,k)]; 
        if k == Nsp(3)
            
            for si = 1:1:Nssg(1)
                acc(2) = nvU(2,j);
                for sj = 1:1:Nssg(2) 

                    conta2 = conta2 + 1 ;
                    
                    tpu(conta1,conta2,1) = acc(1) ;
                    tpu(conta1,conta2,2) = acc(2) ;
                    tpu(conta1,conta2,3) = nvU(3,nvUsize(3)) ;
                    
                    acc(2) = acc(2)+DL(2);
                end
                acc(1) = acc(1)+DL(1);
            end
        end
        
        % last rows in ita:
        
        acc = [nvU(1,i) nvU(2,j) nvU(3,k)]; 
        if j == Nsp(2)
            
            for si = 1:1:Nssg(1)
                acc(3) = nvU(3,k);
                for sk = 1:1:Nssg(3) 

                    conta2 = conta2 + 1 ;
                    
                    tpu(conta1,conta2,1) = acc(1) ;
                    tpu(conta1,conta2,2) = nvU(2,nvUsize(2)) ;
                    tpu(conta1,conta2,3) = acc(3) ;
                    
                    acc(3) = acc(3)+DL(3);
                end
                acc(1) = acc(1)+DL(1);
            end
        end
        
        
        % last rows in xi:
        
        acc = [nvU(1,i) nvU(2,j) nvU(3,k)]; 
        if i == Nsp(1)
            
            for sj = 1:1:Nssg(2)
                acc(3) = nvU(3,k);
                for sk = 1:1:Nssg(3) 

                    conta2 = conta2 + 1 ;
                    
                    tpu(conta1,conta2,1) = nvU(1,nvUsize(1)) ;
                    tpu(conta1,conta2,2) = acc(2);
                    tpu(conta1,conta2,3) = acc(3) ;
                    
                    acc(3) = acc(3)+DL(3);
                end
                acc(2) = acc(2)+DL(2);
            end
        end
        
        


        
        % last corner:
        if (i == Nsp(1) && j == Nsp(2)) && k == Nsp(3)
            conta2 = conta2 + 1 ;
         	tpu(conta1,conta2,1) = nvU(1,nvUsize(1)) ;
         	tpu(conta1,conta2,2) = nvU(2,nvUsize(2)) ;
            tpu(conta1,conta2,3) = nvU(3,nvUsize(3)) ;
        end
        %}
        
        % No. points in that knot span:
        Ntp(conta1,1) = conta2;
        
end
end
end




end