function [Due] = v2864b_EstimatesU (u0, xt, Degree, Ncp, KnotV, Usize, P ,w, EP ,Ew, xdim, Xtol)

% RETURNS:
% u: param postion correspondant to xt using trapezoidal rule estimation:

udim = 3 ;
Due = zeros(1,xdim);

% 1.- Current Xcoord's:

[x0] = b2601_BNURBS_Xcoord (u0, KnotV, Ncp,Degree,Usize, Ew,EP, udim,xdim);

dX = norm(xt-x0);

if dX < Xtol/10
    
    
    % in case of null projection Due=0:
    Due = zeros(1,udim);
    
    
else
    
    
    % only carries on if points are not coincident:
    x0t = (xt-x0)/dX;

    
    % 2.- Finds correspondent vector to x0t in param. space u0t:

    [dS] = b2701_BNURBS_deriv (Degree, Ncp, KnotV, Usize, P ,w, [1 1 1], u0, xdim, udim); % deriv. at u0

    A = zeros(3,3);
    for fil = 1:1:3
        A(fil,1) = dS(2,1,1,fil);
        A(fil,2) = dS(1,2,1,fil);
        A(fil,3) = dS(1,1,2,fil);
    end

    u0t = A\x0t;    
    u0t = u0t/norm(u0t); % orientation vector


    % 3.- Direc-derivative norm at U1:

    dSl = zeros(xdim,1);

    for xdi = 1:1:xdim
        dSl(xdi) = u0t(1)*dS(2,1,1,xdi) + u0t(2)*dS(1,2,1,xdi) + u0t(3)*dS(1,1,2,xdi);
    end
    ndSl = norm(dSl);


    % 4.- Estimates step in param. and updates:

    Dl = dX/ndSl;

    for di = 1:1:udim
        Due(1,di) = round(u0t(di)*Dl,9);
    end
    
end





end