function [u0] = z2890b_FindsU (x, Nks, Ntp, tpu, Degree,Ncp, KnotV, Usize, EP, Ew, CD, udim, xdim)

% RETURNS:
% u0; closes point of trials

% INPUTS:
% Ntp(Nks): No. trial points per span
% tpu(Nks,Ntp,udim)): trial points
% x(xdim): point to be localized
% NURBS features

% 1.- Computes distance from each tp to x

Dx = zeros(sum(Ntp),2); % cols: order and distance
j = 0 ;

ut = zeros(1,udim);



for s = 1:1:Nks
for i = 1:1:Ntp(s)
    
    j = j+1;
    
    ut(1,:) = tpu(s,i,:);

    xt = b2601_BNURBS_Xcoord (ut, KnotV, Ncp,Degree, Usize, Ew,EP, udim, xdim);
    
    Dx(j,1) = s ;
    Dx(j,2) = i ;
    Dx(j,3) = norm(xt-x);
    

end
end


% 2.- Sorts by distance and selects u0:

sDx = sortrows(Dx,3);

s1 = sDx(1,1);
i1 = sDx(1,2);

u0 = zeros(1,udim);
u0(1,:) = tpu(s1,i1,:);

end