function [Xtol] = z2891_XtolPatches (pxtol, Spatches, Npa)

% RETURNS:
% Xtol = DXmax x pxtol / 100  
% (Dmax is the diagonal length of the cube enveloping the physical domain)

% INPUTS:
% pxtol: percentage introduced by user
% Spatches

% Extracts coordinates of control points of all patches:

xdim = 3 ;
n = 0 ;
x = zeros(1,xdim);

for pa = 1:1:Npa
    
    Nacp = Spatches(pa,1).INS(1).mNacp ;
    
    for i = 1:1:Nacp
        n = n+1;
        x(n,:) = Spatches(pa,1).INS(1).mP(i,:);
    end
end


% Sorts coordinates and extracts increments:

xs = sortrows(x,1);
ys = sortrows(x,2);
zs = sortrows(x,3);



Dx = xs(n,1) - xs(1,1);
Dy = ys(n,2) - ys(1,2);
Dz = zs(n,3) - zs(1,3);


% finds Xtol:

D = (Dx^2 + Dy^2 + Dz^2)^0.5;
Xtol = D * pxtol/100;

end

