function [ ] = sc2901_plotCnurbs (fr, pR, crR, cpF, cpR, ccTp)

% PLOTS: contour all curves NURBS (in physical space)

% INPUTS:
% fr: figure ref
% pR: patch ref
% crR: curve ref flag
% cpF: control points flag = 1 to plot CPs
% cpR: control point refs = 1 to write them
% ccTp

figure(fr)

udim = 1 ;
xdim = 3 ;

Nc = ccTp(pR,1).Nc;

for c = 1:1:Nc
    
    cKnotV	= ccTp(pR,1).agCurv(c,1).KnotV;
    cNcp    = ccTp(pR,1).agCurv(c,1).Ncp;
    cDegree = ccTp(pR,1).agCurv(c,1).Degree;
    cUsize  = ccTp(pR,1).agCurv(c,1).Usize;
    cw      = ccTp(pR,1).agCurv(c,1).w;
    cP      = ccTp(pR,1).agCurv(c,1).P;
    
    % CURVE:
    
    x = zeros(1,xdim);
    
    conta = 0 ;
    for u = 0:0.05:1
    
        conta = conta + 1 ;
        
        X = b2601_BNURBS_Xcoord (u, cKnotV, cNcp, cDegree, cUsize, cw, cP, udim, xdim);
        x(conta,:) = X(:,1);
        
    end
    
    plot3 ( x(:,1),  x(:,2),  x(:,3), 'k'); hold on
    
    
    % CURVE REF:
    
    if crR==1
        n = round(conta/2,0);
        text ( x(n,1),  x(n,2),  x(n,3), num2str(c)); hold on
    end
    
    
    
    % CP's:
    
    if cpF == 1

        plot3 ( cP(:,1), cP(:,2), cP(:,3),'--r'); hold on
        scatter3( cP(:,1), cP(:,2), cP(:,3),'r', 'Filled'); hold on
        
        if cpR == 1
            for i = 1:1:cNcp

                text( cP(i,1), cP(i,2), cP(i,3), num2str(i)); hold on

            end
        end
        
        
    end
    
    
end

axis equal

end

