function [ ] = sc2902_plotTC (fr, SP, vrF, crF, ccTp, pR)

% PLOTS: trimming curves of the patch in the space designated

% INPUTS:
% SP: space to represent 'X', 'A', 'U'
% vrF: vertex ref flag
% crF: curve ref flag



Nc = ccTp(pR,1).Nc ;

for c = 1:1:Nc
if ccTp(pR,1).NFC(c,1).n > 0  % only for curves that have vertexes defined (i.e. patch trimming curves)
    
    n = ccTp(pR,1).NFC(c,1).n;
    na = round(n/2,0);
    
    if SP == 'X'
    
        Nsr = 1 ;
        dim = 3 ;
        Cv = zeros(Nsr,n,dim);
        
        Cv(1,:,:) = ccTp(pR,1).NFC(c,1).Xn(:,:);
        
    elseif SP == 'A'
        
        Nsr = 1 ;
        dim = 3 ;
        Cv = zeros(Nsr,n,dim);
        
        Cv(1,:,:) = ccTp(pR,1).NFC(c,1).An(:,:);
        
    elseif SP == 'U'
    
        Nsr = ccTp(pR,1).NFC(c,1).Nsr;
        dim = 2 ;
        Cv = zeros(Nsr,n,dim);
        
        for s = 1:1:Nsr
            Cv(s,:,:) = ccTp(pR,1).NFC(c,1).Un(s,:,:);
        end
        
    end
    
    
    for s = 1:1:Nsr
        
        sr = ccTp(pR,1).NFC(c,1).sr(s,1);
        
        x = zeros(n,dim);
        x(:,:) = Cv(s,:,:);
        
        if dim == 2
            
            figure(fr-1+sr)
            
            plot ( x(:,1),  x(:,2), 'r'); hold on
            
            if crF == 1
                text( x(na,1),  x(na,2), num2str(c), 'fontsize',18); hold on
            end
            
            if vrF == 1
                scatter ( x(:,1),  x(:,2), 'r'); hold on
                for k = 1:1:n
                    text ( x(k,1),  x(k,2), num2str(k)); hold on
                end
            end
                 
        elseif dim == 3
            
            figure(fr)
            
            plot3 ( x(:,1),  x(:,2),  x(:,3), 'b'); hold on
            
            if crF == 1
                text( x(na,1),  x(na,2), x(na,3), num2str(c), 'fontsize',18); hold on
            end
            
            if vrF == 1
                scatter3 ( x(:,1),x(:,2),x(:,3),'b'); hold on
                for k = 1:1:n
                    text ( x(k,1),  x(k,2),  x(k,3), num2str(k)); hold on
                end
            end
            
        end
        
        
        
        axis equal
        
    end
    
    
    
    
end    
end






end

