function [conM] = su2912_TriconM (nlo, nPL, CLu, sU, sULims, sUdim)

% RETURNS:
% conM(Ntri,3): net of triangles composing the skin


% INPUTS:
% nlo: No. contour loops
% nPL(nlo,1): No. points per loop


% 1.- GENERATES CONTOURS DELAUNAY CONSTRAINS:

contaP = 0 ;
fila   = 0 ;
C = zeros(1,2);

for lo = 1:1:nlo

    prevContaL = contaP+1;
    
    for po = 1:1:nPL(lo)

        contaP = contaP+1;
        
        fila = fila + 1 ;
        
        C(fila,1) = contaP;
        C(fila,2) = contaP+1;
    end
    
    C(fila,2) = prevContaL;

end


% 2.- GENERATES 'GROSS' TRIANGULATION:

DT = delaunayTriangulation(sU,C);
nE = size(DT,1);



% 3.- SELECTS ONLY TRIANGLES INSIDE THE CONTOURS & WITH NON-ALIGNED NODES

nEr = 0 ;
conM = zeros(1,3);

for e = 1:1:nE
    
    b = incenter(DT,e);
    
    % finds No. intersections between vert. and horizontal ray and contours:
    [IN] = su2913_INcontours (b, nlo, nPL, CLu, sULims, sUdim);
    
    % 3.1.- Condition 1: triangle IN:
    
    if IN ==1 
        
        % 3.2.- Checks condition 2: points not-aligned:
        
        n1 = DT(e,1);
        n2 = DT(e,2);
        n3 = DT(e,3);
        
        Cnod = [sU(n1,1) sU(n1,2) ; sU(n2,1) sU(n2,2) ; sU(n3,1) sU(n3,2) ];
        
        [AL] = go2512_TnodAligned (Cnod, sUdim, 0.75);
        
        if AL==0
            nEr = nEr+1;
            for nod=1:1:3
                conM(nEr,nod) = DT(e,nod);
            end
        end
    end
    
end



end

