function [IN, corte] = su2913_INcontours (b, nlo, nPL, CLu, sULims, sUdim)

% RETURNS:
% IN=1 if point 'b' is inside contours CLu (at LHS of them)
% otherwise returns IN=0

% INPUTS:
% b: Ucoord's of point to evaluate
% nlo: No. loops
% nPL: No. points per loop
% CLu(nlo, nPL, udim): param. coord's of contours curves
% sUdim: No. param. dims.

% works in parameter space
  
% 1.- INITIATION OF VBLES.

IN = 0;
corte = zeros(2,1);

a = zeros(sUdim,1);
c = zeros(sUdim,1);

if size(b,2)>1
    b = b';
end


% 2.- CHARACTERIZES POINT: also constructs line for the case of corner or
% edge location of 'b' point:

status = '';

if (b(1)==sULims(1,1) && b(2)==sULims(2,1)) || (b(1)==sULims(1,2) && b(2)==sULims(2,2))
    
    status = 'c13'; % b at corners 1 or 3
    
  	La(1) = sULims(1,1); La(2) = sULims(2,1); % diagonal line
  	Lb(1) = sULims(1,2); Lb(2) = sULims(2,2);
    
elseif (b(1)==sULims(1,1) && b(2)==sULims(2,2)) || (b(1)==sULims(1,2) && b(2)==sULims(2,1))
    
    status = 'c24'; % b at corners 2 or 4
    
   	La(1) = sULims(1,1); La(2) = sULims(2,2); % diagonal line
  	Lb(1) = sULims(1,2); Lb(2) = sULims(2,1);
    

    
elseif b(1)==sULims(1,1) ||  b(1)==sULims(1,2)
    
    status = 'vEd'; % b at vertical edge

    La(1) = sULims(1,1); La(2) = b(2); % horzt. line
  	Lb(1) = sULims(1,2); Lb(2) = b(2);
    
elseif b(2)==sULims(2,1) ||  b(2)==sULims(2,2)
    
    status = 'hEd'; % b at horizontal edge
    
   	La(1) = b(1); La(2) = sULims(2,1); % vert. line
   	Lb(1) = b(1); Lb(2) = sULims(2,1);
    
end

 


% 3.- LOOPS ON CONTONURS TO COUNT INTERSECTIONS:

% works with segments a-c, and checks if they are intersected by rays
% passing by b

for L = 1:1:nlo  
for po = 1:1:nPL(L)

    % 3.1.- start / end Ucoor of contour line: a & c 
    
    if po < nPL(L)
        
        for di=1:1:sUdim
            a(di,1) = CLu(L,po+0,di);
            c(di,1) = CLu(L,po+1,di);
        end
    
    elseif po == nPL(L)
        
       	for di=1:1:sUdim
            a(di,1) = CLu(L,po+0,di);
            c(di,1) = CLu(L,1,di);
        end
    end
    

    % 3.2.- Distinguishes cases:
    
    % 3.2.1.- 'b' is at one of the corners of the param. domain 
    % => check only one diagonal line
    % 3.2.2.- 'b' is at one edge of the parameter domain 
    % => check one ray perp. to the edge where it belongs to:
    
    if (strcmp(status,'c13')== true || strcmp(status,'c24')== true) || ...
       (strcmp(status,'vEd')== true || strcmp(status,'hEd')== true)
        
        [iP, inter] = go2524_TwoSegmIntersec (a,c, La,Lb);
        
        % to do not repeat segments, if the intersection happens at the
        % second point of the contour stretch ('c') is not considered:
        
        iP = iP';
        if isequal(round(iP,9),c)== false
            corte(1) = corte(1) + inter ;
        end

    else
        
    % 3.2.3.- Others: check two orthogonal rays:   
    
        pdim = [2 1];
        for di=1:1:sUdim

            pdi = pdim(di);

            if (a(di)<=b(di) && b(di)< c(di)) || (a(di)>=b(di) && b(di)>c(di)) 
            if a(pdi) > b(pdi) || c(pdi) > b(pdi)

                r = c - a ; % contour line vector, a to c
                v = b - a ; % vector a to b

                r = [r;0];
                v = [v;0]; 
                u = cross(r,v);

                if a(di)<c(di) && u(3)<0
                    corte(di) = corte(di)+1;
                end

                if a(di)>c(di) && u(3)>0
                    corte(di) = corte(di)+1;
                end
            end
            end
        end
    end

    
end
end
   



% 4.- CONDITIONS TO BE IN:

% 4.1.- First conditions to  be IN: if they comply => changes IN to 1:

if mod(corte(1),2)==1 || mod(corte(2),2)==1
    
    IN = 1 ;
    
end




end

