function [skin] = su2918_Pcp2Egp (Spatches, Npa, insR, skin)

% RETURNS:
% Eskin.mGP with patches icp's in each B.E. and correspondant basis function values



for pa = 1:1:Npa
    
    pudim   = Spatches(pa).Udim;
    pnbe    = Spatches(pa).nbe;
    pRbe    = Spatches(pa).Rbe;
    mA      = Spatches(pa).mRefin(insR).mA;
    nAN     = Spatches(pa).mRefin(insR).nAN;
    pDegree = Spatches(pa).mRefin(insR).mDegree;
    pUsize  = Spatches(pa).mRefin(insR).mUsize;
    %pNcp    = Spatches(pa).mRefin(insR).mNcp ;
    pKnotV  = Spatches(pa).mRefin(insR).mKnotV;
    
    
    pNcp= zeros(pudim,1);
    for di = 1:1:pudim
        pNcp(di,1) = pUsize(di) - pDegree(di) - 1 ;
    end
    
    for b = 1:1:pnbe

        bR = pRbe(b);

        % checks if it is a coupling surface, and this is the slave patch
        couR = skin(bR).mCou;

        flagSP = 0 ;
        if couR > 0
            
            if pa == skin(bR).mPa(1)
                flagSP = 0 ;
            elseif pa == skin(bR).mPa(2)
                flagSP = 1 ;
            end
        end
        
        
        for g = 1:1:skin(bR).mNgp
            
            Nicp = 0 ;
            RicpA = zeros(1,1);
            
            GXcoor = skin(bR).mGP(g).mXcoor;
            
            if flagSP==0
                GAcoor = skin(bR).mGP(g).mAcoor;
            elseif flagSP==1
                GAcoor = skin(bR).mGP(g).mAcoorS;
            end
            
            % 1.- stores all anchors influencing on that gp in temporary
            % vbles and B-spline basis function values:
            
            for a = 1:1:nAN
                
                EskR = mA(a).mEskR;
                NEsk = mA(a).mNEsk;
                
                % detects if the skin belongs to than anchor influence;
                
                [alreadyIN,~] = GEN_21_alreadyIN_tol (EskR, NEsk, 1, bR, 1);
                
                if alreadyIN == 1
                    
                    % detects if the point is influenced by the anchor and
                    % if it is not zero:
                    
                    aULims = mA(a).mUcoLi;
                    IN = GEN_08_Orthodom_Pin_ndec (GAcoor, aULims, pudim, 'closed', 9);
                    
                    if IN==1
                        
                        [~, N, ~, ~] = p1202_B_basisFuncts ...
                        (pNcp, pKnotV, pUsize, nAN, mA, pDegree, 1, a, GAcoor, pudim);
                        
                        if abs(round(N,6)) > 0
                    
                            Nicp = Nicp + 1 ;
                            RicpA(Nicp,1) = a ;
                  
                        end
                        
                    end
                end

            end
            
            
            %{
            if (g==1 && bR==3) && pa==1
                
                figure(8)
                
                scatter3( GXcoor(1), GXcoor(2), GXcoor(3),'x'); hold on
                
                for i = 1:1:Nicp
                    
                    aR = RicpA(i);
                    
                    X = mA(aR).mXcoor;
                    
                    scatter3( X(1), X(2), X(3),'r'); hold on
                    text( X(1), X(2), X(3),num2str(aR)); hold on
                    
                end
                axis equal
            end
            %}
            
            
            
            % 2.- Computes NURBS bf's values and derivatives in param. space:
            
            [Nabs, ~, Rrel, Usingu] = p1202_B_basisFuncts ...
            (pNcp, pKnotV, pUsize, nAN, mA, pDegree, Nicp, RicpA, GAcoor, pudim);

            [dRpa, ~] = p1212_mdRpa (Usingu, Nicp, pKnotV, RicpA, mA, pDegree, Nabs, pudim);


            % 3.- Allocates:
            
            if flagSP==0
            
                skin(bR).mGP(g).mNicp = Nicp ;
                skin(bR).mGP(g).mRicpA = RicpA ;
                skin(bR).mGP(g).Nabs = Nabs ;
                skin(bR).mGP(g).Rrel = Rrel ;
                skin(bR).mGP(g).dR_pa = dRpa ;
            
            elseif flagSP==1
                
                skin(bR).mGP(g).mNicpS = Nicp ;
                skin(bR).mGP(g).mRicpAS = RicpA ;
                skin(bR).mGP(g).NabsS = Nabs ;
                skin(bR).mGP(g).RrelS = Rrel ;
                skin(bR).mGP(g).dR_paS = dRpa ;
                
            end
            
            
        end 
        
    end


    
end




end

