function [Spatches] = su2919_PatchSkIcps (Spatches, Npa)

% RETURNS:
% Spatches with skin.mP & skin.mGP icp's

% detects what mRM.element the skin.mP point  
% belongs to and inherits its icp's


for pa = 1:1:Npa
    
    % 1.- PATCH GNERAL DATA:
    
    udim = Spatches(pa).Udim;
    
    mE    = Spatches(pa).mRefin(1).mRM.mE;
    nELp  = Spatches(pa).mRefin(1).mRM.nELp;
    FtoIe = Spatches(pa).mRefin(1).mRM.FtoIe;
    mA    = Spatches(pa).mRefin(1).mA ;
    nAN    = Spatches(pa).mRefin(1).nAN ;
    pDegree = Spatches(pa).mRefin(1).mDegree;
    pKnotV = Spatches(pa).mRefin(1).mKnotV ;
    pUsize = Spatches(pa).mRefin(1).mUsize;
    
    
    % 2.-GROSS SKINS:
    
    nGS = Spatches(pa).mRefin(1).nGS;
    
    for sk = 1:1:nGS
        
        % 2.1.- Nodes:
        
        nP = Spatches(pa).mRefin(1).mGskin(sk).nP;
        
      	for po = 1:1:nP

            u = Spatches(pa).mRefin(1).mGskin(sk).mP(po).mAcoor;
            
            % finds elements: stores their icp ref's
            [eNicp, eRicpA] = su2920_icpFromE (u, nELp, mE, FtoIe, udim);
            
            Spatches(pa).mRefin(1).mGskin(sk).mP(po).mNicp  = eNicp;
            Spatches(pa).mRefin(1).mGskin(sk).mP(po).mRicpA = eRicpA;
        end
        
        
        % 2.2.- Contour nodes: just copy from prev.
        
        nPL = Spatches(pa).mRefin(1).mGskin(sk).nPL;
        nlo = Spatches(pa).mRefin(1).mGskin(sk).nlo;
        
        conta = 0 ;
        for lo = 1:1:nlo
            
            for po = 1:1:nPL(nlo)
               
                conta = conta + 1 ;
                
                Spatches(pa).mRefin(1).mGskin(sk).mPL(lo,po).mNicp = ...
                    Spatches(pa).mRefin(1).mGskin(sk).mP(conta).mNicp;
                
                Spatches(pa).mRefin(1).mGskin(sk).mPL(lo,po).mRicpA = ...
                    Spatches(pa).mRefin(1).mGskin(sk).mP(conta).mRicpA;
            end
        end
        

        clearvars nP nPL nlo;
    end
    
    
  
 	% 3.- BOUNDED SKINS:
    
    nBS = Spatches(pa).mRefin(1).nBS;
    
    for sk = 1:1:nBS
        
        % 3.1.- Nodes:
        
        nP = Spatches(pa).mRefin(1).mBskin(sk).nP;
        
      	for po = 1:1:nP

            u = Spatches(pa).mRefin(1).mBskin(sk).mP(po).mAcoor;
            
            % finds elements: stores their icp ref's
            
            [eNicp, eRicpA] = su2920_icpFromE (u, nELp, mE, FtoIe, udim);
            
            Spatches(pa).mRefin(1).mBskin(sk).mP(po).mNicp  = eNicp;
            Spatches(pa).mRefin(1).mBskin(sk).mP(po).mRicpA = eRicpA;
        end
        
        
     	% 3.2.- Contour nodes: just copy from prev.
        
        nPL = Spatches(pa).mRefin(1).mBskin(sk).nPL;
        nlo = Spatches(pa).mRefin(1).mBskin(sk).nlo;
        
        conta = 0 ;
        for lo = 1:1:nlo
            
            for po = 1:1:nPL(nlo)
               
                conta = conta + 1 ;
                
                Spatches(pa).mRefin(1).mBskin(sk).mPL(lo,po).mNicp = ...
                    Spatches(pa).mRefin(1).mBskin(sk).mP(conta).mNicp;
                
                Spatches(pa).mRefin(1).mBskin(sk).mPL(lo,po).mRicpA = ...
                    Spatches(pa).mRefin(1).mBskin(sk).mP(conta).mRicpA;
            end
        end
        
        
        % 3.3.- Gauss points:
        
        nGP = Spatches(pa).mRefin(1).mBskin(sk).nGP;
        
        for g =1:1:nGP
            
            u = Spatches(pa).mRefin(1).mBskin(sk).mGP(g).mAcoor;
            
            % finds elements: stores their icp ref's
            
            [eNicp, eRicpA] = su2920_icpFromE (u, nELp, mE, FtoIe, udim);
            
            Spatches(pa).mRefin(1).mBskin(sk).mGP(g).mNicp  = eNicp;
            Spatches(pa).mRefin(1).mBskin(sk).mGP(g).mRicpA = eRicpA;
            
            [Nabs,~,Rrel,Usingu] = p1209_basisFuncts ...
            (pKnotV, pUsize, nAN, mA, pDegree, eNicp, eRicpA, u, udim);

            [dRpa, dRpaRHS] = p1210_mdTpa (u, Usingu, eNicp, eRicpA, mA, pDegree, Nabs, udim);

            Spatches(pa).mRefin(1).mBskin(sk).mGP(g).Usingu   = Usingu ;
            Spatches(pa).mRefin(1).mBskin(sk).mGP(g).Nabs     = Nabs ;
            Spatches(pa).mRefin(1).mBskin(sk).mGP(g).Rrel     = Rrel ;
            Spatches(pa).mRefin(1).mBskin(sk).mGP(g).dR_pa    = dRpa ;
            Spatches(pa).mRefin(1).mBskin(sk).mGP(g).dR_paRHS = dRpaRHS ;
            
        end
        
        
        clearvars nP nPL nlo nGP;
    end
    
    

    
    clearvars mE nELp nGS;
    
end



end

