function [Nicp, Ricp, Nabs, Rrel, dRpa] = su2926_IcpBf (s, Pa, bgAcoor, pNcp, pKnotV, pUsize, Nacp, CP, pDegree, pudim)

% RETURNS:
% Icp for a parameter coordinate Acoor
% Bf's values and derivatives

Nicp = 0 ;
Ricp = zeros(1,1);

for a = 1:1:Nacp
    
    domL = zeros(pudim,2);
    domL(:,:) = CP(a,1).mAcoLi(:,:);
    
    IN = GEN_08_Orthodom_Pin_ndec (bgAcoor, domL, pudim, 'closed', 9);
    
    % 1.- If contains Acoor , checks value of function
    if IN==1
        
        [~, N, ~, ~] = p1202_B_basisFuncts ...
      	(pNcp, pKnotV, pUsize, Nacp, CP, pDegree, 1, a, bgAcoor, pudim);
                        
        if abs(round(N,6)) > 0
                    
           	Nicp = Nicp + 1 ;
          	Ricp(Nicp,1) = a ;
                
        end
        
        
    end
    
    
end

% 2.- Computes NURBS bf's values and derivatives in param. space:

[Nabs, ~, Rrel, Usingu] = p1202_B_basisFuncts ...
(pNcp, pKnotV, pUsize, Nacp, CP, pDegree, Nicp, Ricp, bgAcoor, pudim);

[dRpa, ~] = p1212_mdRpa (Usingu, Nicp, pKnotV, Ricp, CP, pDegree, Nabs, pudim);



end

