function [agCurv, TNcu, SCcon, CPcon] = so2932_comp2Extg (pR, s,lo,c, agCurv, TNcu, SCcon, CPcon, Ncp2, Degree2, Usize2, KnotV2, P2, w2, conF2, CD2, xdim)

% RETURNS:
% agCurv, TNcu, SCcon, CPcon: updated if new curve is detected

% INPUTS:
% pR: patch reference
% s,lo,c: surface, loop and curve references
% Ncp2, Degree2, Usize2, P2: candidate curve features


% 1.- RUNS ON EXTG. CURVES IN agCurv TO DETECT IF CURRENT IS ALREADY IN:

for exc = 1:1:TNcu

	Ncp1    = agCurv(exc).Ncp;
	Degree1 = agCurv(exc).Degree;
	Usize1  = agCurv(exc).Usize;
 	P1      = agCurv(exc).P;
 
    CMP = ts3314_Compares2curves (Ncp1,Degree1,Usize1,P1, Ncp2,Degree2,Usize2,P2, xdim);

	if CMP~=0  
                    
        % 1.1.- Finds coincidence:  

        % add ref. to surface with sign:
        SCcon(s,lo,c) = CMP*exc;
        
        % add patch to curve (in second position)
        CPcon(exc,2) = pR;
        
        break

	end
end
          

% 2.- If no coincidence was found => new curve:

if CMP == 0
                    
	% - new curve:

	TNcu = TNcu + 1 ;
                
	agCurv(TNcu).Ncp     = Ncp2;
	agCurv(TNcu).Degree  = Degree2;
 	agCurv(TNcu).Usize   = Usize2;
 	agCurv(TNcu).KnotV   = KnotV2;
   	agCurv(TNcu).w       = w2;
 	agCurv(TNcu).P       = P2;
  	agCurv(TNcu).conF    = conF2 ;
    agCurv(TNcu).CD      = CD2 ;
    
 	SCcon(s,lo,c) = TNcu;
                
	CPcon(TNcu,1) = pR;
                
end

end

