function [Av] = so2936_mAv (NV, Xv, s, nlo, ncu, SCcon, Ncv, cAv, cXv, Spatches, pa, Xtol, DUtol)
 
% RETURNS:
% mAv 

pudim = 3 ;
xdim  = 3 ;

% 1.- PATCH FEATURES:

pDegree = Spatches(pa,1).INS(1).mDegree;
pNcp    = Spatches(pa,1).INS(1).mNcp;
pKnotV	= Spatches(pa,1).INS(1).mKnotV;
pUsize	= Spatches(pa,1).INS(1).mUsize;
pP      = Spatches(pa,1).INS(1).mP;
pw      = Spatches(pa,1).INS(1).mw;
pCD     = zeros(xdim,1); % assumes no closed solids, i.e. like a torus

pULims = zeros(pudim,2);

for di = 1:1:pudim
    pULims(di,1) = pKnotV(di,1);
    pULims(di,2) = pKnotV(di,pUsize(di));
end



% 2.- SEPARATES VTX FROM CONTOURS AND SI-VTX. 
% mAv for contours vertexes are transferred
% mAv for SI vertexes are computed here
    
% 2.1.- Counts No. vtx that belong to contour curves of that surface:
    
ccv = 0 ;
    
for lo = 1:1:nlo(s)
    for c = 1:1:ncu(s,lo)
        
        cR = abs(SCcon(s,lo,c));
        ccv = ccv + Ncv(cR)-1;
        
    end
end
    
    
% 2.2.- Vertexes of surface but not contour curves: SI-vrtx:
    
nsp = NV - ccv;
    
if nsp>0
    
    % 2.3.- Extracts SI-vtx phys. coordinates:
    
	sX = zeros(nsp,xdim); 
    
	for v = 1:1:nsp
        sX(v,:) = Xv(ccv+v,:);  
	end

	% 2.4.- Works out point projection of sX:
    
	[sA] = v2861b_PPvol (sX, nsp, pDegree, pNcp, pKnotV, pUsize, pP, pw, pCD, xdim, Xtol, DUtol);
    
end
   

% 3.- ALLOCATES Acoor COORDINATES:
    
Av = zeros(NV,pudim);

% 3.1.- Contour curves vtx:
    
contaV = 0;

for lo = 1:1:nlo(s)
    
    for c = 1:1:ncu(s,lo)
        
        cR = SCcon(s,lo,c);
       
        sc = sign(cR);
        cR = abs(cR);


        % extracts relevant coordinates: Acoord's and Xcoord's, stored
        % already arranged to surface
        
        nv = Ncv(cR)-1;
        
        cAt = zeros(nv, pudim); % temporary coords storage
        cXt = zeros(nv, xdim); 
        
        if sc == 1
            v1 = 1 ;
            v2 = Ncv(cR)-1; % last point is not added !
        elseif sc==-1
            v1 = Ncv(cR) ;
            v2 = 2; % last point is not added !
        end
        
        i = 0 ;
        for v = v1:sc:v2
            i = i + 1 ;
            cAt(i,:) = cAv(cR,v,:);
           	cXt(i,:) = cXv(cR,v,:);
        end
        

        % Allocates coordinates:
        for i = 1:1:nv
            
            contaV = contaV + 1 ;
            
            for di = 1:1:pudim
                Av(contaV,di) = cAt(i,di);
            end

        end

    end
end
    

% 3.2.- SI-vertexes:
    
if nsp > 0
        
	conta2 = contaV;

	for v = 1:1:nsp

        conta2 = conta2+1;

        for di = 1:1:pudim
            Av(contaV+v,di) = sA(v,di);
        end
	end
end


end

