function [cAv, cAvS, CPconE] = so2937be_mAcon (TNcu, Ncv, cLXv, SCcon, Spatches, Nbe, bEnti, Xtol, DUtol, pudim, xdim)

% SPECIFIC FOR BOUNDARY ENTITIES !!

cAv  = zeros(TNcu,max(Ncv),pudim);
cAvS = zeros(TNcu,max(Ncv),pudim); % in patch param. space

CPconE = zeros(TNcu,2); % Curve => patch conn. Second col is por slave patch



for c = 1:1:TNcu
    
    % 1.- ATTACHED PATCHES TO THE CURVE (including slave patch):
    
    % 1.1.- detects surfaces attached to the curve:
    
    nsa = 0 ;
    Rsa = zeros(1,1);
    
    for b = 1:1:Nbe 
        for i = 1:1:size(SCcon,2) 
            for j = 1:1:size(SCcon,3)
                if abs(SCcon(b,i,j))==c
                    nsa = nsa + 1 ;
                    Rsa(nsa,1) = b;      
                end 
            end 
        end 
    end
    
    
    %%%%%%%%%%%%%%%%%%%%%%% %%%%%%%%%%%%%%%%%%%%%
    % plot curves
    %{
    
    x = zeros(Ncv(c),xdim);
    
    for i = 1:1:Ncv(c) 
        x(i,:) = cLXv(c,i,:); 
    end
    
    figure(88)
    
    plot3( x(:,1),  x(:,2),  x(:,3), 'b'); hold on
    
    text(x(5,1),x(5,2),x(5,3),num2str(c)); hold on
    
    axis equal
    
    %}
    %%%%%%%%%%%%%%%%%%%%%%% %%%%%%%%%%%%%%%%%%%%%
    
    % 1.2.- Checks attached patches.
    % In case of 2 patches detects the slave patch
    
    mpR = zeros(1,1);
    spR = zeros(1,1);
    
    Nm = 0;
    Ns = 0 ;
    
    for b = 1:1:nsa
        
        bR = Rsa(b);
        
        Pa  = bEnti(bR).Pa;
        Cou = bEnti(bR).Cou;
        
        Nm = Nm + 1 ;
        mpR(Nm,1) = Pa(1);
        
        if Cou > 0
            Ns = Ns + 1 ;
            spR(Ns,1) = Pa(2);
        end
    end
    
    spR = spR(1);
    
    for i = 1:1:Nm
        
        if mpR(i)~=spR
            mpR = mpR(i);
            break
        end
    end
    
    apR = [mpR, spR];
    
    CPconE(c,1) = mpR ;
    CPconE(c,2) = spR ;
    
    % 2.- MASTER and SLAVE PATCHES:
   
    for i = 1:1:2
    
        pR = apR(i) ;
        
        if pR > 0
    
            % 2.1.- Extracts patch's data:

            pDegree = Spatches(pR,1).INS(1,1).mDegree;
            pNcp    = Spatches(pR,1).INS(1,1).mNcp;
            pKnotV	= Spatches(pR,1).INS(1,1).mKnotV;
            pUsize	= Spatches(pR,1).INS(1,1).mUsize;
            pP      = Spatches(pR,1).INS(1,1).mP;
            pw      = Spatches(pR,1).INS(1,1).mw;
            pCD     = zeros(xdim,1); % assumes no closed solids, i.e. like a torus


            % 2.2.- Stores curve vxt phys, coordinates:

            ccv = Ncv(c); % No. vtxs of the contour curve:

            cX = zeros(ccv,xdim); 
            for v = 1:1:ccv
                cX(v,:) = cLXv(c,v,:);  
            end


            % 2.3.- Works out point inversion:

            [cA] = v2861b_PPvol (cX, ccv, pDegree, pNcp, pKnotV, pUsize, pP, pw, pCD, xdim, Xtol, DUtol);



            % 2.4.- Allocates:

            if i ==1
                for v = 1:1:ccv
                cAv(c,v,:)  = cA(v,:);  
                end
            elseif i==2  
                for v = 1:1:ccv
                cAvS(c,v,:) = cA(v,:);  
                end 
            end
       
        end
    
    end
    
end



end

