function [pR, pDegree, pNcp, pKnotV, pUsize, pP, pw, pCD , pEw, pEP, pULims, ...
            spR, spDegree, spNcp, spKnotV, spUsize, spP, spw, spCD, spEw, spEP, spULims] = ...
            so2938_patchNURBS (couR, Pa, Spatches, xdim)

% RETURNS patches refs and NURBS features (second is for slave patch in case exists)

pudim = 3 ;

pR = Pa(1);
 
spR = 0;
if couR > 0 
    spR = Pa(2); % slave patch ref.
end
    
    
pDegree = Spatches(pR,1).INS(1).mDegree;
pNcp    = Spatches(pR,1).INS(1).mNcp;
pKnotV	= Spatches(pR,1).INS(1).mKnotV;
pUsize	= Spatches(pR,1).INS(1).mUsize;
pP      = Spatches(pR,1).INS(1).mP;
pw      = Spatches(pR,1).INS(1).mw;
pCD     = zeros(xdim,1); % assumes no closed solids, i.e. like a torus
[pEw,pEP] = GEN_12_ExpandBw (pw, pP,xdim, pudim, pNcp);
    
pULims = zeros(pudim,2);

for di = 1:1:pudim
    pULims(di,1) = pKnotV(di,1);
    pULims(di,2) = pKnotV(di,pUsize(di));
end


% detects if it has slave patch attached
    
spDegree = 0 ;
spNcp    = 0 ;
spKnotV	= 0 ;
spUsize	= 0 ;
spP      = 0 ;
spw      = 0 ;
spCD     = 0 ;
spEP      = 0 ;
spEw      = 0 ;
spULims   = 0 ;

if couR > 0 
        
	spDegree = Spatches(spR,1).INS(1).mDegree;
	spNcp    = Spatches(spR,1).INS(1).mNcp;
	spKnotV	= Spatches(spR,1).INS(1).mKnotV;
	spUsize	= Spatches(spR,1).INS(1).mUsize;
	spP      = Spatches(spR,1).INS(1).mP;
 	spw      = Spatches(spR,1).INS(1).mw;
	spCD     = zeros(xdim,1); % assumes no closed solids, i.e. like a torus
 	[spEw,spEP] = GEN_12_ExpandBw (spw, spP, xdim, pudim, spNcp);
        
    spULims = zeros(pudim,2);

    for di = 1:1:pudim
        spULims(di,1) = spKnotV(di,1);
        spULims(di,2) = spKnotV(di,spUsize(di));
    end
        
end
    
    
 
    
    
end

