function [BEskin, agCurvE, SCconE, ncuE, nloE] = so2939_beSkins...
         (Spatches, Nbe, bEnti, bCurv, NGPb, tolRc, tolRs, tolD, Nvx, R, pesw, ndig, wbF, DerC, pRx, DUtol)


% No. dimensions

pudim = 3;
xdim  = 3;
eudim = 2 ;

Rm = ones(Nbe,1) * R ; % R may be different for each B.E. (this option is pending)

Xtol = pRx * Rm / 100; % pp tolerance
Xtola = sum(Xtol)/Nbe;

BEskin(Nbe,1) = cBskin;


% 1.1.- Groups all curves of B.E. (attaches to B.E. via SCcon) and computes vertexes.

pR = 0 ;
[agCurvE, TNcuE, SCconE, CSconE, ncuE, nloE, ~] = so2935_AgreCurves (pR, Nbe, bEnti, bCurv, xdim);




% Computes curves vertexes in local curve physical/param's coord's:
[cLXvE, cLUvE, NcvE, ~] = ts3312_Cvertexes (agCurvE, TNcuE, R, Nvx, tolRc, xdim);


% computes contour curves solid patch param. coordinates:
[cAvE, cAvSE, CPconE] = so2937be_mAcon (TNcuE, NcvE, cLXvE, SCconE, Spatches, Nbe, bEnti, Xtola, DUtol, pudim, xdim);



% 1.2.- Assemblies B.E. surfaces object:

sf(Nbe,1) = struct('Ncp',[], 'Degree',[], 'Usize',[], 'KnotV',[], 'EP',[], 'Ew',[], 'P',[],'w',[], 'CS',[]);

for s = 1:1:Nbe

    sf(s).Ncp    = bEnti(s).Ncp;
    sf(s).Degree = bEnti(s).Degree;
    sf(s).Usize  = bEnti(s).Usize;
    sf(s).KnotV  = bEnti(s).KnotV;
    sf(s).CS     = bEnti(s).CS;
    
    Ncp = bEnti(s).Ncp;
    P = bEnti(s).P;
    w = bEnti(s).w;
    [Ew,EP] = GEN_12_ExpandBw (w, P,xdim, eudim, Ncp);
    
    sf(s).P = P;
    sf(s).w = w;
  	sf(s).EP = EP;
    sf(s).Ew = Ew;
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %{
    
    figure(22)
    
    if bEnti(s).Pa(1)==2
        
        for l = 1:1:nloE(s)
        for c = 1:1:ncuE(s)
            
            cR = SCconE(s,l,c);
            
            a = zeros(NcvE(cR),pudim);
            
            for k = 1:1:NcvE(cR)
                a(k,:) = cAvE(cR,k,:);
            end
            
            plot3( a(:,1) ,  a(:,2) , a(:,3) ,'b'); hold on
            
        end
        end

    end
    
    
	if bEnti(s).Pa(2)==2
        
        for l = 1:1:nloE(s)
        for c = 1:1:ncuE(s)
            
            cR = SCconE(s,l,c);
            
            a = zeros(NcvE(cR),pudim);
            
            for k = 1:1:NcvE(cR)
                a(k,:) = cAvSE(cR,k,:);
            end
            
            plot3( a(:,1) ,  a(:,2) , a(:,3) ,'r'); hold on
            
        end
        end

    end
    
    axis equal
    
    %}
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
end




% 1.3.- Triangulates them:


[QITst] = ts3330_QITst ...
(tolRc, tolRs, tolD, Nvx, R, pesw, Nbe, sf, agCurvE, cLXvE, cLUvE, NcvE, nloE, ncuE, SCconE, xdim, ndig, 0,0,0, wbF, DerC);



% 1.4.- Allocates to Eskin & computes GP's:



for s = 1:1:Nbe
        
    BEskin(s,1).mNcp    = bEnti(s).Ncp;
    BEskin(s,1).mDegree = bEnti(s).Degree;
    BEskin(s,1).mUsize  = bEnti(s).Usize;
    BEskin(s,1).mKnotV  = bEnti(s).KnotV;
    BEskin(s,1).mP      = bEnti(s).P;
    BEskin(s,1).mw      = bEnti(s).w;

    BEskin(s,1).mCS = bEnti(s).CS;
    BEskin(s,1).mPN = bEnti(s).PL;
    
    BEskin(s,1).mNE = QITst(s).mNE ;
    BEskin(s,1).mNV = size(QITst(s).mXv,1) ;

    %BEskin(s,1).mRv = QITst(s).mRv ;
    BEskin(s,1).mUv = QITst(s).mUv ;
    BEskin(s,1).mXv = QITst(s).mXv ;

    BEskin(s,1).mTVcon = QITst(s).mTVcon ;
    BEskin(s,1).mVTcon = QITst(s).mVTcon ;
  	BEskin(s,1).mLVcon = QITst(s).mLVcon ;
    BEskin(s,1).mVLcon = QITst(s).mVLcon ;
    BEskin(s,1).mTLcon = QITst(s).mTLcon ;
    
    NCL = zeros(nloE(s,1),1);
    for lo = 1:1:nloE(s,1)
        NCL(lo,1) = ncuE(s,lo);
    end
    BEskin(s,1).mNCL = NCL ;
    
    BEskin(s,1).mNlo = QITst(s).mNlo ;
    BEskin(s,1).mNlv = QITst(s).mNlv ;
    Nlcv = QITst(s).mNlcv ;
    BEskin(s,1).mNlcv = Nlcv ;
    
    BEskin(s,1).mPa  = bEnti(s).Pa ;
    BEskin(s,1).mCou = bEnti(s).Cou ;
    
    
    % Acoords of the vertexes:
        
    NV = BEskin(s,1).mNV ;
	Xv = QITst(s).mXv;
    
    mpR = bEnti(s).Pa(1) ;
	Av = so2936be_mAv (NV, Xv, s, nloE, ncuE, CPconE, SCconE, NcvE, cAvE, cAvSE, cLXvE, Spatches, mpR, Xtol(s), DUtol); 

    % slave
    
    AvS = 0 ;
    if bEnti(s).Cou > 0 
        
        spR = bEnti(s).Pa(2) ;
        AvS = so2936be_mAv (NV, Xv, s, nloE, ncuE, CPconE, SCconE, NcvE, cAvE, cAvSE, cLXvE, Spatches, spR, Xtol(s), DUtol);
        
    end
    
    BEskin(s,1).mAv = Av ;
    BEskin(s,1).mAvS = AvS ;

    
	% Gauss points:

    couR = bEnti(s).Cou ;
    Pa = bEnti(s).Pa ;
    
    
    [Ngp, GP] = st0304_GPBEskin (s, NGPb, BEskin(s,1), couR, Pa, Spatches, Xtol(s), DUtol);
    

	BEskin(s,1).mGP = GP ;
    BEskin(s,1).mNgp = Ngp ;
	

	% plots skins
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%{
	fr = 99 ;
	Cv = QITst(s).mXv ;
    cdim = size(Cv,2); 
    
    Cg = zeros(Ngp,cdim);

    for g = 1:1:Ngp
        Cg(g,:) = GP(g).mXcoor(:);
    end
    
    
	LVcon = QITst(s).mLVcon ;
	TVcon = QITst(s).mTVcon ;
        
	NLI = size(LVcon,1);
	NE = QITst(s).mNE ;
        
	pt1366_pTriLinMesh_nD...
	(Cv, NLI, LVcon, TVcon, cdim, fr, 'b', 1, 0, NV, 0, 0, NE, 0, 0, 0, 0, 0, 0);
   
    

    scatter3(Cg(:,1), Cg(:,2), Cg(:,3),'filled'); hold on

	%}
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    
    clearvars 'GP' 'Ngp'

end



end

