function [envR, neE] = z2941_envR (tam, Nmin, preP, xdim)

% RETURNS:
% envR = struct('Lims', [xdim,2]) => xdim net of rectangles enveloping the surface
% neE: No. rectangles / cubes     
       
% INPUTS:
% tam(di): max. size  in each direciton
% Nmin: min. No. rect's in any direction
% preP(np,xdim): cloud of point of surface to envelope


% 1.- ESTABLISHES LIMITS OF preP:

np    = size(preP,1);
xLims = zeros(xdim,2);
        
for di=1:1:xdim
    temp = sortrows(preP,di);
    xLims(di,1) = temp(1,di);
    xLims(di,2) = temp(np,di);
end




% 2.-  No. ELEM'S IN EACH DIRECTION, nO. TOTAL ELEMS.
%       Updates tam() if necessary:

nEdi = zeros(xdim,1);
nET = 1 ;
 
for di=1:1:xdim
            
    if round( (xLims(di,2) - xLims(di,1)) , 9 ) == 0 % special case of plane paralel to CSYS

        nEdi(di) = 1 ;
        xLims(di,1) = xLims(di,1) - 1;
    	xLims(di,2) = xLims(di,2) + 1;
        tam(di) = 2 ;
                
    else
        
        nEdi(di) = GEN_41_roof ((xLims(di,2) - xLims(di,1)) / tam(di));
        tam(di) = (xLims(di,2) - xLims(di,1)) / nEdi(di);   
        
        
        
        if nEdi(di) < Nmin
            nEdi(di) = Nmin;
            tam(di) = (xLims(di,2) - xLims(di,1)) / Nmin ;
        end
    end

    nET = nET * nEdi(di);
    
end



% 3.- CREATES THE RESPONSE:
        
X = zeros(xdim,1);
envR(nET,1) = struct('Lims', []);
contaR = 0;
        
X(1) = xLims(1,1);
for i = 1:1:nEdi(1)
            
	X(2) = xLims(2,1);
  	for j = 1:1:nEdi(2)
                
                
        if xdim==2
                    
            contaR = contaR + 1 ;

            for di=1:1:xdim
                envR(contaR).Lims(di,1) = X(di);
                envR(contaR).Lims(di,2) = X(di)+tam(di);
            end
                    
     	elseif xdim==3
                    
         	X(3) = xLims(3,1);
          	for k = 1:1:nEdi(3)

                contaR = contaR + 1 ;

                for di=1:1:xdim
                    envR(contaR).Lims(di,1) = X(di);
                    envR(contaR).Lims(di,2) = X(di)+tam(di);
                end

                X(3) = X(3) + tam(3);
                if k == nEdi(3)
                   X(3)= xLims(3,2);
                end
            end
        end
     
    X(2) = X(2) + tam(2);
    if j == nEdi(2)
    	X(2)= xLims(2,2);
  	end
    
    end
    
    
    X(1) = X(1) + tam(1);
    if i == nEdi(1)
    	X(1)= xLims(1,2);
  	end
end
        
neE = size(envR,1);



end

