function [ub, tF] = z2944_trackBack (ua, ub, ubr, ULims, ULimsr, nd)

% RETURNS:
% ub: updated u value. In case current ub is out of the limits, bring it
% back, computing the intersection with the limits lines
 
% tF=1 if moves back, otherwise = 0

tF = 0 ;

if ubr(1) < ULimsr(1,1)
    
    la = [ULims(1,1) ULims(2,1)];
    lb = [ULims(1,1) ULims(2,2)];
    [IP,iF,pF] = go2526_TwoLinIntersec (ua,ub, la,lb, 'closed', nd);
    
    if pF==0 && sum(iF)==2
        tF = 1 ;
        ub = IP;
        ubr = round(ub,nd);
    end
end


if ULimsr(1,2) < ubr(1)
    
    la = [ULims(1,2) ULims(2,1)];
    lb = [ULims(1,2) ULims(2,2)];
    [IP,iF,pF] = go2526_TwoLinIntersec (ua,ub, la,lb, 'closed', nd);
    
    if pF==0 && sum(iF)==2
        tF = 1 ;
        ub = IP;
        ubr = round(ub,nd);
    end
end


if ubr(2) < ULimsr(2,1)
    
    la = [ULims(1,1) ULims(2,1)];
    lb = [ULims(1,2) ULims(2,1)];
    [IP,iF,pF] = go2526_TwoLinIntersec (ua,ub, la,lb, 'closed', nd);
    
    if pF==0 && sum(iF)==2
        tF = 1 ;
        ub = IP;
        ubr = round(ub,nd);
    end
end

if ULimsr(2,1) < ubr(2)
    
    la = [ULims(1,1) ULims(2,2)];
    lb = [ULims(1,2) ULims(2,2)];
    [IP,iF,pF] = go2526_TwoLinIntersec (ua,ub, la,lb, 'closed', nd);
    
    if pF==0 && sum(iF)==2
        tF = 1 ;
        ub = IP;
        ubr = round(ub,nd);
    end
end




end

