function [] = r3011_gSkins (Skins, Ns, xsF, usF, xdim)

% ACTION:
% Draws gross skins of in the specified space

% INPUTS:
% Skin: object with collection of skins to represent
% nS:   No. skins
% insRs: instance reference selected
% Physical / Parameter: space to represent

fr = 0;
eF = 0 ;
sF = 1 ;
lrF = 0;
vrF = 0;
erF = 0;

stL = 0.5 ;
stT = 0.2 ;

for s = 1:1:Ns
     
    % 1.- Selects the coordinates and extracts some skin data:

 	NE =    Skins(s,1).mNE;
    LVcon = Skins(s,1).mLVcon;
    TVcon = Skins(s,1).mTVcon;
    
    Eiem =  zeros(NE,3,3);
    
    if xsF==1
        Cv = Skins(s,1).mXv;
    elseif usF==1
        Cv = Skins(s,1).mAv;
    end

    NLI = size(LVcon,1);
    
	Nlo = Skins(s,1).mNlo;
    Nlv = Skins(s,1).mNlv;
    

    
    % 2.- Plots skin surface:
    
    al = 1.0;
    pt1369_TriMDMesh (stL, stT, Cv, NLI, NE, LVcon, TVcon, Eiem, fr, eF, sF, lrF, vrF, erF, al)
    
    
    % 3.- Prints contours:

    [Npl, LCv] = r3016_contoCoor (stL, Cv, Nlo, Nlv, LVcon, xdim);
                                       
    for lo = 1:1:Nlo
    
        x = zeros(Npl(lo,1),1);
        y = zeros(Npl(lo,1),1);
        z = zeros(Npl(lo,1),1);

        for v = 1:1:Npl(lo,1)

            x(v,1) = LCv(lo,v,1);
            y(v,1) = LCv(lo,v,2);
            z(v,1) = LCv(lo,v,3);  

        end

        plot3(x,y,z,'-k', 'LineWidth',3); hold on 

    end
    
    

      
end




end

