function [Cv, Cv0] = r3013_skVtx (Spatches, paR, s, Stp, sc, xsF, usF, xdim)

NV = Spatches(paR,1).INS(1,1).skin(s,1).mNV;

Cv = zeros(NV,3); 
Cv0= zeros(NV,3);

if usF == 1
        
    % 1.- PARAMETER SPACE:
    
    for i = 1:1:NV
        Cv(i,:) = Spatches(paR,1).INS(Stp,1).skin(s,1).mVP(i,1).mAcoor(:,1); 
    end
      
elseif xsF == 1
     
    % 2.- PHYSICAL SPACE:
    
    % 2.1.- Initial instance (transfers also initial one)
    
    for i = 1:1:NV
        Cv(i,:)  = Spatches(paR,1).INS(1,1).skin(s,1).mVP(i,1).mXcoor(:,1); 
        Cv0(i,:) = Spatches(paR,1).INS(1,1).skin(s,1).mVP(i,1).mXcoor(:,1); 
    end
    
    
    % 2.2.- Adds scaled displacements:
    
    for t = 2:1:Stp
        

        Dx = zeros(1,xdim);
        
        for i = 1:1:NV
            
            Dx(1,:) = ...
                Spatches(paR,1).INS(t,1).skin(s,1).mVP(i,1).mXcoor(:,1) - ...
                Spatches(paR,1).INS(t-1,1).skin(s,1).mVP(i,1).mXcoor(:,1);

            Cv(i,:) = Cv(i,:) + sc*Dx(1,:); 

        end
    end
    
end



%{
DP = zeros(NV,3);

for i = 1:1:NV
    
    t = 1 ;
    P1 = [Spatches(paR,1).INS(t,1).skin(s,1).mVP(i,1).mXcoor(1,1);
         Spatches(paR,1).INS(t,1).skin(s,1).mVP(i,1).mXcoor(2,1);
         Spatches(paR,1).INS(t,1).skin(s,1).mVP(i,1).mXcoor(3,1)];
    
	t = 2 ;
    P2 = [Spatches(paR,1).INS(t,1).skin(s,1).mVP(i,1).mXcoor(1,1);
         Spatches(paR,1).INS(t,1).skin(s,1).mVP(i,1).mXcoor(2,1);
         Spatches(paR,1).INS(t,1).skin(s,1).mVP(i,1).mXcoor(3,1)];
     
    DP(i,:) = P2(:,1)-P1(:,1);
     
     
    
end
%}




end