function [] = r3014_bSkins (Spatches, paR, Stp, xsF, usF, sc, udfF, vmF, xdim)

% ACTION:
% Draws all skins of a patch in the specified space

% INPUTS:
% Stp: instance reference selected

Ns = Spatches(paR,1).INS(Stp,1).mNsk;

stL = 0.5 ;



for s = 1:1:Ns
     
    % 1.- Skin info:

    NE =    Spatches(paR,1).INS(1,1).skin(s,1).mNE;
    LVcon = Spatches(paR,1).INS(1,1).skin(s,1).mLVcon;
    TVcon = Spatches(paR,1).INS(1,1).skin(s,1).mTVcon;

	Nlo = Spatches(paR,1).INS(1,1).skin(s,1).mNlo;
    Nlv = Spatches(paR,1).INS(1,1).skin(s,1).mNlv;
    
    
    % 2.- Computes verteces coordinates & stresses:
    
    [Cv,Cv0] = r3013_skVtx (Spatches, paR, s, Stp, sc, xsF, usF, xdim);
   
    [ST] = r3017_skStress (Spatches, paR, Stp, s, vmF);


    % 3.- Plots skin surface:
    
    r3019_skin (NE, Cv, Cv0, ST, TVcon, udfF);
    
    
    % 4.- Prints contours:

    [Npl, LCv] = r3016_contoCoor (stL, Cv, Nlo, Nlv, LVcon, xdim);
    r3018_contour (Nlo, Npl, LCv, 'k', 3);
    
    if udfF == 1 
        [Npl, LCv0] = r3016_contoCoor (stL, Cv0, Nlo, Nlv, LVcon, xdim);
        r3018_contour (Nlo, Npl, LCv0, 'g', 1); 
    end
                                       
end

end