function [ST] = r3017_skStress (Spatches, paR, Stp, s, vmF)

% RETURNS:
% ST(NV,1): VM stresses at each point

% 1.- Extraction of basic data:

NV = Spatches(paR,1).INS(Stp,1).skin(s,1).mNV;
ST = zeros(NV,1);
    

% 2.- Transfers coordinates and stresses:

if vmF==1
    for v = 1:1:NV
        
        %{
        x = Spatches(paR,1).INS(Stp,1).skin(s,1).mVP(v,1).mXcoor;
        if (round(x(1),1)==30.7 && round(x(2),1)==38.8) && round(x(3),1)==56.5 
         [paR s v]
            Spatches(paR,1).INS(Stp,1).skin(s,1).mVP(v,1).mVM
        end
        %}
        
        ST(v,1) =  Spatches(paR,1).INS(Stp,1).skin(s,1).mVP(v,1).mVM ;
    end
end


% 3.- Checking of singularities:

% {

eSTs = [ ST , [1:1:NV]' ] ;

STav = sum(ST)/NV;

eSTs = sortrows(eSTs,1);

VL = Spatches(paR,1).INS(Stp,1).skin(s,1).mVLcon;
LV = Spatches(paR,1).INS(Stp,1).skin(s,1).mLVcon;

for v = NV:-1:1
    
    st = eSTs(v,1);
    nR = eSTs(v,2);

    if st/STav < 3
        break
    end
    
    % averge of stresses of adjacent vertexes:
    Svav = 0 ;
    conta = 0 ;
    
    for j = 1:1:size(VL,2)
        
        lR = VL(nR,j);
        
        if lR > 0
            
            onR = LV(lR,1);
            if onR == nR
                onR = LV(lR,2);
            end
            
            conta = conta + 1 ;
            Svav = Svav + ST(onR,1);
        end
    end
    
    Svav = Svav/conta;

    
    % checks:
    if st > 1.5*Svav
        ST(nR,1) = Svav ;
    end
    
    
end

%}


end

