function [ ] = r3019_skin (NE, Cv, Cv0, ST, TVcon, udfF)

% ACTION:
% Draws single skin

% assumes 3D, if not you must extend dimensions before call this function

% INPUTS:
% Cv(NV, dim):   coordinates of skin vertexes
% ST(NV,1):        stress of each vertex 


% 1.- PREPARES ARRAYS FOR fill3 FUNCION:

X = zeros(3,NE);
Y = zeros(3,NE);
Z = zeros(3,NE);
C = zeros(3,NE);

uX = zeros(3,NE);
uY = zeros(3,NE);
uZ = zeros(3,NE);
uC = zeros(3,NE);


% 2.- LOOP ON ELEMENTS TO STORE INFO FOR fill3:

for e = 1:1:NE
    
    n1 = TVcon(e,1);
    n2 = TVcon(e,2);
    n3 = TVcon(e,3);
    
    X(1,e) = Cv(n1,1);    X(2,e) = Cv(n2,1);    X(3,e) = Cv(n3,1);
    
    Y(1,e) = Cv(n1,2);    Y(2,e) = Cv(n2,2);    Y(3,e) = Cv(n3,2);
    
  	Z(1,e) = Cv(n1,3);    Z(2,e) = Cv(n2,3);    Z(3,e) = Cv(n3,3);
    
    C(1,e) = ST(n1,1);      C(2,e) = ST(n2,1);      C(3,e) = ST(n3,1);
    
    if udfF==1
        
        uX(1,e) = Cv0(n1,1);    uX(2,e) = Cv0(n2,1);    uX(3,e) = Cv0(n3,1);

        uY(1,e) = Cv0(n1,2);    uY(2,e) = Cv0(n2,2);    uY(3,e) = Cv0(n3,2);

        uZ(1,e) = Cv0(n1,3);    uZ(2,e) = Cv0(n2,3);    uZ(3,e) = Cv0(n3,3);

        uC(1,e) = ST(n1,1);      uC(2,e) = ST(n2,1);      uC(3,e) = ST(n3,1);
    
    end
    
end


% 3.- REPRESENTS SKINS:

h = fill3(X,Y,Z,C); hold on
set(h,'EdgeColor','none')
alpha (h, 1.0 ) ;
colormap(jet)


if udfF == 1
    
    uh = fill3(uX,uY,uZ,uC); hold on
    set(uh,'EdgeColor','none') 
    alpha (uh, 0.2 ) ;
    
end

end

