function [Cv, Cv0] = r3020_EskVtx (Bentities, bR, pa, Stp, sc, xsF, usF, xdim)

NV  = Bentities(bR,1).INS(Stp,1).skin.mNV;


Cv = zeros(NV,xdim); 
Cv0= zeros(NV,xdim);

if usF == 1
        
    % 1.- PARAMETER SPACE:
    
    % detects if it is slave:
    
    if Bentities(bR,1).mCOU == 0
        
        Cv = Bentities(bR,1).INS(Stp,1).skin.mAv; 
        
    elseif Bentities(bR,1).mCOU > 0
        
        if pa == Bentities(bR,1).mPa(1)
            
            Cv = Bentities(bR,1).INS(Stp,1).skin.mAv;
            
        elseif pa == Bentities(bR,1).mPa(2)
            
            Cv = Bentities(bR,1).INS(Stp,1).skin.mAvS;
            
        end
        
    end
    

elseif xsF == 1
     
    % 2.- PHYSICAL SPACE:
    
    [Cv0, Cv] = bt3061_Xv (Bentities, bR, Stp, sc);
    
    %{
    % 2.1.- Initial instance (transfers also initial one)
    
    Cv  = Bentities(bR,1).INS(Stp,1).skin.mXv; 
    Cv0 = Bentities(bR,1).INS(Stp,1).skin.mXv;

    
    % 2.2.- Adds scaled displacements:
    
    for t = 2:1:Stp
 
        % Dx = zeros(NV,xdim);

        Xv2 = Bentities(bR,1).INS(t,1).skin.mXv ;
        Xv1 = Bentities(bR,1).INS(t-1,1).skin.mXv ;

        
        Dx = Xv2 - Xv1;
        
        Cv = Cv + sc*Dx; 

    end
    
    %}
    
end





end