function [ ] = r3021_PatchAnchors (pNcp, pNacp, pCP, PhyS, ParS, ...
                                   Aon, Aoff, Arefs, Anet, sc, xdim, udim)

% ACTION:
% Draws all skins of a patch in the specified space

% INPUTS:
% pAnet, pnAN, pmA: patch anchors features
% insR: instance reference
% Physical / Parameter / Index: space to represent


textO = 2 ;

if PhyS==1
    dim = xdim; 
elseif ParS==1 
    dim = udim;
end


% 1.- ANCHORS AND THEIR REF'S:

AncCtr = zeros(pNacp,dim); % to store all relevant anchor coordinates

x = zeros(dim,1);


for a = 1:1:pNacp
    

    if (Aon==1 && pCP(a,1).ON==1) || (Aoff==1 && pCP(a,1).ON==0)
        
        for di = 1:1:dim
            
            if PhyS == 1
                
                AncCtr(a,di) = pCP(a).mXcoor(di);
                x(di,1) = pCP(a).mXcoor(di);
                
            elseif ParS == 1
                
                AncCtr(a,di) = pCP(a).mAcoor(di);
                x(di,1) = pCP(a).mAcoor(di);
                
            end
            
        end
        
        %{
        if PhyS==1
            
            for di=1:1:dim
                x(di,1) = pmA(a).mXcoorF(di) + ...
                    (pmA(a).mXcoor2(di) - pmA(a).mXcoorF(di))*sc;
                AncCtr(a,di) = x(di);
            end
            
        elseif ParS==1
            
            for di=1:1:dim
                x(di,1)        = pmA(a).mUcoor(di);
                AncCtr(a,di) = pmA(a).mUcoor(di);
            end
            
        end
        %}

        if pCP(a).ON == 1
            
            col = 'red';
            
        elseif pCP(a).ON == 0
            
            alfa = 0.8;
            col = [0,0,0]+alfa;
            %col = 'red'; %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        end

        
        plot3(x(1),x(2),x(3),'marker','o', 'color',col, 'LineWidth',1.8); hold on ;
        
        if Arefs == 1
            
            text(x(1)+textO, x(2)+textO,x(3)+textO, num2str(a)); hold on ;
            
        end
        
    end
    

end


% 2.- ANCHOR NET:

% {

colNet = '--r';

if Anet == 1

     r3022_printCPnet (AncCtr, pNcp, dim, 0, colNet);
     
    %{
    Cnet = zeros(pNcp(1), pNcp(2), pNcp(3), dim);
    
	conta = 0 ;
    for i = 1:1:pNcp(1)
 	for j = 1:1:pNcp(2)
  	for k = 1:1:pNcp(3) 
        conta = conta+1;
        Cnet(i, j, k,:) = AncCtr(conta,:);
    end
  	end
    end
    
    
    
    for i = 1:1:pNcp(1)
    for j = 1:1:pNcp(2)
        
        X3 = zeros(pNcp(3), dim);
        X3(:,:) = Cnet(i,j,:,:);
        plot3(X3(:,1), X3(:,2), X3(:,3), colNet); hold on
        
    end
    end
    
    
    for j = 1:1:pNcp(2)
    for k = 1:1:pNcp(3)
        
        X1 = zeros(pNcp(1), dim);
        X1(:,:) = Cnet(:,j,k,:);
        plot3(X1(:,1), X1(:,2), X1(:,3), colNet); hold on
        
    end
    end
    
    
    for i = 1:1:pNcp(1)
    for k = 1:1:pNcp(3)
        
        X2 = zeros(pNcp(2), dim);
        X2(:,:) = Cnet(i,:,k,:);
        plot3(X2(:,1), X2(:,2), X2(:,3), colNet); hold on
        
    end
    end
    %}

end
%}


end

