function [ ] = r3023_CPs (xsF, usF, cprF, cnetF, Spatches, paR, Stp, sc, xdim)

pNcp  = Spatches(paR,1).INS(Stp,1).mNcp ;
pNacp = Spatches(paR,1).INS(Stp,1).mNacp ;
pCP   = Spatches(paR,1).INS(Stp,1).mCP ;

% 1.- CP'sC COORDINATES:

CPc = zeros(pNacp,xdim);
    

% 1.1.- First instance:

for c = 1:1:pNacp
  
	if xsF == 1
                
        CPc(c,:) = pCP(c,1).mXcoor(:);
                
	elseif usF == 1
                
        CPc(c,:) = pCP(c,1).mAcoor(:);
                
	end
            
end
  
% 1.2.- Adds next displacements with scale:
% (only in case is physical space and step 2 or greater)

if xsF==1
for s = 2:1:Stp
            
	for c = 1:1:pNacp

        for di = 1:1:xdim
        
            CPc(c,di) = CPc(c,di) + ...
            (Spatches(paR,1).INS(s,1).mCP(c,1).mXcoor(di) - ...
             Spatches(paR,1).INS(s-1,1).mCP(c,1).mXcoor(di))*sc ;

        end
	end
end
end


% 1.3.- Plots:

if xsF==1
    txtO = 2 ;
elseif usF==1
    txtO = 0.05 ;
end

for c = 1:1:pNacp

    if pCP(c,1).ON == 1     
        col = 'red';      
	elseif pCP(c,1).ON == 0  
        alfa = 0.8;
        col = [0,0,0]+alfa;
    end

        
	plot3(CPc(c,1),CPc(c,2),CPc(c,3),'marker','o', 'color',col, 'LineWidth',1.8); hold on ;
        
 	if cprF == 1     
        text(CPc(c,1)+txtO, CPc(c,2)+txtO,CPc(c,3)+txtO, num2str(c)); hold on ;   
	end
end



% 2.- ANCHOR NET:

colNet = '--r';

if cnetF == 1

     r3022_printCPnet (CPc, pNcp, xdim, 0, colNet);
     
end


end

