function [] = i3052_pEntityED_CN (fr, cnF, edF, KnotV, Ncp,Degree,Usize, Ew, EP, P, udim,xdim)

% plots entity edges and control net

% INPUTS:
% cnF = 1 if control net to be printed
% edF = 1 if edges to be printed

CPcol = 'r';
CNcol = '--r';
EDcol = 'k';
EDlw = 3 ;

stp = ones(udim,1)*0.02; % step for representing

if fr > 0
    figure(fr)
end


% CURVES:

if udim == 1
    
    if cnF == 1
        if xdim==2
            scatter(P(:,1),P(:,2),CPcol); hold on
            plot(P(:,1),P(:,2),CNcol); hold on
        elseif xdim==3
            scatter3(P(:,1),P(:,2),P(:,3),CPcol); hold on
            plot3(P(:,1),P(:,2),P(:,3),CNcol); hold on
        end
    end
    
    
    if edF == 1
        
        conta = 0 ;
        r = zeros(1,xdim);
        
        for u = 0:stp(1):1
            
            [X] = b2601_BNURBS_Xcoord (u, KnotV, Ncp, Degree, Usize, Ew, EP, udim,xdim);
            conta = conta+1;
            r(conta,:) = X(:,1);
        end
        
        if xdim==2 
            plot(r(:,1),r(:,2),EDcol, 'LineWidth',EDlw); hold on  
     	elseif xdim==3
            plot3(r(:,1),r(:,2),r(:,3),EDcol, 'LineWidth',EDlw); hold on 
        end
    end
     
end


% SURFACES:

if udim == 2
    
    if cnF == 1
        
        if xdim==2
            
            for i = 1:1:Ncp(1)
                plot(EP(i,:,1),EP(i,:,2),CNcol); hold on
            end
            for j = 1:1:Ncp(2)
                plot(EP(:,j,1),EP(:,j,2),CNcol); hold on
            end
            scatter(P(:,1),P(:,2),CPcol); hold on
        
        end
        
        if xdim==3
            
            for i = 1:1:Ncp(1)
                plot3(EP(i,:,1),EP(i,:,2),EP(i,:,3),CNcol); hold on
            end
            for j = 1:1:Ncp(2)
                plot3(EP(:,j,1),EP(:,j,2),EP(:,j,3),CNcol); hold on
            end
            scatter3(P(:,1),P(:,2),P(:,3),CPcol); hold on
        
        end
        

        
    end
    
    
    if edF == 1

        for v = 0:1:1    
            
            conta = 0 ;
            r = zeros(1,xdim); 
            for u = 0:stp(1):1

                [X] = b2601_BNURBS_Xcoord ([u v], KnotV, Ncp, Degree, Usize, Ew, EP, udim,xdim);
                conta = conta+1;
                r(conta,:) = X(:,1);
            end
            
            if xdim==2 
                plot(r(:,1),r(:,2),EDcol, 'LineWidth',EDlw); hold on  
            elseif xdim==3
                plot3(r(:,1),r(:,2),r(:,3),EDcol, 'LineWidth',EDlw); hold on 
            end

        end
        

        for u = 0:1:1    
            
            conta = 0 ;
            r = zeros(1,xdim); 
            for v = 0:stp(1):1

                [X] = b2601_BNURBS_Xcoord ([u v], KnotV, Ncp, Degree, Usize, Ew, EP, udim,xdim);
                conta = conta+1;
                r(conta,:) = X(:,1);
            end
            
            if xdim==2 
                plot(r(:,1),r(:,2),EDcol, 'LineWidth',EDlw); hold on  
            elseif xdim==3
                plot3(r(:,1),r(:,2),r(:,3),EDcol, 'LineWidth',EDlw); hold on 
            end

        end
        
    end
     
end




% VOLUMES:

if udim == 3
    
    if cnF == 1

        for i = 1:1:Ncp(1)
     	for j = 1:1:Ncp(2)
            
            r = zeros(Ncp(3),xdim);
            for k = 1:1:Ncp(3)
                r(k,:) = EP(i,j,k,:);
            end
            plot3(r(:,1),r(:,2),r(:,3),CNcol); hold on
      	end
        end
        
       	for i = 1:1:Ncp(1)
     	for k = 1:1:Ncp(3)
            
            r = zeros(Ncp(2),xdim);
            for j = 1:1:Ncp(2)
                r(j,:) = EP(i,j,k,:);
            end
            plot3(r(:,1),r(:,2),r(:,3),CNcol); hold on
      	end
        end
        
       	for j = 1:1:Ncp(2)
     	for k = 1:1:Ncp(3)
            
            r = zeros(Ncp(2),xdim);
            for i = 1:1:Ncp(1)
                r(i,:) = EP(i,j,k,:);
            end
            plot3(r(:,1),r(:,2),r(:,3),CNcol); hold on
      	end
        end
        
        scatter3(P(:,1),P(:,2),P(:,3),CPcol); hold on
    end
    
    
    if edF == 1

        %{
        for u = 0:1:1
        for v = 0:1:1    
            
            conta = 0 ;
            r = zeros(1,xdim); 
            for w = 0:stp(3):1

                [X] = b2601_BNURBS_Xcoord ([u v w], KnotV, Ncp, Degree, Usize, Ew, EP, udim,xdim);
                conta = conta+1;
                r(conta,:) = X(:,1);
            end
            
         	plot3(r(:,1),r(:,2),r(:,3),EDcol, 'LineWidth',EDlw); hold on 
        end
        end
        %}
              
        l = [1 2 3 ; 2 3 1 ; 3 1 2 ];
     	uvw = zeros(1,udim);
             
        for di = 1:1:xdim
        
            for u = 0:1:1
            for v = 0:1:1    

                conta = 0 ;
                r = zeros(1,xdim); 
                for w = 0:stp(di):1

                    uvw(1,l(di,1)) = u ;
                    uvw(1,l(di,2)) = v ;
                    uvw(1,l(di,3)) = w ;
                    
                    [X] = b2601_BNURBS_Xcoord (uvw, KnotV, Ncp, Degree, Usize, Ew, EP, udim,xdim);
                    conta = conta+1;
                    r(conta,:) = X(:,1);
                end

                plot3(r(:,1),r(:,2),r(:,3),EDcol, 'LineWidth',EDlw); hold on 
            end
            end
            
        end 
        
    end
     
end







if fr > 0
    axis equal
end


end

