function [Npa, Nbe, Nbc, Ntc, gPatch, gFace, bEnti, tFace, bCurv, tCurv, pCou] = i3100_IGES(Gname, Bname)
          

% RETURNS: 
% Geometry and Boundary entities definition extracted from IGES files
% gPatch
% bEnti
% pCou(No. couplings, coupled patches refs)

% INPUTS:
% Gname: gross patch IGES file name
% Bname: boundary entities IGES file name

xdim = 3 ;
udim = 3 ;


% 1.- READ GROSS GEOMETRY:

[Npa, gFace, gbShell, gPatch] = gp3110_readGP (Gname, xdim, udim);


% 2.- READ BOUNDARY ENTITIES: includes finding and setting couplings

[Nbe, Nbc, Ntc, bEnti, tFace, bCurv, tCurv, pCou, pnbe, pRbe] = be3120_readBE (Bname, gbShell, xdim, udim-1);



% 3.- COMPLETES SOME DATA STRUCTURES:

% 3.- Patches-BE relationship:

for pa = 1:1:Npa
    
    gPatch(pa,1).nbe = pnbe(pa);
    for b = 1:1:pnbe(pa)
        gPatch(pa,1).Rbe(b) = pRbe(pa,b);
    end
end


     
end

