function [bF] = i3102_curvedScomp ...
    (sR, Xmid, fNcp, fDegree, fUsize, fKnotV, fw, fP, fCS, fEw, fEP,  xdim)

% RETURNS:
% belonging flag = 1 if Xmid belongs to computable face (surface), otherwise = 0

   
% INPUTS:
% Xmid: point to evaluate
% face NURBS features and curves

udim = 2 ;

bF = 0 ;

sXmid = Xmid';

% 1.- CHECK 1:
% checks Xmid is within the convex hull of face cp's
                    
% 1.1.- Performs triangulation in non-repeated points cloud:

[rP ,~] = GEN_16_RemoveRepeatedRows (fP, xdim, 0.000001);
DT = delaunayTriangulation(rP);
TRI = DT.ConnectivityList;

% 1.2.- Remove those tet.s that are planar:

[rP, TRI] = go2513_ClearTetMesh (rP, TRI);
                
                
% 1.3.- 'tix' is the index of the tet. where Xmid lies in
% if tix is a number then means Xmid is inside the hull
% of the 'f' face cp's 

tix = tsearchn(rP,TRI,Xmid');


% 2.- CHECK 2:  
% distance from Xmid to face surface < tolD 
% If so, that is the face

if isnan(tix)==false
                                         
	tolD = 0.01;
  	nsp = 1 ;
   
	[Uf] = b2801_PPforSetPoints (nsp, sXmid, fDegree, fNcp, fKnotV, fUsize, fP ,fw, fCS, xdim, udim,0);
    
 	[Xf] = b2601_BNURBS_Xcoord (Uf, fKnotV, fNcp,fDegree,fUsize, fEw,fEP, udim,xdim);
    
	dist = norm(Xmid-Xf);
    
	if dist < tolD
             
        % 3.- CHECK 3: Uf must be within contour loop
        
        % this is inactive at the moment.
           
        %{
        
    	% finds closest point of closest contour curve:
                        
        DXmin = norm(Xmid)*100;
        st = 0.2 ;
                        
                        for c = 1:1:oNoc
                            
                            cKnotV  = oLCurves(c).KnotV;
                            cNcp    = oLCurves(c).Ncp;
                            cDegree = oLCurves(c).Degree;
                            cUsize  = oLCurves(c).Usize;
                            cw      = oLCurves(c).w;
                            cP      = oLCurves(c).P;
 
                            for u = 0:st:1
                                
                                [xt] = b2601_BNURBS_Xcoord (u, cKnotV, cNcp,cDegree,cUsize, cw,cP, 1,xdim);     

                                if norm(xt-Xmid)<DXmin
                                    ccR = c ;
                                    uc = u ;
                                    xc = xt ;
                                    DXmin = norm(xt-Xmid);
                                end
                            end
                        end

                        % selected curve features:
                        cKnotV  = oLCurves(ccR).KnotV;
                        cNcp    = oLCurves(ccR).Ncp;
                      	cDegree = oLCurves(ccR).Degree;
                     	cUsize  = oLCurves(ccR).Usize;
                      	cw      = oLCurves(ccR).w;
                      	cP      = oLCurves(ccR).P;
                        
                        % surface Ucoor at xc
                        [Uc] = b2801_PPforSetPoints (nsp, xc', fDegree, fNcp, fKnotV, fUsize, fP ,fw, fCS, xdim, udim,0);
                 	
                        
                        [xc] = b2601_BNURBS_Xcoord (Uc, fKnotV, fNcp,fDegree,fUsize, fEw,fEP, 2,xdim); 
                        
                        % main derivatives of surface at Uc:
                        [dS] = b2701_BNURBS_deriv (fDegree, fNcp, fKnotV, fUsize, fP ,fw, [1 1], Uc, xdim, udim);

                        dSu = zeros(xdim,1);
                        dSv = zeros(xdim,1);
                        
                        dSu(:,1) = dS(2,1,1,:);
                        dSv(:,1) = dS(1,2,1,:);
                        
                        
                        % normal to surface (points outwards)
                        
                        nv = cross(dSu,dSv);
                        nv = nv/norm(nv);
                        
                        
                        % derivative of curve at xc:
                        [dC] = b2701_BNURBS_deriv (cDegree, cNcp, cKnotV, cUsize, cP ,cw, [1], uc, xdim, 1);
                        
                        dCu = zeros(xdim,1);
                        dCu(:,1) = dC(2,1,1,:);
                        
                        % vector xc-Xmid:
                        vxx = Xmid-xc;
                        
                        % projection onto normal plane at xc:
                     	vxx2 = xc+vxx;
                        [vxx2p] = go2518_POntoP(vxx2, nv, xc);
                        vxx = vxx2p-xc;
                        
                        nv2 = cross(dCu,vxx);
                        nv2 = nv2/norm(nv2);
                        
   
                        % cn3 = 1 , changes to 0 if finds opposite compoent
                        % in normal vectors:
                        
                        cn3 = 1;
                        for di = 1:1:xdim
                            
                            if abs(round(nv(di),2)) > 0 && abs(round(nv2(di),2)) > 0
                            
                                if sign(nv(di))~=sign(nv2(di))
                                    cn3=0;
                                    break
                                    
                                end
                            end
                        end
                        

                        
        % condition 3:
        if cn3==1
            bF = 1 ;                 
        end
   
        %}
        
        bF = 1 ;
        
	end

end

end

