function [Npa, gFace, gbShell, gPatch] = gp3110_readGP (Gname, xdim, udim)

% RETURNS:
% Nso: No. patches
% gShell(Nso): structure with shell vertexes and surfaces NURBS info
% gPatch(Nso): structure will patch NURBS info

% INPUTS:
% Gname. txt IGES file of gross patches



% 1.- PRELIMINARY OPERATIONS: No. lines in IGES, No. patches & patches ref's:

[NL, Npa, paoR] = gp3111_patchesRef (Gname);

%{
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

x = [ 0  10 20 20 30 30];
y = [ 0   0 10 12 5   6];
z = [ 10  5 5   2 2   4];

sX = [x',y',z'];

m=size(sX,1);

A = [ sum(x) ; sum(y) ; sum(z) ] / m; 


%[D] = go2521_lineFit (A, sX,m , 3);

[D] = go2519_planeFit (A, sX, m, xdim);

sc = 10 ;

for di = 1:1:3
P1(di) = A(di)+sc*D(di);
P2(di) = A(di)-sc*D(di);
end

figure(1)
scatter3(x,y,z,'b'); hold on

plot3( [P1(1) P2(1)],  [P1(2) P2(2)],  [P1(3) P2(3)], 'r');
axis equal



if ggg==0
    
    
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%}

% 2.- READ GRAPHIC OBJECTS AND TRANSFERS TO MATRICES:

%{
[Nso,sGMSBO,Nsh,sGshells,Nfa,sGfaces,Nsu,sGsurfN,Nlo,sGloops,Ned,sGedges,Ncu,sGcurves,...
Nve,sGvertexes, Nbs,sGbsurf, Nbo,sGbound, Nsr, sGrsurf, Nli, sGline] = ...
i3150_IGEStoMat (Gname, Npa, NL);
%}


[Smsbo, Sshells, Sfaces, Ssurf, Sloops, Sedges, Scurves, Svrtx, ~, ~] = ...
ri3190_IGEStoMat (Gname, Npa, NL);


% 3.- GENERATES gShell STRUCTURE:
% gShell is a collection of faces and edge curves arranged for filling the
% patch in the next step. gShell will be used also when trimming and B.C.'s

[gShell] = gp3112_gShell ...
(Smsbo, Sshells, Sfaces, Ssurf, Sloops, Sedges, Scurves, Svrtx, Npa, paoR);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%{
for s = 1:1:6
    
    P = gShell.face(s).fSurface.P;
    w = gShell.face(s).fSurface.w;
    n = gShell.face(s).fSurface.Ncp;
    
    [Ew,EP] = GEN_12_ExpandBw (w, P, 3, 2, n);
    
    figure(1)
    
    for i = 1:1:n(1)
        
        plot3( EP(i,:,1),  EP(i,:,2),  EP(i,:,3), '--r'); hold on
        
    end
    
	for j = 1:1:n(2)
        
        plot3( EP(:,j,1),  EP(:,j,2),  EP(:,j,3), '--r'); hold on
        
    end
    
    scatter3(P(:,1), P(:,2), P(:,3), 'r'); hold on
    
    axis equal
    
    
end
%}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% 4.- DEFINES PATCH FEATURES:

[gPatch] = gp3113_gPatch (Npa, gShell, xdim, udim);



% 5.- GENERATES gbShell:
% the unique purpose of gbShell is to help to identify non-trimming B.E.
% later on.
% gbShell: is equivalent to gShell, but re-arranged to be as bShell and be used
% to indentify B.E.

[gbShell] = gp3114_gbShell (Npa, gShell, xdim);


% 6.- STRUCURES TO DEFINE SKINS AFTERWARDS:

[gFace] = gp3116_gFaces (Npa, gShell);






end

