function [NL, Npa, paoR] = gp3111_patchesRef (Fname)

% RETURNS: 
% NL: No. lines in IGES
% Npa: No. patches
% paoR: pointer from user patch ref. to original patch ref as per IGES files

% 1.- No. lines of the file: NL

fid = fopen(Fname);


g = textscan(fid,'%s','delimiter','\n');
NL = length(g{1});

fclose(fid);


% 2.- No. patches and colour references for each: Npa & coR()

Npa = 0 ;
paoR = zeros(1,1); % patch reference reversed: input user ref, gets 'original' ref from IGEs
coR = zeros(1,1);

fid = fopen(Fname);
    
for L = 1:1:NL
    
    wline = fgetl(fid); % read whole line
    
    if strcmp(wline,'')==false

        % EXTRACTS FIRST STRING: feature name
        
        ENu = wline(6:8); % entity number , MSBO = 186 in directory entry section
        Lch = wline(73); % last character

        % counts No. patches = No. MSBO
        % stores colour reference
        
        if strcmp(ENu,'186') == true && strcmp(Lch,'D') == true
            
            Npa = Npa + 0.5;
            
            if mod(Npa,1)==0 % second line of each MSBO read colur reference:
                
                str =  wline(19:24);
                
                for i = 1:1:5
                    if strcmp(str(i),'-')== true
                        strR =  wline(19+i:24);
                        break
                    end 
                end
                
                coR(Npa,1) = str2num(strR);
                
            end
        end
    end
end


fclose(fid);


% 3.- Allocates patches references: paR()

fid = fopen(Fname);
    


for L = 1:1:NL
    
    % read whole line and detects first line is colour:
    wline = fgetl(fid); 
    FL = wline(1:3);
    
    % reads reference:
    if strcmp(FL,'314')== true 
        
        [refP] = gp3115_refP (wline);


        % finds which patch matches and allocates patch reference:
        for pa=1:1:Npa
        
            if coR(pa,1) == refP
                

                
                C = textscan(wline,'%f',2,'Delimiter',',');
                A = cell2mat(C);
                

                
                R = A(2);
                R = round((R*255/100 - 200));


                paoR(R,1) = pa ;
                
                break
            end
        end
    end  
end

fclose(fid);




end

