function [Nbe, Nbc, Ntc, bEnti, tFace, bCurv, tCurv, pCou, pnbe, pRbe] = be3120_readBE (Bname, gbShell, bxdim, budim)

% RETURNS:
% Nbe:          No. B.E.'s
% bEnti(Nbe):	structure with all BE's
% pNbe(nop,1):  No. BE per patch
% pbe(nop,Nbe):	BE ref. per patch
% pTbe(Nbe,1):	trimming flag for BE (0/1 non/trimmed)

% INPUTS:
% Bname. txt IGES file of BE's
% pxdim, pudim: No. dims of BE's


% 1.- PRELIMINARY OPERATIONS: 

% No. lines in IGES, No. BEs, BEs refs, BEs refs in reverse direction
[NL, Nbe, beoR] = be3121_boundRef (Bname);


% No. patches & patches ref's:
[~, Npa, paoR] = gp3111_patchesRef (Bname);


% 2.- READ GRAPHIC OBJECTS AND TRANSFERS TO MATRICES:

[~, Sshells, Sfaces, Ssurf, Sloops, Sedges, Scurves, ~, Sbsurf, Sbound] = ...
ri3190_IGEStoMat (Bname, Npa, NL);


% 3.- GENERATES bshell STRUCTURE FOR BOUNDED SHELL:
% it is easer to work with bShell than the Sstructures directly

[bShell] = be3122_bShell (Npa, Sshells, Sfaces, Sloops, Sedges, Scurves, Ssurf, paoR, bxdim);



% 4.- B.E. IDENTIFICATION:
% returns 
% - patches relation-ship & trimming state of B.E.
% - what patch-face is attached to the B.E.
% - if B.E. NURBS surface needs to be reversed (if so revs(b)=1 )

[pnbe, pRbe, bTr, revs, pCou, bCou, BPcon] = be3123_BEtype ...
    (Npa, bShell, gbShell, Nbe, beoR, Sbsurf, Sbound, Ssurf, Scurves, bxdim, budim);



% 5.- CREATION OF bEnti STRUCTURE:

% uses revs for the determination of the orientantion of correpondent sBbsurf

[bEnti, bCurv, Nbc] = be3124_bEnti ...
(Nbe, beoR, bCou, Sbsurf, Ssurf, Sbound, Scurves, revs, bTr, BPcon, budim, bxdim);

% rounds knot vectors:
nd = 6 ;
for c = 1:1:Nbc
    bCurv(c).KnotV = round(bCurv(c).KnotV,nd);
end


% 6.- TRIMMED FACES and ADDITION OF bCurv

[tFace, Ntc, tCurv] = be3125_tFaces (Npa, bShell, gbShell, bxdim, budim);

% rounds knot vectors:
nd = 6 ;
for c = 1:1:Ntc
    tCurv(c).KnotV = round(tCurv(c).KnotV,nd);
end



% 7.- AMENDS CURVES non-coincident WITH CLOSED LOOP SURFACES: => PENDING !!

% if that happens split the curve at the closed surface edge location,
% creating two curves from one


end

