function [NL, Nbe, beoR] = be3121_boundRef (Bname)

% RETURNS:
% NL: No. lines of the file
% Nbe: No. boundary entities
% beoR: BE refs: from user refs to original

% 1.- No. lines of the file: NL

fid = fopen(Bname);

g = textscan(fid,'%s','delimiter','\n');
NL = length(g{1});

fclose(fid);


% 2.- No. BE and colour references for each: Nbe & coR()

Nbe = 0 ;
beR = zeros(1,1); 
beoR = zeros(1,1); 
coR  = zeros(1,1);


fid = fopen(Bname);
    
for L = 1:1:NL
    
    wline = fgetl(fid); % read whole line
    
    if strcmp(wline,'')==false

        % EXTRACTS FIRST STRING: feature name
        
        ENu = wline(6:8); % entity number , bounded surface = 143
        Lch = wline(73); % last character

        % counts No. BE = No. bounded surfaces
        % stores colour reference
        
        if strcmp(ENu,'143') == true && strcmp(Lch,'D') == true
            
            Nbe = Nbe + 0.5;
            
            if mod(Nbe,1)==0 % second line of each MSBO read colur reference:
                
                str =  wline(19:24);
                
                for i = 1:1:5
                    if strcmp(str(i),'-')== true
                        strR =  wline(19+i:24);
                        break
                    end 
                end
                
                coR(Nbe,1) = str2num(strR);
                
            end
        end
    end
end

fclose(fid);



% 3.- Allocates entities references: beoR() 

fid = fopen(Bname);
    
for L = 1:1:NL
    
    % read whole line and detects first line is colour:
    wline = fgetl(fid); 
    FL = wline(1:3);
    
    % reads reference:
    if strcmp(FL,'314')== true 
        
        [refP] = gp3115_refP (wline);

        % finds which patch matches and allocates patch reference:
        for b =1:1:Nbe
            
            if coR(b,1) == refP
                
                C = textscan(wline,'%f',4,'Delimiter',',');
                A = cell2mat(C);
                R = A(2);
                R = round((R*255/100 - 200));
                beR(b,1) = R ;
                beoR(R,1) = b ;
                break
            end
        end
    end  
end

fclose(fid);






end

