function [conF, eR] = be3126_conF (edCurv, bCurv, b)

% RETURNS:
% conF: contur flag = 0 / 0.5 / 1  if 
% no contour / contour not whole edge / contour in whole edge

xdim = 3 ;

% RETURNS:
% conF updated to 0.5 in case curve lies on edge
% eR: edge ref. where the curve lies on

conF = 0 ;
eR = 0;
ecp = zeros(xdim,1); % edge  point
bcp = zeros(xdim,1); % bound. curve point

nd = 4 ;

bNcp = bCurv(b).Ncp ;
bDegree = bCurv(b).Degree ;
bUsize = bCurv(b).Usize ;
bKnotV = bCurv(b).KnotV ;
bw = bCurv(b).w ;
bP = bCurv(b).P ;
bCD = bCurv(b).CD ;


% 1.- CORNER + MID-POINT CHECK:     

% checks first edge corners: first curve point VS edge corners,
% number of corner is first point of correspondent edge curve
       
for e = 1:1:4           
    % edCurv(4) = struct ('Ncp',0,  'Degree',0, 'Usize',0, 'KnotV',[], 'w',[], 'P',[], 'conF', 0, 'CD', 0);

    % edge features
    eNcp = edCurv(e).Ncp ;
    eDegree = edCurv(e).Degree ;
    eUsize = edCurv(e).Usize ;
    eKnotV = edCurv(e).KnotV ;
    ew = edCurv(e).w ;
    eP = edCurv(e).P ;
    eCD = edCurv(e).CD ;

	if size(eKnotV,1)>1
        eKnotV = eKnotV';
    end
    
    ecp(:,1) = eP(1,:);
    bcp(:,1) = bP(1,:);
    CO1 = go2542_coincidentP (ecp, bcp, xdim, 4);

    % if finds fcp coincident with curve corner => checks second corner
    if CO1 == 1

      	ecp(:,1) = eP(eNcp,:);
        bcp(:,1) = bP(bNcp,:);
        CO2 = go2542_coincidentP (ecp, bcp, xdim, 4);
        
        % finds 2nd corner coincident => compares mid-point
        if CO2 == 1
            
            emp = b2601_BNURBS_Xcoord (0.5, eKnotV, eNcp,eDegree,eUsize, ew,eP, 1,xdim);
            bmp = b2601_BNURBS_Xcoord (0.5, bKnotV, bNcp,bDegree,bUsize, bw,bP, 1,xdim);
            COm = go2542_coincidentP (emp, bmp, xdim, 4);
            
            % that is conF=1
            if COm == 1
                conF=1 ;
                eR=e;
                break
            end 
            
        end
    end          
end


% FURTHER CHECKS: in case no-corner + mid point coincides


% 2.- CHECKS IF is contained in one edge (not spaning the whole lenght though)

if conF == 0
    
    % extracts sample of Nsp points
    
    Nsp = 5 ;
    
    bX = zeros(Nsp,xdim);
    bx = zeros(xdim,1);
    st = 1/Nsp;
    i = 0;
    
    for ui = 0:st:1
        
        i = i+1;
        x = b2601_BNURBS_Xcoord (ui, bKnotV, bNcp,bDegree,bUsize, bw,bP, 1,xdim);
        bX(i,:) = x(:,1);
    end
    
    
    bX
    
    % finds their param. location in edges:
    
    for e = 1:1:4    
        
        % edCurv(4) = struct ('Ncp',0,  'Degree',0, 'Usize',0, 'KnotV',[], 'w',[], 'P',[], 'conF', 0, 'CD', 0);

        % edge features
        eNcp = edCurv(e).Ncp ;
        eDegree = edCurv(e).Degree ;
        eUsize = edCurv(e).Usize ;
        eKnotV = edCurv(e).KnotV ;
        ew = edCurv(e).w ;
        eP = edCurv(e).P ;
        eCD = edCurv(e).CD ;

        if size(eKnotV,1)>1
            eKnotV = eKnotV';
        end
        
        
        
        
        [sUc] = pc2852_setPPcurves(bX, eNcp, eDegree, eKnotV, eUsize, eP, ew, eCD, xdim, nd, 0.01);
        
        for i = 1:1:Nsp
            
            ex = b2601_BNURBS_Xcoord (sUc(i), eKnotV, eNcp,eDegree,eUsize, ew,eP, 1,xdim);
            
            bx(:,1) = bX(i,:);
            
            COx = go2542_coincidentP (ex, bx, xdim, 4);
            
            if COx==0
                break
            end
        end
        
        % this curve coincides, at least in part, with edge eR
        if COx==1
            eR = e ;
            conF = 0.5;
            break
        end

    end
    
end









end

