function [SHP] = be3127_bTr (bShell, bPref, bFref, np, Sbsurf, boR, Sbound, Scurves)

% RETURNS:
% SHP(np,1): shaping feature: 0 / 0.5 / 1  for  external / internal to gross / shaping

% Extracts contour curves corners from bFref and bEnti. 
% Compares their max and min limits: if they are the same it is a shaping boundary.
   

xdim = 3 ;

SHP = ones(np,1); % assumes it is shaping surface

for apa = 1:1:np
    
    pR = bPref(apa);
    fR = bFref(apa);
    
	% 1.- Extracts bShell-face contour curves corners cp's max and min Xcoor, stores in bMm:

	bP = zeros(1,xdim); % coners cp's Xcoords
 	bMm = zeros(xdim,2); % max / mins of bP
        
	bNol = bShell(pR).face(fR).Nol ;
        
 	contaP = 0 ;
    for lo = 1:1:bNol
            
        Noc = bShell(pR).face(fR).fLoop(lo).Noc;
            
        for cur = 1:1:Noc
                
        contaP = contaP + 2 ;
        cNcp = bShell(pR).face(fR).fLoop(lo).LCurves(cur).Ncp;
                
            for di = 1:1:xdim
                bP(contaP-1,di) = bShell(pR).face(fR).fLoop(lo).LCurves(cur).P(1,di);
                bP(contaP-0,di) = bShell(pR).face(fR).fLoop(lo).LCurves(cur).P(cNcp,di);
            end
        end
        
    end
        
    
    for di = 1:1:xdim
        
        temp = sortrows(bP,di);
        bMm(di,1) = temp(1,di);
        bMm(di,2) = temp(end,di);
        
    end

        
	% 2.- Does the same with bEnti, stores in eMm:

	eP = zeros(1,xdim);
	eMm = zeros(xdim,2);
         
	Nob = Sbsurf(boR).Nob;
        
	contaP = 0;
    for ebo = 1:1:Nob
            
        eboR = Sbsurf(boR).boR(ebo);
        eNoc = Sbound(eboR).Noc;
            
        for cur = 1:1:eNoc
                
        contaP = contaP + 2 ;
        ecuR = Sbound(eboR).cuR(cur);
    	ecNcp = Scurves(ecuR).Ncp;
                
            for di = 1:1:xdim
                eP(contaP-1,di) = Scurves(ecuR).P(1,di);
                eP(contaP-0,di) = Scurves(ecuR).P(ecNcp,di);
            end
        end
    end
        
    for di = 1:1:xdim
        
        temp = sortrows(eP,di);
        eMm(di,1) = temp(1,di);
        eMm(di,2) = temp(end,di);
        
    end

    
	% 3.- Compares, if same max and min => potential shaping , keeps the value (SHP=1).
    
	% If max and mins of cp's are not the same as the attached patch-face is 
	% potentially no-shaping (SHP = 0.5), needs to compare against gross patches.
        
	for di = 1:1:xdim
        for Lim = 1:1:2
            
            if round(bMm(di,Lim),2) ~= round(eMm(di,Lim),2)
                SHP(apa,1) = 0.5;
                break
            end
            
        end   
	end

end



end

