function [eXo] = s3143_interHull (eXo, Ncp, xdim)

% Internal nodes: by 'intersection' of three lines, i.e. the closest point
% to them (uses LSM again):

a = zeros(3,xdim);
b = zeros(3,xdim);
v = zeros(3,xdim);
vtemp1 = zeros(xdim,1);
vtemp2 = zeros(xdim,1);
vtemp3 = zeros(xdim,1);

for i = 2:1:Ncp(1)-1

    for j = 2:1:Ncp(2)-1

        for k = 2:1:Ncp(3)-1
        
          	% sets lines in 3 directions
            
            a(1,:) = eXo(1,j,k,:);
            a(2,:) = eXo(i,1,k,:);
            a(3,:) = eXo(i,j,1,:);
            
          	b(1,:) = eXo(Ncp(1),j,k,:);
            b(2,:) = eXo(i,Ncp(2),k,:);
            b(3,:) = eXo(i,j,Ncp(3),:);
            
            for di = 1:1:xdim
                vtemp1(di,1) = b(1,di)-a(1,di);
                vtemp2(di,1) = b(2,di)-a(2,di);
                vtemp3(di,1) = b(3,di)-a(3,di);
            end
            
            vtemp1 = vtemp1/norm(vtemp1);
            vtemp2 = vtemp2/norm(vtemp2);
            vtemp1 = vtemp1/norm(vtemp1);
            
            v(1,:) = vtemp1(:,1);
            v(2,:) = vtemp2(:,1);
            v(3,:) = vtemp3(:,1);
            
  
            % finds closest point to the three lines and allocates:
            
            [CP] = go2523_P_to_nLines (a, v, 3, xdim);
            for di = 1:1:xdim
            eXo(i,j,k,di) = CP(di);
            end

        end
    end
end


end

