function [mXo, vXo, ur] = s3144_0posPrDs (Ncp, eXo, ePh)

% assemblies initial position arrays and prescribed displacements:

xdim = 3 ;
nNod = prod(Ncp);
DoF = nNod*xdim;

mXo = zeros(nNod, xdim); % node by node matrix form
vXo = zeros(DoF,1); % vector form

ur = zeros(DoF, 1); % increment required for achieving final shape (only applicable to contour points!)

a = 0 ;
b = 0 ;



for i = 1:1:Ncp(1)
for j = 1:1:Ncp(2)
for k = 1:1:Ncp(3)
        
    a = a + xdim;
    b = b + 1;
        
    for di = 1:1:xdim

        mXo(b,di) = eXo(i,j,k,di);
        
        r = a - xdim + di ;
        vXo(r,1)  = eXo(i,j,k,di);
            
        ur(r,1)   = ePh(i,j,k,di) - vXo(r,1); % note, it will use only the boundary surface
            
    end

end
end
end






end

