function [K1, K2, K3, Kd] = s3145_subKE1 (Ncp, mXo, NB, TB, TBD, BVcon)

% RETURNS:
% K1 to K4: submatrices with E=1 or bars in 3 diretions and diagonals

xdim = 3 ;
DoF = prod(Ncp)*xdim ;

N = 2 ;             % No. nodes per bar
nr = zeros(N,1);    % nodes references

DX = zeros(xdim,1); % increment of Xcoord's vector

% bars in direction 1, 2, 3 and diagonals
K1 = zeros(DoF,DoF);
K2 = zeros(DoF,DoF); 
K3 = zeros(DoF,DoF); 
Kd = zeros(DoF,DoF); % diagonals

% computes each sub-K with E = 1

E = 1 ;
for b = 1 : 1 : TBD

    % nodes refs
    nr(1) = BVcon(b,1);
    nr(2) = BVcon(b,2);
    
    % length and orientation:
    
    DX(:,1) = mXo(nr(2),:) - mXo(nr(1),:) ;
    L = norm(DX);
    u = DX/L;
    
    % element stiffness matrix (given already in global axis):
    [kL] = ms3201_KGrod3D (E,1,L, u);
    
	% add to sub-K
    
    if 0 < b && b <= NB(1)
        
        [K1] = a3211_insertinK (K1, kL, nr, N, xdim);
        
    elseif NB(1) < b && b <= NB(1)+NB(2)
        
        [K2] = a3211_insertinK (K2, kL, nr, N, xdim);
       
    elseif NB(1)+NB(2) < b && b <= TB
        
        [K3] = a3211_insertinK (K3, kL, nr, N, xdim);
        
 	elseif TB < b && b <= TBD 
        
        [Kd] = a3211_insertinK (Kd, kL, nr, N, xdim);

    end
    
end


end

