function [njF, efc, fcAve] = s3146_elemsJ (RVcon,vXod, NE)

% RETURNS:
% njF = flag of negative jacobian, turns to 1 if finds dJ < 0
% efc(2,1): worst jacobians cases (the two highest values)
% fcAve: averate of all jacobians
    
xdim = 3 ;

njF = 0 ;
efc = [2,1];
    
fcAve = 0 ;
    
for e = 1:1:NE
        
	r = [   RVcon(e,1); RVcon(e,2); RVcon(e,3); RVcon(e,4); ...
            RVcon(e,5); RVcon(e,6); RVcon(e,7); RVcon(e,8)] ;
          
	Xnod = [ ...
                vXod(r(1)*xdim-2) vXod(r(1)*xdim-1) vXod(r(1)*xdim-0); ...
                vXod(r(2)*xdim-2) vXod(r(2)*xdim-1) vXod(r(2)*xdim-0); ...
                vXod(r(3)*xdim-2) vXod(r(3)*xdim-1) vXod(r(3)*xdim-0); ...
                vXod(r(4)*xdim-2) vXod(r(4)*xdim-1) vXod(r(4)*xdim-0); ...
                vXod(r(5)*xdim-2) vXod(r(5)*xdim-1) vXod(r(5)*xdim-0); ...
                vXod(r(6)*xdim-2) vXod(r(6)*xdim-1) vXod(r(6)*xdim-0); ...
                vXod(r(7)*xdim-2) vXod(r(7)*xdim-1) vXod(r(7)*xdim-0); ...
                vXod(r(8)*xdim-2) vXod(r(8)*xdim-1) vXod(r(8)*xdim-0)]; 
            
	% rect-elem Jacobian:
	[J, dJ] = j2314_Jcuboid ([0 0 0], Xnod);

	% condition number metric:
	%fcond = (norm(J,'fro'))^2/abs(dJ);
	fcond = norm(J,'fro') * norm(inv(J),'fro') ;
        
	fcAve = fcAve + fcond;

	% stores the highest values (worst case)
	if fcond > efc(1)
        efc(1) = fcond ;
	elseif fcond > efc(2)
        efc(2) = fcond ;
    end
        
	if dJ < 0
        njF = 1 ;
        break
	end
    
end

fcAve = fcAve / NE ;



end

