function [w] = s3147_ws (Ncp, gShell, pa)

% RETURNS:
% w(ancp,1): transfers weights from surfaces, the internals are equal to one.

xdim = 3 ;
udim = 2 ;

% 1.- Default values:

Ew = ones(Ncp(1),Ncp(2),Ncp(3));
w = ones(prod(Ncp),1);


% 2.- gShell surfaces weights (expanded form):

sw1 = gShell(pa).face(1).fSurface.w;
sw2 = gShell(pa).face(2).fSurface.w;
sw3 = gShell(pa).face(3).fSurface.w;
sw4 = gShell(pa).face(4).fSurface.w;
sw5 = gShell(pa).face(5).fSurface.w;
sw6 = gShell(pa).face(6).fSurface.w;

P1 = gShell(pa).face(1).fSurface.P;
P2 = gShell(pa).face(2).fSurface.P;
P3 = gShell(pa).face(3).fSurface.P;
P4 = gShell(pa).face(4).fSurface.P;
P5 = gShell(pa).face(5).fSurface.P;
P6 = gShell(pa).face(6).fSurface.P;

[sEw1,~] = GEN_12_ExpandBw (sw1, P1, xdim, udim, gShell(pa).face(1).fSurface.Ncp);
[sEw2,~] = GEN_12_ExpandBw (sw2, P2, xdim, udim, gShell(pa).face(2).fSurface.Ncp);
[sEw3,~] = GEN_12_ExpandBw (sw3, P3, xdim, udim, gShell(pa).face(3).fSurface.Ncp);
[sEw4,~] = GEN_12_ExpandBw (sw4, P4, xdim, udim, gShell(pa).face(4).fSurface.Ncp);
[sEw5,~] = GEN_12_ExpandBw (sw5, P5, xdim, udim, gShell(pa).face(5).fSurface.Ncp);
[sEw6,~] = GEN_12_ExpandBw (sw6, P6, xdim, udim, gShell(pa).face(6).fSurface.Ncp);


% 3.- Transfers to patch weights:

for i = 1:1:Ncp(1)
for j = 1:1:Ncp(2)
    
    Ew(i,j,1)       = sEw1(i,j);
    Ew(i,j,Ncp(3))  = sEw4(i,j);
    
end
end


for i = 1:1:Ncp(1)
for k = 1:1:Ncp(3)
    
    Ew(i,1,k)       = sEw2(i,k);
    Ew(i,Ncp(2),k)  = sEw5(i,k);
    
end
end



for j = 1:1:Ncp(2)
for k = 1:1:Ncp(3)
    
    Ew(1,j,k)       = sEw3(j,k);
    Ew(Ncp(1),j,k)  = sEw6(j,k);
    
end
end


% 4.- Contracts weights:

conta = 0 ;
for i = 1:1:Ncp(1)
for j = 1:1:Ncp(2)
for k = 1:1:Ncp(3)
    
    conta = conta + 1 ;
    w(conta,1) = Ew(i,j,k);
    
end
end
end


end

