function [PL] = sf3151_surfacePL (Ncp, P)

% RETURNS: PL = 0 / 1 for non-plane / planar surfaces

% INPUTS:
% Ncp: No. control points in each directions
% P(Ncp,xdim): cp's coordinates

xdim = 3 ;
PL = 1 ; % assumes planar unless detects out of plane cp
    
% 1.- Extracts 3 points of the collection of cp's, and computes plane
% equation coefficients:

a = zeros(xdim,1);
b = zeros(xdim,1);
c = zeros(xdim,1);

for di=1:1:xdim
    
    a(di,1) = P(1,di);
    b(di,1) = P(2,di);
    c(di,1) = P(Ncp(1)*Ncp(2),di);
end
      
[A,B,C,D] = go2506_Plane3P (a,b,c);


% 2.- Check in any cp's coordinates does not match the plane equation:

for po = 1:1:Ncp(1)*Ncp(2)

    resi = A*P(po,1) + B*P(po,2) + C*P(po,3) + D ;
    
    if abs(resi)>0.000001
        
        PL = 0;
        break
    end
end


end

