function [fSurface] = sf3152_ReverseCPs (fSurface, rdi)

% RETURNS: fSurface structure with reversed params in direction 'rdi':
% KnotV, w, P

xdim = 3;


% 1.- Extracts separately features:

Ncp     = fSurface.Ncp;
Degree  = fSurface.Degree;
Usize   = fSurface.Usize;
KnotV   = fSurface.KnotV;
w       = fSurface.w;
P       = fSurface.P;


% 2.- Inverts KnotV:

U = zeros(Usize(rdi),1);

for i=1:1:Usize(rdi)
    U(i) = KnotV(rdi,i);
end

rU = GEN_06_ReverseKnotV (U, Ncp(rdi), Degree(rdi));

for i = 1:1:Usize(rdi)
    fSurface.KnotV(rdi,i) = rU(i);
end


% 3.- Control points coordinates:

% original arrangement bidimensional matrix:

oP = zeros(Ncp(1), Ncp(2), xdim);
ow = zeros(Ncp(1), Ncp(2));


conta = 0;
for i = 1:1:Ncp(1)
for j = 1:1:Ncp(2)
    
    conta = conta + 1 ;
    
    ow(i,j) = w(conta);
    
    for di=1:1:xdim
        oP(i,j,di) = P(conta,di);
    end
end
end


% reverses in 'rdi' direction:

a1 = 1;     st1 =  1;   b1 = Ncp(1);
a2 = 1;     st2 =  1;   b2 = Ncp(2);

if rdi==1
    a1 = Ncp(1); st1 = -1; b1 = 1;
elseif rdi==2
    a2 = Ncp(2); st2 = -1; b2 = 1;
end


conta = 0;
for i = a1:st1:b1
for j = a2:st2:b2
   
    conta = conta + 1 ;
    
    fSurface.w (conta) = ow(i,j);
    
   	for di=1:1:xdim
        fSurface.P (conta,di) = oP(i,j,di);
    end
end
end


end

