function [fSurface] = sf3153_Swap (fSurface)

% RETURNS: fSurface structure copied from from sGsurfaces, but 
% swapping parameter directions 1 and 2

xdim = 3;

% 1.- Extracts separately features:

sgNcp   = fSurface.Ncp;
sgDegree= fSurface.Degree;
sgUsize = fSurface.Usize;
sgKnotV = fSurface.KnotV;
sgw     = fSurface.w;
sgP     = fSurface.P;
sgCS    = fSurface.CS;


% 2.- Features but not cp's coordinates:

uc = [2 1];
for u = 1:1:2
    
    fSurface.Ncp(u)    = sgNcp(uc(u));
    fSurface.Degree(u) = sgDegree(uc(u)) ;
    fSurface.Usize(u)  = sgUsize(uc(u)) ;

    for i=1:1:fSurface.Usize(u)
        
        fSurface.KnotV(u,i) = sgKnotV(uc(u),i);
        
    end
    
    fSurface.CS(u)  = sgCS(uc(u)) ;
    
end


% 3.- Control points coordinates:

% original arrangement bidimensional matrix:

oP = zeros(sgNcp(1), sgNcp(2), xdim);
ow = zeros(sgNcp(1), sgNcp(2));


conta = 0;
for i = 1:1:sgNcp(1)
for j = 1:1:sgNcp(2)
    
    conta = conta + 1 ;
    
    ow(i,j) = sgw(conta);
    
    for di=1:1:xdim
        oP(i,j,di) = sgP(conta,di);
    end
end
end


% 'transposes' oP and ow matrix:

conta = 0;
for j = 1:1:sgNcp(2)
for i = 1:1:sgNcp(1)   
    
    conta = conta + 1 ;
    
    fSurface.w (conta) = ow(i,j);
    
   	for di=1:1:xdim
        fSurface.P (conta,di) = oP(i,j,di);
    end
end
end


end

