function [P] = sf3155_AbatePback (aP, Pr, vr, tita)

% RETURNS:
% P(n,m,xdim): collection of co-planar points rotated back to its position
% Pr,vr: rotation line point and vector
% tita: angle which was rotated previously.

xdim = 3 ;

n = size(aP,1);
m = size(aP,2);
P = zeros(n,m,xdim);

tP = zeros(xdim,1);

for i = 1:1:n
    
    for j = 1:1:m
        
        tP(:,1) = aP(i,j,:);
        
        [Pg] = go2502_RotatePaboutR (tP, Pr, vr, -tita); % note reverses angle
        
        P(i,j,:) = Pg(:,1);
        
    end
    
end




end

