function [NB, TN, nNod, DoF, NE, BVcon, RVcon, flagEB] = at3161_setBars (Ncp, xdim)

% RETURNS:
% Number of bars, DoF and connectivity matrix

% 1.- COMPUTES No. BARS:

% 1.1.- No. bars and diagonals

NB = zeros(xdim,1);
ND = zeros(xdim,1);

NB(1) = (Ncp(1)-1) * Ncp(2) ; % direction 1
NB(2) = Ncp(1) * (Ncp(2)-1); % direction 2

ND(1) = (Ncp(1)-1)*(Ncp(2)-1); % diag. ascending
ND(2) = (Ncp(1)-1)*(Ncp(2)-1); % diag. descending

TN = NB(2) + NB(1) + ND(1) + ND(2) ; % total of bars + diagonals


% 1.2.- No. nodes, elems & DoF:

nNod = Ncp(1)*Ncp(2);
DoF = nNod*xdim ;
NE = (Ncp(1)-1)*(Ncp(2)-1);




% 2.- BARS-VTX CONNECTIVITY MATRIX, R.ELEM-VTX CONN. MATRIX & EXTERNAL BAR FLAG:

% 2.1.- Pre-sizes:

BVcon = zeros(TN,2);

RVcon = zeros(NE,4);

flagEB = zeros(TN,1); % turns to 1 if is external bar, i.e. at least one node is permitral, except diagonals

acc = 0 ;
conta = 0;

for i = 1:1:Ncp(1)
for j = 1:1:Ncp(2)-1
    
    conta = conta + 1 ;
    
    BVcon(conta,1) = j +acc;
    BVcon(conta,2) = j +acc+1;
    
    if i==1 || i==Ncp(1)
        flagEB(conta) = 1 ;
    elseif j==1 || j==Ncp(2)-1
        flagEB(conta) = 1 ;
    end
    
end
acc = acc + Ncp(2) ;
end


for i = 1:1:Ncp(1)-1
for j = 1:1:Ncp(2)
    
    conta = conta+1;
    
    BVcon(conta,1) = (i-1)*Ncp(2) + j ;
    BVcon(conta,2) = (i-0)*Ncp(2) + j ;
    
  	if i==1 || i==Ncp(1)-1
        flagEB(conta) = 1 ;
    elseif j==1 || j==Ncp(2)
        flagEB(conta) = 1 ;
    end
    
end
end

% 2.2.- Diagonals ascending:

for i = 1:1:Ncp(1)-1
for j = 1:1:Ncp(2)-1
    conta = conta+1;
    BVcon(conta,1) = (i-1)*Ncp(2) + j ;
    BVcon(conta,2) = (i-0)*Ncp(2) + j +1 ;
end
end

% 2.3.- Diagonals descending:

for i = 1:1:Ncp(1)-1
for j = 1:1:Ncp(2)-1
    conta = conta+1;
    BVcon(conta,1) = (i-1)*Ncp(2) + j +1 ;
    BVcon(conta,2) = (i-0)*Ncp(2) + j ;
end
end


% 2.4.- Elements: counter clock-wise starting by right-up corner

contaE = 0;
for i = 1:1:Ncp(1)-1
for j = 1:1:Ncp(2)-1
    
    contaE = contaE+1;

    RVcon(contaE,1) = Ncp(2)*i + j + 1 ;
    RVcon(contaE,2) = Ncp(2)*(i-1) + j + 1 ;
    RVcon(contaE,3) = Ncp(2)*(i-1) + j ;
    RVcon(contaE,4) = Ncp(2)*i + j ;
    
end
end

end

