function [K1, K2, Kd] = at3163_K (TN, NB, BVcon, nXo, DoF, flagEB, xdim)

N = 2 ;             % No. nodes per bar
nr = zeros(N,1);    % nodes references

DX = zeros(xdim,1); % increment of Xcoord's vector

K1 = zeros(DoF,DoF); % bars perimeter (with at least one perimeter node)
K2 = zeros(DoF,DoF); % bars internal (with no perimeter node)
Kd = zeros(DoF,DoF); % diagonals

% K = zeros(DoF,DoF); % sum of all bars + diag's

% computes each sub-K with E = 1

E1 = 1 ;
for b = 1 : 1 : TN

    % nodes refs
    nr(1) = BVcon(b,1);
    nr(2) = BVcon(b,2);
    
    % length and orientation:
    
    DX(:,1) = nXo(nr(2),:) - nXo(nr(1),:) ;
    L = norm(DX);
    u = DX/L;
    tita = acos(u(1));
    
    % element stiffness matrix (given already in global axis):
    [kL] = ms3201_KGrod2D (E1,1,L, tita);
    

    % add to sub-K
    
    if 0 < b && b <= NB(1)+NB(2)
        
        if flagEB(b)==1
            [K1] = a3211_insertinK (K1, kL, nr, N, xdim);
        else
            [K2] = a3211_insertinK (K2, kL, nr, N, xdim);
        end
           
 	elseif NB(1)+NB(2) < b && b <= TN 
        
        [Kd] = a3211_insertinK (Kd, kL, nr, N, xdim);

    end
    
end



end

