function [Xsd] = at3165_XOptim (Xo, NE, RVcon, K1, K2, Kd, DoF, nNod, ur, nk, dkr, nu, dur, xdim)

% RETURNS:
% Xds(DoF,1); position of lattice nodes after applying displacement.
% Optimizes the jacobians according to ration Ediag/Ebars

Ntrials = 10 ;

E1 = 100; % externals

E2max = 200; % internals
Edmax = 200 ; % diag's

E2ini = 0 ;
Edini = 0 ;
 
DEd = Edmax/Ntrials;
DE2 = E2max/Ntrials;


fcMin = 999999 ;

for td = 1:1:Ntrials
%for t2 = 1:1:Ntrials
    
    Ed = Edini + DEd*td;

    E2 = E1 ;
    
    % sums stiffness:
    K = E1*K1 + E2*K2 + Ed*Kd ;
    
    % computes displacements:
    [u] = ts3231_prescribedUsol (DoF, nNod, K, ur, nk, dkr, nu, dur, xdim);
    
    % works out deformed position:
    Xod = Xo + u ;
    
    
    % Jacobians of elements (measured at center of element):
    
    flagNJ = 0 ; % flag of negative jacobian, turns to 1 if finds dJ<0
    efc = [ 2 2 ];
    
    efct = zeros(NE,1);
    
    for e = 1:1:NE
        
        r = [ RVcon(e,1); RVcon(e,2); RVcon(e,3); RVcon(e,4) ] ;
        Xnod = [ ...
                Xod(r(1)*xdim-1) Xod(r(1)*xdim-0); ...
                Xod(r(2)*xdim-1) Xod(r(2)*xdim-0); ...
                Xod(r(3)*xdim-1) Xod(r(3)*xdim-0); ...
                Xod(r(4)*xdim-1) Xod(r(4)*xdim-0) ]; 
           
        % rect-elem Jacobian:
        [J, dJ] = j2311_JPlaneRect ([0 0], Xnod);
        
        % condition number metric:
        fcond = norm(J,'fro')^2/abs(dJ);
        
        efct(e) = fcond;
        
        % stores the highest values (worst case)
        if fcond > efc(1)
            efc(1) = fcond ;
        elseif fcond > efc(2)
            efc(2) = fcond ;
        end
        
        if dJ < 0
            flagNJ = 1 ;
            break
        end
    end
    
    % only considers if non-negative Jacobians are found
    if flagNJ == 0
        
        efca = sum(efc)/2; % average of worst case
        
        
        % if worst case is lower than stored, updates
        
        if efca < fcMin
            
            fcMin = efca ;
            Xsd = Xod; % stored positions
            selT = td ;
            
        end
        
    end


    %%%%%%%%%%%%%%
    %{
    % plots all options
    
    figure(11)
    
    for i = 1:1:nNod
        Xt(i,1) = Xod(i*xdim-1);
        Xt(i,2) = Xod(i*xdim-0);
    end
    
    for b = 1:1:sum(NB)
        
        n1 = BVcon(b,1);
        n2 = BVcon(b,2);
        
        plot( [Xt(n1,1) Xt(n2,1)], [Xt(n1,2) Xt(n2,2)],'r'); hold on
        
    end
    
    axis equal
    %}
    %%%%%%%%%%%%%%
%end

%{
oo(td,1) = E1 ;
oo(td,2) = Ed ;
oo(td,3) = E1/Ed ;
oo(td,4) = efca ;
oo(td,5) = sum(efct)/NE ;
%}

end

end

