function [d, fd] = at3167_relDirs (XPi, Ncp)

% RETURNS:
% d(2,1): directions to consider in the 2D lattice
% fd: fixed direction, i.e. the one that does not change

% INPUTS:
% XPi(i,j,3): coord's of control points
% Ncp(2): No. cp's in each param. direction

xdim = 3 ;

% 2.- First point location:

x11 = zeros(xdim,1);

for di=1:1:xdim
    x11 (di,1) = XPi(1,1,di);
end

% 1.- PRECISSION FOR ROUNDING: pr

% it is a percentaje of the min. distance of contour cp's

xt = zeros(xdim,1);

mDst = 9999999999999 ; % min. distance
pc = 0.2; % percentage

for i = 1:1:Ncp(1)
    
    for j = 1:Ncp(2)-1:Ncp(2)
        
        if i~=1 || j~=1
            
            xt(:,1) = XPi(i,j,:);

            Dst = norm(xt-x11);

            if Dst < mDst
               mDst = Dst; 
            end
            
        end
    end
end

pr = mDst * pc/100; % precission (not rounded)

% just takes the order number of pr:
[o] = go2535_order (pr);




[x11] = go2532_RoundToR (x11, 10^o);




% 2.- LOOP ON POINTS: 


d = zeros(2,1); % directions that are in the plane, i,e, directions that are not constant
conta = 0 ;

for i = 1:1:Ncp(1)
    
    for j = 1:Ncp(2)-1:Ncp(2)

        for di = 1:1:xdim 

            if go2532_RoundToR(XPi(i,j,di),10^o)~=x11(di)
                
                if conta == 0
                    
                    conta = conta + 1 ;
                    d(conta,1) = di ;
                    
                elseif conta == 1
                    
                    if di~=d(conta,1)
                        conta = conta + 1 ;
                        d(conta,1) = di ;
                    end
                    
                end

            end

            
            if conta==2
            break
            end

        end

        if conta==2
        break
        end

    end

    if conta==2
    break
    end

end

% 4.- Sets the fixed direction:

for di = 1:1:xdim
    
    if di~=d(1) && di~=d(2)
        fd = di;
        break
    end
    
end



end

