function [P, KnotV, w, Ncp, Usize, addF] = gp3176_tKnotVins (P, KnotV, w, Ncp, Degree, Usize, di, ucandidate, ndig, xdim)

% RETURNS: 
% Surface NURBS features with ucandidate added if it was not previously
% addF = 1 if added, = 0 otherwise

% INPUTS:
% surface NURBS features
% di: direction being checked
% ucandiate: knot to add in case is not part of KnotV

udim = 2 ;           
            
addF = 1 ;

for j = 1:1:Usize(di)
    
    if round(ucandidate,ndig) == round(KnotV(di,j),ndig)
        addF = 0;
        break
    end
    
end
        

    
if addF == 1
                    
    % inserts if the surface does not possesses that ucandidate knot:
    
    U = KnotV(di,1:Usize(di));
    
    [P, U, w, Ncp, Utam] = GEN_03_10_1D_kSingleExt...
    (Ncp, Degree(di), U, P, w, ucandidate, di, xdim, udim);

    for i = 1:1:Utam
        KnotV(di,i) = U(i);
    end

    Usize(di) = Utam;
    
end
    
end

