function [afLoopVL] = gp3177_afLoopVP (Npa, sGMSBO, sGshells, sGfaces, sGloops, sGedges)

% RETURNS:
% afLoopVL(No. all faces , 5): 
% 'afLoopVL' from 'agregated faces loop Vertex List indexes'

%   No. faces = total faces for all patches
%   5 = 1 surface ref. + 4 vertexes per loop (one loop per face)



% 2.1.- Initiates afLoopVL:

afLoopVL = zeros(Npa*6,5);
contaf = 0 ;


% 2.2.- Stores vertex list indexes:

for poR = 1:1:Npa
    
    shR = sGMSBO(poR).shR; % shell reference
     
    for f = 1:1:6
       
        contaf = contaf + 1 ;
        
        % face, loop and surface reference
        
        faR = sGshells(shR).faR(f);
         
        LR = sGfaces(faR).loR(1); 
        
        
        
        suR = sGfaces(faR).suR;
        
        % allocates surface ref.
        afLoopVL(contaf,1) = suR ;
        
      	if f==1
            edR = sGloops(LR).edR(1);
        end

        for v = 1:1:4
            
            LI  = sGloops(LR).eLI(v);   % list index of the vertex
            Ori = sGloops(LR).edO(v);    % orientation of the edge

            % Identifies vertex list index and allocates:
            v1LR = sGedges(edR).v1LR(LI);
            if Ori==0
                v1LR = sGedges(edR).v2LR(LI);
            end
            
            afLoopVL(contaf,v+1) = v1LR;

        end
    end  
end


% 2.3.- Arranges afLoopVL by surface reference 
%       and remove column of surface references:

afLoopVL = sortrows(afLoopVL,1);
afLoopVL = afLoopVL(:,2:5);

 
end

