function [AtoOfaces] = gp3178_AtoOfaces (sGshells, sGfaces, sGverteces, afLoopVL, vR, poR, xdim)

% RETURNS:
% AtoOfaces(6,1)
% row is the Arranged face order, the value in the Orignial face ref.
% e.g.: OtoAfaces(2) = 4 ; original face 4 is ref. 2 for building the solid
    


% first face has the lowest average coordinate
    
    AtoOfaces = zeros(6,1); % row is the Arranged face order, the value in the Orignial face ref.
                            % e.g.: OtoAfaces(2) = 4 ; original face 4 is ref. 2 for building the solid
    
	% 5.1.- Face 1:
    
    Xmin = 99999999999;
    fmin = 0; 
    ofmin = 0; % original face reference with minimum distance to origin
    
    for f = 1:1:sGshells(poR).Nof %%%%%%%%%%%%%%%%%%%%%%%%%%%
     
        % original surface reference
        osR = sGshells(poR).faR(f) ; %%%%%%%%%%%%%%%%%%%%%%%%%%% 
        osR = sGfaces(osR).suR;
        
        Xacc = zeros(xdim,1);
        
        for v = 1:1:4
            
            vL = afLoopVL(osR,v);
            
            for di=1:1:xdim
                
                Xacc(di) = Xacc(di) + sGverteces(vR).P(vL,di);
                
                %XV(v,di) = sGverteces(vR).P(vL,di);
            end
        end
        

        NXacc = norm(Xacc/4);
        
        if NXacc < Xmin
            fmin = f ;
            ofmin = osR;
            Xmin = NXacc;
        end
    end
    
    AtoOfaces(1) = ofmin;


    % 5.2.- Allocates faces 2 and 3:
    
    % Select origin of parameters as first point of that face:
    % axis xi  1 (111) to 4 (121)
    % axis ita 1 (111) to 2 (211)
    
    %aXv = [ afLoopVL(fmin,1) , afLoopVL(fmin,4) ];
    %aIv = [ afLoopVL(fmin,1) , afLoopVL(fmin,2) ];
    
 	aXv = [ afLoopVL(ofmin,1) , afLoopVL(ofmin,4) ];
    aIv = [ afLoopVL(ofmin,1) , afLoopVL(ofmin,2) ];
  
    % Face 2 has axis xi, Face 3 has axis ita
    
    for f = 1:1:6
    if f ~= fmin
      
      	% original surface reference
        osR = sGshells(poR).faR(f) ;  %%%%%%%%%%%%%%%%%%%%%%%%%%%
        osR = sGfaces(osR).suR;
        
        accXi = 0 ;
        accIt = 0;
        
        for v = 1:1:4
            
            vL = afLoopVL(osR,v);
            
            if vL == aXv(1) || vL == aXv(2)
                accXi = accXi + 1 ;
            end
            if vL == aIv(1) || vL == aIv(2)
                accIt = accIt + 1 ;
            end
        end
        
        
        if accXi==2
            AtoOfaces(2) = osR;
        end
        if accIt==2
            AtoOfaces(3) = osR;
        end
        
    end
    end

    
    % 5.3.- Allocates opposite faces (4 to 6):
    
    for af = 1:1:3

        afR = AtoOfaces(af); % allocated face original ref.
        
        % finds face with all nodes different
        for f = 1:1:6
            
      	% original surface reference
    	osR = sGshells(poR).faR(f) ; %%%%%%%%%%%%%%%%%%%%%%%%%%%
     	osR = sGfaces(osR).suR;
            
        if osR ~= afR   
            
            accDist = 0;
            
            for cv = 1:1:4 % loop on candidate face vertexes
                
                cvL = afLoopVL(osR,cv);
                
                dist = 1; % changes to 0 if detects same vertex List index
                
                for av = 1:1:4 % loop on already allocated face verteces
                    avL = afLoopVL(afR,av);
                    if avL==cvL
                        dist = 0;
                        break
                    end
                end
                
                accDist = accDist + dist;
            end
            
            % if all nodes distint from 'fa' face, then 'f' is the opposite face
            if accDist==4
                AtoOfaces(af+3) = osR ;
                break
            end
            
        end
        end
    end
    

end

