function [vP, tAOv] = gp3179_VtxP (sGedges, sGverteces, AtoOfaces, afLoopVL, eR, vR, xdim)

    vP   = zeros(8,xdim);
    tAOv = zeros(8,1); % temporal arranged to original vertex ref's
    
    % 6.1.- vertexes of face 1 arranged as per patch hierarchical order:

    f1R     = AtoOfaces(1);
    tAOv(1) = afLoopVL(f1R,1);
    tAOv(3) = afLoopVL(f1R,2);
    tAOv(7) = afLoopVL(f1R,3);
    tAOv(5) = afLoopVL(f1R,4);

    
    % 6.2.- find vertex v2: connected to v1 by an edge

    for c =1:1:12
        
        % edge 'c' vertex list indexes:
        
        v1LR = sGedges(eR).v1LR(c);
        v2LR = sGedges(eR).v2LR(c);
        
        if v1LR == tAOv(1) && (v2LR~=tAOv(3) && v2LR~=tAOv(5))
            tAOv(2) = v2LR;
            break
        end
        
        if v2LR == tAOv(1) && (v1LR~=tAOv(3) && v1LR~=tAOv(5))
            tAOv(2) = v1LR;
            break
        end
    end

    
    % 6.3.- re-arrange in Face 4 LoopVL to set firstly v2:
    % expands loop of VL and extracts the correct sequence of 4 vertexes

    f4R = AtoOfaces(4);
    exLoopVL = [afLoopVL(f4R,:) , afLoopVL(f4R,:)]; 
    
    for i = 1:1:8
        if exLoopVL(i) == tAOv(2)
            for j = 1:1:4
                afLoopVL(f4R,j) = exLoopVL(i+j-1);
            end
            break
        end
    end
    
    
    % 6.4.- Now we can allocate VL to Arranged VL vertex list and allocate:
    
    tAOv(2) = afLoopVL(f4R,1);
    tAOv(6) = afLoopVL(f4R,2);
    tAOv(8) = afLoopVL(f4R,3);
    tAOv(4) = afLoopVL(f4R,4);
    
    for v = 1:1:8
        for di = 1:1:xdim
            vP(v,di) = sGverteces(vR).P(tAOv(v),di) ;
        end
    end
    
end

