function [AtoOcurves] = gp3180_AtoOcurves (sGedges, eR, tAOv)

    AtoOcurves = zeros(12,2); % (Ocurve ref. , 0/1: reverse/same direction)
    
    for Ocr = 1:1:12 % loop on original curves refs
        
        cuR = sGedges(eR).cuR(Ocr) ;   % curve and vertexes
        cv1 = sGedges(eR).v1LR(Ocr);
        cv2 = sGedges(eR).v2LR(Ocr);
        
        % connection matrix: abs. curve ref. - vertexes
        conCV = [ ...
        tAOv(1) tAOv(5) ;
        tAOv(2) tAOv(6) ;
        tAOv(3) tAOv(7) ;
        tAOv(4) tAOv(8) ;
        ...
        tAOv(1) tAOv(3) ;
        tAOv(2) tAOv(4) ;
        tAOv(5) tAOv(7) ;
        tAOv(6) tAOv(8) ;
        ...
        tAOv(1) tAOv(2) ;
        tAOv(3) tAOv(4) ;
        tAOv(5) tAOv(6) ;
        tAOv(7) tAOv(8) ];
        

        for Acr = 1:1:12 % loop in Arranged curves ref's:
            
            % vertexes references for that curve ref.
            ar = conCV(Acr,1);
            br = conCV(Acr,2);

            % stores original edge ref in correspondant Aer position:
          	if cv1 == ar && cv2 == br
            
                AtoOcurves(Acr,1) = cuR ;
                AtoOcurves(Acr,2) = 1 ;

            elseif cv1 == br && cv2 == ar

                AtoOcurves(Acr,1) = cuR ;
                AtoOcurves(Acr,2) = 0 ;
            end
        end
    end
end

