function [teCurves] = gp3181_teCurves (sGcurves, AtoOcurves, xdim, ndig)

teCurves(12) = struct ('Ncp',0, 'Degree', 0, 'Usize', 0, 'KnotV', [], 'w',[], 'P', []);
    

    % 8.1.- Stores edges curves with all features prepared to define the solid:

    for c = 1:1:12
        
        cR = AtoOcurves(c,1); % curve original ref.
        cO = AtoOcurves(c,2); % curve orientation regarding the Oedge 
        
        
        % transfers values to teCurves:
        
        teCurves(c).Ncp     = sGcurves(cR).Ncp;
        teCurves(c).Degree  = sGcurves(cR).Degree;
        teCurves(c).Usize   = sGcurves(cR).Usize;
        
        teCurves(c).KnotV   = sGcurves(cR).KnotV;
        teCurves(c).w       = sGcurves(cR).w;
        teCurves(c).P       = sGcurves(cR).P;
        
        
        if cO == 0 % inverts if required
            
            Ncp     = sGcurves(cR).Ncp;
            p       = sGcurves(cR).Degree;
            Usize   = sGcurves(cR).Usize;
            U       = sGcurves(cR).KnotV;
            w       = sGcurves(cR).w;
            P       = sGcurves(cR).P;
            
            % cp's coord's and weights:
            conta = Ncp+1;
            for j = 1:1:Ncp
                
                conta = conta-1;
                teCurves(c).w(j) = w(conta) ;
                for di = 1:1:xdim
                    teCurves(c).P(j,di) = P(conta,di) ;
                end 
            end
            
            % Knot vector
            teCurves(c).KnotV = GEN_06_ReverseKnotV (U, Ncp, p);

        end
        
       	teCurves(c).KnotV = teCurves(c).KnotV'; % transforms knot vector into a row matrix
        

    end
    
    
  	% 8.2.- check degree, Ncp and knotV compatibility in 3 edges directions.
    % c1-c4 (xi) , c5-c8 (ita) , c9-c12 (chi)
    
    for rdi = 0:1:2

        [teCurves] = gp3171_curvesHomog (teCurves, rdi, xdim, ndig);
             
    end
end

