function [tFaces] = gp3182_tFaces (sGfaces, sGsurfN, teCurves, AtoOfaces, bxdim, budim, ndig)

 	% tfaces structure with:
    %   fSurface: with all the surface NURBS features, plus PL (0/1 = curved/plane)
    %   eCurveR(2,2) : eCurves refenreces for each face
    
    tFaces(6) = struct ('fSurface',0, 'eCurveR', []);  
    
 	% 9.1.- ALLOCATES eCurveR TO tfaces:
 
    for f=1:1:6
        
        if f == 1 
            tFaces(f).eCurveR = [ 1 3 ; 5 7];
        elseif f==2
            tFaces(f).eCurveR = [ 1 2 ; 9 11];
        elseif f==3
            tFaces(f).eCurveR = [ 5 6 ; 9 10];
        elseif f==4 
            tFaces(f).eCurveR = [ 2 4 ; 6 8]; 
        elseif f==5 
            tFaces(f).eCurveR = [ 3 4 ; 10 12]; 
        elseif f==6 
            tFaces(f).eCurveR = [ 7 8 ; 11 12];
        end 
        
    end
    
    % 9.2.- SURFACE features:
    
    for f = 1:1:6

        fR = AtoOfaces(f); % original face ref.
        sR = sGfaces(fR).suR; % surface ref. from sGsurfaces
        ecR = tFaces(f).eCurveR; % face edges curves ref's

        [tSurface] = gp3173_gSurf (ecR, sR, f, sGsurfN, teCurves, bxdim, budim, ndig);
        
        tFaces(f).fSurface = tSurface;
 
        %{
        figure(11)
        if f==3  || f==6
            
            Ncp = tSurface.Ncp;
            
            P = tSurface.P;
            
            for i = 1:1:prod(Ncp)
                
                scatter3(P(i,1), P(i,2),P(i,3),'r'); hold on
                text(P(i,1), P(i,2),P(i,3),num2str(i)); hold on
                
            end
            
        end
        axis equal
        %}
    end
end

