function [AtoOfaces, AtoOcurves, vP] = gp3183_AtoO (poR, afLoopVL, sGMSBO, sGverteces, sGshells, sGfaces, sGloops, sGedges, xdim)

% RETURNS: relation of the position of the arranged objects w.r.t. original order
% AtoOfaces: for faces
% AtoOcurves: for curves
% vP(8,xdim): vertexes coordinates (arranged hierarchically)

   
% 1.- TEMPORARY STRUCTURES and REFERECES:

    % identifies eR and vR (assumes the same ref. through the whole patch)
    shR = sGMSBO(poR).shR;
    faR  = sGshells(shR).faR(1);
    loR  = sGfaces(faR).loR(1); % loop reference
    edR  = sGloops(loR).edR(1) ; % edges ref. (assume one edges ref. per patch), allocates only once
    vR  = sGedges(edR).v1R(1);    

    
% 2.- RE-ORDER FACES ACC/TO CRITERIA (STORES IN AtoOfaces):

[AtoOfaces] = gp3178_AtoOfaces (sGshells, sGfaces, sGverteces, afLoopVL, vR, poR, xdim);

    
% 3.- ALLOCATES vP COORDINATES:
        
[vP, tAOv] = gp3179_VtxP (sGedges, sGverteces, AtoOfaces, afLoopVL, edR, vR, xdim);
    
    
% 4.- COMPUTES AtoOcurves:
    
[AtoOcurves] = gp3180_AtoOcurves (sGedges, edR, tAOv);

end

