function [Smsbo, Sshells, Sfaces, Ssurf, Sloops, Sedges, Scurves, Svrtx, Sbsurf, Sbound] = ...
    ri3190_IGEStoMat (Fname, Npa, NL)

% RETURNS: graphic objects transferred to matrices, each type has its own structure

% note that references to dependant objects are already changed to local
% structure order. 
% E.g.: 
% Sshells(s).fR(f) = order in the Sfaces() structure ;




% 1.- TRANSFERS TO NUMERICAL ARRAYS:

[Nso, msbo, Nsh, shells, Nfa, faces, Nsu, surf, Nlo, loops, Ned, edges, ...
Ncu, curves, Nve, vrtx, Nbs, bsurf, Nbo, bound, ~, ~, ~, ~] = ...
ri3191_toArrays (Npa, NL, Fname);




% 2.- STRUCTURES FOR SOLIDS DEFINITION: 

% here, in surfaces (Ssurf) we swap Ncp, Degree, Usize, and KnotV to meet
% the arrangement of this work

[Smsbo, Sshells, Sfaces, Ssurf, Sloops, Sedges, Scurves, Svrtx] = ...
ri3192_Solids (msbo, shells, faces, surf, loops, edges, curves, vrtx, ...
Nso, Nsh, Nfa, Nsu, Nlo, Ned, Ncu, Nve);



% 3.- STRUCTURES FOR BOUNDED SURFACES:

[Sbsurf, Sbound] = ri3193_Bound (bsurf, bound, Nbs, Nbo);



% 4.- TRANSFORMS REFERENCES FROM ORIGINAL (IN IGES) TO CORRELATIVE, STARTING BY 1:

% 4.1.- Structures for solids:

[Smsbo, Sshells, Sfaces, Ssurf, Sloops, Sedges, Scurves, Svrtx] = ri3194_rFrom1solid ...
(Smsbo, Sshells, Sfaces, Ssurf, Sloops, Sedges, Scurves, Svrtx, ...
Npa, Nsh, Nfa, Nsu, Nlo, Ned, Ncu, Nve);

% 4.2.- Structures for bounded surfaces:

[Sbsurf, Sbound] = ri3195_rFrom1bSur ...
(Sbsurf, Sbound, Ssurf, Scurves, Nbs, Nbo, Nsu, Ncu);



% 5.- CHANGES ORIENTATION OF FACES THAT HAS ATTACHED A NURBS SURFACE:
% Only of the orientatin of the face (faO) is 1, i.e. its orientation is
% towards the patch in the original arrangement, but since we swapped
% parameter directions, it needs reversal.



[Ssurf] = ri3196_revSurf (Sshells, Sfaces, Ssurf, Nsh);


end

