function [Smsbo, Sshells, Sfaces, Ssurf, Sloops, Sedges, Scurves, Svrtx] = ri3194_rFrom1solid ...
(Smsbo, Sshells, Sfaces, Ssurf, Sloops, Sedges, Scurves, Svrtx, ...
Npa, Nsh, Nfa, Nsu, Nlo, Ned, Ncu, Nve)

% 1.- Shells and affected MSBO:

rm = zeros(Nsh,1);
for s =1:1:Nsh
    rm(s) = Sshells(s).R; % shells ref's
end


for p=1:1:Npa % loop on MSBO
    
    shR = Smsbo(p).shR;
    
    for s = 1:1:Nsh
        if shR == rm(s)
            Smsbo(p).shR = s;
            break
        end
    end
end


% 2.- Faces and affected shells:

rm = zeros(Nfa,1);
for f =1:1:Nfa
    rm(f) = Sfaces(f).R; % faces refs
end

for s = 1:1:Nsh % loop in shells
    
    for f = 1:1:Sshells(s).Nof
    
        faR = Sshells(s).faR(f);
        
        for gf = 1:1:Nfa
            if faR == rm(gf)
                Sshells(s).faR(f) = gf;
                break
            end
        end
    end  
end



% 3.- Surfaces refs => affected faces and boundary surfaces:

rmS = zeros(Nsu,1);

for s = 1:1:Nsu
    rmS(s) = Ssurf(s).R; % surfaces refs
end


for f = 1:1:Nfa % loop on faces
    
    suR = Sfaces(f).suR;
    for s = 1:1:Nsu
        if suR == rmS(s)
            Sfaces(f).suR = s;
            break
        end
    end
    
end



% 4.- Loops and affected faces:

rmL = zeros(Nlo,1);
for s = 1:1:Nlo
    rmL(s) = Sloops(s).R; % loops refs
end

for f = 1:1:Nfa % loop on faces
    
    fNol = Sfaces(f).Nol; % No. faces of that loop

    for fl = 1:1:fNol
        
        loR = Sfaces(f).loR(fl);
        
        for gl = 1:1:Nlo
            
            if loR == Sloops(gl).R
                
                Sfaces(f).loR(fl) = gl;
                break
            end
        end
    end
end




% 5.- Edges and affected loops:

rm = zeros(Ned,1);
for e=1:1:Ned
   rm(e) = Sedges(e).R ; % edges refs
end


for L = 1:1:Nlo % loop on loops
    
    for e = 1:1:Sloops(L).Noe
        
        edR = Sloops(L).edR(e);
        
        for ge = 1:1:Ned
            
            if edR == rm(ge)
                Sloops(L).edR(e) = ge;
                break
            end
            
        end
        
    end
end


% 6.- Curves / verteces and affected edges:

rm = zeros(Ncu,1);
rmV = zeros(Nve,1);

for c=1:1:Ncu
   rm(c) = Scurves(c).R ; % curves refs
end

for v=1:1:Nve
   rmV(v) = Svrtx(v).R ; % verteces refs
end


for e = 1:1:Ned % loop on edges
    
    for c = 1:1:Sedges(e).Noc
        
        cuR = Sedges(e).cuR(c); % curve ref.
        v1R = Sedges(e).v1R(c); %vert.1 ref.
        v2R = Sedges(e).v2R(c); %vert.2 ref.
        
        for gc = 1:1:Ncu
            if cuR==rm(gc)
                Sedges(e).cuR(c) = gc;
                break
            end
        end
        
        for gv = 1:1:Nve
            if v1R == rmV(gv)
                Sedges(e).v1R(c) = gv;
                break
            end
        end
        
        for gv = 1:1:Nve
            if v2R == rmV(gv)
                Sedges(e).v2R(c) = gv;
                break
            end
        end
        
    end
end






end

