function [Ssurf] = ri3196_revSurf (Sshells, Sfaces, Ssurf, Nsh)


xdim = 3 ;

for s = 1:1:Nsh
    
    for i = 1:1:Sshells(s).Nof
        
        faO = Sshells(s).faO(i);
        faR = Sshells(s).faR(i);

        if faO == 1 
 
            % Since has been swapped, the NURBS surface needs to be
            % reversed.
            % We do it by reversing direction 1
            
            di = 1 ;
            
            suR = Sfaces(faR).suR;
            
            % only affects to KnotV, w and P
             
            KnotV   = Ssurf(suR).KnotV ;
            Ncp     = Ssurf(suR).Ncp ;
            Degree  = Ssurf(suR).Degree ;

            Usize = Ncp(di)+Degree(di)+1;
            U = zeros(Usize,1);
            
            for j = 1:1:Usize
                U(j,1) = KnotV(di,j);
            end

            rU = GEN_06_ReverseKnotV (U, Ncp(di), Degree(di));
            
            for j = 1:1:Usize
                KnotV(di,j) = rU(j,1);
            end
            
            Ssurf(suR).KnotV = KnotV ;
            
            P = Ssurf(suR).P ;
            w = Ssurf(suR).w ;
            
            udim = 2 ;

            [Ew,EP] = GEN_12_ExpandBw (w, P,xdim, udim, Ncp);
            
            rEw = zeros(Ncp(1),Ncp(2));
            rEP = zeros(Ncp(1),Ncp(2));
            
            for b = 1:1:Ncp(2)
                
                ar = Ncp(di)+1;
                for a = 1:1:Ncp(di)
                    
                    ar = ar - 1;

                    rEw(ar,b) = Ew(a,b);
                    
                    for xd = 1:1:xdim
                        rEP(ar,b,xd) = EP(a,b,xd);
                    end
                    
                end
 
            end
            
            [rw,rP] = GEN_12_ContractsBw (rEw, rEP, xdim, udim, Ncp);
            
            Ssurf(suR).P = rP ;
            Ssurf(suR).w = rw ;

        end


    end
    
  
end


end

