function [KG] = ms3201_KGrod2D (E,A,L, tita)

% RETURNS:
% K: matriz of one rod (truss element, only tension-compression) in global coordinates

% works in 2D

% E,A,L: bar features
% tita: angle in radians

% local matrix:

k = E*A/L ;

KL = [  k  0  -k  0 ;
        0  0   0  0 ;
       -k  0   k  0 ;
        0  0   0  0 ];


% rotation matrix:
    
c = cos(tita) ;
s = sin(tita) ;

R = [   c  s  0  0 ;
       -s  c  0  0 ;
        0  0  c  s ;
        0  0 -s  c ];
       
       
% global matrix:

KG = R'*KL*R ;


end

