function [B] = ms3202_2DplaneB (J, uG)

% RETURNS:
% deformation matrix for 2D plane rectangle linear

% INPUTS:
% J: jacobian at uG
% uG: coord's in parent space

B = zeros(3,8);

% inverse of jacobian
Ji = inv(J);

% derivatives about parent space at uG:

dN1(1,1) = (1+uG(2))/4;
dN1(2,1) = (1+uG(1))/4;

dN2(1,1) = -(1+uG(2))/4;
dN2(2,1) =  (1-uG(1))/4;

dN3(1,1) = -(1-uG(2))/4;
dN3(2,1) = -(1-uG(1))/4;

dN4(1,1) =  (1-uG(2))/4;
dN4(2,1) = -(1+uG(1))/4;


% computes derivative w.r.t. physical space:

dN1 = Ji*dN1 ;
dN2 = Ji*dN2 ;
dN3 = Ji*dN3 ;
dN4 = Ji*dN4 ;


% assemblies B:

B(1,1) = dN1(1) ;
B(1,3) = dN2(1) ;
B(1,5) = dN3(1) ;
B(1,7) = dN4(1) ;

B(2,2) = dN1(2) ;
B(2,4) = dN2(2) ;
B(2,6) = dN3(2) ;
B(2,8) = dN4(2) ;


for i = 1:1:4
    B(3,2*i-1) = B(2,2*i) ;
    B(3,2*i-0) = B(1,2*i-1) ;
end


end

