function [K] = a3211_insertinK (K, kL, nr, N, ndim)


% RETURNS:
% K: global stiffness matrix with inserted components correspondant to nr
% nodes refs and local stiffness matrix kL

% INPUTS:
% K:                    stiffness matrix previous to insertion
% kL(Nndim, Nndim):   local stiffness matrix to incorporate to K
% nr(N,1):              nodes references
% N:                    No. nodes of the element
% ndim:                 No. dimensions

% loop on nodes twice (for rows and cols of K):

% rows positions
rlp = zeros(ndim,1); % local
rgp = zeros(ndim,1); % global

% cols positions
clp = zeros(ndim,1); % local
cgp = zeros(ndim,1); % global


for i = 1:1:N
   
    a = nr(i); % row node
    
    % row pos:
  	for di=1:1:ndim
        rlp(di) = i*ndim - (ndim-di) ; % local pos.
        rgp(di) = a*ndim - (ndim-di) ; % global pos.   
    end
    
    
    for j=1:1:N
    
        b = nr(j); % col. node

        % cols. positions:
        for di=1:1:ndim
            clp(di) = j*ndim - (ndim-di) ; % local pos.
            cgp(di) = b*ndim - (ndim-di) ; % global pos.
        end
        
        
        % insert submatrix skL(ndim,ndim)
        for r = 1:1:ndim
        for c = 1:1:ndim
            K(rgp(r),cgp(c)) = K(rgp(r),cgp(c)) + kL(rlp(r),clp(c));
        end
        end

    end
end




end

