function [ue] = a3212_extractU (u, nn, nr, ndim)

% RETURNS:
% ue(nde,1): vector extracted from u for DoF dr

% INPUTS:
% u():          original vector
% nn:           No. nodes to extract
% nr(nn,1):     nodes references
% ndim:         No. dim's of the problem


nde = nn*ndim ; % No. DoF to extract
ue = zeros(nde,1);

contaR = 0 ;

for i = 1:1:nn

    for di = 1:1:ndim
        
        contaR = contaR + 1 ;       % local row ref.
        r = nr(i)*ndim - (ndim-di); % global row ref.
        
        ue(contaR,1) = u(r,1);
        
    end 
end

end

