function [Ke] = a3213_extractK (K, nn, nr, ndim)

% RETURNS:
% Ke(nde,1): vector extracted from u for DoF dr

% INPUTS:
% K(,):         original matrix
% nn(2):        No. nodes to extract row and cols
% nr(nn,2):     nodes references
% ndim:         No. dim's of the problem

% No. DoF to extract for rows and cols
nde(1) = nn(1)*ndim ; 
nde(2) = nn(2)*ndim ;

Ke = zeros(nde(1),nde(2));

contaR = zeros(2,1);

for i = 1:1:nn(1)

    for di1 = 1:1:ndim
        
        contaR(1) = contaR(1) + 1 ;     % local row ref.
        r = nr(i,1)*ndim - (ndim-di1);  % global row ref.
        
        contaR(2) = 0 ;
        
        for j = 1:1:nn(2)

            for di2 = 1:1:ndim

                contaR(2) = contaR(2) + 1 ; % local col ref.
                c = nr(j,2)*ndim - (ndim-di2); % global col ref.

                Ke(contaR(1),contaR(2)) = K(r,c);

            end 
        end
    
    end
    
end

end

