function [u] = ts3231_prescribedUsol (DoF, nNod, K, ur, nk, dkr, nu, dur, xdim)

% RETUNRS:
% u(DoF,1): displacements of a linear system, including the prescribed


% 1.- COMPUTES Kaa, Kab AND ub:

ub = a3212_extractU (ur, nk, dkr, xdim);


mnr = [dur dur] ;
Kaa = a3213_extractK (K, [nu,nu]', mnr, xdim);

% nodes ref's matrix
if nk == nu
    
    mnr = [dur dkr];
    
elseif nk > nu
    
    mnr = [ [dur; zeros(nk-nu,1)] dkr];
    
elseif nk < nu
    
    mnr = [ dur [dkr; zeros(nu-nk,1)]];
end

Kab = a3213_extractK (K, [nu,nk]', mnr, xdim);




% 2.- SOLVES DISPLACEMENTS ua (for internals):

fa = -Kab*ub;
ua = Kaa\fa ;


% 3.- Extends with prescribed displacements:

u = zeros(DoF,1);

contaK = 1 ;
contaU = 1 ;

for i = 1:1:nNod
    
    % prescribed displacement:
    if contaK <= nk
    
        if i==dkr(contaK)
            for di = 1:1:xdim
                
                r = i*xdim-(di-1);
                u(r) = ur(r);
                
            end
            contaK = contaK + 1 ;
        end
        
    end
    
    % computed displacement:
    
    if contaU <= nu
    
        if i==dur(contaU)
            for di = 1:1:xdim
                
                r1 = i*xdim-(di-1);
                r2 = contaU*xdim-(di-1);
                u(r1) = ua(r2);
                
            end
            contaU = contaU + 1 ;
        end
        
    end 
    
end



end

