function [nk, nu, dkr, dur] = tr3242_ShellKnownNodRefs (Ncp, nNod)

% RETURNS: KNOWN AND UN-KNOWN NODES REFERENCES for 3D truss whose envelope
% shell nodes displacements are prescried and internal un-knowns

% nk, nu: No. nodes known and un-known
% dkr(nk), dur(nu): references of those nodes


% Nodes references for 'ua' (internals) and 'ub'(contour):

nk = 2 * ( Ncp(1)*Ncp(2) + Ncp(1)*(Ncp(3)-2) + (Ncp(2)-2)*(Ncp(3)-2) );
nu = nNod-nk;

% stores addresses of known and un-known nodes
dkr = zeros (nk , 1); 
dur = zeros (nu , 1);

contaR = 0;
contaK = 0;
contaU = 0;

for i = 1:1:Ncp(1)
for j = 1:1:Ncp(2)
for k = 1:1:Ncp(3)
    
    contaR = contaR + 1 ;
    
    if i == 1 || i == Ncp(1)

        contaK = contaK + 1 ;
        dkr(contaK) = contaR ;
        
    elseif j == 1 || j == Ncp(2)
        
        contaK = contaK + 1 ;
        dkr(contaK) = contaR ;
        
    elseif k == 1 || k == Ncp(3)
        
        contaK = contaK + 1 ;
        dkr(contaK) = contaR ;
        
    else
        contaU = contaU + 1 ;
        dur(contaU) = contaR ;
        
    end
end
end
end
end

