function [Ustd] = ar3303_Rposi (nR, R)

% RETUNRS:
% Ustd(1,2): position of nR node in the standard space with R distance


% 1.- FOR FIRST POINT THE STANDARD POSITION IS 0 0:

if nR==1
    Ustd = [0 0];
    return
end

% 2.- FINDS CONTOUR WHERE nR BELONGS TO, THE SIDE sR & 1st CORNER nRcor

sF = 0 ; % stops flag, turns to 1 when the contour is found
accN = 1 ; % acc. No. nodes
ct = 0 ;

while (sF==0)
    
    ct = ct+1;
    
    % No. nodes per contour and side:
    Ncn = 6*ct ; 
    Nsi = ct ;
    
    % starting and end contour node reference:
    snR = accN + 1 ;
    enR = accN + Ncn ;
    
    % localizes:
    if snR <= nR && nR <= enR 
        
        cR = ct ;
        sF = 1;
        
        % localizes side:
        accNs = accN ;
        
        for si = 1:1:6
            
            s1nR = accNs;
            s2nR = s1nR + ct ;
            
            if s1nR < nR && nR <= s2nR 
                sR = si ;
                nRcor = s1nR+1;
                break
            end
            accNs = accNs + ct ;
            
        end 
    end
    
    % increases accumulated:
    accN = accN + Ncn;
    
end



% 3.- COMPUTES POSITION IN THE STANDARD SPACE:

% 3.1.- Norm and angle of vector from center (0 0) to corner of sR side:

nUcor = R*cR;
tita = (60*(sR-1)) / 57.29578;


% 3.2.- Transforms into cartesian coordinates:

Ucor = [nUcor*cos(tita) nUcor*sin(tita)];


% 3.3.- Moves up to the current node nR from the corner node nRcor:

Nseg = nR - nRcor;                      % No. segments
alfa = (120 + (si-1)*60) / 57.29578;    % angle of the side

L = Nseg*R;

Ustd(1,1) =  Ucor(1) + L*cos(alfa);
Ustd(1,2) =  Ucor(2) + L*sin(alfa);

end

