function [t12plane] = ar3306_angUtoVplane (V1, V2, nv, xdim)

% RETURNS:
% t12plane: angle from V1 to V2, both in the same plane of normal vector nv
% note that considers the angle sign as per nv right hand rule

[t12plane] = go2511_angleUV (V1, V2);

tem = cross(V1,V2); % if tem same dir as nv angu OK, if opp the angu = -angu


if norm(tem) < norm(nv)/100000
    
    % selects the max. abs. value of both vectors:
    
    m1 = abs(V1(1));
    r1 = 1;
    m2 = abs(V2(1));
    r2 = 1 ;
    
    for di = 2:1:xdim
        
        if abs(V1(di)) > m1
           
            m1 = abs(V1(di));
            r1 = di;

        end
        
        if abs(V2(di)) > m2
           
            m2 = abs(V2(di));
            r2 = di;

        end
    end
    
    % allocates angle:
    
    if sign(V1(r1)) == sign(V2(r2)) 
        
        % same direction of vectors:
         t12plane = 0; 
    else
        
        % opp. direction vectors:
        t12plane = 3.14159;
    end
     
else
    
    flagDir = 0;
    
    Vref = norm(tem);
    
    for di = 1:1:xdim

        if abs(tem(di)) > 0.0001*Vref
        
            if sign(tem(di))==sign(nv(di))
                flagDir = flagDir + 1;
            else
                flagDir = flagDir - 1;
            end
        
        end
 
    end
    
    t12plane = t12plane * sign(flagDir);
end



end

