function [alfa] = ar3307_AngleU (v, dS1, dS2, xdim)

% RETURNS:
% alfa: orientation w.r.t. dSu in parameter space of a vector 'v' defined
% in physical space that starts at param. location 'u' whose main
% derivatives are 'dS1' and 'dS2'

% 1.- Solves system: c dS1 + s dS2 =  v
    
rw = [1 2 ; 2 3 ; 1 3];
    
for di = 1:1:xdim
    A = [   dS1(rw(di,1))  dS2(rw(di,1));
            dS1(rw(di,2))  dS2(rw(di,2))];  
	b = [   v(rw(di,1))    v(rw(di,2)) ]';
            
    if abs(det(A))>0.0000001
      	break
    end
end

rsp = A\b;
    
    
% 2.- Computes orientation:
    
c = rsp(1);
s = rsp(2);
    
if (c == 0 && s > 0) || (abs(s/c)>500 && s>0)
    
    % 2.1.- Special case 90:
    
    alfa =  90 / 57.29578 ;
    
elseif (c==0 && s<0)  || (abs(s/c)>500 && s<0)
    
    % 2.2.- Special case 270:
    
	alfa = -90 / 57.29578 ;
    
else
    
    % 2.3.- 'Normal' cases:
    
    alfa = atan(s/c);
         
	% amends in case is negative sub-plane
	if c < 0
        alfa = alfa + 3.14159;
	end
end


end

