function [cLXv, cLUv, Ncv, cRc] = ts3312_Cvertexes (cCurv, TNcu, R, Nvx, tolR, xdim)

% RETURNS:
% physical coord's of contour curves:  cLXv(TNcu,Ncv,xdim)
% parameter coord's of contour curves: cLUv(TNcu,Ncv,udim)
% Ncv(TNcu): No. vertexes per curve (accounts for initial and final)

% Note: param. coord's obtained here are in terms of curve.

% INPUTS: collection of non-repeated curves and mesh desired features

% tolC: admisible rror in % w.r.t. Rc of actual curve and segment (assumes cicumf. arc)
% curveError = 'yes' if considers tolC

cUdim = 1 ;
cLXv = zeros(TNcu,2,xdim); 
cLUv = zeros(TNcu,2,cUdim);  
Ncv  = zeros(TNcu,1);
cRc  = zeros(TNcu,1);


% LOOP ON CONTOUR CURVES:
for c = 1:1:TNcu

    
	% 1.1.- Extracts curve NURBS features:
    
    cNcp    = cCurv(c).Ncp ;
	cDegree = cCurv(c).Degree ;
    cUsize  = cCurv(c).Usize ;
  	cKnotV  = cCurv(c).KnotV ;
  	cB      = cCurv(c).P ;
 	cw      = cCurv(c).w ;


	% knot vector has to be row vector:
    if size(cKnotV,2)==1
        cKnotV = cKnotV';
    end


	% 1.2.- Physical and param. coord's (in terms of curve param. space):
    
    [cU, cX, ~, Rc] = ts3315_oneCvtxs (c, R, Nvx, cNcp, cDegree, cUsize, cKnotV, cB, cw, xdim, cUdim, tolR);

    
%{
if TNcu==4
    
    
    
    ENTRA = 1
cX
    
    % 3330 line 68
    % 2934 line 17
    
end
%}
    
    cRc(c,1) = Rc ;
    
    % 1.3.- Allocates to response:
   
    Ncv(c,1) = size(cX,1);
    
    for i=1:1:Ncv(c)
        
        cLXv(c,i,:)  = cX(i,:);
        cLUv(c,i,:) = cU(i);

    end
end
end