function [CMP] = ts3314_Compares2curves (Ncp1,Degree1, Usize1,P1, Ncp2,Degree2, Usize2,P2, xdim)

% RETURNS:
% CMP= 1/0/-1 if both curves are the same / non-same / opposite

% INPUTS:
% curves to compare are 1 and 2, with their features as inputs


CMP = 0 ; % assumes 0 and changes if finds equality


if (Ncp1 == Ncp2 && Degree1 == Degree2) && Usize1 == Usize2
    
    
    % Checks if are the same sense: uses first, second and last cp's:
    
    
    % 1.- Assumes coincident and same sense unless proved otherwise:
    
    CMP = 1; 
    
    
    % 2.- If cps 1, 2 and last do not coincide is not coincident same-sense:
    
    for di=1:1:xdim

        if round(P1(1,di),6)~=round(P2(1,di),6)
            CMP = 0;
            break
        end
        
        if round(P1(2,di),6)~=round(P2(2,di),6)
            CMP=0;
            break
        end
        
        if round(P1(Ncp1,di),6)~=round(P2(Ncp2,di),6)
            CMP=0;
            break
        end
    end
    
    
    % 3.- if not same sense => checks coincident opposite-sense:
    
    if CMP == 0
        
        
        % assumes coincident and opp-sense unless find differnces => is not coincident:
        
        CMP = -1;
    
        for di=1:1:xdim

            if round(P1(1,di),6)~=round(P2(Ncp2,di),6)
                CMP=0;
                break
            end

            
            if Ncp1>2
                if round(P1(2,di),6)~=round(P2(Ncp2-1,di),6)
                    CMP=0;
                    break
                end
            end
            
            
            if round(P1(Ncp1,di),6)~=round(P2(1,di),6)
                CMP=0;
                break
            end
        end
        
    end
    
end


end

