function [cU, cX, Lseg, Rc] = ts3315_oneCvtxs ...
         (c, R, cNmin, cNcp, cDegree, cUsize, cKnotV, cB, cw, cXdim, cUdim, tolR)

% RETURNS:
% lU(nlp,udim), lX(nlp,xdim): coordinate of points of curve attending to
% max. no points and tam() criteria and min. No. segments cNmin
% note it arranges points to achieve ascending parameter order on them

% Lseg(NS,1): length of each segment


% 1.- DIVIDES INTO dC-mesh:

[Un, ndC, NE] = ts3316_dCmesh (cNcp, cDegree, cUsize, cKnotV, cB, cw, cXdim, cUdim, tolR);


%figure(c)
%scatter3( cB(:,1),  cB(:,2),  cB(:,3), 'k'); hold on
%axis equal



% 2.- ESTIMATES Current SEGMENT REFERENCE LENGTH (Rc) & No. SEGMENTS (NS):

[Ltotal,Rc,NS] = ts3317_FixSize ...
(c, cKnotV, cNcp,cDegree,cUsize, cB, cw, cUdim, cXdim, cNmin,R);


cU  = zeros(1,cUdim); % they ll increase to fit No. sub-segments
cX  = zeros(1,cXdim);
Lseg = zeros(1,1);

NGPs = cDegree + 1 ;


% 3.- COMPUTES ACCUMULATED R up to each segment:

Lacc = zeros(NE+1,1);

for e=1:1:NE 
    Du = Un(e+1)-Un(e);
	Lacc(e+1,1) = Lacc(e,1) + 0.5*Du*(ndC(e)+ndC(e+1)); 
end





% 4.- ESTIMATES u VALUES FOR ACHIEVING SEGMENTS OF LRx:

ouF = 0 ;

u = cKnotV(1);
uLim = cKnotV(cUsize);
Dumax = [0 uLim-cKnotV(1)];

% 4.1.- First vertex:

conta= 1;
cU(conta,1) = cKnotV(1);
Ra = 0;


% 4.2.- Intermediate vertexes:

contaL = 0 ;

while (ouF==0)
    
    % target phys. length
    Ra = Ra + Rc;
    
    %contaL = contaL + 1 ;
    
    for e=1:1:NE+1
       
        if Lacc(e) <= Ra && Ra <= Lacc(e+1)

            u1 = Un(e);    u2 = Un(e+1);
            ndC1 = ndC(e); ndC2 = ndC(e+1);

            Reff = Ra-Lacc(e);
            
            [h] = ts3318_LPincrement (u1, u2, ndC1, ndC2, Reff, Dumax);
            
            conta=conta+1;
            cU(conta) = u1 + h;
            break
            
        elseif Lacc(NE+1)<Ra
            ouF=1;
            break
        end

        
    end

    %{
    if c==1 
          Lacc(NE+1)
        Ra
        
          if contaL == 12
          
              if gg==0
              end
              
          end
    end
    %}
    
    
end



% 4.3.- Last vertex:

% estimates last segment phys. length: if too close, nove last point to
% end, if too far, just adds a new last point

dCu = zeros(cXdim,1);

u1 = cU(conta);
dC = b2701_BNURBS_deriv (cDegree, cNcp, cKnotV, cUsize, cB ,cw, 1, u1, cXdim,cUdim);
dCu(:) = dC(2,1,1,:);
ndC1 = norm(dCu); 

u2=uLim;
ndC2 = ndC(NE+1);

Rlast = 0.5*(u2-u1)*(ndC1+ndC2);

if Rlast < 0.5*Rc % move to end
    
    cU(conta) = uLim;
    
else % create a new one at the end
    
    conta = conta+1;
    cU(conta) = uLim;
end



% 5.- COMPUTES PHYSICAL COORDINATES AND SEGMENTS LENGTHS:

for i=1:1:conta
    
    [X] = b2601_BNURBS_Xcoord (cU(i), cKnotV, cNcp,cDegree,cUsize, cw,cB, cUdim,cXdim);
    
    for di=1:1:cXdim
        cX(i,di) = X(di);
    end 
    
end

NS = conta-1;
for i = 1:1:NS
	Ls = ts3319_Lsegm (cU(i),cU(i+1), NGPs, cKnotV, cNcp,cDegree,cUsize, cB,cw, cUdim,cXdim);
    Lseg(i,1) = Ls ; 
end



end

