function [h] = ts3318_LPincrement (u1, u2, ndC1, ndC2, Reff, Dumax)

% RETURNS:
% h: positive increment within (or close) to [u1-u2] to achieve area of
% trapezoidal rule equal to Reff.


x = [0 (u2-u1)];
y = [ndC1  ndC2];
[m,n] = go2516_mnCoeff (x,y);

%Reff = Ra-Lacc(e);

a =  m/2;
b =  n ;
c = -Reff;

[utemp,~] = GEN_24_rootQuadPolm (a,b,c, Dumax, 0.000001);

h = utemp(1);

end

