function [Lt] = ts3320_Ltotal (cKnotV, cNcp,cDegree,cUsize, cB, cw, cUdim, cXdim)

% RETURNS:
% Lt: length of NURBS curve (total length)

NGP = cDegree + 1 ;

[GPpc, Wg] = ip2301_GP_1D (NGP);


% non-void spans: number and limits:

[nvU, nvUsize] = GEN_18_UnonVoid (cKnotV, cUsize, cDegree, cUdim);

nE = nvUsize-1 ; % No. elements


% Loop on elements to compute each lenght:

Lt = 0 ;
for e = 1:1:nE

    u1 = nvU(e);
    u2 = nvU(e+1);
    
    unp = [u1 ; u2];
    dJ2 = j2313_Jac2_elem (2, cUdim, 0, unp');


    for g = 1:1:NGP
        
        uG = GPpc(g);
        u = m2321_parentMapping (uG, unp, 1,2);
        [~,dJ1] = j2315_J1_Bspline (u, cKnotV, cNcp, cDegree, cUsize, cB, cw, cUdim, cXdim);

        %{
        if round(cB(1,1),4)==8.3485
    
            if e==33 && g==1
                
                unp
                uG
                cKnotV
            end
            

        end
        %}
        
        Lt = Lt + dJ2 * dJ1 * Wg(g)  ;
    end

end

end

