function [df12] = ts3321_df12 (f, dg1, dg2, dg3, xdim)

% RETURNS:
% f12(2): first and second derivative of f
% f is a function of norm(g').
% g is a vector function that depends on parameter u

% INPUTS:
% f: f function value , equal to norm of dg1
% dg1, dg2, dg3: derivatives 1 to 3 of function g, each one is a vector in xdim

% A and B coefficients: 

A = 0 ;
B = 0 ;

for di = 1:1:xdim
    A = A + dg1(di) * dg2(di);
    B = B + dg2(di) * dg2(di) + dg1(di) * dg3(di) ;
end


% computes first and second derivative of f, and allocates:

df1 = A / f ;
df2 = (B * f - A * df1) / f^2 ;

df12 = [df1 ; df2];





end

