function [sU] = ts3323_sUconF05_ ...
    (nv, cX, edCurv, eR, sULims, xdim, sUdim, Xtol, DUtol)

% RETURNS:
% sU(nv,sUdim): surface param. coordinates of curve sX points in case they
% lie on the egde but do not span the whole edge (conF=0.5)

%{
% 1.- DETECTS WHICH EDGE LIES IN:
% uses pp for 1st and 2nd points

sX = zeros(2,sUdim);
for i = 1:1:2
    sX(i,:) = cX(i,:);
end
%}

%[sU] = s2831b_PPsurf (sX, N, Degree, Ncp, KnotV, Usize, P, w, CD, xdim, Xtol, DUtol)


% 1.- EXTRACTS CURVE FEATURES:

cNcp    = edCurv(eR).Ncp ;
cDegree = edCurv(eR).Degree ;
cUsize  = edCurv(eR).Usize ;
cKnotV  = edCurv(eR).KnotV ;
cw      = edCurv(eR).w ;
cP      = edCurv(eR).P ;
cCD     = edCurv(eR).CD ;
            
if size(cKnotV,1)>1
    cKnotV = cKnotV';
end
  


% 2.- COMPUTES PARAM. COORDINATES IN TERMS OF EDGE CURVE:

% equal ends flag:

c1 = zeros(xdim,1);
c2 = zeros(xdim,1);
x1 = zeros(xdim,1);
x2 = zeros(xdim,1);

c1(:,1) = cP(1,:);
c2(:,1) = cP(cNcp,:);

x1(:,1) = cX(1,:);
x2(:,1) = cX(nv,:);

CO11 = go2542_coincidentP (c1, x1, xdim, 3);
CO22 = go2542_coincidentP (c2, x2, xdim, 3);

CO12 = go2542_coincidentP (c1, x2, xdim, 3);
CO21 = go2542_coincidentP (c2, x1, xdim, 3);

if CO11==1 && CO22==1
    equeF = 1 ;
elseif CO12==1 && CO21==1
    equeF = -1 ;
else
    equeF = 0 ;
end


if nv==2 && abs(equeF) == 1
   
    % 2.1.- Special case there are only 2 points and coincide with curve ends:
    
    sUe = zeros(2,1);
    
    if equeF==1
        sUe(1,1) = cKnotV(1);
        sUe(2,1) = cKnotV(cUsize);
    elseif equeF==-1
     	sUe(2,1) = cKnotV(1);
        sUe(2,1) = cKnotV(cUsize);
    end
    
else
    
    % 2.2.- Rest of the cases:

    [sUe] = c2811b_PPcurves (cX, nv, cDegree, cNcp, cKnotV ,cP, cw, cCD, xdim, Xtol, DUtol);


end





%{
if round(cX(1,1),4)==43.4315 && round(cX(1,2),4)==15.0000 && round(cX(1,3),4)==56.5685
    eP
    sUe
end
%}

% 3.- TRANSFERS TO SURFACE:  note that for edges 3 and 4 needs to the
% complementary

sU = zeros(nv,sUdim);
            
if eR==1
                
    for i = 1:1:nv
    sU(i,1) = sUe(i);
    sU(i,2) = sULims(2,1);
    end
                
elseif eR==2
                
    for i = 1:1:nv
    sU(i,1) = sULims(1,2);
    sU(i,2) = sUe(i);
    end
               
elseif eR==3
          
    for i = 1:1:nv
        sU(i,1) = sULims(1,2)-sUe(i);
        sU(i,2) = sULims(2,2);
    end
                    
elseif eR==4
        
    for i = 1:1:nv
        sU(i,1) = sULims(1,1);
        sU(i,2) = sULims(2,2)-sUe(i);
    end
end

end

