function [dS1,dS2] = ds3324_maindSu (u, Dspline, Degree, Ncp, KnotV, Usize, EP,Ew, NeR, eR, fpeR, fceR, conM, conMp, conMc, nUcoor, vDirp, dSu, dSv, xdim, udim, DerC)

% RETURNS:
% dS1, dS2 = dSu, dSu : main derivative at location u


% 1.- IN CASE EXACT OF Dspline NEEDS TO TAKE BACK TO THE DOMAIN u IN CASE
% LIES IN PERIMETER OF CORNER ELEMENT:

if strcmp(DerC,'ex')==true || strcmp(DerC,'sp')==true
    
    [u] = ds3325_backUcoor (u);
    
end


% 2.- COMPUTES DERIVATIVE:

dS1 = zeros(xdim,1);
dS2 = zeros(xdim,1);


if strcmp(DerC,'ex')==true
    
    [dS] = b2701_BNURBS_deriv (Degree, Ncp, KnotV, Usize, EP,Ew, [1 1], u, xdim, udim);
    
    dS1(:,1) = dS(2,1,1,:);
    dS2(:,1) = dS(1,2,1,:);
       
elseif strcmp(DerC,'ip')==true
    
    [dS1,dS2] = ds3330_BILdS (u, NeR, eR, fpeR, fceR, conM, conMp, conMc, nUcoor, vDirp, dSu, dSv, xdim);
    
elseif strcmp(DerC,'sp')==true
    
    [~, dS1, dS2] = ds3328_dSspline (u, 0, Dspline,udim, xdim);

end






end

