function [ndS] = ds3326_dStita (u, tita, Degree, Ncp, KnotV, Usize, EP,Ew, xdim, udim)

% RETURNS:
% ndS: norm of tita-direction derivative, computed exactly
%  if u lies outside parameter limits of surface takes value of perimeter
%  of corner


% 1.- COMPUTES DERIVATIVE:

if size(u,1)>1
   u = u'; 
end

dSu = zeros(xdim,1);
dSv = zeros(xdim,1);

[dS] = b2701_BNURBS_deriv (Degree, Ncp, KnotV, Usize, EP,Ew, [1 1], u, xdim, udim);
    
dSu(:,1) = dS(2,1,1,:);
dSv(:,1) = dS(1,2,1,:);

c = cos(tita);
s = sin(tita);

dS = c * dSu + s * dSv ;

ndS = norm(dS);


end

