function [ndS] = ds3327_BILndStita (u, tita, NeR, eR, fpeR, fceR, conM, conMp, conMc, nUcoor, vDirp, dSu, dSv, xdim)

% RETURNS:
% ndS (norm) w.r.t. tita direction using interpolation of modules at nodes

% INPUTS:
% u: location where compute
% NeR, eR: elements where u lies in (multiple in case of u is on edge)


% 1.- BASIS FUNCTIONS:

[Nnod, N, nr] = ds3329_bilN (u, NeR, eR, fpeR, fceR, conM, conMp, conMc, nUcoor, vDirp);



% 2.- COMPUTES dSn-tita AT EACH NODE AND INTERPOLATES:

dS1 = zeros(xdim,1);
dS2 = zeros(xdim,1);

ndS = 0 ;

c = cos(tita);
s = sin(tita);

for i = 1:1:Nnod
   
    dS1(:,1) = dSu(nr(i),:);
    dS2(:,1) = dSv(nr(i),:);
    
    dStita = norm(c*dS1 + s*dS2);
    
    ndS = ndS + N(i)*dStita;
    
end


%{
% 1.- IN CASE EXISTS CORNER / PERIM. ELEMENT IN eR ONLY CONSIDERS THAT ONE

% 1.1.- Detects: 

erCorner = 0;
erPerime = 0;
for e = 1:1:NeR
    
    er = eR(e);
    
    if fceR<=er
        erCorner = er;
        break
    end
    if fpeR<=er && er<fceR
        erPerime = er;
        break
    end
    
end


% 1.2.- Case of corner:

if erCorner > 0
    
    er = erCorner ;
    
  	ereff = er - (fceR-1);

 	% node ref:
  	nr(1) = conMc(ereff);

    dSdir = zeros(xdim,1);
  	for di=1:1:xdim
        dSdir(di) = dSu(nr(1),di)*cos(tita) + dSv(nr(1),di)*sin(tita);
    end
  	ndS = norm(dSdir);
    
end


% 1.3.- Case of perimeter:

if erPerime > 0
    
    er = erPerime ;
    
 	ereff = er - (fpeR-1);
 	vd = vDirp(ereff);

   	% nodes ref's and No. nodes:
  	nr = conMp(ereff,:);
   	Nnod = 2;

 	% Basis functions values:
    u1 = nUcoor(nr(1),vd);    
   	u2 = nUcoor(nr(2),vd);     
    L = (u2-u1);
    N(1) = (u2-u(vd)) / L ;
    N(2) = (u(vd)-u1) / L ;
    
    ndS = 0 ;
	for nod = 1:1:Nnod

        dSdir = zeros(xdim,1);
        for di=1:1:xdim
            dSdir(di) = dSu(nr(nod),di)*cos(tita) + dSv(nr(nod),di)*sin(tita);
        end

        ndS = ndS + N(nod)*norm(dSdir);
 	end
    
end



% 2.- REST OF CASES:
%   LOOPS ON THE ELEMENTS COMPUTING mdC AT u GIVEN BY EACh ELEMENT

if erCorner==0 && erPerime==0
    
    ndSe = zeros(NeR,1); % modules at u (can be more than 1 if u lies on edge bewteen 2 or more elemnts)

    for e = 1:1:NeR

        er = eR(e);


        % 2.1.- ESTABLISHES NODES AND BASIS FUNCTIONS VALUES:


        % - CASE INTERNAL ELEMENT:

            % nodes ref's and No. nodes:
            nr = conM(er,:);
            Nnod = 4;

            % Basis functions values:
            u1 = nUcoor(nr(1),1);     v1 = nUcoor(nr(1),2); 
            u2 = nUcoor(nr(4),1);     v2 = nUcoor(nr(4),2); 
            A = (u2-u1) * (v2-v1);
            N(1) = (u2-u(1)) * (v2-u(2)) / A ;
            N(2) = (u2-u(1)) * (u(2)-v1) / A ;
            N(3) = (u(1)-u1) * (v2-u(2)) / A ;
            N(4) = (u(1)-u1) * (u(2)-v1) / A ;


        
            
        % 2.2.- COMPUTES MODULES AT EACH NODE AND INTERPOLATES: => ndSe

        for nod = 1:1:Nnod

            dSdir = zeros(xdim,1);
            for di=1:1:xdim
                dSdir(di) = dSu(nr(nod),di)*cos(tita) + dSv(nr(nod),di)*sin(tita);
            end
            ndSnod = norm(dSdir);

            ndSe(e) = ndSe(e) + N(nod)*ndSnod;

        end

    end


    % 2.3.- COMPUTES THE AVERAGE OF ALL THE ELEMENTS:

    ndS = sum(ndSe)/NeR ;

end
%}





end

