function [Nnod, N, nr] = ds3329_bilN (u, NeR, eR, fpeR, fceR, conM, conMp, conMc, nUcoor, vDirp)

% RETURNS:
% Nnod: No. involved nodes : 1, 2, or 4
% N(Nnod): basis functions values at u for bilinear interpolation
% nr(Nnod): nodes references of dSmesh

% INPUTS:
% u: location where compute
% NeR, eR: elements where u lies in (multiple in case of u is on edge)


% 1.- IN CASE EXISTS CORNER / PERIM. ELEMENT IN eR ONLY CONSIDERS THAT ONE

% 1.1.- Detects: 

erCorner = 0;
erPerime = 0;
for e = 1:1:NeR
    
    er = eR(e);
    
    if fceR<=er
        erCorner = er;
        break
    end
    if fpeR<=er && er<fceR
        erPerime = er;
        break
    end
    
end


% 1.2.- Case of corner:

if erCorner > 0
    
    Nnod = 1 ;
    nr = zeros(Nnod,1);
    
    er = erCorner ;
  	ereff = er - (fceR-1);

 	% node ref:
  	nr(1) = conMc(ereff);

    % basis funct. value:
    N = ones(Nnod,1);
    
end


% 1.3.- Case of perimeter:

if erPerime > 0
    
   	Nnod = 2 ;
    nr = zeros(Nnod,1);
    N = ones(Nnod,1);
    
    er = erPerime ;
    
 	ereff = er - (fpeR-1);
 	vd = vDirp(ereff);

   	% nodes ref's:
  	nr(:,1) = conMp(ereff,:);


 	% Basis functions values:
    
    u1 = nUcoor(nr(1),vd);    
   	u2 = nUcoor(nr(2),vd);     
    L = (u2-u1);
    N(1) = (u2-u(vd)) / L ;
    N(2) = (u(vd)-u1) / L ;
    
end



% 2.- INTERNAL SINGLE ELEMENT:

if (erCorner==0 && erPerime==0) && NeR==1
    
    Nnod = 4 ;
	nr = zeros(Nnod,1);
    N = ones(Nnod,1);
    
    
	% nodes ref's:
  	nr(:,1) = conM(eR(1),:);

    
	% Basis functions values:
 	u1 = nUcoor(nr(1),1);     v1 = nUcoor(nr(1),2); 
	u2 = nUcoor(nr(4),1);     v2 = nUcoor(nr(4),2); 
    
   	A = (u2-u1) * (v2-v1);
    
  	N(1) = (u2-u(1)) * (v2-u(2)) / A ;
  	N(2) = (u2-u(1)) * (u(2)-v1) / A ;
  	N(3) = (u(1)-u1) * (v2-u(2)) / A ;
 	N(4) = (u(1)-u1) * (u(2)-v1) / A ;
end



% 3.- TWO INTERNAL ELEMENTS:

if (erCorner==0 && erPerime==0) && NeR==2
    
	Nnod = 2 ;
    nr = zeros(Nnod,1);
    
    % selects the shortest element:
    
    enr = zeros(NeR,2); % influential nodes of both elements
    dse = zeros(NeR,1); % distance of each element involved edge

    ter = 1; % temporarily element ref.
    
    for e = 1:1:NeR
        
        conta = 0;
        for i = 1:1:4
            
            nod = conM(eR(e),i);
            
            if nUcoor(nod,1)==u(1) || nUcoor(nod,2)==u(2) 
                conta = conta + 1 ;
                enr(e,conta) = nod;
            end
        
            if conta==2
                break
            end
        end
        
        dse(e,1) = abs ( nUcoor(enr(e,1),1)-nUcoor(enr(e,2),1) + nUcoor(enr(e,1),2)-nUcoor(enr(e,2),2) );
        
        if e == 2
            if dse(2)<dse(1)
                ter = 2;
            end
        end
    end
    
    % nodes references:
    nr(:,1) = enr(ter,:);
    
	% Basis functions values:
    
    u1 = [ nUcoor(enr(ter,1),1) ; nUcoor(enr(ter,1),2) ];    
   	u2 = [ nUcoor(enr(ter,2),1) ; nUcoor(enr(ter,2),2) ];   
    

    
    L = norm(u2-u1);
    N(1) = norm(u2-u) / L ;
    N(2) = norm(u-u1) / L ;
end


% 4.- FOUR or THREE INTERNAL ELEMENTS:

if (erCorner==0 && erPerime==0) && (NeR==4 || NeR==3)
    
	Nnod = 1 ;
    nr = zeros(Nnod,1);
    
 	% node ref: The one that coincides with u
    
    for e = 1:1:NeR
    for i = 1:1:4
        nod = conM(eR(e),i);
        ucor(1) = nUcoor(nod,1); ucor(2) = nUcoor(nod,2);
        
        if ucor(1)==u(1) && ucor(2)==u(2)
            nr(1) = nod;
            break
        end
    end
    if nr(1) > 0
        break
    end
    end
    
    % basis funct. value:
    N = ones(Nnod,1);
    
end



end

