function [dS1,dS2] = ds3330_BILdS (u, NeR, eR, fpeR, fceR, conM, conMp, conMc, nUcoor, vDirp, dSu, dSv, xdim)

% RETURNS:
% dSu, dSv: main derivative at location u using bilinear interpolation of dSmesh

% INPUTS:
% u: location where compute
% NeR, eR: elements where u lies in (multiple in case of u is on edge)


% 1.- BASIS FUNCTIONS:

[Nnod, N, nr] = ds3329_bilN (u, NeR, eR, fpeR, fceR, conM, conMp, conMc, nUcoor, vDirp);



% 2.- COMPUTES dS AT EACH NODE AND INTERPOLATES:

dS1 = zeros(xdim,1);
dS2 = zeros(xdim,1);

dS1i = zeros(xdim,1);
dS2i = zeros(xdim,1);

for i = 1:1:Nnod
    
	dS1i(:,1) = dSu(nr(i),:);
    dS2i(:,1) = dSv(nr(i),:);
    
    dS1(:,1) = dS1(:,1) + N(i)*dS1i(:,1);
    dS2(:,1) = dS2(:,1) + N(i)*dS2i(:,1);
end

end

