function [cRv] = rs3332_EVRcoor (R, NCT, sUvt, sRvt, inF, coF, ULims, ndig, NL, Nlv, ncu, Nlcv)

% RETURNS:
% cRv(Nlo, Nlv,2): coordinates of loop edges vertexex in pattern space


% 1.- INTERSECTION ULims EDGES vs HEXAGONS IN PATTERN SPACE:

[peRcoor, Npe, LPpe] = rs3339_peRcoor (R, NCT, sUvt, sRvt, inF, coF, ULims, ndig); 


% 2.- TRIMS ULims EDGES IN PATTERN SPACE ACC. TO cUv

cRv = zeros(NL,Nlv,2); % stores Rcoor of contour

eRm = [1 4 2 3];


for lo = 1:1:NL
contaCP = 0;
for ed = 1:1:ncu(lo)
    
    eR = eRm(ed); % edge ref. for cUScoord's

    NVc = Nlcv(ed); % No. vertexes in the edge curve
    
    rst  = LPpe(eR, Npe(eR)) / NVc ; % all steps equal in pattern space
    
    
    % first point of the edge = corner
    
    contaCP = contaCP + 1 ;
    
    if ed <= 2  % initial node reference
        inr = 1 ;
    elseif ed >= 3
        inr = Npe(eR) ;
    end
    
    cRv(lo,contaCP,1) = peRcoor(eR,inr,3);
    cRv(lo,contaCP,2) = peRcoor(eR,inr,4);
    
    
    % extracts vector of acc. distances and reverse if necessary:
    
    vad = zeros(Npe(eR),1);
  	vad(:,1) = LPpe(eR, 1:1:Npe(eR)) ;
    
    if ed >=3
        [vad] = GEN_45_reverseDISvector (vad, Npe(eR));
    end
    
    
    % rest of the points:
    
    racc = 0 ;
    i1 = 1 ;
    
    for po = 2:1:NVc
        
        racc = racc + rst ;
        contaCP = contaCP + 1 ;
        
        % finds segment of vad where hacc belongs to and estimate h-coord's
        % by interpolation of the segment ends:
        
        for i = i1 :1:Npe(eR)-1
            if vad(i) <= racc && racc <= vad(i+1)
                
                % references of segment points in cUScoor:
                if ed <= 2
                    ra = i ;
                    rb = i+1 ;
                elseif ed >=3
                    ra = Npe(eR) - i + 1;
                    rb = ra-1 ;
                end
                
                % computes h-coor for hacc by interpolating:
                L = vad(i+1) - vad(i);
                Li = vad(i+1) - racc ;
                
                Na = Li/L;
                Nb = (L-Li) / L ;
                
                cRv(lo,contaCP,1) = Na*peRcoor(eR,ra,3) + Nb*peRcoor(eR,rb,3) ;
                cRv(lo,contaCP,2) = Na*peRcoor(eR,ra,4) + Nb*peRcoor(eR,rb,4) ;
                
                % updates initial searching limit & ends loop:
                i1 = i;
                break
            end
        end

    end
    
end
end



end

