function [X] = rs3333_Xcoor (u, Dspline, dSmesh, sKnotV, sNcp, sDegree, sUsize, sEw, sEP, ULims, udim, xdim, DerC)

% RETURNS:
% X(xdim,1): X coordinate , in case u lies outside limits estimates


% extracts from dSmesh structure:

dSu = dSmesh.mdSu ;

dSv = dSmesh.mdSv ;

NE = dSmesh.mNE ;

NEt = dSmesh.mNEt ;

fpeR = dSmesh.mfpeR ;

fceR = dSmesh.mfceR ;

conM = dSmesh.mconM ;

conMp = dSmesh.mconMp ;

conMc = dSmesh.mconMc ;

grEp = dSmesh.mgrEp ;

vEgr = dSmesh.mvEgr ;

vDirp = dSmesh.mvDirp ;

ULimEr = dSmesh.mULimEr ;
ULimEpr = dSmesh.mULimEpr ;
nUcoorr = dSmesh.mnUcoorr ;


if (u(1) < ULims(1,1) || ULims(1,2) < u(1)) || (u(2) < ULims(2,1) || ULims(2,2) < u(2))

    % position of intersection with limit (ui) & U - angle from limit to u (tu):
    
    if u(1) < ULims(1,1) && u(2) < ULims(2,1) % corner 11
        
        ui = [ULims(1,1) ; ULims(2,1)];
        
        tu = atan2( (u(2)-ui(2)) , (u(1)-ui(1)) );
        
    	c = - ( 1 / (tan(tu)^2+1))^0.5 ;
    
        s = c*tan(tu);
        
    elseif u(1) < ULims(1,1) &&  ULims(2,2) < u(2)  % corner 12
        
        ui = [ULims(1,1) ; ULims(2,2)];

        tu = atan2( (u(2)-ui(2)) , (u(1)-ui(1)) );
        
        c = - ( 1 / (tan(tu)^2+1))^0.5 ;
        s = c*tan(tu);
        
    elseif ULims(1,2) < u(1) && u(2) < ULims(2,1) % corner 21
        
        ui = [ULims(1,2) ; ULims(2,1)];

        tu = atan2( (u(2)-ui(2)) , (u(1)-ui(1)) );
        
     	c = ( 1 / (tan(tu)^2+1))^0.5 ;
        s = c*tan(tu);
        
	elseif ULims(1,2) < u(1) && ULims(2,2) < u(2) % corner 22
        
        ui = [ULims(1,2) ; ULims(2,2)];

        tu = atan2( (u(2)-ui(2)) , (u(1)-ui(1)) );
        
    	c = ( 1 / (tan(tu)^2+1))^0.5 ;
        s = c*tan(tu);
        
    elseif u(1) < ULims(1,1) % Left of patch
        
        ui = [ULims(1,1);u(2)];
        tu = 180 / 57.296;
        
        c = -1 ;
        s = 0 ;
        
    elseif ULims(1,2) < u(1)  % Right of patch
        
        ui = [ULims(1,2);u(2)];
        tu = 0 / 57.296;
         
     	c = 1 ;
        s = 0 ;
        
    elseif u(2) < ULims(2,1)  % Below patch
        
        ui = [u(1);ULims(2,1)];
        tu = 270 / 57.296;
            
      	c = 0 ;
        s = -1 ;
        
    elseif ULims(2,2) < u(2)  % Above patch
        
        ui = [u(1);ULims(2,2)];
        tu = 90 / 57.296;
          
      	c = 0 ;
        s = 1 ;
        
    end
    
 
    
    % param. distance from u to intersection point
    Du = norm(ui-u);
    
    
    % distance in physical space by trap. rule. Note ndS is constant
    
    [NeR, eR] = dp3355_FindRele (ULims, NE, NEt, grEp, ULimEr, ULimEpr, fpeR, u);
    
    ndS = ds3323_ndSutita (u, tu, Dspline, NeR, eR, fpeR, fceR, ...
    sDegree, sNcp, sKnotV, sUsize, sEP,sEw, conM, conMp, conMc, nUcoorr, vDirp, dSu, dSv, udim, xdim, DerC);

    Dx = ndS*Du;
    
    
    % main derivatives at ui:
    
    [dS1,dS2] = ds3324_maindSu (u, Dspline, sDegree, sNcp, sKnotV, sUsize, sEP,sEw, NeR, eR, fpeR, fceR, conM, conMp, conMc, nUcoorr, vDirp, dSu, dSv, xdim, udim, DerC);
    

    
    % vector with same angle in physical space:

    vsa = c*dS1 + s*dS2;
    
    % modifies vector module to match Dx
    v = vsa / norm(vsa)*Dx;
    
    % add v to x position of ui:
    xi = b2601_BNURBS_Xcoord (ui, sKnotV, sNcp,sDegree,sUsize, sEw,sEP, udim, xdim);
    
    X = xi + v ;
    
else
    
	[X] = b2601_BNURBS_Xcoord (u, sKnotV, sNcp,sDegree,sUsize, sEw,sEP, udim, xdim);
    
end



end

