function [TVcon] = rs3335b_swapDiag (t, tr1, tr2, TVcon, Xv, vR, NT, atRc, xdim)


% checks that both normals point to the same sense

tTVcon = TVcon;

tTVcon(tr1,1) = vR(1) ;
tTVcon(tr1,2) = vR(2) ;
tTVcon(tr1,3) = vR(3) ;

tTVcon(tr2,1) = vR(3) ;
tTVcon(tr2,2) = vR(4) ;
tTVcon(tr2,3) = vR(1) ;

[~, u] = tm1306_tArea_n (tTVcon, tr1, Xv, 0, xdim);
[~, v] = tm1306_tArea_n (tTVcon, tr2, Xv, 0, xdim);

% equal side = 1 if both normals point in the same direction ish

[ES] = go2510_vectorEQside (u, v);



% ONLY CONTINUES IF ES=1

if ES==1

    if t == NT-1 % last triangles pair

        TVcon(tr1,1) = vR(1) ;
        TVcon(tr1,2) = vR(2) ;
        TVcon(tr1,3) = vR(3) ;

        TVcon(tr2,1) = vR(3) ;
        TVcon(tr2,2) = vR(4) ;
        TVcon(tr2,3) = vR(1) ;

    else % other triangles: need to keep same edge of second triang.

        % detects party edge with next triangle
        tr3 = atRc(t+2); 

        conta = 0 ;
        pev3 = zeros(2,1); 

        for i= 1:1:3

            v1 = TVcon(tr2,i);
            for j = 1:1:3

                v2 = TVcon(tr3,j);
                if v2 == v1
                    conta = conta+1;
                    pev3(conta) = v1;
                    break
                end
            end

        end

        tm1 = [vR(1) vR(2) vR(3)] ; % temporary matrices                   
        tm2 = [vR(3) vR(4) vR(1)] ; 

        % detects which 'tm' contains pev3

        se = 1 ; % assumes is 1 and changes to 2 if necessary:

        conta = 0 ;
        for i = 1:1:3
            if tm2(i) == pev3(1) || tm2(i)== pev3(2)
                conta = conta + 1 ;
            end
        end

        if conta == 2
            se = 2;
        end

        % allocates to TVcon and modifies VTcon:

        if se == 1

            for i = 1:1:3
                TVcon(tr2,i) = tm1(i);
                TVcon(tr1,i) = tm2(i);
            end

        elseif se == 2

            for i = 1:1:3
                TVcon(tr2,i) = tm2(i);
                TVcon(tr1,i) = tm1(i);
            end

        end

    end

end


end

