function [cXv, cUv, Nlv, Nlcv] = rs3336_cUvSurface ...
    (cLXv, cLUv, Ncv, SCcon, ncu, nlo, cCurv, sR, sf, xdim)

% RETURNS:
% same as 2922 but in terms of surface and merging curves in its loop
% Nlv(nlo,1): Number or vertexes per loop (not including the latest coz = than the first!)
% Nlcv(nlo,ncu): No. vertexes in each curve of the loop (not including the last)

% INPUTS:
% Local curves coordinates
% sR: surface refernece


% 1.- EXTRACTS surface vbles:

Xtol = 0.01 ;
DUtol = 0.001;

sUdim = 2;

% 1.1.- Surface:

sDegree = sf(sR).Degree;
sNcp    = sf(sR).Ncp;
sKnotV  = sf(sR).KnotV;
sUsize  = sf(sR).Usize;
sP      = sf(sR).P;
sw      = sf(sR).w;
sEw     = sf(sR).Ew;
sEP     = sf(sR).EP;
CS      = sf(sR).CS;


% 1.2.- Surface contour edges: starts by 0,0 and moves counter-clock-wise:
% they are numbered as 1 to 4 edges with that order

[edCurv] = ts3313_EdgesContours (sNcp, sDegree, sUsize, sP,sw, sKnotV);

% edCurv(4) = struct ('Ncp',0,  'Degree',0, 'Usize',0, 'KnotV',[], 'w',[], 'P',[], 'conF', 0, 'CD', 0);


% 2.- LOOPS ON SURFACE LOOPS TO COMPUTE CONTOUR VERTEXES

[cXv, cUv, Nlv, Nlcv] = rs3336b_loops ...
(edCurv, cLXv, cLUv, Ncv, SCcon, ncu, nlo, cCurv, sR, sDegree, sNcp, sKnotV, sUsize, sP, sw, sEP, sEw, CS, sUdim, xdim, Xtol, DUtol);




% 3.- CLOSED SURFACE CHECK:

if sum(CS) > 0
    [cUv] = su2914_CSuLims (cUv, sKnotV, sUsize, nlo(sR), Nlv, CS, sUdim);
end


end




