function [cXv, cUv, Nlv, Nlcv] = rs3336b_loops ...
    (edCurv, cLXv, cLUv, Ncv, SCcon, ncu, nlo, cCurv, sR, sDegree, sNcp, sKnotV, sUsize, sP, sw, sEP, sEw, CS, sUdim, xdim, Xtol, DUtol)


% SURFACE parameter limits:

sULims = zeros(sUdim,2);
for di = 1:1:sUdim
    sULims(di,1) = sKnotV(di,1);
    sULims(di,2) = sKnotV(di,sUsize(di));
end

% LOOPS ON SURFACE LOOP TO COMPUTE CONTOUR VERTEXES

cXv  = zeros(nlo(sR),1,xdim);
cUv  = zeros(nlo(sR),1,sUdim);
Nlv  = zeros(nlo(sR),1);
Nlcv = zeros(nlo(sR),1);


for lo = 1:1:nlo(sR)

    for c = 1:1:ncu(sR,lo)
        
        % 2.1.- Curve reference, sense and No. vertexes:
        
        cR = SCcon(sR,lo,c); 
        sc = sign(cR);
        cR = abs(cR);
        
        nv = Ncv(cR);
        
        
        % 2.2.- Transfers to cU and cX that curve coord's:
        
        cU = zeros(nv,1);
        cX = zeros(nv,xdim);

        for i = 1:1:nv  
            cU(i)   = cLUv(cR,i);
            cX(i,:) = cLXv(cR,i,:);  
        end
        

        if sc == -1   

            [cU] = GEN_45_reverseDISvector (cU, nv);
            j = nv+1;
            
            for i = 1:1:nv
                j=j-1;
                cX(i,:) = cLXv(cR,j,:);
            end

        end
        

        % 2.3.- Contour flag: in case it is not fully coincident with one
        % edge evaluates if curve is located on one edge but not along its whole length
        
        conF = cCurv(cR).conF; 
       
        
        if conF == 0
            [conF, eR] = ts3310_conF05_ (edCurv, cX, xdim, Xtol); % if conF=1 or 0.5 also gives the edge ref.
        end


      	% 2.4.- Param. coord's (in terms of surface param. space):

        nv = Ncv(cR);
        if conF == 1 % case of curve coincident with one whole edge

            [sU] = su2923_UconCurves ...
            (nv, cX,cU, sDegree, sNcp, sKnotV, sUsize, sP ,sw, sEw,sEP, CS, xdim, sUdim);
        
        
            %{
            
            cR 
            sU
        
            figure(33)
            scatter(sU(:,1), sU(:,2), 'b'); hold on
            
            for i=1:1:size(cU,1)
                text(sU(i,1), sU(i,2), num2str(i)); hold on
            end
            
            axis equal

            
            %}
            
        elseif conF == 0.5 % case of curve coincident with edge but not in the whole length (USES SURFACE edge)
        
            
            [sU] = ts3323_sUconF05_ (nv, cX, edCurv, eR, sULims, xdim, sUdim, Xtol, DUtol);
            
            
        else %if conF == 0 % case of curve with any vertex inside the surface

            [sU] = s2831b_PPsurf (cX, nv, sDegree, sNcp, sKnotV, sUsize, sP, sw, CS, xdim, Xtol, DUtol);

        end


        % 2.5.- Transfers to response:
        
        nvp = Nlv(lo,1);
        
        for i = 1:1:nv-1
            
            j = nvp + i ;
            
            for di=1:1:xdim
                cXv(lo,j,di) = cX(i,di);
            end
            for di=1:1:sUdim
                cUv(lo,j,di) = sU(i,di);
            end
            
        end
        
        
        % No. vertexes of curve and contour loop:
        
        Nlv(lo,1)  = Nlv(lo,1) + nv-1;
        Nlcv(lo,c) = nv-1 ; 
        
        
    end
end



end




