function [atRc, NT, accV] = rs3338a_concTr (sR, Nlcv, lo, pcr, ncr, NTe, etR, accV, Nc, Ntrp, TVcon, ucF, Xv)

% re-orders triangles to follow edge curve vertexes
% finds out the next triangle by finding 'party' edges

% RETURNS:
% atRc(NT,1): arranged triangles refs for that curve
% NT: No. triangles
% accV: updates acc. No. vtx up to the end of that curve

% INPUTS:
% Nlcv: No. vtx per curve of the loop
% lo: loop ref
% pcr: previous curve ref
% nr: current or new curve reference
% NTe(c,1): No. elements attached to each curve
% etR(c,NTe): triangles refs (not ordered)

% accV: accumulated vertex just before the starting of the curve 'nr'
% Nc: No. curves of the loop
% Ntrp: No. triangles to iclude from the previous curve of the loop

% - First, second and end vtx. ref's of 'nr' curve:

fvR = accV + 1 ;
svR = fvR  + 1 ;

evR = Nlcv(lo,ncr)+accV;

if ncr < Nc
    evR = evR + 1 ; %  adds first vtx of next curve
end

if ncr == Nc
    evR = 1 ;
    
    if Nlcv(lo,ncr)==1
        svR =  1 ;
    end
 
end


% - Stores in single row all involved triangles ref's.  
%   Note that it adds last 'Ntrp' triangles from prev. curve:


itR = etR(ncr,1:NTe(ncr));

if Ntrp > 0
   
    r1 = NTe(pcr)-(Ntrp-1);
    r2 = NTe(pcr);
    
    itR = [itR , etR(pcr,r1:1:r2)];
    
    %{
    if NTe(pcr) < Ntrp
        
        itR = [itR , etR(pcr,1:1:NTe(pcr))];
        
        O1=etR(pcr,1:1:NTe(pcr))
        
    else
        
        itR = [itR , etR(pcr,NTe(pcr)-5:1:NTe(pcr))];
        O2=etR(pcr,NTe(pcr)-5:1:NTe(pcr))
    end
    %}
  
end


itR = itR';
[itR,~] = GEN_16_RemoveRepeatedRows (itR, 1, 0.01);
itR = itR';

NTi = size(itR,2);



% - Arranges triangles:
[atRc, NT] = rs3338b_concTr (sR, NTi, itR, TVcon, fvR, svR, evR, ucF, Xv);


% - Updates acc. vtx. ref's:
accV = accV + Nlcv(lo,ncr) ;

end