function [atRc, NT] = rs3338b_concTr (sR, NTi, itR, TVcon, fvR, svR, evR, ucF, Xv)

% concatenates triangles in ascending order of an edge curve vertexes

% RETURNS:
% atRc(NT,1):   arranged triangles references acc/to edge curve vertexes
% NT:           No. triangles (size of atRc)

% INPUTS:
% NTi:  No. candidates triang.  
% itR(NTi,1): candidate triang. ref's
% ftR: first triang. ref (pre-computed earlier)
% TVcon: conn. matrix of triangulation
% fvR, evR: first and end vtx ref of the edge curve
% ucF = 1 if there is a unique curve in the contour



% 1.- COMPUTES FIRST TRIANGLE: ftR

for t = 1:1:NTi
        
	tR = itR(t);
 	NCV = 0 ;
        
    % condition is that two vertexex of the triangle are the same
    % as vertexes 1 and 2 of the edge (recall vertexes are
    % arranged consequtively)
    
    %tR
    %TVcon(tR,:)
    
    for v = 1:1:3
        vR = TVcon(tR,v);
        if vR == fvR || vR == svR
            NCV = NCV+1;
        end
    end
        
 	if NCV==2 % 'i' counts No. vertexes
     	ftR = tR;
      	break
	end
        
end


%{
if sR==3 % && ftR==404 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   ftR 
   itR
   
   
   
    xdim = 3 ;
	xnod = zeros(3,xdim);
    
    for t = 1:1:NTi

        Xav = zeros(xdim,1);
        for i = 1:1:3
            
            tr = itR(t);
            
            xnod(i,:) = Xv(TVcon(tr,i),:);
           
            for di = 1:1:xdim
                Xav(di,1) = Xav(di,1) + Xv(TVcon(tr,i),di)/3;
            end
        end

        pt1361_plotTri_nD (xnod, xdim, ftR, 'r')

        figure(ftR)
        text(Xav(1), Xav(2), Xav(3),num2str(tr)); hold on
        axis equal
    end

   
end
%}


% 2.- TRANSFERS 1st TRIANGLE AND 1st PARTY VTX REF'S (pev):

NT = 1 ;

atRc = zeros(1,1);
atRc(1,1) = ftR; % first triangle
    
ctR = ftR ;         % current triangle reference
pev = zeros(2,1);   % party edge vertexes
NCV = 0 ;

for v = 1:1:3
    
    if TVcon(ctR,v)~=fvR
        NCV = NCV+1;
        pev(NCV,1) = TVcon(ctR,v);
    end
    
end
    
   
% 3.- LOOPS TIL NO CONSECUTIVE TRI. IS FOUND:

% in case of single curve, ends when arrives to first triangle again
    
ppev = zeros(1,1);

endF = 0; % end flag
   
NLp = 0 ;

while (endF == 0)
    
    NLp = NLp + 1 ;
    
    % 3.1.- Finds next triangle (that shares the party edge vertexes 'pev'):
    
    for t = 1:1:NTi

        tr = itR(t);
        NCV = 0 ; 
            

        % compares vtx ref's, stores in 'NCV' No. coincident vertexes:
            
        if tr ~= ctR
                
            for v = 1:1:3
                
                if TVcon(tr,v)==pev(1,1) || TVcon(tr,v)==pev(2,1) 
                    
                    NCV = NCV+1;
                    ppev(NCV,1) = TVcon(tr,v); % party vertexes of ctR
                    
                elseif TVcon(tr,v)~=pev(1,1) || TVcon(tr,v)~=pev(2,1) 
                    
                    nvR = TVcon(tr,v); % temp. new vertex ref.
                    
                end
                
            end 
            
        end


        % detects next triangle => updates info
        
        if NCV == 2 

            % adds triangle:
            if tr ~= ftR
                
                % add triangle to the list
                NT = NT + 1 ;
                atRc(NT,1) = tr ;
                
                % updates party edge vertexes 'pev' and current triangle ref. 'ctR'
                % one is the new vertex and the other depends

                pev(1) = nvR;

                if (fvR <= nvR && nvR <= evR) 
                    
                % - new vertex is edge => selects the other from vtemp that is not edge 

                    if (fvR <= ppev(1,1) && ppev(1,1) <= evR)
                    
                        pev(2) = ppev(2,1); 

                    elseif (fvR <= ppev(2,1) && ppev(2,1) <= evR)
                        
                        pev(2) = ppev(1,1); 
                        
                    end

                else         
                    
                % - new vertes is interior 
                
                    if (fvR <= ppev(1,1) && ppev(1,1) <= evR) && (fvR <= ppev(2,1) && ppev(2,1) <= evR)
                    % - both vtx edges => selectes the maximum of them
                        
                        pev(2) = max(ppev);
                    
                    else
                    % - only one vtx is edge => that is the selected  
                        
                        pev(2) =  ppev(1,1);
                        if (fvR <= ppev(2,1) && ppev(2,1) <= evR)
                            pev(2) = ppev(2,1);
                        end
                    end   
                end
            
                ctR = tr ;
                break
                
            end 
                
            % special case of unique curve and finds first loop => ends searching
            if tr == ftR && ucF==1
                
                endF = 1;
                break
                
            end
            
        end
        
        

    end
    

    
    % 3.2.- If does not find two coincident vertexes is the end:
    
    if NCV < 2
        endF = 1; 
    end


end % end While
    
    


%{
if sR==3 % && ftR==404 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   ftR 
   itR
   
   
   
    xdim = 3 ;
	xnod = zeros(3,xdim);
    for t = 1:1:NT

        Xav = zeros(xdim,1);
        for i = 1:1:3
            
            tr = atRc(t);
            
            xnod(i,:) = Xv(TVcon(tr,i),:);
           
            for di = 1:1:xdim
                Xav(di,1) = Xav(di,1) + Xv(TVcon(tr,i),di)/3;
            end
        end

        pt1361_plotTri_nD (xnod, xdim, ftR, 'r')

        figure(ftR)
        text(Xav(1), Xav(2), Xav(3),num2str(tr)); hold on
        axis equal
    end

   
end
%}

end

