function [peRcoor, Npe, LPpe] = rs3339_peRcoor (R, NCT, sUvt, sRvt, inF, coF, ULims, ndig)

% RETURNS:
% pePcoor(4,1,4): U & R coord's of perimeter edges vtx, which are intersections between contours and edges themselves
% Npe(4): No. points in each perimeter curve (accounts for initial and final points)
% LPpe(4,Ncus): accumulated length at each point of each contour curve in hexagon-space

% Edges Ucoord's and Scoord's and No. points in each edge
% edges are arranged 1-2 (verticals) and 3-4 (horizontals)

peRcoor = zeros(4,1,4); 
Npe = zeros(4,1); 
LPpe = zeros(4,1); 


% 1.- COMPUTES ALL INTERSECTIONS:

% searches points outside, called 'cp' and computes segment from 'cp' to
% internal points of its fist contour. Then computes intersection bt'wn
% segments and


vr = 1;

for ct = 1:1:NCT
for si = 1:1:6  
for po = 1:1:ct
        
        vr = vr + 1 ;
        
        % 1.1.- Finds point out of limits: calls it cp

        if inF(vr) == 0 && coF(vr) == 1
            
            % 1.2.- First contour to cp
            
            cp = vr ;
            cornerFcp = 0;
            
            if po==1
         	cornerFcp = 1;
            end
            
            [fc] = rb3372_firstC (cp, ct, si, cornerFcp, R);
            
            Ucp = [sUvt(cp,1) sUvt(cp,2)]; % 'central point'
            Scp = [sRvt(cp,1) sRvt(cp,2)];
                                    
            % 1.3.- Finds points of fc inside and computes 
            % intersection bt'n segment and edge line:
            
            for i = 1:1:6
                
                ip = fc(i,1);
                if inF(ip)==1
                
                    Uip = [sUvt(ip,1) sUvt(ip,2)]; % 'interior point'
                    Sip = [sRvt(ip,1) sRvt(ip,2)];
                                      
                    % min. and max. Ucoord's of the segment:
            
                    um(1) = min(Ucp(1) , Uip(1));
                    um(2) = max(Ucp(1) , Uip(1));

                    vm(1) = min(Ucp(2) , Uip(2));
                    vm(2) = max(Ucp(2) , Uip(2));
                    
                    
                    % Sets edge to find intersection with:
            
                    if um(1) <= ULims(1,1) && ULims(1,1) <= um(2)

                    % - edge 1:

                        eR = 1 ;
                        ea = [ULims(1,1),ULims(2,1)];
                        eb = [ULims(1,1),ULims(2,2)];

                    elseif um(1) <= ULims(1,2) && ULims(1,2) <= um(2)

                    % - edge 2:

                        eR = 2 ;
                        ea = [ULims(1,2),ULims(2,1)];
                        eb = [ULims(1,2),ULims(2,2)];


                    elseif vm(1) <= ULims(2,1) && ULims(2,1) <= vm(2)

                    % - edge 3:

                        eR = 3 ;
                        ea = [ULims(1,1),ULims(2,1)];
                        eb = [ULims(1,2),ULims(2,1)];

                    elseif vm(1) <= ULims(2,2) && ULims(2,2) <= vm(2)

                    % - edge 4:

                        eR = 4 ;
                        ea = [ULims(1,1),ULims(2,2)];
                        eb = [ULims(1,2),ULims(2,2)];

                    end
                    
            
            
                    % finds intersection segment - contour:

                    [Uits, ~] = go2524_TwoSegmIntersec (Ucp, Uip, ea,eb); % 'intersection point'

            
                    % interpolates and allocates coordinates to that intersection point:

                    L =  ( (Ucp(1) - Uip(1))^2  + (Ucp(2) - Uip(2))^2  )^0.5;
                    Li = ( (Ucp(1) - Uits(1))^2 + (Ucp(2) - Uits(2))^2 )^0.5;

                    N(1) = (L-Li)/L;
                    N(2) = Li/L;

                    Npe(eR) = Npe(eR)+1;

                    peRcoor(eR,Npe(eR),1) = round(Uits(1),ndig);
                    peRcoor(eR,Npe(eR),2) = round(Uits(2),ndig);

                    peRcoor(eR,Npe(eR),3) = N(1)*sRvt(cp,1) + N(2)*sRvt(ip,1);
                    peRcoor(eR,Npe(eR),4) = N(1)*sRvt(cp,2) + N(2)*sRvt(ip,2);
  
                end
            end
            
            
        end
        
end
end
end



% 2.- ARRANGES ASCENDINGLY AND REMOVES OUT OF DOMAIN POINTS:

for ed = 1:1:4
    
    % 2.1.- Extracts array and at the same time removes points 
    % out of the limits, Ncus is then updated
    
    if ed <= 2  % relevant direction
        rd = 2 ;
    else
        rd = 1 ;
    end
    
    UStemp = zeros(1,4);
    
    conta = 0;
    
    for po = 1:1:Npe(ed)
        
        if peRcoor(ed,po,rd) <= ULims(rd,1) || ULims(rd,1) <= peRcoor(ed,po,rd)
            conta =conta + 1 ;
            UStemp(conta,:) = peRcoor(ed,po,:);
        end
    end
    
    Npe(ed) = conta ;
    
    
    % 2.2.- Arranges in ascending order:
    
    if ed <=2
        UStemp = sortrows(UStemp,2);
    else
        UStemp = sortrows(UStemp,1);
    end
     
    % 2.3.- Re-allocates:
    
    for po = 1:1:Npe(ed)
        peRcoor(ed,po,:) = UStemp(po,:);
    end
  
end




% 3.- ADD CORNERS TO EDGES:

% 3.1.- Corners: uses intersection of edges segments:

SUcorner = zeros(4,4);

for c = 1:1:4
    
    % selection acc/corner:
    
    if c==1
        
        uc = [ULims(1,1) ULims(2,1)];

        ed1 = 1 ;
        ed2 = 3 ;
        
        ab1 = [1 2] ;
        ab2 = [1 2] ;
        
    elseif c==2
        
        uc = [ULims(1,1) ULims(2,2)];

        ed1 = 1 ;
        ed2 = 4 ;
        
        ab1 = [Npe(ed1)-1 Npe(ed1)];
        ab2 = [1 2] ;
        
    elseif c==3
        
        uc = [ULims(1,2) ULims(2,1)];

        ed1 = 2 ;
        ed2 = 3 ;
        
        ab1 = [1 2] ;
        ab2 = [Npe(ed2)-1 Npe(ed2)];
        
        
    elseif c==4
        
        uc = [ULims(1,2) ULims(2,2)];

        ed1 = 2 ;
        ed2 = 4 ;
        
        ab1 = [Npe(ed1)-1 Npe(ed1)];
        ab2 = [Npe(ed2)-1 Npe(ed2)];
        
    end
    
    % calculation of corner Scoord's:
    
    a1 = [peRcoor(ed1,ab1(1),3) peRcoor(ed1,ab1(1),4)];
    b1 = [peRcoor(ed1,ab1(2),3) peRcoor(ed1,ab1(2),4)];

    a2 = [peRcoor(ed2,ab2(1),3) peRcoor(ed2,ab2(1),4)];
    b2 = [peRcoor(ed2,ab2(2),3) peRcoor(ed2,ab2(2),4)];

    [Uits, ~] = go2524_TwoSegmIntersec (a1, b1, a2, b2);

    SUcorner(c,1) = uc(1);
    SUcorner(c,2) = uc(2);
    SUcorner(c,3) = Uits(1);
    SUcorner(c,4) = Uits(2);
    
end


% 3.2.- Assemblies in each edge the corners

for ed = 1:1:4
    
	UStemp = zeros(Npe(ed),4);
    for po = 1:1:Npe(ed)
        UStemp(po,:) = peRcoor(ed,po,:);
    end
    
    if ed == 1
        c1 = 1 ;    c2 = 2 ;
    elseif ed == 2
        c1 = 3 ;    c2 = 4 ;
    elseif ed == 3
        c1 = 1 ;    c2 = 3 ;
    elseif ed == 4
        c1 = 2 ;    c2 = 4 ;
    end
    
    
    UStemp = [ SUcorner(c1,:) ; UStemp ; SUcorner(c2,:)];
    Npe(ed) = Npe(ed)+2;
    
  	for po = 1:1:Npe(ed)
        peRcoor(ed,po,:) = UStemp(po,:);
    end
 
end


% 4.- COMPUTES LPpe:

LPpe = zeros(4,max(Npe));

for c = 1:1:4
    
    LPpe(c,1) = 0 ;
    
    for po = 2:1:Npe(c)
        
        a = [peRcoor(c,po-1,3) , peRcoor(c,po-1,4)];
        b = [peRcoor(c,po,3)   , peRcoor(c,po,4)  ];

        LPpe(c,po) = LPpe(c,po-1) + norm(b-a);

    end
 
end



end

