function [Nct, cvR, sRvt, sUvt, sXvt, inF, coF, dSmesh, sRv, sUv, sXv, Nv] = sv3340_Svertexes ...
    (sR, strF, Ld, pt, sDegree,sNcp, sKnotV, sUsize, sP,sw, sEw,sEP, ULims, R, esw, sXdim, sUdim, ndig, tolRs,tolD, cUv, Nlv, Nlcv, DerC)

ARCO = 2 ; % delete when finished

tamp = 30 * 3.14159 / 180 ;
NSg = 3 ;

% RETURNS:
% coordiantes in pattern, param. and physical space
% sRv, sUv,   sXv (sivn,3):	SI-vertexes 
% sRvt, sUvt, sXvt(alln,3): all surface vrtxs 

% Nct: No. contours computed
% coF(alln): computed flag = 1 if vtx computed
% inF(alln): inside flag = 1 if vtx inside surface param. limits
% trimmed: 'yes' or 'no'

% 1.- SETS PARAMETERS:

% Nct = 16 ;

Dumax(1) = 0 ;
Dumax(2) = ((sKnotV(1,sUsize(1)) - sKnotV(1,1))^2 + (sKnotV(2,sUsize(2)) - sKnotV(2,1))^2)^0.5 / 2  ;

% Correction of R in case small surfaces:
[R] = sv3349_Rcorr (R, sDegree, sNcp, sKnotV, sUsize, sP ,sw, sXdim, sUdim);


% 2.- GENERATES BOTH MESHES:

if strcmp(DerC,'sp')== true

    [Dspline] = ds3375_Dspline (sDegree, sNcp, sKnotV, sUsize, sP,sw, sXdim, ndig, tolD);

else
    Dspline = 0 ;
    
end

trimmed = 'no';
[dSmesh]=  rs3381_dSmesh ...
(sDegree,sNcp, sKnotV, sUsize, sP,sw, Dspline, sXdim, sUdim, ULims,Dumax, tolRs, ndig, esw, cUv, Nlv, Nlcv, DerC,trimmed);



if strF == 0

    %%%%%%%%%%%%%% for non strip surfaces %%%%%%%%%%%%%%%%%%%%%%%%%
    
    % 3.- FIRST POINT & FIRST CONTOUR:

    [contaP, sXvt, sUvt, sRvt, inF, coF, csVtx, cvR, Ncn] = sv3341_01contours ...
  	(ULims, sXdim, ndig, dSmesh, Dspline, sDegree, sNcp, sKnotV, sUsize, sEP,sEw, R, Dumax, tamp, NSg, DerC, ARCO);

    % retrieved vtx flag:
    rvF = zeros(7,1);

    % extends coF and inF to account for the next 2 contours
    rvF = [ rvF ; zeros((2+3)*6,1)];
    coF = [ coF ; zeros((2+3)*6,1)];
    inF = [ inF ; zeros((2+3)*6,1)];


    % 4.- FURTHER CONTOURS:

    cornerF = ones(7,1); % corner flag = 1 if node is corner, 7 will increase
    accN = 7 ;
    ct = 1 ;
    coFct = ones(6,1); % computed vertex flag = 1 if computed

    NVct = zeros(1,1); % No. points per contour

    NVct(1,1) = 1 ;
    NVct(2,1) = 6 ;



    while sum(coFct)>0

        ct = ct+1;
        %CONTOUR = ct

        if ct== 11 && sR==3 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
           %break 
        end


        % No. nodes for that contour:

        Ncn(ct) = 6 * ct;
        NVct(ct+1,1) = Ncn(ct) ;

        % Extends cornerF considering contour 'ct'

        extF = zeros(Ncn(ct),1);

        conta = 0 ;

        for si = 1:1:6
        for i = 1:1:ct

            conta = conta+1;
            if i==1
                extF(conta) = 1;
            end
        end
        end
        cornerF = [cornerF ; extF ];


        % extends coF and inF to account for the next 2 contours
        rvF = [ rvF ; zeros((2*ct+3)*6,1)];
        coF = [ coF ; zeros((2*ct+3)*6,1)];
        inF = [ inF ; zeros((2*ct+3)*6,1)];

        % Loop on rest of the points: distinguishes bt'n side and corner

        [contaP, cvR, csVtx, rvF, coF, inF, sXvt, sUvt,sRvt,coFct] = sv3342_Fcontours ...
        (sR, ct, contaP, cvR, csVtx, rvF, coF, inF, accN, cornerF, R, sXvt, sUvt,sRvt, Ncn, dSmesh, ...
        Dspline, sDegree, sNcp, sKnotV, sUsize, sEP,sEw, Dumax, ULims, sXdim, ndig, tamp, NSg, DerC, ARCO);

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %{
    % plot contours in param. space:
    if sR==3
        
        figure(100)

        % U Lims:
        ctu = [0 0 ; 0 1 ; 1 1 ; 1 0 ; 0 0 ];
        plot(ctu(:,1), ctu(:,2), 'b'); hold on

        % Current contour:
        
        r1 = size(sUvt,1)-Ncn(ct)+1;
        r2 = size(sUvt,1);


        for i = r1:1:r2-1
            if coF(i)==1 && coF(i+1)==1
                
                cr = 'k';
                if rvF(i)==1 || rvF(i+1)==1 % retrieved
                    cr = 'r';
                end
                
                plot( [sUvt(i,1) sUvt(i+1,1)] , [sUvt(i,2) sUvt(i+1,2)] , cr); hold on 
            end
        end

        if coF(r2)==1 && coF(r1)==1   
            
            cr = 'k';
        	if rvF(r2)==1 || rvF(r1)==1 % retrieved
                cr = 'r';
            end
            
            plot( [sUvt(r2,1) sUvt(r1,1)] , [sUvt(r2,2) sUvt(r1,2)] , 'k'); hold on    
        end

        % Prev. contour (for retrieved vtx)
        
    	r1 = size(sUvt,1)-Ncn(ct-1)-Ncn(ct)+1;
        r2 = size(sUvt,1)-Ncn(ct);
        
        for i = r1:1:r2-1
            if coF(i)==1 && coF(i+1)==1
            if rvF(i)==1 || rvF(i+1)==1
                plot( [sUvt(i,1) sUvt(i+1,1)] , [sUvt(i,2) sUvt(i+1,2)] , 'r'); hold on 
            end
            end
        end

        
        axis equal

    end
    %}
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        % updates accumulated No. vtx computed:

        accN = accN + Ncn(ct);

    end

    % No. contours computed
    Nct = ct ;


    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %{
    % plot contours in param. space:


    if sR==3
        figure(100+sR)

        ctu = [0 0 ; 0 1 ; 1 1 ; 1 0 ; 0 0 ];
        plot(ctu(:,1), ctu(:,2), 'r'); hold on

        scatter(sUvt(1,1), sUvt(1,2),'.', 'k'); hold on

        accV = 1 ;
        for i = 1:1:Nct

            r1 = accV + 1;
            r2 = accV + NVct(i+1,1) ;

            % all contour up to last vertex:

            for v = 1:1:NVct(i+1,1)-1

                accV = accV+1;
                if sum(sUvt(accV,:))~=0 && sum(sUvt(accV+1,:))~=0 

                    plot( [sUvt(accV,1) sUvt(accV+1,1)] , [sUvt(accV,2) sUvt(accV+1,2)] , 'k'); hold on 

                end
            end

            % last segment:
            if sum(sUvt(r2,:))~=0 && sum(sUvt(r1,:))~=0   
                plot( [sUvt(r2,1) sUvt(r1,1)] , [sUvt(r2,2) sUvt(r1,2)] , 'k'); hold on    
            end

            accV = accV+1;
        end

        axis equal

    end
    %}
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


elseif strF == 1
    
    %%%%%%%%%%%%%% for STRIP surfaces %%%%%%%%%%%%%%%%%%%%%%%%%  
    
    [sXvt, sUvt, sRvt, contaP, inF, coF] = sv3340b_SvtxStrip ...
    (R, Ld, pt, dSmesh, Dspline, sDegree, sNcp, sKnotV, sUsize, sEP,sEw, Dumax, sUdim, ULims, sXdim, ndig, DerC);

    Nct = 0;
    cvR = 0;
 
end


%{

if sR==3
    
    o = zeros(1,4);
    i = 0 ;
    for r = 226:1:232

        i = i+1;
        
        o(i,1) = r ;
        o(i,2) = rvF(r) ;
        o(i,3) = sUvt(r,1) ;
        o(i,4) = sUvt(r,2) ;
        
    end
    o
    
    
end
        
%}


% 4.- COMPUTES X coord's and transfers final Ucoord's:
%     only computes points that are IN (inF=1) 
%    ( and are inside the 'bsc contour' ?? )

%     also computes retained nodes starndard space coordinates Scoor

sXv = zeros(1,sXdim);
sUv = zeros(1,sUdim);
sRv = zeros(1,sUdim);

Nv = 0 ;


for i = 1:1:contaP
    
    if inF(i)==1
    
        u = [sUvt(i,1) sUvt(i,2)];
        
        % edge strip contour flag = 1 if inside % now it does it in other
        % functin afterwards

        eswF = 1 ;
        
        if eswF == 1
        
            Nv = Nv + 1 ;
            
            sUv(Nv,1) = u(1) ;
            sUv(Nv,2) = u(2) ;

            for di = 1:1:sXdim
                sXv(Nv,di) = sXvt(i,di);
            end
            
            sRv(Nv,1) = sRvt(i,1);
            sRv(Nv,2) = sRvt(i,2);
 
        end
    end
  
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%{
figure(99)
scatter3(sXv(:,1),sXv(:,2),sXv(:,3));


figure(100)
plot(sUvt(:,1),sUvt(:,2));

%}

end

