function [sXvt, sUvt, sRvt, contaP, inF, coF] = sv3340b_SvtxStrip ...
(R, Ld, pt, dSmesh,Dspline, sDegree, sNcp, sKnotV, sUsize, sEP,sEw, Dumax, sUdim, ULims, sXdim, ndig, DerC)

ua = zeros(sUdim,1);
ub = zeros(sUdim,1);
ra = zeros(sUdim,1);
rb = zeros(sUdim,1);

sXvt = zeros(1,sXdim);
sUvt = zeros(1,sUdim);
sRvt = zeros(1,sUdim);


d2r = 3.14159/180 ;

Rs = 3*(pt/100+1)*R;

% 1.- TRANSVERSAL DIRECTION AND INITIAL POINT UcoordS:
  
Td = 1 ;
tita = 90 * d2r ;
    
if Ld==1
	Td = 2 ; 
	tita = 0 * d2r ;
end
    
ua(Td,1) = 0.5;
	
contaP = 0 ;

% 2.- FIRST THREE VTX:

% 2.1.- Vtx 1:

contaP = contaP+1;

tita1 = tita + 180*d2r;

[ub] = dp3350_DPincrement ...
(R/2,tita1, ua, dSmesh,Dspline, sDegree, sNcp, sKnotV, sUsize, sEP,sEw, Dumax, ULims, sXdim, ndig, DerC);

[X] = rs3333_Xcoor (ub, Dspline, dSmesh, sKnotV, sNcp, sDegree, sUsize, sEw, sEP, ULims, sUdim, sXdim, DerC);
%[X] = b2601_BNURBS_Xcoord (ub, sKnotV, sNcp,sDegree,sUsize, sEw,sEP, sUdim, sXdim);

rb(Td,1) = 0 ;
rb(Ld,1) = -R/2 ;

sXvt(contaP,:) = X(:,1);
sUvt(contaP,:) = ub(:,1);
sRvt(contaP,:) = rb(:,1);

ua = ub ;
ra = rb ;

% 2.2.- Side vtxs (2 and 3):

[sXvt, sUvt, sRvt, contaP] = sv3340c_sideVtx (sXvt, sUvt, sRvt, contaP, ua, ra, ...
Td, Ld, R, Rs, tita, dSmesh,Dspline, sDegree, sNcp, sKnotV, sUsize, sEP,sEw, Dumax, ULims, ndig, DerC);


% 3.- REST OF THE POINTS ALONG DIRECTION Ld:

endF=0;

while endF == 0
        
    contaP = contaP +1;
        
	% 3.1.- Centre point:
        
	[ub] = dp3350_DPincrement ...
	(R,tita, ua, dSmesh,Dspline, sDegree, sNcp, sKnotV, sUsize, sEP,sEw, Dumax, ULims, sXdim, ndig, DerC);

    [X] = rs3333_Xcoor (ub, Dspline, dSmesh, sKnotV, sNcp, sDegree, sUsize, sEw, sEP, ULims, sUdim, sXdim, DerC);
	%[X] = b2601_BNURBS_Xcoord (ub, sKnotV, sNcp,sDegree,sUsize, sEw,sEP, sUdim, sXdim);
        
    rb(Td,1) = 0 ;
    rb(Ld,1) = ra(Ld,1) + R ;

    
	% stores:
        
	sXvt(contaP,:) = X(:,1);
	sUvt(contaP,:) = ub(:,1);
	sRvt(contaP,:) = rb(:,1);

    % 3.2.- Side points:
    
    ua = ub ;
    ra = rb ;
  
    [sXvt, sUvt, sRvt, contaP] = sv3340c_sideVtx (sXvt, sUvt, sRvt, contaP, ua, ra, ...
    Td, Ld, R, Rs, tita, dSmesh,Dspline, sDegree, sNcp, sKnotV, sUsize, sEP,sEw, Dumax, ULims, ndig, DerC);
    

    % 3.3.- Checks if central point is out:
    
    if (ua(1)<ULims(1,1) || ULims(1,2)<ua(1)) || ...
       (ua(2)<ULims(2,1) || ULims(2,2)<ua(2))    
       endF = 1 ;
    end
    

	
        
end



% x.- FLAG OF 'in' & 'computed' VTXs:

coF = ones(contaP,1);
inF = ones(contaP,1);

for v = 1:1:contaP

    ub(:,1) = sUvt(v,:);
    
    if (ub(1)<ULims(1,1) || ULims(1,2)<ub(1)) || ...
       (ub(2)<ULims(2,1) || ULims(2,2)<ub(2))
    
        inF(contaP,1) = 0 ;

    end

end

end

