function [contaP, cvR, csVtx, rvF, coF, inF, sXvt, sUvt,sRvt,coFct] = sv3342_Fcontours ...
    (sR, ct, contaP, cvR, csVtx, rvF, coF, inF, accN, cornerF, R, sXvt, sUvt,sRvt, Ncn, dSmesh,...
    Dspline, sDegree, sNcp, sKnotV, sUsize, sEP,sEw, Dumax, ULims, sXdim, ndig, tamp, NSg, DerC, ARCO)

% RETURNS: 
% No. points (vertexes) counted
% cvR(ct,i): contour vertexes references
% csNod(i,2): contour and side ref. of each vextex
% coF(i), inF(i): computed and 'in' flags

% INPUTS:
% ct: hexagonal contour reference

% computed vertex flag (initiates as not computed), 
% all vertexes of this contour in a single array:

Ntvc  = 6*ct ;  % total No. vtx per contour
coFct = zeros(Ntvc,1); 


rbF = 0 ; % retrieved base flag = 1 if any base vtx has been recovered

% loop on all points of 'ct' contour:

i = 0 ;
r = contaP; % reference of vertex of the contour


for si = 1:1:6
    for po = 1:1:ct
    
        % 1.- COUNTING AND REFERENCES:
        
        i = i+1 ;
        r = r+1 ;
        
        
        % vtx references of the contour: (starts from RHS corner) & counter-clock-wise
        cvR(ct,i) = accN + i ; 
        
        % contour and side or each vertex:
     	csVtx(r,1) = ct ; 
        csVtx(r,2) = si ; 
        
        
        % 2.- BASE VERTEX TO COMPUTE CURRENT:
        % Establishes Base vertexes refernces and angles and radius of arcs:
        
        [ra,rb, ta,tb, Rused] = sv3348_BaseV (po, i, r, si, ct, cvR, Ncn, R, accN, ARCO);
        
        % 3.- DETERMINES IF THE POINT IS TO BE COMPUTED:
        % That happens if one of the two next conditions happens:
        % a) at least one base vertex is inside
        % b) both are outside, but in opposite ends
        
        [ncoF] = sv3343_ncoF (sR, ULims, sUvt, inF, coF,  ra, rb);

        %{
        if (226<=r && r<=232) && sR==3
            
            [r ncoF]
            
            
            %BASE = [ra rb]
            %ANGL = [ta tb ]*57.3 
            
            
            %{
            sUvt(ra,:)
            sUvt(rb,:)
            %}
            
        end
        %}
        
        % 3.- PROCEEDS DIFFERENTLY IF IS TO COMPUTE OR NOT:

      	if ncoF == 1   
            
        % 3.1.- Point to compute:
        
            % 3.1.1.- Computes base in case was not computed in its correspondent contour:

            if coF(ra)==0 || coF(rb)==0
                
                % 'ref. of not computed' vtx
                rnc = ra;  
                if coF(rb) == 0
                    rnc = rb;
                end

                ctnc = csVtx(rnc,1);
                sinc = csVtx(rnc,2);

                % find neighbour contours:
                [fc, sc] = rb3371_NeighbourV (rnc, ctnc, sinc, cornerF, R);
                
                % includes the missed vtx in the arrays:
                [sRvt, sUvt, sXvt, coF, inF] = rb3370_RetrieveBV ...
                (sRvt, sUvt, sXvt, fc, sc, coF, inF, rnc, ctnc, sinc, tamp, NSg, R, dSmesh, Dspline,...
                sDegree, sNcp, sKnotV, sUsize, sEP,sEw, Dumax, ULims, sXdim, ndig, DerC);
                
                rvF(rnc,1) = 1 ;
            
                %{
                if rnc==226 && sR==3
                
                    fc
                    sc
                
                end
                %}
                
                
                %{
                if round(sUvt(rnc,1),5)==-0.07355
                    rnc
                end
                %}
                
                rbF = 1 ;
            
            end
  
            % 3.1.2.- Computes:

            rc = r;

            [sUvt, sXvt, inF] = sv3347_sUvAadd ...
            (sUvt, sXvt, inF, ra, rb, rc, r, ta,tb, tamp, NSg, Rused, dSmesh, Dspline,...
            sDegree, sNcp, sKnotV, sUsize, sEP,sEw, Dumax, ULims, sXdim, ndig, DerC, ARCO);

            [RCoor] = sv3345_Rpos_withCS (r, R, ct, si);
            sRvt(r,1) = RCoor(1);
            sRvt(r,2) = RCoor(2);
        
            coF(r) = 1 ;
 
            %{
            if round(sUvt(rc,2),5)== 0.75375
                
            end
            
            if (226 <= rc && rc <= 232) && sR==3
                
                rc
                sUvt(rc,:)
                
            end
            %}

        elseif ncoF == 0 
            
     	% 3.2.- Point to not compute:
        
            for di=1:1:sXdim
                sXvt(r,di) = 0 ;
            end
        
            sUvt(r,1) = 0 ;
            sUvt(r,2) = 0 ;
            
        	sRvt(r,1) = 0 ;
            sRvt(r,2) = 0 ;
            
            coF(r) = 0 ;
            inF(r) = 0 ;
            
        end
        
        % stores contour computed nodes flag:
        coFct(i,1) = coF(r);

    end
end


r = contaP ;
contaP = contaP + i; % updates vertex ref.


% IN CASE OF RETRIEVED BASE VTX. =>
% CHECKS IF ANY NON-COMPUTED VTX OF THE CURRENT CONTOUR HAS ONE BASE THAT
% HAS BEEN RETRIEVED

%rbF = 0 ; % resets the retrieved base flag to 0

if rbF == 1

    rbF = 0 ; % resets the retrieved base flag to 0

    i = 0 ;
    for si = 1:1:6
    for po = 1:1:ct

        % 1.- COUNTING AND REFERENCES:
        
        i = i+1 ;
        r = r+1 ;
        
        if coF(r)==0 % only for non-computed vtx
            
            
            % 2.- BASE VERTEX TO COMPUTE CURRENT:
            
            [ra,rb, ta,tb, Rused] = sv3348_BaseV (po, i, r, si, ct, cvR, Ncn, R, accN, ARCO);

            
             % 3.- DETERMINES IF THE POINT IS TO BE COMPUTED:
             
            [ncoF] = sv3343_ncoF (sR, ULims, sUvt, inF, coF,  ra, rb);
            
            %{
            if r==227 && sR==3
                
                [ra rb ncoF]
                
            end
            %}
            
            % 4.- COMPUTES THE VTX:
            
            if ncoF == 1   

                % 4.1.1.- Computes base in case was not computed in its correspondent contour:

                if coF(ra)==0 || coF(rb)==0

                    % 'ref. of not computed'
                    rnc = ra;  
                    if coF(rb) == 0
                        rnc = rb;
                    end

                    ctnc = csVtx(rnc,1);
                    sinc = csVtx(rnc,2);

                    % find neighbour contours:
                    [fc, sc] = rb3371_NeighbourV (rnc, ctnc, sinc, cornerF, R);

                    % includes the missed vtx in the arrays:
                    [sRvt, sUvt, sXvt, coF, inF] = rb3370_RetrieveBV ...
                    (sRvt, sUvt, sXvt, fc, sc, coF, inF, rnc, ctnc, sinc, tamp, NSg, R, dSmesh, Dspline,...
                    sDegree, sNcp, sKnotV, sUsize, sEP,sEw, Dumax, ULims, sXdim, ndig, DerC);

                    rvF(rnc,1) = 1 ;
                
                    rbF = 1 ;

                end

                % 4.1.2.- Computes:

                rc = r;

                [sUvt, sXvt, inF] = sv3347_sUvAadd ...
                (sUvt, sXvt, inF, ra, rb, rc, r, ta,tb, tamp, NSg, Rused, dSmesh, Dspline,...
                sDegree, sNcp, sKnotV, sUsize, sEP,sEw, Dumax, ULims, sXdim, ndig, DerC, ARCO);

                [RCoor] = sv3345_Rpos_withCS (r, R, ct, si);
                sRvt(r,1) = RCoor(1);
                sRvt(r,2) = RCoor(2);

                rvF(r,1) = 1 ;
                coF(r,1) = 1 ;

            end

        end
        
    end
    end


end
    
end

