function [Ustd] = sv3345_Rpos_withCS (nR, R, cR, sR)

% RETUNRS:
% Ustd(1,2): position of nR node in the standard space with R distance

% INPUTS:
% cR & sR: contour and side references


% 1.- FOR FIRST POINT THE STANDARD POSITION IS 0 0:

if nR==1
    Ustd = [0 0];
    return
end


% 2.- COMPUTES CORNER REFERENCE OF THAT SIDE:

if cR==1
    
    nRcor = 1+sR ;

else
    
    nRcor = 2 ;
    for ct = 1:1:cR
        nRcor = nRcor + 6*(ct-1);
    end
    nRcor = nRcor + ct*(sR-1);
end



% 3.- COMPUTES POSITION IN THE STANDARD SPACE:

% 3.1.- Norm and angle of vector from center (0 0) to corner of sR side:

nUcor = R*cR;
tita = (60*(sR-1)) / 57.29578;


% 3.2.- Transforms into cartesian coordinates:

Ucor = [nUcor*cos(tita) nUcor*sin(tita)];


% 3.3.- Moves up to the current node nR from the corner node nRcor:

Nseg = nR - nRcor;                      % No. segments
alfa = (120 + (sR-1)*60) / 57.29578;    % angle of the side

L = Nseg*R;

Ustd(1,1) =  Ucor(1) + L*cos(alfa);
Ustd(1,2) =  Ucor(2) + L*sin(alfa);

end

