function [ra,rb, ta,tb, Rused] = sv3348_BaseV (po, i, j, si, ct, cvR, Ncn, R, accN, ARCO)

% RETURNS:
% ra,rb: base vtx. references
% ta,tb: base angles
% Rused: arcs radius (same for both base vtx)


% INPUTS:
% po: position of vtx within the side
% i: postition of vertex within the contour
% j: absolute position of the vertex

if po == 1
        
	% - Corner nodes:

            pcr = j - (6*(ct-1) + si-1); % prev. corner ref.
        
            if i == 1
                
            % - Case of first corner of the contour:
                ra = cvR(ct-1,Ncn(ct-1));
                rb = pcr + 1;
                
            elseif ct==2 && j==18 
                
            % - special case 2nd contour last corner:  
                ra = 6;
                rb = 2;
            else
            
            % - other cases:
                ra = pcr - 1 ; 
                rb = pcr + 1 ; 
            
            end
            
        	ta = ( 30 + 60*(si-1)) / 57.296 ;
            tb = (-30 + 60*(si-1)) / 57.296 ;
            
            Rused = 3^0.5 * R ;
            
            if ARCO==2
                
                ta = -60 / 57.296 ;
                tb =  60 / 57.296 ;

            end
            
elseif i > 1 && po > 1
            
	% - Side  nodes:
            
            ra = j - (6*(ct-1) + si) ; 
            rb = ra+1;
            
            % special case last point of last side:
            if j == Ncn(ct)+accN
                rb = cvR(ct-1,1);
            end

            ta = ( 60 + 60*(si-1)) / 57.296 ;
            tb = (  0 + 60*(si-1)) / 57.296 ;
 
            Rused = R ;
            
            if ARCO==2
                
                ta = -60 / 57.296 ;
                tb =  60 / 57.296 ;

            end
            
end


end

