function [Rr] = sv3349_Rcorr (R, Degree, Ncp, KnotV, Usize, P ,w, xdim, udim)

% RETURNS:
% Rr = R reduced in case first contour lies outside the surface contour edges


% 1.- Mid point

um = [0.5 0.5]; 
dSm1 = zeros(xdim,1);
dSm2 = zeros(xdim,1);
dSm = b2701_BNURBS_deriv (Degree, Ncp, KnotV, Usize, P ,w, [1 1], um, xdim, udim);
dSm1(:,1)= dSm(2,1,1,:);
dSm2(:,1)= dSm(1,2,1,:);

nSm1 = norm(dSm1);
nSm2 = norm(dSm2);


% 2.- Edge-contur points

uc = [ 1 0.5 ; 0.5 1 ; 0 0.5 ; 0.5 0 ]; % contour edge locations
dSe1 = zeros(xdim,1);
dSe2 = zeros(xdim,1);

nSe = zeros(4,1);

for e = 1:1:4
    
    ui = [uc(e,1) uc(e,2)] ;
    
    dSm = b2701_BNURBS_deriv (Degree, Ncp, KnotV, Usize, P ,w, [1 1], ui, xdim, udim);
    
    dSe1(:,1)= dSm(2,1,1,:);
    dSe2(:,1)= dSm(1,2,1,:);
    
    if e==1 || e==3
        nSe(e) = norm(dSe1);
    else
        nSe(e) = norm(dSe2);
    end
end


% 3.- Measures distance from um to each edge-mid-point:
% It does rough estimation with derivatives

D = zeros(4,1);

nSm = [ nSm1 nSm2 nSm1 nSm2 ];

for e = 1:1:4
    D(e) = 0.5 * (nSm(e) + nSe(e))/2;
end


% 4.- Compares min ditance with R and reduces if required:

if min(D) < R*0.9
    
    Rr = min(D)*0.8 ;
    
else
    
    Rr = R ;
    
end
    


end

