function [NfeR, feR] = dp3351_findFirstE ...
    (uar,tita, ULims, NE, NEt, ULimEr, ULimEpr, fpeR, fceR, conM, conMp, conMc, grEp, vEgr, vDirp, nUcoorr, nd)


% 1.- FINDS ALL ELEMENTS:

[nEa, eRa] = dp3355_FindRele (ULims, NE, NEt, grEp, ULimEr, ULimEpr, fpeR, uar);



% 2.- SELECTS THOSE ELEMENTS THAT CONTAIN THE TRAJECTORY:

udim = 2 ;

if nEa == 1
    
    NfeR = 1 ;
  	feR(NfeR) = eRa(1);
    
else
    
    % 2.1.- Shortest distance from ua to nodes & edges: 
    %       stored in Umin also stores elements limits
    
    eL = zeros(nEa,udim,2);
    
    pdiag = ((ULims(1,2) - ULims(1,1))^2 + (ULims(2,2) - ULims(2,1))^2 )^0.5;
    
    Umin = pdiag;  % initial value of shortest distance
    

    
    for e = 1:1:nEa
        
        er = eRa(e);
        
        if er < fpeR
            
        % - internal element
            
            Nnod = 4 ;
            nr = conM(er,:);
            
            for di=1:1:udim
                eL(e,di,1) = nUcoorr(nr(1),di); 
                eL(e,di,2) = nUcoorr(nr(4),di);
            end
            
        elseif er < fceR
 
        % - perimeter element:
        
            eref = er-(fpeR-1);
            
            Nnod = 2 ;
            nr = conMp(eref,:);
                        
            % var. dir. & group:
            vd = vDirp(eref);
            gr = vEgr(eref);
            

            if gr==1
                eL(e,1,1) = nUcoorr(nr(1),1) - pdiag;
                eL(e,1,2) = nUcoorr(nr(1),1);
                eL(e,2,1) = nUcoorr(nr(1),2);
                eL(e,2,2) = nUcoorr(nr(2),2);
            elseif gr==2
                eL(e,1,1) = nUcoorr(nr(1),1);
                eL(e,1,2) = nUcoorr(nr(1),1) + pdiag;
                eL(e,2,1) = nUcoorr(nr(1),2);
                eL(e,2,2) = nUcoorr(nr(2),2);
            elseif gr==3
                eL(e,1,1) = nUcoorr(nr(1),1);
                eL(e,1,2) = nUcoorr(nr(2),1);
                eL(e,2,1) = nUcoorr(nr(2),2) - pdiag;
                eL(e,2,2) = nUcoorr(nr(2),2);
            elseif gr==4
                eL(e,1,1) = nUcoorr(nr(1),1);
                eL(e,1,2) = nUcoorr(nr(2),1);
                eL(e,2,1) = nUcoorr(nr(2),2);
                eL(e,2,2) = nUcoorr(nr(2),2) + pdiag;
            end

        else
        
        % - corner element:
        
            eref = er-(fceR-1);
            
            Nnod = 1 ;
            nr = conMc(eref);
            
            if eref==1
                eL(e,1,1) = nUcoorr(nr,1) - pdiag;
                eL(e,1,2) = nUcoorr(nr,1);
                eL(e,2,1) = nUcoorr(nr,2) - pdiag;
                eL(e,2,2) = nUcoorr(nr,2);
            elseif eref==2
             	eL(e,1,1) = nUcoorr(nr,1) - pdiag;
                eL(e,1,2) = nUcoorr(nr,1);
                eL(e,2,1) = nUcoorr(nr,2);
                eL(e,2,2) = nUcoorr(nr,2) + pdiag;
            elseif eref==3
               	eL(e,1,1) = nUcoorr(nr,1);
                eL(e,1,2) = nUcoorr(nr,1) + pdiag;
                eL(e,2,1) = nUcoorr(nr,2) - pdiag;
                eL(e,2,2) = nUcoorr(nr,2);
            elseif eref==4
               	eL(e,1,1) = nUcoorr(nr,1);
                eL(e,1,2) = nUcoorr(nr,1) + pdiag;
                eL(e,2,1) = nUcoorr(nr,2);
                eL(e,2,2) = nUcoorr(nr,2) + pdiag;
            end
            
        end

        
        % computes shortest distance:
        
        % distaces to nodes:
        for nod = 1:1:Nnod
            
            nR = nr(nod);
            uNod = [ nUcoorr(nR,1); nUcoorr(nR,2) ];
            Ndis = norm(uNod - uar);
            if Ndis < Umin && Ndis > 10^(-nd)
                Umin = Ndis;
            end
        end

        % distances to edges:
        for di = 1:1:udim
        for li = 1:1:2   
            Edis = abs(uar(di)-eL(e,di,li)) ;
            if Edis < Umin && Edis > 10^(-nd)
                Umin = Edis;
            end
        end    
        end

    end
    

    
    
    % 2.2.- Re-selects elements that contains ub = ua + Umin/2:
    
    ub = [uar(1) + 0.5*Umin*cos(tita), uar(2) + 0.5*Umin*sin(tita)];
    
    feR = zeros(1,1);
    NfeR = 0;
    
    for e = 1:1:nEa
        
        if (eL(e,1,1)-10^(-nd) <= ub(1) && ub(1) <= eL(e,1,2)+10^(-nd)) ...
     	&& (eL(e,2,1)-10^(-nd) <= ub(2) && ub(2) <= eL(e,2,2)+10^(-nd)) 
        
            NfeR = NfeR + 1 ;
            feR(NfeR,1) = eRa(e);
            
        end
    end
    
end



end

