function [uints] = dp3354_rayEleInts (NeR, eR, u, tita, conM,conMp,conMc, nUcoor, fpeR,fceR, grEp, vDirp, nd, Ttol)

% RETURNS:
% uints: intersection point between : 
% - semi-infinite ray (given by u and tita), u is the starting point
% - elements 'eR(NeR)' edges



for e = 1:1:NeR
    
    er = eR(e);
    
    % 1.- Diagonal of the element: D, to compute uo ('u out of element') that intersects elem edges.
    % Depends on the type of element.

    
    if er < fpeR 
    
   	% - internal element:
        
        na = conM(er,1); % nodes references
        nb = conM(er,4);
        nua = [nUcoor(na,1) nUcoor(na,2)]; % nodes coordinates
        nub = [nUcoor(nb,1) nUcoor(nb,2)];

        D = 1.1 * norm(nua-nub);
    
    
    elseif fpeR <= er && er < fceR
        
 	% - perimeter element:
        
        ueReff = er - (fpeR-1);
        
        % detects group:
        for i = 1:1:4
        if grEp(i,1) <= ueReff && ueReff <= grEp(i,2)
            gr = i ;
        	break
        end
        end
        
        % Leng of the element side 'L':
        vd = vDirp(ueReff);
      	na = conMp(ueReff,1); % nodes references
        nb = conMp(ueReff,2);
        L = nUcoor(nb,vd) - nUcoor(na,vd);
        
        % angle with respect perp. to L:
        if gr == 1
            titaRef = 180/57.296;
        elseif gr == 2
            titaRef =   0/57.296;
     	elseif gr == 3
          	titaRef = 270/57.296;
      	elseif gr == 4
          	titaRef =  90/57.296;     
        end
        titaEff = abs(tita - titaRef);
        
        % computes hypotenusa, i.e. maximum segment length. 
        % Then increases x2 to compute D:
        h = L / abs(sin(titaEff));
        D = 2 * h;
          
       
    elseif fceR <= er
        
    % - corner element:   
    
        ueReff = er - (fceR-1);
        na = conMc(ueReff);
        nua = [nUcoor(na,1) nUcoor(na,2)]; % node coordinates
        
        
        if round(tita,3)==0
        % - horizontal line:    
            
            D = abs(u(1)-nua(1)) * 10 ;
        
        else
      	% - works out y=xm+n with u and tita:
          
        	m = tan(tita);
            n = u(2) - m*u(1);

            % computes coordinates of that line intersection with 
            % nua(1) and nua(2) and selects the largest one:

            uvert = [nua(1); m*nua(1)+n];
            uhorz = [(nua(2)-n)/m; nua(2)];

            Dv = norm(u - uvert);
            Dh = norm(u - uhorz);

            D = max(Dh,Dv)*10;
        
        end
   
    end
    
    % 2.- computes uo:
    
    uo(1) = u(1) + D*cos(tita);
    uo(2) = u(2) + D*sin(tita);
    

    % 3.- Computes intersection between element edges and u-uo:
    
 	[iE, NiE] = dp3360_intersecLadosElem (u, uo, er, conM,conMp,conMc, nUcoor, fpeR, fceR, grEp, vDirp, nd);
                                        
 
    % 4.- Selects the point:
    
    % for single intersection point and single element, that point is the
    % one (u lies just at the edge of the element)
    if NeR == 1 && NiE == 1
        
        uints = [ iE(1,1); iE(1,2)];
        
    % for other cases, the point that does not coincide with u is uints:    
    else
        
        for po = 1:1:NiE
        if round(iE(po,1),nd)~=round(u(1),nd) || round(iE(po,2),nd)~=round(u(2),nd)

            uints = [ iE(po,1); iE(po,2)];
            break 
        end
        end
    end

end


uints = round(uints, nd);

end

