function [nE, eR] = dp3355_FindRele (ULims, NE, NEt, grEp, ULimE, ULimEp, fpeR, u)

% RETURNS:
% nE: No. elms that contain u. In case u is in the limit, then nE > 1
% eR(nE): elements ref. in the net, if more than 1 arranges by element area


% INPUTS:
% ULims(2,2):   parameter limits of the surface
% NE, NEt:      No. internal elements, and total No. elements
% grEp(4,1):    elements ref. for each perimeter group
% ULimE / ULimEp:   elements param. limits, for internals and for perimeter
% u(2):         param. coord's to find attached element


nE = 0 ;
eR = zeros(1,1);

% 1.- CORNER ELEMENTS (include at egde itself - closed interval):

if u(1)<=ULims(1,1) && u(2)<=ULims(2,1) % corner 1

    nE = nE+1;
    eR(nE,1) = NEt - 3;
    
elseif u(1)<=ULims(1,1) && ULims(2,2)<=u(2) % corner 2

   	nE = nE+1;
    eR(nE,1) = NEt - 2;
    
elseif ULims(1,2)<=u(1) && u(2)<=ULims(2,1) % corner 3

  	nE = nE+1;
    eR(nE,1) = NEt - 1;

elseif ULims(1,2)<=u(1) && ULims(2,2)<=u(2) % corner 4

  	nE = nE+1;
    eR(nE,1) = NEt - 0;

end



% 2.- PERIMETER ELEMENTS (include at egde itself - closed interval):

if u(1)<=ULims(1,1) && (ULims(2,1)<=u(2) && u(2)<=ULims(2,2)) % Left

    gr = 1 ;    vd = 2 ;
    [nE, eR] = dp3356_FindPeE (nE, eR, gr, grEp, fpeR, ULimEp, u(vd));

end
if ULims(1,2)<=u(1) && (ULims(2,1)<=u(2) && u(2)<=ULims(2,2))  % Right
    
    gr = 2 ;    vd = 2 ;
    [nE, eR] = dp3356_FindPeE (nE, eR, gr, grEp, fpeR, ULimEp, u(vd));
    
end
if u(2)<=ULims(2,1) && (ULims(1,1)<=u(1) && u(1)<=ULims(1,2))  % Bottom

 	gr = 3 ;    vd = 1 ;
    [nE, eR] = dp3356_FindPeE (nE, eR, gr, grEp, fpeR, ULimEp, u(vd));
    
end
if ULims(2,2)<=u(2) && (ULims(1,1)<=u(1) && u(1)<=ULims(1,2)) % Top
      
 	gr = 4 ;    vd = 1 ;
    [nE, eR] = dp3356_FindPeE (nE, eR, gr, grEp, fpeR, ULimEp, u(vd));
    
end


% 3.- INTERNAL ELEMENTS (include at egde itself - closed interval):

[nE, eR] = dp3357_FindInE (nE, eR, NE, ULimE, u);



end

