function [nE, eR] = dp3356_FindPeE (nE, eR, gr, grE, fpeR, ULimEp, u)

% RETURNS: for 'Perimeter Elements'
% nE: updated No. elms that contain u. In case u is in the limit, then nE > 1
% eR(nE): updated elements ref. in the net, if more than 1 arranges by element area


% INPUTS:
% gr: group to search in (1,2,3 & 4 varies as L, R, B & T bands)
% grE(): elements references for each group


% 1.- SELECTS ELEMETS TO SEACH IN:

e1 =  grE(gr,1);
e2 =  grE(gr,2);


% 2.- SEARCH ELEMENTS:

for e = e1:1:e2
    
    u1 = ULimEp(e,1);
    u2 = ULimEp(e,2);
    
    if u1<=u && u<=u2 
        nE = nE + 1 ;
        eR(nE,1) = fpeR + (e-1);
    end

end


end

