function [nE, eR] = dp3357_FindInE (nE, eR, NE, ULimE, u)

% RETURNS: for 'Internal Elements'
% nE: No. elms that contain u. In case u is in the limit, then nE > 1
% eR(nE): elements ref. in the net, if more than 1 arranges by element area
% u1...v2: element limits

% INPUTS:
% u(2): param coord's to find attached element

% 1.- SEARCHES ACCORDING TO PARAM. LIMITS:

% 1.1.- Selection acc/to coord 1,1:

contaH1 = 0 ;
H1 = zeros(1,1);

for r = 1:1:NE
    if ULimE(r,1) <= u(1) 
        contaH1 = contaH1+1;
        H1(contaH1) = r ; % H for horquilla  
    else
        break
    end
end


% 1.2.- Selection acc/to coord 1,2:

contaH2 = 0 ;
H2 = zeros(1,1);

for i = 1:1:contaH1
    
    r = H1(i);
    if u(1) <= ULimE(r,2) 
        contaH2 = contaH2+1;
        H2(contaH2) = r ;   
    end
end


% 1.3.- Selection acc/to coord 2,1:

contaH3 = 0 ;
H3 = zeros(1,1);

for i = 1:1:contaH2
    r = H2(i);
    if ULimE(r,3) <= u(2)
        contaH3 = contaH3+1;
        H3(contaH3) = r ;   
    end
end


% 1.4.- Coor 2,2: last selection:

contaH4 = 0 ;
H4 = zeros(1,1);

for i = 1:1:contaH3
    r = H3(i);

    if u(2) <= ULimE(r,4)  

        contaH4 = contaH4+1;
        H4(contaH4) = r ; 
        
    end
end




% 2.- STORES ELEMENTS, STORES THEM SORTED ACC/TO ASCENDING ORDER OF AREA:

% 2.1.- Computes area in each element and arranges acc/to area:

tem = zeros(contaH4,3); % elem. ref / row position in ULimE / Area of element

for e = 1:1:contaH4
    
    row = H4(e);
    Ae = (ULimE(row,2) - ULimE(row,1)) * (ULimE(row,4) - ULimE(row,3)) ;
    
    tem(e,1) = ULimE(row,5);
    tem(e,2) = row;
    tem(e,3) = Ae;
end

tem = sortrows(tem,3);


% 2.2.- Transfers responses:

if nE == 0
    eR = tem(:,1);
else
    eR = [eR ; tem(:,1)];
end

nE = nE + contaH4;




end

