function [Lx] = dp3358_OEPlength (u1, u2, mSg1, mSg2)

% RETURNS:
% Lx: distance in physical space for u increment from u1 to u2
% both locations lie within one element of dS-mesh

% INPUTS:
% u1,u2: param. coord's of extreme segment ends
% mSg1, mSg2: modules of derivatives dC at u1 and u2 in tita direction

% Note: just carries out integration of the straight line

Du = norm(u1 - u2);
mSavg = (mSg1 + mSg2)/2;
Lx = Du * mSavg ;

end

