function [ue] = dp3359_LDPincrement (u1, u2, tita, mSg1, mSg2, Reff, Dumax)

% RETURNS:
% ue(2): estimated u value to accumulate a distance in physical space = Reff

% INPUTS:
% u1,u2: param. coord's of extreme segment ends
% mSg1, mSg2: modules of derivatives dC at u1 and u2 in tita direction
% tita: angle on plan bewteen horizontal and sgm u1-u2
% Reff: effective physical length that we are targeting

Du = norm(u2-u1);

x = [0 Du];
y = [mSg1  mSg2];
[m,n] = go2516_mnCoeff (x,y);
        
a =  m/2;
b =  n ;
c = -Reff;

[utemp,~] = GEN_24_rootQuadPolm (a,b,c, Dumax, 0.000001);
        
ue = zeros(2,1);

ue(1,1) = u1(1) + utemp(1)*cos(tita);
ue(2,1) = u1(2) + utemp(1)*sin(tita);

% (note: ue can lie prev. or futher to u2).


end

