function [sRvt, sUvt, sXvt, coF, inF] = rb3370_RetrieveBV ...
    (sRvt, sUvt, sXvt, fc, sc, coF, inF, rnc, ct, si, tamp, NSg, R, dSmesh, Dspline, ...
    sDegree, sNcp, sKnotV, sUsize, sEP,sEw, Dumax, ULims, xdim, nd, DerC)


% 1.- FIND TWO SUITABLE NODES TO COMPUTE rnc BY THEIR CIRCUMF. INTERSECTION:

% finds two nodes to compute rnc position. The angle difference btn them
% w.r.t. rnc must be between 60 and 120. Checks first the first contour

pfF = 0 ; % 'points found flag' = 1 when finds 2 suitable points to compute rnc position

% 2.1.- Searches 'a' in first contour:

for i = 1:1:6
    
    ra = fc(i,1);
    Ra = fc(i,2);
    Oa = fc(i,3);
    
    if coF(ra)==1
        
        % Searches 'b' in first contour:
        
        for j = 1:1:6
        if j~=i
                
            rb = fc(j,1);
          	Rb = fc(j,2);
            Ob = fc(j,3); 
            Dt = abs(Oa-Ob);

            
            if coF(rb)==1 && (55/57.3 < Dt && Dt < 125/57.3)
                pfF = 1 ;
              	break
            end
                
        end
        end
        
        
        % Searches 'b' in second contour:
        
        if pfF == 0 
            
            for j = 1:1:12

                rb = sc(j,1);
                Rb = sc(j,2);
                Ob = sc(j,3);
                Dt = abs(Oa-Ob);

                if coF(rb)==1 && (55/57.3 < Dt && Dt < 125/57.3)
                    pfF = 1 ;
                    break
                end

            end

        end
        
    end
    
    if pfF==1
       break 
    end

end
     

%{
if rnc==226
    [ra rb]
end
%}

% 2.2.- Searches 'a' and 'b' in second contour:
% note first restrings Dt to 55-125, if not in a second 
% loop restrings just to not be equal

if pfF == 0
    
    for lo= 1:1:2
    for i = 1:1:12
       
        ra = sc(i,1);
      	Ra = sc(i,2);
       	Oa = sc(i,3);
        
        if coF(ra)==1
        
            % Searches 'b':

            for j = 1:1:12
            if j~=i

                rb = sc(j,1);
                Rb = sc(j,2);
                Ob = sc(j,3);
                Dt = abs(Oa-Ob);

                if lo==1
                
                    if coF(rb)==1 && (55/57.3 < Dt && Dt < 125/57.3)
                        pfF = 1 ;
                        break
                    end

                elseif lo==2
                    
                   	if coF(rb)==1 && Dt > 0 
                        pfF = 1 ;
                        break
                    end
                    
                end
                
            end
            end
        end
        
  	if pfF == 1
   	break
   	end
       
    end
    
  	if pfF == 1
    break
  	end
    
    end
    
end
    

% 2.- FINDS POSITION OF rnc BY INTERSECTION OF CIRCUMF. FROM 'a' & 'b':

rc = rnc;

ua = [sUvt(ra,1); sUvt(ra,2)];
ub = [sUvt(rb,1); sUvt(rb,2)];

xa = [sXvt(ra,1); sXvt(ra,2); sXvt(ra,3)];
xb = [sXvt(rb,1); sXvt(rb,2); sXvt(rb,3)];


%{
ta = ta - 180/57.296;
tb = tb - 180/57.296;

[ui,~,~] = ar3301_Ainters ...
(ua,ub, ta,tb, ra, rb, rc, tamp, NSg, R, Ra, Rb, dSmesh, Dspline, ...
sDegree, sNcp, sKnotV, sUsize, sEP,sEw, Dumax, ULims, xdim, nd, DerC);
%}


Rstd = R ;

pa = ar3303_Rposi (ra, Rstd);
pb = ar3303_Rposi (rb, Rstd);
pc = ar3303_Rposi (rc, Rstd);

% Angles ta and tb (recall that angle ta is Vac wrt Vab, and similar to tb)
 
Vac = [pc'-pa'];
Vab = [pb'-pa'];
ta = go2511_angleUV (Vac, Vab);

Vbc = [pc'-pb'];
Vba = [pa'-pb'];
tb = go2511_angleUV (Vbc, Vba);

if Oa < Ob
    tb = -tb ;
else
    ta = -ta ;
end

%{
if round(pa(1),0)==-300

    pa
    pb
    pc
    
    ta*57.3
    tb*57.3
    
    figure(88)
    scatter(pa(1),pa(2),'r'); hold on
    scatter(pb(1),pb(2),'r'); hold on
    scatter(pc(1),pc(2),'r'); hold on
    axis equal

    
end

%}

[ui,~,~] = ar3302_Ainters_v2 ...
(xa, xb, ua,ub, ta,tb, ra, rb, rc, tamp, NSg, Rstd, Ra, Rb, dSmesh,Dspline, ...
sDegree, sNcp, sKnotV, sUsize, sEP,sEw, Dumax, ULims, xdim, nd, DerC);






udim = 2;
[X] = rs3333_Xcoor (ui, Dspline, dSmesh, sKnotV, sNcp, sDegree, sUsize, sEw, sEP, ULims, udim, xdim, DerC);

for di=1:1:xdim
    sXvt(rnc,di) = X(di);
end

sUvt(rnc,1) = ui(1);
sUvt(rnc,2) = ui(2);
        
inF(rnc,1) = 1 ;
if  (ui(1) < ULims(1,1) || ULims(1,2) < ui(1)) || ...
    (ui(2) < ULims(2,1) || ULims(2,2) < ui(2))    
    inF(rnc,1) = 0 ;
end

coF(rnc) = 1 ;



% 4.- COMPUTES Rcoord's:

[Ustd] = sv3345_Rpos_withCS (rnc, R, ct, si);

sRvt(rnc,1) = Ustd(1);
sRvt(rnc,2) = Ustd(2);



end

