function [fc, sc] = rb3371_NeighbourV (cp, ct, si, cornerF, R)


% RETURNS:
% first and second contour information for node cp
% fc(6,3): node ref, distance, angle (in rads)
% sc(12,3): node ref, distance, angle (in rads)


% INPUTS:
% cp: 'central point' (node) reference
% ct: contour order
% si: side ref.
% corner flag = 1 if the node is a corner


% 1.- FIRST CONTOUR:

[fc] = rb3372_firstC (cp, ct, si, cornerF(cp), R);



% 2.- SECOND CONTOUR: 

sc = zeros(12,3);


% 2.1.- nodes references:

if cornerF(cp) == 0

% - SIDES:

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    sc(1,1) = cp + (6*ct + 6*(ct+1) + 2*(si-1)) ;

    sc(2,1) = sc(1,1) + 1 ;

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    sc(3,1) = sc(1,1) + 2 ;

    sc(4,1) = cp + (6*(ct+1) - 4 + (si-1));

    if si==6 && cornerF(cp+1)==1

        sc(4,1) = cp + 1;

    end

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    sc(5,1) = cp + 2 ;

    if cornerF(cp+1) == 1 && si<6

        sc(5,1) = cp + (6*(ct+1) - 3 + (si-1));

    elseif cornerF(cp+1) == 1 && si==6

        sc(5,1) = cp + 2 ;   

    elseif cornerF(cp+2) == 1 && si==6

        sc(5,1) = cp - (6*ct-2) ; 

    end


    sc(6,1) = cp - (6*(ct-1) - 1 + (si-1));

    if cornerF(cp+1) == 1 && si<6

        sc(6,1) = cp + 2;

    elseif cornerF(cp+1) == 1 && si==6

        sc(6,1) = cp -(6*ct -2);

    elseif cornerF(cp+2) == 1 && si==6

        sc(6,1) = cp -(6*ct + 6*(ct-1) -2);

    end

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    sc(7,1) = cp - (6*(ct-2) + 6*(ct-1) + 2*(si-1)) ;

    if cornerF(cp+1) == 1 && si < 6

        sc(7,1) = cp - (6*(ct-1) - 1 + (si-1)) ;

    elseif cornerF(cp+1) == 1 && si == 6

        sc(7,1) = cp - (6*ct + 6*(ct-1) - 2 ) ;

    elseif cornerF(cp+2) == 1 && si == 6

        sc(7,1) = cp - (6*ct + 6*(ct-1) + 4 +  6*(ct-3) ) ;

    end



    sc(8,1) = sc(7,1)-1 ;

    if cornerF(cp+1) == 1 && si < 6

        sc(8,1) = cp - (6*(ct-1) + 6*(ct-2) + 2*(si-1) + 1 )  ;

    elseif cornerF(cp+1) == 1 && si == 6   

        sc(8,1) = cp - (6*(ct-1) + 6*ct + 5 + 6*(ct-3)) ;

    elseif cornerF(cp+2) == 1 && si == 6

        sc(8,1) = cp - (6*ct + 6*(ct-1) - 1 ) ;

    end

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    sc(9,1) = cp - (6*(ct-1) + 6*ct -10 + 2*(si-1)) ;

    if cornerF(cp-1) == 1 && si > 1

        sc(9,1) = cp - (6*(ct-1) + (si-1) + 2 ) ;

    elseif cornerF(cp-1) == 1 && si == 1

        sc(9,1) = cp - 2 ;

    end



    sc(10,1) = cp - (6*ct + (si-1) - 4) ;

    if cornerF(cp-1) == 1 && si > 1

        sc(10,1) = cp - 2 ;

    elseif cornerF(cp-1) == 1 && si == 1

        sc(10,1) = cp + (6*ct - 2) ;

    end

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    sc(11,1) = cp - 2 ;

    if cornerF(cp-1) == 1 && si > 1

        sc(11,1) = cp + (6*ct + (si-1) - 2 ) ;

    elseif cornerF(cp-1) == 1 && si == 1

        sc(11,1) = cp + (6*ct + 6*(ct-1) + 10 ) ;

    end

    sc(12,1) = cp + (6*ct - 1 + (si-1)) ;




elseif cornerF(cp)==1

% - CORNERS:
    

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    sc(1,1) = cp + (6*ct + 6*(ct+1) + 2*(si-1)) ;

    sc(2,1) = sc(1,1) + 1 ;

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    sc(3,1) = sc(1,1) + 2 ;

    sc(4,1) = cp + (6*(ct+1) - 4 + (si-1));

    if si==6 && cornerF(cp+1)==1

        sc(4,1) = cp + 1;

    end   
    
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    sc(5,1) = cp + 2 ;

    if cornerF(cp+1) == 1 && si<6

        sc(5,1) = cp + (6*(ct+1) - 3 + (si-1));

    elseif cornerF(cp+1) == 1 && si==6

        sc(5,1) = cp + 2 ;   

    elseif cornerF(cp+2) == 1 && si==6

        sc(5,1) = cp - (6*ct-2) ; 

    end


    
    sc(6,1) = cp - (6*(ct-1) - 1 + (si-1));


    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    
    sc(7,1) = cp - (6*(ct-1) + 6*(ct-2) + 2*(si-1));
    
    sc(8,1) = cp - (6*(ct-1) + 1 + (si-1));

    if si==1
        sc(8,1) = cp - 1 ;
    end
    
 	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  	sc(9,1) = cp - 2;

    if si==1
        sc(9,1) = cp + (6*ct - 2);
    end
    
   	sc(10,1) = cp + (6*ct - 2 + (si-1)) ;

    if si==1
        sc(10,1) = cp + (6*ct + 6*(ct-1) + 10);
    end
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    sc(11,1) = cp + (6*ct + 6*(ct+1) - 2 + 2*(si-1)) ;

    if si==1
        sc(11,1) = cp + (6*ct + 6*(ct+1) + 6*(ct+2) - 2) ;
    end
    
  	sc(12,1) = cp + (6*ct + 6*(ct+1) - 1 + 2*(si-1)) ;

    if si==1
        sc(12,1) = cp + (6*ct + 6*(ct+1) + 6*(ct+2) - 1) ;
    end
    
    
end




% 2.2.- Distances and angles:

alfas = [0 30 60 90 120 150 180 210 240 270 300 330 0 30 60 90 120 150 180 210 240 270 300 330 ] / 57.2958 ;
ini = [1 3 5 7 9 11];

for i = 1:1:12
    
   if mod(i,2)==1
       
        sc(i,2) = 2*R;
    
   elseif mod(i,2)==0
       
        sc(i,2)=3^0.5 * R;
        
   end
    
   sc(i,3) = alfas(i-1+ini(si)) ;
   
end





end

