function [Dspline] = ds3375_Dspline (sDegree, sNcp, sKnotV, sUsize, sP,sw, xdim, nd, tolD)

% RETURNS:
% Dspline: R-element-wise splines to approximate derivatives


plotRealg =  0 ; % ***
plotEstimg = 0 ; % ***

ust1 = 0.05 ; % ***
ust2 = 0.05 ; % ***

% functions to represen

udirA = 1 ; % *** 
udirB = 2 ; % *** 

xdirA = 1 ; % *** 
xdirB = 3 ; % ***




% 1.- DECLARES STRUCTURE AND SET OPTIONS:

cp = struct('dEP',[]); % in each fitted spline 'fs' there are 6 sets of cp's
fs = struct('dNcp',[], 'dDegree',[], 'dUsize',[], 'dKnotV',[], 'ULim',[],'nvU',[], 'nvUs',[], 'cp',{cp}); % fitted spline featurs
Dspline = struct('NE',0,'ELim',[],'fs',{fs}); % No. fs = NE

udim = 2 ;

% options for fitting
Degree = [2 2];             % ***
paramPos = 'as-points';     % ***
ktype = 'equally_spaced';   % ***
% ktype = 'averaged';       % ***
homCoord = 0 ;              % ***


% 2.- KNOT SPANS & No. ELEMENTS:

% extracts knot spans:
[nvU, nvUs] = GEN_18_UnonVoid (sKnotV, sUsize, sDegree, udim);
nvU = round(nvU,nd);

% No. elements:
NE = (nvUs(1)-1)*(nvUs(2)-1);

% allocates:
Dspline.NE = NE ;


% 3.- LOOPS ON EACH ELEMENT: fits Spline , add cp's until error < tolD

NF = xdim*udim;
eUlim = zeros(udim,2);

contaE = 0 ;
for e1 = 1:1:nvUs(1)-1
for e2 = 1:1:nvUs(2)-1
    
    contaE = contaE + 1 ;
    
    % 3.1.- element limits:
    
    eUlim(1,1) = nvU(1,e1);   eUlim(1,2) = nvU(1,e1+1);
    eUlim(2,1) = nvU(2,e2);   eUlim(2,2) = nvU(2,e2+1);

    eDU(1) = eUlim(1,2) - eUlim(1,1); % element knot spans
    eDU(2) = eUlim(2,2) - eUlim(2,1);
    
    
   	% 3.2.- Computes average height of element for each function gx,u , gy,u , ... gz,v

    [ah] = ds3379_avgH (eUlim, eDU, sDegree, sNcp, sKnotV, sUsize, sP ,sw, xdim, udim);

    % corrects 'ah' too low: if they are less than 50% average are raise to that value:
    
    accah = sum(sum(ah));
    ahthr = 0.6*accah/NF;
    
   	for ud = 1:1:udim
       for xd = 1:1:xdim
           if ah(ud,xd) < ahthr
               ah(ud,xd) = ahthr;
           end
       end
    end
    
    %{
    maxah = [ max(ah(1,:)); max(ah(2,:))];

    for ud = 1:1:udim
       for xd = 1:1:xdim
           ah(ud,xd) = maxah(ud);
       end
    end
    %}
    
    % 3.3.- sets initial spline features (same for all splines functions):
    
    iNpa= [1;1];
    [~,xs1] = ds3378_spFeat (eUlim, eDU, Degree, iNpa, udim);
    
    % 3.4.- Initial relative error computed with no sub-division:
    
    np = 3 ; % No. points to measure (by side)
    dro = 3 ; % desired derivative order for error computation
    
    [Ierr] = ds3380_Ierr (eUlim, eDU, xs1, ...
	sDegree, sNcp, sKnotV, sUsize, sP ,sw, ah, xdim, udim, nd, np, dro);


    % 3.5.- Computes max. No. points to add in each direction:

  	mNpa = zeros(udim,1);
    
    for di=1:1:udim
        
        % maximum error and No. points to add:
        emax = max(Ierr(di,:));
        
        k = emax/tolD;
        
    	D = 0.72 * 0.5 * eDU(di) / k^(1/3);  
     	n = round(eDU(di)/D + 0.3333 , 0); 
            
      	mNpa(di) = n-Degree(di); 
        
        if mNpa(di)<1
            mNpa(di)=1;
        end
    end
    
    % mNpa=[1;1] * 2 ; %%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    % 3.6.- Recomputes Ncp and their coordinates to comply with updates Npa:
    
    [Ncp, xs] = ds3378_spFeat (eUlim, eDU, Degree, mNpa, udim);
    
    uxf=zeros(Ncp(1),Ncp(2),udim); % param coord's of points to fit = knot spans
    
    for i = 1:1:Ncp(1)
    for j = 1:1:Ncp(1)
        uxf(i,j,1) = xs(1,i);
        uxf(i,j,2) = xs(2,j);
    end
    end
    
    
	% 3.7.- Set spline features except cp's coordinates:
    
    Usize = [ 2*Degree(1)+mNpa(1)+1 , 2*Degree(2)+mNpa(2)+1 ];

	Dspline.fs(contaE,1).dNcp = Ncp ;
	Dspline.fs(contaE,1).dDegree = Degree;
	Dspline.fs(contaE,1).dUsize = Usize ;
 	Dspline.fs(contaE,1).ULim = round(eUlim,nd) ; 

    % KnotV and non-void spans:

	KnotV = zeros(udim, max(Usize));
    pdm = [2 1]; % perp direction

    for di = 1:1:udim

        pd = pdm(di); % perp. direction

        % knot vector limits:
    	u0 = round(eUlim(di,1),nd) ; 
    	u1 = round(eUlim(di,2),nd) ;   

        % averages uxf for that direction:
      	uxd = zeros(Ncp(di),1);

        for i = 1:1:Ncp(di)
            acc = 0 ;
            for j = 1:1:Ncp(pd) 
                if di==1
                    acc = acc + uxf(i,j,di);
                else
                    acc = acc + uxf(j,i,di);
                end
            end
            uxd(i,1) = acc / Ncp(pd);
        end

        % computes knot vector:
        U = bf3408_knotV (Ncp(di), Degree(di), u0, u1, ktype, uxd);  

        % allocates to response:
        for i = 1:1:Usize(di)
            KnotV(di,i) = U(i);
        end
    end
    
    [dnvU, dnvUs] = GEN_18_UnonVoid (KnotV, Usize, Degree, udim);
    dnvU = round(dnvU,nd);
    
    Dspline.fs(contaE,1).dKnotV = KnotV ;
    Dspline.fs(contaE,1).nvU = dnvU ;
    Dspline.fs(contaE,1).nvUs = dnvUs ;
    
    % 3.7.- Set cp's coordinates and allocates:
    
    [EP] = ds3376_OneEcp (sDegree, sNcp, sKnotV, sUsize, sP, sw, Degree, Ncp, KnotV, Usize, xs, xdim, paramPos, ktype, homCoord);
    
    dEP = zeros(Ncp(1), Ncp(2), xdim);
    for f = 1:1:NF
        
        dEP(:,:,:) = EP(f,:,:,:);
        Dspline.fs(contaE,1).cp(f).dEP = dEP ;
        
    end

end 
end


% sets ELim and allocates:

ELim = zeros(NE,4);

contaE = 0 ;
for i = 1:1:nvUs(1)-1
    for j = 1:1:nvUs(2)-1
        
        contaE = contaE + 1 ;
        
        ELim(contaE,1) = round(nvU(1,i),nd);
      	ELim(contaE,2) = round(nvU(1,i+1),nd);
        
       	ELim(contaE,3) = round(nvU(2,j),nd);
      	ELim(contaE,4) = round(nvU(2,j+1),nd);
        
    end
end

Dspline.ELim = ELim;


% 4.- PLOTS:

if plotRealg==1 || plotEstimg==1

    for udir = udirA:1:udirB 
    for xdir = xdirA:1:xdirB 
        
	Fr = xdir + (udir-1)*xdim; % function total reference
        
    if plotRealg==1
    
        % 4.1.- Real surfaces:

        conta1 = 0 ;
        for i = 0:ust1:nvU(1,nvUs(1))

            conta1 = conta1+1;

            conta2 = 0;
            for j =0:ust2:nvU(2,nvUs(2))

                conta2 = conta2+1;
                xr(conta1,conta2,1) = i;
                xr(conta1,conta2,2) = j;

                u = [i, j];

                [dS] = b2701_BNURBS_deriv (sDegree, sNcp, sKnotV, sUsize, sP,sw, [1 1], u, xdim,udim);

                if udir==1
                    xr(conta1,conta2,3) = dS(2,1,1,xdir);
                elseif udir==2
                    xr(conta1,conta2,3) = dS(1,2,1,xdir);
                end
                


            end
        end

        pclr = 'b';
        for j = 1:1:size(xr,2)

            figure(80+Fr)
            plot3(xr(:,j,1),xr(:,j,2),xr(:,j,3),pclr); hold on
        end

        for i = 1:1:size(xr,1)

            figure(80+Fr)
            plot3(xr(i,:,1),xr(i,:,2),xr(i,:,3),pclr); hold on 
        end

    end
    
    if plotEstimg==1
    
        % 4.2.- Approximated splines:

        for e = 1:1:NE

            xe = zeros(1,1,xdim);

            eUlim = Dspline.fs(e,1).ULim ;

            dKnotV = Dspline.fs(e,1).dKnotV;
            dNcp = Dspline.fs(e,1).dNcp;
            dDegree = Dspline.fs(e,1).dDegree;
            dUsize = Dspline.fs(e,1).dUsize;
            dEP = Dspline.fs(e,1).cp(Fr).dEP;

            conta1 = 0;
            for i = eUlim(1,1):ust1:eUlim(1,2)

                conta1 = conta1 + 1 ;
                conta2 = 0;

                for j = eUlim(2,1):ust2:eUlim(2,2)

                    conta2 = conta2 + 1 ;
                    u = [i j];

                    [X] = b2603_Bspline_Xcoord ...
                    (u, dKnotV, dNcp, dDegree, dUsize, dEP, udim,xdim);

                    xe(conta1,conta2,1) = X(1) ;
                    xe(conta1,conta2,2) = X(2) ;
                    xe(conta1,conta2,3) = X(3) ;

                end
            end

            pclr = 'r';
            for j = 1:1:size(xe,2)

                figure(80+Fr)
                plot3(xe(:,j,1),xe(:,j,2),xe(:,j,3),pclr); hold on
            end

            for i = 1:1:size(xe,1)

                figure(80+Fr)
                plot3(xe(i,:,1),xe(i,:,2),xe(i,:,3),pclr); hold on
            end

        end

    end
    
    end
    end
end





end

