function [EP] = ds3376_OneEcp (sDegree, sNcp, sKnotV, sUsize, sP, sw, dDegree, dNcp, dKnotV, dUsize, xs, xdim, paramPos, ktype, homCoord)

% RETURNS:
% EP: cp's of fitted spline surface at one element (extended version)
% the rest of the spline features are inputs
% computes for all 6 functions

% INPUTS:
% xs(Ncp(1), Ncp(2),udim) plan coordinates of points to fix

udim = 2 ;
NF   = udim*xdim; % No. functions
Ncpt = dNcp(1)*dNcp(2); % total No. cp's

EP = zeros(NF, dNcp(1), dNcp(2), xdim);

% 1.- SET OF POINTS TO FIT TO:

xf = zeros(dNcp(1), dNcp(2), udim);

bu = zeros(Ncpt,1); % xf in vector form
bv = zeros(Ncpt,1);

z = zeros(NF, dNcp(1), dNcp(2)); % required height in each function
bz = zeros(NF,Ncpt); % vector form, each row is a vector

contaP = 0 ;
for i = 1:1:dNcp(1)
for j = 1:1:dNcp(2)
    
    contaP = contaP + 1 ;
    
    u = [xs(1,i) xs(2,j)];
    xf(i,j,1) = u(1);
    xf(i,j,2) = u(2);

    bu(contaP,1) = u(1);
    bv(contaP,1) = u(2);
    
  	[dS] = b2701_BNURBS_deriv (sDegree, sNcp, sKnotV, sUsize, sP,sw, [1 1], u, xdim,udim);

    contaF = 0;
    for xd = 1:1:xdim    
        contaF = contaF+1;
    	z(contaF,i,j) = dS(2,1,1,xd);
        bz(contaF,contaP) = dS(2,1,1,xd);
    end
    for xd = 1:1:xdim    
        contaF = contaF+1;
    	z(contaF,i,j) = dS(1,2,1,xd);
        bz(contaF,contaP) = dS(1,2,1,xd);
    end
    
end
end


% 2.- COMPUTES PARAMETER POSITIONS FOR EACH xf POINT:
%     uses selected method

uxf = zeros(dNcp(1), dNcp(2), udim);

if strcmp(paramPos,'as-points')==1

    for i = 1:1:dNcp(1)
    for j = 1:1:dNcp(2)

        for di = 1:1:udim
            uxf(i,j,di) = xf(i,j,di);
        end
        
    end
    end

else  
    %{
    % PENDING ! 
    
	xhom = xf ; 
	if homCoord == 1
        
        xs = zeros(Npt,xdim); % coord's in a single row
        
        conta = 0 ;
        for i = 1:1:Np(1)
       	for j = 1:1:Np(2)
            
            conta = conta+1;
            for di = 1:1:xdim
                xs(conta,di) = xf(i,j,di);
            end
        end
        end
        
        % works out averags in each direcion:
        
        for di = 1:1:udim
            
        end
        
        % homogeniezed coordinates in each direction
        xhoms = bf3404_homCoor (xs, Npt, xdim);
        
    end
        
  	% parameters coorespondant to each point:
   	u0 = xf(1,1,di);
 	u1 = xf(Np(1),Np(2),di);
   	[uxf] = bf3407_paramPos (Np, xhom, u0, u1, paramPos);
        
 	%}
end


% 3.- CONTROL POINTS COORDINATES:

% 3.1.- Coefficients matrix: A c = xf (same for all functions)

A = zeros(Ncpt,Ncpt);


fil = 0 ;
for ir = 1:1:dNcp(1)
for jr = 1:1:dNcp(2)
    
    fil = fil + 1 ;
    u = [uxf(ir,jr,1) uxf(ir,jr,2)];
    
    col = 0 ;
    for ic = 1:1:dNcp(1)
    for jc = 1:1:dNcp(2)
        
        col = col + 1 ;
        br = [ic jc];
        B = b2604_MNL (u, br, dKnotV, dNcp, dDegree, dUsize, udim); 

        A(fil,col) = B ;
        
    end
    end
end
end


% 3.2.- Computes coordinates of cp's for plan dimensions (they are shared
% for all the splines)

cu = A\bu;
cv = A\bv;


% 3.3.- Computes third coordinate (height) for functions and allocates

b = zeros(Ncpt,1);

for f = 1:1:NF
    
    b(:,1) = bz(f,:);
    cz = A\b;
    
    conta = 0;
    for i = 1:1:dNcp(1)
    for j = 1:1:dNcp(2)
        conta = conta + 1;
        EP(f,i,j,1) = cu(conta);
        EP(f,i,j,2) = cv(conta);
        EP(f,i,j,3) = cz(conta);
    end
    end
end



end