function [dfo] = ds3377_df_dro (u, dro, sDegree, sNcp, sKnotV, sUsize, sP ,sw, xdim, udim)

% RETURNS:
% dfn(udim,xdim,n,n): derivatives up to n of each f component
% udim: No. rows for f=g,u and f=g,v
% xdim: No. cols for each component of f vector
% dro: No. derivatives order in both directions (accounts for cross derivatives)


% INPUTS:
% u: location to compute derivatives
% n: maximum order of derivative selected


% 1.- DERIVATIVES OF NURBS (g in theory) AT u UP TO n ORDER:

[dS] = b2701_BNURBS_deriv ...
(sDegree, sNcp, sKnotV, sUsize, sP ,sw, [dro+1 dro+1], u, xdim, udim);

% 2.- POPULATES dfn:
% copies directly from derivatives of NURBS (g function in theory):

dfo = zeros(udim, xdim, dro+1,dro+1);

for a = 1:1:udim % param. directions
for b = 1:1:xdim % vector component
            
	for i = 1:1:dro+1
    for j = 1:1:dro+1
         
        if a==1
            dfo(a,b,i,j) =  dS(1+i,j,1,b); 
        elseif a==2
            dfo(a,b,i,j) =  dS(i,1+j,1,b); 
        end
  
    end
	end
       
end 
end



end

