function [Np, xs] = ds3378_spFeat (eUlim, eDU, Degree, Npa, udim)

% RETURNS: 
% Np(udim): No. control points in each direction
% xs(udim,Np): positions of sample points (assuming orthogonal net and points equally spaced)

% INPUTS:
% eUlim(udim,2): element limits
% Degree(udim) desired degree
% Npa(udim): No. points to add


% 1.- No. control points and coordinates:

Np = zeros(udim,1);
xs = zeros(udim, max(Degree)+max(Npa));  % positions of sample points

for di = 1:1:udim
        
    Np(di) = Degree(di) + Npa(di);
    stp = (eUlim(di,2) - eUlim(di,1))/(Np(di)-1);

    acc = eUlim(di,1);
    for i = 1:1:Np(di)

        xs(di,i) = acc ;
        acc = acc + stp;

        if i==Np(di)-1
            acc = eUlim(di,2);
        end
    end
end

% used to returns also:
% 	NSE, seUlim, seIcp, Nicp
% but removed for simplicity

%{
% 2.- Subelements:

NSE =  Npa(1)*Npa(2); % No. sub-elements

seUlim = zeros(NSE,udim,2); % sub-element limits  

sest = [eDU(1)/Npa(1) ; eDU(2)/Npa(2)]; % sub-element step

if NSE==1
    
    seUlim(1,:,:) = eUlim(:,:);
    
else

    contaSE = 0 ;
    acc1 = eUlim(1,1);
    
    for i = 1:1:Npa(1)

        acc2 = eUlim(2,1);
        for j = 1:1:Npa(2)

            contaSE = contaSE+1;

            seUlim(contaSE,1,1) = acc1 ;
            seUlim(contaSE,1,2) = acc1+sest(1) ;

            if i==Npa(1)
                seUlim(contaSE,1,2) = eUlim(1,2);
            end

            seUlim(contaSE,2,1) = acc2 ;
            seUlim(contaSE,2,2) = acc2+sest(2) ;

            if j==Npa(2)
                seUlim(contaSE,2,2) = eUlim(2,2);
            end

            acc2 = acc2+sest(2);
        end

        acc1 = acc1+sest(1);
    end

end
 

% 3.- Sub-elements icp's:

seIcp = zeros(NSE,udim,max(Degree)+1); % points ref's of each sub-element in each direction
    
contaSE = 0 ;
for i = 1:1:Npa(1)
    for j = 1:1:Npa(2)
        
        contaSE = contaSE + 1 ;
        
        for a = 1:1:Degree(1)+1
            seIcp(contaSE,1,a) = i+a-1;
        end
        for b = 1:1:Degree(2)+1
            seIcp(contaSE,2,b) = j+b-1;
        end

    end
end
    
Nicp = [Degree(1)+1 ; Degree(2)+1];
%}

end

