function [ah] = ds3379_avgH (eUlim, eDU, sDegree, sNcp, sKnotV, sUsize, sP ,sw, xdim, udim)

% RETURNS:
% ah: root mean square (RMS) height of derivatives components for each element

ah = zeros(udim,xdim);
cnt = 0.5*[eUlim(1,2)+eUlim(1,1) , eUlim(2,2)+eUlim(2,1)]; % center element coordinates
    
ug = zeros(4,udim); % GAuss points locations:
    
ug(1,1) = cnt(1)-0.577*eDU(1)/2;
ug(1,2) = cnt(2)-0.577*eDU(2)/2;
    
ug(2,1) = cnt(1)-0.577*eDU(1)/2;
ug(2,2) = cnt(2)+0.577*eDU(2)/2;
    
ug(3,1) = cnt(1)+0.577*eDU(1)/2;
ug(3,2) = cnt(2)-0.577*eDU(2)/2;
    
ug(4,1) = cnt(1)+0.577*eDU(1)/2;
ug(4,2) = cnt(2)+0.577*eDU(2)/2;
    
%{
dSu = zeros(xdim,1);
dSv = zeros(xdim,1);
%}

% Gauss quadrature:

for g = 1:1:4
        
    [dSa] = b2701_BNURBS_deriv ...
    (sDegree, sNcp, sKnotV, sUsize, sP ,sw, [1 1], [ug(g,1) ug(g,2)], xdim, udim);

    udi = 1 ;
    for xdi=1:1:xdim
        ah(udi,xdi) = ah(udi,xdi)+ (dSa(2,1,1,xdi))^2;
    end

 	udi = 2 ;
    for xdi=1:1:xdim
        ah(udi,xdi) = ah(udi,xdi)+ (dSa(1,2,1,xdi))^2;
    end

    %{
    dSu(:,1) = dSa(2,1,1,:);
    dSv(:,1) = dSa(1,2,1,:);

    f1 = norm(dSu);
    f2 = norm(dSv);

    ah(1) = ah(1)+f1;
    ah(2) = ah(2)+f2;
    %}
end
    

% sqrt's:

for ud = 1:1:udim
for xd = 1:1:xdim
    ah(ud,xd) = ah(ud,xd)^0.5;
end
end



ah = 0.25*ah;

end

