function [Dspline] = ds3375_Dspline (sDegree, sNcp, sKnotV, sUsize, sP,sw, xdim, nd, tolD)

% RETURNS:
% Dspline: R-element-wise splines to approximate derivatives


plotRealg = 0; % ***
plotEstimg = 0 ; % ***

ust1 = 0.05 ; % ***
ust2 = 0.05 ; % ***



% 1.- DECLARES STRUCTURE AND SET OPTIONS:

fs = struct('dNcp',[], 'dDegree',[], 'dUsize',[], 'dKnotV',[], 'dEP',[], 'ULim', []);

Dspline = struct('NE',0,'ELim',[],'fs1',{fs},'fs2',{fs});

udim = 2 ;

% options for fitting
Degree = [2 2];             % ***
paramPos = 'as-points';     % ***
ktype = 'equally_spaced';   % ***
% ktype = 'averaged';       % ***
homCoord = 0 ;              % ***


% 2.- KNOT SPANS & No. ELEMENTS:

% extracts knot spans:
[nvU, nvUs] = GEN_18_UnonVoid (sKnotV, sUsize, sDegree, udim);
nvU = round(nvU,nd);

% No. elements:
NE = (nvUs(1)-1)*(nvUs(2)-1);

% allocates:
Dspline.NE = NE ;


% 3.- LOOPS ON EACH ELEMENT: fits Spline , add cp's until error < tolD

eUlim = zeros(udim,2);

contaE = 0 ;
for e1 = 1:1:nvUs(1)-1
for e2 = 1:1:nvUs(2)-1
    
    contaE = contaE + 1 ;
    
    % 3.1.- element limits:
    
    eUlim(1,1) = nvU(1,e1);   eUlim(1,2) = nvU(1,e1+1);
    eUlim(2,1) = nvU(2,e2);   eUlim(2,2) = nvU(2,e2+1);

    eDU(1) = eUlim(1,2) - eUlim(1,1); % element knot spans
    eDU(2) = eUlim(2,2) - eUlim(2,1);
    
    
   	% 3.2.- Computes average height of element for each function f=g,u & f=g,v
    
    [ah] = ds3379_avgH (eUlim, eDU, sDegree, sNcp, sKnotV, sUsize, sP ,sw, xdim, udim);


    % 3.3.- sets initial spline features (two splines for both functions):
    
    Npa1= [1;1];
    [Np1, xs1, NSE1, seUlim1, seIcp1, Nicp1] = ds3378_spFeat (eUlim, eDU, Degree, Npa1, udim);
    
    % 3.4.- Initial relative error computed with no sub-division:
    
    n = 3 ; % No. points to measure (by side)
    
    [Ierr] = ds3381_Ierr (eUlim, Nicp1, eDU, xs1, ...
	sDegree, sNcp, sKnotV, sUsize, sP ,sw, ah, xdim, udim, nd, n);


    % 3.5.- Recomputes Dx and Dy to control error below tolD:
    
    k = [ Ierr(1)/tolD ; Ierr(2)/tolD ];

	Dx = 0.72 * 0.5 * eDU(1) / k(1)^(1/3);  
	n = round(eDU(1)/Dx+0.3333,0); 
	Npa1 = [n-Degree(1); n-Degree(2)];
   
	Dy = 0.72 * 0.5 * eDU(2) / k(2)^(1/3);  
 	n = round(eDU(2)/Dy+0.3333,0); 
 	Npa2 = [n-Degree(1); n-Degree(2)];

    for di = 1:1:udim
        
        if Npa1(di)<1
            Npa1(di)=1;
        end
        if Npa2(di)<1
            Npa2(di)=1;
        end
        
    end
    
    
    % 3.6.- Slines features:
    
    [Np1, xs1, NSE1, seUlim1, seIcp1, Nicp1] = ds3378_spFeat (eUlim, eDU, Degree, Npa1, udim);
    [Np2, xs2, NSE2, seUlim2, seIcp2, Nicp2] = ds3378_spFeat (eUlim, eDU, Degree, Npa2, udim);
    
    
    
    %{
    % 3.4.- Inserts sample points until error < tolD for both functions:
    
   	fer = 1 ; % error flag
    while (fer==1)
        
        fer = 0 ;
        for se = 1:1:NSE1
            
            % relative error in this sub-element:
            
            [SEerr] = ds3380_SEerr (eUlim, se, Nicp1, seIcp1, seUlim1, eDU, xs1, ...
            sDegree, sNcp, sKnotV, sUsize, sP ,sw, ah, xdim, udim, nd, 1);

            if SEerr > tolD
                fer = 1 ;
                break
            end
        end 

        % add sample point in direction error > tolD
        if fer==1 
            Npa1(1) = Npa1(1)+1;
            Npa1(2) = Npa1(2)+1;
            [Np1, xs1, NSE1, seUlim1, seIcp1, Nicp1] = ds3378_spFeat (eUlim, eDU, Degree, Npa1, udim);
        end
    end
   
        
   	fer = 1 ; % error flag
    while (fer==1)
        
        fer = 0 ;
        for se = 1:1:NSE2
            
            % relative error in this sub-element:
            
            [SEerr] = ds3380_SEerr (eUlim, se, Nicp2, seIcp2, seUlim2, eDU, xs2, ...
            sDegree, sNcp, sKnotV, sUsize, sP ,sw, ah, xdim, udim, nd, 2);

            if SEerr > tolD
                fer = 1 ;
                break
            end
        end 

        % add sample point in direction error > tolD
        if fer==1 
            Npa2(1) = Npa2(1)+1;
            Npa2(2) = Npa2(2)+1;
            [Np2, xs2, NSE2, seUlim2, seIcp2, Nicp2] = ds3378_spFeat (eUlim, eDU, Degree, Npa2, udim);
        end
    end
    %}
    %{
    fer = 1 ; % error flag
    while (fer==1)
        
        fer = 0 ;
        for se = 1:1:NSE
            
            % relative error in this sub-element:
            [SEerr] = ds3380_SEerr (eUlim, se, Nicp, seIcp, seUlim, eDU, xs, ...
            sDegree, sNcp, sKnotV, sUsize, sP ,sw, ah, xdim, udim, nd);

            if SEerr(1)>tolD || SEerr(2)>tolD
                fer = 1 ;
                break
            end
        end 

        % add sample point in direction error > tolD
        if fer==1 
            
            Npa(1) = Npa(1)+1;
            Npa(2) = Npa(2)+1;
            [Np, xs, NSE, seUlim, seIcp, Nicp] = ds3378_spFeat (eUlim, eDU, Degree, Npa, udim);
            
        end
    end
    %}
    
    % 3.5.- Computes both surfaces: 

    [fs1] = ds3376_OneE (sDegree, sNcp, sKnotV, sUsize, sP, sw, Np1, Degree, xs1,eUlim, xdim, paramPos, ktype, homCoord, 1);
    [fs2] = ds3376_OneE (sDegree, sNcp, sKnotV, sUsize, sP, sw, Np2, Degree, xs2,eUlim, xdim, paramPos, ktype, homCoord, 2);
    
    % [fs1, fs2] = ds3376_OneE (sDegree, sNcp, sKnotV, sUsize, sP, sw, Np1, Degree, xs1, eUlim, xdim, paramPos, ktype, homCoord);
    
    
    % 3.6.- Allocates:

    Dspline.fs1(contaE,1) = fs1 ;
    Dspline.fs2(contaE,1) = fs2 ;

end 
end


% sets ELim and allocates:

ELim = zeros(NE,4);

contaE = 0 ;
for i = 1:1:nvUs(1)-1
    for j = 1:1:nvUs(2)-1
        
        contaE = contaE + 1 ;
        
        ELim(contaE,1) = round(nvU(1,i),nd);
      	ELim(contaE,2) = round(nvU(1,i+1),nd);
        
       	ELim(contaE,3) = round(nvU(2,j),nd);
      	ELim(contaE,4) = round(nvU(2,j+1),nd);
        
    end
end


Dspline.ELim = ELim;


% 4.- PLOTS:

if plotRealg==1 || plotEstimg==1

    dS1 = zeros(xdim,1);
    dS2 = zeros(xdim,1);

    if plotRealg==1
    
        % 4.1.- Real surfaces:

        conta1 = 0 ;
        for i = 0:ust1:nvU(1,nvUs(1))

            conta1 = conta1+1;

            conta2 = 0;
            for j =0:ust2:nvU(2,nvUs(2))

                conta2 = conta2+1;
                xr1(conta1,conta2,1) = i;
                xr1(conta1,conta2,2) = j;

                xr2(conta1,conta2,1) = i;
                xr2(conta1,conta2,2) = j;

                u = [i, j];

                [dS] = b2701_BNURBS_deriv (sDegree, sNcp, sKnotV, sUsize, sP,sw, [1 1], u, xdim,udim);

                dS1(:,1) = dS(2,1,1,:);
                xr1(conta1,conta2,3) = norm(dS1);

                dS2(:,1) = dS(1,2,1,:);
                xr2(conta1,conta2,3) = norm(dS2);

            end
        end

        pclr = 'b';
        for j = 1:1:size(xr1,2)

            figure(81)
            plot3(xr1(:,j,1),xr1(:,j,2),xr1(:,j,3),pclr); hold on

            figure(82)
            plot3(xr2(:,j,1),xr2(:,j,2),xr2(:,j,3),pclr); hold on
        end

        for i = 1:1:size(xr1,1)

            figure(81)
            plot3(xr1(i,:,1),xr1(i,:,2),xr1(i,:,3),pclr); hold on

            figure(82)
            plot3(xr2(i,:,1),xr2(i,:,2),xr2(i,:,3),pclr); hold on

        end

    end
    
    if plotEstimg==1
    
        % 4.2.- Approximated splines:

        for e = 1:1:NE

            xe1 = zeros(1,1,xdim);
            xe2 = zeros(1,1,xdim);

            eUlim = Dspline.fs1(e,1).ULim ;

            dKnotV1 = Dspline.fs1(e,1).dKnotV;
            dNcp1 = Dspline.fs1(e,1).dNcp;
            dDegree1 = Dspline.fs1(e,1).dDegree;
            dUsize1 = Dspline.fs1(e,1).dUsize;
            dEP1 = Dspline.fs1(e,1).dEP;

            dKnotV2 = Dspline.fs2(e,1).dKnotV;
            dNcp2 = Dspline.fs2(e,1).dNcp;
            dDegree2 = Dspline.fs2(e,1).dDegree;
            dUsize2 = Dspline.fs2(e,1).dUsize;
            dEP2 = Dspline.fs2(e,1).dEP;

            conta1 = 0;
            for i = eUlim(1,1):ust1:eUlim(1,2)

                conta1 = conta1 + 1 ;
                conta2 = 0;

                for j = eUlim(2,1):ust2:eUlim(2,2)

                    conta2 = conta2 + 1 ;
                    u = [i j];

                    [X] = b2603_Bspline_Xcoord ...
                    (u, dKnotV1, dNcp1, dDegree1, dUsize1, dEP1, udim,xdim);

                    xe1(conta1,conta2,1) = X(1) ;
                    xe1(conta1,conta2,2) = X(2) ;
                    xe1(conta1,conta2,3) = X(3) ;

                    [X] = b2603_Bspline_Xcoord ...
                    (u, dKnotV2, dNcp2, dDegree2, dUsize2, dEP2, udim,xdim);

                    xe2(conta1,conta2,1) = X(1) ;
                    xe2(conta1,conta2,2) = X(2) ;
                    xe2(conta1,conta2,3) = X(3) ;

                end
            end



            pclr = 'r';
            for j = 1:1:size(xe1,2)

                figure(81)
                plot3(xe1(:,j,1),xe1(:,j,2),xe1(:,j,3),pclr); hold on

                figure(82)
                plot3(xe2(:,j,1),xe2(:,j,2),xe2(:,j,3),pclr); hold on
            end

            for i = 1:1:size(xe1,1)

                figure(81)
                plot3(xe1(i,:,1),xe1(i,:,2),xe1(i,:,3),pclr); hold on

                figure(82)
                plot3(xe2(i,:,1),xe2(i,:,2),xe2(i,:,3),pclr); hold on

            end

        end

    end
end





end

