function [SEerr] = ds3380_SEerr (eUlim, se, Nicp, seIcp, seUlim, eDU, xs, ...
                sDegree, sNcp, sKnotV, sUsize, sP ,sw, ah, xdim, udim, nd, fr)

% RETURNS:
% SEerr(2): relatuve error of sub-element (selects maximum of the 4 corners)

% INPUTS:
% se: sub-element reference


% a.- maximum abs. value of products of Dx:
            
Dxs = zeros(udim,1) ;
for di = 1:1:udim
            
    dmax = 0 ;
    for sg = 1:1:Nicp(di)-1 % distance from each mid span to all nodes

        nr1 = seIcp(se,di,sg); % node ref.
        
        mxs = (xs(di,nr1) + xs(di,nr1+1))/2; % mid-span coord

        acc = 1 ;
        for i = 1:1:Nicp(di)

            nr2 = seIcp(se,di,i); % node ref.
            nodx = xs(di,nr2);
            acc = acc * abs(mxs-nodx);
 
        end

        if acc > dmax
        dmax = acc ;
        end
        
    end

    Dxs(di) = dmax ; % note that Dxs is already elevated !
end
      

      
% b.- computes errors using 3rd derivatives of f at 4 corners of
% sub-element; selects the max. value of errors for each element:

for i = 1:1:2
for j = 1:1:2
                
    % corner param. coord's
 	% ensures uc inside the element in case uc is at element limits:
                
 	uc = [seUlim(se,1,i) seUlim(se,2,j)]; 

	ftr = 0.001 ; % factor to multiply to eleemt span to add/deduct to uc 
    
   	for di = 1:1:udim
        
        if round(uc(di),nd) == round(eUlim(di,1),nd)
            uc(di) = uc(di) + ftr*eDU(di);
      	elseif round(uc(di),nd) == round(eUlim(di,2),nd)
            uc(di) = uc(di) - ftr*eDU(di);
        end
        
    end
                
	% derivatives at that point of original function
    
	[dSa] = b2701_BNURBS_deriv ...
 	(sDegree, sNcp, sKnotV, sUsize, sP ,sw, [4 4], uc, xdim, udim);
        

    % derivatives of f
	[~,~,~,df3] = ds3374_df3 (dSa, fr, xdim);

	% abs. error:
  	terr = abs( df3(1)*Dxs(1) + df3(2)*Dxs(2) + ...
  	3 * (df3(3)*max(Dxs) + df3(4)*min(Dxs)))/6;
                
  	% relative error:
  	terr = 100*terr/ah(fr);
            
  	% stores error:
 	if i==1 && j==1
        % first corner
    	SEerr = terr;
    else
        % other corners: stores if overcomes maximum stored so far
        if terr > SEerr
            SEerr = terr;
        end
	end

        
    %{
	% derivatives of f
	[~,~,~,df3] = ds3377_df3 (dSa, xdim);
                  
	% temporal error calculation and compare to max. stored (for both functions)
	for f = 1:1:2
                    
        % abs. error:
        terr(f) = abs( df3(f,1)*Dxs(1) + df3(f,2)*Dxs(2) + ...
      	3 * (df3(f,3)*max(Dxs) + df3(f,4)*min(Dxs)))/6;
                
        % relative error:
        terr(f) = 100*terr(f)/ah(f);
            
        % stores error:
        if i==1 && j==1
            % first corner
            SEerr(f) = terr(f);
        else
            % other corners: stores if overcomes maximum stored so far
            if terr(f) > SEerr(f)
                SEerr(f) = terr(f);
            end
        end
    end  
    %}
end
end

end

