function [dSu, dSv, dSn, NE, NN, conM, nUcoor, ULimE, edeR, NedeR, ETcon] = rs3382_FirstMesh ...
         (Degree,Ncp, KnotV, Usize, P,w, nvU, nvUsize, xdim,udim)

% RETURNS:

% dSn: derivatives in u,v directions up to order 3 for all nodes
% edeR(4, NedeR(4)): edge elem's references in each edge
% ETcon(): grid that relates elements refs and serves to detect T junctions
% to each element

% INPUTS:
% ust(2): param. space step in each direction
% Nst(2): No. steps in each direction


% 1.- SETS No. LIMITS IN PARAM. SPACE:

ULims = [ KnotV(1,1) KnotV(1,Usize(1))  ;  KnotV(2,1) KnotV(2,Usize(2))];


% 2.- ELEMS LIMITS and ETcon MATRIX:

Uends = nvU;
Nst(1) = nvUsize(1)-1;
Nst(2) = nvUsize(2)-1;

ETcon = zeros (Nst(1), Nst(2));

contaE = 0 ;
for i = 1:1:Nst(1)
for j = 1:1:Nst(2)
    contaE = contaE + 1;
    ETcon(i,j) = contaE ;
end
end




% 3.- DERIVATIVES OF NODES & COORD'S:

% 3.1.- No. els., No. nodes:

nnd = [Nst(1)+1 Nst(2)+1];
NE = Nst(1)*Nst(2);

NN = nnd(1) * nnd(2);

nUcoor = zeros(NN,udim);
dSu = zeros(NN,xdim);
dSv = zeros(NN,xdim);
dSn = zeros(NN,4,4,1,xdim);

% 3.2.- derivatives and nodes coordinates:

contaN = 0 ;

%u = ULims(1,1);
for i = 1:1:Nst(1)+1
    
    u = Uends(1,i);
    
    %v = ULims(2,1);
    for j = 1:1:Nst(2)+1

        contaN = contaN+1;

        v = Uends(2,j);
        
        nUcoor(contaN,1) = u ;
        nUcoor(contaN,2) = v ;

        [dS] = b2701_BNURBS_deriv (Degree, Ncp, KnotV, Usize, P,w, [3 3], [u v], xdim,udim);
    
        dSu(contaN,:) = dS(2,1,1,:);
        dSv(contaN,:) = dS(1,2,1,:);
        dSn(contaN,:,:,:,:) = dS(:,:,:,:);
        
        %v = Uends(2,j+1);
        %v = v + ust(2);
        if j == Nst(2)
            %v = ULims(2,2);
        end
    end
    
    
    %u = Uends(1,i+1);
  	%u = u + ust(1);
    if i == Nst(1)
        %u = ULims(1,2);
    end
    
end


% No. els., No. nodes and conM:

conM = zeros(NE,4);

contaE = 0 ;
for i =1:1:Nst(1)
for j =1:1:Nst(2)
    
    contaE = contaE+1;
    
    conM(contaE,1) = nnd(2)*(i-1) + j ;
    conM(contaE,2) = nnd(2)*(i-1) + j+1 ;
    conM(contaE,3) = nnd(2)*(i-1) + j   + nnd(2);
    conM(contaE,4) = nnd(2)*(i-1) + j+1 + nnd(2);
    
end  
end


% 4.- U limits of elements: ULime( lim11, lim12, lim21, lim22, elem. ref.):

ULimE = zeros(NE,5);


contaE = 0 ;
for i =1:1:Nst(1)
for j =1:1:Nst(2)
    
    contaE = contaE+1;
    
    ULimE(contaE,1) = Uends(1,i);
    ULimE(contaE,2) = Uends(1,i+1);
    ULimE(contaE,3) = Uends(2,j);
    ULimE(contaE,4) = Uends(2,j+1);
    ULimE(contaE,5) = contaE;
end  
end


% 5.- Edges elements references:
% dir-1: u=0 / dir-2: u=1 / dir-3: v=0 / dir-4: v=1

% {
edeR = zeros( 4, max(Nst) ); 
NedeR = zeros(4,1);

NedeR(1) = Nst(2);
NedeR(2) = Nst(2);

for i = 1:1:Nst(2)
    
    edeR(1,i) = i ;
    edeR(2,i) = Nst(2)*Nst(1) - Nst(2) + i ;
    
end

NedeR(3) = Nst(1);
NedeR(4) = Nst(1);

c = Nst(2);

for i = 1:1:Nst(1)
    
    edeR(3,i) = 1 + (i-1)*c;
    edeR(4,i) = c + (i-1)*c;

end
%}


end

