function [errEsd] = rs3383_ErrorEdsDiag (Degree, Ncp, KnotV, Usize, P,w, dSn, conM, nUcoor, eR)

% RETURNS:
% errEsd(6): errors in 4 edges and both diagonals for an element 'eR' in percentage
% w.r.t. estimated lengthn in each case

xdim = 3 ;
errEsd = zeros(1,6);


% 1.- COMPUTES ANGLES OF EACH ELEMENT: (stores in degr):

% nodes ref's. and angle of diagonal w.r.t. horizt. in param. space (given in degrees):

n1 = conM(eR,1);
n2 = conM(eR,2);
n3 = conM(eR,3);
n4 = conM(eR,4);

H = nUcoor(n3,1)-nUcoor(n1,1);
V = nUcoor(n4,2)-nUcoor(n3,2);

a = atan(V/H) * 180/3.14159;

degr = [ 90 ; 90 ; 0 ; 0 ; a ; -a ];
degrP = [0 ; 0 ; 90 ; 90 ]; % perp. angle for deriv. interp. error

% 2.- COMPUTES ERROR IN % IN EACH PATH:

nr = [ 1 2 ; 3 4 ; 1 3 ; 2 4 ; 1 4 ; 3 2 ]; % nodes ref's for each line


for s = 1:1:6
    
    % 2.0.- Computes data:
    
    % nodes ref's and angle:
    
    n1 = conM(eR,nr(s,1));
    n2 = conM(eR,nr(s,2));
    tita = degr(s) * 3.14159/180;
    

    % param. coordinates of ends:
    
    a = [nUcoor(n1,1)  nUcoor(n1,2)];
    b = [nUcoor(n2,1)  nUcoor(n2,2)];

    
    % function f and its derivatives f' and f'': 
    dSna = zeros(4,4,1,xdim);
    dSna(:,:,1,:) = dSn(n1,:,:,1,:);
    
	dSnb = zeros(4,4,1,xdim);
    dSnb(:,:,1,:) = dSn(n2,:,:,1,:);
    
    [f012a] = rs3390_f02tita (dSna, tita, xdim);
    [f012b] = rs3390_f02tita (dSnb, tita, xdim);
    
	fa = f012a(1) ; % extracts f and f'' at both nodes
    fb = f012b(1) ; 
  	fa2 = f012a(3) ; 
    fb2 = f012b(3) ;
    
    % Selects higher value of both f'' :
    
    f2 = max(abs(fa2),abs(fb2));
    
    
    % 2.1.- Error in length estimation:
    
    % estimates length in physical space:
    
    f_av = (fa + fb)/2 ;
    Du = norm(a-b) ;
    estL = Du * f_av;
    
    
    % estimates error in percentage:
    
    estE = 1/12*f2*Du^3;
    errEsd(s) = 100 * estE/estL ;

    
end




end

