function [udSu, udSv, udSn, uNE,uNN, uconM, unUcoor, uULimE, uedeR, uNedeR, uETcon] = rs3384_DivideRect...
        (Degree, Ncp, KnotV, Usize, P,w, eR, dSu,dSv, dSn, NE, NN, conM, nUcoor, ULimE, edeR, NedeR, ETcon, xdim,udim)


% RETURNS: updated net with element eR sub-divided


% 1.- PRELIMINARIES:


% original node reference (from element to divide 'eR'):
onr = zeros(4,1); 

for nod=1:1:4
	onr(nod) = conM(eR,nod);
end


% 7.- UPDATES ETcon:

% 7.1.- locates eR in ETcon:

nf = size(ETcon,1);
nc = size(ETcon,2);

fil = 0 ;
col = 0 ;
for i = 1:1:nf
for j = 1:1:nc
    if ETcon(i,j)==eR
       fil = i ;
       col = j ;
       break
    end
end
if fil>0
   break 
end
end



% 7.2.- inserts row below eR:

uETcon = ETcon;

if fil==nf 
    
    uETcon = [  ETcon(1:fil,1:nc) ;
                zeros(1,nc) ];
	nf = nf + 1;
            
else
    
    if ETcon(fil+1,col)>0
    
        uETcon = [  ETcon(1:fil,1:nc) ;
                    zeros(1,nc) ;
                    ETcon(fil+1:nf,1:nc)] ;
        nf = nf + 1;
    end
end


% 7.3.- inserts col at RHS of eR:

if col==nc
    
    uETcon = [ uETcon(1:nf,1:nc) , zeros(nf,1) ];
    
else
    
    if ETcon(fil,col+1)>0
        uETcon = [ uETcon(1:nf,1:col) , zeros(nf,1) , uETcon(1:nf,col+1:nc) ];
    end
end


% 7.4.- Add new elements to uETcon:

uETcon(fil,col+1) = NE+1;
uETcon(fil+1,col) = NE+2;
uETcon(fil+1,col+1) = NE+3;


% candidates elements to share T-nodes:

% LEFT:


for i = fil+1:1:nf
    
    
    
end


% 2.- UPDATED CONNECTIVITY MATRIX:

uconM = conM ;

uconM(eR,1) = onr(1);
uconM(eR,2) = NN + 1 ;
uconM(eR,3) = NN + 2 ;
uconM(eR,4) = NN + 3 ;

uconM(NE+1,1) = NN + 1;
uconM(NE+1,2) = onr(2);
uconM(NE+1,3) = NN + 3;
uconM(NE+1,4) = NN + 4;

uconM(NE+2,1) = NN + 2 ;
uconM(NE+2,2) = NN + 3 ;
uconM(NE+2,3) = onr(3) ;
uconM(NE+2,4) = NN + 5 ;

uconM(NE+3,1) = NN + 3 ;
uconM(NE+3,2) = NN + 4 ;
uconM(NE+3,3) = NN + 5 ;
uconM(NE+3,4) = onr(4) ;

% 1.1.- Updated no. elements and nodes:

uNE = NE + 3 ;
uNN = NN + 5 ;


% 3.- PARAM. COOR'S OF NEW NODES:

unUcoor = nUcoor;

for di = 1:1:udim
    
    unUcoor(NN+1,di) = (nUcoor(onr(1),di) + nUcoor(onr(2),di)) / 2 ;
    unUcoor(NN+2,di) = (nUcoor(onr(1),di) + nUcoor(onr(3),di)) / 2 ;
    
    unUcoor(NN+3,di) = (nUcoor(onr(1),di) + nUcoor(onr(4),di)) / 2 ;
    
    unUcoor(NN+4,di) = (nUcoor(onr(2),di) + nUcoor(onr(4),di)) / 2 ;
    unUcoor(NN+5,di) = (nUcoor(onr(3),di) + nUcoor(onr(4),di)) / 2 ;
    
end



% 4.- DERIVATIVES AT NEW NODES:

udSu =  [dSu ; zeros(3,xdim)] ;
udSv =  [dSv ; zeros(3,xdim)] ;
udSn = dSn ;

for nR = NN+1:1:uNN
    
    u = [unUcoor(nR,1)  unUcoor(nR,2)];
 	[dS] = b2701_BNURBS_deriv (Degree, Ncp, KnotV, Usize, P,w, [3 3], u, xdim,udim);
    
  	udSu(nR,:) = dS(2,1,1,:);
   	udSv(nR,:) = dS(1,2,1,:);
    udSn(nR,:,:,:,:) = dS(:,:,:,:);

end



% 5.- UPDATED LIMITS OF ELEMENTS:

% SPECIAL CASE there is single element:

if NE==1
    
    uULimE = [...
            0   0.5  0   0.5 1 ; ...
            0   0.5  0.5 1   2 ; ...
           	0.5 1    0   0.5 3 ; ...
            0.5 1    0.5 1   4 ];
end


% REST of the cases:

if NE>1

    % 5.1.- Copy all elements except eR:

    uULimE = zeros(NE-1,5);
    contaE = 0;

    for e = 1:1:NE
        if ULimE(e,5) ~= eR
            contaE = contaE + 1 ;
            for nod = 1:1:5
                uULimE(contaE,nod) = ULimE(e,nod);
            end
        end
    end


    % 5.2.- find element 'eR' row and extracts its limits and calculates mid-values:

    for r = 1:1:NE 
        if ULimE(r,5)==eR
            rR = r ;
            break
        end
    end

    erL = zeros(1,4); 
    for li = 1:1:4
        erL(li) = ULimE(rR,li);
    end

    % midL = round ( [ (erL(1)+erL(2))/2  (erL(3)+erL(4))/2 ], nd+3) ;
    midL = [ (erL(1)+erL(2))/2  (erL(3)+erL(4))/2 ] ;


    % 5.3.- new elements limits:

    e0L = [ erL(1) midL(1)  erL(3) midL(2)   eR ] ;
    e1L = [ erL(1) midL(1)  midL(2) erL(4)   NE+1 ] ;
    e2L = [ midL(1) erL(2)  erL(3) midL(2)   NE+2 ] ;
    e3L = [ midL(1) erL(2)  midL(2) erL(4)   NE+3 ] ;

    neL = [ e0L ; e1L ; e2L ; e3L ];


    % 5.6.- Inserts new values in uULimE:
    nne = 4 ;
    [uULimE] = rs3387_insertULimE (uULimE, NE-1, nne, neL);


end



% 6.- UPDATES EDGE ELEMENTS:

% 6.1.- edges where eR lies:

Ned = 0 ;
edR = zeros(4,2); % 'lado' ref. and position in 'lado'

for ladoR = 1:1:4
    
    for ladoPos = 1:1:NedeR(ladoR)
    if eR == edeR(ladoR,ladoPos)     
        Ned = Ned+1;
        edR(Ned,1) = ladoR;
        edR(Ned,2) = ladoPos;
        break  
    end
    end
end


% 6.2.- modifies edeR if necessary:

uedeR = edeR ;
uNedeR = NedeR ;

for i = 1:1:Ned
    
    ladoR   = edR(i,1);
    ladoPos = edR(i,2);
    [uNedeR, uedeR] = rs3389_insertEdgeE (uNedeR, uedeR, ladoR, ladoPos, NE);
    
end




end

