function [dg1, dg2, dg3] = rs3385_dS3tita (dS, tita, xdim)

% RETURNS:
% dg: derivative up to order n in direction tita (in rads) 

% INPUTS:
% dS:  derivatives with respect u and v, up to n order
% tita: is angle with rescpt horizontal in parameter space

dg1 = zeros(xdim,1); % one col per vector
dg2 = zeros(xdim,1);
dg3 = zeros(xdim,1);

c = cos(tita);
s = sin(tita);


for di=1:1:xdim
        
	dS10 = dS(2,1,1,di);
  	dS01 = dS(1,2,1,di);
        
 	dg1(di,1) = c * dS10 + s * dS01 ;
    
	dS20 = dS(3,1,1,di);
	dS02 = dS(1,3,1,di);
	dS11 = dS(2,2,1,di);
        
	dg2(di,1) = c^2 * dS20 + s^2 * dS02 + 2 * c*s * dS11 ;
    
    dS30 = dS(4,1,1,di);
    dS03 = dS(1,4,1,di);
    dS21 = dS(3,2,1,di);
    dS12 = dS(2,3,1,di);

    dg3(di,1) = c^3 * dS30 + s^3 * dS03 + 3 * c^2*s * dS21 + 3 * c*s^2 * dS12 ;
end


end

