function [H, ri, fF, eF] = rs3388_findUrange (u, row1, row2, uULimE, col)

% RETURNS:
% H(2): range where 'u' lies in
% ri: row where insert to, if is new value. Otherwise ri = 0 
% fF: 'first' flag = 1 if the position has to be the first, otherwise = 0
% eF: 'end' flag, same as fF but for the end of the sequence


H = zeros(2,1);
ri = 0 ;
fF = 0 ;
eF = 0 ;

% case compares with a single row:

if row1 == row2
    
    if u < uULimE(row1,col)
        
      	H(1) = 0;
        H(2) = 0;
        ri = row1-1;
        
      	if ri == 0
            fF = 1;
        end
        
        
    elseif u == uULimE(row1,col)
        
        H(1) = row1;
        H(2) = row2;
        ri = 0;
        
    elseif u > uULimE(row1,col)
        
    	H(1) = 0;
        H(2) = 0;
        ri = row1;
        
        if ri == size(uULimE,1)
            eF = 1 ;
        end
        
    end
    
    return
    
end



% case there is a range:


for c1 = row1:1:row2 % H(1): first pos. of range
if  u <= uULimE(c1,col)

        H(1) = c1 ;
        ur = uULimE(c1,col);

        if u < uULimE(c1,col)

            ri = c1-1;

            if ri==0
                fF = 1 ;
            end

            break

        else

            for c2 = c1:1:row2 % H(2): second pos. of range
            if ur < uULimE(c2,col)

                H(2) = c2-1 ;
            	break

            elseif c2 == row2

            	H(2) = c2 ;
                
            end
            end

        end

        break
end
end


% end case:

if uULimE(c1,col) < u
    
    if c1 == size(uULimE,1)
        
        eF = 1 ;
        
    else
        
        ri = c1 ;
        
    end
    
    
end
    
    



end

