function [f02] = rs3390_f02tita (dSna, tita, xdim)

% RETURNS:
% f012(3,1): value of f, f' and f'' at location a

% f is my function: f = norm(g')
% g is a vector function that depends on parameter u (directional derivative)

% INPUTS:
% dSna: surface main derivatives up to 3 for this node
% n: order of derivatives desired

% 1.- empty

% 2.- Computes tita-derivatives up to order n:
    
[dg1, dg2, dg3] = rs3385_dS3tita(dSna, tita,xdim); % 1 to 3rd direct. deriv at 'a'



% 3.- Computes value of function f:

f = norm(dg1); % f values at 'a'


% 4.- Computes f' and f'':

A = 0 ; % A and B coefficients
B = 0 ;

for di = 1:1:xdim
    A = A + dg1(di) * dg2(di);
    B = B + dg2(di) * dg2(di) + dg1(di) * dg3(di) ;
end


df1 = A / f ;
df2 = (B * f - A * df1) / f^2 ;


% 5.- Allocates:

f02 = [f; df1 ; df2];
    




end

