function [f0n] = rs3391_f0n (dSna, xdim, n)

% RETURNS:
% f0n(udim,n+1): value of f, f', f'' ... f n) at location a for both main directions

% n max at the moment is 3

% f is my function: f = norm(g')
% g is a vector function that depends on parameter u (directional derivative)

% INPUTS:
% dSna: surface main derivatives up to n for this node
% n: order of derivatives desired

f0n = zeros(2,n+1);

dgu = zeros(n+1,xdim);
dgv = zeros(n+1,xdim);


% stores derivatives:

for i = 1:1:n+1
    dgu(i,:) = dSna(i+1,1,1,:);
    dgv(i,:) = dSna(1,i+1,1,:);
end




% first value:

f0n(1,1) = norm(dgu(1,:));
f0n(2,1) = norm(dgv(1,:));


for i = 1:1:n
    
    if i==1

        Au = 0 ; 
        Av = 0 ;
        
        for di = 1:1:xdim
            Au = Au + dgu(1,di) * dgu(2,di);
            Av = Av + dgv(1,di) * dgv(2,di);
        end
        
        f0n(1,2) = Au / f0n(1,1);
        f0n(2,2) = Av / f0n(2,1);

    elseif i==2
        
    	Bu = 0 ; 
        Bv = 0 ;
        
        for di = 1:1:xdim
            Bu = Bu + dgu(2,di) * dgu(2,di) + dgu(1,di)* dgu(3,di);
            Bv = Bv + dgv(2,di) * dgv(2,di) + dgv(1,di)* dgv(3,di);
        end
        
        f0n(1,3) = (Bu - f0n(1,2)^2) / f0n(1,1);
        f0n(2,3) = (Bv - f0n(2,2)^2) / f0n(2,1);
        
    elseif i==3
        
     	Cu = 0 ; 
        Cv = 0 ;
        
        for di = 1:1:xdim
            Cu = Cu + 3 * dgu(2,di) * dgu(3,di) + dgu(1,di)* dgu(4,di);
            Cv = Cv + 3 * dgv(2,di) * dgv(3,di) + dgv(1,di)* dgv(4,di);
        end
        
        f0n(1,4) = (Cu - 3*f0n(1,2)*f0n(1,3)) / f0n(1,1);
        f0n(2,4) = (Cv - 3*f0n(2,2)*f0n(2,3)) / f0n(2,1);
    end

end

end

