function [uTVcon, uUv, uXv, uNE, uNN] = ts3392_UisoMesh (KnotV, Ncp,Degree,Usize, Ew,EB, Ust, xdim)

% RETURNS:
% mesh which is isotropic in parameter space

% INPUTS:
% surface NURBS features
% Ust:  step in parameter space for triangulation


udim = 2 ;

% 1.- GENERATES Ucoord's:

uUv = zeros(1,udim);

conta = 0 ;

for i = 0:Ust:1
    
    uUv(conta+1,1) = i;
    uUv(conta+1,2) = 0;
    
  	uUv(conta+2,1) = i;
    uUv(conta+2,2) = 1;

  	uUv(conta+3,1) = 1;
    uUv(conta+3,2) = i;
    
  	uUv(conta+4,1) = 0;
    uUv(conta+4,2) = i;
    
    conta = conta + 4 ;
    
end

uUv = sortrows(uUv,[1 2]);
[uUv , ~] = GEN_16_RemoveRepeatedRows (uUv, udim, 0.0001);


p1 = [Ust : Ust : 1-Ust ];
p2 = [Ust/2 : Ust : 1-Ust/2];

Nr = [size(p1,2) size(p2,2)];

pos = zeros(2,max(Nr));


for j=1:1:Nr(1)
pos(1,j) = p1(j);
end

for j=1:1:Nr(2)
pos(2,j) = p2(j);
end

ref = 1 ;
bacc = -1 ;
for i = Ust:Ust:1-Ust
   
    bacc = bacc*(-1);
    ref = ref + bacc ;

    for j = 1:1:Nr(ref)
        
        conta = conta + 1 ;
        uUv(conta,1) = i ;
        uUv(conta,2) = pos(ref,j) ;
    end

end

[uUv , ~] = GEN_16_RemoveRepeatedRows (uUv, udim, 0.0001);


% 2.- TRIANGULATES: and No. elements and vertexes

DT = delaunayTriangulation(uUv);
uTVcon = DT.ConnectivityList ;

uNE   = size(uTVcon,1);
uNN   = size(uUv,1);


% 3.- COMPUTES PHYSICAL COORDINATS:

uXv = zeros(uNN,xdim);
u = zeros(1,udim);

for po = 1:1:uNN
    
    u(:) = uUv(po,:);
	x = b2601_BNURBS_Xcoord ( u, KnotV, Ncp,Degree,Usize, Ew,EB, udim,xdim);
 	uXv(po,:) = x(:);
    
end


end

