function [ ] = ts3394_plotKnSp (frKS, stKS, KnotV, Ncp,Degree,Usize, Ew,EB,xdim)

% RETURNS:
% plots surface contour lines and knot spans

% INPUTS:
% frKS: figure reference
% stKS: parameter space step for advancing in contour representation
% NURBS sufaces features


udim = 2 ;

if frKS > 0

    figure(frKS)

    % 1.1.- Plots cp's:
    
    for i = 1:1:Ncp(2)
    plot3 (EB(:,i,1), EB(:,i,2), EB(:,i,3),'--r'); hold on 
    end

    for i = 1:1:Ncp(1)
    plot3 (EB(i,:,1), EB(i,:,2), EB(i,:,3),'--r','marker','o'); hold on 
    end


    % 1.2.- Plots knot span contours:

    [uv, nvUsize] = GEN_18_UnonVoid (KnotV, Usize, Degree, udim);

    for u = 1:1:nvUsize(1)

        conta = 0 ;
        cx = zeros(1,xdim);
        for v = 0:stKS:1

            conta = conta + 1 ;
            x = b2601_BNURBS_Xcoord ([uv(1,u) v], KnotV, Ncp,Degree,Usize, Ew,EB, udim,xdim);
            cx(conta,:) = x(:);

        end 

        plot3(cx(:,1), cx(:,2), cx(:,3),'k'); hold on

    end


    for v = 1:1:nvUsize(2)

        conta = 0 ;
        cx = zeros(1,xdim);
        for u = 0:stKS:1

            conta = conta + 1 ;
            x = b2601_BNURBS_Xcoord ([u uv(2,v)], KnotV, Ncp,Degree,Usize, Ew,EB, udim,xdim);
            cx(conta,:) = x(:);

        end 

        plot3(cx(:,1), cx(:,2), cx(:,3),'k'); hold on

    end

    axis equal

end

end

