function [angl, vale, area] = ts3395_AVA ...
    (angl, vale, area, NE, Xv, TVcon, NV)

% RETURNS:
% angl(NT*3,1): angles values (rads)
% vale(NV,1):   vertexes valences
% area(NT,1):   vertexes valences

xdim = 3 ;
NEp = size(area,1);
if NEp == 1
   NEp = 0 ; 
end

% 1.- ANGLES & AREAS:

vrc = [3 1 2 ; 1 2 3 ; 2 3 1] ; % vertex local refs for each corner

ba = zeros(xdim,1); % vector from corner to a and to c
bc = zeros(xdim,1);

contaC = NEp ;
j = 0 ;

v1 = zeros(xdim,1);
v2 = zeros(xdim,1);

for e = NEp+1:1:NEp+NE
    
    j = j+1;
    
    % 1.1.- computes area:
    
    va = TVcon(j,1);
  	vb = TVcon(j,2);
  	vc = TVcon(j,3);
    v1(:,1) = Xv(vb,:)-Xv(va,:);
    v2(:,1) = Xv(vc,:)-Xv(va,:);
    
    area(e,1) = abs(norm(cross(v1,v2))/2);
    
    
    % 1.2.- computes angles:
    
    for cor = 1:1:3
        
        contaC = contaC + 1 ;
        
        % vertexes local refs in rMcon invoved, b is at the corner
        a = vrc(cor,1);
        b = vrc(cor,2);
        c = vrc(cor,3);
        
        va = TVcon(j,a);
        vb = TVcon(j,b);
        vc = TVcon(j,c);
        
        ba(:,1) = Xv(va,:)-Xv(vb,:);
        bc(:,1) = Xv(vc,:)-Xv(vb,:);
        
        a = go2511_angleUV (ba, bc);
        
        angl(contaC,1) = a ;
    end
    
end


% 2.- VALENCES:

if size(vale,1)==1
    NNp = 0 ;
    vale = zeros(NV,1);
else
    NNp = size(vale,1) ;
    vale = [vale ; zeros(NV,1)];
end

for j = 1:1:NE
    for v = 1:1:3
        vr = NNp + TVcon(j,v);
        vale(vr) = vale(vr) + 1 ;
    end   
end







end

