function [] = ts3396_plotQITmesh (frXvOLD, frdSm, fr6, frCT, frUv, frXv, frdSm3D, ...
                cXv, sXv, dSmesh, sUvt, coF, cnR, NCT, ewsON, Xv, Uv, TVcon, NE)

%{          
mnUcoor = dSmesh.mnUcoor ;
mNE   = dSmesh.mNE;
mconM = dSmesh.mconM;
%}

al = 0.67; % greys colours


% 1.- PHYSICAL SPACE:

if frXvOLD > 0
    
    figure(frXvOLD)

    CLxaccExt = [ cXv ; cXv(1,:)];
    plot3(CLxaccExt(:,1), CLxaccExt(:,2), CLxaccExt(:,3), 'k'); hold on
    scatter3(sXv(:,1), sXv(:,2), sXv(:,3), 'k'); hold on

    if ewsON == 1
        
    	bscN = dSmesh.mbscN;
        bscXcoor = dSmesh.mbscXcoor;
        
        for ed = 1:1:4
        for po = 1:1:size(bscXcoor,2)-1
            
            if (bscXcoor(ed,po,1)==0 && bscXcoor(ed,po,2)==0 && bscXcoor(ed,po,3)==0) ...
        	|| (bscXcoor(ed,po+1,1)==0 && bscXcoor(ed,po+1,2)==0 && bscXcoor(ed,po+1,3)==0) 
        
            else
                
                x = [bscXcoor(ed,po,1), bscXcoor(ed,po+1,1)];
                y = [bscXcoor(ed,po,2), bscXcoor(ed,po+1,2)];
                z = [bscXcoor(ed,po,3), bscXcoor(ed,po+1,3)]; 
        
                al = 0.67;
                plot3(x,y,z,'Color',[0 0 0]+al); hold on
            end
        end
        end
        
    end
    axis equal
end


% 2.- dS-mesh IN PARAMETER SPACE:

if frdSm > 0

    mnUcoor = dSmesh.mnUcoor ;
    mNE   = dSmesh.mNE;
    mconM = dSmesh.mconM;
    
    figure (frdSm)

    for e = 1:1:mNE

        x = [   mnUcoor(mconM(e,1),1)  mnUcoor(mconM(e,2),1)  mnUcoor(mconM(e,4),1)  ...
                mnUcoor(mconM(e,3),1)  mnUcoor(mconM(e,1),1) ];

        y = [   mnUcoor(mconM(e,1),2)  mnUcoor(mconM(e,2),2)  mnUcoor(mconM(e,4),2)  ...
                mnUcoor(mconM(e,3),2)  mnUcoor(mconM(e,1),2) ];

        xm = (mnUcoor(mconM(e,1),1) +  mnUcoor(mconM(e,4),1)) / 2 ;
        ym = (mnUcoor(mconM(e,1),2) +  mnUcoor(mconM(e,4),2)) / 2 ;

        if e <=mNE
            al=1;
        else
            al = 1;
        end

        text(xm,ym, num2str(e));
        plot(x,y,'Color',[0 0 0]+al); hold on
    end

    axis equal
end


% 3.- ALL VERTEXES IN PARAMETER SPACE, ALSO DERIVATIVES FIELD:


if fr6 > 0

    mnUcoor = dSmesh.mnUcoor ;
    mNE   = dSmesh.mNE;
    mconM = dSmesh.mconM;
    
    al = 0.5 ;
    
    figure(fr6)

    for e = 1:1:mNE

        x = [   mnUcoor(mconM(e,1),1)  mnUcoor(mconM(e,2),1)  mnUcoor(mconM(e,4),1)  ...
                mnUcoor(mconM(e,3),1)  mnUcoor(mconM(e,1),1) ];

        y = [   mnUcoor(mconM(e,1),2)  mnUcoor(mconM(e,2),2)  mnUcoor(mconM(e,4),2)  ...
                mnUcoor(mconM(e,3),2)  mnUcoor(mconM(e,1),2) ];

        plot(x,y,'Color',[0 0 0]+al); hold on
    end

    NoUt = size(sUvt,1);

    for po = 1:1:NoUt

        if coF(po)==1  
            %scatter(sUvt(po,1), sUvt(po,2),'k');  hold on
        end

    end
    axis equal

    %{
    % initial knot spans
    for i = 0:0.25:0.75
       
        for j=0:0.5:1
            
            x = [i i+0.25];
            y = [j j];
            plot(x,y,'Color','b', 'LineWidth',2.5); hold on
        end
        
    end
    
    for i = 0:0.25:1
       
        for j=0:0.5:0.5
            
            x = [i i];
            y = [j j+0.5];
            plot(x,y,'Color','b', 'LineWidth',2.5); hold on
        end
        
    end
    %}
    
end


% 4.- CONTOURS IN PARAMETER SPACE:

if frCT > 0

    figure(frCT)

    i = 1 ;
    for ct = 1:1:NCT

        for po = 1:1:(6*ct-1)
        i = i+1;
        if coF(i)==1 && coF(i+1)==1

            p1 = cnR(ct,po);
            p2 = cnR(ct,po+1);

            x = [ sUvt(p1,1) , sUvt(p2,1) ];
            y = [ sUvt(p1,2) , sUvt(p2,2) ];
            plot( x, y, '-k'); hold on

        end
        end

        i = i+1 ;

        % last segment:
        if coF(i)==1 && coF(cnR(ct,1))==1

            p1 = cnR(ct,6*ct);
            p2 = cnR(ct,1);

            x = [ sUvt(p1,1) , sUvt(p2,1) ];
            y = [ sUvt(p1,2) , sUvt(p2,2) ];
            plot( x, y, '-k'); hold on

        end
    end

    x = [ 0 1 1 0 0 ];
    y = [ 0 0 1 1 0 ];
    plot(x,y,'Color',[0 0 0]+al); hold on
    axis equal

end


% 5.- MESH IN U-space and X-space:

if frUv > 0 || frXv > 0
    
    X = zeros(3,NE);
    Y = zeros(3,NE);
    Z = zeros(3,NE);
    C = zeros(3,NE);

    Xu = zeros(3,NE);
    Yu = zeros(3,NE);
    Zu = zeros(3,NE);

    for fil = 1:1:3

        for e = 1:1:NE

            nR = TVcon(e,fil);

            X(fil,e) = Xv(nR,1);
            Y(fil,e) = Xv(nR,2);
            Z(fil,e) = Xv(nR,3);
            C(fil,e) = 0 ;

            Xu(fil,e) = Uv(nR,1);
            Yu(fil,e) = Uv(nR,2);

        end
    end

    if frUv > 0

        figure(frUv)
        fill3(Xu,Yu,Zu,C); hold on
        axis equal

    end

    if frXv > 0

        figure(frXv)
        fill3(X,Y,Z,C); hold on
        axis equal
        
        
        % elems refs:
        for e = 1:1:NE
            
            n1 = TVcon(e,1);
            n2 = TVcon(e,2);
            n3 = TVcon(e,3);
            
            x = (Xv(n1,1) + Xv(n2,1) + Xv(n3,1))/3;
            y = (Xv(n1,2) + Xv(n2,2) + Xv(n3,2))/3;
            z = (Xv(n1,3) + Xv(n2,3) + Xv(n3,3))/3;
            
            % text(x,y,z,num2str(e)); hold on
        end
        
        
        % vtx refs:
        for n  =1:1: size(Xv,1)
            
            x = Xv(n,1);
            y = Xv(n,2);
            z = Xv(n,3);
            
            % text(x,y,z,num2str(n)); hold on
        end

        
    end

end


%{
TVcon(22,:)
TVcon(72,:)
TVcon(91,:)

Xv(1,:)
Xv(49,:)
Xv(50,:)
Xv(143,:)
%}


% 6.- DERIVATIVES FIELD in 3D WITH VALUES:

if frdSm3D > 0
      
    mnUcoor = dSmesh.mnUcoor ;
    mNE   = dSmesh.mNE;
    mconM = dSmesh.mconM;
    
    figure(frdSm3D);
    
    % PARTIAL INPUTS FOR THIS PLOT:
    
    wd = 0.2; % width of perimeter to represent
    
    sc = 1/ 500 ; % scale
    
    dSs = dSmesh.mdSu; % *** SELECTED HERE WHICH
    
    
    mNEt   = dSmesh.mNEt;
    mfpeR   = dSmesh.mfpeR;
    mfceR   = dSmesh.mfceR;
	mconMp = dSmesh.mconMp;
    mconMc = dSmesh.mconMc;
    mvEgr = dSmesh.mvEgr;
    
    % base contour:
    
    x = [0 0 1 1 0];
    y = [0 1 1 0 0];
    z = [0 0 0 0 0];
    
    plot3(0,0,0,'k'); hold on
    
    % plot3(x,y,z,'k'); hold on
    
    
    % internal elements:
    
    for e = 1:1:mNE
        
    	x = zeros(5,1);
        y = zeros(5,1);
        z = zeros(5,1);
        
        dS = zeros(3,1);
        
        i = [1 2 4 3];
        
        for n = 1:1:4
            
            nR = mconM(e,i(n));
            dS = dSs(nR,:);

            x(n,1) = mnUcoor(nR,1);
            y(n,1) = mnUcoor(nR,2);
            z(n,1) = norm(dS)*sc;
        end
        
        x(5,1) = x(1,1); y(5,1) = y(1,1); z(5,1) = z(1,1);
        
        
        plot3(x,y,z,'r'); hold on
        
    end
    
    
    % perimeter elements:
    
    for e = mfpeR:1:mfceR-1
        
        effeR = e-mfpeR+1;
        
     	x = zeros(5,1);
        y = zeros(5,1);
        z = zeros(5,1);
        
        dS = zeros(3,1);
        
        for n = 1:1:2
            
          	nR = mconMp(effeR,n);
            dS = dSs(nR,:);

            x(n,1) = mnUcoor(nR,1);
            y(n,1) = mnUcoor(nR,2);
            z(n,1) = norm(dS)*sc;
        end
        
       	x(3,1) = x(2,1);  y(3,1) = y(2,1);  z(3,1) = z(2,1);        	
        x(4,1) = x(1,1);  y(4,1) = y(1,1);  z(4,1) = z(1,1);
        x(5,1) = x(1,1);  y(5,1) = y(1,1);  z(5,1) = z(1,1);
        
        if mvEgr(effeR)==1
            x(3) = x(3)-wd;
            x(4) = x(4)-wd;
        elseif mvEgr(effeR)==2
         	x(3) = x(3)+wd;
            x(4) = x(4)+wd;
        elseif mvEgr(effeR)==3
            y(3) = y(3)-wd;
            y(4) = y(4)-wd;
    	elseif mvEgr(effeR)==4
            y(3) = y(3)+wd;
            y(4) = y(4)+wd;
        end
        
        plot3(x,y,z,'b'); hold on
        
    end
    
    
    % corner elements:
    
    for e = 1:1:4
        
    	x = zeros(5,1);
        y = zeros(5,1);
        z = zeros(5,1);
        
        nR = mconMc(e);
        dS = zeros(3,1);
        dS = dSs(nR,:);

        x(1,1) = mnUcoor(nR,1);
      	y(1,1) = mnUcoor(nR,2);

        for i = 1:1:5
            z(i) = norm(dS)*sc;
        end
        
        if e==1
            x(2) = x(1)-wd;  y(2) = y(1);  
            x(3) = x(1)-wd;  y(3) = y(1)-wd;          	
            x(4) = x(1);  y(4) = y(1)-wd;  
            x(5) = x(1);  y(5) = y(1); 
        elseif e==2
         	x(2) = x(1)-wd;  y(2) = y(1);  
            x(3) = x(1)-wd;  y(3) = y(1)+wd;          	
            x(4) = x(1);  y(4) = y(1)+wd;  
            x(5) = x(1);  y(5) = y(1); 
      	elseif e==3
             x(2) = x(1)+wd;  y(2) = y(1);  
            x(3) = x(1)+wd;  y(3) = y(1)-wd;          	
            x(4) = x(1);  y(4) = y(1)-wd;  
            x(5) = x(1);  y(5) = y(1); 
      	elseif e==4
            x(2) = x(1)+wd;  y(2) = y(1);  
            x(3) = x(1)+wd;  y(3) = y(1)+wd;          	
            x(4) = x(1);  y(4) = y(1)+wd;  
            x(5) = x(1);  y(5) = y(1); 
        end
        
        plot3(x,y,z,'b'); hold on 
    end
    
    axis equal ;
    
end

end

