function [Fangl, Farea, Fvale] = ts3397_plotAVA ...
    (angl, area, vale, Da, a1, a2, Ds, s1, s2, Nmv, fAng, fVal, fAre, clor, xoff)

% INPUTS:
% clor: color
% xoff: offset w.r.t. cetnral position, in percentage.

% frecuencies are in percentage
% Fangl(): frecuencies of angles in Da intervals between a1 and a2
% Fvale(): frecuencies of valences from 1 to Nmv
% Farea(): frequencies of triangles area

La = a2-a1;             % total angles span
Nai = round(La/Da,0)+1; % No. angles intervals

Ls = s2-s1;             % total areas span
Nsi = round(Ls/Ds,0)+1; % No. areas intervals

NE = size(area,1);      % No. triangles


% 1.- COMPUTES FREQUENCIES:

% Angles:
Fangl = zeros(Nai,1);
Ncor = size(angl,1);
for cor = 1:1:Ncor
    
    av = angl(cor);
    acc = a1;

    for i = 1:1:Nai
        if acc<= av && av <acc+Da
            Fangl(i) = Fangl(i)+1;
            break
        end
        acc = acc + Da;
    end
end

for i = 1:1:Nai
    Fangl(i) = Fangl(i) * 100 / (NE*3) ; % precentage
end




% Areas:
Farea = zeros(Nsi,1);
for e = 1:1:NE
    
    s = area(e);
    acc = s1;

    for i = 1:1:Nsi
        if acc<= s && s <acc+Ds
            Farea(i) = Farea(i)+1;
            break
        end
        acc = acc + Ds;
    end
end

for i = 1:1:Nsi
    Farea(i) = Farea(i) * 100 / (NE) ; % precentage
end



% Valences:

NV = size(vale,1) ;
Fvale = zeros(Nmv,1);

for v = 1:1:NV
    Fvale(vale(v)) = Fvale(vale(v))+1;
end

for i = 1:1:Nmv
    Fvale(i) = Fvale(i) * 100 / NV ; % precentage
end




% 2.- PRINTING:

LW = 6 ; % line width

if fAng > 0  % ANGLES frequ.
    
    Dag = Da * 180 / 3.14159 ; % in degrees
    
    figure(fAng);
    acc = a1 * 180 / 3.14159 + Dag/2 ;
    for a = 1:1:Nai
        plot( [acc+Dag*xoff/100  acc+Dag*xoff/100 ] ,  [0 Fangl(a)], clor, 'LineWidth',LW) ; hold on
        acc = acc + Dag ;
    end
    
end




if fVal > 0 % VALENCES frequ.
    
    figure(fVal);
    for v = 1:1:Nmv
        plot( [v+xoff/100  v+xoff/100] ,  [0 Fvale(v)], clor, 'LineWidth',LW) ; hold on
    end
    
end


if fAre > 0 % AREAS frequ.
    
    figure(fAre);
    acc = s1;
    for s = 1:1:Nsi
        plot( [acc+Ds*xoff/100  acc+Ds*xoff/100 ] ,  [0 Farea(s)], clor, 'LineWidth',LW) ; hold on
        acc = acc + Ds ;
    end
    
end




end

