function [Bangl, Barea, Bvale] = ts3398_BITmesh (Bangl, Barea, Bvale,At, ta,sa)


% RETURNS:
% Frecuencies of BIT correspondant mesh to any triangulation (AT)


% INPUTS:
% t: total No. triangles of AT
% s: total No. conotur segments of AT

% 1.- COMPUTES No. ROWS AND COLS OF BIT:

s1 = sa/4;
s2 = (sa^2/16 - ta/2)^0.5 ;

rb = round(s1 + s2,0) ;
cb = round(s1 - s2,0) ;

tb = 2*rb*cb ;  % No. triangles of BIT
Ncor = 3 * tb ; % No. corners
Nv = (rb+1)*(cb+1);


% 2.- SETS FIRST ROW TO FILL:

if size(Bvale,1)==1
    i1 = 0 ;
else
    i1 = size(Bvale,1) ;
end



% 3.- COMPUTES AND ALLOCATES PARAMETERS:

Bangl = [Bangl ; ones(Ncor,1)*60*3.14159/180];
Barea = [Barea ; ones(tb,1)*At ] ;

Bvale(i1+1,1) = 1 ;
Bvale(i1+2,1) = 1 ;
Bvale(i1+3,1) = 2 ;
Bvale(i1+4,1) = 2 ;

for i = (i1+5) : 1 : (i1+4+(2*(cb-1+rb-1)))
    Bvale(i,1) = 3 ;
end

for j = (i+1) : 1 : (i1+Nv)
    Bvale(j,1) = 6 ;
end



end

