function [gv, Egv, gvd] = bf3402_GrevnD (KnotV, Degree, Ncp, udim)

% RETURNS:
% gv(Ncptotal, udim): greville points coordinates
% Egv(Ncp,Ncp,Ncp,udim): grp extended
% gvd(udim,Ncp): coordinates separtes by directions

% works for any No. udim

% 0.- Preliminary operations:

% total No. control points:
aNcp = 1 ;
for di=1:1:udim
    aNcp = aNcp * (Ncp(di));
end

% extend Ncp to eNcp:
Ngd = ones(udim,1) ;

for di=1:1:udim
   Ngd(di) = Ncp(di); 
end



% 2.- Computes gv points in each direction:

gvd = zeros(3, max(Ncp));

for di = 1:1:udim
    
    % knot vector:
    
    Usize = Degree(di)+Ncp(di)+1;
    U = zeros(Usize,1);
    for i=1:1:Usize
        U(i,1) = KnotV(di,i);
    end
   
    % Greville points:
    
    [g] = bf3401_Grev1D (U,Ncp(di),Degree(di));
    for i = 1:1:Ncp(di)
        gvd(di,i) = g(i);
    end
    
end


% 3.- Assemblies responses:

[gv, Egv] = bf3405_asseblyGv (Ngd, gvd, udim);



end

