function [xh] = bf3404_homCoor (x, n, xdim)

% RETURNS:
% xh(n,xdim): coordinates x but homogenaized (with same total increment in
% each direction)

% INPUTS:
% x(n,xdim): points coordinates
% n: No. points
% xdim: No. dimensions of points


xh = zeros(n,xdim);


% 1.- TOTAL INCREMENTS IN EACH DIRECTION & minimum:

Dx = zeros(xdim,1);

for di=1:1:xdim
    
    xd = zeros(n,1);
    xd(:,1) = x(:,di);
    Dx(di,1) = max(xd) - min(xd);
end


Dxmin = min(Dx);


% 2.- SCALEs IN EACH DIRECTION:

for di = 1:1:xdim
    
    f = Dxmin/Dx(di);
    
    for i = 1:1:n 
        xh(i,di) = x(i,di)*f;
    end
end


end

