function [upp] = bf3407_paramPos (n, xf, u0, u1, paramPos)

% RETURNS:
% upp(n,1): parameters positions correspondant to the n points to fit

% INPUTS:
% n: No. points to fit
% xf(n.xdim): points coordinates
% u0, u1: knot span limits

upp = zeros(n,1);

if strcmp(paramPos,'equally_spaced')==1

    acc = u0;
    st = (u1-u0)/(n-1);
    
    for i = 1:1:n
        
        if i==n
            acc = u1 ;
        end
        
        upp(i,1) = acc ;
        acc = acc+st;
    end
    
elseif strcmp(paramPos,'chord_length')==1
    
    d = 0 ; % total chord length
    
    for i = 2:1:n
        d = d + norm(xf(i-1,:)-xf(i,:));
    end
    
   upp(1,1) = u0;
   
   for i = 2:1:n-1
       upp(i,1) = upp(i-1,1) + norm(xf(i,:)-xf(i-1,:))/d;
   end
    
   upp(n,1) = u1 ;
    
elseif strcmp(paramPos,'centripetal')==1
    
	d = 0 ; 
    
    for i = 2:1:n
        d = d + (norm(xf(i-1,:)-xf(i,:)))^0.5;
    end
    
    
	upp(1,1) = u0;

    for i = 2:1:n-1
        upp(i,1) = upp(i-1,1) + (norm(xf(i,:)-xf(i-1,:)))^0.5/d;
    end

	upp(n,1) = u1 ;
    
end

end

