function [U] = bf3408_knotV (n,p, u0, u1, ktype, uxd)

% RETURNS:
% U: knot vector constructed for fitting one curve

if strcmp(ktype,'equally_spaced')==1

    U = go2552_equalspacedKV (n,p, u0,u1);

    U = U';
    
elseif strcmp(ktype,'averaged')==1
    
    m = n+p+1;
    
    U = zeros(1,m);
    
    % initial
    for i = 1:1:p+1
        U(1,i) = u0;
    end
    
    % intermediates:
    for j = 1:1:n-p
    
        acc = 0;
        for i = j:1:j+p-1
            acc = acc + uxd(i+1);
        end
        U(1,p+1+j) = acc/p ;
    end
    
    % final:
    for i = m-p:1:m
        U(1,i) = u1; 
    end
end


end

