function [MLT, THC, pNE, connT, tp, teR2] = tn3600_EdgeSplit ...
    (contaL,  teR1, isi, ILn, mLR, THC, connS, connT, Spatches, pR, rTskin, agCurv, MLT, Xtol, DUtol, tolP, pL)

tp = "0";

pNE = size(connT.EV,1);
teR2 = teR1 ;

Nsi = size(isi,1);  % No. sides intersected

pudim = 3 ;

nd = 6 ;

meR = 0 ;

% 1.- CHECKS IF SPLIT EDGE CONDITIONS ARE MET:
% a: node to insert is within one of the affected tets
% b: node to insert is sufficiently far from the other facets (not with the closest line) of the tet.


% both conditions are given implicitly by meR, if meR=0 are not fullfilled

pLt = 33 ; % percentaje of common line length to compute threshold distance


% 1.1.- More than one side:

if Nsi > 1

    % Extracts intersection lines between sides (in advancing order of sides)

    [ILS] = tn3601_isiIntLines (isi, ILn, THC, connS);

    % Find the location of MLT missing line closer to FIRST or LAST intersection line:
    % eTHC and icR refers to the tet line that is closest to the projected MLT point
    % Only considers them if they are closer than threshold distance to intersectio line

    [Ncp, eTHC, icR, idis] = tn3602_cuILS ...
    (contaL, ILS, ILn, THC, connT, Spatches, pR, rTskin, agCurv, MLT, pLt, Xtol, DUtol, tolP);

    if Ncp == 0
        return % only carries on if finds close proj'd points to their intersection line
    end

    % Checks if IN condition is met: 
    % - Acp belongs to any of the tets that surround the ILS line AND
    % - the distance the opposite faces is more than a threshold
    % (Checks for Acp1 and Acp2 and chooses one)

    [eTHCi, ilR, meR] = tn3605_INlineTet (eTHC, icR, connT, connS, THC, pL);


elseif Nsi == 1
    
    sr = isi(1,1).R; % common side reference

    A1 = MLT.tAv(ILn(1,2),:)';
    A2 = MLT.tAv(ILn(2,2),:)';
    u = A2 - A1;

    [lm] = tn3607_SiLvsMLR (connS, connT, THC, sr, A1, u); % side lines info w.r.t. missing line

    lR = lm(1,1);
    
    B1 = THC.Av(connT.LV(lR,1),:)';
    B2 = THC.Av(connT.LV(lR,2),:)';

    Ac = go2549_cPr2r ((A1+A2)/2, 0,0, 0,0, A1,A2, B1,B2, tolP);


    % Finds projectd point:

    L = norm(A2-A1); % interpolation values
    L1 = norm(Ac-A1);
    L2 = norm(Ac-A2);

    N = [L2/L L1/L];

	if contaL == 10

        fr = 10 ;
        figure(fr)
        for e = 1:1:size(teR1,1)
            eR = teR1(e,1);
            pt1373_pTetConn (eR, connT, THC.Av, fr, 'k', 1, 1, 0, 0);
        end

        [rv, rP1, rP2] = ts1602_mLAspace (ILn, THC.Av, 1, fr, 'r', 2.0, 1.0);
        scatter3(Ac(1),Ac(2),Ac(3),'r'); hold on
        
    end
    
    
    [~, B0, U0, A0, csM] = ts1615_info2projN (rTskin, ILn, THC, N); % data required for projection

    eTHCi = ts1614_inU0 (contaL, Spatches, pR, rTskin, agCurv, csM, MLT, B0, U0, A0, Xtol, DUtol);


    % Re-selects the closest line amont the three involved to eTHCi
    
    eAvi = eTHCi.Av ;

    lm = zeros(3,2); % line ref and distance to eAvi
    for k = 1:1:3
        
        lR = connS.SL(sr,k);
        
        B1 = THC.Av(connT.LV(lR,1),:)';
        B2 = THC.Av(connT.LV(lR,2),:)';
        v = B2-B1 ;
        
        [dist, d] = go2527_distPtoRecta (eAvi, B1, v, pudim);
        
        lm(k,1) = lR ;
        lm(k,2) = dist ;
    end
    
    lm = sortrows(lm,2);
    ilR = lm(1,1);
    
    
    % Checks conditions:

    % a: lies within one element attached to ilR: 
    
    Anod = zeros(4,pudim);
    
    for k = 1:1:size(connT.LE,2)
        
        eR = connT.LE(ilR,k);
        
        if eR > 0

            for i = 1:1:4
                nR = connT.EV(eR,i);
                Anod(i,:) = THC.Av(nR,:);
            end
            [IN,~,~,~,~] = go2539_PinTet (Anod, eTHCi.Av, nd);
            
            if IN > 0
                meR = eR;
                break
            end
        end
    end
    
    if meR > 0
        
        [acF] = tn3606_d2OppSides (meR, ilR, THC, connT, connS, eTHCi, pL);
             
        if acF == 1
        meR = 0 ;     
        end
    end
    
    
end


if meR == 0
    return % only carries on if Acp is within tets that surround the ilR
end





% 2.- IF CONDITION IS MET:
% => treats the situation as a common line intersection case

oconnT = connT ;

% aff'd elements:
Nel = 0;
elR = zeros(1,1);

for k = 1:1:size(connT.LE,2)
    
    r = connT.LE(ilR,k);
    if r > 0
        Nel = Nel + 1 ;
        elR(Nel,1) = r;
    end 
end

pNV = size(THC.Av,1);
pNV = pNV + 1 ;
nnR = pNV; % new node is added at the rear

THC.Xv =  [ THC.Xv  ; eTHCi.Xv' ];
THC.Av =  [ THC.Av  ; eTHCi.Av' ];
THC.Uv =  [ THC.Uv  ; eTHCi.Uv' ];
THC.Bv =  [ THC.Bv  ; eTHCi.Bv  ];
THC.NCS = [ THC.NCS ; eTHCi.NCS ];
THC.rm =  [ THC.rm  ; eTHCi.rm  ];

LeRd = zeros(Nel,2); % local ref of edge of each element corresponding to intersected tet edge
neR = [ connT.LV(ilR,1) ;  connT.LV(ilR,2) ];


for e = 1:1:Nel
    
    eR = elR(e,1);
    
    [leR] = ts1620_LedgeR (connT, neR, eR);
    
    LeRd(e,1) = leR(1);
    LeRd(e,2) = leR(2);
end


pNE = size(connT.EV,1);
EVcon = connT.EV;

[pNE, EVcon] = ei1663_TetDiv2 (THC, pNE, EVcon, Nel, elR, nnR, LeRd);
connT.EV = EVcon;


teR2 = [ elR ; [pNE-Nel+1:1:pNE]' ] ;

[connT] = th1333_oConnL (pNE, pNV, connT.EV);

[MLT, slF] = ts1603_insertMLT (contaL, eTHCi, Spatches, pR, mLR, MLT, pL);

tp = "split edge";


% Plots: only for checking purposes:

%{

% INITIAL SITUATION:

Nsi = size(isi,1);

fr = 500 + contaL;

plotF = 1 ;
[~,~,~] = ts1602_mLAspace (ILn, THC.Av, plotF, fr, 'r', 1.2, 1);

p1 = ILn(1,1);
scatter3 ( THC.Av(p1,1), THC.Av(p1,2), THC.Av(p1,3), 'r', 'Filled'); hold on


for s = 1:1:Nsi
   pt1374_pSidConn (isi(s,1).R, connS.SV, THC.Av, fr, 'k', 1, 1, 0, 0);
end

pt1375_pLinConn (ilR, oconnT.LV, THC.Av, fr, 'g', 0.33, 4.2, 0);

scatter3 ( eTHCi.Av(1),  eTHCi.Av(2), eTHCi.Av(3), 'g' );

for e = 1:1:Nel
    pt1373_pTetConn (elR(e), oconnT, THC.Av, fr, 'k', 1, 1, 0, 0);
end


% MODIFIED SITUATION:

fr = 600 + contaL;

for e = 1:1:Nel
    pt1373_pTetConn (elR(e), connT, THC.Av, fr, 'k', 1, 1, 0, 0);
end

for e = pNE:-1:pNE-Nel+1
    pt1373_pTetConn (e, connT, THC.Av, fr, 'k', 1, 1, 0, 0);
end
    
x = [ MLT.tAv(ILn(1,2),:) ; MLT.tAv(MLT.tNV,:); MLT.tAv(ILn(2,2),:) ];



plot3 ( x(:,1), x(:,2),x(:,3),'r' ); hold on

%{
if jj==9
end
%}


%}

end

