function [ILS] = tn3601_isiIntLines (isi, ILn, THC, connS)

% RETURNS:
% ILS(Nsi-1,1): intersection lines between sides, in order fron ILn(1,1)
% (son como las bisagras entre intersected sides)

Nsi = size(isi,1);
pudim = 3 ;

% Initial point of MLT missing line:

a0 = zeros(pudim,1);
a0(:,1) = THC.Av(ILn(1,1),:);


% Stores distances from isi.Acoor to a0, and orders:

dr = zeros(Nsi,2); % distance and side global ref.

a = zeros(pudim,1);

for s = 1:1:Nsi
    a(:,1) = isi(s,1).Acoor(:,1);
    
    dr(s,1) = norm(a-a0);
    dr(s,2) = isi(s,1).R ;
end

dr = sortrows(dr,1);


% Find intersection lines between pairs of sides:

ILS = zeros(Nsi-1,1);

conta = 0 ;
for s = 1:1:Nsi-1
    
    s1 = dr(s,2);
    s2 = dr(s+1,2);
    
    for i = 1:1:3
        
        Lr1 = connS.SL(s1,i);
        
        for j = 1:1:3
            
            Lr2 = connS.SL(s2,j);
            
            if Lr1 == Lr2
                
                conta = conta + 1 ;

                ILS(conta,1) = Lr1 ;
                break
                
            end
            
        end
 
        if Lr1 == Lr2
            break
        end
        
    end

end


[ILS,~] = GEN_16_RemoveRepeatedRows (ILS, 1, 0.1);


end

