function [Ncp, eTHC, icR, idis] = tn3602_cuILS ...
         (contaL, ILS, ILn, THC, connT, Spatches, pR, rTskin, agCurv, MLT, pL, Xtol, DUtol, tolP)

% RETURNS:
% eTHC(Ncp, pudim):  closest point proj'd on MLT to its intersection line
% icR(Ncp,1):       lines of intersection sides
% idis(Ncp,1):      distance from Acp to its icR

pudim = 3 ;


% Lines to check: chooses the unique line (if only one) or the first and last if various:

Nlc = 1 ;
lcR = ILS(1);

if size(ILS,1) > 1
   Nlc = 2 ; 
   lcR = [ ILS(1) ; ILS(end) ];
end


% Threshold distances:

tD = zeros(Nlc,1);

for k = 1:1:Nlc 
    n1 = connT.LV(lcR(k),1);
    n2 = connT.LV(lcR(k),2);
    
    tD(k,1) = pL/100 * norm(THC.Av(n2,:) - THC.Av(n1,:));
end



% Finds closest location of missing line to each intersection lines to check.
% Transfers response only those projected points closer to their line than tD:

Ncp = 0 ;
eTHC(1,1) = struct ( 'Xv',[], 'Av',[], 'Uv',[], 'Bv',[], 'NCS',[], 'rm',[] ) ;
icR = zeros(1,1);
idis = zeros(1,1);

for i = 1:1:Nlc
    
    Lr = lcR(i);

    B1 = THC.Av(connT.LV(Lr,1),:)';
    B2 = THC.Av(connT.LV(Lr,2),:)';
    vB = B2-B1 ;

    [eTHCi] = tn3603_Aclosest (contaL, ILn, THC, Lr, connT, Spatches, pR, rTskin, agCurv, MLT, Xtol, DUtol, tolP);
    [disti, ~] = go2527_distPtoRecta (eTHCi.Av, B1, vB, pudim);
    
    
    %{
    if contaL == 8
        
        fr = 88 ;
        figure(fr)
        
        plot3( [B1(1) B2(1)], [B1(2) B2(2)], [B1(3) B2(3)],'k'); hold on
        scatter3(eTHCi.Av(1), eTHCi.Av(2), eTHCi.Av(3), 'r'); hold on
        
        n1 = ILn(1,2);
        n2 = ILn(2,2);
        scatter3 ( MLT.tAv(n1,1),  MLT.tAv(n1,2),  MLT.tAv(n1,3), 'b', 'Filled'); hold on
        scatter3 ( MLT.tAv(n2,1),  MLT.tAv(n2,2),  MLT.tAv(n2,3), 'b', 'Filled'); hold on
        
        axis equal
    end
    %}
    
    
    if disti < tD(i)
        
        Ncp = Ncp + 1 ;
        eTHC(Ncp,1) = eTHCi;
        icR(Ncp,1) = Lr ;
        idis(Ncp,1) = disti ;
    end
     
end






end

