function [eTHC] = tn3603_Aclosest (contaL, ILn, THC, Lr, connT, Spatches, pR, rTskin, agCurv, MLT, Xtol, DUtol, tolP)

% RETURNS:
% eTHC: closest point of MLT missing line (projected to MLT surface) to a tet line.

% INPUTS:
% ILn: nodes of tets corresponding to missing line
% lR: Line of tets where we want to find the closest MLT missing line location

% tolP = 0.5 ;

pudim = 3 ;


% 1.- Common line between tet sides:

B1 = THC.Av(connT.LV(Lr,1),:)';
B2 = THC.Av(connT.LV(Lr,2),:)';
vB = B2-B1 ;


% 2.- Missing line of MLT:

A1 = THC.Av(ILn(1,1),:)';
A2 = THC.Av(ILn(2,1),:)';
Ac0 = (A1 + A2)/2;


% 3.- Closest point from line B to line A:

Ac = go2549_cPr2r (Ac0, 0,0, 0,0, A1,A2, B1,B2, tolP);


% 4.- Finds projectd point:

% 4.1.- Interpolation values:

L = norm(A2-A1);
L1 = norm(Ac-A1);
L2 = norm(Ac-A2);

N = [L2/L L1/L];


% 4.2.- Projects:

[~, B0, U0, A0, csM] = ts1615_info2projN (rTskin, ILn, THC, N); % data required for projection

eTHC = ts1614_inU0 (contaL, Spatches, pR, rTskin, agCurv, csM, MLT, B0, U0, A0, Xtol, DUtol);





end

