function [acF] = tn3606_d2OppSides (eR, lR, THC, connT, connS, eTHCi, pL)

% RETURNS:
% acF new node to insert is too close to opp. sides 
% acF = 1 if it is closer than threshold distance.


pudim = 3 ;

% Detects the 2 sides that do not contain the common line ('opposite sides'):

conta = 0 ;
Sop = zeros(1,1);

for s = 1:1:4
    
    sR = connT.ES(eR,s);
    
    addF = 1 ;
    for l = 1:1:3
        
        r = connS.SL(sR,l);
        if r == lR
            addF = 0;
            break
        end
        
    end
    
    if addF == 1
        conta = conta + 1 ;
        Sop(conta,1) = sR;
    end

end


% Threshold distance from eTHCi to opp. sides:

Tnod = zeros(4,pudim);

for k = 1:1:4
    nR = connT.EV(eR,k);
    Tnod(k,:) = THC.Av(nR,:);
end

[bave] = tm1313_bave (Tnod, pudim);

tD = pL/100 * bave ;



% Measure distance to both sides:

Snod = zeros(3,pudim);


acF = 0 ;
for s = 1:1:2
    
    sR = Sop(s,1);
    
    for k = 1:1:3
        nR = connS.SV(sR,k);
        Snod(k,:) = THC.Av(nR,:);
    end
    
    [dist,~,~] = go2534b_dP2Plan (eTHCi.Av, Snod, 0,0);
    
    if dist < tD
        acF = 1 ; % move flag
        break
    end
end




end

