function [pAnod, ppd] = dt3702_ppd (Anod, Aav, bave)

% RETURNS:
% pAnod(4,pudim): nodes coordinates projected onto fitted plane
% ppd = 100 * dmax / bave => 'perc. plane distace' distance from LSM plane to furthest node in % wrt bave


% INPUTS:
% Anod(4,pudim): nodes coordinates
% Aav(pudim,1): average of nodes
% bave: average length of edges of the node

pudim = 3 ;
pAnod = zeros(4,pudim);


% 1.- Fits plane to Anod by LSM, and projects points to that plane:

[Np] = go2519_planeFit (Aav, Anod, 4, pudim); % normal to fitted plane (LSM)

P = zeros(pudim,1);
dm = zeros(4,1);

for k =1:1:4

    P(:,1) = Anod(k,:);
    [dist,~, Q] = go2534b_dP2Plan (P, 0, Np, Aav);
    
    pAnod(k,:) = Q(:,1);
    dm(k,1) = dist ;

end


% 2.- Computes ppd:

dm = sortrows(dm,1);
ppd = 100 * dm(4) / bave ;


end

