function [mL, DL] = dt3704_mL (LNcon, Anod)

% RETURNS:
% mL arranged by length
mL = zeros(6,5); % line ref, length, increment to next length, n1, n2
DL = zeros(2,1); % max increment and location

% Computes mL:

for i = 1:1:6
    
    n1 = LNcon(i,1);
    n2 = LNcon(i,2);
    
    a1(:,1) = Anod(n1,:);
    b1(:,1) = Anod(n2,:);
    
    mL(i,1) = i ;
    mL(i,2) = norm(a1-b1);
    mL(i,4) = n1;
    mL(i,5) = n2;
    
end


% Arranges mL and computes increments:

mL = sortrows(mL,2);

for i = 1:1:5
    mL(i,3) = mL(i+1,2)/mL(i,2);
end


% Detects maximum increment and location:

mLt = sortrows(mL,3);

DL(1,1) = mLt(6,3);

for i = 1:1:5
    
    if mL(i,3)==DL(1,1)
       
        DL(2,1) = i ;
        break
        
    end
    
end

end

