function [pcd, inLR] = dt3705_pcd (pAnod, ipF, bave, nd)

% RETURNS:
% pcd = 100 x min. dist from centre point to contour / bave
% inLR: internal node ref (only for CAP case)
% ceLR: ref of closest entity (if inLR>0 ceLR is edge, if inLR=0 ceLR is another node)

% uses projected coordiantes:

pudim = 3 ;
Tnod = zeros(3,pudim);

C = zeros(pudim,1);
a = zeros(pudim,1);
b = zeros(pudim,1);

% 1.- Finds inLR:

if ipF == 1
    
    % 1.- NO INTERNAL NODE (i.e. internal intersection exists):
    
    inLR = 0 ;
    
else
    
        
    % 2.- THERE IS INTERNAL NODE:
    
    inLR = 0 ;
    mnr = [ 2 3 4 ; 1 3 4 ; 1 2 4 ; 1 2 3 ] ;
    
    for i = 1:1:4
        
        a1(:,1) = pAnod(i,:);
        
        for j = 1:1:3
            nr = mnr(i,j);
            Tnod(j,:) = pAnod(nr,:);
        end
        
        [IN,~,~] = go2548_PinTri2 (Tnod, a1, pudim, nd);
        
        if IN > 0
            inLR = i ;
            mnri = [mnr(i,:) mnri(i,1)];
            break
        end
        
    end
    
end


% 2.- Computes distance from central point to contour, and pcd:




if ipF==1
    
    
    
    
else
    

    C(:,1) = pAnod(inLR,:);
    
    for k = 1:1:3
        
        a(:,1) = pAnod(mnri(k+0),:);
        b(:,1) = pAnod(mnri(k+1),:);
        v = b-a;
        
        [dist, d] = go2527_distPtoRecta (C, a, v, pudim);
            
    end
    
end


end

