function [] = ap1A_9701_main ( )


% 1.- ENTITY DEFINITION:

% [KnotV, Ncp, Degree, Usize, Ew, EP, w, P, CD, udim, xdim] = ap1A_9782_curv1 ( );

% [KnotV, Ncp, Degree, Usize, Ew, EP, w, P, CD, udim, xdim] = ap1A_9781_surf1 ( );

 [KnotV, Ncp, Degree, Usize, Ew, EP, w, P, CD, udim, xdim] = ap1A_9783_volu2 ( );


% represents entity:

frX = 1 ;
frUn = 20 ;
frUt = 30 ;
cnF = 1 ;
edF = 1;

i3052_pEntityED_CN (frX, cnF, edF, KnotV, Ncp, Degree, Usize, Ew, EP, P, udim, xdim);

% prepares parameter spaces plots:
ap1A_9751_preparPlots (frUn, frUt, udim);


% 2.- TARGET POINT: ur (cancel one option or another)

Xtol  = 0.01;
DUtol = 0.001;

% from X:
%{
xt = [15 10 8 ];

if udim == 1
	[ut] = c2811b_PPcurves (xt, 1, Degree ,Ncp ,KnotV ,P, w, 0, xdim, Xtol, DUtol);
elseif udim == 2
    [ut] = s2831b_PPsurf   (xt, 1, Degree, Ncp, KnotV, Usize, P, w, [0 0], xdim, Xtol, DUtol);
elseif udim == 3
    
end

ut = ut';
%}

% from U:
ut = [ 0.2 0.25 0.8]' ;
xt = b2601_BNURBS_Xcoord (ut, KnotV, Ncp,Degree,Usize, Ew,EP, udim,xdim);

figure(frX)
scatter3(xt(1),xt(2),xt(3),400,'b','+','LineWidth',1.5); hold on



% 3.- PREPARES CLOUD OF POINTS & SETS No. ITERATIONS:

Nmax = 12 ; % no. iterations
Ni = 8 ; % No. intervals

[Eua, ua] = ap1A_9752_cloudX0 (Ni,udim);




% 4.- EVALUATES N steps:
% If reduces distance after N iterations it is assumed convergent:

u0 = zeros(1,udim); % initial searching point

ZL = [0 1.2]; % limits of Z for Niter representation
sc = 0.1 ;

Ntotal = (Ni+1)^udim;

% parameters of both methods:
Rob = zeros(1,2); % robustness
Nit = zeros(1,2); % No. iterations

for i = 1:1:Ntotal
    
    u0(1,:) = ua(i,:); % initial searching point to check
    

    % N-R:
    
    [Xnr, Unr, cvF, Niter] = ap1A_9711_NRiter (Nmax, u0, xt, KnotV, Ncp, Degree, Usize, Ew, EP, w, P, CD, udim, xdim, Xtol, DUtol); 
    
    if cvF == 1
        
        ap1A_9753_plots (frUn, frUn+1, Unr, Niter, sc, 'r', ZL, udim);
         
        Rob(1,1) = Rob(1,1) + 1 ;
        Nit(1,1) = Nit(1,1) + Niter ;
         
    end
    
    

    % Tracing:
    
    [Xtc, Utc, cvF, Niter] = ap1A_9712_TCiter (Nmax, u0, xt, KnotV, Ncp, Degree, Usize, Ew, EP, w, P, CD, udim, xdim, Xtol, DUtol);
    
    if cvF == 1
        
        ap1A_9753_plots (frUt, frUt+1, Utc, Niter, sc, 'b', ZL, udim);
         
        Rob(1,2) = Rob(1,2) + 1 ;
        Nit(1,2) = Nit(1,2) + Niter ;
         
    end  
    
end


% measurement of performance:

for m = 1:1:2
    
    n = Rob(1,m) ; % No. convergence points
    
    Rob(1,m) = 100 * n / Ntotal ;
    Nit(1,m) = Nit(1,m)/n;
    
end

Rob
Nit


%{
for i = 1:1:Ni+1
for j = 1:1:Ni+1

    u0(1,:) = ua(i,j,:); % initial searching point
    
    % N-R:
    [Xnr, Unr, cvF, Niter] = ap1A_9711_NRiter (Nmax, u0, xt, KnotV, Ncp, Degree, Usize, Ew, EP, w, P, CD, udim, xdim, Xtol, DUtol);     
    if cvF == 1
         ap1A_9751_plots (frUn, frUn+1, Unr, Niter, sc, 'r', ZL);
    end
    

    % Tracing:
    [Xtc, Utc, cvF, Niter] = ap1A_9712_TCiter (Nmax, u0, xt, KnotV, Ncp, Degree, Usize, Ew, EP, w, P, CD, udim, xdim, Xtol, DUtol);
    if cvF == 1
         ap1A_9751_plots (frUt, frUt+1, Utc, Niter, sc, 'b', ZL);
    end

end
end
%}

end

