function [] = ap1A_9715_convPlot (fr, ut, Uc, DUg, DUtol, udim, col)

% PLOTS: dot in case there is convergence with initial searching point

% INPUTS:
% fr: fig. ref where plot
% ut: target coordinates
% Uc: computed coordinates

cvF = 0 ; % convergence flag

DU1 = zeros(udim,1);
DU2 = zeros(udim,1);

Ncc = size(Uc,1);

for di = 1:1:udim
	DU1(di,1) = ut(di) - Uc(1,di);
	DU2(di,1) = ut(di) - Uc(Ncc,di);
end

nDU1 = norm(DU1);
nDU2 = norm(DU2);


% CHECKS CONVERGENCE:

% a) final position lies within the gross tolerance and then if last
% position is closer than first:

if nDU2 < DUg
    if nDU2 < nDU1  
        cvF = 1;
    end
end


% b) final distance < DUtol:

if nDU2 < DUtol  
	cvF = 1;
end

% PLOTS if CONVERGES:

if cvF == 1
    figure(fr)
	scatter(Uc(1,1),Uc(1,2),col);  
end

end

