function [ ] = p9800_main ( )


% 1.- BASIC DATA:

xdim = 3 ;
ndig = 6 ;
plotF = 0 ;
UisoF = 0 ;
BIT = 1;


% 2.- UN-TRIMMED SURFACE:


% 2.1.- NURBS surfaceS definition:

[Nsf, sf] = p9801_NURBSdefinition_1 ;



% 2.2.- Meshing parameters:
 
Nvx = 3 ;
R  = 12 ;
esw = 0.33 * R ; % edge strip width

% percentaje fo difference of approximated R
tolRc = 4 ; % curves 1
tolRs = 16 ;  % surface 4
tolD = 15 ; % surfaces derivatives interpolation

tolC = 7 ;
curveError ='yes';

wbF = 1 ;

DerC = 'ip'; % 'ex' for exact derivative calculation, 'ip' for interpolated, 'sp' for spline surface


% 2.3.- QIT:

tic

QITs = ts3330_QIT ...
(tolRc, tolRs, tolD, Nvx, R, Nsf, sf, xdim, ndig, plotF, UisoF, BIT, wbF, DerC);

toc

if gg==0
end

% 3.- TRIMMED SURFACE:

% 3.1.- NURBS surfaceS definition:

[tNsf, tsf, agCurv, TNcu, SCcon, ncu, nlo] = p9801_NURBSdefinition_11_tr; 


% 3.2.- Meshing parameters:
 
Nvx = 3 ;
R  = 9 ;
eswP = 30 ;
esw = eswP/100 * R ; % edge strip width

% percentaje fo difference of approximated R
tolRc = 1.0 ; % curves
tolRs = 4.0 ;  % surface
tolD = 20 ; % surfaces derivatives interpolation

tolC = 2 ;
curveError ='yes';

wbF = 1 ;

DerC = 'ip'; % 'ex' for exact derivative calculation, 'ip' for interpolated, 'sp' for spline surface



% 3.3.- Computes curves vertexes in local curve physical/param's coord's:

[cLXv, cLUv, Ncv,~] = ts3312_Cvertexes (agCurv, TNcu, R, Nvx, tolRc, xdim, tolC, curveError);



% 3.4.- QIT:

[QITst] = ts3330_QIT_trim ...
(tolRc, tolRs, tolD, Nvx, R, esw,eswP, tNsf, tsf, agCurv, cLXv, cLUv, Ncv, nlo, ncu, SCcon, xdim, ndig, 0,0,0, wbF, DerC, tolC, curveError);

% plots QIT-mesh:

frXv = 3 ;

for s = 1:1:tNsf
    
    NE = QITst(s).mNE;
    Xv = QITst(s).mXv;
    Uv = QITst(s).mUv;
    TVcon = QITst(s).mTVcon;
    
    ts3396_plotQITmesh (0, 0, 0, 0, 0, frXv, 0, ...
    0, 0, 0, 0, 0, 0, 0, 0, Xv, Uv, TVcon, NE);
    
end






end

