function [Nsf, sf] = p9801_NURBSdefinition_1( )

% BRACKET single SURFACE:

xdim = 3 ;
udim = 2 ;

H = 100 ;
L = 150 ;
W = 50 ;
D = 60 ;
r = 5 ;


Nsf = 1; % No. surfaces of skins


% declares structs:

sf(Nsf) = struct('Ncp',[], 'Degree',[], 'Usize',[], 'KnotV',[], 'EP',[], 'Ew',[], 'P',[],'w',[], 'CS',[0 0]);


% surface 1:

sNcp = [ 6 5 ];
sDegree = [2 2];

sKnotV = [0 0 0 0.25 0.5 0.75  1 1 1 ;
         0 0 0 0.50 0.5  1 1 1 0] ;
     
sUsize = [ 9 8 ];

sEP = zeros(6,5,xdim);
sEw = ones(6,5);

accD = 0;
accW = 0;

for i = 1:1:5
    
    sEP(1,i,1) = 0 ;
    sEP(2,i,1) = (L-W)*0.3 ;
    
    sEP(3,i,1) = L-W-r ;
    
    sEP(4,i,1) = L - accW ;
    sEP(5,i,1) = L - accW ;
    sEP(6,i,1) = L - accW ;
    
    sEP(2,i,2) = accD;
    sEP(3,i,2) = accD;
    sEP(4,i,2) = accD;
    
    sEP(5,i,2) = D + r;
    sEP(6,i,2) = H ;
    
    accD = accD + D/4;
    accW = accW + W/4;
end

sEP(1,1,2) = 0;
sEP(1,2,2) = 0;
sEP(1,3,2) = D/2;
sEP(1,4,2) = D;
sEP(1,5,2) = D;

sEP(1,1,3) = -3*D/2;
sEP(1,5,3) = -D/2;

sEP(2,1,3) = -D/4;
sEP(2,5,3) = -D/4;

sEw(1,2) = 0.707;
sEw(1,4) = 0.707;
sEw(4,1) = 6 ;


[sw,sP] = GEN_12_ContractsBw (sEw, sEP, xdim, udim, sNcp);

%{
x=zeros(1,3);

for i = 1:1:6
    
    for j=1:1:5
        
        x(1,:) = sEP(i,j,:);
        
        [i j]
        [x sEw(i,j)]
        
    end
    
    
end
%}

sf(1).Ncp = sNcp;
sf(1).Degree = sDegree;
sf(1).Usize = sUsize;
sf(1).KnotV = sKnotV;
sf(1).EP = sEP;
sf(1).Ew = sEw;
sf(1).P = sP;
sf(1).w = sw;
sf(1).CS = 0;


end

