function [tNsf, tsf, agCurv, TNcu, SCcon, ncu, nlo] = p9801_NURBSdefinition_11_tr ( )

% BRACKET drilled with 2 surfaces:

xdim = 3 ;
udim = 2 ;

ro = 75 ;
ri = 15 ;

H = 35 ;



tNsf = 2; % No. surfaces of skins


% declares structs:

tsf(tNsf) = struct('Ncp',[], 'Degree',[], 'Usize',[], 'KnotV',[], 'EP',[], 'Ew',[], 'P',[],'w',[], 'CS',[0 0]);


% surface 1:

sR = 1 ;

sNcp = [ 5 2 ];
sDegree = [2 1];

sKnotV = [  0 0 0 0.5 0.5  1 1 1 ;
            0 0 1 1   0    0 0 0] ;
     
sUsize = [ 8 4 ];

sEP = ones(sNcp(1), sNcp(2), xdim)*H;
sEw = ones (sNcp(1), sNcp(2));

sEP(1,1,1) = 0 ;
sEP(1,1,2) = ro ;
sEP(1,2,1) = ro-ri ;
sEP(1,2,2) = ro ;

sEP(2,1,1) = 0 ;
sEP(2,1,2) = 0 ;
sEP(2,2,1) = ro-ri ;
sEP(2,2,2) = ro-ri ;

sEP(3,1,1) = ro ;
sEP(3,1,2) = 0 ;
sEP(3,2,1) = ro ;
sEP(3,2,2) = ro-ri ;

sEP(4,1,1) = 2*ro ;
sEP(4,1,2) = 0 ;
sEP(4,2,1) = ro+ri ;
sEP(4,2,2) = ro-ri ;

sEP(5,1,1) = 2*ro ;
sEP(5,1,2) = ro ;
sEP(5,2,1) = ro+ri ;
sEP(5,2,2) = ro ;

sEw(2,1) = 0.707 ;
sEw(2,2) = 0.707 ;
sEw(4,1) = 0.707 ;
sEw(4,2) = 0.707 ;


[sw,sP] = GEN_12_ContractsBw (sEw, sEP, xdim, udim, sNcp);

%{
x=zeros(1,3);

for i = 1:1:sNcp(1)
    
    for j=1:1:sNcp(2)
        
        x(1,:) = sEP(i,j,:);
        
        %[i j]
        %[x sEw(i,j)]
        figure(1)
        scatter3(x(1,1),x(1,2), x(1,3),'b'); hold on
        axis equal
        
    end
    
    
end
%}

tsf(sR).Ncp = sNcp;
tsf(sR).Degree = sDegree;
tsf(sR).Usize = sUsize;
tsf(sR).KnotV = sKnotV;
tsf(sR).EP = sEP;
tsf(sR).Ew = sEw;
tsf(sR).P = sP;
tsf(sR).w = sw;
tsf(sR).CS = [0 0];



% surface 2:

sR = 2 ;

sNcp = [ 5 2 ];
sDegree = [2 1];

sKnotV = [  0 0 0 0.5 0.5  1 1 1 ;
            0 0 1 1   0    0 0 0] ;
     
sUsize = [ 8 4 ];

sEP = ones(sNcp(1), sNcp(2), xdim)*H;
sEw = ones (sNcp(1), sNcp(2));

for i = 1:1:sNcp(1)
    sEP(i,1,3) = 0;
end


sEP(1,1,1) = 0 ;
sEP(1,1,2) = ro ;
sEP(1,2,1) = 0 ;
sEP(1,2,2) = ro ;

sEP(2,1,1) = 0 ;
sEP(2,1,2) = 0 ;
sEP(2,2,1) = 0 ;
sEP(2,2,2) = 0 ;

sEP(3,1,1) = ro ;
sEP(3,1,2) = 0 ;
sEP(3,2,1) = ro ;
sEP(3,2,2) = 0 ;

sEP(4,1,1) = 2*ro ;
sEP(4,1,2) = 0 ;
sEP(4,2,1) = 2*ro ;
sEP(4,2,2) = 0 ;

sEP(5,1,1) = 2*ro ;
sEP(5,1,2) = ro ;
sEP(5,2,1) = 2*ro ;
sEP(5,2,2) = ro ;

sEw(2,1) = 0.707 ;
sEw(2,2) = 0.707 ;
sEw(4,1) = 0.707 ;
sEw(4,2) = 0.707 ;


[sw,sP] = GEN_12_ContractsBw (sEw, sEP, xdim, udim, sNcp);

%{
x=zeros(1,3);

for i = 1:1:sNcp(1)
    
    for j=1:1:sNcp(2)
        
        x(1,:) = sEP(i,j,:);
        
        %[i j]
        %[x sEw(i,j)]
        figure(1)
        scatter3(x(1,1),x(1,2), x(1,3),'b'); hold on
        axis equal
        
    end
    
    
end
%}

tsf(sR).Ncp = sNcp;
tsf(sR).Degree = sDegree;
tsf(sR).Usize = sUsize;
tsf(sR).KnotV = sKnotV;
tsf(sR).EP = sEP;
tsf(sR).Ew = sEw;
tsf(sR).P = sP;
tsf(sR).w = sw;
tsf(sR).CS = [0 0];


% CURVES:

nlo = zeros(tNsf,1);
ncu = zeros(tNsf,2);
SCcon = zeros(tNsf,2,4);

TNcu = 10 ;

nlo(1,1) = 2 ;
nlo(2,1) = 1 ;

ncu(1,1) = 4 ;
ncu(1,2) = 3 ;
ncu(2,1) = 4 ;

SCcon(1,1,1) = 1  ; SCcon(1,1,2) = 2 ;SCcon(1,1,3) = 3 ;SCcon(1,1,4) = 4 ;
SCcon(1,2,1) = 5  ; SCcon(1,2,2) = 6 ;SCcon(1,2,3) = 7 ;SCcon(1,2,4) = 0 ;
SCcon(2,1,1) = -1 ; SCcon(2,1,2) = 8 ;SCcon(2,1,3) = 9 ;SCcon(2,1,4) = 10 ;

agCurv(TNcu,1) = struct ('Ncp',0, 'Degree',0, 'Usize',0, 'KnotV',[], 'w',[], 'P',[], 'conF', 0);


% surf 1 - contour 1

agCurv(1,1).Ncp = 5 ;
agCurv(2,1).Ncp = 2 ;
agCurv(3,1).Ncp = 5 ;
agCurv(4,1).Ncp = 2 ;

agCurv(1,1).Degree = 2 ;
agCurv(2,1).Degree = 1 ;
agCurv(3,1).Degree = 2 ;
agCurv(4,1).Degree = 1 ;

agCurv(1,1).Usize = 8 ;
agCurv(2,1).Usize = 4 ;
agCurv(3,1).Usize = 8 ;
agCurv(4,1).Usize = 4 ;

agCurv(1,1).KnotV = [ 0 0 0 0.5 0.5  1 1 1 ] ;
agCurv(2,1).KnotV = [ 0 0 1 1 ] ;
agCurv(3,1).KnotV = [ 0 0 0 0.5 0.5  1 1 1 ] ;
agCurv(4,1).KnotV = [ 0 0 1 1 ] ;

agCurv(1,1).w = [1 0.707 1 0.707 1] ;
agCurv(2,1).w = [1 1] ;
agCurv(3,1).w = [1 0.707 1 0.707 1] ;
agCurv(4,1).w = [1 1] ;

agCurv(1,1).P = [ 0 ro H ; 0 0 H ; ro 0 H ; 2*ro 0 H; 2*ro ro H ] ;
agCurv(2,1).P = [ 2*ro ro H ; ro+ri ro H ] ;
agCurv(3,1).P = [ ro+ri ro H ; ro+ri ro-ri H ; ro ro-ri H ; ro-ri ro-ri H ; ro-ri ro H ] ;
agCurv(4,1).P = [ ro-ri ro H ; 0 ro H ] ;

agCurv(1,1).conF = 1 ;
agCurv(2,1).conF = 1 ;
agCurv(3,1).conF = 1 ;
agCurv(4,1).conF = 1 ;


% surf 1 - contour 2

agCurv(5,1).Ncp = 4 ;
agCurv(6,1).Ncp = 4 ;
agCurv(7,1).Ncp = 4 ;

agCurv(5,1).Degree = 3 ;
agCurv(6,1).Degree = 3 ;
agCurv(7,1).Degree = 3 ;

agCurv(5,1).Usize = 8 ;
agCurv(6,1).Usize = 8 ;
agCurv(7,1).Usize = 8 ;

agCurv(5,1).KnotV = [ 0 0 0 0 1 1 1 1 ] ;
agCurv(6,1).KnotV = [ 0 0 0 0 1 1 1 1 ] ;
agCurv(7,1).KnotV = [ 0 0 0 0 1 1 1 1 ] ;

agCurv(5,1).w = [ 1 1 1 1 ] ;
agCurv(6,1).w = [ 1 1 1 1 ] ;
agCurv(7,1).w = [ 1 1 1 1 ] ;

agCurv(5,1).P = [ ro 0.2*ro H ; 1.1*ro 0.2*ro H ; 1.1*ro 0.3*ro H; 1.1*ro 0.4*ro H ] ;
agCurv(6,1).P = [ 1.1*ro 0.4*ro H ; 1*ro 0.4*ro H ; 0.8*ro 0.4*ro H ; 0.8*ro 0.3*ro H ] ;
agCurv(7,1).P = [ 0.8*ro 0.3*ro H ; 0.9*ro 0.25*ro H ; 0.9*ro 0.2*ro H ; ro 0.2*ro H ] ;

agCurv(5,1).conF = 0 ;
agCurv(6,1).conF = 0 ;
agCurv(7,1).conF = 0 ;


% surf 2 - contour 1

agCurv(8,1).Ncp = 2 ;
agCurv(9,1).Ncp = 5 ;
agCurv(10,1).Ncp = 2 ;

agCurv(8,1).Degree = 1 ;
agCurv(9,1).Degree = 2 ;
agCurv(10,1).Degree = 1 ;

agCurv(8,1).Usize = 4 ;
agCurv(9,1).Usize = 8 ;
agCurv(10,1).Usize = 4 ;

agCurv(8,1).KnotV = [ 0 0  1 1 ] ;
agCurv(9,1).KnotV = [ 0 0 0 0.5 0.5 1 1 1 ] ;
agCurv(10,1).KnotV = [ 0 0 1 1 ] ;

agCurv(8,1).w = [ 1 1 ] ;
agCurv(9,1).w = [ 1 0.707 1 0.707 1 ] ;
agCurv(10,1).w = [ 1 1  ] ;

agCurv(8,1).P = [ 0 ro H ; 0 ro 0] ;
agCurv(9,1).P = [ 0 ro 0 ; 0 0 0 ; ro 0 0 ; 2*ro 0 0; 2*ro ro 0 ] ;
agCurv(10,1).P = [ 2*ro ro 0 ; 2*ro ro H ] ;

agCurv(8,1).conF = 1 ;
agCurv(9,1).conF = 1 ;
agCurv(10,1).conF = 1 ;


%{
for c = 1:1:TNcu
    
    for po = 1:1:agCurv(c).Ncp
        
        figure(1)
        scatter3(agCurv(c).P(po,1),agCurv(c).P(po,2),agCurv(c).P(po,3),'r'); hold on
        axis equal
        
    end
    
end
%}


end

