function [Nsf, sf] = p9801_NURBSdefinition_3( )

% alambique:

xdim = 3 ;
udim = 2 ;

H = 150 ;
Lt = 100 ;
W = 80 ;
B = 60 ;
r = 60 ;

Dbase = 35 ; % base increment in percentage

Nsf = 3 ; % No. surfaces of skins


% declares structs:

sf(Nsf) = struct('Ncp',[], 'Degree',[], 'Usize',[], 'KnotV',[], 'EP',[], 'Ew',[], 'P',[],'w',[], 'CS',[0 0]);


% surface 1: lid

s = 1 ;

sNcp =      [ 5 2 ];
sDegree =   [ 2 1 ];

sKnotV = [0 0 0  0.5 0.5  1 1 1 ;
          0 0 1  1   0    0 0 0];
     
sUsize = [ 8 4 ];

sEP = ones(sNcp(1),sNcp(2),xdim)*H; % provides H now
sEw = ones(sNcp(1),sNcp(2));

sEP(1,1,1) = 0;     sEP(1,1,2) = W/2;
sEP(2,1,1) = 0;     sEP(2,1,2) = 0;
sEP(3,1,1) = W/2;  	sEP(3,1,2) = 0;
sEP(4,1,1) = W;     sEP(4,1,2) = 0;
sEP(5,1,1) = W;     sEP(5,1,2) = W/2;

sEP(1,2,1) = 0.25*W;    sEP(1,2,2) = W/2;
sEP(2,2,1) = 0.25*W;   sEP(2,2,2) = W/4;
sEP(3,2,1) = 0.50*W;  	sEP(3,2,2) = W/4;
sEP(4,2,1) = 0.75*W;   sEP(4,2,2) = W/4;
sEP(5,2,1) = 0.75*W;    sEP(5,2,2) = W/2;

sEw(2,1) = 2^0.5/2;
sEw(4,1) = 2^0.5/2;

sEw(2,2) = 2^0.5/2;
sEw(4,2) = 2^0.5/2;

[sw,sP] = GEN_12_ContractsBw (sEw, sEP, xdim, udim, sNcp);

sf(s).Ncp = sNcp;
sf(s).Degree = sDegree;
sf(s).Usize = sUsize;
sf(s).KnotV = sKnotV;
sf(s).EP = sEP;
sf(s).Ew = sEw;
sf(s).P = sP;
sf(s).w = sw;
sf(s).CS = 0;


% surface 2: side

s = 2 ;

sNcp =      [ 3 5 ];
sDegree =   [ 2 2 ];

sKnotV = [0 0 0  1     1  1 0 0;
          0 0 0  0.5 0.5  1 1 1];
     
sUsize = [ 6 8 ];

sEP = zeros(sNcp(1),sNcp(2),xdim);
sEw = ones(sNcp(1),sNcp(2));

accZ = 0 ;
for i = 1:1:3
for j = 1:1:5
    sEP(i,j,3) = accZ;
end
accZ = accZ+H/2;
end

for i=1:1:3
    
    if i==1
        
        da = Dbase*W/100 ;
        
        sEP(i,1,1) = W+da;      sEP(i,1,2) = W/2;
        sEP(i,2,1) = W+da;      sEP(i,2,2) = 0-da;
        sEP(i,3,1) = W/2;       sEP(i,3,2) = 0-da;
        sEP(i,4,1) = 0-da;      sEP(i,4,2) = 0-da;
        sEP(i,5,1) = 0-da;      sEP(i,5,2) = W/2;
    else
      	sEP(i,1,1) = W;     sEP(i,1,2) = W/2;
        sEP(i,2,1) = W;     sEP(i,2,2) = 0;
        sEP(i,3,1) = W/2;  	sEP(i,3,2) = 0;
        sEP(i,4,1) = 0;     sEP(i,4,2) = 0;
        sEP(i,5,1) = 0;     sEP(i,5,2) = W/2;
    end
    
end

sEw(1,2) = 2^0.5/2;
sEw(1,4) = 2^0.5/2;

sEw(2,2) = 2^0.5/2;
sEw(2,4) = 2^0.5/2;

sEw(3,2) = 2^0.5/2;
sEw(3,4) = 2^0.5/2;

[sw,sP] = GEN_12_ContractsBw (sEw, sEP, xdim, udim, sNcp);

sf(s).Ncp = sNcp;
sf(s).Degree = sDegree;
sf(s).Usize = sUsize;
sf(s).KnotV = sKnotV;
sf(s).EP = sEP;
sf(s).Ew = sEw;
sf(s).P = sP;
sf(s).w = sw;
sf(s).CS = 0;


% surface 3: pipe

s = 3 ;

sNcp =      [ 3 5 ];
sDegree =   [ 2 2 ];

sKnotV = [0 0 0   1 1 1   0 0;
          0 0 0  0.5 0.5   1 1 1];
     
sUsize = [ 6 8 ];

sEw = ones(sNcp(1),sNcp(2));

f = 1 ;
sEP(1,f,1) = 0.75*W;    sEP(1,f,2) = W/2;    sEP(1,f,3) = H;
sEP(2,f,1) = 0.75*W;    sEP(2,f,2) = W/2;    sEP(2,f,3) = H+r;
sEP(3,f,1) = 0.75*W;  	sEP(3,f,2) = W/2+r;  sEP(3,f,3) = H+r;

f = 2 ;
sEP(1,f,1) = 0.75*W;    sEP(1,f,2) = W/4;    sEP(1,f,3) = H;
sEP(2,f,1) = 0.75*W;    sEP(2,f,2) = W/4;    sEP(2,f,3) = H+r+W/4;
sEP(3,f,1) = 0.75*W;  	sEP(3,f,2) = W/2+r;  sEP(3,f,3) = H+r+W/4;

f = 3 ;
sEP(1,f,1) = 0.5*W;    sEP(1,f,2) = W/4;    sEP(1,f,3) = H;
sEP(2,f,1) = 0.5*W;    sEP(2,f,2) = W/4;    sEP(2,f,3) = H+r+W/4;
sEP(3,f,1) = 0.5*W;  	sEP(3,f,2) = W/2+r;  sEP(3,f,3) = H+r+W/4;

f = 4 ;
sEP(1,f,1) = 0.25*W;    sEP(1,f,2) = W/4;    sEP(1,f,3) = H;
sEP(2,f,1) = 0.25*W;    sEP(2,f,2) = W/4;    sEP(2,f,3) = H+r+W/4;
sEP(3,f,1) = 0.25*W;  	sEP(3,f,2) = W/2+r;  sEP(3,f,3) = H+r+W/4;

f = 5 ;
sEP(1,f,1) = 0.25*W;    sEP(1,f,2) = W/2;    sEP(1,f,3) = H;
sEP(2,f,1) = 0.25*W;    sEP(2,f,2) = W/2;    sEP(2,f,3) = H+r;
sEP(3,f,1) = 0.25*W;  	sEP(3,f,2) = W/2+r;  sEP(3,f,3) = H+r;


wr = 2^0.5/2 ;

sEw(1,2) = wr;
sEw(1,4) = wr;

sEw(2,1) = wr;
sEw(2,2) = wr^2;
sEw(2,3) = wr;
sEw(2,4) = wr^2;
sEw(2,5) = 1;

sEw(3,2) = wr;
sEw(3,4) = wr;


[sw,sP] = GEN_12_ContractsBw (sEw, sEP, xdim, udim, sNcp);

sf(s).Ncp = sNcp;
sf(s).Degree = sDegree;
sf(s).Usize = sUsize;
sf(s).KnotV = sKnotV;
sf(s).EP = sEP;
sf(s).Ew = sEw;
sf(s).P = sP;
sf(s).w = sw;
sf(s).CS = 0;




% P's:

for s = 1:1:Nsf
    
    %{
    
    SURFACE=s
    
    x=zeros(1,3);

    for i = 1:1:sf(s).Ncp(1)

        for j=1:1:sf(s).Ncp(2)

            x(1,:) = sf(s).EP(i,j,:);

            [i j]
            [x sf(s).Ew(i,j)]

        end


    end
    %}
end


end

