function [Nsf, sf] = p9801_NURBSdefinition_4( )

% BRACKET single SURFACE but degree 5

% initial plate: L x H (directions 1 and 2) with L in mid line

% first 2 corners height: z1, z2

% RHS edge height: eh

% radius: r to mid line

% origin is at radius centre

xdim = 3 ;
udim = 2 ;

H = 80 ;
L = 160 ;
z1 = 0 ;
z2 = 0 ;
eh = 60 ;
r = 200 ;
em = -15 ; % mid-points height

twa = 100 * 3.14159/180 ; % twisting angle at end

DL = 50; % extra increment at last edge



Nsf = 1; % No. surfaces of skins


% declares structs:

sf(Nsf) = struct('Ncp',[], 'Degree',[], 'Usize',[], 'KnotV',[], 'EP',[], 'Ew',[], 'P',[],'w',[], 'CS',[0 0]);


% surface 1:

sNcp = [ 9 7 ];
sDegree = [5 5];

sKnotV = [  0 0 0 0 0 0 0.25 0.5 0.75  1 1 1 1 1 1;
            0 0 0 0 0 0 0.20 1   1     1 1 1 1 0 0 ] ;
     
sUsize = [ sNcp(1)+sDegree(1)+1 ,  sNcp(2)+sDegree(2)+1 ];

sEP = zeros(sNcp(1),sNcp(2),xdim);
sEw = ones(sNcp(1),sNcp(2));

% control points basic plate

Ta = L/r; % total angle
Da = Ta / (sNcp(1)-1); % increment of angle

a = 0 / 57.3 ; % initial angle

for i = 1:1:sNcp(1)
    
    po(1) = (r-H/2)*sin(a); % center line
    po(2) = (r-H/2)*cos(a);
    
    Dpo(1) = H/(sNcp(2)-1) * sin(a);
    Dpo(2) = H/(sNcp(2)-1) * cos(a);
    
    for j = 1:1:sNcp(2)
        
        if i<sNcp(1)-1
            
         	sEP(i,j,1) = po(1);
            sEP(i,j,2) = po(2);
            sEP(i,j,3) = 0 ;
            
       	elseif i==sNcp(1)-1

          	sEP(i,j,1) = po(1)+  0.25 * DL*cos(a);
            sEP(i,j,2) = po(2)-  0.25 * DL*sin(a);
            sEP(i,j,3) = 0 ;
            
        elseif i==sNcp(1)
            
            sEP(i,j,1) = po(1)+DL*cos(a);
            sEP(i,j,2) = po(2)-DL*sin(a);
            sEP(i,j,3) = 0 ;
            
        end

        po(1) = po(1) + Dpo(1) ;
        po(2) = po(2) + Dpo(2) ;
    end
    
    a = a + Da;
    
end



% control points heights:
% {
sEP(1,1,3) = z1;
sEP(2,1,3) = z1/2;
sEP(1,2,3) = z1/2;

sEP(1,sNcp(2),3) = z2;
sEP(2,sNcp(2),3) = z2/2;
sEP(1,sNcp(2)-1,3) = z2/2;

for j = 1:1:sNcp(2)
    sEP(sNcp(1),j,3) = eh ;
end

for j = 1:1:sNcp(2)
    sEP(sNcp(1)-1,j,3) = 0.25*eh ;
end

for i = 4:1:6
for j = 2:1:4
    
    sEP(i,j,3) = 0.75*em;
    
    if i==5 && j==3
        sEP(i,j,3) = em;
    end
    
end
end
%}

% twisting:
% {
xe1 = [sEP(sNcp(1),1,1); sEP(sNcp(1),1,2); sEP(sNcp(1),1,3)];
xe2 = [sEP(sNcp(1),sNcp(2),1); sEP(sNcp(1),sNcp(2),2); sEP(sNcp(1),sNcp(2),3)];

d = norm(xe2-xe1);
Dd = d / (sNcp(2)-1);

acc = 0;
n = sNcp(1);
cn = 4 ;

for i = cn+1:1:sNcp(2)
    
    acc = acc+Dd;
    z = acc*sin(twa);
    l = acc*cos(twa);
    
    sEP(n,i,1) = sEP(n,cn,1) + l*sin(Ta);
    sEP(n,i,2) = sEP(n,cn,2) + l*cos(Ta);
    sEP(n,i,3) = sEP(n,cn,3) + z;
end

acc = 0;
for i = cn-1:-1:1
    
    acc = acc+Dd;
    z = acc*sin(twa);
    l = acc*cos(twa);
    
    sEP(n,i,1) = sEP(n,cn,1) - l*sin(Ta);
    sEP(n,i,2) = sEP(n,cn,2) - l*cos(Ta);
    sEP(n,i,3) = sEP(n,cn,3) - z;
end
%}


%%% contracts cp's coord's and allocates:

[sw,sP] = GEN_12_ContractsBw (sEw, sEP, xdim, udim, sNcp);



%{
figure(1)
scatter3(sP(:,1),sP(:,2),sP(:,3)); 
axis equal
%}

sf(1).Ncp = sNcp;
sf(1).Degree = sDegree;
sf(1).Usize = sUsize;
sf(1).KnotV = sKnotV;
sf(1).EP = sEP;
sf(1).Ew = sEw;
sf(1).P = sP;
sf(1).w = sw;
sf(1).CS = 0;

end

