function [ ] = t9901_01_Main ( )

% 1/4 cyl. NURBS param:

xdim = 3 ;
udim = 2 ;

P = [   10  10  0   ;
        10  10  15  ;
        10  20  0   ;
        10  20  15  ;
        20  20  0   ;
        20  20  15  ];
    
w = [   1 1 2^0.5/2 2^0.5/2 1 1 ];


Degree = [2 1 ];
Ncp = [3 2];

KnotV = [ 0 0 0 1 1 1 ;
          0 0 1 1 0 0];

Usize = [6 4];

[Ew,EP] = GEN_12_ExpandBw (w, P,3, 2, Ncp);

% Select sample points:

su = 0.5 ;
sv = 1 ;

Nn = 0 ;
for u = 0:su:1
for v = 0:sv:1
    
    Nn = Nn+1 ;
    
    Ucoor(Nn,1) = u ;
    Ucoor(Nn,2) = v ;
    
    [X] = b2601_BNURBS_Xcoord ([u v], KnotV, Ncp,Degree,Usize, Ew,EP, 2,3);

    for di=1:1:xdim
    Xcoor(Nn,di) = X(di);
    
    end
    if sv>1
       sv = 1 ; 
    end
    
end
    if su>1
       su = 1 ; 
    end
end

figure(11);
scatter3(Xcoor(:,1) , Xcoor(:,2), Xcoor(:,3)); hold on
axis equal


% makes connection and elems:

DT = delaunayTriangulation(Ucoor);
conM = DT.ConnectivityList;
nE = size(conM,1);
conMe = [conM , conM(:,1)];

figure(12);

for e=1:1:nE
for a = 1:1:3
        
    n1 = conMe(e,a);
	n2 = conMe(e,a+1);
        
	x(1) = Xcoor(n1,1); y(1) = Xcoor(n1,2); z(1) = Xcoor(n1,3);
   	x(2) = Xcoor(n2,1); y(2) = Xcoor(n2,2); z(2) = Xcoor(n2,3);
        
 	plot3(x,y,z, 'k'); hold on
end
end

axis equal 



% COMPUTES INTEGRALS:


% integrates by GP = 1:

INTE1 = 0 ;

unp = zeros(3,udim);
Nne = 3 ;
for e=1:1:nE
    
    uG = [1/3 1/3];
    
    for a = 1:1:3
        n1 = conMe(e,a);
        unp(a,1) = Ucoor(n1,1); unp(a,2) = Ucoor(n1,2);
    end
    
    uv = m2321_parentMapping (uG, unp, udim, Nne);
    [X] = b2601_BNURBS_Xcoord (uv, KnotV, Ncp,Degree,Usize, Ew,EP, udim, xdim);

    [J1, detJ1] = j2315_J1_Bspline (uv, KnotV, Ncp,Degree,Usize, P, w, udim, xdim);
    
    [detJ2] = j2313_Jac2_elem (Nne, udim, unp, 0);
    
    INTE1 = INTE1 + 0.5 * detJ1 * detJ2;
    
    %{
    figure(12);
    scatter3(X(1),X(2),X(3), 'r'); hold on
    %}
 
end

INTE1




% integrates by GP = 3:

INTE3 = 0 ;

unp = zeros(3,udim);
Nne = 3 ;
for e=1:1:nE
    
    uG1 = [1/2  0 ];
    uG2 = [1/2  1/2 ];
    uG3 = [0  1/2 ];
    
    for a = 1:1:3
        n1 = conMe(e,a);
        unp(a,1) = Ucoor(n1,1); unp(a,2) = Ucoor(n1,2);
    end
    
    uv1 = m2321_parentMapping (uG1, unp, udim, Nne);
    uv2 = m2321_parentMapping (uG2, unp, udim, Nne);
    uv3 = m2321_parentMapping (uG3, unp, udim, Nne);

    [~, detJ11] = j2315_J1_Bspline (uv1, KnotV, Ncp,Degree,Usize, P, w, udim, xdim);
    [~, detJ12] = j2315_J1_Bspline (uv2, KnotV, Ncp,Degree,Usize, P, w, udim, xdim);
    [~, detJ13] = j2315_J1_Bspline (uv3, KnotV, Ncp,Degree,Usize, P, w, udim, xdim);
    
    [detJ2] = j2313_Jac2_elem (Nne, udim, unp, 0);
    
    INTE3 = INTE3 + 1/6 * (detJ11 + detJ12 + detJ13) * detJ2;
    
    %{
    figure(12);
    scatter3(X(1),X(2),X(3), 'r'); hold on
    %}


    
end

INTE3


end

