function [L] = ts9911_Lpol2 (x, a)

% RETURNS:
% Lagrangian pols of order 2

% INPUTS:
% x(3,1): three nodes position
% a: position where compute L

L = zeros(3,1); % three lagr. pols

x0 = x(1);
x1 = x(2);
x2 = x(3);

L(1,1) = (a - x1)/(x0-x1) * (a - x2)/(x0-x2);

L(2,1) = (a - x0)/(x1-x0) * (a - x2)/(x1-x2);

L(3,1) = (a - x0)/(x2-x0) * (a - x1)/(x2-x1);

end

