function [] = ts99_02_1_pWholeS (KnotV, Ncp, Degree, Usize, Ew,EP, P, udim, xdim, cF, pF, fr)

% Plots whole surface:

figure(fr)


% 1.- CONTOURS:

if cF == 1
    
    % 1.1.- Step and no. sample points:

    st = [ 0.05 0.05 ];
    ns = [1/st(1)+1 1/st(2)+1]; 

    u = zeros(udim,1);
    
    % 1.2.- Non-void spans:
    
    [Uk, nk] = GEN_18_UnonVoid (KnotV, Usize, Degree, udim);
    
    
    % 1.3.- Wires in 2-direction:
    
    for i = 1:1:nk(1)
        
        conta = 0 ;
        x = zeros(ns(2),xdim);
        
        u(1,1) = Uk(1,i);
        u(2,1) = 0;
        
        for j = 1:1:ns(2)
            
            [X] = b2601_BNURBS_Xcoord (u, KnotV, Ncp, Degree, Usize, Ew, EP, udim, xdim);
 
            conta = conta + 1 ;
            x(conta,:) = X(:,1);
            
            u(2,1) = round(u(2,1)+st(2),3);
        end

        plot3(x(:,1), x(:,2), x(:,3), 'k', 'LineWidth', 2); hold on
    end
    
        
    % 1.4.- Wires in 1-direction:
    
    for i = 1:1:nk(2)
        
        conta = 0 ;
        x = zeros(ns(1),xdim);
        
        u(2,1) = Uk(2,i);
        u(1,1) = 0;
        
        for j = 1:1:ns(1)
            
            [X] = b2601_BNURBS_Xcoord (u, KnotV, Ncp, Degree, Usize, Ew, EP, udim, xdim);
 
            conta = conta + 1 ;
            x(conta,:) = X(:,1);
            
            u(1,1) = round(u(1,1)+st(1),3);
        end

        plot3(x(:,1), x(:,2), x(:,3), 'k', 'LineWidth', 2); hold on
    end
    
end


% 2.- CONTROL NET:

if pF == 1
    
   
    scatter3(P(:,1), P(:,2),P(:,3),'r'); hold on
    
    for i = 1:1:Ncp(1)
        
        x = zeros(Ncp(2),xdim);
        
        for j = 1:1:Ncp(2)
            for di = 1:1:xdim
                x(j,di) = EP(i,j,di);
            end
        end
        plot3(x(:,1), x(:,2), x(:,3), '--r'); hold on
    end
    
    for j = 1:1:Ncp(2)
        
        x = zeros(Ncp(1),xdim);
        
        for i = 1:1:Ncp(1)
            for di = 1:1:xdim
                x(i,di) = EP(i,j,di);
            end
        end
        plot3(x(:,1), x(:,2), x(:,3), '--r'); hold on
    end
    
end


axis equal

end

