function [Unod, Xnod] = ts99_02_5_uxNod (wu, KnotV, Ncp, Degree, Usize, Ew, EP)

% RETURNS: the 6 nodes coordinates:

% INPUTS:
% wu(3,udiim): working domain vertex coordinates in parameter space

xdim = 3 ;
udim = 2 ;

% Mid-nodes position:

ewu = [wu; wu(1,:)];
mwu = zeros(3,udim);

for i = 1:1:3
    m = (ewu(i,:) + ewu(i+1,:))/2;
    mwu(i,:) = m ;
end

% All nodes coordinates in parameter and physical space:

u = zeros(udim,1);
Unod = zeros(6,udim);
Xnod = zeros(6,xdim);

for i = 1:1:3
    
    for di = 1:1:udim
        Unod(i,di) = wu(i,di);
        Unod(i+3,di) = mwu(i,di);
    end
end

for i = 1:1:6
    
    u(:,1) = Unod(i,:);
    [X] = b2601_BNURBS_Xcoord (u, KnotV, Ncp, Degree, Usize, Ew, EP, udim, xdim);
    Xnod(i,:) = X(:,1);
    
end


end

