function [] = ts99_02_Ct()


xdim = 3 ;
udim = 2 ;

% EXACT SURFACE FEATURES:

[Ncp, Degree, Usize, KnotV, w, P, Ew, EP, CD, ULims] = ts99_02_2_Sfeat();



% PRINTS WHOLE SURFACE:

fr = 1 ;
cF = 1 ;
pF = 1 ;

ts99_02_1_pWholeS (KnotV, Ncp, Degree, Usize, Ew,EP, P ,udim, xdim, cF, pF, fr)


% WORKING-DOMAIN: defined by the three vertexes of the triangle

wu = [ 0.1 0.1 ; 0.99 0.05 ; 0.4 0.88 ];
[Unod, Xnod] = ts99_02_5_uxNod (wu, KnotV, Ncp, Degree, Usize, Ew, EP);


% SAMPLE POINTS WITHIN THE TRIANGLE in pattern space:

n = 11 ;
[ss, su, Nv, EVcon, NE] = ts99_02_3_Tsamp (n, Unod);


% COORDINATES AND ERROR:

[Sr, Se, Ea] = ts99_02_6_CoordE (ss, su, Nv, Xnod, Degree, Ncp, KnotV, Usize, P ,w, EP ,Ew, CD, ULims);


% ESTIMATION OF ERROR (considers the worst case of sample points):


Xv = Xnod(1:3,:);
[R,h] = tr1342_Rnh (Xv, xdim);



% Error calculation at sample points, selects the worst case:

%{

Eem = 0 ;
L = 60 ;
p = 2 ;
m = 3 ;

mE12 = zeros(Nv,1);
mE23 = zeros(Nv,1);
mE13 = zeros(Nv,1);

for v = 1:1:Nv

    u = su(v,:);

    [f1S, f2S, f3S] = go2554_S_normS (u, Degree, Ncp, KnotV, Usize, P ,w, xdim, udim, p);
    
    c12 = zeros(xdim,1);
    c23 = zeros(xdim,1);
    c13 = zeros(xdim,1);
    
    E12 = zeros(xdim,1);
    E23 = zeros(xdim,1);
    E13 = zeros(xdim,1);
    
    for di = 1:1:xdim 
        
        c12(di,1) = f1S(di) / f2S(di);
        c23(di,1) = f3S(di) / f3S(di);
        c13(di,1) = f1S(di) / f3S(di);
        
        E12(di,1) = c12(di) ; % *  f2S(di,1);
        E23(di,1) = c23(di) ; % * f3S(di,1);
        E13(di,1) = c13(di) * R^(m) * h^(3-2*m) * f3S(di,1);
        
    end
    
    mE12(v,1) = norm(E12) ;
    mE23(v,1) = norm(E23) ;
    mE13(v,1) = norm(E13) ;
    
    if Eem < norm(E23)
        
        Eem = norm(E23) ;
        
    end

end


mE12
mE23
mE13

%}

% PLOTS:

% surfaces

fr = 20;

pt1365_fill3 (fr, EVcon, Se, 1);
pt1365_fill3 (fr, EVcon, Sr, 2);


% error:

fr = 21;

sc = 1 ;

err = zeros(Nv,3);

for v = 1:1:Nv
    err(v,1) = ss(v,1);
    err(v,2) = ss(v,2);
    err(v,3) = Ea(v,1) * sc ;
end

pt1365_fill3 (fr, EVcon, err, 1);


end

