function [sfs] = a02_surfFromSolid (Ncp, Degree, KnotV, Usize, EP, Ew)

% Extracts surfaces from solid:

xdim = 3 ;


sfs(6,1) = struct('sNcp',[], 'sDegree',[], 'sKnotV',[], 'sUsize',[], 'sP',[], 'sw',[] );

% order of surfaces:    1 and 4: perp to chi direction
%                       2 and 5: perp to ita direction 
%                       3 and 6: perp to xi  direction 


% 1.- No. cp's, degree, Usize and KnotV:

r = [1 2 ; 1 3 ; 2 3 ];

for s = 1:1:3
    
    r1 = r(s,1);
    r2 = r(s,2);
    
    for i = 0:3:3

        sfs(s+i,1).sNcp    = [Ncp(r1)     Ncp(r2)];
        sfs(s+i,1).sDegree = [Degree(r1)  Degree(r2)];
        sfs(s+i,1).sUsize  = [Usize(r1)   Usize(r2)];

        U = zeros(2,max([Usize(r1)   Usize(r2)]));
    
        U(1,1:Usize(r1)) = KnotV(r1,1:Usize(r1));
        U(2,1:Usize(r2)) = KnotV(r2,1:Usize(r2));
        
        sfs(s+i,1).sKnotV  = U;
        
    end
    
end



% 2.- CP's and weights:

for s = 1:1:3
    
    r1 = r(s,1);
    r2 = r(s,2);

    P1 = zeros(Ncp(r1)*Ncp(r2),xdim);
    P2 = zeros(Ncp(r1)*Ncp(r2),xdim);

    w1 = zeros(Ncp(r1)*Ncp(r2),1);
    w2 = zeros(Ncp(r1)*Ncp(r2),1);

    conta = 0 ;
    for i = 1:1:Ncp(r1)
    for j = 1:1:Ncp(r2)

        conta = conta + 1 ;

        % indexes selection
        if s==1

            a =[ i j 1 ];
            b =[ i j Ncp(3)];

        elseif s==2

            a =[ i 1      j ];
            b =[ i Ncp(2) j ];

        elseif s==3

            a =[ 1      i j ];
            b =[ Ncp(1) i j ];

        end
 
        
        % coordinates allocation:
        % 1 and 2 are parallel surfaces 1 and 2
        for di = 1:1:xdim
            P1(conta,di) = EP(a(1),a(2),a(3),di) ;
            P2(conta,di) = EP(b(1),b(2),b(3),di) ;
        end

        w1(conta,1) = Ew(a(1),a(2),a(3)) ;
        w2(conta,1) = Ew(b(1),b(2),b(3)) ;

    end 
    end

    
    sfs(s,1).sP  = P1 ;
    sfs(s,1).sw  = w1 ;
    sfs(s+3,1).sP  = P2 ;
    sfs(s+3,1).sw  = w2 ;

end


end
