function [vol] = a03_TetMeshVol (GP, Ngp, pKnotV, pNcp, pDegree, pUsize, pP, pw, iem, Av)

% RETURNS:
% vol: volume of a NURBS solid, that is discretized with tetrahedrons

% INPUTS:
% GP(Ngp,1): Gauss points object
% pNcp...: patch NURBS features
% iem, Av: tet-mesh features

pxdim = 3 ;
pudim = 3 ;

vol = 0 ;

iem = zeros(4,4); %%%%%%%%%%%%%%%%%%%%%%%%

for g = 1:1:Ngp

	w = GP(g,1).mw ;

	a = GP(g,1).mAcoor ;

	[~,dJ1] = j2315_J1_Bspline (a, pKnotV, pNcp, pDegree,pUsize, pP, pw, pudim, pxdim);

	Anod = zeros(4,pudim);
    for i = 1:1:4

        nR = EVcon(g,i);
        Anod(i,:) = Av(nR,:);

    end


	[~, dJ2] = j2317_J2_tets (Anod, iem);


	vol = vol + abs(dJ1*dJ2*w);

end


end

