function [] = a99ch022_plots (U, n, p , w, P, xdim, fr1, fr2, fr3, pLims)

stp = 0.02 ; % step for representation

% 1.2.- Basis functions: 

figure(fr1)

for bf = 1:1:n

    conta = 0 ;
    
    x = zeros(1,2);
    
    for xi = 0:stp:1
     
        [~,basisR] = GEN_01_CalcBF (bf,xi,p,U,n);
        conta = conta + 1 ;
        x(conta,1) = xi ;
        x(conta,2) = basisR(p+1,1);

    end

    plot(x(:,1), x(:,2), 'b'); hold on
    
end

axis equal
xlim([0 1])
ylim([0 1])


% 1.3.- Curve in physical space:

figure(fr2)

conta = 0 ;
    
x = zeros(1,xdim);
    
for xi = 0:stp:1
     
    [X] = b2601_BNURBS_Xcoord (xi, U, n, p, n+p+1 , w, P, 1,xdim);
    conta = conta + 1 ;
    x(conta,:) = X(:,1);

end

plot(x(:,1), x(:,2), 'b', 'LineWidth',1.5); hold on
plot(P(:,1), P(:,2), '--r'); hold on
scatter(P(:,1), P(:,2), 'r'); hold on

axis equal

xlim ([ pLims(1,1) pLims(1,2)])
ylim ([ pLims(2,1) pLims(2,2)])


% 1.3.- Modification of curve => affects to the whole curve

figure(fr3)

plot(x(:,1), x(:,2), 'g', 'LineWidth',1.5); hold on

Pu = P ; % moves one cp
Pu(n,1) = Pu(n,1) - 0.5 ;
Pu(n,2) = Pu(n,2) + 4 ;

conta = 0 ;
    
xu = zeros(1,xdim);

for xi = 0:stp:1
     
    [X] = b2601_BNURBS_Xcoord (xi, U, n, p, n+p+1 , w, Pu, 1,xdim);
    conta = conta + 1 ;
    xu(conta,:) = X(:,1);

end

plot(xu(:,1), xu(:,2), 'b', 'LineWidth',1.5); hold on
plot(Pu(:,1), Pu(:,2), '--r'); hold on
scatter(Pu(:,1), Pu(:,2), 'r'); hold on

axis equal

xlim ([ pLims(1,1) pLims(1,2)])
ylim ([ pLims(2,1) pLims(2,2)])


end

