function [rNcp, rDegree, rKnotV, rP, rw, rUsize] = GEN_0390_kRem_approx ...
         (uNcp, uDegree, uKnotV, uP, uw, uUsize, nX, pudim, pxdim, pa)

     
cudim = 1 ;
    
% 1.- DETECTS IF IT IS TO REDUCE:


rdi = 0 ;

for i = 1:1:size(nX,1)
    if nX(i,1)==pa
        for di = 1:1:pudim
           if nX(i,di+1)==-1
               rdi = di ;
           end
        end
    end
end




% 2.- JUST TRANSFERS:
% (if not reduction is done remains as it is)
   
    rNcp = uNcp ;
    rDegree = uDegree ;
    rKnotV = uKnotV ;
    rP = uP ;
    rw = uw ;
    rUsize = uUsize ;
    
    
if rdi > 0

    % 3.- REDUCTION:
    
	ns1 = 35; % No. sample points for LSM within the involved knot spans (in the other spans there is one single sample point and at ends of domain also)
    
    % 3.1.- Perp dirs to rdi:
    
    pdi = zeros(2,1);
    conta = 0 ;
    
    for di = 1:1:pudim
        if di~=rdi
            conta = conta + 1 ;
            pdi(conta,1) = di ;
        end
    end


    % 3.2.- Count No.cps in each direction after removal:
    
    tNcp = zeros(pudim,1);
    
    tNcp(pdi(1),1) = uNcp(pdi(1));
    tNcp(pdi(2),1) = uNcp(pdi(2));
    
    nr = gf0513_NcpRem (uDegree(rdi), uNcp(rdi));
    tNcp(rdi,1) = uNcp(rdi)-nr;
    
    
    
    % 3.3.- Refines each line:

    idx = zeros(pudim,1); % indexes used of expanded version of coordiantes
    
    [Ew,EP] = GEN_12_ExpandBw (uw, uP, pxdim, pudim, uNcp);

    NE = struct('Ncp',[],'Degree',[],'KnotV',[], 'Usize',[], 'P', [], 'w', [] );

    rEP = zeros(tNcp(1),tNcp(2),tNcp(3), pxdim);
    rEw = zeros(tNcp(1),tNcp(2),tNcp(3) );
    
    for i = 1:1:uNcp(pdi(1))
    for j = 1:1:uNcp(pdi(2))

        % relevant indexes in relevant positions:
        
        idx(pdi(1)) = i ;
     	idx(pdi(2)) = j ;
        
        
        % treats each line as an individual NURBS entity, and allocates:
        
        NE.Ncp      = uNcp(rdi);
        NE.Degree   = uDegree(rdi);
        NE.KnotV    = uKnotV(rdi,:);
        NE.Usize    = uUsize(rdi);

        
        % Extracts cps in rdi direction
        
        P = zeros(uNcp(rdi),pxdim);
        w = zeros(uNcp(rdi),1);
        
        for k = 1:1:uNcp(rdi)

            idx(rdi) = k ;
            P(k,:) = EP(idx(1),idx(2),idx(3),:);
            w(k,1) = Ew(idx(1),idx(2),idx(3));
            
        end

        NE.w = w';
        NE.P = P;

        [NE] = gf0512_removeLSMn (NE, ns1, pxdim, cudim);
 
        for k = 1:1:NE.Ncp
            
            idx(rdi) = k ;
            rEP(idx(1),idx(2),idx(3),:) = NE.P(k,:) ; 
            rEw(idx(1),idx(2),idx(3))   = NE.w(k) ;
            
        end

    end
    end


    
    % 3.4.- Allocates features back to patch:

    rNcp(rdi)       = NE.Ncp ;
    rDegree(rdi)    = NE.Degree ;
    rUsize(rdi)     = NE.Usize ;

    for i = 1:1:uUsize(rdi)
        if i <= NE.Usize
            rKnotV(rdi,i) = NE.KnotV(i);
        else
            rKnotV(rdi,i) = 0;
        end
    end

    [rw,rP] = GEN_12_ContractsBw (rEw, rEP, pxdim, pudim, rNcp);

end





end

