function [] = GEN_0399_kRem_inter (r)

% INPUTS:
% r: position in the control point to remove

[ p,n,U,w,P ] = a04_NURBScurve( );


% Q = [ 0  ; 1 ; 2.4 ; 4.4 ; 8 ; 9 ; 12  ];

xdim = size(P,2) ;
udim = 1 ;

m = n + p + 1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% 1.- First and last cp's susceptible to be removed:

Fc = ceil(p/2)+1;
Lc = ceil(p/2)+n-p-1;


% 2.- Involved cps refs for the removal of r:

nL = floor((p-1)/2);

nR = floor(p/2);

Nc = nL + 1 + nR;

IC = [r-nL : 1 : r+nR ]';


% 3.- Associated knots refs to IC:

IK = zeros(Nc,1);
for i = 1:1:Nc
    IK(i,1) = IC(i) - Fc + p + 2 ;
end

kr = r - Fc + p + 2 ; % knot ref to remove


% 4.- Sample points: parameter and physical coordinates
% they are just the average within each knot span

us = zeros(Nc-1,udim);
xs = zeros(Nc-1,xdim);

for i = 1:1:Nc-1
    
    u = (U(IK(i)) + U(IK(i+1))) / 2 ;
    
    us(i,1) = u ;
    
   x = b2601_BNURBS_Xcoord (u, U, n, p, n+p+1, w, P, udim, xdim);
   xs(i,:) = x(:,1);
    
end

% 5.- Reduced values:

% 5.1.- Knot vector & Npcs:

Ur = zeros(1,m-1);
nr = n - 1 ;

mr = m-1;

j = 0 ;
for i = 1:1:m
    if i~=kr 
        j = j+1;
        Ur(j) = U(i);
    end
end

% 5.2.- Basis functions values

N = zeros(Nc-1,nr); 

for i = 1:1:Nc-1 
    
    u = us(i);

    for b = 1:1:nr

        [B] = b2604_MNL (u, b, Ur, nr, p, mr, udim);
        
        N(i,b) = B ;
        
    end

end


% 6.- System of equations: Nu Pu = c

% Nu:   basis functions of unknowns
% Pu:   unknown cps
% c:    vector c = xs - NkPk
%       with Nk and Pk the basis functions and cps that are known

ur  = [IC(1):1:IC(Nc)-1]; % unknown cp refs in reduced arrangement
kr1 = [1:1:IC(1)-1];
kr2 = [IC(Nc):1:nr];

wr = [w(1:r-1) , w(r+1:n)] ;
T = [P(1:r-1,:) ; P(r+1:n,:)]; % temporaty P with no r cp

Nu = [ N(:,ur) ] ;
% Pu = zeros(Nc-1,xdim);

Nk = [ N(:,kr1),  N(:,kr2) ];
Pk = [ T(kr1,:);  T(kr2, :) ];

c = xs - Nk*Pk ;

Pu = Nu\c ;



% 7.- Allocates control points:
% Pr is the 'refined' control points position

Pr = [ T(kr1,:) ; Pu ; T(kr2, :) ];

% {
figure(88)

scatter(P(:,1), P(:,2), 'k'); hold on
scatter(Pr(:,1),Pr(:,2),'r'); hold on

axis equal
%}


% prints:

C  = zeros(1,xdim);
Cr = zeros(1,xdim);



conta = 0 ;

for u = 0:0.05:1
    
    conta = conta+1;
    
    [X] = b2601_BNURBS_Xcoord (u, U, n, p, n+p+1, w, P, udim, xdim);
    C(conta,:) = X(:,1);
    
 	[X] = b2601_BNURBS_Xcoord (u, Ur, nr, p, nr+p+1, wr, Pr, udim, xdim);
    Cr(conta,:) = X(:,1);
    

    
end

figure(8)

plot(C(:,1),C(:,2),'k'); hold on
plot(Cr(:,1),Cr(:,2),'r'); hold on


axis equal

end

