function [Ncp,Degree,KnotV,B,w, noc,Usize] = GEN_03_00_zoneNURBS_refinement ...
         (Ncp,Degree,KnotV,B,w, noc,Usize, padd, nX, hrefZ, udim, xdim, pa)

% CARRIES OUT NURBS "TRADITIONAL" REFINEMENT for certain zone

% INPUTS:
% Ncp,Degree,KnotV, Usize:  patch features
% B,w:	Cp's X coor's and weights (collapsed form)
% pa:   patch reference (cor nX and nIn matrices)  


% GENERATES nIn acc/to hrefZ:

[nInZ] = GEN_03_11_hrefZone (hrefZ, udim);


% nIn(4,4) indicates which patch, and point param. coord's to be
% inserted
% are inserted; if = 0 then there is no refinement
    
% xie => % new knot coordinates, changes for each direction
    
    
for i=1:1:size(nInZ,1)
    if nInZ(i,1) == pa
            
        % 3.1.- Insertion in each direction:
        
        for d=1:1:udim
            
            sal = 0 ; % changes to 1 if new knot already exists
            xie = nInZ(i,d+1); % new knot position to insert

            % A.- copy knot vector in that direction, and detects if xie
            % exists already:
            
            Uet = zeros(Usize(d),1);
            for j=1:1:Usize(d)
               Uet(j) = KnotV(d,j); 
               if round(xie,5) == round(Uet(j),5)
                   sal = 1 ;
               end
            end
    
            
            % B.- Only continues if new knot position is non-existing:
            
            if sal ==0
               
                [Be, Ue, we, Ncpe, Utame] = GEN_03_10_1D_kSingleExt...
                                (Ncp, Degree(d), Uet, B, w, xie, d, xdim, udim);
                
                % updates geometrical parameters to refined mesh:
                Ncp = Ncpe ;
                B = Be;
                Usize(d) = Utame;
                for j=1:1:Utame
                   KnotV(d,j) = Ue(j); 
                end
                w = we;
            end

        end
      
    end
end
    
    
% 3.2.- Updates total No. control points:
    
noc = 1 ;
for di=1:1:udim
    noc = noc * Ncp(di); 
end
  
    

end