function [Ncpe,KnotVe, Be, we, noce, Usizee] = GEN_03_02_pRefinement...
    (Ncp, KnotV, Degree, B,w, pe, noc, Usize, udim, xdim)

% returns degree elevated parameters:


% 1.- Initially returns the same as inputs unless they are elevated:
noce = noc ;
Ncpe = zeros(udim,1);
Usizee = zeros(udim,1);
KnotVe = zeros(udim,max(Usize));
Be = zeros(noc,xdim);
we = zeros(noc,1);

for d=1:1:udim
    
    Ncpe(d) = Ncp(d);
    Usizee(d) = Usize(d);
   
    for i=1:1:Usize(d)
        KnotVe(d,i) = KnotV(d,i);
    end
end


Be(:,:)= B(:,:);
we(:)  = w(:);


% 2.- Projects  coordinates:

Bw(noc,xdim+1)=0;

for cp=1:1:noc
    for d = 1:1:xdim
    Bw(cp,d) = Be(cp,d)*we(cp);
    end
    Bw(cp,xdim+1) = we(cp);
end



% 3.- Expand Bw by indexes (it is much easier working then):

nL = ones(3,1);
for di=1:1:udim
   nL(di) = Ncpe(di); 
end

EBw = zeros(nL(1),nL(2),nL(3),xdim+1);
conta=1;
for i=1:1:nL(1)
for j=1:1:nL(2)   
for k=1:1:nL(3)
    
    for dir=1:1:xdim+1
        EBw(i,j,k,dir) = Bw(conta,dir);
    end

    conta=conta+1;
end    
end    
end



% 4.- Identifies  required = pe-Degree
tinc = zeros(udim,1);
for d=1:1:udim
    tinc(d) = pe(d)-Degree(d);
end


% 5.- Works in each parameter direction:

for d=1:1:udim   
if tinc(d)>0 % requires elevation
    
    % resets values:
    cK = zeros(1,1);
    iK = zeros(1,1);
    
    % values for that direction
    Ue = zeros(Usize(d),1);
    Ue(:,1) = KnotVe(d,1:Usize(d));
    p = Degree(d);

    if (Usize(d)>(p+1)*2) % checks if is not a Bezier already
        
        % extract Bezier curves and No. curves
        [EBwz,Noz, cK, iK] = GEN_03_03_1D_DivideBezier(p, Ncpe, Ue, EBw,d, xdim, udim) ;
        
    else
        
        for a1=1:1:size(EBw,1)
        for a2=1:1:size(EBw,2)
        for a3=1:1:size(EBw,3)
        for a4=1:1:size(EBw,4)
             EBwz(1,a1,a2,a3,a4) = EBw(a1,a2,a3,a4);        
        end 
        end
        end
        end
        Noz=1; cK(1)=p; iK(1)=0; % see meaning below
    end 

    % note:
    % Noz:  No. Bezier segments
    % cK:   continuity of internal knots (of original knot vector with no refinement)
    % iK:   No. internal knots (of original knot vector with no refinement)
    
    
    % For each Bezier segment calculates new CP's to comply with 
    % new degree(pe). They are stored in extended EQwz
    [EQwz] = GEN_03_04_1D_BezierPmax(EBwz,p,tinc(d),Noz,Ncpe,d,xdim,udim);
    
    % extended knot vector containing Noz Bezier curves
    % nze: No Cp's
    [Uze,nze] = GEN_03_05_Uze(pe(d),Noz,Ue,Ncpe(d),iK);
    
    % CP's vector: joints the Bezier curves
    [EQwez] = GEN_03_06_1D_CPzmax(nze,Ncpe,Noz,pe(d),EQwz,d,udim,xdim);
    
    % Reduces No CP's according to its continuity (contained in cK(i))
    % calculates elevated knot vector
    [EQwe,Ue,Ncpe] = GEN_03_07_1D_CpKnot(nze,Ncpe,cK,pe(d),Uze,EQwez,Noz,d,xdim,udim);
    
    % transfers values:
    Usizee(d) = Ncpe(d)+pe(d)+1 ;
    
    for i=1:1:Usizee(d)
        KnotVe(d,i) = Ue(i);
    end
    EBw = EQwe;
    

end % condition of necessity of p-refinement
end % loop on udim




% 6.- UN-projects and Un-exand coordinates and transfer
%     to response coordinates and total No. cp's:

nL=ones(3,1);
for dir=1:1:udim
    nL(dir) = Ncpe(dir);
end


noce = nL(1)*nL(2)*nL(3);

conta=1;
for i=1:1:nL(1)
for j=1:1:nL(2)
for k=1:1:nL(3)
    
    for dir=1:1:xdim
        Be(conta,dir) = EQwe(i,j,k,dir)/EQwe(i,j,k,xdim+1);
    end
    we(conta) = EQwe(i,j,k,xdim+1);
    conta=conta+1;
    
end
end
end


end