function [Uze,nze] = GEN_03_05_Uze(pe,Noz,U,n,iK)

% RETURNS:
% nUze: extended knot vector containing Noz Bezier curves
% nze:  No Cp's for extended 

% INPUTS:
% pe:   extended degree in relevant direction
% Noz:  No. Bezier curves
% U:    knot vector in the relevant direction
% n:    No. cps in direction relevant
% iK:   internal knots (non first and last of U)



nze = (pe+1) + (Noz-1)*pe;
Uze = zeros((nze+pe+1),1) ; 

conta=1;
j=1;

for i=1:1:(nze+pe+1) % loop on knot components
    
    if i <= pe+1            % initial components
        
        Uze(i) = U(1);      
    
    elseif i > nze          % final components
        
        Uze(i) = U(n+1);
    
    else                    % intermediate components
            
        Uze(i)=iK(j);
        conta=conta+1;
        
        if conta>pe 
            conta=1;
            j=j+1;
        end
    
    end
    
end % knot components
    
end