function [EQwez] = GEN_03_06_1D_CPzmax(nze,Ncpe,Noz,pe,EQwz,d,udim,xdim)

% RETURNS:
% EQwez: physical coord's of cp extended vector, with all Bezier curves
% merged in a single one

% INPUTS:
% nze:  No. cp's in relevant direction
% Ncpe: No. cp's in each direction



% 1.- No. cp's in each direction

nL = ones(3,1);    % total No. cp's in each direction
nLzi= ones(3,1);   % initial cp's ref's for each Bezier partition
nLzf= ones(3,1);   % final   cp's ref's for each Bezier partition

for di=1:1:udim
    
    if di == d
        nL(di) = nze;
        nLzi(di)= 2 ;
        nLzf(di)= pe+1;
    else
        nL(di) = Ncpe(di);
        nLzi(di)= 1 ;
        nLzf(di)= Ncpe(di);
    end
end


% 2.- Sizes response:

EQwez = zeros(nL(1),nL(2),nL(3), xdim+1);


% 3.- Loop on Bezier curves to transfer data:

for z=1:1:Noz
        
    if z==1 % first span

        for i=1:1:nLzf(1) 
        for j=1:1:nLzf(2)
        for k=1:1:nLzf(3)
        for dir=1:1:xdim+1
            
            ri=i; % references for response array
            rj=j;
            rk=k;
            
            EQwez(ri,rj,rk,dir) = EQwz(z,i,j,k,dir);
            
        end
        end
        end 
        end

    else % next spans

        for i=nLzi(1):1:nLzf(1)
        for j=nLzi(2):1:nLzf(2)
        for k=nLzi(3):1:nLzf(3)
        for dir=1:1:xdim+1
            
            ri=i; % references for response array
            rj=j;
            rk=k;
            
            % modifies references according to selected d
            if d==1
                ri = (z-1)*pe + i ;
            elseif d==2
                rj = (z-1)*pe + j ;
            elseif d==3
                rk = (z-1)*pe + k ;
            end
            EQwez(ri,rj,rk,dir) = EQwz(z,i,j,k,dir);

        end
        end
        end 
        end

    end 
end





end