function [EQwe,Uex,Ncpe] = GEN_03_07_1D_CpKnot(nze,Ncpe,cK,pe,Uze,EQwez,Noz,d,xdim,udim)

% Reduces No. CP's according to its continuity (contained in cK(i))

% RETURNS:
% EQwe(i,j,k,dir):  extended projected CP's of the elevated curve
% Uex:              knot vector elevated
% Ncpe:             No. CP's with elevated curve
 

        
% 1.- Prepares some parameters:

nL=ones(3,1);
for di=1:1:udim
    nL(di) = Ncpe(di);
end


ne = nze ;
        
for i=1:1:Noz-1
    ne = ne - cK(i);
end

EQwe = zeros(1,1,1,xdim+1);
Ue(ne+pe+1) = 0 ;
Uet1 = Uze ;
Uet2 = zeros(1);
EQwet1 = EQwez ;
EQwet2(1) = zeros(1);
net = nze ;


for z=Noz-1:-1:1 % loop on internal knots (not repeated), goes backwards
        
red=1;  % reduction can be 0,1 or 2 depending on the cont., the
        % formulas change according to which reduction step we are in  
        
for c=1:1:cK(z)
            
    if red==1 % first reduction
                
        kr = pe+1 + z*pe ;  % knot ref. to be removed
        cr = kr-pe ;        % CP to remove
         
        
        
        % CP's:
        
        for dir=1:1:xdim+1
            
            if d==1
            
                for j=1:1:nL(2)
                for k=1:1:nL(3)

                    for i=1:1:cr-1
                        EQwet2(i,j,k,dir) = EQwet1(i,j,k,dir);
                    end

                    for i=cr:1:net-1
                        EQwet2(i,j,k,dir) = EQwet1(i+1,j,k,dir);
                    end 

                end
                end
            
            elseif d==2
                
                for i=1:1:nL(1)
                for k=1:1:nL(3)

                    for j=1:1:cr-1
                        EQwet2(i,j,k,dir) = EQwet1(i,j,k,dir);
                    end

                    for j=cr:1:net-1
                        EQwet2(i,j,k,dir) = EQwet1(i,j+1,k,dir);
                    end 

                     
                end
                end
                
            elseif d==3
                
                for i=1:1:nL(1)
                for j=1:1:nL(2)

                    for k=1:1:cr-1
                        EQwet2(i,j,k,dir) = EQwet1(i,j,k,dir);
                    end

                    for k=cr:1:net-1
                        EQwet2(i,j,k,dir) = EQwet1(i,j,k+1,dir);
                    end 

                end
                end  
            end
            
        end
        
        
        
        % knot vector:
        for i=1:1:kr-1
            Uet2(i) = Uet1(i);
        end
        for i=kr+1:1:net+pe+1
            Uet2(i-1) = Uet1(i);
        end 
        
        Uet1=Uet2;
        Uet2=zeros(1);
        EQwet1=EQwet2;
        EQwet2=zeros(1,1,1);
        net=net-1;
        red = red+1;
        
    elseif red==2 % second reduction
                
        kr = pe+1 + z*pe-1 ;  % knot ref. to be removed
        cr = kr-pe  ;        % CP to remove, and +1
        ur = Uet1(kr) ;
        ar = (ur-Uet1(cr))/(Uet1(cr+pe+2)-Uet1(cr));
                
                
        % CP's:

        for dir=1:1:xdim+1
        
            if d==1

                for j=1:1:nL(2)
                for k=1:1:nL(3)

                    for i=1:1:cr-1
                    EQwet2(i,j,k,dir) = EQwet1(i,j,k,dir);
                    end
                    EQwet2(cr,j,k,dir) = (EQwet1(cr,j,k,dir) - (1-ar)*EQwet1(cr-1,j,k,dir))/ar;
                    for i=cr+1:1:net-1
                    EQwet2(i,j,k,dir) = EQwet1(i+1,j,k,dir);
                    end 

                end
                end

            elseif d==2

                for i=1:1:nL(1)
                for k=1:1:nL(3)

                    for j=1:1:cr-1
                    EQwet2(i,j,k,dir) = EQwet1(i,j,k,dir);
                    end
                    EQwet2(i,cr,k,dir) = (EQwet1(i,cr,k,dir) - (1-ar)*EQwet1(i,cr-1,k,dir))/ar;
                    for j=cr+1:1:net-1
                    EQwet2(i,j,k,dir) = EQwet1(i,j+1,k,dir);
                    end 

                end
                end

            elseif d==3
                
                for i=1:1:nL(1)
                for j=1:1:nL(2)

                    for k=1:1:cr-1
                    EQwet2(i,j,k,dir) = EQwet1(i,j,k,dir);
                    end
                    EQwet2(i,j,cr,dir) = (EQwet1(i,j,cr,dir) - (1-ar)*EQwet1(i,j,cr-1,dir))/ar;
                    for k=cr+1:1:net-1
                    EQwet2(i,j,k,dir) = EQwet1(i,j,k+1,dir);
                    end 

                end
                end
            end
        
        end
       
        % knot vector:
        for i=1:1:kr-1
            Uet2(i) = Uet1(i);
        end
        for i=kr+1:1:net+pe+1
            Uet2(i-1) = Uet1(i);
        end 
        Uet1=Uet2;
        Uet2=zeros(1);
        EQwet1=EQwet2;
        EQwet2=zeros(1,1,1,1);
        net=net-1;
    end
            
            
end % loop on continuity 
end % loop in internal knots
   


EQwe = EQwet1 ;
Uex = Uet1 ;
Ncpe(d) = net;

end