function [nInZ] = GEN_03_11_hrefZone (hrefZ, udim)

% RETURNS:
% nInZ(patch, xi, ita, chi) insertions

% INPUTS:
% herfZ(i,13): defines zones

n = 0 ; % No. insertions
nInZ  = zeros(1,4);

for z = 1:1:size(hrefZ,1)
    
    if hrefZ(z,1)>0
        
        paR = hrefZ(z,1) ;
        
        % 1.- Defines L, NE & BI in each direction
        
        INI = zeros(udim,1); % initial Ucoor of zone
        LAS = zeros(udim,1); % initial Ucoor of zone
        L = zeros(udim,1); % span
        NE = zeros(udim,1); % No elments
        BI = zeros(udim,1); % Bias
        
        conta = 3 ;
        for di=1:1:udim
            
            INI(di,1) = hrefZ(z,conta-1) ;
            LAS(di,1) = hrefZ(z,conta) ;
            
            L(di,1)  = hrefZ(z,conta) - hrefZ(z,conta-1);
            NE(di,1) = hrefZ(z,7+di); 
            BI(di,1) = hrefZ(z,10+di);
            conta = conta+2;
        end
        

        
        % 2.- Defines Uinsertions in each direction: Uin
        
        Uin = zeros(udim,1);
        
        for di=1:1:udim
            
            bstep = (BI(di) - 1) / (NE(di)-1);
            
            % factor for each element span:
            f = zeros(NE(di),1);
            
            for e = 1:1:NE(di)
                f(e) = BI(di)-(e-1)*bstep;
            end
            
            % smallest element span:
            sep = L(di)/sum(f);
            
            acc = INI(di);
            for e = 1:1:NE(di)
                
                Uin(di,e) = acc ;
                acc = acc + f(e) * sep ;
            end
            
            Uin(di,e+1) = LAS(di);
            
        end
        
        format long
        
        Uin'
        
        format short

        % 3.- Extends nInz:
        
        for di=1:1:udim
        for i = 1:1:NE(di)+1  
            
            n = n+1;
            nInZ(n,1)  = paR ;
            nInZ(n,di+1) = Uin(di,i);

        end    
        end
        
        
        
    end
    
end



end

