function rs=BasisN_0(bf,u,U,p,n)

%THIS FUNCTION EVALUATES THE N_0 BASIS FUNCTION bf AT THE LOCATION xi

% U:    knot vector
% bf:   basis function reference. Is the function where u is evaluated
% n:    No. control points = No. basis functions
% p:    order of NURBS


% Particularities for T splines:
% U has p+2 knots
% bf is equal to the column of the basisF matrix (the final bf is always 1)
% n = 0, there is no point for n in T splines


Usize = size (U,2);
if Usize==1
    Usize = size(U,1);
end



rs=0;


if ( round(u,12) >= round(U(bf),12)) && ( round(u,12) <= round(U(bf+1),12) ) % only continues if u belongs to closed interval
  
%{
if n==18  % && round(EB(1,1),4) == 30.7180
if u == 1 && bf == 18
if round(U(5),4)==0.1328  % && basisF(1,1)==18

    
    format long
    
    
    u
    U(bf)
    U(bf+1)
    
    format short
    
end
end
end
%}
    
  
    if round(U(bf),12) ~= round(U(bf+1),12)  % standard case


        if (u >= U(bf)) && (u<U(bf+1))
            rs=1;
        else
            rs=0;
        end

        if rs== 0 

            % checks if bf is the last one, in that case is one: SUSPENDED
            %if bf==Usize-1
            %   rs=1; 
            %end


            if u==U(bf+1) && U(bf+1)==U(Usize)

                % special case where u is just at the end of the last non-void
                % knot span
                rs = 1 ;

            end


        end

   
    
    elseif round(U(bf),12) == round(U(bf+1),12)  % knot vector components involved have same value


            %{
            for i=2:1:Usize
            if U(i)==U(Usize)
                bfOne = i;
                break
            end
            end

            if bf+1==bfOne
                rs=1;
            else
                rs=0;
            end

            %}

    end



    % this is for a special case of u = U(latest value)

    if size(U,2)== p+2 % treatment as T spline

        %{
        if u==U(p+2)

            last=1; % check if last anchor
            for i=2:1:p+1
                if U(i)~=U(i+1)
                last=0; % not the last anchor
                break
                end
            end

            if last==1
                rs=1;
            end

        end
        %}
        %if bf==1 && u==U(p+2)
            %rs=1;
        %end

    else % treatment as B spline

        if (bf==n) && (u==U(n+p+1))
            rs=1;
        end

    end


end % condition to continue
    

end
