function rs = BasisN_h(basisR, bfp, col , u, h, U)

% THIS FUNCTION EVALUATES THE BASIS FUNCTION OF HIGHER ORDER THAN 0, THAT 
% IS  ORDER (h+1), AT THE LOCATION u

% basisR:       basis functions of lower orders already evaluated for xi

% u:            location to be evaluated
% h+:           order of basis function to be evaluated
% U:    ie        knot vector
% col:          is the actual position in the basisR matrix. It is
%               used to evaluate lower order N functions (in theory
%               nomenclature Ni,p-1 and Ni+1,p-1)

% in case of T splines: U is (p+2) size, and col=bf

    % rs1 is the first summand
    if U(bfp+h)==U(bfp)
        rs1=0;
    else
        rs1= (u-U(bfp)) / (U(bfp+h)-U(bfp)) * basisR(h,col);
    end

    % rs2 is the second summand
    if U(bfp+h+1)==U(bfp+1)
        rs2=0;
    else
        rs2= (U(bfp+h+1)-u) / (U(bfp+h+1) - U(bfp+1)) * basisR(h,col+1) ;
    end

    rs= (rs1 + rs2);
    
    % OJO AQUI!! ES UN PARCHE QUE NO SE SI FUNCIONA!!
    if rs==2
       %rs=1; 
    end

end
