function [basisF,basisR] = GEN_01_CalcBF (bf,xi,p,U,n)

% RETURNS TWO MATRICES: 
% basisF (references of non vanishing functions)
% basisR (results )  of non vanishing functions)

% both are (p+1 rows) x (p+1 cols)

% n:    No control points
% bf:   basis function reference
% xi:   where to calculate basisR
% p:    degree of NURBS
% U:    knot vector

% NOTE: for T-splines.
% bf and n = 1
% U is local knot vector


% 1.- Initiates responses:

basisF = zeros(p+1,p+1);
basisR = zeros(p+1,p+1);



% 2.- Calculates basisF:

for fil=1:1:p+1
for col=1:1:p+1
    
    if col<= p+2-fil
        basisF(fil,col) = bf-1+col;
    end
       
end
end


% 3.- Calculates basisR:

for fil=1:1:p+1
for col=1:1:p+1
    
    if col<= p+2-fil
        
        bfp = basisF(fil,col);
        if fil==1 % basis function order 0
                    
            basisR(fil,col)= BasisN_0 (bfp, xi, U, p,n);
             
            %{
         	if n==18  % && round(EB(1,1),4) == 30.7180
            if xi == 1 && bfp == 18
            if round(U(5),4)==0.1328  && basisF(1,1)==18
                
                fil
                
                 
                
                bfp
              basisR
                
                %BasisN_0(bfp, xi, U, p,n)
                
            end
            end
            end
            %}
            
        else % basis functions of higher order
                    
            h= fil-1; % order to be evaluated
            
            basisR(fil,col)= BasisN_h(basisR,bfp,col,xi,h,U);

        end
    end
    
end
end





end
