function dBS = GEN_02_CalcDerBF(bf, p, ka, bR, U)

% RETURNS: dBS(ka+1): derivatives of B-spline up to ka order

% bR is the matrix of the results of basis functions bN, bN+1 ... at point
% u, the order increase from the 1st row to the last

% bf:   basis function reference or span
% U:    knot vector
% it requires calculate previously bR


% 1.- Construct factors matrix a():

a = zeros (ka+1, ka+1);


for fil=1:1:ka+1
for col=1:1:ka+1

    if fil==1 && col==1

        a(fil,col)=1;

    elseif col==1

        if (U(bf+p+1-(fil-1))-U(bf))==0 
            a(fil,col)= 0 ;
        else
            a(fil,col)= a(fil-1,1) / (U(bf+p+1-(fil-1))-U(bf)) ;
        end

    elseif fil == col

        if (U(bf+p+1)-U(bf+(col-1)))==0
            a(fil,col)= 0 ;
        else
            a(fil,col)= -a(fil-1,col-1) / (U(bf+p+1)-U(bf+(col-1))) ;
        end
    end

end
end


for fil=3:1:ka+1
for col=2:1:fil-1
    
        if ( U(bf+p+(col-1)-(fil-1)+1)  -  U(bf+(col-1)  ))==0
            a(fil,col) =0;
        else
          a(fil,col) = ( a(fil-1,col) - a(fil-1,col-1) ) / ...
            ( U(bf+p+(col-1)-(fil-1)+1)  -  U(bf+(col-1))  ) ; 
        end
   
end
end



% 2.- Derivatives:

dBS = zeros(ka+1,1);

dBS(1)=bR(p+1,1);
    

for der = 2 : 1 : ka+1
       
    aN = 0 ;
    
    for j = 0 : 1 : der-1
        aN = aN + a(der,j+1) * bR(p+1-(der-1),j+1);
    end
    
    dBS(der) = aN * factorial(p)/factorial(p-(der-1)) ; 
    
end



end