function [rU] = GEN_06_ReverseKnotV (U, n, p)

% RETURNS:
% rU: knot vector U reversed

% INPUTS:
% U: original knot vector
% n,p: No. cp's and degree

Usize = n+p+1;

if size(U,1)==1
    rU = zeros(1,Usize);
elseif size(U,2)==1
    rU = zeros(Usize,1);
end


% Knot vector end values
for i = 1:1:p+1
    rU(i)   = 0;
    rU(i+n) = 1;
end

% Knot vector intermediate values
if Usize > 2*(p+1)
         
    % stores intermediate knot spans:
    
  	temp =zeros(1,1);
   	conta = 0 ;
  	for i = p+2:1:n+1
    	conta = conta+1;
    	temp(conta,1) = U(i)-U(i-1);
    end
         
 	[temp] = GEN_40_invertRowsOrder(temp);
        
 	conta=0;
   	for i = p+2:1:n+1
        
        conta = conta+1;
      	rU(i) = rU(i-1) + temp(conta,1);
        
    end
end

end

