function IN = GEN_08_Orthodomain_Pin (P, domL, dim, modo, tol)

% note: previous name: GEN_08_CPdomain_Pin

% RETURNS:
% IN:  = 1 if point is inside "orthogonal" domain, otherwise IN=0 if not
% "orthogonal" domain: line, rectangle or cube, aligned with orthogonal reference base (x,y,z)


% INPUTS:
% P:    coordinates of the point to evaluate
% domL:  domain limits (udim,1/2)
% dim: No. dims space
% modo: values 'opened' or 'closed' to define the belonging
% tol: abs value to account for tolerance

% 1.- Initiates response to 0:

IN = 0 ;



% 2.- Determines whether P is in or out of domain

INcond = zeros(dim,1); % if all are one => belongs to the domain

if strcmp(modo,'opened') % open boundary
    
    for dir = 1:1:dim
    if domL(dir,1)+tol < P(dir) && P(dir) < domL(dir,2)-tol
        INcond(dir) = 1 ;
    end
    end
    
end


if strcmp(modo,'closed') % closed boundary
    
    for dir = 1:1:dim
    if domL(dir,1)-tol <= P(dir) && P(dir) <= domL(dir,2)+tol
        INcond(dir) = 1 ;
    end
    end
    
end


if sum(INcond) == dim
   IN = 1 ; 
end


end

