function Umerged = GEN_09_MergesKnotVectors(udim, U,V,T)

% RETURNS:
% Umerged:  matrix with all the knot vectors, they must be consistent in
% No. components, then completes with zeros if required
% Umerged (udim, No. knot of longest knot vector 

% INPUTS:
% udim: No. dims in parameter space
% U,V,T: knot vectors, introduce 0 if it does not apply

% note: knot vector are column vectors, so it will be rquired to transpose
% them to construct the Umerged matrix


% 1.- Computes max. No. knots:
maxK = max (size(U,1),size(V,1));
maxK = max (maxK , size(T,1));

% 2.- Preallocates the answer:
Umerged = zeros(udim,maxK);


% 3.- Transfers answer:
for col=1:1:maxK
       
    if udim >= 1
        if col<= size(U,1)
            Umerged(1,col) = U(col,1);
        else
            Umerged(1,col) = 0 ;
        end
        
        if udim >= 2
            if col<= size(V,1)
                Umerged(2,col) = V(col,1);
            else
                Umerged(2,col) = 0 ;
            end 

            if udim == 3
                if col<= size(T,1)
                    Umerged(3,col) = T(col,1);
                else
                    Umerged(3,col) = 0 ;
                end
            end
        end
    end
    
    

   
end





end