 function LP = GEN_10_LocalPosition_ijk(cp, xdim, udim,m,l)
            
% provides position in the patch stiffness matrix of certain cp
% is the first position of the cp vector (which can have 1, 2
% or 3 components , depending on xdim)
% uses cp references i,j,k
     
% INPUTS:

% cp:       control point reference
% xdim:     No. dims in physical space
% n,m,l:    No. cp's for each direction

if udim ==1
                
    i = obj.icp(cp);              
    LP = i * xdim - xdim + 1 ;

elseif udim ==2
                
    i = obj.icp(cp,1);
    j = obj.icp(cp,2);              
    LP = ((i-1)*m + j )* xdim - xdim + 1 ;

elseif udim ==3
                
    i = obj.icp(cp,1);
    j = obj.icp(cp,2);
    k = obj.icp(cp,3);              
    LP = ((i-1)*(m*l) + (j-1)*l + k )* xdim - xdim + 1 ;

end

end
