function [w,B] = GEN_12_ContractsBw (Ew, EB, xdim, udim, Ncpo)

% RETURNS:
% w,B:   contracted cp's coordinates (ncp) from expanded (i,j,k) 

% INPUTS:
% Ew,EB:        cp's expanded coord's
% xdim:         physical dimensions
% Ncpo:         No. cp's in each direction (original, might be expanded)


% 0.- Expand Ncp to have 3 elements:

noc = 1;
Ncp = ones(3,1);
for di = 1:1:udim
    Ncp(di) = Ncpo(di);
    noc = noc * Ncpo(di);
end


% 1.- Sizes responses:

w = zeros(noc,1);
B = zeros((noc),3); % fills up 3 xdims, but might use less



% 2.- Loop on subindexes:

conta=1;

for i=1:1:Ncp(1)
for j=1:1:Ncp(2)
    
    if udim==2
        
       w(conta) = Ew(i,j);

        for dir=1:1:xdim
            B(conta,dir) = EB(i,j,dir); 
        end

        conta = conta+1; 
        
    elseif udim==3
        
        for k=1:1:Ncp(3)   
   
            w(conta) = Ew(i,j,k);

            for dir=1:1:xdim
               B(conta,dir) = EB(i,j,k,dir); 
            end

            conta = conta+1;
        end
        
    end
    
end 
end



end

