function [Ew,EB] = GEN_12_ExpandBw (w, B,xdim, udim, Ncpo)

% RETURNS:

% Ew:   extended weights array, Ew(i,j,k), always 3 udims, but values of
%       some of them can be 0 depending on udim

% EB:   extended cp's physical coord's, EB(i,j,k,xdim), always 3 udims,  
%       but values of some of them can be 0 depending on udim


% INPUTS:
% w,B:          cp's coord's
% xdim:         physical dimensions
% Ncpo:         No. cp's in each direction (original, might be expanded)


% 0.- Expand Ncp to have 3 elements:
Ncp = ones(3,1);
for di = 1:1:udim
    Ncp(di) = Ncpo(di);
end



% 1.- Sizes responses:
Ew = zeros(Ncp(1),Ncp(2),Ncp(3));
EB = zeros(Ncp(1),Ncp(2),Ncp(3),3); % fills up 3 xdims, but might use less



% 2.- Loop on subindexes:
conta=1;

for i=1:1:Ncp(1)
for j=1:1:Ncp(2)
for k=1:1:Ncp(3)   
   
    Ew(i,j,k) = w(conta);
    for dir=1:1:xdim
       EB(i,j,k,dir) = B(conta,dir); 
    end

    conta = conta+1;
end 
end 
end



end

