function [preP] = GEN_15_PatchP (stp, Ncp, Degree, Usize, KnotV, EP, Ew, xdim, udim)

% RETURNS:
% preP(np,xdim): preliminary set of points of a NURBS patch, any dimension!

% INPUTS:
% stp(udim): step in each direction



% 01.- COMPUTES No. POINTS IN EACH DIRECTION & TOTAL No. POINTS:

npd  = zeros(udim,1);
np   = 1 ;
kLim = zeros(udim,1);

for di=1:1:udim

    kLim(di) = KnotV(di,Usize(di));
    
    npd(di) = GEN_41_roof((kLim(di) - KnotV(di,1)) / stp(di)) + 1;
    
    np = np * npd(di);
    
end

preP = zeros(np,xdim);



% 02.- LOOP ON POINTS COMPUTING PHYSICAL COORD. IN EACH (STORED IN preP):

u = zeros(udim,1);
contaP = 0 ;

if udim==1
    
    u(1) = KnotV(1,1); 
    
    for i = 1:1:npd(1)

        contaP = contaP + 1 ;
            
        %{
          if Ncp(1)==18  && round(EP(1,1),4) == 30.7180
            if u==1
                format long
            u
            
            KnotV'
            Ncp
            
            Degree
            Usize
            Ew
            EP
            udim
            xdim
            format short
            
            end
          end
        %}
        
        
        [X] = b2601_BNURBS_Xcoord (u, KnotV, Ncp,Degree,Usize, Ew,EP, udim,xdim);
            

        if Ncp(1)==18  && round(EP(1,1),4) == 30.7180
            if u==1

            % X
            
            end
        end
        
        
        for di=1:1:xdim
    	preP(contaP,di) = X(di);
        end

        

        
   	u(1) = u(1) + stp(1);
    if u(1) > kLim(1)
        u(1) = kLim(1);
    end
    
  
    
    
    
    end  
    
elseif udim==2
    
    u(1) = KnotV(1,1); 
    for i = 1:1:npd(1)

        u(2) = KnotV(2,1); 
        for j = 1:1:npd(2)

            contaP = contaP + 1 ;
            
            [X] = b2601_BNURBS_Xcoord (u, KnotV, Ncp,Degree,Usize, Ew,EP, udim,xdim);
            
            for di=1:1:xdim
         	preP(contaP,di) = X(di);
            end
            
      	u(2) = u(2) + stp(2);
        if u(2) > kLim(2)
        u(2) = kLim(2);
        end
        end
        
   	u(1) = u(1) + stp(1);
  	if u(1) > kLim(1)
    u(1) = kLim(1);
    end
    end
    
elseif udim==3
    
    u(1) = KnotV(1,1); 
    for i = 1:1:npd(1)

        u(2) = KnotV(2,1); 
        for j = 1:1:npd(2)

            u(3) = KnotV(3,1); 
            for k = 1:1:npd(3)
                
                contaP = contaP + 1 ;

                [X] = b2601_BNURBS_Xcoord (u, KnotV, Ncp,Degree,Usize, Ew,EP, udim,xdim);

                for di=1:1:xdim
                preP(contaP,di) = X(di);
                end
            
            u(3) = u(3) + stp(3);
            if u(3) > kLim(3)
            u(3) = kLim(3);
            end
            end     
      	u(2) = u(2) + stp(2);
        if u(2) > kLim(2)
        u(2) = kLim(2);
        end
        end
   	u(1) = u(1) + stp(1);
   	if u(1) > kLim(1)
    u(1) = kLim(1);
    end
    
    end
    
end






end

