function [conMof] = GEN_17_conMortoFull ( Usize, udim )

% RETURNS:
% conMof(nE,Ncor): connection matrix for ortho domain (rectangle or prisma)
% will all nodes and elements

% INPUTS:
% Usize(udim):              No. coord's in each direction
% udim: problem No. dimensions, typically 2 or 3



if udim==2
    
    conMof = zeros ( (Usize(1)-1)*(Usize(2)-1) , 2^udim) ;
    
 	conta=0;
    
    for i =1:1:Usize(1)-1
	for j =1:1:Usize(2)-1

        conta = conta+1;
        
        cte =  (i-1)*Usize(2) ;
        
        conMof(conta,1) = cte + j ;
        conMof(conta,2) = cte + j +1 ;
        
        conMof(conta,3) = cte + j + Usize(2) ;
        conMof(conta,4) = cte + j + Usize(2) + 1 ;
        
    end
    end
    
    
elseif udim==3
    
    conMof = zeros ((Usize(1)-1)*(Usize(2)-1)*(Usize(3)-1) , 2^udim) ;
       
    conta=0;
    
    for i =1:1:Usize(1)-1
	for j =1:1:Usize(2)-1
	for k =1:1:Usize(3)-1
    
        conta = conta+1;
        
        cte = (j-1)*Usize(3) + (i-1)*Usize(3)*Usize(2) ;
        
        conMof(conta,1) = cte + k ;
        conMof(conta,2) = cte + k +1 ;
        
        conMof(conta,3) = cte + k + Usize(3) ;
        conMof(conta,4) = cte + k + Usize(3) + 1 ;
        
        conMof(conta,5) = cte + Usize(3)*Usize(2) + k ;
        conMof(conta,6) = cte + Usize(3)*Usize(2) + k +1 ;
        
        conMof(conta,7) = cte + Usize(3)*Usize(2) + k + Usize(3) ;
        conMof(conta,8) = cte + Usize(3)*Usize(2) + k + Usize(3) + 1 ;
        
    end
    end
    end
    
    
end




end

