function [nvU, nvUsize] = GEN_18_UnonVoid (U, Usize, Degree, udim)

% RETURNS:
% nvU(udim,nvUsize): non-voids span limits of knot vectors
%   e.g.: [0 0 0  0.2  0.2  0.5  0.8  1 1 1] => [0  0.2  0.5  0.8  1]
% nvUsize(udim,1): size of nvU vector in each direction

% 1.- Preliminary sizes:

nvU     = zeros(udim,1); % '1' will grow
nvUsize = zeros(udim,1);

% 2.- Loop on each parameter direction:

for di=1:1:udim
    
    % all values except the last:
    p1 = Degree(di)+1 ;         % position of last p+1 starters
    p2 = Usize(di)-Degree(di) ; % position of first p+1 endings

    for i = p1 : 1 : p2
        
        if U(di,i)~= U(di,i+1)
            nvUsize(di) = nvUsize(di) + 1 ;
            nvU(di,nvUsize(di)) = U(di,i) ;
        end
    end
    
    % check the last:
    if U(di, p2) ~= U(di, p2-1) 
        
        nvUsize(di) = nvUsize(di) + 1 ;
    	nvU(di,nvUsize(di)) = U(di,Usize(di)-Degree(di)) ;
    end
    
end

end

