function [P] = GEN_20_RectGrid_2D (Lims, D, Nmin)

% RETURNS:
% P(i,j,2): points of plane rect grid 

% INPUTS:
% Lims(2,2); coord's of limits
% D(2): min. spacing req'd
% Nmin: minimum No. nodes

% effective D and n:

eD = zeros(2,1);
n = zeros(2,1);

for di = 1:1:2
    
    L = Lims(di,2)-Lims(di,1);
    
    n(di) = round(L/D(di)+0.5,0)+1;
    
    if n(di) < Nmin
        n(di) = Nmin;
    end
    
    eD(di) = L/(n(di)-1);
    
end


% populates answer:

P = zeros(n(1),n(2),2);
x = Lims(1,1)-eD(1);

for i = 1:1:n(1)
    
    x = x + eD(1);
    
 	if i==n(1)
        x = Lims(1,2);
 	end
    
    y = Lims(2,1)-eD(2);
    for j = 1:1:n(2)

        y = y + eD(2);
        
        if j==n(2)
            y = Lims(2,2);
        end
        
        P(i,j,1) = x ;
        P(i,j,2) = y ;
    end
end


end