function [r, niF] = GEN_24_rootQuadPolm (a,b,c, xL, tol)

% RETURNS: root of quadratic polynomial
% r(2): first is the one that is between the prescribed limits
% niF: not in limits flag = 1 it r is not within xL, otherwise is 0


% INPUTS:
% a,b,c: coefficients of pol. ax2 + bx +c = 0
% xL(2): limits for expected correct root
% tol: percentaje w.r.t. norm of coeff. to disregards one coefficient

n = norm([a,b,c]);

ra = 100* abs(a/n);
rb = 100* abs(b/n);
rc = 100* abs(c/n);


if ra < tol && (rb > tol && rc > tol)
    
    r = -c/b;
    niF = 0 ;
    
elseif rb < tol && (ra > tol && rc > tol)
    
    r = (-c/a)^0.5;
    niF = 0 ;
    
elseif rc < tol && (ra > tol && rb > tol)
    
    r = -b/a;
    niF = 0 ;
    
elseif (ra < tol && rb < tol) && rc > tol
    
    % ??
    
elseif (ra < tol && rc < tol) && rb > tol
     
	r = 0;
    niF = 0 ;
    
elseif (rb < tol && rc < tol) && ra > tol
    
 	r = 0;
    niF = 0 ;
    
else
    
    raiz = (b^2 - 4*a*c);

    x1 = (-b + raiz^0.5 ) / (2*a) ;
    x2 = (-b - raiz^0.5 ) / (2*a) ;

    %xm = (xL(1) + xL(2))/2;

    r = zeros(2,1);


    if xL(1)<=x1 && x1<=xL(2)

        r = [x1 ; x2] ;
        niF = 0 ;

    elseif xL(1)<=x2 && x2<=xL(2)

        r = [x2 ; x1] ;
        niF = 0;

    else

        r = [x1 ; x2] ;
        niF = 1 ;

    end

end

end

