function [ eR ] = GEN_28_FindRelem (Relem, RnEL, u, udim)

% RETURNS: eR: element of rect-mesh where location u belongs, for any udim
% all in parameter space

% INPUTS:
% Relem:        elem's of rect-mesh
% RnEL:         No. R elements
% u:            location to evaluate

cpL = zeros(udim,2); % param. coord's limits of each element

for eR=1:1:RnEL % loops on elements
    
    span = 1 ; % turns to 0 if any span is null
    
    for di=1:1:udim
        
        cpL(di,1) = Relem(eR).mPcoLi(di,1);
        cpL(di,2) = Relem(eR).mPcoLi(di,2);
        
        if round((cpL(di,2)-cpL(di,1)),7)==0
            span = 0;
            break
        end 
        
    end
    
    if span==1 % carries on only for non void elements
        
        IN = GEN_08_Orthodom_Pin_ndec (u, cpL, udim, 'closed', 6);
        
        if IN==1
            % belongs to element "eR"
            break
        end
        
    end
end
end

