function [Ni, iR] = GEN_29_SelAtt (mr, conM)

% RETURNS:
% iR(Ni,1): ref. of items of conM that are attached to refs contained in mr

% INPUTS:
% mr(*,1): references to use to search in conM. They are rows of conM
% cnM(*,*): conn matrix with items attached to each ref.

% e.g.: mr are nodes refs, and conM the VL conn matrix. Then, iR(Ni,1) are
% the Ni lines attached to the mr nodes, but with no repretition!

Ni = 0;
iR = zeros(1,1);

for i = 1:1:size(mr,1)
    
    r = mr(i);
    
    for k = 1:1:size(conM,2)

        if conM(r,k)>0 
            
            tR = conM(r,k);
            
            if Ni == 0
                
                Ni = 1 ;
                iR(Ni,1) = tR;
                
            else
            
                addF = 1 ;
                
                for t = 1:1:Ni
                    if iR(t)==tR
                       addF = 0 ;
                       break
                    end
                end
            
                if addF == 1  
                    Ni = Ni+1 ;
                    iR(Ni,1) = tR;
                end 
            end
            
        else
            break
        end
        
    end
    
end

end

