function [Inde] = GEN_30_IndexFromParam (Ucoor, KnotV, Usize, Degree, udim)

% RETURNS:
% Inde(udim):   indexes corrrespondant to a certain parameter coordinates

% valid for all dims

% INPUTS:
% Ucoor:        param. coord's
% KnotV:        knot vectors
% Degree:       degree
% udim:         param dims


% 0.- Preliminary size:

Inde = zeros(udim,1);


% 1.- Loop on udim:

for di=1:1:udim
    
    % 1.1.- Extract data for that direction:
    
    u = round(Ucoor(di),6) ; % param. coord's
    
    p = Degree(di); % degree
    
    U = zeros(Usize(di),1); % knot vector
    for i=1:1:Usize(di)
    U(i) = KnotV(di,i);
    end
    
    
    % 1.2.- Allocates indexes:
    
    if u==U(1)
        
        Inde(di) = p+1 ;
        
    elseif u== U(Usize(di))
        
        Inde(di) = Usize(di) - p ;
        
    else
        
        % find U span and interpolates:
        
        for i=p+1 :1: Usize(di)-p
        
            if U(i)<=u && u<U(i+1)
            
                u1 = U(i);
                u2 = U(i+1);
                
                por  = (u-u1) / (u2-u1);
                
                Inde(di) = i + round( por,5) ;
                
            end
            
        end
        
    end
    
    
    
end


end

