function [ u ] = GEN_34_ParamFromIndex (index, U)

% RETURNS:
% u:    param. space coordinate given one index of a knot vector
%       considers also fractions of indexes

% INPUTS:
% index:    index
% U:        knot vector in parameter space

if mod(index,1) == 0 % integer index
    
    u = U(index);
    
    
else % index is a fraction
    
    ind_prev = round(index-0.50000000001,0);
    ind_next = ind_prev + 1;
    
    Dind = index - ind_prev;
    
    Du = (U(ind_next) - U(ind_prev)) * Dind;
    
    u = U(ind_prev) + Du;
    
    
    
end


end

