function [ xM ] = GEN_38_InsertsInMatrix ( M, x, xpos, addF )

% RETURNS:
% xM:   matrix M with insertion x 

% INPUTS:
% M:        original matrix
% x:        new component to add
% xpos(2):  position after where insert x in M
% addF:     if 1 add within row, if 0 add within col

% Note: the non-involved rows (or cols) are just extended with zeros

% 1.- Preliminary size of xM:

Or = size(M,1); % original sizes
Oc = size(M,2);
Nr = size(M,1); % extended sizes
Nc = size(M,2);

if addF==1 % add in a row => extend No. cols by one
    Nc = Nc+1;
elseif addF==0 % add in a col => extend No. rows by one  
    Nr = Nr+1;
end

xM = zeros(Nr,Nc);


% 2.- Copies M into xM, there will be an extra col or row of zeros at the end:

for i=1:1:Or
for j=1:1:Oc
    xM(i,j) = M(i,j);
end
end



% 3.- Inserts x:

if addF==1
    
    xM(xpos(1), xpos(2)+1) = x ;
  	for j = xpos(2)+2:1:Nc
        xM(xpos(1),j) = M(xpos(1),j-1);
	end
    
elseif addF==0
   
    xM(xpos(1)+1, xpos(2)) = x ;
	for i = xpos(1)+2:1:Nr
        xM(i,xpos(2)) = M(i-1,xpos(2));
 	end
    
    
end


end

