function [IN, Tr, NEsk, EskR] = GEN_51_FAnchorIN ...
         (aR, aULims, pnbe, pRbe, Nbe, Eskin, nBS, Bskin, pR, pCou, pudim)

% RETURNS:
% IN: if anchor ULims include the domain
% Tr: if the anchor domain is trimmed by Eskin
% EskR(NEsk): Eskins that trim the anchor ULims 

% INPUTS:
% aR: point reference, just of checking purposes
% pCou(Ncou,2): patcehs ref's for coupling: 1 masters, 2 slave
% pR : patch ref


% works in patch param. space

IN = 0 ;
Tr = 0 ;
NEsk = 0 ;
EskR = zeros(1,1);

% center of anchor in parameter space
Actr= zeros(pudim,1);
for di = 1:1:pudim
    Actr(di) = (aULims(di,1) + aULims(di,2))/2;
end

% 1.- CHECKS B.E. SKINS:

% the purpose is:
% - store Eskins that trim the anchor
% - find out if is a trimmed anchor
% - store the closest point of the closest BE

dmin = 9999 ;
cb = 0; % closest BE 



for b = 1:1:pnbe  
    
    bR  = pRbe(b);
    
    % detects coupling and if is master or slave
    couR = Eskin(bR).mCou; 

    flagSP = 0; % flag of slave patch
    if couR > 0
        if pCou(couR,1)==pR
            
            flagSP = 0;
            
        elseif pCou(couR,2)==pR
            
            flagSP = 1;
            
        end
    end
    

    % 1.1.- Checks skin integration points:
    
    Ngp =  Eskin(bR).mNgp;
    u = zeros(pudim,1);

    for g = 1:1:Ngp
    
        if flagSP==0
            u(:,1) = Eskin(bR).mGP(g).mAcoor(:);
        elseif flagSP==1
            u(:,1) = Eskin(bR).mGP(g).mAcoorS(:);
        end
        
        d = norm(u-Actr);
        if d < dmin
            cb = bR ;
            dmin = d ;
        end
        
        sIN = GEN_08_Orthodom_Pin_ndec (u, aULims, pudim, 'closed', 9);
        
        if sIN == 1
            
        	NEsk = NEsk + 1;
            EskR(NEsk,1) = bR;
            Tr = 1 ;
            break   
        end     
    end
end


% 2.- THEN CHECKS IF IS IN:

if Tr==1
    
    % 2.1.- If is trimmed is IN:
    
    IN = 1 ;

elseif Tr==0
    
    % 2.2.- If not trimmed needs further check:
    % uses the closest BE 'cb' and compares vectors senses
    
    % finds closest BE in param. space
    dmin = 99999;
    for b = 1:1:pnbe  

        NE =  Eskin(bR).mNE;
        TV =  Eskin(bR).mTVcon;
        Av =  Eskin(bR).mAv;
        
        %[tve, sdmin, Pp, nv] = i0104_closestP (sR, P, NV, TV, VT, PNv, PNe, Pv, dim)
        
        [~, sdmin] = i0104_closestT (Actr, NE, TV, Av, pudim);
        
        if sdmin < dmin 
            cb = b;
            dmin = sdmin;
        end
    end
    
    % determines if is IN:
    [IN,~,~] = i0102_pIN (Actr, cb, Eskin, pudim);
    
end

end