function [IN, TRIM, dCtrS] = GEN_65_checkOneSk ...
         (gPatch, pa, skR, Bskin, ULims, cUcoor, cXcoor, bCurv, pudim)

% RETURNS:
% In/trimming parameters for one element (ULims) compared against one Bskin(skR)
% dCtrS: distance crt. of element to skin closest point

% INPUTS:
% Bskin(skR): skin to compare with
% ULims(udim,2): elem. param. space limits
% cUcoor/cXcoor: elem. ctr. coord's, physical and patch param.


% 1.- CHECK FROM CTR. POINT OF ELEMENT:

diag = zeros(pudim,1);
for di=1:1:pudim
    diag(di) = (ULims(di,2) - ULims(di,1));
end
udmax = 0.5 * norm(diag);
    
[IN, TRIM, SV, dCtrS] = GEN_62_elePinTrim (gPatch, pa, skR, Bskin, ULims, cUcoor, cXcoor, udmax, bCurv);


% 2.- CHECK CORNERS (in case of not definitive answer from ctr.)
    
if SV==0
    [IN, TRIM] = GEN_64_cornersIN (gPatch, pa, skR, Bskin, ULims, bCurv, pudim);
end
    

%{
% My CHECK
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if round(cXcoor(1),4) == 93.75 && round(cXcoor(2),4) == 31.25 && round(cXcoor(3),4) == 15
    
    [IN, Tr, SV, dCtrS]
end
%}
end

