function [IN, TRIM, allU, allX, allIN, allTRIM, allSV, allF] = GEN_66_cornersINpre ...
         (gPatch, pa, skR, skO, Bskin, cudmax, epR, SeNo, iULims, bCurv, pudim, allU, allX, allIN, allTRIM, allSV, allF)

% RETURNS:

% IN = 1 if element is IN
% TRIM: = 1 if elem (ULims) is trimmed by Bskin 's'

% checks from corners of the element as base points, corners might be
% pre-computed from previous sub-elements

% INPUTS:
% skR: skin ref to compare with
% skO: skin order in BskR
% cudmax: threshold distance (in param. space) to ensure skin is not-trimming
% SeNo: conn. matrix sub-element  -  nodes ref's
% epR: sub-element 'local' reference

IN = 0 ;
TRIM = 0 ;



% 1.- LOOP ON CORNERS:

% stores each corner IN/TRIM and coord's:
cIN     = zeros(8,1);
cTRIM   = zeros(8,1);
cU      = zeros(8,pudim);
cX      = zeros(8,3);

contaC = 0 ;

for i = 1:1:2
for j = 1:1:2
for k = 1:1:2
    
    contaC = contaC + 1 ;
    nR = SeNo(epR,contaC); % node ref.
    
    % if already computed, just extracts
    if allF(nR, skO)==1
        
        for di=1:1:pudim
            cU(contaC,di) = allU(nR,skO,di);
        end
        for di=1:1:3
            cX(contaC,di) = allX(nR,skO,di);
        end
        
        cIN(contaC)   = allIN(nR,skO);
        cTRIM(contaC) = allTRIM(nR,skO);
        
        cSV = allSV(nR,skO);
        
    % if not computed, does it and allocates    
    elseif allF(nR, skO)==0
        
     	% corner coord's:
        uc = [iULims(1,i) ; iULims(2,j) ; iULims(3,k)];
        xc = b2602_BNURBS_Xcoord_gPatch (uc, gPatch, pa);

        for di=1:1:pudim
            cU(contaC,di) = uc(di);
            allU(nR,skO,di) = uc(di);
        end

        for di=1:1:3
            cX(contaC,di) = xc(di);
            allX(nR,skO,di) = xc(di);
        end
        
      	% skin position from that corner:
        [cIN(contaC), cTRIM(contaC), cSV,~] = GEN_62_elePinTrim (gPatch, pa, skR, Bskin, iULims, uc, xc, cudmax, bCurv);

        allIN(nR,skO) = cIN(contaC);
        allTRIM(nR,skO) = cTRIM(contaC);
        allSV(nR,skO) = cSV;
        allF(nR,skO) = 1 ;
    end
    
    if cIN(contaC)==1
     	IN = 1;
    end

  	if cTRIM(contaC)==1
        TRIM = 1;
   	end
    
    
    %{
    % MY CHECK
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if ((ULims(1,1)==0.0 && ULims(1,2)==1) && (ULims(2,1)==0.5 && ULims(2,2)==0.75)) ...
            && (round(ULims(3,1),4)==0.5 && ULims(3,2)==0.75)
    if pa==1  
        
        CORNER = contaC
    	[uc';xc']
        
        %Bskin(s).mB
    end
    end
    %}
    
    
    if cSV==1
    break
    end
end
    if cSV==1
    break
    end
end
    if cSV==1
    break
    end
end


% 2.- IN CASE cSV=0 (not fully solved, => no trim detected, TRIM=0) & SKIN
% IS IN CHECKS POTENTIAL TRIM FROM MID POINTS BETWEEN ADJACENT CORNERS:

% two adjacent corners are IN but not trimmed, that is because  Bskin is
% parallel to the edge of the element, and is trimming very close to the
% limit, therefore it was not detected by the ctr. point check.
% => check intermediate point to see if is trimmed


if IN == 1 && cSV == 0
    
    % corner pairs (or edges ends) references:
    corcou = [1 2 ; 1 3 ; 1 5 ; 2 4 ; 2 6 ; 3 4 ; 3 7 ; 4 8 ; 5 6 ; 5 7 ; 6 8 ; 7 8];
    
    % loop on corner pairs (or edges)
    for cou = 1:1:12
        
        % extreme nodes ref's of the edge
        aR = corcou(cou,1);
        bR = corcou(cou,2);
        
        % if both are IN or OUT, checks mid point
        if (cIN(aR)==1 && cIN(bR)==1) || (cIN(aR)==0 && cIN(bR)==0)
            
            % computes mid point and its state:
            
            for di=1:1:pudim
                uc(di) = (cU(aR,di) + cU(bR,di)) / 2 ;
            end
            
            for di=1:1:3
                xc(di) = (cX(aR,di) + cX(bR,di)) / 2 ;
            end
            
            [~, mTRIM, ~,~] = GEN_62_elePinTrim ...
                (gPatch, pa, skR, Bskin, iULims, uc, xc, cudmax, bCurv);
    
            % if finds it trimmed => assumes mSV = 1 and IN=1
            if mTRIM==1
                TRIM = 1 ;
                break
            end
        end
        
    end
    

    
    
end



end

