function [ Spatches ] = c1401_CopyNextIns (UsInte, Spatches, nop, udim, xdim, NTs )

% RETURNS:
% Spatches matrix of patches objects with a new instance which is a copy of
% the last one with updated correspondant parameters:

% INPUTS:
% NTs:   time step of the new instance
% Du:   vector of displacements for anchors produced after that time step.
%       It will be considered at the beggining of next instance.
%       Needs to be split up in displacements for each patch.

for pa=1:1:nop
    
    % 1.- Updates No. instances in the patch:
    
    nIp = Spatches(pa).nI;
    nIn = nIp+1;
    Spatches(pa).nI = nIn ;
    
    % 2.- Extract displacements especifically for this patch in muP:
    muP = Spatches(pa).mRefin(NTs-1).mu ;
    

    % 3.- Copy original "O" instance + Du (computed in previous step) to
    % new instance and updates relevant features.
    
    ORefin = Spatches(pa).mRefin(nIp); 
    NRefin = c1402_CopytoNextRefin (UsInte, ORefin, muP, NTs, udim,  xdim);

    
    % 5.- Transfers variables:
    Spatches(pa).mRefin(nIn) = NRefin ;
    
    clearvars ORefin NRefin OmS NmS ;
    
    
end
 





end

