function [Cwires] = c1403_CopyWires( Owires, nW, xdim, udim, TM )

% RETURNS:
% Cwires: copy of wires from Owires, with Xcoor's updated with Xdisp
% Xdisp are set to 0 , and the rest of features are copied from original

% INPUTS:
% OWires:   original wires object
% TM:       type of mesh 'R' or 'T'

Cwires(nW) = GenWire ;

Icoor = zeros(1,udim);
Ucoor = zeros(1,udim);
XcoorF = zeros(1,xdim);



for wi = 1:1:nW
    
    % 1.- General info of the wire:
    
    conE = Owires(wi).conE;
    ON = Owires(wi).ON ;
    nPO = Owires(wi).nPO ;
    mDir = Owires(wi).mDir ;
    %mILim = Owires(wi).mILim ;
    mPeri = Owires(wi).mPeri ;
    Na = Owires(wi).mNa;
    Nb = Owires(wi).mNb;

    
    Cwires(wi).conE = conE ;
    Cwires(wi).ON = ON ;
    Cwires(wi).nPO = nPO ;
    Cwires(wi).mDir = mDir ;
    %Cwires(wi).mILim = mILim ;
    Cwires(wi).mPeri = mPeri ;
    Cwires(wi).mNa = Na ;
    Cwires(wi).mNb = Nb ;


    
    % 2.- Points of the wire:
    
    mP(nPO) = GenPoint;

    for po = 1:1:nPO

        for di=1:1:udim
            
            %{
            % index coord's: only for 1 and nPO points and in 'R' mesh:
            
            if strcmp(TM,'R')==1 && (po==1 || po==nPO)
                Icoor(di) = Owires(wi).mP(po).mIcoor(di) ;
                mP(po).mIcoor(di) = Icoor(di);
            end
            %}
            
            Ucoor(di) = Owires(wi).mP(po).mUcoor(di) ;
            mP(po).mUcoor(di) = Ucoor(di);
            
        end

        for di=1:1:xdim

            XcoorF(di) = Owires(wi).mP(po).mXcoorF(di); % Initial coord's do not change
            mP(po).mXcoorF(di) = XcoorF(di);
            
            mP(po).mXcoor(di) = Owires(wi).mP(po).mXcoor(di) +  Owires(wi).mP(po).mXdisp(di);

            mP(po).mXdisp(di) = 0 ; % set displacement to 0
            
        end
        
        
        % icps:
        Nicp = Owires(wi).mP(po).mNicp ;
        RicpA = Owires(wi).mP(po).mRicpA ;
        mP(po).mNicp = Nicp ;
        mP(po).mRicpA = RicpA ;
        
    end
    

    % 4.- Transfers the info:
    Cwires(wi).mP = mP ;
    clearvars mP ;

    
end



end

