function [ CmA ] = c1404_CopyAnchors (OmA, nAN , Du ,udim, xdim)

% RETURNS:
% CmA: copied anchors matrix object. Note the position is updated or not acc. to Du

% INPUTS:
% OmA:  original matrix of anchors
% nAN:  No. anchors
% Du:   total displacement vector of patch. If Du=0 no displacement added


% 0.- Preliminary sizes:

CmA(nAN) = GenAnchor;

Usize = zeros(udim,1);
Acoor = zeros(udim,1);
Icoor = zeros(udim,1);
Pcoor = zeros(udim,1);
IcoLi = zeros(udim,2);
PcoLi = zeros(udim,2);
        
Xcoor = zeros(xdim,1);

ui = 0;


% 1.- Loop on anchors:

for a = 1:1:nAN
    
    for di=1:1:udim
        
        % U sizes
        Usize(di) = OmA(a).mUsize(di);
        CmA(a).mUsize(di) = Usize(di);
        
        % LKVs
        UI = zeros(Usize(di),1);
        U = zeros(Usize(di),1);
        for i=1:1:Usize(di)
           
            UI (i) = OmA(a).mLKVI(di,i);
            U  (i) = OmA(a).mLKV(di,i);
            
            CmA(a).mLKVI(di,i) = UI(i);
            CmA(a).mLKV(di,i)  = U(i);
        end
        
        % coordinates
        Acoor(di) = OmA(a).mAcoor(di);
        Icoor(di) = OmA(a).mIcoor(di);
        Pcoor(di) = OmA(a).mPcoor(di);
        
        CmA(a).mAcoor(di) = Acoor(di);
        CmA(a).mIcoor(di) = Icoor(di);
        CmA(a).mPcoor(di) = Pcoor(di);
        
        % influence limits
        IcoLi(di,:) = OmA(a).mIcoLi(di,:);
        PcoLi(di,:) = OmA(a).mPcoLi(di,:);
        
        CmA(a).mIcoLi(di,:) = IcoLi(di,:);
        CmA(a).mPcoLi(di,:) = PcoLi(di,:);
    end
    
    % physical coord's , here adds Du vector if it has to:
    
    if size(Du,1)==1 && Du(1,1)==0
       
        for di=1:1:xdim
            Xcoor(di) = OmA(a).mXcoor(di);
            CmA(a).mXcoor(di) = Xcoor(di);
        end
        
    else
        
        for di=1:1:xdim
            ui = ui+1;
            Xcoor(di) = OmA(a).mXcoor(di) + Du(ui);
            CmA(a).mXcoor(di) = Xcoor(di);
        end
    end
    
    
    % Weights
    Weig = OmA(a).mWeig;
    CmA(a).mWeig = Weig;

    % Usingularities:
    Usingu = OmA(a).mUsingu ;
    CmA(a).mUsingu = Usingu ; 
    
    % t-junctions:
    Tj = OmA(a).mTj ;
    CmA(a).mTj = Tj ; 
    
    % iterations parameters mPar:
    CmA(a).InitiatesParams(xdim);

end






end

