function [CRmesh] = c1405_CopyRmesh ( ORmesh, mA, Degree, xdim, udim)

% RETURNS:
% CRmesh:   copied rectangular mesh


% 0.- Initializes:

CRmesh = Rmesh ;
    

% 1.- Mesh basic params:

% read:

nELf    = ORmesh.nELf ;
nNOi    = ORmesh.nNOi ;
conMi   = ORmesh.conMi ;
conMis   = ORmesh.conMis ;
effKVI   = ORmesh.effKVI ;

nEL     = ORmesh.nEL ; 
nNO     = ORmesh.nNO ;
conM    = ORmesh.conM ;
conMs   = ORmesh.conMs ;

FtoIe    = ORmesh.FtoIe;
FtoIn    = ORmesh.FtoIn;
nWI     = ORmesh.nWI ;
nWIi    = ORmesh.nWIi ;


% copy:

CRmesh.nELf = nELf ;
CRmesh.nNOi  = nNOi ;
CRmesh.conMi  = conMi ;
CRmesh.conMis  = conMis ;
CRmesh.effKVI  = effKVI ;

CRmesh.nEL  = nEL ; 
CRmesh.nNO  = nNO ;
CRmesh.conM  = conM ;
CRmesh.conMs = conMs ;

CRmesh.FtoIe = FtoIe;
CRmesh.FtoIn = FtoIn;
CRmesh.nWI  = nWI;
CRmesh.nWIi = nWIi;

% 2.- Elements:
ORelem = ORmesh.mE ;
CRelem = c1406_CopyRelem ( ORelem, nEL, mA, Degree, udim, xdim);
CRmesh.mE  = CRelem;    


% 3.- Nodes:

% 3.1.- p-nodes:

mNp(nNO) = GenGeomPoint ;

for nod = 1:1:nNO
    mNp(nod) = p1210_CopyGeomPointInfo (ORmesh.mNp(nod), CRelem, nEL, mA, Degree, udim, xdim);
end
CRmesh.mNp = mNp ;


% 3.2.- index-nodes:

mNi(nNOi) = GenGeomPoint ;

for nod = 1:1:nNOi
    mNi(nod) = p1210_CopyGeomPointInfo (ORmesh.mNi(nod), CRelem, nEL, mA, Degree, udim, xdim);
end
CRmesh.mNi = mNi ;


% 4.- Wires: for mXcoor add mXdisp from Owires

Owires = ORmesh.mW;
[Cwires] = c1403_CopyWires (Owires, nWI, xdim, udim, 'R' );
CRmesh.mW  = Cwires ;


OIndexwires = ORmesh.mWi;
[CIndexwires] = c1410_CopyIndexWires (OIndexwires, nWIi, udim);
CRmesh.mWi  = CIndexwires ;




end

