function [CRelem] = c1406_CopyRelem (ORelem, nE, mA, Degree, udim, xdim)

% RETURNS:
% CRelem:   copied rectangular elements matrix, from ORelem

CRelem(nE) = GenElem ;

for e=1:1:nE 

    Nicp    = ORelem(e).mNicp;
    RicpA   = ORelem(e).mRicpA;
    IcoLi   = ORelem(e).mIcoLi;
    PcoLi   = ORelem(e).mPcoLi;  
    nIed    = ORelem(e).nIed; 
    Trim    = ORelem(e).mTrim ;
    Vspan   = ORelem(e).mVspan ;
    
    Ntnod   = ORelem(e).Ntnod ;
    mTnod   = ORelem(e).mTnod ;
    Ntele   = ORelem(e).Ntele ;
    mTele   = ORelem(e).mTele ;
    
    mLM = ORelem(e).mLM ;
    mlk = ORelem(e).mlk ;
    
    
    
    CRelem(e).mNicp = Nicp;
    CRelem(e).mRicpA = RicpA;
    CRelem(e).mIcoLi = IcoLi;
    CRelem(e).mPcoLi = PcoLi;
    CRelem(e).nIed   = nIed;
    CRelem(e).mTrim = Trim;
    CRelem(e).mVspan = Vspan;

    CRelem(e).Ntnod = Ntnod;
    CRelem(e).mTnod = mTnod;
    CRelem(e).Ntele = Ntele;
    CRelem(e).mTele = mTele;
    
  	CRelem(e).mLM = mLM;
    CRelem(e).mlk = mlk;
    
    
    % 2.- IEdges:
    
    if nIed > 0
        
        OmIed = ORelem(e).mIed;
        Ied(nIed) = IEdge ;
        
        for ed = 1:1:nIed
            
            Dir = OmIed(ed).mDir;
            Ied(ed).mDir = Dir ;
            
            mP(2) = GenGeomPoint;
            
            for po = 1:1:2

                OmP = OmIed(ed).mP(po);
                
                mP(po) = p1210_CopyGeomPointInfo ...
                (OmP, ORelem, nE, mA, Degree, udim, xdim);
            end
        
            Ied(ed).mP = mP ;
            
            clearvars mP ;
            
        end
        
        
        CRelem(e).mIed = Ied ;
        
        clearvars Ied;
        
    end
    
    
    
    
end

end

