function [CTmesh] = c1407_CopyTmesh (UsInte, OTmesh, Relem, RnE, mA, Degree, xdim, udim)

% RETURNS:
% CTmesh:   copied rectangular mesh

% INPUTS:
% Relem, RnE: rect. mesh elements

% 0.- Initializes:
CTmesh = Tmesh ;
    

% 1.- Mesh basic params:

nNO     = OTmesh.nNO ;
nELf    = OTmesh.nELf ;
conM    = OTmesh.conM ;
nGP     = OTmesh.nGP ;
nWI     = OTmesh.nWI ;
OmN     = OTmesh.mN ;
OmGP    = OTmesh.mGP ;

CTmesh.nNO  = nNO ;
CTmesh.nELf = nELf ;
CTmesh.conM = conM;
CTmesh.nGP  = nGP;
CTmesh.nWI  = nWI;


  
% 2.- Nodes:

mN(nNO) = GenGeomPoint ;

for nod = 1:1:nNO

    mN(nod) = p1210_CopyGeomPointInfo ...
    (OmN(nod), Relem, RnE, mA, Degree, udim, xdim);

end
CTmesh.mN = mN ;


% 3.- GP's:

mGP(nGP) = GenPoint ;

for g = 1:1:nGP

    mGP(g) = p1203_CopyPointInfo...
   (UsInte, OmGP(g), Relem, RnE, mA, Degree, udim, xdim);
end
CTmesh.mGP = mGP ;



% 4.- Elements:

OTelem    = OTmesh.mE ;
CTelem    = c1408_CopyTelem (OTelem, nELf, mGP);
CTmesh.mE = CTelem;  



% 5.- Wires: for mXcoor add mXdisp from Owires:

Owires = OTmesh.mW;

[Cwires] = c1403_CopyWires (Owires, nWI, xdim, udim, 'T');
CTmesh.mW  = Cwires ;
 


end

