function [CTelem] = c1408_CopyTelem (OTelem, nE, mGP)

% RETURNS:
% CTelem:   copied triangular elements matrix, from OTelem

% INPUTS:
% nE:       No. triangular elements
% mGP:      Gp's object for mAe computation


CTelem(nE) = GenElem ;

for e = 1:1:nE 

    ON      = OTelem(e).ON;
    Trim    = OTelem(e).mTrim ;
    NGP     = OTelem(e).NGP ;
    mGr     = OTelem(e).mGr ;
  	dJ2     = OTelem(e).dJ2 ;
    conW    = OTelem(e).conW;

    CTelem(e).ON    = ON;
    CTelem(e).mTrim = Trim;
    CTelem(e).NGP   = NGP;
    CTelem(e).mGr   = mGr;
    CTelem(e).dJ2   = dJ2;
    CTelem(e).conW  = conW;
    
    % area of element (updated)

    acc = 0 ;
    for g = 1:1:NGP
        
        gR  = mGr(g);
        dJ1 = mGP(gR).dJ1;
        wgp = mGP(gR).mw;
        
        acc = acc + dJ1*dJ2*wgp ;
    end
    
    CTelem(e).mAe = acc;

end


end

