function [Ucoor] = b2803_PP_with_preSel ...
    (Xcoor, Ucoor, ULims, seekst, dmin, tolDist, Degree, Ncp, KnotV, Usize, P ,w,CD, udim, xdim, po)

% RETURNS:
% Ucoor for a given Xcoor

% INPUTS:
% Xcoor: physical coord's where to find correspondant Ucoor
% Ucoor: initial searchin point
% seekst: initial seeking step in case needs to re-compute it
% dmin: pre-established minimum distance for re-searching initial Ucoor
% po: point reference


% Philosophy: if does not converge in contaL loops => varies initial Ucoor 


% 1.- Sets preliminary vales:

NOC     = 1 ;
divsr   = 2 ;
contaL  = 0 ;

Lerr1 = 0.0001; % coincidence tolerance
Lerr2 = 0.001;  % perpendicularity tolerance

LIMcontaL = 2 ;

% 2.- Searches u value while there is no convergence:

while NOC==1
 
    Ucoor = round(Ucoor,12); % rounds up to achieve same precision as in GEN_03_FindSpan
    

    % 2.1.- Ucoor correspondant to Xcoor, NOC=1 if does not find convergence:
    
    [Ucoor, NOC] = b2805_UfromX (Degree, Ncp, KnotV, Usize, P ,w, CD, Xcoor, Ucoor, Lerr1, Lerr2, udim, xdim);
    
    if round(sum(Xcoor),4) == 8.9113
        %Sale = Ucoor
    end

    
    % 2.2.- Re-sets initial Ucoor if NOC=1
    
    if NOC==1
        
        Dseekst = seekst/divsr;
        [Ucoor, NOC] =  b2842_intialU (Dseekst, ULims, Xcoor, dmin, tolDist, Degree, Ncp, KnotV, Usize, P ,w, udim, xdim);
        
        divsr = divsr+1;
    end

 
    % 2.3.- Controls No. global loops:

    contaL = contaL+1; 
    if contaL ==  LIMcontaL  %%%%%%%%%%%%%%%%%%%%%%%%%%%55
        
        Scoor = num2str(Xcoor(1)) ;
        for di = 2:1:xdim
            Scoor = strcat(Scoor, ' , ' , num2str(Xcoor(di)));
        end
        
        disp( [ Scoor, ' ' , ' - point ref: ', num2str(po) , '   - does not converge, see b2805'  ] );
        break
        
    end

end



end


