function [u, NOC] = b2805_UfromX (Degree, Ncp, KnotV, Usize, P ,w, CD, Xcoor, u0, Lerr1, Lerr2, udim, xdim)

% RETURNS:
% u: param. space coord's correspondant to a physical point Xcoor
% NOC: 0 - 1 if converges or not in less than cLLIM loops

% INPUTS:
% P:    physical coord's where find u from
% u0:   initial parameter for searching
% Lerr1, Lerr2:    errors limits for point coincidence and zero cosine, respectively, when convergence check, (abs. value, not percentaje)
% udim: dimension of parameter space


% to control evo,lution

sumXcoor = 8.9113 ;

% 1.- PRELIMINARIES:

% 1.1.- Initiates errors and counter of err1o small (Cerr1o):

Lerr1o = Lerr1 ;

err1 = Lerr1+1;

err2 = zeros(udim,1);
for di=1:1:udim
   err2(di) = Lerr2+1; 
end

E2 = 1; % turns to 0 when all err2 are less than Lerr2

err1o = Lerr1o + 1 ;
cerr1o = 0 ;

% 1.2.- Expands cps' coordinates:

[Ew,EP] = GEN_12_ExpandBw (w,P,xdim,udim, Ncp);


% 1.3.- Sets counters

NOC = 0 ;
cL = 0 ;
cLLIM = 15 ;
cerr1oLIM = 4 ;

% 1.4.- Reduces P and u0 to actual xdim and udim and transfers to actual points:

rP = zeros(xdim,1);
for di = 1:1:xdim
    rP(di) = Xcoor(di);
end

ru1 = zeros(udim,1);
ru2 = zeros(udim,1);
for di = 1:1:udim
    ru1(di) = u0(di);
    ru2(di) = u0(di);
end



strdU = zeros(cLLIM,udim); % stores  stored U coord's, used for checking bouncing iterations

% 2.- LOOP UNTIL FINDS CONVENGENCE, OR REACHES MAX. NO. LOOPS:

while ((Lerr1 < err1 && E2==1) && cerr1o < cerr1oLIM)
    
    % rounds up to achieve same precision as in GEN_03_FindSpan
    ru1 = round(ru1,12); 
    ru2 = round(ru2,12); 

    
	if round(sum(Xcoor),4) == sumXcoor
        LOOOOOPP__PP = cL+1 
    end
    

    
    % 2.1.- Computes physical position 'S' correspondant to u:

    [S] = b2601_BNURBS_Xcoord (ru2, KnotV, Ncp,Degree,Usize, Ew,EP, udim,xdim);
    
    
    % 2.2.- Computes increment of u, (needs Jacobian and 'force' vector 
    %       calculated from first derivatives of S about parameter space)
    
    % previous iteration 'ru' value
    pru1 = ru1 ; 
    pru2 = ru2 ; 
    
    r = (S-rP);

    [Ju, dS1] = b2806_Jpp (Degree, Ncp, KnotV, Usize, P ,w, r, ru2, udim, xdim);
    
    fu = zeros(udim,1);
    for di = 1:1:udim
        
        Si = zeros(xdim,1);
        
        for xdi = 1:1:xdim
      	Si(xdi) = dS1(di,xdi);
        end

        fu(di) = dot (r, Si);
    end

    du = -inv(Ju)*fu;
    ru2 = ru2 + du ;
    

 	% 2.3.- Makes sure is ru goes back to domain in case is out:
  	% fBackD(udim)=1 if was out of domain and goes back
	% fLoopD(udim)=1 if passes the limit in the loop direction
    
    ru1 = ru2 ;
    [ru2, fBackD, fLoopD] = z2803_Ulimits(KnotV, Usize, ru1, udim, CD);
    
  	if round(sum(Xcoor),4) == sumXcoor
        
        prevEST = [pru1' pru2']
        ESTIMA = [ru1' ru2']
        
    end
    
    
    % 2.4.- Computes errors:

    [err1, err2, E2] = z2802_errors(Xcoor, S, dS1, xdim, udim, Lerr2);
    [err1o] = z2801_errorO (pru1, ru1, udim);
    
    if err1o < Lerr1o
       cerr1o = cerr1o + 1 ; 
    end
    
 	if round(sum(Xcoor),4) == sumXcoor
        eerr = [err1 E2 err1o]
        cerr1o
    end
    

    % 2.5.- No. loops and stores Ucoord's
    
    cL = cL + 1 ;
    
    for di = 1:1:udim
        strdU(cL,di) = ru2(di);
    end

    
    % 2.6.- Control No. loops is < cLLIM:
    
    if cL == cLLIM
        
        % if gets cLLIM checks if is a 'bouncing' iteration
        [ru2, BO] = z2805_bouncingU (strdU, 0.01 , udim);
        
        % in case of bouncing system, assumes approximated 'ru' and finish
        if BO==1
        
            NOC = 0 ;
            
        % otherwise is not convergent and carry out another supra-iteration    
        elseif BO==0
            
            NOC = 1 ;
        end
        
        break
    end


    
end





% 3.- TRANSFERS TO 'u' VALUES FROM 'ru':

u = zeros(3,1);

for di=1:1:udim
   u(di) = ru2(di); 
end



end

