function [u] = b2812_PPonePo_pre (x, Degree, Ncp, KnotV, Usize, P ,w, CD, xdim, udim, ut)

% ut: initial coordinate for searching

% 1.- Computes some parameters to use afterwards:

% 1.1.- SETS MIN. DISTANCE (dmin) AS 'DIAGONAL' OF PATCH CP'S PHYSICAL COORD'S
% ALSO: tolDist: tolerance to consider initial Ucoor is the solution

tncp = 1 ; % total No. cp's
for di = 1:1:udim
    tncp = tncp * Ncp(di);
end

temp = sortrows(P,[1:1:xdim]);
a = zeros(xdim,1);
b = zeros(xdim,1);

for di=1:1:xdim
    a(di) = temp(1,di);
    b(di) = temp(tncp,di);
end
dmin = norm(b-a);

conta = 1 ;
while (abs(dmin)<0.0001) % makes sure distance is not so small or zeros (i.e. closed surfaces)
    
	for di=1:1:xdim
        a(di) = temp(1,di);
        b(di) = temp(tncp-conta,di);
 	end
    dmin = norm(b-a);
    conta = conta+1;
    
end

% compares a few points with x, in case that distance is greater:

if norm(x-a) > dmin
    dmin = norm(x-a);
end

if norm(x-b) > dmin
    dmin = norm(x-b);
end


% tol. to assume coincidence point:
tolDist = dmin * 0.000001 ;



% 1.2.- U LIMITS AND STEP FOR SEEKING:

ULims = zeros(3,2);
seekst = zeros(3,1);
    
for di = 1:1:udim
        
    ULims(di,1) = KnotV(di,1);
    ULims(di,2) = KnotV(di,Usize(di));

    seekst(di) = (ULims(di,2) - ULims(di,1) )*0.25;
end
   



% 2.- Works out the searching:
    
[ut] = b2803_PP_with_preSel ...
    (x, ut, ULims, seekst, dmin, tolDist, Degree, Ncp, KnotV, Usize, P ,w, CD, udim, xdim);


% 3.- Transfers to response with components:

u = zeros(udim,1);
for di=1:1:udim
    u(di) = ut(di);
end


end

