function [ULims, seekst, fUcoor, dmin, tolDist] = ...
            b2841_preparPProj (x, Degree, Ncp, KnotV, Usize, P ,w, xdim, udim)

% RETURNS: some vbles. necessary for starting point projection

% Ulims(udim,2): param. space mins and maxs.
% seekst(udim,1): step to find initial Ucoor for point projection
% fUcoor(udim,1): first u coord for x point projection
% dmin: minimum distance reference in physical space
% tolDist:  tolerance in distance to stop search initial Ucoor in case it
%           coincides with the actual solution

% INPUTS:
% x(xdim,1):  physical coord's

% 1.- SETS MIN. DISTANCE (dmin) AS 'DIAGONAL' OF PATCH CP'S PHYSICAL COORD'S
% ALSO: tolDist: tolerance to consider initial Ucoor is the solution

tncp = 1 ; % total No. cp's
for di = 1:1:udim
    tncp = tncp * Ncp(di);
end

temp = sortrows(P,[1:1:xdim]);
a = zeros(xdim,1);
b = zeros(xdim,1);

for di=1:1:xdim
    a(di) = temp(1,di);
    b(di) = temp(tncp,di);
end
dmin = norm(b-a);

conta = 1 ;
while (abs(dmin)<0.0001) % makes sure distance is not so small or zeros (i.e. closed surfaces)
    
	for di=1:1:xdim
        a(di) = temp(1,di);
        b(di) = temp(tncp-conta,di);
 	end
    dmin = norm(b-a);
    conta = conta+1;
    
end

% compares a few points with x, in case that distance is greater:

if norm(x-a) > dmin
    dmin = norm(x-a);
end

if norm(x-b) > dmin
    dmin = norm(x-b);
end


% tol. to assume coincidence point:
tolDist = dmin * 0.000001 ;



% 2.- U LIMITS AND STEP FOR SEEKING:

ULims = zeros(3,2);
seekst = zeros(3,1);
    
for di = 1:1:udim
        
    ULims(di,1) = KnotV(di,1);
    ULims(di,2) = KnotV(di,Usize(di));

    seekst(di) = (ULims(di,2) - ULims(di,1) )*0.25;
end
   

% 3.- INITIAL Ucoor FOR SEATCHING ucoord's OF 1st Xcoord's:

% finds closest Ucoor with seekst:
[fUcoor,~] = b2842_intialU (seekst, ULims, x, dmin, tolDist, Degree, Ncp, KnotV, Usize, P ,w, udim, xdim);
                            


end

