function [sU] = t2801_PPforSetPoints (nsp, sX, KnotV, Degree, Usize, nAN, mA, xdim, udim)

% RETURNS:
% sU(nsp,udim): param. coord's of a set of points, computed by using point projection

% INPUTS:
% nsp: No. points
% sX(nsp,xdim): physical coord's of points
% KnotV, Degree, Usize, nAN, mA: T-apline patch features


% 1.- Computes some parameters to use afterwards and first Ucoor for first Xcoor point projection:

[ULims, seekst, Ucoor, dmin, tolDist] = ...
    t2802_preparPProj (nsp, sX, KnotV, Degree, Usize, nAN, mA, xdim, udim);
                                                            

wb = waitbar(0,'computing Ucoor of stress rep. points');
set(wb,'Name','point projection process');
wbPos = [10 250 300 70]; % left bottom wide height
set(wb,'position', wbPos);


% 2.- Point projection for each point:
  
sU = zeros(nsp,udim);
Xcoor = zeros(3,1);

for po = 1:1:nsp
    
    for di = 1:1:xdim
        Xcoor(di) = sX(po,di);
    end

    [Ucoor] = t2803_PP_with_preSel ...
    (Xcoor, Ucoor, ULims, seekst, dmin, tolDist, KnotV, Usize, Degree, nAN, mA, udim,xdim);
    
    for di = 1:1:udim
        sU(po,di) = Ucoor(di);
    end
    
    waitbar(po/nsp,wb, strcat('point= ',num2str(po+1))) ; 
end

delete (wb);

end

