function [err1, err2, E2] = z2802_errors (P, S, dS1, xdim, udim, Lerr2)

% if E2=0 then error type 2 is negligible, otherwise E2=1

% 1.- Point coincidence error ('err1'):

err1 = 0 ;
for xdi = 1:1:xdim
    err1 = err1 + (P(xdi)-S(xdi))^2;
end
err1 = err1^0.5;


% 2.- Zero cosine error:

err2 = zeros(udim,1);

SP = zeros(xdim,1);

for xdi=1:1:xdim
    SP(xdi) = S(xdi)-P(xdi);
end

for i=1:1:udim
    
    Si = zeros(xdim,1);
    for xdi=1:1:xdim
        Si(xdi) = dS1(i,xdi);
    end
    
    err2(i) = abs(dot(Si,SP)) / (norm(Si)*norm(SP));
    
end


E2 = 0;

for di=1:1:udim
        
    if err2(di)>Lerr2
        E2 = 1;
        break
    end
    
end


end

