function [u, fBackD, fLoopD] = z2803_Ulimits (KnotV, Usize, u, udim, CD)

% RETURNS:
% u(udim): updated u coordinates to give it back to domain
% fBackD(udim) = 1 if u was out of domain and goes back
% fLoopD(udim) = 1 if us passes to the other side in the loop


% INPUTS:
% CD(udim): closed domain flag, in case the domaim is closed (e.g. pipe),
% then CD=1 and the check is different


fBackD = zeros(udim,1) ;
fLoopD = zeros(udim,1) ;

for di = 1:1:udim
    

    % 1.- Ends of parameter space:
    
    a = KnotV(di,1);
    b = KnotV(di,Usize(di));
    

    % 2.- No-closed domain:
    
    if CD(di)==0 
    
        if u(di) < a
        u(di) = a;
        fBackD(di) = 1 ;
        end

        if u(di) > b
        u(di) = b;
        fBackD(di) = 1 ;
        end
           
        
    % 3.- Closed or looped domain
    
    elseif CD(di)==1 
        
        u(di) = round(u(di),9);
        
        % for more than one loop, divides and takes the resto + one loop:
        if abs(u(di)) > 2*(b-a)
            u(di) = mod(u(di),(b-a)) + (b-a);
        end
        
        
        while u(di)<a || b<u(di)

            if u(di) < a
            u(di) = b -(a-u(di));
            fLoopD(di) = 1 ;
            end

            if u(di) > b
            u(di) = a + (u(di)-b);
            fLoopD(di) = 1 ;
            end
        
        end
    end
end




end

