function [Mr] = GEN_44_removeRepeatedRows_DEL (M, Ncols)

% RETURNS:
% Mr:   matrix with removed repeated rows:

% INPUTS:
% M:    original matrix
% Ncols:    No. columns of M


% 0.- PREMILIMARIES:

M = sortrows(M, [1:1:Ncols]); % arrange M in ascending order

Mr = zeros(1,Ncols); % to store non-repeated rows

cOR = 0 ; % counter of original matrix M
cNO = 0 ; % counter of non-repeated matrix Mr

P1 = zeros(Ncols,1);
P2 = zeros(Ncols,1);





% 1.- LOOP ON matrix M:

flagA = 0;
while (flagA == 0)

    cOR = cOR+1;
    
    % 1.1- Compares M row with next row to check if are the same:
    
    % last row: has to be non-repeated
    if cOR == size(M,1)
        
        cNO = cNO+1;
        for po =1:1:Ncols
            Mr(cNO,po) = M(cOR,po); 
        end
        flagA = 1;
        
    % no last row: compare with the next one
    else
        
        for po = 1:1:Ncols
            P1(po,1) = M(cOR,po);
            P2(po,1) = M(cOR+1,po);
        end
        CO = GEN_42_coincidentP (P1, P2, Ncols, 2);
        
    end
    

    
    % 1.2.- non-repeated edge: add to Mr
    
    if CO == 0 && flagA == 0
        cNO = cNO+1;
        for po =1:1:Ncols
            Mr(cNO,po) = P1(po,1); 
        end
    end
    
    
    % 1.3.- repeated edges: detects next non-repeated:
    
    if CO == 1 && flagA == 0
        
        flagB = 0;
        while (flagB == 0)
            
            cOR = cOR+1;
            
            if cOR == size(M,1) % if reaches end of M, just finish
                
                flagA = 1;
                flagB = 1;
                
            else
                
                for po =1:1:Ncols
                    P1(po,1) = M(cOR,po);
                    P2(po,1) = M(cOR+1,po);
                end
                CO = GEN_42_coincidentP (P1, P2, Ncols, 2);
                if CO == 0
                    flagB = 1 ;
                end
                
            end

        end
    end
    

    
end



end

