function [Spatches] = c0914_u2anchors (Spatches, Npa, duacc, du, insR)

% RETURNS:
% patches object with stored anchors displacements (mu)

xdim = 3 ;
udim = 3 ;

contaDisp = 0;
for pa = 1:1:Npa
    
    
    % 1.- EXTRACTS ANCHORS DATA AND PREPARES mu VECTOR:

    pKnotV  = Spatches(pa,1).INS(insR).mKnotV;
    pDegree = Spatches(pa,1).INS(insR).mDegree;
    pUsize  = Spatches(pa,1).INS(insR).mUsize;
    pEw     = Spatches(pa,1).INS(insR).mEw;
    pEP     = Spatches(pa,1).INS(insR).mEP;
    pNcp    = Spatches(pa,1).INS(insR).mNcp;

    pnAN    = Spatches(pa,1).INS(insR).nAN;   
    pAref   = Spatches(pa,1).INS(insR).mAref ;

    pmA     = Spatches(pa,1).INS(insR).mA ;
    
    tmA(pnAN,1) = GenAnchor ;
    
    % Spatches(pa).mRefin(insR).mu = zeros(pnAN*xdim,1);
    pu = zeros(pnAN*xdim,1);
    
    
    % 2.- TRANSFERS TO PATCH AND ANCHORS THE VECTOR OF DISPLACEMENT:
    
    for a = 1:1:pnAN
        
        %tmA(a).mLKV = Spatches(pa).mRefin(insR).mA(a).mLKV;
        %tmA(a).mWeig = Spatches(pa).mRefin(insR).mA(a).mWeig;

        tmA(a).mWeig = pmA(a).mWeig ;
        
        if pAref(a)>0

            aXdisp = zeros(xdim,1);
         	aXcoor2 = zeros(xdim,1);
            
            for di=1:1:xdim

                contaDisp = contaDisp + 1;

                % Spatches(pa).mRefin(insR).mu(a*xdim-3+di)    = duacc(contaDisp);
                pu(a*xdim-3+di) = duacc(contaDisp);
                
                % Spatches(pa).mRefin(insR).mA(a).mXdisp(di,1) = duacc(contaDisp);
                % Spatches(pa).mRefin(insR).mA(a).mXcoor2(di)  = Spatches(pa).mRefin(insR).mA(a).mXcoor(di) + du(contaDisp);

                aXdisp(di,1) = duacc(contaDisp);
                aXcoor2(di,1) = pmA(a).mXcoor(di) + du(contaDisp);
                
            end

            Spatches(pa,1).INS(insR).mA(a).mXdisp = aXdisp;
            Spatches(pa,1).INS(insR).mA(a).mXcoor2 = aXcoor2 ;
            
            tmA(a).mXcoor = Spatches(pa,1).INS(insR).mA(a).mXcoor2 ;
        end
    end
      
    % allocates:
    Spatches(pa,1).INS(insR).mu = pu;
    

    % transfers coord's to cp's array:
    contaA = 0 ;
    
    pEP2 = zeros(pNcp(1),pNcp(2),pNcp(3),xdim);
    
    for i = 1:1:pNcp(1)
    for j = 1:1:pNcp(2)
    for k = 1:1:pNcp(3)
        
        contaA = contaA + 1 ;
        for di = 1:1:xdim
        pEP2(i,j,k,di) = Spatches(pa,1).INS(insR).mA(contaA).mXcoor2(di);
        end
    end
    end 
    end
    
        
    % 3.- UPDATES COORDINATES OF BOUNDED SKINS:
    
    nBS = Spatches(pa,1).INS(insR).nBS ;
    
    for sk = 1:1:nBS
        
        NV = Spatches(pa,1).INS(insR).mBskin(sk).mNV; % all vertexes of skin
        
        u = zeros(udim,1);
        
        xp = zeros(NV,3);
        
        for v = 1:1:NV

            u(:,1) = Spatches(pa,1).INS(insR).mBskin(sk).mAv(v,:);
            [X] = b2601_BNURBS_Xcoord (u, pKnotV, pNcp, pDegree, pUsize, pEw,pEP2, udim, xdim);

            xp(v,:) = X(:,1);
            
            Spatches(pa,1).INS(insR).mBskin(sk).mXv2(v,:) = X(:,1);
            
        end
        
        %{
        if sk==1
            
            xp
            
            figure(sk)
            scatter3(xp(:,1),xp(:,2),xp(:,3),'r'); hold on
            axis equal
            
        end
        %}
        
        clearvars NV;
    end

    
    
    clearvars pDegree nAN pAref tmA pmA nGS;
    
end




end

