function [aEr, A,B,C,D ] = fs0713_ErrorE2_simple (D1, D2, dQ, xdim, aEtol)

% RETURNS:
% nEr: abs. error btw estimated and actual surface coordinates for order 2 (norm value)
% A,B,C,D: factors of cubic equation to estimate the longest new increment


% Increments products:

Dxxx = 3/64*D1^3 ;
Diii = 3/64*D2^3 ;
Dxxi = 1/64*D1^2*D2 ;
Diix = 1/64*D2^2*D1 ;


% Errors for the 3 dims:

Er = zeros(xdim,1); 
    
for di = 1:1:xdim
            
    fxxx = dQ(1,di) ;
    fiii = dQ(4,di) ;
    fxxi = dQ(2,di) ;
    fiix = dQ(3,di) ;

    Er(di,1) = (abs(Dxxx*fxxx) + 3 * abs(Dxxi*fxxi) + 3 * abs(Diix*fiix) + abs(Diii*fiii))/6;

end
        


% Error norm and A,B,C,D to estimate D1 or D2 (the longest one):
        
aEr = norm(Er);
   
if D1 > D2 % x is D1
            
    A = fxxx;
    B = fxxi*D2/2;
    C = fiix*D2^2/4 ;
    D = fiii*D2^3/8-128*aEtol;

    if round(A,6)==0 && round(B,6)==0 && round(C,6)==0

        A = fiii;
        D = -128*aEtol;

    end
            
else  % x is D2
            
    A = fiii;
    B = fiix*D1/2;
    C = fxxi*D1^2/4 ;
    D = fxxx*D1^3/8-128*aEtol;

    if round(A,6)==0 && round(B,6)==0 && round(C,6)==0

        A = fxxx;
        D = -128*aEtol;

    end
            
end
        


end

