function [Au, Av, ust] = fs0733_Sdi ...
    (pDegree, pNcp, pKnotV, pUsize, pP, pw, pCD, sKnotV, sNcp, sDegree, sEw, sEP, sUsize, cU1, Nc1, Umid, st, xdim, Xtol, DUtol)

% RETURNS: Points to estimate 3rd derivative in curves
% Au(4,pudim): in direction 1
% Av(4,pudim): in direction 2

sudim = 2 ;
nd = 6 ;

% 1.- SURFACE PARAM. COORDINATES:

[ui, ust] = fs0703_sampleP3dcc (Umid, st, nd, cU1, Nc1);



% 2.- COMPUTES PHYSICAL COORDINATES: mapping

xu = zeros(4,xdim);
xv = zeros(4,xdim);

u = zeros(sudim,1);
v = zeros(sudim,1);

for i = 1:1:4

    u(:,1) = ui(1,i,:);
    
    [X] = b2601_BNURBS_Xcoord (u , sKnotV, sNcp, sDegree, sUsize, sEw,sEP, sudim, xdim);
    xu(i,:) = X(:,1);
    
    v(:,1) = ui(2, i,:);
    
    [X] = b2601_BNURBS_Xcoord (v , sKnotV, sNcp, sDegree, sUsize, sEw,sEP, sudim, xdim);
    xv(i,:) = X(:,1);
    
end



% 3.- COMPUTES PATCH PARAM. SPACE COORDINATES: point projection

[Au] = v2861b_PPvol (xu, 4, pDegree, pNcp, pKnotV, pUsize, pP, pw, pCD, xdim, Xtol, DUtol);
[Av] = v2861b_PPvol (xv, 4, pDegree, pNcp, pKnotV, pUsize, pP, pw, pCD, xdim, Xtol, DUtol);




end

