function [iNv, iUv] = fs0748_iNodes (Us, Ns, cDu)

cULims = [0 1];

iUv = zeros(1,1);
iNv = 0;

% transfers to x-y names, like coordinates:
nd = 6 ;
x = round(Us,nd);
y = round(cDu,nd);

% front advancing:
c1 = 0;
tu1 = zeros(2,1);
endF = 0 ;
    


% 1.- SPECIAL CASES:
    
spF = 0; % special case flag
    
% 1.1.- Minimum step is greater that 0.475 => just inserts mid-node:
    
if  0.475 < min(y)
        
	iNv = 3 ;
        
	iUv(1,1) = 0 ;
	iUv(2,1) = 0.5 ;
	iUv(3,1) = 1 ;
        
	spF = 1 ;
        
end
    
    
% 1.2.- All steps vary less than +- c portion of the Uspan => uses average
    
avy = sum(y)/Ns;
c = 0.05 ;
    
if (avy-c <= min(y) && min(y) <=avy+c) && ...
   (avy-c <= max(y) && max(y) <=avy+c)  
        
        % computes No. segments (mininum 2)
        n = round(1/avy,0);
        if n<2
            n = 2 ;
        end
        
        % corrects (n+1) to be odd number:
        if mod(n+1,2)==0
            n = n+1;
        end
        
        d = 1/n;
        
        iNv = n+1;
        
        acc = 0 ;
        for i = 1:1:n
            iUv(i,1) = acc ;
            acc = acc + d;
        end
        
        iUv(n+1,1) = 1 ;
        
        spF = 2 ;
end
    
    
    
% 2.- REST OF THE CASES:
    
if spF == 0
    
	ns0 = y(1); % initial nodal step

	t1 = x(1);  % interval limits
	t2 = x(1) + ns0;

	c1 = c1+1;
	tu1(c1,1) = t1 ; % first node

	% inserts nodes until it passes the curve param. limits:
	while endF == 0

            % checks if in interval t1-t2 exists one x that requires smaller step:

            f = 0.925 ; % factor for tolerance when detecting smaller steps
            sF = 0 ;    % split flag
            vR = 0 ;

            for i = 1:1:Ns-1

                if t1 <= x(i) && x(i)<=t2

                    rs = y(i);

                    if rs < f*ns0
                        sF = 1 ;
                        vR = i;
                        break
                    end

                elseif t2 < x(i)
                    break
                end

            end



            % initial step is not to be split, then computes next initial step:

            if sF == 0

                t1 = t2;

                ns0 = fs0749_lineInterp (Ns, x, y, t1);

                t2 = round(t1 + ns0,nd) ;


                % allocates node:
                c1 = c1+1;
                tu1(c1,1) = t1 ;

            end

            % initial step is to be split, 
            % then sets new node and computes next initial step:

            if sF == 1

                % trhee nodes centre in vR with required step
                x0 = x(vR) - y(vR);
                x1 = x(vR) ;
                x2 = x(vR) + y(vR);


                % revises x0: moves acc. to proportions ns0 and y(vR): PENDING
                [rx, rN] = fs0750_redistrNod (t1, t2, x0, x1, x, y, vR, Ns);

                % allocates rx, that contains nodes
                % - from: next node to t1; to:
                % - node at x0.

                for i = 1:1:rN
                    c1 = c1 + 1 ;
                    tu1(c1,1) = rx(i) ;
                end


                % resets intevals and initial step:

                t1 = rx(rN) ;

                ns0 = fs0749_lineInterp (Ns, x, y, t1);

                t2 = round(t1 + ns0, nd) ;

            end



            % ends loop if out of domain
            if 1 < t2
                t2 = 1 ;
                endF = 1;
            end

	end

	% allocates last node:
	c1 = c1 + 1 ;
	tu1(c1,1) = cULims(2) ;


	% in case of No. nodes even , adds another one:
	if mod(c1,2)==0
        [tu1] = fs0751_addtoEven (tu1, c1);
        c1 = c1 + 1 ;
    end
        
	% moves second and prev-last node at mid-location:
        
	tu1(c1-1) = ( tu1(c1-2) + tu1(c1) ) / 2 ;
	tu1(2)    = ( tu1(1) + tu1(3) )     / 2 ;
        
	% allocates to answer:

	iNv = c1 ;
	for i = 1:1:c1
        iUv(i,1) = tu1(i) ;
	end

end


% 3.- MOVES MID-NODES TO THE CENTER OF THE SEGMENT:

for i = 2:2:iNv
    
    n1 = i-1;
    n2 = i+1;
   
    um = (iUv(n1,1) + iUv(n2,1))/2 ;
    
    iUv(i,1) = um ;
    
end




end

