function [ dist, r , Pside ] = GEN_25_distPtoV_2D (P, Xo, V, dim )

% RETUNRS:
% dist:     distance from P to Xo
% r:        vector from P to Xo
% Pside:    P is 'left' or 'rite' about vector V

% for 2D geometry


% INPUTS:
% P:        point to evaluate
% Xo:       point where V is applied
% V:        vector

[dist, r] = GEN_22_dist_bwtin_2P( P, Xo, dim );


if size(r,1) > 1
   r = r' ; 
end


if size(V,1) > 1
   V = V' ; 
end


rxc = cross([r 0], [V 0]); % cross product

if rxc(3) > 0
    Pside = 'left' ;
else
    Pside = 'rite';
end



end

