function [n] = i3160_nVersor (tface, f, xdim)

% RETURNS:
% n: normal versor of surface, pointing outwards the shell
% uses cross prodcut of vector P1P2 x P2Pn-1


   
% 1.- Extracts information from the face structure and 
%     picks up all the control points of the curves arranged acc/to loop
%     sense and remove repeated ones:


fO       = tface(f).fO;
Noc      = tface(f).fLoop(1).Noc;
oLCurves = tface(f).fLoop(1).LCurves;

conta = 0;
P = zeros(1,xdim); % cp's physical coordinates

for c = 1:1:Noc
    
    for po = 1:1:oLCurves(c).Ncp
        
        conta = conta + 1 ;
        for di=1:1:xdim
           P(conta,di) = oLCurves(c).P(po,di); 
        end
    end
end


[P,~] = GEN_16_RemoveRepeatedRows (P, xdim, 0.000001);
nr = size(P,1); % No. non-repeated cp's:


% 2.- Generates vectors v1 = P1P2 and v2 = P2Pnr

% note, if v2 is co-linear to v1 goes to the previous control point until
% they are not co-linear

v1 = zeros(1,xdim);

for di = 1:1:xdim
    v1(di) = P(2,di)  - P(1,di);
end


v2 = zeros(1,xdim);
ya = 0;
conta = nr ;
while (ya==0)
                             
    for di = 1:1:xdim
        v2(di) = P(conta,di) - P(2,di);
    end
    
    % if v1 is not parallel to v2 is a valid pair and breaks the loop:
    [PV] = go2509_ParallelVectors (v1, v2, xdim,6);
    
 
    if PV == 0
        ya=1;
    end

    conta = conta - 1 ;
end



% 3.- Computes perp. vector by v1 x v2:
% note that inverts if loop orientation is inverted

n = cross(v1,v2)';
n = n / norm(n);



if fO~=1
    n = -n; 
end




end

