function [pNn, pXnod, pAnod] = im0145b_PrelimNodes (pNcp, pEP, pEw, pP, pw, pDegree, pKnotV, pUsize, pULims, pxdim, pudim)

% RETURNS:
% pNn: preliminary No. nodes and their coordinates

Xtol = 0.01; % for pp
DUtol = 0.005;

% Initial nodes coord's, using control net cells:

% No. nodes:

pNn = pNcp(1)*pNcp(2)*pNcp(3);

nXo = pP; % initial position

% final position of truss:

% Truss No. bars and conn. matrices:

[NB, ND, TNB, TN, nNod, DoF, NE, BVcon, RVcon, flagEB] = tr3241_reg3DTrussBars (pNcp, pxdim);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%{
fr = 1 ;
colNet =' --r';

stp = [0.1 0.1 0.1];

figure(fr)

conta = 0 ;

for i = 1:1:pNcp(1)
for j = 1:1:pNcp(2)
for k = 1:1:pNcp(3)
    
    conta = conta + 1 ;
    
    if (i==1 || i==pNcp(1)) || (j==1 || j==pNcp(2)) || (k==1 || k==pNcp(3)) 
        
        scatter3(pP(conta,1), pP(conta,2), pP(conta,3),120, 'r'); hold on
        
    else
        scatter3(pP(conta,1), pP(conta,2), pP(conta,3), 100, 'r', 'filled'); hold on
        
    end
    
end  
end
end


% r3022_printCPnet (pP, pNcp, 3, fr, colNet)

r3005_Gedges (fr, stp, pKnotV, pNcp,pDegree,pUsize, pEw, pEP, pudim,3);

axis equal

%if gg==0
%end
%}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



% Stiffness matrices:

Kb = zeros(DoF,DoF); % bars
Kd = zeros(DoF,DoF); % diagonals

K = zeros(DoF,DoF);

% computes each sub-K with E = 1

E = 1 ;
Npr = 2 ; % No. nodes per row

for b = 1 : 1 : TN

    % nodes refs
    nr(1) = BVcon(b,1);
    nr(2) = BVcon(b,2);
    
    % length and orientation:
    DX(:,1) = nXo(nr(2),:) - nXo(nr(1),:) ;
    L = norm(DX);
    u = DX/L;
    
    % element stiffness matrix (given already in global axis):
    [kL] = ms3201_KGrod3D (E,1,L, u);
    
	% add to sub-K
    if 0 < b && b <= NB(1)    
        [Kb] = a3211_insertinK (Kb, kL, nr, Npr, pxdim);
 	elseif TNB < b && b <= TN  
        [Kd] = a3211_insertinK (Kd, kL, nr, Npr, pxdim);
    end
    
end


% known and un-known refs:

[nk, nu, dkr, dur] = tr3242_ShellKnownNodRefs (pNcp, nNod);


% prescribed displacements:

[ur] = pd0170_prescribedDispl (DoF, pNcp, pDegree, pKnotV, pUsize, pEP, pEw, pP, pw, pxdim, Xtol, DUtol);



% computes displacements:

K = 2*Kb + 1*Kd;
[u] = ts3231_prescribedUsol (DoF, nNod, K, ur, nk, dkr, nu, dur, pxdim);


% updates nodes coordiantes:

Xnod = zeros(nNod,pxdim);

for i = 1:1:nNod
    for di = 1:1:pxdim
        r = i*pxdim - (pxdim-di);
        Xnod(i,di) = pP(i,di) + u(r);
    end
end





% Patch param. coord's:
[pAnod] = v2861b_PPvol (Xnod, pNn, pDegree, pNcp, pKnotV, pUsize, pP, pw, [0 0 0], pxdim, Xtol, DUtol);



% Physical coordinates:

pXnod = zeros(pNn,pxdim);

for i = 1:1:pNn
    
    Acoor = round([pAnod(i,1), pAnod(i,2), pAnod(i,3)],6);
    
    [X] = b2601_BNURBS_Xcoord (Acoor, pKnotV, pNcp,pDegree,pUsize, pEw,pEP, pudim,pxdim);
    pXnod(i,:) = X(:,1);

end





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fr = 1 ;
colNet =' --r';

stp = [0.1 0.1 0.1];

figure(fr)

conta = 0 ;

for i = 1:1:pNcp(1)
for j = 1:1:pNcp(2)
for k = 1:1:pNcp(3)
    
    conta = conta + 1 ;
    
    if (i==1 || i==pNcp(1)) || (j==1 || j==pNcp(2)) || (k==1 || k==pNcp(3)) 
        
        scatter3(pXnod(conta,1), pXnod(conta,2), pXnod(conta,3),120, 'b'); hold on
        
    else
        scatter3(pXnod(conta,1), pXnod(conta,2), pXnod(conta,3), 100, 'b', 'filled'); hold on
        
    end
    
end  
end
end


% r3022_printCPnet (pP, pNcp, 3, fr, colNet)

r3005_Gedges (fr, stp, pKnotV, pNcp,pDegree,pUsize, pEw, pEP, pudim,3);

axis equal

if gg==0
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




end

