function [tAv, tXv, tUs, tUc, tANv, tXNv, tNS, tSR, tNC, tCR] = im0148_NNttr ...
    (sR, tNV, i, tAv, tXv, tUs, tUc, tANv, tXNv, tNS, tSR, tNC, tCR, skin, slpF)

% RETURNS:
% Features of new node of TTR, first time is detected

% factor for slave patches:

f = 1 ;
if slpF == 1
    f = -1 ;
end

nv = zeros(3,1);

% Node coordinates and normals in patch parameter space:

if slpF == 0
    
    tAv(tNV,:) = skin.mAv(i,:);
    
    nv(:,1) = skin.mANv(i,:);
    tANv(tNV,:) = nv;
    
elseif slpF == 1
    
    tAv(tNV,:) = skin.mAvS(i,:);
    
 	nv(:,1) = skin.mANvS(i,:);
    tANv(tNV,:) = nv;
    
end


% same but in physical space:

tXv(tNV,:) = skin.mXv(i,:);
      
nv(:,1) = skin.mXNv(i,:);
tXNv(tNV,:) = f * nv;



% Surface where the node lies in:

tNS(tNV,1) = 1 ; % add first skin
tSR(tNV,tNS(tNV,1)) = sR ;   % stores skin ref.
tUs(tNV,sR,:) = skin.mUv(i,:);  % stores skin param. coord's


% Curve where the node lies in:

Nec = skin.mNec(i,1);

tNC(tNV,1) = 0 ;
tCR(tNV,1) = 0 ;  
tUc(tNV,1,1) = 0 ;

if Nec > 0
    tNC(tNV,1) = Nec ;
end

for c = 1:1:Nec
    
	cR = skin.mER(i,c);
	Ev = skin.mEv(i,c);

	tCR(tNV,c) = abs(cR) ;
	tUc(tNV,abs(cR),1) = Ev;  
    
end


%{

Nlo = skin.mNlo ;
NCL = skin.mNCL ;

Nlv = skin.mNlv ;
Nlcv = skin.mNlcv ;


if Nec > 0
    
    tNC(tNV,1) =  Nec ; % add first curve(s)
    
    if Nec == 1
        
        cR = skin.mER(i,1);
        Ev = skin.mEv(i,1);
        
        tCR(tNV,1) = cR ;
        tUc(tNV,abs(cR),1) = Ev;  
        
        
    elseif Nec == 2
        
        for c = 1:1:Nec
            
            cR = skin.mER(i,c);
            Ev = skin.mEv(i,c);

            tCR(tNV,c) = cR ;
            tUc(tNV,abs(cR),1) = Ev;  
        end
    end

end
%}

end