function [Nlo, Nlv, CoorL, unCoorL] = r3016_contoCoor (skin, PhyS, ParS, sc, xdim, udim)

% RETURNS: info for representing loops of ine skin
% nlo: No loops
% nPL: No. points per loop
% CoorL. coord's


% extracts surface No. loops, vertexes and coordinates:

Nlo = skin.mNlo ;
Nlv = skin.mNlv ;
    
if PhyS==1
    
    Xcoor0 = skin.mXv0;
    Xcoor1 = skin.mXv2 ;
    
    Scoor0 = Xcoor0 ;
    Scoor  = Xcoor0 + (Xcoor1-Xcoor0)*sc;
    
elseif ParS == 1  
    
    Scoor0 = skin.mAv ;
    Scoor  = skin.mAv ;
    
end


% Allocates coordinates of contours:

CoorL   =  zeros(Nlo,max(Nlv)+1,3);
unCoorL =  zeros(Nlo,max(Nlv)+1,3);

conta = 0 ;
for lo = 1:1:Nlo
    
    for v = 1:1:Nlv(lo)

        conta = conta + 1 ;
        
        CoorL(lo,v,:) = Scoor(conta,:);
        unCoorL(lo,v,:) = Scoor0(conta,:);
    
    end
    
    
    % Adds first loop point again at the beggining:
    
    CoorL(lo,v+1,:) = Scoor(conta-Nlv(lo)+1,:);
    unCoorL(lo,v+1,:) = Scoor0(conta-Nlv(lo)+1,:);
    
end





end

