function [Coor, unCoor, ST, TVcon] = r3017_CoorSTconM (skin, PhyS, ParS, insRs, sc, xdim, udim)

% RETURNS:
% Coor(nP,dim) coordi's of specified skin
% Coor(nP,dim) coordi's of specified skin for undeformed !
% ST(nP,...): stresses at each point
% conM: connection matrix for skin points

% INPUTS:
% skin: features
% Physical, Parameter: space selector


% 1.- Extraction of basic data:

NV = skin.mNV;
    
if PhyS == 1
    dim = xdim; 
elseif ParS == 1
    dim = udim;
end
    
Coor = zeros(NV,dim);
unCoor = zeros(NV,dim);
ST = zeros(NV,1);
    
TVcon = skin.mTVcon ;
    

% 2.- Transfers coordinates and stresses:

for v = 1:1:NV
       
    % coordinates:
    
    if PhyS==1

        for di=1:1:xdim
            
            Coor(v,di) = skin.mXv0(v,di) + ...
            (skin.mXv2(v,di) - skin.mXv0(v,di)) * sc;
        
            % Coor(v,di) = skin.mXv2(v,di);
        
            unCoor(v,di) = skin.mXv0(v,di);
        end

  	elseif ParS==1

        for di=1:1:udim
            Coor(v,di) = skin.mAv(v,di);
        end
        
    end


    % stresses:
    
    if insRs==1 && sc==0
        ST(v,1) = 0 ;
    else

        % ST(v,1) = skin.mP(v).mVM ; %REACTIVAR ESTO !!
        ST(v,1) = 12 ;
    end
end
    


end

