function [ ] = r3019_skin (Coor, unCoor, ST, conM, undef)

% ACTION:
% Draws single skin

% assumes 3D, if not you must extend dimensions before call this function

% INPUTS:
% Npo:              No. points of the skin
% Coor(Npo, dim):   coordinates of skin points
% ST(Npo,1):        stress of each point 
% conM(Npo,3):      connectivity matrix


% 1.- PREPARES ARRAYS FOR fill3 FUNCION:

nE = size(conM,1);

X = zeros(3,nE);
Y = zeros(3,nE);
Z = zeros(3,nE);
C = zeros(3,nE);

uX = zeros(3,nE);
uY = zeros(3,nE);
uZ = zeros(3,nE);
uC = zeros(3,nE);


% 2.- LOOP ON ELEMENTS TO STORE INFO FOR fill3:

for e = 1:1:nE
    
    n1 = conM(e,1);
    n2 = conM(e,2);
    n3 = conM(e,3);
    
    X(1,e) = Coor(n1,1);    X(2,e) = Coor(n2,1);    X(3,e) = Coor(n3,1);
    
    Y(1,e) = Coor(n1,2);    Y(2,e) = Coor(n2,2);    Y(3,e) = Coor(n3,2);
    
  	Z(1,e) = Coor(n1,3);    Z(2,e) = Coor(n2,3);    Z(3,e) = Coor(n3,3);
    
    C(1,e) = ST(n1,1);      C(2,e) = ST(n2,1);      C(3,e) = ST(n3,1);
    
    if undef==1
        
        uX(1,e) = unCoor(n1,1);    uX(2,e) = unCoor(n2,1);    uX(3,e) = unCoor(n3,1);

        uY(1,e) = unCoor(n1,2);    uY(2,e) = unCoor(n2,2);    uY(3,e) = unCoor(n3,2);

        uZ(1,e) = unCoor(n1,3);    uZ(2,e) = unCoor(n2,3);    uZ(3,e) = unCoor(n3,3);

        uC(1,e) = ST(n1,1);      uC(2,e) = ST(n2,1);      uC(3,e) = ST(n3,1);
    
    end
    
end


% 3.- REPRESENTS SKINS:

h = fill3(X,Y,Z,C); hold on
set(h,'EdgeColor','none')
alpha (h, 1.0 ) ;

if undef == 1
    
    uh = fill3(uX,uY,uZ,uC); hold on
    set(uh,'EdgeColor','none') 
    alpha (uh, 0.2 ) ;
    
end

end

