function [NE, TVcon, Rv, Uv, Xv] = rs3334_Rtriang ...
                (cRv,sRv, cUv,sUv, cXv,sXv, NL, Nlv, Nlcv, ncu, sR, xdim)

% RETURNS
% rMcon(NE,3): connectivy matrix
% NE: No. elements of tri-mesh
% assembled coordinates

% mesh in pattern space


% 1.- ASSEMBLIES ALL VERTEXES COORDINATES: first are contour edge vertexes

Rv = sRv;
Uv = sUv;
Xv = sXv;

for l = NL:-1:1
    
    r = zeros(Nlv(l),2);
    u = zeros(Nlv(l),2);
    x = zeros(Nlv(l),xdim);
    
    for v = 1:1:Nlv(l)
        r(v,:) = cRv(l,v,:);
        u(v,:) = cUv(l,v,:);
        x(v,:) = cXv(l,v,:);
    end
    
    Rv = [r ; sRv];
    Uv = [u ; sUv];
    Xv = [x ; sXv];
end



% 2.- GENERATES THE MESH:

Cnst = [ [1:1:Nlv(1)]' [2:1:Nlv(1),1]' ]; % constraint

DT = delaunayTriangulation(Rv,Cnst);

conMtemp = DT.ConnectivityList;

TVcon = zeros(1,3);
NEtemp = size(conMtemp);

ieF = DT.isInterior(); % interior element flag

NE = 0;
for e = 1:1:NEtemp 
    if ieF(e) == 1
        NE = NE+1;
        TVcon(NE,:) = conMtemp(e,:);
    end
end


%{
% 3.- IMPROVES THE MESH BY AMEDING THE EDGE STRIP:

Nc = ncu(sR,1); % No. curves in that loop

[TVcon] = rs3335_ESimprov(Nc, NE, TVcon, Nlcv, Xv, xdim);
%}


end

