function [fP] = sf3157_innerCP (eP, teCurves, ecR, xdim)


fP = ecR ;
udim = 2 ;



% NURBS features:

Ncp = [teCurves(ecR(1,1)).Ncp, teCurves(ecR(2,1)).Ncp];

Degree = [teCurves(ecR(1,1)).Degree, teCurves(ecR(2,1)).Degree];

Usize = [teCurves(ecR(1,1)).Usize, teCurves(ecR(2,1)).Usize];

KV = zeros(udim, max(Usize));

for di = 1:1:udim
    for i = 1:1:Usize(di)
        KV(di,i) = teCurves(ecR(di,1)).KnotV(i);
    end
end

ULims = zeros(udim,2);

for di = 1:1:udim
    ULims(di,1) = KV(di,1);
    ULims(di,2) = KV(di,Usize(di));
end


% Derivatives at edges and param. coords where are computed:

st = zeros(udim,1);
uDer = zeros(udim,1); % coord's in each direction


for di = 1:1:udim
  
    st(di) = (ULims(di,2) - ULims(di,1))/(Ncp(di)-1);
    
    KnotV = KV(di,1:Usize(di));
    
    for si = 1:1:2
        
        P = teCurves(ecR(di,si)).P;
        w = teCurves(ecR(di,si)).w;
        
        conta = 0 ;
        for u = ULims(di,1):st(di):ULims(di,2)

            conta = conta + 1 ;
            [dS] = b2701_BNURBS_deriv (Degree(di), Ncp(di), KnotV, Usize(di), P ,w, 1, u, xdim, 1);

            for xdi = 1:1:xdim
                Der(di,si,conta,xdi) = dS(2,1,1,xdi) ;
            end

            uDer(di,conta) = u ;
            
        end  
    end

end




% finds field of derivatives by interpolation:

fDer = zeros(udim,Ncp(1),Ncp(2),xdim); % derivatives at all points of filled surface


% derivatives w.r.t. direction 1

for i = 1:1:Ncp(1)
    
    d1 = [Der(1,1,i,1);Der(1,1,i,2);Der(1,1,i,3)];
    d2 = [Der(1,2,i,1);Der(1,2,i,2);Der(1,2,i,3)];

    Dd = (d2-d1)/(Ncp(2)-1);

    acc = d1-Dd;

    for j = 1:1:Ncp(2)

        acc = acc + Dd;

        for di = 1:1:xdim
            fDer(1,i,j,di) = acc(di);
        end

        %{
        figure(6)
        
        p1 = [uDer(1,i),uDer(1,i)+acc(1)/1000];
        p2 = [uDer(2,j),uDer(2,j)+acc(2)/1000];
        
        plot( p1, p2, 'b'); hold on
        
        %quiver(p1(1),p1(2),d2(1),d2(2),'k'); hold on
        %}
    end
    
end



% derivatives w.r.t. direction 2

for i = 1:1:Ncp(2)
    
    d1 = [Der(2,1,i,1);Der(2,1,i,2);Der(2,1,i,3)];
    d2 = [Der(2,2,i,1);Der(2,2,i,2);Der(2,2,i,3)];

    Dd = (d2-d1)/(Ncp(1)-1);

    acc = d1-Dd;

    for j = 1:1:Ncp(1)

        acc = acc + Dd;

        for di = 1:1:xdim
            fDer(2,j,i,di) = acc(di);
        end

        %{
        figure(7)
        
     	p1 = [uDer(1,j),uDer(1,j)+acc(1)/1000];
        p2 = [uDer(2,i),uDer(2,i)+acc(2)/1000];
        
        plot( p1, p2, 'b'); hold on
        
        %}
    end
    
end







end

