function [Nn, Xnod, Anod] = im0146_CleanNodes (Rt, pNn, pXnod, pAnod, Eskin, Bskin, pnbe, pRbe, nBS, pudim, pxdim)

xts = [28.52 4.89 66.85]; % for debugging


% 1.- SELECTS NODES WITHIN THE DOMAIN (DEFINED BY TRIMMING SURFACES)
%     USES CLOSEST 'BE' IN PARAM SPACE:

Anodt = zeros(1,pxdim);
Xnodt = zeros(1,pxdim);
Nnt = 0 ;

Acoor = zeros(pudim,1);
Xcoor = zeros(pudim,1);

for i = 1:1:pNn
    
    Acoor(:,1) = pAnod(i,:);
    Xcoor(:,1) = pXnod(i,:);
    
    % 1.1.- Examines if is IN:
    
    IN = i0102_pIN_2 (Acoor, pnbe, pRbe, Eskin, pudim, 'closed', 1);
    

    % 1.2.- Allocates:
    
    if IN==1
        Nnt = Nnt + 1 ;
        Anodt(Nnt,:) = Acoor(:,1);
        Xnodt(Nnt,:) = Xcoor(:,1);
    end
    
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%{


 i0198_plotSkin (Eskin, 8, 1, 2, 3);


%}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% 2.- FROM THE NODES 'IN' REJECTS THOSE CLOSER TO SURFACE LIMITS THAN A TOLERANCE:
% measures distances in physical space

Anod = zeros(1,pxdim);
Xnod = zeros(1,pxdim);
Nn = 0 ;

for i = 1:1:Nnt 
    
	Xcoor(:,1) = Xnodt(i,:);
    Acoor(:,1) = Anodt(i,:);
    
    % minimum Xdist to BE's:
        
	XdminE = 9999 ;
    for b = 1:1:pnbe  

        bR  = pRbe(b);
        if Eskin(bR).mTr == 1

            NE =  Eskin(bR).mNE;
            NV =  Eskin(bR).mNV;
        	TV =  Eskin(bR).mTVcon;
            VT =  Eskin(bR).mVTcon;
          	Xv =  Eskin(bR).mXv;
            
            XNv =  Eskin(bR).mXNv;
            XNe =  Eskin(bR).mXNe;

            [~,sdmin,~,~] = i0104_closestP (bR, Xcoor, NV, TV, VT, XNv, XNe, Xv, pxdim);
            
            if sdmin < XdminE
            	cb = bR ;
             	XdminE = sdmin ;
            end
        end
    end
    
    % minimum Xdist to B-face:
        
	XdminF = 9999 ;
  	for f = 1:1:nBS  

        NE =  Bskin(f).mNE;
        NV =  Bskin(f).mNV;
    	TV =  Bskin(f).mTVcon;
        VT =  Bskin(f).mVTcon;
     	Xv =  Bskin(f).mXv;
        
        XNv = Bskin(f).mXNv;
     	XNe = Bskin(f).mXNe;
        
        [~,sdmin,~,~] = i0104_closestP (f, Xcoor, NV, TV, VT, XNv, XNe, Xv, pxdim);

     	if sdmin < XdminF
        	cf = b ;
         	XdminF = sdmin ;
      	end
    end
        

    % selects minimum distance (to B-face or to BE) and adds if > tol
        
 	Xdmin = min(XdminE, XdminF);
    
    if Xdmin > 0.33*Rt
        Nn = Nn + 1 ;
    	Anod(Nn,:) = Anodt(i,:);
     	Xnod(Nn,:) = Xnodt(i,:);
    end 
        
end

end