function [NE, NV, EVcon, LVcon, ELcon] = im0147c_unTrTetMesh ...
    (Spatches, pR, Xv, Av, pxdim, pudim)

% RETURNS:
% NE: No. elements
% EVcon: conn. matrix element => vertex
% NLId(3): desagregated No. lines: contact with TTR, boudnary, rest
% flagET(NE,1) = 1 for elements in contact with TTR, otherwise = 0

edr = [ 1 2 3 4 4 4 ; 
        2 3 1 1 2 3 ]'; % edges nodes references, e.g. edge 1 goes from node 1 to node 2

    
% 1.- PRELIMINARY TRIANGULATION:

DT = delaunayTriangulation(Xv);

pEVcon = DT.ConnectivityList; % conn. matrix element => vertex

pNE = size(pEVcon,1); % No. elements


% 2.- DELETE TRETRAHEDRALS THAT ARE QUASI-PLANE (in parameter space):

% Compares its current volume 'Vc' against the volume of the regular tetrahedron
% whose side length a = average(sides) 'Va'. If Va/Vc< treshold disregard that tet.
% Works in parameter space.
% Also, returns tet's centre in physical and parameter spaces.

Vthr = 0.01; % 100 times less

[NE, EVcon,~,~] = th1331_delPlanes (Vthr, pNE, pEVcon, Av, Xv, pxdim, pudim);


% 3.- OTHER CONN. MATRICES:

NV = size(Xv,1);

[LVcon, ELcon] = th1332_LV_EL_Linear (Spatches, pR, edr, NE, EVcon);


end