function [mWp, nWIp, conEWp, conWEp, conWNp] = w0151_firstIwires (nELp, conENp, mNp, ImE, gPatch, pa, repI, pudim, pxdim)


% RETURNS:
% mWp:	object, including physical space coord's for representation
% nWIp:   	No. wires

% for rect-mesh

% INPUTS:
% FRefin:   first instace, necessary for mXcoorF calculation
% Elem:     element objects
% mA:       anchors object
% mu:       displacements vector (un-scaled)
% nELp:     No. filled elements of the rect-mesh, physical or param. space
% nELi:     total No. elem's, index space
% KnotV:    global knot vector
% repI:     representation increment

% Strategy: 


% 1.- RELATIONS BETWEEN WIRES, ELEMENTS AND NODES:
%   uses connectivity matrices


[nWIp, conEWp, conWEp, conWNp, pDir] = w0152_connWires (nELp, conENp, pudim);





mWp(nWIp,1) = GenWire;
pKnotV = gPatch(pa).KnotV;
pUsize = gPatch(pa).Usize;

% 2.- FILLS AND COMPUTES PARAMTER/PHYSICAL WIRES FEATURES:

% aux. variables:
ap   = zeros(pudim,1);
bp   = zeros(pudim,1);

for wi = 1:1:nWIp
    
	% 4.1.- Directions:
    
    mWp(wi).mDir = pDir(wi);
    
    
    % 4.2.- Points of wire, icp's, number and mP object:
    
  	n1 = conWNp(wi,1);
    n2 = conWNp(wi,2);
    
    for di=1:1:pudim
        ap(di) = mNp(n1). mUcoor(di);
        bp(di) = mNp(n2). mUcoor(di);
    end
    
    % extracts and merges icps from both nodes:
    
    v1 = zeros(mNp(n1).mNicp,1);
    v2 = zeros(mNp(n2).mNicp,1);
    
    for a = 1:1:mNp(n1).mNicp
        v1(a) = mNp(n1).mRicpA(a);
    end
    for a = 1:1:mNp(n2).mNicp
        v2(a) = mNp(n2).mRicpA(a);
    end
    tRicpA = GEN_22_merge2vec (v1,v2);
    tNicp = size(tRicpA,1);



    reDir = pDir(wi);
        
	[nPO, mPp] = i0199_First_nPOmP (ap,bp, repI, reDir, tNicp, tRicpA, gPatch, pa, pudim, pxdim);

  	mWp(wi).nPO = nPO;
 	mWp(wi).mP  = mPp;
    
    
     % 4.3.- Stores if is perimeter wire: internal / surface / edge
    
    mWp(wi).mPeri = w0502_Perimeter (ap, bp, pKnotV, pUsize, reDir, pudim);

    
    % 4.4.- Wire ON flag:
    
    mWp(wi).ON = 1 ;
    
    acc = 0 ;
    
    for i = 1:1:size(conWEp,2)

        eR = conWEp(wi,i);
        if eR==0
            break
        else
            acc = acc + ImE(eR).ON;
        end
    end
    
    if acc==0 
        mWp(wi).ON = 0 ;
    end

    
end



end

