function [RMesh] = rm0121_FRMesh (gPatch, pa, Bskin, bCurv, Anet, pKnotVI, repI)

% RETURNS:
% RMesh:  initial Rect-mesh object

% INPUTS:

pNcp     = gPatch(pa).Ncp ;
pDegree  = gPatch(pa).Degree ;
pUsize   = gPatch(pa).Usize ;
pKnotV   = gPatch(pa).KnotV ;

pudim    = gPatch(pa).Udim ;
pxdim    = gPatch(pa).Xdim ;



% 1.- DECLARES MESH & COMPUTES INDEX No. ELEMENTS:

RMesh = Rmesh;

nELi = 1 ;
for di=1:1:pudim
    nELi = nELi * (pNcp(di) + pDegree(di));
end




% 2.- COMPUTES mE & GENERAL VBLES. FOR RMesh:

nBS = size(Bskin,1);

[elem, nNOp, nNOi, mInodi, mUnod, mXnod, nodNicp, nodRicpA, nELp, FtoIe,FtoIn, conM, conMs, conMi, conMis, effKVI] = ...
 rm0122_FirstRectElem (gPatch, pa, Bskin, nBS, bCurv, nELi, Anet, pKnotVI);

RMesh.nELi   = nELi ;
RMesh.nNOi   = nNOi ;
RMesh.conENi  = conMi ;
RMesh.conENSi = conMis ;
RMesh.effKVI = effKVI ;

RMesh.nELp  = nELp ;
RMesh.nNOp  = nNOp ;
RMesh.conENp  = conM ;
RMesh.conENSp = conMs ;

RMesh.FtoIe = FtoIe ;
RMesh.FtoIn = FtoIn ;

RMesh.mE    = elem ;




% 3.- COMPUTES mNp & mNi FOR RMesh:

% 3.1.- Nodes param. space: note that mXcoorF = mXcoor in this case
% also allocates Tj=0 to all nodes (initially no T-junctions)

Nodes(nNOp) = GenGeomPoint;
u = zeros(pudim,1);

for nod=1:1:nNOp
   
 	Nodes(nod).mNicp = nodNicp(nod);
    for i=1:1:nodNicp(nod)
        Nodes(nod).mRicpA(i) = nodRicpA(nod,i); 
    end
    
    for di=1:1:pudim
        Nodes(nod).mUcoor(di) = mUnod(nod,di);
        u(di) = mUnod(nod,di);
    end
    
    for di=1:1:pxdim
        Nodes(nod).mXcoor(di) = mXnod(nod,di);
        Nodes(nod).mXcoorF(di)= mXnod(nod,di);
        Nodes(nod).mXcoor2(di)= mXnod(nod,di);
        Nodes(nod).mXdisp(di) = 0;
    end
    
    Nodes(nod).mTj = zeros(pudim,1);
end

RMesh.mNp = Nodes;


% 3.2.- Nodes index space:

Nodesi(nNOi) = GenGeomPoint;

for nod=1:1:nNOi
   
    % Index coord's and Tjunction flags (all zeros initially)
    for di=1:1:pudim
        Nodesi(nod).mIcoor(di) = mInodi(nod,di);
        Nodesi(nod).mTj(di) = 0;
    end
end

RMesh.mNi = Nodesi;




% 4.- COMPUTES FIRST RMesh CABLES:

[pWires, nWIp, iWires, nWIi, conEWi, conWEi, conWNi, conEWp, conWEp, conWNp] =  w0131_firstRwires ...
    (elem,FtoIe, mInodi, mUnod, nodNicp, nodRicpA, nELp, nELi, gPatch, pa, pDegree, pKnotV, pKnotVI, pUsize, repI, pudim, pxdim);

RMesh.nWIp = nWIp ;
RMesh.mWp = pWires;

RMesh.nWIi = nWIi ;
RMesh.mWi = iWires;

RMesh.conEWi = conEWi;
RMesh.conWEi = conWEi;
RMesh.conWNi = conWNi;

RMesh.conEWp = conEWp;
RMesh.conWEp = conWEp;
RMesh.conWNp = conWNp;



end

