function [elem, nNO, nNOi, mInodi, mUnod, mXnod, nodNicp, nodRicpA, nELp, FtoIe, FtoIn, conM,conMs, conMi,conMis, effKVI] = ...
                    rm0122_FirstRectElem (gPatch, pa, Bskin, nBS, bCurv, nELi, Anet, pKnotVI)


% include bCurv here as input (and backwards)


% RETURNS: 

% elem:     element object
% mNO:      No. nodes of the mesh
% mUnod:    param. coord's of nodes
% nELf:     No. filled elements
% FtoI:     correspondence param. mesh - index mesh (for elem's and nodes)
% conM:     nodes connection matrix to filled elements, OJO! is referred to nELf references !


pNcp     = gPatch(pa).Ncp ;
pDegree  = gPatch(pa).Degree ;
pUsize   = gPatch(pa).Usize ;
pKnotV   = gPatch(pa).KnotV ;

pudim = gPatch(pa).Udim ;
pxdim = gPatch(pa).Xdim ;
   
pEw       = gPatch(pa).Ew ;
pEB       = gPatch(pa).EP ;




% 1.- WORK ON ELEMENT object:

% 1.1.- Declares element object and initiates some responses:

elem(nELi) = GenElem;
nELp = 0;
FtoIe = zeros(1,1);


% 1.2.- Expand Usize, then is 1 by default:

eUsize = ones(3,1);
for di =1:1:pudim
eUsize(di) = pUsize(di);
end


% 1.3.- Sets elements indexes limits with no trimming (mTrim, mNcpo, mCupo):

e=1;
for i= 1:1:eUsize(1)-1
for j= 1:1:eUsize(2)-1
    
    elem(e).mIcoLi = zeros(pudim,2);

    if pudim==2

        elem(e).mIcoLi(1,1) = i;    elem(e).mIcoLi(1,2) = i+1;
        elem(e).mIcoLi(2,1) = j;    elem(e).mIcoLi(2,2) = j+1;

        e=e+1;
        
    elseif pudim==3
        
        for k=1:1:eUsize(3)-1
            elem(e).mIcoLi(1,1) = i;    elem(e).mIcoLi(1,2) = i+1;
            elem(e).mIcoLi(2,1) = j;    elem(e).mIcoLi(2,2) = j+1;
            elem(e).mIcoLi(3,1) = k;    elem(e).mIcoLi(3,2) = k+1;

            e=e+1;
        end
    end

    
    % integration edges, at the moment they do not exist : nIed = 0
    elem(e).nIed = 0 ;
    
end  
end


% 1.4.- Icp's and param. space coord's :

Ncor = 2^pudim; % No. corners or 'nodes' of the element

CorELs   = zeros(2,pudim); % corner coord's, assumes 2 corners, but they will be more
UcorElem = zeros(nELi,Ncor, pudim); % param coord's of each element corners (for void elem's remains as 0)
conta    = 0;


% Set icp's on each element:
[elem] = a0113_icpEinitial (elem, Anet, pDegree, pNcp, pudim);


for e=1:1:nELi
    
    Cor = elem(e).cornersIcoor(pudim); % corner indexes of each element
        
    % Param space limits. Also counts nELf and sets FtoI.

    [elem(e).mPcoLi, VoidE ] = p2003_ULims_Vspan (elem(e).mIcoLi, pKnotV, pudim );
     elem(e).mVspan = VoidE ;


    % for non-void elements considers and stores the corners and filled element 
    % reference in previous conM: pconM (later will be used for conM) conMp
    

    if sum(VoidE)== pudim
       
    	nELp = nELp + 1 ; % add non-void (or filled) element
        FtoIe(nELp) = e ; % correspondance to index elements

        for co =1:1:Ncor
           
            conta = conta+1;

            for di=1:1:pudim

                index  = Cor(co,di);

                U = pKnotV(di,1:pUsize(di));

                CorELs(conta,di) = GEN_34_ParamFromIndex( index, U );
                UcorElem(e,co,di) = CorELs(conta,di);

            end
        end
    end
end % loop on elements







% 3.- CONNECTIVITY MATRIX & ON flag:
% conM(nELp,mNOE) and sides conMs(nELf,1)


% 3.1.- No. nodes and param. coord's in nodes param. space (no index);

% removes repeated corner param. coord's, these are the nodes of the mesh:
[mUnod,~] = GEN_16_RemoveRepeatedRows( CorELs, pudim, 0.0001 );

% arrange the nodes:
mUnod = sortrows(mUnod,[1:pudim]);

% No. nodes = No. non-repeated corners:
nNO = size(mUnod,1);


% param. mesh nodes Xcoor:

mXnod = zeros(nNO,pxdim);
u = zeros(pudim,1);
for nod = 1:1:nNO

    u(:) = mUnod(nod,:);
    X = b2601_BNURBS_Xcoord (u, pKnotV, pNcp, pDegree, pUsize, pEw,pEB, pudim,pxdim);
    mXnod(nod,:) = X(:);
    
end





% 3.2.- conM and ON flag:

conM = zeros(nELp, Ncor) ;
cUcoor = zeros(pudim,1);

for e = 1:1:nELp
    

    % extracts / computes data:
    
    eR = FtoIe(e);
    ULims = elem(eR).mPcoLi;
    
    for di=1:1:pudim
        cUcoor(di) = (ULims(di,1) + ULims(di,2)) / 2;
    end
    cXcoor = b2601_BNURBS_Xcoord (cUcoor, pKnotV, pNcp,pDegree,pUsize, pEw,pEB, pudim,pxdim);
    

    
    % conn. matrix:
    
    conE = p2001_elemConM (ULims, mUnod, nNO, Ncor, pudim);
    conM(e,:) = conE(:);
    

 
    
    % determines if element is ON, trimmed and trimming Bskins:

    [IN, eTr, NBsk, BskR] = GEN_61_FcubeIN (gPatch, pa, ULims, cUcoor, cXcoor, Bskin, nBS, bCurv);
    
    if IN==1
        elem(eR).ON = 1 ;
        elem(eR).mTrim = eTr ;
        elem(eR).mNBsk = NBsk ;
        elem(eR).mBskR = BskR ;
    else
        elem(eR).ON = 0 ;
        elem(eR).mTrim = 0 ;
        elem(eR).mNBsk = 0 ;
        elem(eR).mBskR = zeros(1,1) ;
    end
 
end






% 3.3.- conMs: initially all are zeros - no side nodes (coz no T-junctions exist)

conMs = zeros(nELp, 1) ;



% 3.4.- Computes nodes icp's (nodNicp, nodRicpA) and physical coord's (mXnod):

nodNicp = zeros(nNO,1);
nodRicpA = zeros(nNO,1); % '1' might increase to equalize nodNicp


for e = 1:1:nELp
    
    eiR = FtoIe(e);
    
    Nicp  = elem(eiR).mNicp ;
    RicpA = elem(eiR).mRicpA ;
    
    for co=1:1:Ncor
        
        nR = conM(e,co);
        
        if nodNicp(nR)==0

            nodNicp(nR) = Nicp;
            for a = 1:1:Nicp
            nodRicpA(nR,a) = RicpA(a);
            end
            
        else
            
            for a  = 1:1:Nicp
                
                aR = RicpA(a);
                
                % check if anchor ref. 'aR' is already IN
                yasta=0;
                for na = 1:1:nodNicp(nR)
                    naR = nodRicpA(nR,na);
                    if naR == aR
                       yasta=1;
                       break
                    end
                end
                
                % if not, adds:
                if yasta==0
                    nodNicp(nR) = nodNicp(nR) + 1 ;
                    nodRicpA(nR,nodNicp(nR)) = aR ;
                end
            end
        end
    end
    
    
end

for nod = 1:1:nNO

    nodNicp(nod,1) = Nicp ;
    
    for i=1:1:Nicp
       nodRicpA(nod,i) = RicpA(i); 
    end
end






% 4.- NODES & conMi IN INDEX. Also computes  
%     relation bt'n nNO and nNOi: FtoIn:

% 4.1.- No. nodes:

nNOi = 1 ;
for di=1:1:pudim
    nNOi = nNOi * pUsize(di);
end



% 4.2.- Index coord's of nodes:

FtoIn  = zeros(nNO,1);
mInodi = zeros(nNOi,3); % extended to 3 dims

% generates extended -to 3 dims- parameters and visible domain:

extUsize  = ones(3,1);

extKnotVeff = zeros(3,1);
extUsizeeff  = ones(3,1);
Ur = zeros(1,1);
Nu = zeros(3,1);


% index coord's of index nodes:

for di=1:1:pudim
    extUsize(di) = pUsize(di);
end

contaI = 0 ; % counter for nodes in index mesh

for i=1:1:extUsize(1)
for j=1:1:extUsize(2)
for k=1:1:extUsize(3)
    
    contaI = contaI + 1 ;
    
    mInodi(contaI,1) = i ;
    mInodi(contaI,2) = j ;
    mInodi(contaI,3) = k ;

end
end
end


for di=1:1:pudim
    
    % removes repeated values from KnotV's and transfers to extKnoteff:
    
    for i=1:1:pUsize(di)
        Ur(i,1) = pKnotV(di,i);
    end
    [Ur,~] = GEN_16_RemoveRepeatedRows (Ur, 1, 0.00001);
    
    extUsizeeff(di,1) = size(Ur,1);
    
    for i=1:1:size(Ur,1)
        extKnotVeff(di,i) = Ur(i,1);
    end
end


contaP = 0 ; % counter for nodes in parameter mesh

ic = zeros(3,1);

for i=1:1:extUsizeeff(1)
for j=1:1:extUsizeeff(2)
for k=1:1:extUsizeeff(3)

	contaP = contaP + 1 ;
    
    % computes node ucoord's and indexes:
  	Nu(1,1) = extKnotVeff(1,i) ;
    Nu(2,1) = extKnotVeff(2,j) ;
    Nu(3,1) = extKnotVeff(3,k) ;
    
    [Inde] = GEN_30_IndexFromParam (Nu, pKnotV, pUsize, pDegree, pudim);

    
    % finds index mesh node and allocates to FtoIn
    for nod = 1:1:nNOi
        
        ic(:,1) = mInodi(nod,:) ;

        [CO] = go2542_coincidentP (Inde, ic, pudim, 2);
        
        if CO==1
            FtoIn(contaP,1) = nod;
            break
        end
        
    end
end
end
end



% 4.3.- Connectivity matrix:

conMi  = GEN_17_conMortoFull ( pUsize, pudim ) ;
conMis = zeros(nELi,1);


% 4.4.- Effetive LKI, in this case all are populated:

effKVI = ILine;

pDir = [2 3 ; 1 3 ; 1 2]; % perp. directions

extUsize = ones(3,1);
for di=1:1:pudim
   extUsize(di) = pUsize(di); 
end


for di = 1 : 1 : pudim
    
    pd1 = pDir(di,1);
    pd2 = pDir(di,2);
    
    Nseg=0;
    for i=1:1:extUsize(pd1)
    for j=1:1:extUsize(pd2)
        
        Nseg=Nseg+1;
        for k=1:1:pUsize(di);
        effKVI(di).mSeg(Nseg,1).mP(k).mIcoor = pKnotVI(di,k);
        end
        
    end
    end
end





end

