function [Refin] = a0111_FAnchors (gPatch, pa, Refin, Bskin, Eskin, pnbe, pRbe)

% RETURNS:
% Refin with anchors and all parameters depending on them

Ncp     = gPatch(pa).Ncp ;
nAN     = gPatch(pa).noc ;
Degree  = gPatch(pa).Degree ;
Usize   = gPatch(pa).Usize ;
KnotV   = gPatch(pa).KnotV ;
P   = gPatch(pa).P ;
w   = gPatch(pa).w ;

pudim = gPatch(pa).Udim ;
pxdim = gPatch(pa).Xdim ;


% 1.- COMPUTES ANCHORS AND ALLOCATES:

nELp  = Refin.mRM.nELp ;
mE    = Refin.mRM.mE ;
FtoIe = Refin.mRM.FtoIe ;

[mA] = a0112_FirstAfeat ...
(nAN, Ncp, Degree, KnotV, Usize, P, w, Bskin, Eskin, nELp, mE, FtoIe, pnbe, pRbe, pxdim, pudim);

Refin.nAN  	= nAN;
Refin.mA    = mA ;


% 2.- COMPUTES mRefin MEMBERS DEPENDANT ON ANCHORS:

NAon = 0 ;
Aref = zeros(nAN,1);

for a = 1:1:nAN
if mA(a).ON==1
    NAon = NAon + 1 ;
    Aref(a,1) = NAon ;
end
end

Refin.mNAon = NAon; 
Refin.mAref = Aref ;
Refin.mu  	= zeros(nAN*pxdim,1); % initially all displacements are 0

end