function [mA] = a0112_FirstAfeat ...
         (nAN, Ncp, Degree, KnotV, Usize, P ,w, Eskin, pnbe, pRbe, pR, TTR, pxdim, pudim)

% initiates anchors object, No. anchors and No. elements (for dims 2 and 3):
% also returns anchors influenced by B.E.'s


% 1.- INITIATES ANCHORS CLASS & AUX. VECTORS:

mA(nAN,1) = GenAnchor ;
U = zeros(1,max(Usize)); % global knot vector in one direction


% 2.- PARAM. COORD'S. and INDEXES:

a=0 ;
for i=1:1:Ncp(1)
    
    for j=1:1:Ncp(2)
    for k=1:1:Ncp(3)  
        
        a = a+1;
        IX = [i,j,k];
        
        for di=1:1:pudim
            
            if di==1
                x = i ;
            elseif di==2
                x = j ;
            elseif di==3
                x = k ;
            end
            
            U(:) = KnotV(di,:);
            index = (Degree(di)+3)/2 + x - 1 ;
            
            u = GEN_34_ParamFromIndex (index, U);
            
            mA(a).mUcoor(di) = round (u,5) ;
        end

        mA(a).mIX = IX;
        
    end    
    end
end


% 3.- PHYSICAL COORD'S:

for a = 1:1:nAN
 
    mA(a,1).mWeig = w(a);
    mA(a,1).InitiatesParams(pxdim); % iterations parameters mPar

    for di=1:1:pxdim
        mA(a,1).mXcoor(di)  = P(a,di);
        mA(a,1).mXcoorF(di) = P(a,di);
        mA(a,1).mXcoor2(di) = P(a,di);
        mA(a,1).mXdisp(di)  = 0;
    end

end



% 4.- PARAM. LIMITS:

a = 0 ;
U = KnotV(1,1:Usize(1));
V = KnotV(2,1:Usize(2));
W = KnotV(3,1:Usize(3));

for i = 1:1:Ncp(1) 
    
    [~,ULims,~] = a0115_aLKV (Degree(1), U, i);
    
    for j = 1:1:Ncp(2)
        
        [~,VLims,~] = a0115_aLKV (Degree(2), V, j);
        
        for k = 1:1:Ncp(3)
            
            [~,WLims,~] = a0115_aLKV (Degree(3), W, k);

            a = a + 1;

         	mA(a,1).mUcoLi(1,1)= ULims(1);
            mA(a,1).mUcoLi(1,2)= ULims(2);
         	mA(a,1).mUcoLi(2,1)= VLims(1);
            mA(a,1).mUcoLi(2,2)= VLims(2);
          	mA(a,1).mUcoLi(3,1)= WLims(1);
            mA(a,1).mUcoLi(3,2)= WLims(2);
            
        end 
    end
end


% 5.- 'ON' FLAG &  AFF'd B.E.'s:

for a = 1:1:nAN
    
    % computes anchor center of influence cube coordinates(Ucoor and Xcoor):

    aULims = mA(a,1).mUcoLi;
   
    % detects if the anchor influence cube is in or not and its influenced Eskin:
    
    if pnbe==0
        
        % trivial case of no B.E.
     	mA(a,1).ON = 1 ;
        mA(a,1).mNEsk = 0;
        mA(a,1).mEskR = 0;
        
    else
        
        [ON, NEsk, EskR] = a0116_aON_sks (pR, pnbe, pRbe, Eskin, TTR, aULims, pudim);
        % [IN, ~, NEsk, EskR] = GEN_51_FAnchorIN (a, aULims, pnbe, pRbe, Nbe, Eskin, nBS, Bskin, pR, pCou, pudim);

        mA(a,1).ON = ON ;
        mA(a,1).mNEsk = NEsk;
        mA(a,1).mEskR = EskR;  
    end

end


end