function [mA] = a0112_FirstAfeat ...
         (nAN, Ncp, Degree, KnotV, Usize, P ,w, Bskin, Eskin, nELp, mE, FtoIe, pnbe, pRbe, pxdim, pudim)

% initiates anchors object, No. anchors and No. elements (for dims 2 and 3):
% also returns anchors influenced by B.E.'s

% 1.- INITIATES ANCHORS CLASS & AUX. VECTORS:

mA(nAN) = GenAnchor ;

U = zeros(1,max(Usize)); % global knot vector in one direction
side = zeros(pudim,1);

eNcp = ones (3,1);
for di = 1:1:pudim
    eNcp(di) = Ncp(di);
end


% 2.- INDEX, PARAM. & ANCHOR-NET COORD'S. ALSO ANCHORS NET ITSELF ('Anet'):

a=1 ;
for i=1:1:eNcp(1)
    
    for j=1:1:eNcp(2)
    for k=1:1:eNcp(3)  
        
        for di=1:1:pudim
            
            if di==1
                x = i ;
            elseif di==2
                x = j ;
            elseif di==3
                x = k ;
            end
            
            U(:) = KnotV(di,:);
            index = (Degree(di)+3)/2 + x - 1 ;
            
            u = GEN_34_ParamFromIndex (index, U);
            
            mA(a).mIcoor(di) = index ;
            mA(a).mPcoor(di) = round( u , 5) ;
        end
        
        mA(a).mAcoor(1)  = i ;
        mA(a).mAcoor(2)  = j ;
        mA(a).mAcoor(3)  = k ;
 
        a = a+1;
    end    
    end
end


% 3.- REST OF THE FEATURES BUT NOT ON 'FLAG':

% No. knots to conisder each side of 'index' when computing LKV
extPos = [1 1 ; 1 2 ; 2 2 ; 2 3 ; 3 3 ; 3 4 ; 4 4 ; 4 5 ; 5 5 ; 5 6];


for a = 1:1:nAN
 
mA(a).mWeig = w(a);
mA(a).InitiatesParams(pxdim); % iterations parameters mPar

mA(a).mUsingu = zeros(pudim,1);

for di=1:1:pxdim
    mA(a).mXcoor(di) = P(a,di);
    mA(a).mXcoorF(di) = P(a,di);
    mA(a).mXcoor2(di) = P(a,di);
    mA(a).mXdisp(di) = 0;
end

for di=1:1:pudim
    
    UsizeAn = Degree(di)+2 ; % LKV size
    mA(a).mUsize(di) = UsizeAn ;
    
    % Round anchor index to lower bound, in the global KV:
    index = round(mA(a).mIcoor(di)-0.2,0);
    
    % No. knot to consider each side of 'index':
    extN = extPos(Degree(di),1);
    extP = extPos(Degree(di),2);
    
    
    % central (or before central) component of LKV:
    
    Cpos = round ((Degree(di)+3)/2-0.2 , 0 ) ;

    mA(a).mLKV(di,Cpos) = KnotV(di,index);
    mA(a).mLKVI(di,Cpos)= index ;
    
    
    % Negat. direct. positions:
    for i = 1:1:extN
        mA(a).mLKV(di,i) = KnotV(di,index-extN+i-1);
        mA(a).mLKVI(di,i)= index-extN+i-1 ;
    end
       
     
    % Posit. direct. positions
    for i = 1:1:extP
        mA(a).mLKV(di,Cpos+i) = KnotV(di,index+i);
        mA(a).mLKVI(di,Cpos+i)= index+i ;
    end
    
    
    mA(a).mPcoLi(di,1) = mA(a).mLKV(di,1);  
    mA(a).mPcoLi(di,2) = mA(a).mLKV(di,UsizeAn); 
    
    side(di) = (0.5 +Degree(di)*0.5);
    mA(a).mIcoLi(di,1) = mA(a).mIcoor(di) - side(di);   
    mA(a).mIcoLi(di,2) = mA(a).mIcoor(di) + side(di); 
 
    
    % mUsingu:
    p = Degree(di);
    U = zeros(p+2,1);
    
    for i=1:1:p+2
        U(i) = mA(a).mLKV(di,i);
    end

    for i=1:1:Usize(di)
        kv(i) = KnotV(di,i);
    end 
    
    [us,~] = a0207_Usingu ( kv, U, p );
    mA(a).mUsingu(di) = us;
    
    
    % T-junction: initially no T junction
    mA(a).mTj = zeros(pudim,1);
    
end
end


% 4.- 'ON' FLAG &  AFF'd B.E.'s:


for a = 1:1:nAN
    
    % computes anchor center of influence cube coordinates(Ucoor and Xcoor):

    aULims = mA(a).mPcoLi;
   
    % detects if the anchor influence cube is in or not and its influenced Eskin:

    [IN, ~, NEsk, EskR] = GEN_51_FAnchorIN ...
   	(aULims, pnbe, pRbe, Eskin, nELp, mE, FtoIe, pudim);


    % allocates ON value and trimming B.E.'s
    mA(a).ON = IN ;
    mA(a).mNEsk = NEsk;
    mA(a).mEskR = EskR;

end





end