function [IN] = i0102_pIN_2 (P, pnbe, pRbe, Eskin, dim, tp, dom)

% RETURNS:
% IN = 1 if P is inside the domain (parameter of physical)


% INPUTS:
% P(dim,1): point to evaluate
% tp: type 'closed' C=0 is IN, 'open' C=0 is out
% dom: domain '1' param, '2' phys

% uses param. or phys. space closest B.E if is trimming ! 

% 1.- Find closest BE in parameter space:
    
dmin = 999999 ;
    
for b = 1:1:pnbe  
    
	bR  = pRbe(b);
    
	if Eskin(bR).mTr == 1 % only trimming surfaces
        
        NE =  Eskin(bR).mNE;
        NV =  Eskin(bR).mNV;
        TV =  Eskin(bR).mTVcon;
        VT =  Eskin(bR).mVTcon;
        
        if dom==1
            
            Pv =  Eskin(bR).mAv;
            PNv =  Eskin(bR).mANv;
            PNe =  Eskin(bR).mANe;
            
        elseif dom==2
            
            Pv =  Eskin(bR).mXv;
            PNv =  Eskin(bR).mXNv;
            PNe =  Eskin(bR).mXNe;
            
        end
        
        [tve, sdmin, Api, cnvi] = i0104_closestP (bR, P, NV, TV, VT, PNv, PNe, Pv, dim);
        
        if sdmin < dmin
            
            cb = bR ;
            tvec = tve ;
        	Ap = Api;
        	cnv = cnvi ;
            dmin = sdmin ;
            
        end
	end
end
    



% 2.- Determines if is IN by measuring angle vector 'ap' to normal 'cnv'


ap = Ap-P;

if norm(ap) < 0.00001
    
    C = 0;
    
else
    
    ap = ap / norm(ap);
    C = round(dot(ap,cnv),6);
    
end

   
%{
if round(Acoor(1),4)==0.4721 && round(Acoor(2),4)==0.3621
    
    cb
    tvec
    sdmin
    Acoor
    Ap
    ap
    cnv
    C
    
    figure(8)
    
    plot3( [Acoor(1) Ap(1)], [Acoor(2) Ap(2)], [Acoor(3) Ap(3)], 'r'); hold on
    plot3( [Ap(1) Ap(1)+cnv(1)/10], [Ap(2) Ap(2)+cnv(2)/10], [Ap(3) Ap(3)+cnv(3)/10], 'k'); hold on
    
    axis equal
    
end
%}

if C > 0
    
    IN = 1 ;
    
elseif C==0
    
    if strcmp(tp,'closed')==1
        
        IN = 1 ;
        
    elseif strcmp(tp,'open')==1
        
        IN = 0 ;
        
    end
    
else
    IN = 0 ;
end

end

