function [IN, At, tr] = i0102_pIN (A, cb, Eskin, udim)

% RETURNS:
% IN = 1 in case location A is within the computable domain
% At: A projected onto the triangle plane
% tr: triangle reference

% INPUTS:
% A(udim,1): param. coord's of the point
% uses the closest vtx 'cv' of the closest BE 'cb' and compares vectors senses

TV = Eskin(cb).mTVcon;
NE = Eskin(cb).mNE;
Av = Eskin(cb).mAv;

% distances to all triangles centers and sort by distance:

td = zeros(NE,2); % tr. ref and distance

for e = 1:1:NE

    Tctr = zeros(udim,1);
    c = zeros(udim,1);
    
    for i = 1:1:3
        c(:,1) = Av(TV(e,i),:); 
        Tctr = Tctr + c ; 
    end
    
    Tctr = Tctr/3; 
    td(e,1) = e ;
    td(e,2) = norm(Tctr-A);
end

td = sortrows(td,2);


% measures distance to Nps triangles which closer center:

Nps = 3 ; % No. pre-selected triangles
dmin = td(end,2);

for e = 1:1:Nps
    
    tR = td(e,1);
    n1 = TV(tR,1);
    
    nv = i0103_nTriang (TV, tR, Av, udim); % normal to plane
    a = [Av(n1,1),Av(n1,2),Av(n1,3)]'; % plane point
    
    %{
  	if round(A(1),4)==0.9563 && round(A(2),4)==0.4820
  
        tR
        
        for i = 1:1:3
            r = TV(tR,i);
            
            [ Av(r,1) Av(r,2) Av(r,3)]
            
        end
        
        nv
        
    end
    %}
    
    B = go2518_POntoP(A, nv, a); % proj. of A onto triangle
    
    AB = B-A;
    d = norm(AB);
    
    if d < dmin
        
        % stores:
        Cs = dot(AB,nv);
        if Cs <= 0
            IN = 0 ;
        else
            IN = 1 ;
        end
        At = B ;
        tr = tR;
        
        dmin = d ;
    end
    
end

end