function [nPO, mP] = w0503_RnPOmP (ap,bp, allP, nAN, mA, FnAN, FmA, Degree,FDegree, repI, reDir, udim, xdim)

% RETURNS:
% nPO, mP: No. points and its object for a certain wire

% INPUTS:
% ap, bp: coord's of wire end points
% allP: if = 1 indicates there are IEdges at that wire, then it computes
% icp's independently for each point of the wire. Otherwise is = 0

% 1.- No. point of the wire, step and mP declaration:

nPO = round(norm(bp-ap)/repI(reDir)) + 1;
if nPO==1
    nPO=2;
end
   
% computes step given nPO: 
step = zeros(udim,1);
for di=1:1:udim
    step(di) = round((bp(di)-ap(di)) / (nPO-1),9);
end
    
    
% declares points object:
mP(nPO) = GenPoint;
    
    

% 2.- Icp's: computes for end points (mNab) & one at middle. Then for the
% rest of points assumes is the boolean summation:

[aNicp, aRicpA] = p1204_icpsPo (nAN, mA, ap, udim, 'closed');
[aN, aNicp, aRicpA] = t2603_N_upIPCs (aNicp, aRicpA, Degree, mA, ap, udim);
    
[bNicp, bRicpA] = p1204_icpsPo (nAN, mA, bp, udim, 'closed');
[bN, bNicp, bRicpA] = t2603_N_upIPCs (bNicp, bRicpA, Degree, mA, bp, udim);

[cNicp, cRicpA] = p1204_icpsPo (nAN, mA, (ap+bp)/2, udim, 'closed');
[~, cNicp, cRicpA] = t2603_N_upIPCs (cNicp, cRicpA, Degree, mA, (ap+bp)/2, udim);

% in case of no new anchors with respect First configuration just copy:
if  size(mA,2) == size(FmA,2)
        
        FaNicp  = aNicp;
        FaRicpA = aRicpA ;
        FaN = aN;
        
        FbNicp  = bNicp;
        FbRicpA = bRicpA ;
        FbN = bN;
        
     	FcNicp  = cNicp;
        FcRicpA = cRicpA ;
        
else
        [FaNicp, FaRicpA] = p1204_icpsPo (FnAN, FmA, ap, udim, 'closed');
        [FaN, FaNicp, FaRicpA] = t2603_N_upIPCs (FaNicp, FaRicpA, Degree, FmA, ap, udim);
        
        [FbNicp, FbRicpA] = p1204_icpsPo (FnAN, FmA, bp, udim, 'closed');
        [FbN, FbNicp, FbRicpA] = t2603_N_upIPCs (FbNicp, FbRicpA, Degree, FmA, bp, udim);
        
    	[FcNicp, FcRicpA] = p1204_icpsPo (FnAN, FmA, (ap+bp)/2, udim, 'closed');
        [~, FcNicp, FcRicpA] = t2603_N_upIPCs (FcNicp, FcRicpA, Degree, FmA, (ap+bp)/2, udim);
end
    
    
[RicpA , ~]  = GEN_16_RemoveRepeatedRows ( [aRicpA  ; bRicpA  ; cRicpA  ], 1, 0.1);
[FRicpA , ~] = GEN_16_RemoveRepeatedRows ( [FaRicpA ; FbRicpA ; FcRicpA ], 1, 0.1);
    
Nicp = size(RicpA,1);
FNicp = size(FRicpA,1);
    

    
% 3.- Coord's (mXcoor, mUcoor, mXcoorF) and mXdisp (set to 0) of each point:
% also allocates icps:
    
u = zeros(udim,1);

for di=1:1:udim
u(di) = round(ap(di),9);
end
    
for po = 1:1:nPO
        
	% computes physical coord's of actual 'A' and first 'F' instances:

    if po==1
           
        tNicp  = aNicp; % icp's to transfer
        tRicpA = aRicpA;
        
        [AX,~] = t2602_TNURBS_Xcoord_withN (mA,  aN,  aNicp, aRicpA, xdim);
        [FX,~] = t2602_TNURBS_Xcoord_withN (FmA, FaN, FaNicp, FaRicpA, xdim);
        
    elseif po==nPO
            
        tNicp  = bNicp; % icp's to transfer
        tRicpA = bRicpA;
        
    	[AX,~] = t2602_TNURBS_Xcoord_withN (mA, bN, bNicp, bRicpA, xdim);
        [FX,~] = t2602_TNURBS_Xcoord_withN (FmA, FbN, FbNicp, FbRicpA, xdim);
           
    else
            
        if allP == 0 % no IEdges in that element wire => can consider icp's computed previously
        
         	tNicp  = Nicp; % icp's to transfer
            tRicpA = RicpA;
            
            [N] = t2605_N_givenIcp (Nicp, RicpA, Degree, mA, u, udim);
            [AX , ~ ] = t2602_TNURBS_Xcoord_withN (mA, N, Nicp, RicpA, xdim);

            [N] = t2605_N_givenIcp (FNicp, FRicpA, FDegree, FmA, u, udim);
            [FX , ~ ] = t2602_TNURBS_Xcoord_withN (FmA, N, FNicp, FRicpA, xdim);

        elseif allP == 1 % => there are IEdges, then must consider icp's for each point
            
            [FNicp, FRicpA] = p1204_icpsPo (FnAN, FmA, u, udim, 'closed');
            [~, FNicp, FRicpA] = t2603_N_upIPCs (FNicp, FRicpA, Degree, FmA, u, udim);
            
            [N] = t2605_N_givenIcp (FNicp, FRicpA, FDegree, FmA, u, udim);
            [FX , ~ ] = t2602_TNURBS_Xcoord_withN (FmA, N, FNicp, FRicpA, xdim);
            
            [tNicp, tRicpA] = p1204_icpsPo (nAN, mA, u, udim, 'closed');
            [N, tNicp, tRicpA] = t2603_N_upIPCs (tNicp, tRicpA, Degree, mA, u, udim);
            
            [N] = t2605_N_givenIcp (tNicp, tRicpA, Degree, mA, u, udim);
            [AX , ~ ] = t2602_TNURBS_Xcoord_withN (mA, N, tNicp, tRicpA, xdim);
            
        end
        
    end
        
  
 	% param. and phys. coord's:
  	for di=1:1:udim
        mP(po).mUcoor(di) = u(di);
    end
        
  	for di=1:1:xdim
        mP(po).mXcoor(di)  = AX(di);
        mP(po).mXcoorF(di) = FX(di);
        mP(po).mXdisp(di)  = 0;
    end
          
        
 	% icp's:
 	mP(po).mNicp  = tNicp;
  	mP(po).mRicpA = tRicpA;
        
    
  	% updates param. coor'ds
   	for di=1:1:udim
        
     	u(di) = round( u(di) + step(di) , 9)  ;
        
        if po==nPO-1
    	u(di) = round ( bp(di) , 9 ) ;  
        end
        
    end


    
end




end

