function [connT, THC, NE, MLT] = um0623_LnmVSmlt ...
    (contaL, pR, Spatches, rTskin, agCurv, Lnm, connT, THC, NE, MLT, Xtol, DUtol, tolL, tolA, nd)


% 1.- DETECTS ALL INTERSECTIONS AND STORES:

% intR(Nint,3);      LR of tets, triangle of MLT, NCS (only surface) of MLT
% intA(Nint,pudim);  A-coords of intersection

[Nint, intR, intA] = um0624_TiM (Lnm, connT, THC, MLT);



%{

if pR == 2

    fr = 9 ;
    
    figure(fr);
    
    scatter3 (intA(:,1), intA(:,2), intA(:,3), 'r'); hold on
    

    pm0650_plotMLT (MLT, fr, 'k', 1.1, 0, 0, 0, 0, 0, 0, 0);


    if gg==0
    end
    
end

%}

%{
if pR == 2
    
    fr = 72 ;
    nR = 50 ;
    
    for e = 1:1:size(connT.VE,2)
        
        eR = connT.VE(nR,e);
        
        if eR > 0
            pt1373_pTetConn (eR, connT, THC.Av, fr, 'k', 1, 1.2, 0, 0);
        end
        
    end
    
    if jj==0
    end
    
end

%}

% 2.- INSERTS NODE IN BOTH MLT AND TET:

pudim = 3 ;
sudim = 2 ;

for s = 1:1:Nint
    

    fr = s ;
    pm0650_plotMLT (MLT, fr, 'k', 1.22, 0, 0, 0, 0, 0, 0, 0);
        
    
    % 2.1.- Prelim. calculation of features:
    
    NV = size(THC.Av,1);
    [connT] = th1333_OtherConnLin (NE, NV, connT.EV);
    [connS,~,~] = th1381_connS (NE, connT);
    
  	LR = intR(s,1); % line of tet
    tR = intR(s,2); % triangle of MLT
    sR = intR(s,3); % T-surface
    
    csM = [ 0  sR ;
            0  sR ] ;
    
    A0 = zeros(pudim, 1); % initial trial point
    B0 = 0; % ASSUMES LIES WITHIN SURFACE AND NOT AT EDGES !! (NEEDS REVISION)
   
    A0(:,1) = intA(s,:);
    
    U0 = zeros(1,sudim);
    for i = 1:1:3
        nR = MLT.tTVcon(tR,i);
        U0(1,:) = U0(1,:) + MLT.tUv(nR,:)/3;
    end
    U0 = U0';  
    
    
    % 2.2.- Computes coordinates and NCS of intersection point:
    
    [eTHC] = ei1643_eTHCm (contaL, Spatches, pR, rTskin, agCurv, csM, B0, U0, A0, Xtol, DUtol);
              
    
    % 2.3.- Updates tets:
    % (nodes, connT.EV and NE; the rest of connT. are updated at the end of this routine)
    
    [THC, NE, connT]  = ts1613_inNodTET (contaL, eTHC, NE, connT, connS, THC, tolL, tolA, nd);

    
    % 2.4.- Inserts new node into the MLT triangles:
    
    eAt = eTHC.At ;

    [MLT] = um0660_inNodMLT (MLT, eTHC, eAt, tolL, tolA, nd);

    NV = size(THC.Av,1);
    tNV = MLT.tNV ;
    
    for di = 1:1:pudim
        THC.ANv(NV,di) = MLT.tANv(tNV,di);
    end
  
end




% 3.- UPDATES connT:

NV = size(THC.Av,1);
[connT] = th1333_OtherConnLin (NE, NV, connT.EV);




end

