function [Nint, intR, intA] = um0624_TiM (Lnm, connT, THC, MLT)

% RETURNS:
% intersections between lines of tets and triangles of MLT

tolL = 1 ;
tolA = 1 ;
nd = 3 ;
pudim = 3 ;

% intersections storage
Nint = 0 ;              % No. intersection
intR = zeros(1,3);      % LR of tets, triangle of MLT, NCS (only surface) of MLT
intA = zeros(1,pudim);  % A-coords of intersection


NLI = size(connT.LV,1);

tmL1 = zeros(pudim,1);
tmL2 = zeros(pudim,1);

tm1 = zeros(pudim,1); % temporaries
tm2 = zeros(pudim,1);
tm3 = zeros(pudim,1);

pv1 = zeros(pudim,1); % plane vectors and point
pv2 = zeros(pudim,1);
pp = zeros(pudim,1);

lv = zeros(pudim,1);  % line vector and point
lp = zeros(pudim,1);

Llims = zeros(pudim,2); % limits of enveloping cube of line and triangle
Tlims = zeros(pudim,2);

Lnod = zeros(2,pudim);
Tnod = zeros(3,pudim);

for LR = 1:1:NLI

    if Lnm(LR) > 0

        % checks intersection with all involved triangles of MLT: 
        % if lies within a triangle, then insert new node

        % point and vector of line, and its limits:

        nR = zeros(2,1);

        for i = 1:1:2
            nR(i) = connT.LV(LR,i); % nodes refs of the line 
            Lnod(i,:) = THC.Av(nR(i),:);
        end

        tmL1(:,1) = THC.Av(nR(1),:);
        tmL2(:,1) = THC.Av(nR(2),:);

        lp(:,1) = THC.Av(nR(1),:);
        lv(:,1) = THC.Av(nR(2),:) - THC.Av(nR(1),:);

        for di = 1:1:pudim
            Llims(di,1) = min(tmL1(di),tmL2(di));
            Llims(di,2) = max(tmL1(di),tmL2(di));
        end

        % loops in MLT triangles:

        for t = 1:1:MLT.tNE

            nT = zeros(3,1);

            for i = 1:1:3 
                nT(i) = MLT.tTVcon(t,i);
                Tnod(i,:) = MLT.tAv(nT(i),:);
            end

            tm1(:,1) = MLT.tAv(nT(1),:);
            tm2(:,1) = MLT.tAv(nT(2),:);
            tm3(:,1) = MLT.tAv(nT(3),:);

            for di = 1:1:pudim
                Tlims(di,1) = min(tm1(di),min(tm2(di),tm3(di)));
                Tlims(di,2) = max(tm1(di),max(tm2(di),tm3(di)));
            end


            % Line and side cubes must intersect:

            intF = 1 ; % intersection flag turns to 0 if

            for di = 1:1:pudim

                if (Llims(di,2) < Tlims(di,1)) || (Tlims(di,2) < Llims(di,1))
                    intF = 0 ;
                    break
                end
            end


            % Line must not have node on one node of the triangle:

            if intF == 1

                for i = 1:1:2
                    for j = 1:1:3

                        CO = go2542_coincidentP (Lnod(i,:), Tnod(j,:), pudim, 3);

                        if CO==1
                            intF = 0;
                            break
                        end

                    end

                    if CO==1
                    break
                    end

                end

            end



            % only carries on if intersection may happen and line is not same as triangle edge:

            if intF == 1

                pv1 = tm2 - tm1;
                pv2 = tm3 - tm1;
                pp = tm1 ;

                % intersection point:
                [IP,~] = go2545_PlaneLineIntersec (pv1, pv2, pp, lv, lp);

                % inside the triangle?
                IN = go2546_PinTriang (Tnod, IP, tolL, tolA, nd);

                % inside the line limits?
                ON = go2520_PonSegment (IP, tmL1, tmL2, pudim, tolL);

                if IN > 0 && ON > 0

                    Nint = Nint + 1 ;
                    
                    intR(Nint,1) = LR ;
                    intR(Nint,2) = t ;
                    
                    % NCS=> takes surface ref:
                    
                    sr1 = MLT.tNCS(MLT.tTVcon(t,1),2) ;
                    sr2 = MLT.tNCS(MLT.tTVcon(t,2),2) ;
                    sr3 = MLT.tNCS(MLT.tTVcon(t,3),2) ;
                    
                    if sr1 == sr2 || sr1 == sr3
                        intR(Nint,3) = sr1 ;
                    else
                        intR(Nint,3) = sr2 ;
                    end


                    % interscetion coordinates in patch parameter space:
                    
                    intA(Nint,:) = IP(:,1);

                    break
                end

            end

        end

    end
end




end

