function [connT, NE, THC] = um0626_upTets (LR, connT, NE, THC, eTHC)

% RETURNS: updated connT, NE, THC


% 1.- UPDATES NODES COORDS AND NCS:
 
THC.Xv = [ THC.Xv ; eTHC.Xv' ] ;
THC.Av = [ THC.Av ; eTHC.Av' ] ;
THC.Uv = [ THC.Uv ; eTHC.Uv' ] ;
THC.Bv = [ THC.Bv ; eTHC.Bv ] ;
    
THC.NCS = [ THC.NCS ; eTHC.NCS ] ;
THC.ANv = [ THC.ANv ; eTHC.ANv ] ; % to be updated when recomputing MLT
    
nr = size(THC.Av,1); % new node ref.
    
lnR = [ connT.LV(LR,1) ; connT.LV(LR,2) ] ; % linked nodes to LR
    
   

% 2.- CONN MATRIX EV and No. ELEMENTS:

for t = 1:1:size(connT.LE,2)
        
	eR = connT.LE(LR,t);
        
	if eR > 0
            
        % 2.1.- Detects 'free nodes' (not attached to LR):

        fnR = zeros(2,1);
        conta = 0 ;

        for k = 1:1:4

            nR = connT.EV(eR,k);
            if nR~=lnR(1) && nR~=lnR(2)

                conta = conta + 1 ;
                fnR(conta,1) = nR ;

            end
        end

        %{
        if LR == 2510

            fr = LR ;   
            
            pt1373_pTetConn (eR, connT, THC.Av, fr, 'k', 1, 1.25, 0);

            scatter3(THC.Av(nr,1), THC.Av(nr,2),THC.Av(nr,3),'r'); hold on
            
        end
        %}
        
        % 2.2.- Split element: updates NE and connT.EV:

        NE = NE + 1 ;
        connT.EV(eR,1) = nr; connT.EV(eR,2) = lnR(1); connT.EV(eR,3) = fnR(1); connT.EV(eR,4) = fnR(2); 
        connT.EV(NE,1) = nr; connT.EV(NE,2) = lnR(2); connT.EV(NE,3) = fnR(1); connT.EV(NE,4) = fnR(2); 

        %{
        if LR == 2510

            fr = LR+1 ;        
            pt1373_pTetConn (eR, connT, THC.Av, fr, 'k', 1, 1.25, 0);
            pt1373_pTetConn (NE, connT, THC.Av, fr, 'k', 1, 1.25, 0);
            
        end
        %}
    
	end
        
end



end

