function [utTLcon] = um0633_upTLcon (tTLcon, utTVcon, utLVcon, etR, utNL, Nnli, Nti, itr, DNE)

% RETURNS:
% utTLcon updated considering new node insertion

% INPUTS:
% utNL: updated No. lines considering the insertion
% utTVcon, utLVcon updated
% Nli: No. new lines involved
% itr(Nti): No. triangles involved and refs
% 

utTLcon = [ tTLcon ; zeros(DNE,3) ] ;

% involved lines refs 'extended', considering added and previous:

ilre = zeros(2,1);


ilr = [ utTLcon(etR,1), utTLcon(etR,2), utTLcon(etR,3)] ; 

r = utNL-Nnli;

for i = 1:1:Nnli
    r = r + 1 ;
    ilr = [ilr , r ] ;
end



for k = 1:1:Nti
    
	tR = itr(k);
    
    TVe = [ utTVcon(tR,1), utTVcon(tR,2), utTVcon(tR,3), utTVcon(tR,1) ] ;
    
    tmL = zeros(3,1);
    conta = 0 ;
    
    for i = 1:1:3
        
        n1 = TVe(i); 
        n2 = TVe(i+1);
        
        for j = 1:1:5
            
            lR = ilr(j) ;
            
            if ( utLVcon(lR,1) == n1 && utLVcon(lR,2) == n2 ) || ...
               ( utLVcon(lR,1) == n2 && utLVcon(lR,2) == n1 )   
           
                conta = conta + 1 ;
                tmL(conta,1) = lR ;
            end
        end

        utTLcon(tR,i) = 0; % resets
        
    end
    
    
    % allocates:
    
    for i = 1:1:3
        utTLcon(tR,i) = tmL(i);
    end
  
end
end

