function [TVcon, VTcon, LVcon, LTcon, VLcon, TLcon] = fs0706_IMPRVtri ...
     (sR, pR, tFace, Spatches, TVcon, VTcon, LVcon, LTcon, VLcon, TLcon, Avm, Uvm, NL, eNc)


% RETURNS: improved triangulation in patch parameter space
% loops on triangles until no change happens

sudim = 2 ;
pudim = 3 ;
xdim = 3 ;

sDegree = tFace(pR).mSur(sR).Degree ;
sNcp    = tFace(pR).mSur(sR).Ncp ;
sKnotV  = tFace(pR).mSur(sR).KnotV ;
sUsize  = tFace(pR).mSur(sR).Usize ;
sP     = tFace(pR).mSur(sR).P ;
sw     = tFace(pR).mSur(sR).w ;
sCD    = tFace(pR).mSur(sR).CS ;
[sEw,sEP] = GEN_12_ExpandBw (sw, sP, xdim, sudim, sNcp); 

Degree  = Spatches(pR).INS(1).mDegree ; 
Ncp     = Spatches(pR).INS(1).mNcp ; 
KnotV   = Spatches(pR).INS(1).mKnotV ; 
Usize   = Spatches(pR).INS(1).mUsize ; 
P       = Spatches(pR).INS(1).mP ; 
w       = Spatches(pR).INS(1).mw ; 
EP      = Spatches(pR).INS(1).mEP ; 
Ew      = Spatches(pR).INS(1).mEw ; 
CD      = zeros(pudim,1);
ULims   = [0 1 ; 0 1 ; 0 1 ];
Xtol    = 0.01 ;
DUtol   = 0.01 ;



% 1.- INTRODUCED MID-NODES JUST FOR THIS PROCESS:
% Creates the 'extended' matrices in case Nne = 3

Nne = 3 ;

NLI = size(LTcon,1) ;
NE  = size(TVcon,1) ;
NV  = size(Avm,1) ;

% 1.1- Preliminary size:

if Nne == 2  
    eTV = TVcon ;
    eLV = LVcon ;
end

eAv = Avm ;

eVT = VTcon ;
eLT = LTcon ;
eVL = VLcon ;
eTL = TLcon ;


% 1.2.- Allocates values in case Nne = 3 ;

if Nne == 3

    eTV = [ TVcon, zeros(NE,3) ] ;
    eLV = [ LVcon(:,1) , zeros(NLI,1) , LVcon(:,2) ] ;

    vR = NV ;

    
    % eLV matrix and eAv:
    
    for i = 1:1:NLI

        vR = vR + 1 ; % new node ref

        
        % mid-point Acoor:
        
        v1 = eLV(i,1); % end-nodes refs
        v2 = eLV(i,3); 

        um = (Uvm(v1,:) + Uvm(v2,:))/2 ; % mid-point Ucoor
        
        xm = b2601_BNURBS_Xcoord (um, sKnotV, sNcp, sDegree, sUsize, sEw, sEP, sudim, xdim);
        a0 = (Avm(v1,:) + Avm(v2,:))/2 ; % mid-point Acoor
        
        [am, ~] = v2865b_onePoint (xm, a0, Degree, Ncp, KnotV, Usize, P ,w, EP ,Ew, CD, ULims, xdim, Xtol, DUtol);
        
        eLV(i,2) = vR ;
        eAv(vR,:) = am(1,:);
    end

    
    % eTV matrix:
    
    for e = 1:1:NE 
        for i = 1:1:3 
            lR = eTL(e,i);
            vR = eLV(lR,2);
            eTV(e,3+i) = vR;
        end
    end
    
end




% 2.- CARRIES OUT THE IMPROVEMENT:

endF = 0;
conta = 0 ;

while endF==0

    conta = conta + 1 ;

    [eTV, eVT, eLV, eLT, eVL, eTL, endF] = fs0707_IMPRVtri1 ...
         (sR, eTV, eVT, eLV, eLT, eVL, eTL, eAv, NL, eNc, Nne);

end
 

% 3.- TRANSFERS RESPONSES, BUT WITHOUT THE MID-NODES:





end

