function [eTV, eVT, eLV, eLT, eVL, eTL, endF] = fs0707_IMPRVtri1 ...
     (sR, eTV, eVT, eLV, eLT, eVL, eTL, eAv, NL, eNc, Nne)

% RETURNS: improved triangulation in patch parameter space

% Swap edge-line between 2 triangles if:
% - the alternative line is shorter
% and
% - the resultant triangles improve the regularity (condition number)


% 1.- PRELIMINARIES:

pudim = 3 ;

% 1.1.- Ends flag turns to 0 if changes happen

endF = 1 ; 


% 1.2.- Intervals of nodes of edge-lines:
% Recall eNc(NL,1) counts for 1st and last node, ie. it is repeated

ieL = zeros(NL,2);

acc = 0 ;

for cL = 1:1:NL  
    ieL(cL,1) = acc + 1 ;
    ieL(cL,2) = acc + eNc(cL)-1 ;
    acc = acc + eNc(cL)-1;
end


% 1.3.- No. lines and verteces:

NLI = size(eLT,1);
NV = size(eVL,1); %  oj o aki !!!1


% 2.- LOOP ON LINES TO ANALYZE PAIRS OF TRIANGLES:

for LR = 1:1:NLI
      
tR = [eLT(LR,1) eLT(LR,2)]; % triangles refs.
    
if tR(2) > 0 % not for edge-lines
    
	% 2.1.- CONDITION A : about diagonal lenghts
        
    [caF] = ti0725_condA (sR, LR, eTV, eLV, eAv, Nne);
       

    % (carries on to second condition if condition A is met only)
    
	if caF==1

        % identifies alternative arrangement for triangles 1 and 2:
        
        nar1 = 0 ;
        nar2 = 0 ; 
        
        % 2.2.- CONDITION B: about regularity of the triangles
        
        pc = 5 ;
        
        [cbF] = ti0726_condB (tR, nar1, nar2, eTV, eAv, pc);
        
        
        %{
        % 2.2.- CONDITION 2 : 
        % ro-number is area of inscribed circle or equlateral / circle current.
        % - average of both ro-number is closer to 1
        % and
        % - in case one triangle is worse, it is by less than 'pc' percentage 
           
        pc = 15 ;

           
        % condition number for both current triangles:
           
        nc = zeros(2,1);
           
        Anod1 = zeros(3,pudim);
        Anod2 = zeros(3,pudim);
           
        for i = 1:1:3
            Anod1(i,:) = Avm(TVcon(tR(1),i),:);
            Anod2(i,:) = Avm(TVcon(tR(2),i),:);
        end
           
        nc(1) = tm1304_Ronumber (Anod1, pudim);
        nc(2) = tm1304_Ronumber (Anod2, pudim);

        ncv = sum(nc)/2; % average
        ncM = min(nc); % minimum
           
           
        % condition number for alternative
           
        na = zeros(2,1);
           
        tR1 =  [nRa(1) nRa(2) nRc(1) ];
        tR2 =  [nRa(2) nRa(1) nRc(2) ];
           
        for i = 1:1:3
               Anod1(i,:) = Avm(tR1(i),:);
               Anod2(i,:) = Avm(tR2(i),:);
        end
           
        na(1) = tm1304_Ronumber (Anod1, pudim); 
        na(2) = tm1304_Ronumber (Anod2, pudim);
           
        nav = sum(na)/2 ; % average
        naM = min(na); % minimum
            
        %}

        % in case meets condition B, carries on the change:
            
        if cbF == 1
                
                
              	% stores all involved edges within one matrix
                ilR = zeros(6,1);
                
                conta = 0;
                for i = 1:1:2 
                for j = 1:1:3 
                    conta = conta + 1 ;
                    ilR(conta,1) = eTL(tR(i),j);  
                end
                end
                   
                [ilR,~] = GEN_16_RemoveRepeatedRows (ilR, 1, 0.1);
                
                % same with triangles:
                
                itR = zeros(2,1);
                
                conta = 0 ;
                for i = 1:1:5
                    
                    conta = conta+1;
                    itR(conta,1) = eLT(ilR(i),1);
                    
                    if eLT(ilR(i),2) > 0
                        conta = conta+1;
                        itR(conta,1) = eLT(ilR(i),2);
                    end
                end
                
                [itR,~] = GEN_16_RemoveRepeatedRows (itR, 1, 0.1);
                
                
                % ending flag turns to 0 
                endF = 0 ;
                
                % updates triangulation:
                % TVcon, VTcon, LVcon, LTcon, VLcon, TLcon

                % TV: _____________________________________________________________________________________
                
                % searches nRa and next nRc, then adds
                % afterwards the other nRa:
                for i = 1:1:2 
                
                    % extend TVcon:
                    tTVcon = [eTV(tR(i),1), eTV(tR(i),2), eTV(tR(i),3), eTV(tR(i),1)];

                    for k = 1:1:3
                        
                        if tTVcon(k) == nRa(1)
                            
                            n1 = nRa(1); % first node
                            
                            % other two nodes:
                            if tTVcon(k+1)== nRc(1)
                                
                                n2 = nRc(1);
                                n3 = nRa(2);
                                
                            elseif tTVcon(k+1)== nRc(2)
                                
                                n2 = nRc(2);
                                n3 = nRa(2);

                            end
                            
                            break
                            
                        elseif  eTV(tR(i),k) == nRa(2)
                            
                            n1 = nRa(2); % first node
                            
                            % other two nodes:
                            if tTVcon(k+1)== nRc(1)
                                
                                n2 = nRc(1);
                                n3 = nRa(1);
                                
                            elseif tTVcon(k+1)== nRc(2)
                                
                                n2 = nRc(2);
                                n3 = nRa(1);

                            end                         
                            
                            break
                            
                        end
                        
                    end

   
                    eTV(tR(i),1) = n1;
                    eTV(tR(i),2) = n2;
                    eTV(tR(i),3) = n3;
                end
                

                
                % VT: _____________________________________________________________________________________
                
                % nRa's gain one triangle
                
                for i = 1:1:2
                    
                    % current triangles of nRa
                    
                    ta = zeros(1,1);
                    conta = 0 ;
                    
                    for j = 1:1:size(eVT,2)
                        
                        cnF = 1 ; % new col. flag
                        
                        if eVT(nRa(i),j)>0
                            
                            conta = conta+1;
                            ta(conta,1) = eVT(nRa(i),j);
                            
                        elseif eVT(nRa(i),j)==0
                            
                            cnF = 0 ;
                            break
                            
                        end

                    end
                    
 
                    
                    % detects which is the triangle to add:
                    
                    for j = 1:1:conta
                        
                        if ta(j)==tR(1)
                            
                            tRa = tR(2);
                            break
                            
                        elseif ta(j)==tR(2)
                            
                            tRa = tR(1);
                            break 
                            
                        end
                    end
                    
                    

                    
                    
                    % adds the triangle ref:
                    
                    if cnF==0
                        
                        eVT(nRa(i),conta+1) = tRa;
                        
                    elseif cnF==1
                        
                        % extends one column and adds:
                        
                        eVT = [eVT zeros(size(eVT,1),1) ];
                        eVT(nRa(i),size(eVT,2)) = tRa;
                    end

                end
                
    
                % nRc's lose one tiiangle
                
                for i = 1:1:2
                    
                    % finds which is triangle to remove
                    
                    tRr = 0 ;
                    
                    for j = 1:1:2
                        
                        for k = 1:1:3
                            
                            if eTV(tR(j),k) == nRc(i)
                                
                                if j==1
                                    tRr = tR(2);
                                elseif j==2
                                    tRr = tR(1);
                                end
                                
                                break
                            end
                            
                        end
                        
                        if tRr > 0
                            break
                        end
                    end
                    
                    
                    % remove tRr from VTcon:
                    
                    t = zeros(size(eVT,2),1);
                    conta = 0 ;
                    
                    for j = 1:1:size(eVT,2)
 
                        if eVT(nRc(i),j)~=tRr
                            conta = conta + 1 ;
                            t(conta,1) = eVT(nRc(i),j);
                        end
                    end
                    
                    for j = 1:1:size(eVT,2)
                        eVT(nRc(i),j) = t(j,1);
                    end

                    %{
                    if L == 21 %%%%%%%%%%%%%%%%
                        
                        nRc(i)
                        triangREmo = tRr
                        
                        t
                        

                    end
                    
                    %}
                    
                    
                end
                
                
                % LV: _____________________________________________________________________________________
                eLV(LR,1) = nRa(1);
                eLV(LR,2) = nRa(2);
               
                
                % LT: _____________________________________________________________________________________
                
                % checks involve lines: ilR and itR are created previously
                
                for i = 1:1:5
                    
                    % nodes refs:
                    n1 = eLV(ilR(i),1);
                    n2 = eLV(ilR(i),2);
                    
                    %{
                    if L==21 %%%%%%%%%%%%%%%%%%%%%%%%%%%%

                        if ilR(i)==18
                            [n1 n2]
                        end
                        
                    end
                    %}
                    
                    % searches triangles with those nodes:
                    
                    conta = 0 ;
                    
                    for j = 1:1:size(itR,1)
                        
                        eTV = [ eTV(itR(j),1) eTV(itR(j),2) eTV(itR(j),3) eTV(itR(j),1)];

                        for k = 1:1:3
                            
                            if (eTV(k)==n1 && eTV(k+1)==n2) || (eTV(k)==n2 && eTV(k+1)==n1)
                            
                                conta = conta+1;
                                eLT(ilR(i),conta) = itR(j);
                                
                                break
                                
                            end
                        end
                        
                        %{
                        if L==21 %%%%%%%%%%%%%%%%%%%%%%%%%%%%
                            if ilR(i)==18
                                itR(j)
                                eTV
                                conta
                            end
                        end
                        %}
                        
                        if conta==2
                            break 
                        end
                        
                    end
                    
                end
                
       
                % VL: _____________________________________________________________________________________
                % current verteces loose L line
                c = size(eVL,2);
                for i = 1:1:2
                    
                    t = zeros(1,1); % temporary
                    
                    conta = 0 ;
                    for j = 1:1:c
                        
                        if (eVL(nRc(i),j)>0 && eVL(nRc(i),j)~= LR)
                            
                            conta = conta + 1 ;
                            t(conta,1) = eVL(nRc(i),j);
                            
                        end
                        eVL(nRc(i),j)=0; % resets
                    end
                    
                    % re-allocates
                    for j = 1:1:conta  
                        eVL(nRc(i),j) = t(j);
                    end
                end
                % alternative verteces gain L line:
                for i = 1:1:2
                    
                    ncF = 1 ; % new column flag
                    
                    for j = 1:1:c
                        
                        if eVL(nRa(i),j)==0 
                            
                            eVL(nRa(i),j) = LR;
                            ncF = 0 ;
                            
                            break
                        end
                    end
                    
                    if ncF==1 
                        eVL = [eVL zeros(NV,1)];
                        c = c+1;
                        eVL(nRa(i),c) = LR ;
                    end
                    
                end
                
                
                % TL: _____________________________________________________________________________________
                

                % allocates
                
                t = [ 1 2 ; 2 3 ; 3 1 ]; % temp. refs for nodes
                
                for i = 1:1:2
                    
                    conta = 0 ;
                    for j = 1:1:3
                    
                        tn = [ eTV(tR(i),t(j,1))  eTV(tR(i),t(j,2)) ]; % pair of nodes refs

                        % searches this pair in lines in the updated LVcon:
                        
                        for k = 1:1:5
                            
                            lr = ilR(k);
                            
                            if (eLV(lr,1)==tn(1) && eLV(lr,2)==tn(2)) || (eLV(lr,1)==tn(2) && eLV(lr,2)==tn(1))
                                
                                conta = conta + 1 ;
                                eTL(tR(i),conta) = lr;
                                break
                                
                            end
                            
                        end

                    end
                    
                end
                
                
            
        end
            
            
	end
          
end  
end




end

