function [E2, Du0] = fs0712_Err_Du0 ...
    (eULims, eDegree, eNcp, eKnotV, eUsize, EeP, Eew, pDegree, pNcp, pKnotV, pUsize, pP, pw, pCD, ...
    Umid, Unod, Eadm, DUtol, Xtol)

% RETURNS:
% rEr: relative error in a triangle, in % w.r.t. side of equilateral triangle of area At
% Dur(2,1): updated increment between nodes rquired to reduce rEr below tolS.
%           The intention is to achieve Dup(1) = Dup(2).

eudim = 2 ;
pudim = 3 ;
xdim  = 3 ;

Du0 = zeros(2,1);

% 1.- PRELIMINARIES:

% 1.1.- Max. distances in triangle (in its param. space) horiz. & vert.:

[Du,~,~] = tm1307_maxD1D2 (Unod);
Du = Du/2;

% 1.2.- Estimates 3rd derivatives.

[dQ] = fs0716_estim3der ...
    (eULims, eKnotV, eNcp,eDegree,eUsize, Eew, EeP, pDegree, pNcp, pKnotV, pUsize, pP, pw, pCD, ...
    Umid, Xtol, DUtol, pudim, eudim, xdim);



% 2.- CALCULATION OF ERROR WITH CURRENT SITUATION:
        
[E2] = fs0713_ErrorE2_simple (Du(1), Du(2), dQ, xdim); % absolute value



% 3.- IN CASE OF EXCESSIVE ERROR FINDS PARAM. SPACE STEPS TO REDUCE < tolS:


if E2 > Eadm
   [Du0] = fs0714_minResidual (Du, dQ, Eadm, eudim, pudim, DUtol);
end




end

