function [aEr] = fs0713_ErrorE2_simple (D1, D2, dQ, xdim)

% RETURNS:
% nEr: abs. error btw estimated and actual surface coordinates for order 2 (norm value)
% A,B,C,D: factors of cubic equation to estimate the longest new increment


% Increments products:

Dxxx = D1^3 ;
Diii = D2^3 ;
Dxxi = D1^2*D2 ;
Diix = D2^2*D1 ;


% Errors for the 3 dims:

Er = zeros(xdim,1); 
    
for di = 1:1:xdim
            
    fxxx = dQ(1,di) ;
    fiii = dQ(4,di) ;
    fxxi = dQ(2,di) ;
    fiix = dQ(3,di) ;

    Er(di,1) = (abs(Dxxx*fxxx) +  abs(Dxxi*fxxi) + abs(Diix*fiix) + abs(Diii*fiii))/16;

    % Er(di,1) = ((Dxxx*fxxx) +  (Dxxi*fxxi) + (Diix*fiix) + (Diii*fiii))/16;
    
end
        

% Error norm:
aEr = norm(Er);


end

