function [Du0] = fs0714_minResidual (Du, dQ, aEtol, eudim, pudim, DUtol)

% Du0(2,1): Increment to reduce resudial r = error - tolS close to 0

% Generates a net of rect. elems, selects those where z function
% (residuial) passes from neg. to pos. and divides them into 4. Repeates
% the process until size of elem < tolES.

% Then, selects elem. closer to 45 degrees line (bisector of parameter
% space) and estimates Du for r = 0 by interpolation.

fR = 90 ;

% 1.- INITIAL NET OF POINTS:
    
u = zeros(1,1); % horiz.
v = zeros(1,1); % vert.
f = zeros(1,1); % residual
    
iNEd = 5 ; % initial No. elems in each direction
%stp = [Du(1)/iNEd Du(2)/iNEd]; % consequent step
    
stp = [1/iNEd 1/iNEd]; % consequent step

i = 0;
for x = 0:stp(1):1 %Du(1)
        
	i = i+1;
        
	j = 0 ;
    for y = 0:stp(2):1 %Du(2)

    	j = j+1;

    	r = 0 ;
        for di = 1:1:pudim
            r = r + ( (x^3 * y^0 *dQ(1,di) + x^2 * y^1 *dQ(2,di) + x^1 * y^2 *dQ(3,di) +  x^0 *y^3 *dQ(4,di))/16 )^2 ;
        end
     	r = r^0.5 - aEtol;

     	u(i,j) = x ;
      	v(i,j) = y ;
      	f(i,j) = r ;
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%
%{
% FUNCTION REPRESENT

figure(fR+1)

for i = 1:1:iNEd
for j = 1:1:iNEd-1
    plot3( [u(i,j) u(i,j+1)] , [v(i,j) v(i,j+1)] , [f(i,j) f(i,j+1)] , 'r'); hold on
end
end

for i = 1:1:iNEd-1
for j = 1:1:iNEd
    plot3( [u(i,j) u(i+1,j)] , [v(i,j) v(i+1,j)] , [f(i,j) f(i+1,j)] , 'r'); hold on
end
end

plot3( [0 1 1 0 0], [0 0 1 1 0], [0 0 0 0 0], 'k'); hold on

if kk==0
end

%}
%%%%%%%%%%%%%%%%%%%%%%%%%%



% 2.- INITIAL SET OF ELEMENTS (CREATED FROM PREV. COORDIANTES):

NE = 0 ;
EUL = zeros(1,eudim,3); % Elements limits (on plan)
Ef = zeros(1,2,2);      % function value at elements nodes (arranged hierarchically)
    
i = 0 ;
for a = 1:1:iNEd
        
    i = i + 1;
    j = 0 ;
        
    for b = 1:1:iNEd
        j = j + 1 ;

        if sign(f(i,j))~=sign(f(i,j+1)) || sign(f(i,j))~=sign(f(i+1,j))  || sign(f(i,j))~=sign(f(i+1,j+1))
                
            NE = NE+1;
                
          	EUL(NE,1,1) = u(i,j);
         	EUL(NE,1,2) = u(i+1,j+1);
                
           	EUL(NE,2,1) = v(i,j);
           	EUL(NE,2,2) = v(i+1,j+1);
                
          	Ef(NE,1,1) = f(i,j);
          	Ef(NE,1,2) = f(i,j+1);
           	Ef(NE,2,1) = f(i+1,j);
            Ef(NE,2,2) = f(i+1,j+1);
                
        end
    end
end
 


%%%%%%%%%%%%%%%%%%%%%%%%%%
%{

% INITIAL DIVISION

figure(fR)
for e = 1:1:NE
      
    x = zeros(5,2);
    
    x(1,1) = EUL(e,1,1);
    x(1,2) = EUL(e,2,1);
    
    x(2,1) = EUL(e,1,2);
    x(2,2) = EUL(e,2,1);
    
 	x(3,1) = EUL(e,1,2);
    x(3,2) = EUL(e,2,2);
    
  	x(4,1) = EUL(e,1,1);
    x(4,2) = EUL(e,2,2);
    
   	x(5,1) = EUL(e,1,1);
    x(5,2) = EUL(e,2,1);
    
    for di = 1:1:2
        plot(x(:,1),x(:,2),'k','LineWidth',1); hold on   
    end
end

axis equal



%}
%%%%%%%%%%%%%%%%%%%%%%%%%%




% 3.- SUB-DIVIDES ELEMENTS:
% detects elements with sign change in residual (z) and divide by 4 until
% elements size < tolES

contaL = 0 ;

Ut = zeros(eudim,3); % temp. Ucoord's in net (3x3)
tolES = 25*DUtol ;
ES = tolES+1 ;

while (ES > tolES)
    
    contaL = contaL + 1 ;
    
	NEt = 0 ;
	EULt = zeros(1,2,2);
	Eft = zeros(1,2,2);
        
    for e = 1:1:NE
            
        % coordinates in each direction (after partition):
        
        for di = 1:1:eudim
            Ut(di,1) = EUL(e,di,1);
            Ut(di,2) = (EUL(e,di,1)+EUL(e,di,2))/2;
            Ut(di,3) = EUL(e,di,2);
        end
            

        % value of function:
            
    	u = zeros(3,3);
     	v = zeros(3,3);
       	f = zeros(3,3);
            
      	for a = 1:1:3
            for b = 1:1:3
                
                x = Ut(1,a);
                y = Ut(2,b);
                
                if a==1 && b==1
                    r = Ef(e,1,1);
                elseif a==1 && b==3
                    r = Ef(e,1,2);
             	elseif a==3 && b==1
                 	r = Ef(e,2,1);
              	elseif a==3 && b==3
                    r = Ef(e,2,2);     
                else
                    
                    r = 0 ;
                    for di = 1:1:pudim
                    r = r + ( (x^3 * y^0 *dQ(1,di) + x^2 * y^1 *dQ(2,di) + x^1 * y^2 *dQ(3,di) +  x^0 *y^3 *dQ(4,di))/16 )^2 ;
                    end
                    r = r^0.5 - aEtol;
                    
                end
                
                u(a,b) = x ;
                v(a,b) = y ;
                f(a,b) = r ;
                
            end
        end
            
            
        % checks the four elements (generated by division):
            
        for i = 1:1:2
            for j = 1:1:2
                
                if sign(f(i,j))~=sign(f(i,j+1)) || sign(f(i,j))~=sign(f(i+1,j))  || sign(f(i,j))~=sign(f(i+1,j+1))
                
                    NEt = NEt + 1 ;
                    
                    EULt(NEt,1,1) = u(i,j);
                    EULt(NEt,1,2) = u(i+1,j+1);

                    EULt(NEt,2,1) = v(i,j);
                    EULt(NEt,2,2) = v(i+1,j+1);
                    
                    Eft(NEt,1,1) = f(i,  j  );
                    Eft(NEt,1,2) = f(i,  j+1);
                    Eft(NEt,2,1) = f(i+1,j  );
                    Eft(NEt,2,2) = f(i+1,j+1);
                end
            end
        end

        
    end

	NE = NEt;
	EUL = EULt ;
 	Ef = Eft ;
     
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%
    %{

    %DIVISIONS DURING ITERATIONS:

    %if contaL < 2
        %figure(100+contaL)
        figure(fR)
        for e = 1:1:NE

            x = zeros(5,2);

            x(1,1) = EUL(e,1,1);
            x(1,2) = EUL(e,2,1);

            x(2,1) = EUL(e,1,2);
            x(2,2) = EUL(e,2,1);

            x(3,1) = EUL(e,1,2);
            x(3,2) = EUL(e,2,2);

            x(4,1) = EUL(e,1,1);
            x(4,2) = EUL(e,2,2);

            x(5,1) = EUL(e,1,1);
            x(5,2) = EUL(e,2,1);

            for di = 1:1:2
                plot(x(:,1),x(:,2),'k'); hold on   
            end
        end

        axis equal
    %end
    %}
    %%%%%%%%%%%%%%%%%%%%%%%%%%
    
    
	ES = ((EUL(1,1,2)-EUL(1,1,1))^2 + (EUL(1,2,2)-EUL(1,2,1))^2)^0.5;
    
end
   



%%%%%%%%%%%%%%%%%%%%%%%%%%
%{
% BISECTOR

figure(fR)
plot([0 1],[0 1],'r'); hold on
axis equal
%}
%%%%%%%%%%%%%%%%%%%%%%%%%%




% 4.- SELECTS ELEMENTS CLOSEST TO BISECTOR.
% That implies Du(1) is similar to Du(2)

% 4.1.- Arranges elements by angle diff. with 45 degrees
    
EDA = zeros(NE,2); % deviation w.r.t. 1 (tan 45) and elem. ref
for e = 1:1:NE
        
    ce = [ EUL(e,1,1)+EUL(e,1,2) EUL(e,2,1)+EUL(e,2,2) ]/2; % element center
        
	tg = ce(2)/ce(1);

	EDA(e,1) = abs(1-tg);
	EDA(e,2) = e ;
end
    
EDA = sortrows(EDA,1);
    

% 4.2.- Chooses first element (closest to 45 deg.) an interpolates:
    
eR = EDA(1,2);


% 4.3.- Interpolates within that element to estimate Du:

re = [1 2 2 1 1 ; 1 1 2 2 1 ]';
    
a = zeros(eudim+1,1);
b = zeros(eudim+1,1);
    
contaI = 0 ; % counts intersections, stops when = 2
    
for i = 1:1:4
        
    for di = 1:1:eudim
        a(di,1) = EUL(eR,di,re(i,di));
      	b(di,1) = EUL(eR,di,re(i+1,di));
    end
        
	a(3,1) = Ef(eR,re(i,1),re(i,2));
	b(3,1) = Ef(eR,re(i+1,1),re(i+1,2));
        
	if sign(a(3)) ~= sign(b(3))

        contaI = contaI+1;
        [iu] = fs0717_zeroInterst (a,b);
 
        if contaI==1
            c = iu ;
    	elseif contaI == 2
            d = iu ;
            break
        end  
    end
end
    
% uses segment c - d  and select point that reduces distance u-v
% (intersection with bisector)

v1 = [1 1]';
v1 = v1/norm(v1);
p1 = [0 0]';
     
v2 = c-d;
v2 = v2/norm(v2);
p2 = c ;
    
A = [ v1(1) -v2(1) ; v1(2) -v2(2) ] ;
b = [ -p1(1)+p2(1) ; -p1(2)+p2(2) ];
    
t = A\b ; % parameters
    
u = p1 + t(1)*v1 ;
    
IN = 0 ;
for di = 1:1:2
    if (min(c(di),d(di)) <= u(di) && u(di) <= max(c(di),d(di))) 
    IN = 1 ;
    end
end
    

% allocates response:
if IN == 1
    
    Du0 = u ; 
    
else
        
    tg1 = abs(1-c(2)/c(1));
    tg2 = abs(1-d(2)/d(1));

    if tg1 < tg2
        Du0 = c ;
    else
        Du0 = d ;
    end
end

end