function [Uvi, NVi] = fs0715_upCorVtx2 (Uvi, NVi, Uv, LVcon, Nlv, NLI, NSL)

% RETURNS>
% NVi, Uvi(NVi,2): updated including new vertexes of internal lines 

u1 = zeros(2,1);
u2 = zeros(2,1);

for li = sum(Nlv)+1:1:NLI % internal lines start at last point of loops 
    
    if NSL(li)>1

        n1 = LVcon(li,1);
        n2 = LVcon(li,2);

        u1(:,1) = Uv(n1,:);
        u2(:,1) = Uv(n2,:);

        D = norm(u2-u1)/NSL(li);

        [N, sd] = go2531_DivSegment (u1, u2, 2, D, 2, 1);
        
        if N > 2

            nUv = zeros(N-2,2);  
            for i = 1:1:N-2
                nUv(i,:)=sd(i+1,:);
            end

            Uvi = [Uvi;nUv];
            NVi = NVi + N-2;
        end
    end 
    
end

end

