function [NVc, Xvc] = fs0719_addContLines (b, Xv, LVcon, NSL, nloE, ncuE, SCconE, NcvE, agCurvE, Xtol, DUtol)

% NOTE !! NVc includes for each curve initial and final vertex !

xdim  = 3 ;
eudim = 2 ;
cudim = 1 ;

NVc = zeros(nloE(b,1),size(ncuE,2));
Xvc = zeros(nloE(b,1),size(ncuE,2),1,xdim);
    
x1 = zeros(xdim,1);
x2 = zeros(xdim,1);

contaL = 0 ;

for lo = 1:1:nloE(b,1)    
for c = 1:1:ncuE(b,lo)
        
        cR = abs(SCconE(b,lo,c));
            
        j = 0;
        xt=zeros(1,3);
        for v = 1:1:NcvE(cR)-1

            contaL = contaL + 1 ;

            n1 = LVcon(contaL,1);
         	n2 = LVcon(contaL,2);

          	x1(:,1) = Xv(n1,:);
        	x2(:,1) = Xv(n2,:);

            
            % param. coord's in terms of curve:
            
            p = agCurvE(cR).Degree ;
            n = agCurvE(cR).Ncp ;
            U = agCurvE(cR).KnotV ;
            P = agCurvE(cR).P ;
            w = agCurvE(cR).w ;
            ULims = [0 1];
            CD = agCurvE(cR).CD ;
            
            u = zeros(2,1);
            u0 = 0.5 ;
            [u1,~] = c2815b_onePoint (x1, u0, p, n, U, P ,w, ULims, CD, xdim, Xtol, DUtol);
            [u2,~] = c2815b_onePoint (x2, u0, p, n, U, P ,w, ULims, CD, xdim, Xtol, DUtol);


            D = norm(u2-u1)/NSL(contaL);

        	[N, sd] = go2531_DivSegment (u1, u2, 2, D, 1, 1);

            if v < NcvE(cR)-1
                i2 = N-1;
            elseif v == NcvE(cR)-1
                i2 = N;
            end

            for i = 1:1:i2

                j = j+1;

                u = round(sd(i,:),6);

                [X] = b2601_BNURBS_Xcoord (u, U, n, p, n+p+1, w, P, cudim,xdim);
            	Xvc(lo,c,j,:) = X(:,1);

                xt(j,:) = X(:,1);
                    
            end

        end

        NVc(lo,c) = j;
            
end
end
    
end

