function [cLXvE, cLUvE, NcvE, ESV] = fs0741_contourVtx ...
 (cLXvE, cLUvE, NcvE, agCurvE, ESV, TNcuE, Eskin, Nbe, Ntc, tcR, Nts, tsR, nloE, ncuE, SCconE, Xtol, DUtol)

% RETURNS:
% updated cLXvE, cLUvE considering Tskin refinement
% updated considering Eskin refinement and adding Uvc coordinates

% ESV(Nbe,1) = struct('NVc', [] ,'NVi',0,  'Xvc', [], 'Xvi', [], 'Uvc', [] , 'Uvi', [] ); 

eudim = 2 ;
xdim = 3 ;
alreadyCMP = zeros(TNcuE,1); % turns to 1 if the curve is computed


% 1.- INSERTS VTX ACC. TO ESV to CURVES:

for b1 = 1:1:Nts

    sR1 = tsR(b1,1);
    
    for lo1 = 1:1:nloE(sR1)
    for cu1 = 1:1:ncuE(sR1,lo1)

    	Nss = 0; % No. selected skins
        ss = zeros(1, 4); % sb(Nss, bR sg lo cu )
        
       	cR1 = SCconE(sR1,lo1,cu1); % curve reference
       	sg1 = sign(cR1);
      	cR1 = abs(cR1);

        if alreadyCMP(cR1,1) == 0 % curve not explored so far
            
            alreadyCMP(cR1,1) = 1 ;

            Nss = Nss + 1 ;
            ss(Nss,1) = sR1;
            ss(Nss,2) = sg1;
            ss(Nss,3) = lo1;
            ss(Nss,4) = cu1;

            % initially allocates vtx from skin 1
            NVc1 = ESV(sR1,1).NVc(lo1,cu1); % No. vtx of that curve from skin 1
            [cXv] = fs0742_extractcXv (sg1, NVc1, ESV, sR1, lo1,cu1, xdim);
            

            % searches curve cR1 within itself and next surfaces.
            % stores in sb info from surfaces
            % Updates cXv to the one with more vtx.
            [Nss, ss, cXv] = fs0743_compar (ESV, Nbe, NVc1, Nss, ss, cXv, sR1, cR1, cu1, SCconE, nloE, ncuE, xdim);


            % recomputes in curve param. space and updates curve coordinates:

            N = size(cXv,1) ;

            p = agCurvE(cR1).Degree;
            n = agCurvE(cR1).Ncp;
            U = agCurvE(cR1).KnotV;
            
            P = agCurvE(cR1).P;
            w = agCurvE(cR1).w;
            CD = agCurvE(cR1).CD;

            [cUv] = c2811b_PPcurves (cXv, N, p, n, U, P, w, CD, xdim, Xtol, DUtol);
            

            for i = 1:1:N
                cLXvE(cR1,i,:) = cXv(i,:);
                cLUvE(cR1,i,:) = cUv(i);  
            end

            NcvE(cR1,1) = N ;

            
            % recomputes coordinates in param. space of attached surfaces
            % and updates their skin contour vtx:
            

            for i = 1:1:Nss
                
                bR = ss(i,1);
                sg = ss(i,2);
                lo = ss(i,3);
                cu = ss(i,4);
                                
                [ESV] = fs0744_cXUtoESV (ESV, Eskin, bR, N, cXv, sg, lo, cu, xdim, Xtol, DUtol);
                
            end
            
        end
  
    end
    end
end




% 2.- INSERTS MID-VTX:
%  computes the mid-segments points

sUv = zeros(Ntc,1, eudim); % edge curve coord's in terms of surface param. space

% EN LA MIERDA ESTA !!
% *******************************************************************************************************

for j = 1:1:Ntc

    cR = tcR(j,1);
   
	p = agCurvE(cR).Degree;
	n = agCurvE(cR).Ncp;
	U = agCurvE(cR).KnotV;    
  	P = agCurvE(cR).P;
  	w = agCurvE(cR).w;
  	
    Nmax = NcvE(cR,1);
    
    for i = 1:1:Nmax-1
    
        u = (cLUvE(cR,i) + cLUvE(cR,i+1)) / 2 ;
        
        x = b2601_BNURBS_Xcoord (u, U, n, p, n+p+1, w, P, 1, xdim);
        
        cLUvE(cR,Nmax+i) = u;
        cLXvE(cR,Nmax+i,:) = x(:,1);
    end
    
    NcvE(cR,1) = NcvE(cR,1) + Nmax-1;
    
    % plots curve corner and mid-points
    %{
    

    
    x = zeros(1,3);
    
    for i = 1:1:NcvE(cR,1)-(Nmax-1)
        
        x(i,:) = cLXvE(cR,i,:);
        
    end
    
    
    
    figure(23)
    scatter3(x(:,1),x(:,2),x(:,3),'k'); hold on
    plot3(x(:,1),x(:,2),x(:,3),'k'); hold on
    
 	x = zeros(1,3);
    j = 0;
    for i = Nmax+1:1:NcvE(cR,1)
        j = j + 1 ;
        x(j,:) = cLXvE(cR,i,:);
    end
    
    scatter3(x(:,1),x(:,2),x(:,3),'r'); hold on
    axis equal
    
    

    %}
    
  
end



% 3.- REVISIT INTENRAL POINTS (Uvi) TO DELETE THOSE ONES TOO CLOSE OR OUT OR THE CONTOUR:



for i = 1:1:2
    
    sR = tsR(i,1);
    
    
    figure(2)
    scatter(ESV(sR,1).Uvi(:,1), ESV(sR,1).Uvi(:,2),'r'); hold on
    axis equal
    
    for l = 1:1:1
        
        for  c = 1:1:4
        for v = 1:1:ESV(sR,1).NVc(c)
            
            scatter(ESV(sR,1).Uvc(l,c,v,1), ESV(sR,1).Uvc(l,c,v,2), 'b'); hold on
            axis equal
        end
        end
        
    end
    
end



if gg==0
end
    


end

