function [Ncvt, cUvt] = fs0747_Cref (TNcu, Ntc, tcR, Ncv, cUv, cDu, crF)

% RETURNS:
% cUv(NTcu,Ncv) with inserted nodes to reduce error below Eadm

Ncvt = zeros(TNcu,1);
cUvt = zeros(TNcu,1);

for j = 1:1:Ntc
    
    cR = tcR(j,1);
    
    NV = Ncv(cR,1);
    i = 0 ;

    % 2.- REFINES ELEMENTS IF REQUIRED:

    for e = 1:1:NV-1
        
        if crF(j,e)==0
            
            % 2.1.- No refinement required:
            
            i = i+1;
            cUvt(cR,i) = cUv(cR,e);
            
        elseif crF(j,e)==1

            % 2.2.- Adds nodes:
        
            s = cUv(cR,e+1) - cUv(cR,e);
            
            n = round(s/cDu(cR,e));
            
            if n < 2
                n = 2 ;
            end
            
            s = s/n;
            
            Uacc = cUv(cR,e);
            
            for k = 1:1:n
                
                i = i+1;
                cUvt(cR,i) = Uacc;
                
                Uacc = Uacc + s;
                
            end

        end
        
    end
    
    % last point:
    i=i+1;
    cUvt(cR,i) = cUv(cR,NV);
    
    
    % 2.3.- No. nodes of the curve:
    
    Ncvt(cR,1) = i;
    
end



end

