function [rx, rN] = fs0750_redistrNod (t1, t2, x0, x1, x, y, vR, inn)

% RETURNS:
% x0, x1: redistribuited nodes to be inserted within the interval t1-t2

% INPUTS:
% vR: 'pivot' node ref, where nodes are to be inserted


k45 = 0.66667;

rx = zeros(1,1);

Dxp = x(vR) - x(vR-1); % increment in x from previous sample point

Dxr = x1 - x0; % required increment in x

% 1.- REQUIRED INTERVAL IS SMALLER THAN PREV. STEP IN x:
% Adds nodes between pivot and previous sample point changing the distance linearly

if Dxr < Dxp
    
    % No. intervals:
    n = round(Dxp/Dxr); 
    if n<2
        n = 2 ;
    end
    
    % postitions:
    [ix] = GEN_25_LdivBias (x(vR-1), y(vR-1), x(vR), y(vR), n+1, k45);
    
    % allocates:
    for i = 1:1:n+1 
        rx(i,1) = ix(i);
    end
    
    rN = n+1;
    
end


% 2.- REQUIRED INTERVAL IS GREATER THAN PREVIOUS STEP IN x:

if Dxp <= Dxr
    
    rx = zeros(2,1);
    
    rN = 2 ;
    
    % try first to distribute the node between t1 and sample vertex vR acc.
    % to y's values
    
    yt1 = fs0749_lineInterp (inn, x, y, t1);
    [ix] = GEN_25_LdivBias (t1, yt1, x(vR), y(vR), 3, k45);
    
    
    if ix(3)-ix(2) < Dxr
        % is acceptable if second x-increment is less than Dxr 

        rx(1) = ix(2);
        rx(2) = ix(3);
        
    else
        % if is less, just assumes x0 where it is:
        
     	rx(1) = x0;
        rx(2) = x1;
        
    end
    
    
end

end

