function [rEskin2] = fs0771_reSkin (cLXvE, cLUvE, NcvE, agCurvE, Nbe, rEskin1, ESV, nloE, ncuE, SCconE, Spatches, Xtol, DUtol)

% ESV(Nbe,1) = struct('NVc', [] ,'NVi',0,  'Xvc', [], 'Xvi', [], 'Uvc', [] , 'Uvi', [] ); 
% recall that NVc(lo,cu) contain all vtx., from initial to final

xdim  = 3 ;
pudim = 3 ;
eudim = 2 ;

rEskin2(Nbe,1) = cEskin;

for b = 1:1:Nbe

    Tr = rEskin1(b,1).mTr ;
    pR = rEskin1(b,1).mPa(1);
    
    % 1.- EXTRACTS VERTEXES FROM ESV: number and X and U coordinates
    % Recall ESV has vtxs required for reducing error < tolS.
    
    NV = 0 ;
    Xv = zeros(1,xdim);
    Uv = zeros(1,eudim);
    
    Nec = zeros(1,1); % No. curve edges attached 
    ER = zeros(1,1);  % edge curve ref and local param coord
    Ev = zeros(1,1);
    
    Nlo = nloE(b,1);
    
    % 1.1.- Contour vtx:
    
    Nlv  = zeros(Nlo,1); 
    Nlcv = zeros(Nlo,1);
    
    for lo = 1:1:Nlo
        
        Ncu = ncuE(b,lo);
        
        for cu = 1:1:Ncu
            
            cR = SCconE(b,lo,cu);
            sg = sign(cR);
            
            n = ESV(b).NVc(lo,cu) - 1 ; % No. vtx of the curve (except the last)
            
            j = 0 ;
            if sg==-1
                j = n+1;
            end
            
            for i = 1:1:n
                
                j = j + sg;
                NV = NV + 1 ;
                
                Xv(NV,:) = ESV(b).Xvc(lo,cu,i,:);
                Uv(NV,:) = ESV(b).Uvc(lo,cu,i,:);
                
                
                Nec(NV,1) = 1 ;
                ER(NV,1) = cR ;
                Ev(NV,1) = cLUvE(abs(cR),j);
                
                % special cases:
                
                if i == 1 && cu==1
                    
                    cRlast = SCconE(b,lo,Ncu);
                    sglast = sign(cRlast);
                    nprev = ESV(b).NVc(lo,Ncu) ;
                    
                    if sglast==-1
                        nprev = 1 ;
                    end
     
                    Nec(NV,1) = 2 ;
                    ER(NV,2) = cRlast ;
                    Ev(NV,2) = cLUvE(abs(cRlast),nprev);
                    
                end
                
                
                if i == 1 && cu > 1
                    
                    cRprev = SCconE(b,lo,cu-1);
                    sgprev = sign(cRprev);
                    nprev = ESV(b).NVc(lo,cu-1) ;
                    
                    if sgprev==-1
                        nprev = 1 ;
                    end
     
                    Nec(NV,1) = 2 ;
                    ER(NV,2) = cRprev ;
                    Ev(NV,2) = cLUvE(abs(cRprev),nprev);
                end
                
            end
            

            Nlcv(lo,cu) = n ;
            Nlv(lo,1) = Nlv(lo,1)+n;
            
        end
    end
    
    % 1.2.- Internals, that are added at the back.

    for i = 1:1:ESV(b).NVi
        
        NV = NV+1;
    	Xv(NV,:) = ESV(b).Xvi(i,:);
        Uv(NV,:) = ESV(b).Uvi(i,:);

        Nec(NV,1) = 0;
        ER(NV,1) = 0 ;
        Ev(NV,1) = 0 ;
        
    end
    

    
    % 2.- ESTIMATES PATTERN COORDINATES OF NEW VTX ARRANGEMENT:
    
    [Rv] = fs0773_newRv (b, rEskin1, Nlo, NV, Uv);
    

    % 3.- TRIANGULATION OF NEW ARRANGEMENT:
    % Triangulation of new vrtx (considers contours as constraints):

    [NE, NV, NLI, TVcon, VTcon, LVcon, VLcon, TLcon] = tr1340_globalTriang (Nlo, Nlv, Rv);

    
    
	% 4.- PATCH PARAM. SPACE, NORMALS AND PHYSICAL AREAS:

    % 4.1.- Patch(es) features:

    [~,   pDegree,   pNcp, pKnotV,  pUsize,  pP,  pw,  pCD, ~, ~, ~, ...
    spR, spDegree, spNcp, spKnotV, spUsize, spP, spw, spCD, ~, ~, ~] = ...
    so2938_patchNURBS (rEskin1(b,1), Spatches, xdim);


    % 4.2.- Patch param. coord's and normals (in patch param. and physical 
    %       space) and physical area of each triangle:

    Av = v2861b_PPvol (Xv, NV, pDegree, pNcp, pKnotV, pUsize, pP, pw, pCD, xdim, Xtol, DUtol);

    spF = 0;
    [~,  ANe, ANv] = tm1308_TmeshNA (spF, NE, NV, TVcon, VTcon, Av, pudim);
    [Ae, XNe, XNv] = tm1308_TmeshNA (spF, NE, NV, TVcon, VTcon, Xv, pudim);

    AvS = 0 ;
    ANeS = 0 ;
    ANvS = 0 ;

    if spR > 0
        
        AvS = v2861b_PPvol (Xv, NV, spDegree, spNcp, spKnotV, spUsize, spP, spw, spCD, xdim, Xtol, DUtol);
        spF = 1;
        [~,  ANeS, ANvS] = tm1308_TmeshNA (spF, NE, NV, TVcon, VTcon, AvS, pudim);
  
    end
    
    
    
    
    % 4.- MIDPOINTS COORDINATES (only for trimming surface).
    % Internals are computed at u-mid.
    % At edges are computed using contour curves.
    
    if sum(Tr) > 0
    
        [NVm, Uvm, Xvm, Avm, AvSm, LVm, TVm] = fs0772_midVtx ...
        (cLXvE, cLUvE, NcvE, agCurvE, pR, Spatches, b, rEskin1, Nlv, NV, Uv, Av,AvS, Xv, ...
        LVcon, NLI, NE, TVcon, TLcon, nloE, ncuE, SCconE, eudim, pudim, xdim, Xtol, DUtol);

    elseif  sum(Tr) == 0
        
        NVm = NV ;
        Uvm = Uv ;
        Xvm = Xv ;
        Avm = Av ;
        AvSm = AvS ;
        LVm = LVcon;
        TVm = TVcon;
        
    end


    
    % 6.- ALLOCATES:

    rskin = cEskin;

    for k = 1:1:1
    
    rskin.mDegree = rEskin1(b,1).mDegree ;
    rskin.mKnotV = rEskin1(b,1).mKnotV ;
    rskin.mUsize = rEskin1(b,1).mUsize ;
    rskin.mNcp  = rEskin1(b,1).mNcp ;
    rskin.mP    = rEskin1(b,1).mP ;
    rskin.mw    = rEskin1(b,1).mw ;

    rskin.mPN = rEskin1(b,1).mPN ;
    rskin.mCS = rEskin1(b,1).mCS ;

    rskin.mNlo = Nlo ;
    rskin.mNlv = Nlv ;

    NCL = zeros(Nlo,1);
    for lo=1:1:Nlo
        NCL(lo,1) = ncuE(b,lo);
    end
    
    rskin.mNCL  = NCL ;
    rskin.mNlcv = Nlcv ;
    
    rskin.mNE = NE ;
    rskin.mNV = NV ;
    rskin.mNVm = NVm ;
    
    rskin.mRv = Rv ;
    rskin.mUv = Uvm ;
    rskin.mAv  = Avm ;
    rskin.mAvS = AvSm ;

    rskin.mXv = Xvm ;

    rskin.mTVcon = TVm ;
    rskin.mVTcon = VTcon ;
    rskin.mLVcon = LVm ;
    rskin.mVLcon = VLcon ;
    rskin.mTLcon = TLcon ;

    rskin.mArea = Ae ;

    rskin.mANv = ANv ;
    rskin.mANe = ANe ;

    rskin.mANvS = ANvS ;
    rskin.mANeS = ANeS ;

    rskin.mXNv = XNv ;
    rskin.mXNe = XNe ;

    rskin.mTr  = rEskin1(b,1).mTr ;
    rskin.mPa  = rEskin1(b,1).mPa ;
    rskin.mCou = rEskin1(b,1).mCou ;
    
    if sum(Tr) > 0
        
        iemt = zeros(NE,3,3);
        ieme = [0 4 6 ; 4 0 5 ; 6 5 0];
        
        for e = 1:1:NE
            
            for i = 1:1:3
          	for j = 1:1:3
                iemt(e,i,j) = ieme(i,j);
          	end
            end
            
        end
        rskin.iem = iemt;
    else
        rskin.iem = zeros(NE,3,3);
    end

    rskin.mNec = Nec;
	rskin.mEv = Ev ;
    rskin.mER = ER ;
    
    rEskin2(b,1) = rskin;
    
    end
    
    clearvars('rskin');
    
end


end
