function [NVm, Uvm, Xvm, Avm, AvSm, LVm, TVm] = fs0772_midVtx ...
    (cLXvE, cLUvE, NcvE, agCurvE, pR, Spatches, bR, Eskin, Nlv, NV, Uv, Av,AvS, Xv, ...
    LVcon, NLI, NE, TVcon, TLcon, nloE, ncuE, SCconE, eudim, pudim, xdim, Xtol, DUtol)

% RETURNS:
% triang. with mid nodes at sides

% 1.- PRELIMINARIES:

% 1.1.- Initial arrays:

TVm = [TVcon zeros(NE,3)]; % mid vtx

LVm = zeros(NLI,3);

NVm = NV ;
Uvm = Uv;
Xvm = Xv;
Avm = Av;
AvSm = AvS;

% 1.2.- Extracts data:

[~,  pDegree,  pNcp,  pKnotV,  pUsize,  pP,  pw,  pCD , pEw,  pEP,  pULims, ...
spR, spDegree, spNcp, spKnotV, spUsize, spP, spw, spCD, spEw, spEP, spULims] = ...
so2938_patchNURBS (Eskin(bR,1), Spatches, xdim);

eDegree     = Eskin(bR,1).mDegree ;
eNcp        = Eskin(bR,1).mNcp ;
eKnotV      = Eskin(bR,1).mKnotV ;
eUsize      = Eskin(bR,1).mUsize ;
eCS         = Eskin(bR,1).mCS ;
eP          = Eskin(bR,1).mP ;
ew          = Eskin(bR,1).mw ;
[eEw,eEP] = GEN_12_ExpandBw (ew, eP,xdim, eudim, eNcp);



% 2.- MID-POINTS COORD'S THAT LIE AT CONTOUR CURVES:
% they are taken from mid-points of the correspondent curve

li = 0 ;

for lo = 1:1:nloE(bR)
for cu = 1:1:ncuE(bR,lo)
    
	cR = SCconE(bR,lo,cu);
	sg = sign(cR);
 	cR = abs(cR);

    cKnotV  = agCurvE(cR,1).KnotV;
    cNcp    = agCurvE(cR,1).Ncp;
    cDegree = agCurvE(cR,1).Degree;
    cUsize  = cNcp + cDegree + 1;
    cw      = agCurvE(cR,1).w;
    cP      = agCurvE(cR,1).P;
    
    
    % No. mid-points parameter coordinates (physical space):
    
    nt = NcvE(cR,1);    % No. total nodes of the curve
    nc = (nt+1)/2 ;         % No. corner nodes
    nm = nt-nc;             % No. mid-nodes
        
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %{
    figure(cR)
 
        for i = 1:1:nc
            scatter3(cLXvE(cR,i,1), cLXvE(cR,i,2), cLXvE(cR,i,3), 'k'); hold on
        end
        
        for i = 1:1:nm
            j = nc+i ;
            scatter3(cLXvE(cR,j,1), cLXvE(cR,j,2), cLXvE(cR,j,3), 'r'); hold on
        end

    axis equal
    %}
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    Xcm = zeros(nm,xdim);
    for i = 1:1:nm
        j = nc+i;
        Xcm(i,:) = cLXvE(cR,j,:);
    end
    
    if sg == -1 % reverses in case is opposite to surface contour
        Xcm = GEN_40_invertRowsOrder(Xcm);
    end

    
	% computes param. coord's of Xcm:
    
    if nm==1
        [Ucm, ~] = s2835b_onePoint (Xcm, [0.5 0.5], eDegree, eNcp, eKnotV, eUsize, eP ,ew, eEP ,eEw, eCS, [0 1;0 1], xdim, Xtol, DUtol);
    else
        [Ucm] = s2836_PPlineonS (Xcm, nm, eDegree, eNcp, eKnotV, eUsize, eP, ew, eCS, xdim, Xtol, DUtol);
    end

	[Acm] = v2861b_PPvol (Xcm, nm, pDegree, pNcp, pKnotV, pUsize, pP, pw, pCD, xdim, Xtol, DUtol);
        
    if spR > 0
        AcSm = v2861b_PPvol (Xcm, nm, spDegree, spNcp, spKnotV, spUsize, spP, spw, spCD, xdim, Xtol, DUtol);
    end
    
    

	% Allocates to surface, and updates No. vtx and conn. matrix
        
    for i = 1:1:nm  
        
        NVm = NVm + 1 ;
        
     	Uvm(NVm,:) = Ucm(i,:);
    	Xvm(NVm,:) = Xcm(i,:);
    	Avm(NVm,:) = Acm(i,:);
            
        if spR > 0
            Avm(NVm,:) = AcSm(i,:);
        end
        
     	li = li + 1 ;
            
      	v1 = LVcon(li,1);
     	v2 = LVcon(li,2);
            
     	LVm(li,1) = v1;
     	LVm(li,2) = NVm;
      	LVm(li,3) = v2; 
        
    end
    
end
end


%{
x = Xvm(1:NV,:);
a = Avm(1:NV,:);
u = Uvm(1:NV,:);

xm = Xvm(NV+1:NVm,:);
am = Avm(NV+1:NVm,:);
um = Uvm(NV+1:NVm,:);

figure(1)
scatter3(x(:,1),  x(:,2),  x(:,3),  'k');  hold on
scatter3(xm(:,1), xm(:,2), xm(:,3), 'r');  hold on
axis equal

figure(2)
scatter3(a(:,1),  a(:,2),  a(:,3),  'k');  hold on
scatter3(am(:,1), am(:,2), am(:,3), 'r');  hold on
axis equal

figure(3)
scatter(u(:,1),  u(:,2),  'k');  hold on
scatter(um(:,1), um(:,2), 'r');  hold on
axis equal
%}

% 3.- MID-POINTS IN THE INTERIOR TRIANGLES SIDES:

% rest of mid-points: just follows the NLI and computes the mid point in
% surface param. space

liC = li+1 ;

u = zeros(eudim,1);
a0 = zeros(1,pudim);
a0S = zeros(1,pudim);


for li = liC:1:NLI
    
    v1 = LVcon(li,1);
  	v2 = LVcon(li,2);
    
    for di = 1:1:eudim
        u(di,1) = (Uv(v1,di) + Uv(v2,di))/2;
    end
  
   	for di = 1:1:pudim
        a0(1,di) = (Av(v1,di) + Av(v2,di))/2;
    end
    
    x = b2601_BNURBS_Xcoord  (u, eKnotV, eNcp,eDegree,eUsize, eEw, eEP, eudim, xdim);
    [a, ~] = v2865b_onePoint (x, a0, pDegree, pNcp, pKnotV, pUsize, pP ,pw, pEP ,pEw, pCD, pULims, xdim, Xtol, DUtol);
 
    if spR > 0
        
        for di = 1:1:pudim
            a0S(1,di) = (AvS(v1,di) + AvS(v2,di))/2;
        end
        [aS, ~] = v2865b_onePoint (x, a0S, spDegree, spNcp, spKnotV, spUsize, spP ,spw, spEP ,spEw, spCD, spULims, xdim, Xtol, DUtol);

    end
    

    NVm = NVm + 1 ;
    Uvm(NVm,:) = u(:,1);
    Xvm(NVm,:) = x(:,1);
    Avm(NVm,:) = a(1,:);
    
    if spR > 0
    AvSm(NVm,:) = aS(1,:);
    end
    
    LVm(li,1) = v1;
    LVm(li,2) = NVm;
    LVm(li,3) = v2;

end


% 4.- UPDATES TVcon:

% allocates mid-vtx to elements in conn. matrix TVcon:
% assumes that TLcon is arranges acc/to vertexes: 12, 23, 31

for e = 1:1:NE

    for i = 1:1:3
        
        % line ref:
        lR = TLcon(e,i);
        
        % mid-vtx of that line:
        mvR = LVm(lR,2);
        
        % allocates:
        TVm(e,3+i) = mvR ;
  
    end

end





end

