function [Rv] = fs0773_newRv (b, rEskin1, Nlo, NV, Uv)

% RETURNS:
% Rv(NV,2): pattern coordinates of the new (refined) nodes arrangement.
% Remember these nodes are only the corner-nodes, that are used for
% triangulation

eudim = 2 ;

    % 2.1.- Triangulation in pattern space with original vtx:
    
    oNlv = rEskin1(b,1).mNlv ;
    oRv = rEskin1(b,1).mRv ;
    oUv = rEskin1(b,1).mUv ;
    
    [rNE, rNV, rNLI, rTVcon, rVTcon, rLVcon, rVLcon, rTLcon] = tr1340_globalTriang (Nlo, oNlv, oRv);
    

    
    % 2.2.- Envelope ULims of each triangle:
    
    rULims = zeros(rNE,eudim,2);

    for e = 1:1:rNE

        unod = zeros(3,eudim);
        for i = 1:1:3
            nR = rTVcon(e,i);
            unod(i,:) = oUv(nR,:);
        end

        [~,~,eLims] = tm1307_maxD1D2 (unod);
        rULims(e,:,:) = eLims(:,:);

    end
    
    

    % 2.3.- Computes Rv of updated arrangement:
       
    Rv = zeros(NV,2);

    nd = 4 ;
    u = zeros(eudim,1);

    rEiem = zeros(rNE,3,3);
    

    for i = 1:1:NV

        u(:,1) = Uv(i,:);

        r = tr1348_interpTriLQ (u, rEiem, rNE, rTVcon, oUv, rULims, oRv, eudim, nd);
        Rv(i,:) = r(:,1);

    end


end

