function [AR, AE, rE, aE, TVcont] = fs0781_RnE_Acoords ...
    (pR, Spatches, eKnotV, eNcp, eDegree, eUsize, eEw, eEP, NV,NVm, Avm, Uvm, NE, TVm, Eiem, Nlv, eudim, pudim, xdim, Eadm, Udiag, Xtol, DUtol)

% RETURNS
% AE, AR: estimated and real coord's in patch param. space
% rE: plan coord's and relative errors
% aE: plan coord's and aboslute errors

pDegree = Spatches(pR,1).mRefin(1).mDegree ;
pNcp    = Spatches(pR,1).mRefin(1).mNcp ;
pKnotV  = Spatches(pR,1).mRefin(1).mKnotV ;
pUsize  = Spatches(pR,1).mRefin(1).mUsize;
pP      = Spatches(pR,1).mRefin(1).mP ;
pw      = Spatches(pR,1).mRefin(1).mw ;
pCD     = zeros(pudim,1);
[pEw,pEP] = GEN_12_ExpandBw (pw, pP,xdim, pudim, pNcp);  

pULims = [ 0 1 ; 0 1 ; 0 1 ];


% 1.- GENERATES TRIANGULATION WITHIN THE CONTOUR:

NVt = 0 ;
Ut = zeros(1,2);

% extracts contours nodes:

NLt = 1 ;
Nlvm = 2 * Nlv;

for i = 1:1:Nlv

    NVt = NVt + 1 ;
    Ut(NVt,:) = Uvm(i,:);
    
    NVt = NVt + 1 ;
    Ut(NVt,:) = Uvm(i+NV,:);
end


% adds K times contour nodes in between:

NK = 3 ;

u = zeros(2,1);

for k = 1:1:NK

    iUt = zeros(Nlvm,2);
    for i = 1:1:Nlvm

        a = i ;
        b = i+1;

        if i==Nlvm
            b = 1;
        end

        for di = 1:1:2
            u(di,1) = (Ut(a,di) + Ut(b,di))/2;
        end

        iUt(i,:) = u(:,1);

    end

    v = zeros(1,2);
    j = 0 ;
    for i = 1:1:Nlvm

        j = j+1;
        v(j,:) = Ut(i,:);

        j = j+1;
        v(j,:) = iUt(i,:);

    end

    Ut = v ;

    NVt = NVt+Nlvm;
    Nlvm = Nlvm+Nlvm;

end


% then the rest:

for i = Nlv+1:1:NV
    NVt = NVt + 1 ;
    Ut(NVt,:) = Uvm(i,:);
end

for i = NV+Nlv+1:1:NVm
    NVt = NVt + 1 ;
    Ut(NVt,:) = Uvm(i,:);
end



[NEt, NVt, NLIt, TVcont, VTcont, LVcont, VLcont, TLcont] = tr1340_globalTriang (NLt, Nlvm, Ut);

% adds nodes at mid points again:
% {



for k = 1:1:NK

    u1 = zeros(2,1);
    u2 = zeros(2,1);

    for l = Nlvm+1:1:NLIt

        u1(:,1) = Ut(LVcont(l,1),:);
        u2(:,1) = Ut(LVcont(l,2),:);

        NVt = NVt + 1 ;

        Ut(NVt,1) = (u1(1)+u2(1))/2 ;
        Ut(NVt,2) = (u1(2)+u2(2))/2 ;
    end

    [NEt, NVt, NLIt, TVcont, VTcont, LVcont, VLcont, TLcont] = tr1340_globalTriang (NLt, Nlvm, Ut);

end

%}

pt1366_pTriLinMesh_nD (Ut, NLIt, LVcont, TVcont, 2, 22, 'k', 0, NVt, 0, 0, NEt, 0, 0, 0, 0, 0, 0)



% 2.- ELEMT ULims 

eULims = zeros(NE,2,eudim);

for e = 1:1:NE
    
    % element corner nodes coord's:
    
    Unod = zeros(3,eudim);
    Anod = zeros(3,pudim);
    
    for i = 1:1:3
        nR = TVm(e,i);
        Unod(i,:) = Uvm(nR,:);
        Anod(i,:) = Avm(nR,:);
    end
    
    % U Limits:
    
    eULims(e,1,1) = min(Unod(:,1));
    eULims(e,1,2) = max(Unod(:,1));
    
    eULims(e,2,1) = min(Unod(:,2));
    eULims(e,2,2) = max(Unod(:,2));
    

end



% 2.- MEASURES AT POINTS:


AR = zeros(NVt,pudim); % real
AE = zeros(NVt,pudim); % estimated
rE = zeros(NVt,pudim); % rel. errors
aE = zeros(NVt,pudim); % abs. errors

nd = 4 ;

u = zeros(2,1);

ts = zeros(NVt,2); % for checkings

for i = 1:1:NVt
    
    u(:,1) = Ut(i,:);
    
	% interpolated (or estiamted) value:
    
	[ae, eR] = tr1348_interpTriLQ (u, Eiem, NE, TVm, Uvm, eULims, Avm, pudim, nd);
    AE(i,:) = ae(:,1);
    
    
	% real value:
    
	x = b2601_BNURBS_Xcoord (u, eKnotV, eNcp, eDegree, eUsize, eEw, eEP, eudim,xdim);
    
	a0 = [0.5 0.5 0.5];
    
	[ar, ~] = v2865b_onePoint (x, a0, pDegree, pNcp, pKnotV, pUsize, pP ,pw, pEP ,pEw, pCD, pULims, xdim, Xtol, DUtol);
    
	AR(i,:) = ar(1,:);
        

	% ERRORs:
        
	rE(i,1) = u(1) ;
	rE(i,2) = u(2) ;

    aE(i,1) = u(1) ;
	aE(i,2) = u(2) ;
   
    for di = 1:1:pudim    
        Aerr = (AR(i,di)-AE(i,di))^2;
    end
	Aerr = Aerr^0.5;
        

    Rerr = 100*abs(Aerr/Udiag);
    
    aE(i,3) = Aerr ;
	rE(i,3) = Rerr ;

    ts(i,1) = Aerr;
    ts(i,2) = i ;
 
end

ts = sortrows(ts,1);



end

