function [AR, AE, rE, aE] = fs0781_RnE_Acoords ...
    (Nsp, pR, Spatches, eKnotV, eNcp, eDegree, eUsize, eEw, eEP, NV, Avm, Uvm, NE, TVm, Eiem, eudim, pudim, xdim, Eadm, Udiag, Xtol, DUtol)

% RETURNS
% AE, AR: estimated and real coord's in patch param. space
% rE: plan coord's and relative errors
% aE: plan coord's and aboslute errors

pDegree = Spatches(pR,1).mRefin(1).mDegree ;
pNcp    = Spatches(pR,1).mRefin(1).mNcp ;
pKnotV  = Spatches(pR,1).mRefin(1).mKnotV ;
pUsize  = Spatches(pR,1).mRefin(1).mUsize;
pP      = Spatches(pR,1).mRefin(1).mP ;
pw      = Spatches(pR,1).mRefin(1).mw ;
pCD     = zeros(pudim,1);
[pEw,pEP] = GEN_12_ExpandBw (pw, pP,xdim, pudim, pNcp);  

pULims = [0 1 ; 0 1 ; 0 1 ];


% 1.- GOES THROUGH SAMPLE POINTS:

% 1.1.- No. sample points and steps.

stp = zeros(eudim,1);

for di = 1:1:2
    stp(di,1) = 1/(Nsp(di,1)-1);
end



AR = zeros(NV,pudim); % real
AE = zeros(NV,pudim); % estimated
rE = zeros(NV,pudim); % rel. errors
aE = zeros(NV,pudim); % abs. errors

% 1.2.- For each element: ULims and reference lenght:

L = zeros(NE,1);
eULims = zeros(NE,2,eudim);

for e = 1:1:NE
    
    % element corner nodes coord's:
    
    Unod = zeros(3,eudim);
    Anod = zeros(3,pudim);
    
    for i = 1:1:3
        nR = TVm(e,i);
        Unod(i,:) = Uvm(nR,:);
        Anod(i,:) = Avm(nR,:);
    end
    
    % U Limits:
    
    eULims(e,1,1) = min(Unod(:,1));
    eULims(e,1,2) = max(Unod(:,1));
    
    eULims(e,2,1) = min(Unod(:,2));
    eULims(e,2,2) = max(Unod(:,2));
    

end


% 1.3.- Loop on nodes:


nd = 4 ;

i = 0 ;
for u = 0:stp(1):1
    
    j = 0 ;
    i = i+1;
    
    for v = 0:stp(2):1

        j = j+1;
        

        % interpolated (or estiamted) value:
        [ae, eR] = tr1348_interpTriLQ ([u v]', Eiem, NE, TVm, Uvm, eULims, Avm, pudim, nd);
        
        AE(i,j,:) = ae(:,1);


        % real value:
        x = b2601_BNURBS_Xcoord ([u v'], eKnotV, eNcp, eDegree, eUsize, eEw, eEP, eudim,xdim);
        a0 = [0.5 0.5 0.5];
        [ar, ~] = v2865b_onePoint ...
     	(x, a0, pDegree, pNcp, pKnotV, pUsize, pP ,pw, pEP ,pEw, pCD, pULims, xdim, Xtol, DUtol);
        AR(i,j,:) = ar(1,:);
        
        
        % ERRORs:
        
        rE(i,j,1) = u ;
        rE(i,j,2) = v ;

       	aE(i,j,1) = u ;
        aE(i,j,2) = v ;
        
        for di = 1:1:pudim    
            Aerr = (AR(i,j,di)-AE(i,j,di))^2;
        end
        Aerr = Aerr^0.5;
        
        
        Rerr = 100*abs(Aerr/Udiag);
        
        aE(i,j,3) = Aerr ;
        rE(i,j,3) = Rerr ;
        

    end
    
end


end

