function [Spatches] = c0916_uP_elastic (yModel, Spatches, PatchPos, du, Npa, insR, Anty, MTL)

% RETURNS:
% update points after allocation of increment of force (and displacement): either GP's and nodes


for pa = 1:1:Npa
   
    
    xdim = Spatches(pa,1).Xdim;
    udim = Spatches(pa,1).Udim;
    
    
    % 1.- COMPUTES ELASTIC CONSISTENCY MATRIX:
    [D] = e2403_Dmatrix (yModel, Anty, MTL, 0, 0, 0, 0, 0, 0, udim);
    
    % 1.- CREATES 'hmA' ANCHORS: where copy only updated Xcoor with: portion * displacement
    
    %portion = 0.5;
    %[hmA, uiA] = f0914_AnchorsHalfD (Spatches, pa, insR, pxdim, uiA, du, portion);


    % 2.- EXTRACTS POINTS FOR COMFORT:
    
    Ngp = Spatches(pa,1).INS(insR).mIM.mNgp ;
    mGP = Spatches(pa,1).INS(insR).mIM.mGP ;
    
    nBS = Spatches(pa,1).INS(insR).nBS;

    % 3.- PATCH GAUSS POINTS:
    
    for g = 1:1:Ngp
         
        % defines point (Po) and extracts icps' and dRx of each anchor:
        
        Po = mGP(g);

        Nicp  = Po.mNicp;
        Ricp = Po.mRicp;  
        dRx   = Po.dRfi; 
        
        % deformation matrix & displacement vector of icps' of that point,
        % then computes stresses:
        
        [B] = s1013_Bmatrix (Nicp, [1:1:Nicp], dRx, xdim);
        [icpu] = c0953_icpU (Nicp, Ricp, du, PatchPos, pa, xdim);
        stv = D*B*icpu ;
        
        
        % allocates and clears Po object:
        
        mGP(g).mSv = stv;
        clearvars Po; 
        
    end

    % Transfers changed objects to Spatches and delete vbles: (NOT SURE ABOUT THIS!)

    Spatches(pa,1).INS(insR).mIM.mGP = mGP ;
    
    clearvars nGP mGP;
    

    % 4.- SKINS GAUSS POINTS:
    
    for sk = 1:1:nBS
        
        snGP = Spatches(pa,1).INS(insR).mBskin(sk).nGP;
        
        for g = 1:1:snGP
            
            Po = Spatches(pa,1).INS(insR).mBskin(sk).mGP(g);
            
            Nicp  = Po.mNicp;
            Ricp = Po.mRicpA;  
            dRx   = Po.dR_fi; 
            
            [B] = s1013_Bmatrix (Nicp, [1:1:Nicp], dRx, xdim);
            [icpu] = c0953_icpU (Nicp, Ricp, du, PatchPos, pa, xdim);
            stv = D*B*icpu ;
 
            % allocates and clears Po object:

            Spatches(pa,1).INS(insR).mBskin(sk).mGP(g).mSv = stv;
            clearvars Po; 
            
        end
        
        
    end
    
    
    

    
 
end


        





end

