function [z] = mp1352_TRImapp (Znod, Nne, rs, zdim)

% RETURNS:
% z(dim,1): coord mapped from parent space using r coord

% INPUTS:
% Znod(n,dim): phys. coords of nodes of the triangle
% n: No. nodes/triangle
% rs(2,1): parent coord of point to map
% zdim: No. dimension of phys. space

% 1.- Basis functions:

r = rs(1);
s = rs(2);
t = 1-r-s ;

N = zeros(Nne,1);

if Nne == 3
    
    N(1,1) = r;
    N(2,1) = s; 
    N(3,1) = t; 
    
elseif Nne == 6

    N(1,1) = r*(2*r-1) ;
    N(2,1) = s*(2*s-1) ;
    N(3,1) = t*(2*t-1) ; 

   	N(4,1) = 4*r*s ;
    N(5,1) = 4*s*t ; 
    N(6,1) = 4*r*t ; 
    
end


% 2.- Computes coordinate (mapping):

z = zeros(zdim,1);

for i = 1:1:Nne 
    
    for di = 1:1:zdim
        z(di,1) = z(di,1) + N(i,1)*Znod(i,di);
    end
end



end

