function [mBv, mUv, mAv, mXv] = th1324b_midCoords ...
    (li, metS, otpS, Xt, B0, U0, A0, mBv, mUv, mNCS, Spatches, pR, rTskin, agCurv, Xtol, DUtol)

cR = mNCS(1,1);
sR = mNCS(1,2);

cudim = 1 ;
sudim = 2 ;
pudim = 3 ;
xdim = 3 ;

if cR > 0

    cDegree = agCurv(cR).Degree;
    cNcp    = agCurv(cR).Ncp;
    cKnotV  = agCurv(cR).KnotV;
    cP      = agCurv(cR).P;
    cw      = agCurv(cR).w;
    cUsize  = agCurv(cR).Usize;
    cCD     = agCurv(cR).CD;
    cULims  = [ 0 1 ];

end

sDegree = rTskin(sR).mDegree;
sNcp    = rTskin(sR).mNcp;
sKnotV  = rTskin(sR).mKnotV;
sP      = rTskin(sR).mP;
sw      = rTskin(sR).mw;
sUsize  = rTskin(sR).mUsize;
sCD     = rTskin(sR).mCS;
[sEw,sEP] = GEN_12_ExpandBw (sw, sP, xdim, sudim, sNcp);
sULims  = [ 0 1 ; 0 1 ];
        
pDegree = Spatches(pR).INS(1).mDegree;
pNcp    = Spatches(pR).INS(1).mNcp;
pKnotV  = Spatches(pR).INS(1).mKnotV;
pP      = Spatches(pR).INS(1).mP;
pw      = Spatches(pR).INS(1).mw;
pUsize  = Spatches(pR).INS(1).mUsize;
pULims  = [0 1 ; 0 1 ; 0 1 ];
pEP     = Spatches(pR).INS(1).mEP;
pEw     = Spatches(pR).INS(1).mEw;
pCD     = [ 0 0 0 ];

if metS=="p" && otpS=="C" 
    
    % pp from Xt to curve, using B0 as starting point
    [mBv,~] = c2815b_onePoint (Xt', B0, cDegree, cNcp, cKnotV, cP ,cw, cULims, cCD, xdim, Xtol, DUtol);

    % X coord from curve:
    x = b2601_BNURBS_Xcoord (mBv, cKnotV, cNcp, cDegree, cUsize, cw, cP, cudim, xdim);
    mXv(1,:) = x(:,1);
    
    % pp to surface and solid:
    [mAv, ~] = v2865b_onePoint (x, A0, pDegree, pNcp, pKnotV, pUsize, pP ,pw, pEP ,pEw, pCD, pULims, xdim, Xtol, DUtol);
    [mUv, ~] = s2835b_onePoint (x, U0, sDegree, sNcp, sKnotV, sUsize, sP ,sw, sEP ,sEw, sCD, sULims, xdim, Xtol, DUtol);

elseif metS=="p" && otpS=="S" 
    
    mBv = zeros(1,1);
    
	% pp from Xt to surface, using U0 as starting point
    [mUv, ~] = s2835b_onePoint (Xt', U0, sDegree, sNcp, sKnotV, sUsize, sP ,sw, sEP ,sEw, sCD, sULims, xdim, Xtol, DUtol);
    
    % X coord from surface:
    x = b2601_BNURBS_Xcoord (mUv, sKnotV, sNcp, sDegree, sUsize, sEw, sEP, sudim, xdim);
    mXv(1,:) = x(:,1);
    
    % pp to solid:
    [mAv, ~] = v2865b_onePoint (x, A0, pDegree, pNcp, pKnotV, pUsize, pP ,pw, pEP ,pEw, pCD, pULims, xdim, Xtol, DUtol);
        
elseif metS=="d" && otpS=="C" 
    
	% X coord from curve:
    x = b2601_BNURBS_Xcoord (mBv, cKnotV, cNcp, cDegree, cUsize, cw, cP, cudim, xdim);
    mXv(1,:) = x(:,1);
    
    % pp to surface and solid:
    [mAv, ~] = v2865b_onePoint (x, A0, pDegree, pNcp, pKnotV, pUsize, pP ,pw, pEP ,pEw, pCD, pULims, xdim, Xtol, DUtol);
    [mUv, ~] = s2835b_onePoint (x, U0, sDegree, sNcp, sKnotV, sUsize, sP ,sw, sEP ,sEw, sCD, sULims, xdim, Xtol, DUtol);

  
elseif metS=="d" && otpS=="S" 
    
	mBv = zeros(1,1);
    
    % X coord from surface:
    x = b2601_BNURBS_Xcoord (mUv, sKnotV, sNcp, sDegree, sUsize, sEw, sEP, sudim, xdim);
    mXv(1,:) = x(:,1);
    
    % pp to solid:
    [mAv, ~] = v2865b_onePoint (x, A0, pDegree, pNcp, pKnotV, pUsize, pP ,pw, pEP ,pEw, pCD, pULims, xdim, Xtol, DUtol);
 
end


end

