function [Ncs, csR, liR, Nte, clR] = th1334_tetInv (contaL, ILn, NE, connT, THC)

% RETURNS: involved tet and the common side/edge

Ncs = 0 ;	% No. common sides (may be 0, 1 or 2)

% tets with common side ( Ncs > 0 )
csR = zeros(1,4);	% refs of tets, side ref., type intersection (t1,t2,csr,losF)

% tets with common edge (Ncs = 0 )
liR = 0 ;           % common line ref. Is the current edge to be split to account for missing line
Nte = 0 ;           % No. tets attached to liR
clR = zeros(2,1);   % tets attached to liR 


% INPUTS:
% ILn(2,2): reference of nodes of the missing line in tets (1st col) and in MLT (2nd col)


Av = THC.Av ;
Xv = THC.Xv ;

pudim = 3 ;

% 1.- PRE-SELECTS INVOLVED TETRAHEDRONS:
% tets attached to first and second nodes

teR = zeros(2,1); 
NteR = zeros(2,1);

for k = 1:1:2   
    
    conta = 0 ;   
    for j = 1:1:size(connT.VE,2)  

        if connT.VE(ILn(k,1),j)>0
            conta = conta + 1 ;
            teR(k,conta) = connT.VE(ILn(k,1),j);
            
            %{
            
            xdim = 3 ;
            fr = 81 ;
            
            tR = teR(k,conta) ;
            
            Xnod = zeros(4,xdim);
            
            for i = 1:1:4 
                nR = connT.EV(tR,i);
                Xnod(i,:) = Xv(nR,:);
            end
            
            pt1362_pTet (Xnod, xdim, fr, 0, 1.2);
            
            axis equal
            
            %}
            
        end
    end
    
    NteR(k,1) = conta ;
end


%%%%%%%%%%%%%%%%%%%%%%%%%%% %%%%%%%%%%%%%%%%%%%%%%%
% plots triangles
%{

trnsp = 0.667 ;

if contaL==4

    ptR = [ 1208 107 ] ;
    
    fr = 9 ;
    
    Anod = zeros(4,pudim);
    
    for k = 1:1:2
        
        eR = ptR(k);

        for j = 1:1:4
            nR = connT.EV(eR,j);
            Anod(j,:) = Av(nR,:);
        end
        
        pt1362_pTet (Anod, pudim, fr, trnsp, 1.2);
        
    end
    
    figure(fr)
    
	mLa = zeros(2,pudim);

    for j = 1:1:2
        mLa(j,:) = THC.Av(ILn(j,2),:);
    end

	plot3( mLa(:,1),  mLa(:,2), mLa(:,3),'r'); hold on
    
    %{
    for k = 1:1:2
    for i = 1:1:NteR(k)

        eR = teR(k,i);

        Anod = zeros(4,pudim);

        for j = 1:1:4
            nR = connT.EV(eR,j);
            Anod(j,:) = Av(nR,:);
        end

        fr = eR ;
        
        pt1362_pTet (Anod, pudim, fr, trnsp, 1.2);
        
     	figure(fr)
    
        mLa = zeros(2,pudim);

        for j = 1:1:2
            mLa(j,:) = THC.Av(ILn(j,2),:);
        end

        plot3( mLa(:,1),  mLa(:,2), mLa(:,3),'r'); hold on


    end
    end
    
%}

end

%}
%%%%%%%%%%%%%%%%%%%%%%%%%%% %%%%%%%%%%%%%%%%%%%%%%%


% 2.- SELECTS THOSE THAT SHARE SAME FACE:

for j = 1:1:NteR(1)
    
    % 2.1.- Tet. attached to first node: 't1'
    
    t1 = teR(1,j);

	% 2.2.- Searches tet. attached to 2nd node and :
 	% a - sharing face with t1,
  	% b - the missing line intersection belongs to the face triangle.
        
    for k = 1:1:NteR(2)
            
        t2 = teR(2,k);

        % checks sides refs:

        for s1 = 1:1:4

            s1r = connT.ES(t1,s1);

            for s2 = 1:1:4

                s2r = connT.ES(t2,s2);

            	% condition a :
                        
                if s1r == s2r

                    %{
            
                    xdim = 3 ;
                    fr = 82 ;

                    Xnod1 = zeros(4,xdim);
                    Xnod2 = zeros(4,xdim);
                    
                    for i = 1:1:4 
                        nR1 = connT.EV(t1,i);
                        nR2 = connT.EV(t2,i);
                        Xnod1(i,:) = Xv(nR1,:);
                        Xnod2(i,:) = Xv(nR2,:);
                    end

                    pt1362_pTet (Xnod1, xdim, fr, 0, 1.2);
                    pt1362_pTet (Xnod2, xdim, fr, 0, 1.2);
                    axis equal

                    %}
                    
                    % checks condition b:
                            
                   	[losF] = th1335_mLineSide (ILn, Av, s1r, connT.SV);
                            
                    if losF > 0 % 1 line within the face (1 in, 2 edge)
                            
                        Ncs = Ncs + 1 ;
                                
                        csR(Ncs,1) = t1 ;
                    	csR(Ncs,2) = t2 ;
                      	csR(Ncs,3) = s1r ;
                    	csR(Ncs,4) = losF ;      
                    	break      
                    end
                end          
            end
        end
    end
end





                    %{
            
                    xdim = 3 ;
                    fr = 83 ;

                    Xnod1 = zeros(4,xdim);
                    Xnod2 = zeros(4,xdim);
                    
                    for i = 1:1:4 
                        nR1 = connT.EV(csR(Ncs,1),i);
                        nR2 = connT.EV(csR(Ncs,2),i);
                        Xnod1(i,:) = Xv(nR1,:);
                        Xnod2(i,:) = Xv(nR2,:);
                    end

                    pt1362_pTet (Xnod1, xdim, fr, 0, 1.2);
                    pt1362_pTet (Xnod2, xdim, fr, 0, 1.2);
                    axis equal

                    %}



% 3.- SELECTS TETS SHARING the COMMON LINE (liR). ONLY IF Ncs=0
% liR is to be inserted new node, in next steps

if Ncs == 0
    
    L1 = zeros(6,1);
    
    % 3.1.- Finds line liR:
    
    % Finds the couple of tets that:
    % a.- have the involved nodes 'tn'
    % b.- have one line shared, with this line not containing any 'tn'
    
    
    for i = 1:1:NteR(1) % loop on tets attached to tn1
        
        t1 = teR(1,i);
        
        for k1 = 1:1:6
       	L1(k1,1) = connT.EL(t1,k1);
        end
        
        for j = 1:1:NteR(2) % loop on tets attached to tn2
            
            t2 = teR(2,j);
            % searches one common line (liR):
            % - liR is not to have nodes tn1 and tn2
            % - liR belongs to the same plane as missing line
            
            
            for k2 = 1:1:6
                
                Lr = connT.EL(t2,k2);
                
                for k1 = 1:1:6
                    
                    if Lr == L1(k1) && (connT.LV(Lr,1) ~= ILn(1,1) && connT.LV(Lr,1) ~= ILn(2,1)) % checks not containing tn
                        
                        cn = [ connT.LV(Lr,1); connT.LV(Lr,2) ]; % common line nodes

                        Anod = zeros(4,pudim);
                        for c = 1:1:2
                            Anod(c+0,:) = Av(ILn(c,1),:);
                            Anod(c+2,:) = Av(cn(c),:);
                        end

                        [PL,~,~,~,~] = go2505_cloudP_plane (4, Anod);

                        if PL == 1 % checks are in the same plane 
                            liR = Lr ;
                            break
                        end  
                    end
                end
                
                if liR>0
               	break 
                end
            end
            
            if liR>0
           	break 
            end
        end
        
        if liR>0
       	break 
        end
    end
    
    
    
    % 3.2.- Stores all tets attached to such line (liR):
    
    for e = 1:1:NE
        
        for k = 1:1:6
            
            Lr = connT.EL(e,k);
            if Lr == liR
                Nte = Nte + 1 ;
                clR(Nte,1) = e ;
            end
        end
        
    end
    


end




end

