function [LVcon, VLcon, ELcon, VEcon, NLId] = th1337_otherConn (agCurvE, Eskin, r, NE, NV, EVcon, Av, Xv, ALims, TTR, Xtol, DUtol)

% NLI(3): No. lines: TTR, bounded surfaces and the rest

% r(6,2): edges nodes references

xdim = 3 ;
udim = 3 ;

% 1.- Lines - vtx conn. matrices:

LVcon = zeros(1,3); % might be linear or quaratic, the latter witht he mid-nod in position 2 of LVcon

NLI = 0 ;

tNV = TTR.tNV ;
tTVcon = TTR.tTVcon ;
tVTcon = TTR.tVTcon ;
tLVcon = TTR.tLVcon ;
tVLcon = TTR.tVLcon ;
tTLcon = TTR.tTLcon ;
tAv = TTR.tAv ;
tANv = TTR.tANv ;
tANe = TTR.tANe ;
tXv = TTR.tXv ;
tXNv = TTR.tXNv ;
tXNe = TTR.tXNe ;

tSR  = TTR.tSR ;
tCR  = TTR.tCR ;

tNS  = TTR.tNS ;
tNC  = TTR.tNC ;

tUs  = TTR.tUs ;
tUc  = TTR.tUc ;

% 1.1.- first element:
 
for i = 1:1:6
    
    NLI = NLI + 1 ;
    
    n1 = EVcon(1,r(i,1));
    n2 = EVcon(1,r(i,2));
    

    % quadratic line check

    [qlF, Xmc] = th1338_quadrLine (agCurvE, Eskin, n1,n2, tNV, tNC, tNS, tCR, tSR, tUc, tUs, Xv, xdim, Xtol, DUtol);
    
    
    % adds mid-node if rquired:
    
    if qlF == 0
        
        LVcon(NLI,1) = n1;
        LVcon(NLI,2) = n2;
        
    elseif qlF == 1
        
        LVcon(NLI,1) = n1;
        
        LVcon(NLI,3) = n2;
        
    end
    

    
    
    % adds mid-node:
    
    if CR > 0
        
        
    elseif SR > 0
        
        
    end
    
    
    
    
    qlF = 0 ;
    if qlF == 0
        
        LVcon(NLI,1) = n1;
        LVcon(NLI,2) = n2;
        
    elseif qlF == 1
        
        Xm = zeros(xdim,1);
        Xm(:,1) = (Xv(n1,:) + Xv(n2,:))/2;
        
        
        
    end
    
    

    
    
    
end


% 1.2.- rest of the elements:

for e = 2:1:NE
    
    for i = 1:1:6
        
        % candidate couple of nodes:
        
        n1 = EVcon(e,r(i,1));
        n2 = EVcon(e,r(i,2));
        
        
        % check if they're IN already (aIN=1) and adds if not:
        
        aIN = 0 ;
        for j = 1:1:NLI
            
            if (LVcon(j,1)==n1 && LVcon(j,2)==n2) || (LVcon(j,2)==n1 && LVcon(j,1)==n2) 
                aIN = 1;
                break
            end
            
        end
        
        if aIN == 0
            
            NLI = NLI + 1 ;
            LVcon(NLI,1) = n1 ;
            LVcon(NLI,2) = n2 ;
            
        end
        
    end
end

% re-arranges to set first lines at trimming surfaces, then at bounded
% faces and then the rest:


NLIt = 0 ; % No lines that belong to TTR
NLIb = 0 ; % No. lines taht belong to bounded faces (and not to TTR)
NLIr = 0 ; % rest of the lines

LVcont = zeros(1,2);
LVconb = zeros(1,2);
LVconr = zeros(1,2);

NLI = size(LVcon,1);

a = zeros(2,udim);

tNLI = size(tLVcon,1);

for l = 1:1:NLI
    
    % lines coord's:
    
    nr1 = LVcon(l,1);
    nr2 = LVcon(l,2);
    
    for i = 1:1:2
        nr = LVcon(l,i);
        a(i,:) = Av(nr,:);
    end
    
    
    % checks if it is coincident with TTR line:
    flagT = 0 ;
    
    for tl = 1:1:tNLI
        
        tnr1 = tLVcon(tl,1);
        tnr2 = tLVcon(tl,2);
        
        if (tnr1 == nr1 && tnr2 == nr2) || ...
           (tnr1 == nr2 && tnr2 == nr1)    
           flagT = 1;
           break
        end
        
    end
    
    
    % checks if it is at boundary surface:
    
    a = round(a,3);
    
    flagB = 0;
    for di = 1:1:udim
        
        if  (a(1,di) == ALims(di,1) && a(2,di) == ALims(di,1)) || ...
            (a(1,di) == ALims(di,2) && a(2,di) == ALims(di,2)) 
            
            flagB=1;
        
        end
    end
    

    % allocates to correspodent group:
    
    %if LVcon(l,1)<=tNV && LVcon(l,2)<=tNV
    if flagT==1 
        NLIt = NLIt+1;
        for i = 1:1:2
            LVcont(NLIt,i) = LVcon(l,i);
        end
        
    elseif flagB==1
        
     	NLIb = NLIb+1;
        for i = 1:1:2
            LVconb(NLIb,i) = LVcon(l,i);
        end
        
    else
        
     	NLIr = NLIr+1;
        for i = 1:1:2
            LVconr(NLIr,i) = LVcon(l,i);
        end
    end
    
end

% reconstructs LVcon:
LVcon = [LVcont ; LVconb ; LVconr];

NLId = [NLIt; NLIb; NLIr];
NLI = sum(NLId);

% 2.- Vertex - lines:

VLcon = zeros(NV,1);

for l = 1:1:NLI
for i = 1:1:2
        
	vR = LVcon(l,i);

	addF = 0 ;
	for j = 1:1:size(VLcon,2)
            
        if VLcon(vR,j)==0
                
            VLcon(vR,j) = l ;
            break
                
        elseif j == size(VLcon,2)
                
        addF = 1 ;
                
        end
            
	end
        
	if addF == 1
        VLcon(vR,j+1) = l ;
	end  
end
end


% 3.- Tets - lines:

ELcon = zeros(NE,6);

for e = 1:1:NE
    
    contaL = 0 ;

    for i = 1:1:6
        
        n1 = EVcon(e,r(i));
        n2 = EVcon(e,r(i+1));
        
        for l = 1:1:NLI
            
            conta = 0;
            for j = 1:1:size(LVcon,2)
                
                if LVcon(l,j)==n1 || LVcon(l,j)==n2 
                    conta = conta + 1 ;
                end
                if conta==2
                    break
                end
            end
            
            if conta==2
                contaL = contaL + 1 ;
                ELcon(e,contaL) = l ;
                break
            end
            
        end
        
    end
    
end


% 4.- Vtx to triangles:

VEcon = zeros(NV,1);

nev = zeros(NV,1); % No. elms attached to each vtx

for e = 1:1:NE 

	for i = 1:1:3 
        
        vr = EVcon(e,i);
        
        nev(vr) = nev(vr)+1;
        
     	VEcon(vr,nev(vr)) = e ;
        
	end

end



end