function [mNIL, NIL] = th1339_Nien (Nts, tsR, rTskin, NV, NLI, LVcon, Av)

% RETURNS:
% NIL: No. non-included lines in the tetrahedralization, that are in the MLT
% mNIL(NIL,4): sR/L/tn1/tn2: surface ref., line reference, and both nodes of the line

pudim = 3 ;

NIL = 0 ;
mNIL = zeros(1,4); % rTskin and lines refs, and tet nodes involved (Nnit , sR/L/tn1/tn2)


nd = 3 ;

for s = 1:1:Nts
    
    sR = tsR(s);
    
    cLVcon = rTskin(sR,1).mLVcon; % "candidate"
    cAv    = rTskin(sR,1).mAv; 
    cNLI   = size(cLVcon,1);
    
    % checks the line (sR,L)
    for cL = 1:1:cNLI
        
        % candidate coordinates:
        
        cn1 = cLVcon(cL,1);
        cn3 = cLVcon(cL,3);
        
        cCd = zeros(2,pudim); % direct
        cCr = zeros(2,pudim); % reverse
        
        cCd(1,:) = cAv(cn1,:);
    	cCd(2,:) = cAv(cn3,:);
                
        cCr(2,:) = cAv(cn1,:);
    	cCr(1,:) = cAv(cn3,:);  
        
        % loop on tets to check if is IN or not:
        
        inF = 0 ; % in flag
        
        for L = 1:1:NLI
            
            n1 = LVcon(L,1);
            n2 = LVcon(L,2);
            
            % tets coordinates:
            
            tC = zeros(2,pudim);
            
            tC(1,:) = Av(n1,:);
            tC(2,:) = Av(n2,:);
            
            COd = go2541_coincidentM (tC, cCd, 2,pudim, nd);
            COr = go2541_coincidentM (tC, cCr, 2,pudim, nd);
            
            if COd==1 || COr==1
                inF = 1 ;
                break
            end
      
        end
 
        
        % if candidate is to store, checks the coordinates (coz might have been
        % stored previously at other rTskin, that might happen at contours lines)
        
        if inF == 0

            % searches if already stored:

            addF = 1 ;
            
            for i = 1:1:NIL

                % already stored coordinates:

                asR = mNIL(i,1);
                aLR = mNIL(i,2);

                aLVcon = rTskin(asR,1).mLVcon;
                aAv    = rTskin(asR,1).mAv;

                an1 = aLVcon(aLR,1);
                an3 = aLVcon(aLR,3);
                
                aC = zeros(2,pudim);
                aC(1,:) = aAv(an1,:);
                aC(2,:) = aAv(an3,:);


                % candidates coordinates:
                [CO1] = go2541_coincidentM (aC, cCd, 2,pudim, nd);
                [CO2] = go2541_coincidentM (aC, cCr, 2,pudim, nd);
                
                if CO1==1 || CO2==1
                    
                    addF = 0 ;
                    
                end
                
            end

            % adds if it was not already stored:
            
            if addF == 1
                
                NIL = NIL + 1 ;
                
                mNIL(NIL,1) = sR;
                mNIL(NIL,2) = cL;
                
                tCn = zeros(pudim,1);
                cCn1 = zeros(pudim,1);
                cCn2 = zeros(pudim,1);
                
                cCn1(:,1) = cCd(1,:);
                cCn2(:,1) = cCd(2,:);
                
                conta = 2 ;
                for n = 1:1:NV
                    
                    tCn(:,1) = Av(n,:); 
                    
                    CO1 = go2541_coincidentM (tCn, cCn1, pudim,1, nd);
                    CO2 = go2541_coincidentM (tCn, cCn2, pudim,1, nd);
                    
                    if CO1==1 || CO2==1
                        
                        conta = conta + 1 ;
                        mNIL(NIL,conta) = n;
                        
                        if conta == 4
                           break 
                        end
                    end
                end

            end


        end
  
    end

end




end

