function [EVcon, chF] = li1633_DouCap (contaSL, aeR, connT, Av)

% RETURNS:
% EVcon updated to account for axis flip if the worst of the four 
% involved elements improve
% chF = 1 if change happens

% INPUTS:
% aeR(4,1): affected elements refs:

pudim = 3 ;

EVcon = connT.EV ;
chF = 0 ;



% 1.- CHECKS IF FLIPPING IS DOABLE:


% 1.1.- No. elements:

Ne = size(aeR,1);

if Ne ~= 4
    return
end


% 1.2.- Common line for the 4 elements:

LR = 0 ;

eR1 = aeR(1,1);

for L1 = 1:1:6
    
    r1 = connT.EL(eR1,L1);
    
    conta = 0 ;
    
    for e = 2:1:Ne
        
        eR = aeR(e,1);
        
        for L2 = 1:1:6
            
            r2 = connT.EL(eR,L2);
            if r1 == r2
                conta = conta + 1 ;
                break
            end
        end
        
    end
    
    if conta == 3
        LR = r1 ;
        break
    end
    
end

if LR == 0
    return
end


% 1.3.- No. nodes:
anRx = [ connT.LV(LR,1) ; connT.LV(LR,2) ];
fnR = zeros(1,1); % 'free nodes', must be = 4 to continue this routine

conta = 0 ;

for e = 1:1:Ne
    
    eR = aeR(e,1);
    
    for k = 1:1:4
        
        nR = connT.EV(eR,k);
        
        if nR ~= anRx(1) && nR ~= anRx(2)
            conta = conta + 1 ;
            fnR(conta,1) = nR ;
        end
    end
 
end

[fnR,~] = GEN_16_RemoveRepeatedRows (fnR, 1, 0.1);


if size(fnR,1) ~= 4
   return 
end

% 1.4.- Carries on:

EVcon = connT.EV ;
dim = 3 ;


% 2.- FINDS OUT EACH PAR OF NODES ATTACHED TO EACH AXIS (3 No. ARRANGEMENTS):

% 2.1.- Axis X: current

anRx = [ connT.LV(LR,1) ; connT.LV(LR,2) ] ; % attached nodes to LR (axis X)


% 2.2.- Alternative axis Y:

anRy = zeros(2,1);

% Alternative axis Y: selects free node 1 and finds the other free node that do not share any element

nR1 = fnR(1);
anRy(1) = nR1 ;

eR1 = zeros(1,1);
n1 = 0 ;

for i = 1:1:size(connT.VE,2)
    
    eR = connT.VE(nR1,i);
    
    if eR > 0
        n1 = n1 + 1 ;
        eR1(n1,1) = eR ; % elements attached to node nR1
    end
end


for k = 2:1:4
    
    stF = 0 ; % stop flag
    
    nR = fnR(k);
    
    for i = 1:1:size(connT.VE,2)
        
        eR = connT.VE(nR,i);
        
        if eR > 0
        for j = 1:1:n1
            
            if eR == eR1(j)
                stF = 1 ;
             	break
            end
            
        end
        end
        
        if stF == 1
           break 
        end
    end
    
    if stF == 0
        anRy(2) = nR ;
        break
    end
end


% 2.3.- Alternative axis Z:

anRz = zeros(2,1);

conta = 0 ;
for i = 1:1:4
    
    if fnR(i) ~= anRy(1) && fnR(i) ~= anRy(2)
        conta = conta + 1 ;
        anRz(conta,1) = fnR(i);
    end
    
end


% 3.- CHECKS THE THREE CONFIGURATIONS AND SELECTS THE ONE WITH HIGHEST min(R):

% the 3rd configuration is the original

EVt(3,1) = struct('m',[]);

EVt(1,1).m = [
    anRy(1) anRz(1) anRz(2) anRx(1);
    anRy(1) anRz(1) anRz(2) anRx(2);
    anRy(2) anRz(1) anRz(2) anRx(1);
    anRy(2) anRz(1) anRz(2) anRx(2)];

EVt(2,1).m = [
    anRx(1) anRy(1) anRy(2) anRz(1);
    anRx(1) anRy(1) anRy(2) anRz(2);
    anRx(2) anRy(1) anRy(2) anRz(1);
    anRx(2) anRy(1) anRy(2) anRz(2)];

EVt(3,1).m = [
    anRz(1) anRx(1) anRx(2) anRy(1);
    anRz(1) anRx(1) anRx(2) anRy(2);
    anRz(2) anRx(1) anRx(2) anRy(1);
    anRz(2) anRx(1) anRx(2) anRy(2)];


Rc = zeros(3,1);


% 4.- SELECTS THE ONE WITH MAX Rc:

for i = 1:1:3

    Rt = zeros(4,1);

    for e = 1:1:Ne

        Anod = zeros(4,dim);
        
        for j = 1:1:4
            
            nR = EVt(i,1).m(e,j);
            Anod(j,:) = Av(nR,:);
            
        end

        Rt(e,1) = th1319_tetR (Anod);

        % pt1362_pTet (Anod, pudim, 200+i, 'r', 1, 1, 0); hold on
        
    end

    Rc(i,1) = min(Rt);

end


% 5.- CHANGES IF NECESSARY:

mRc = max(Rc);

if mRc == Rc(3)
    return % No. changes
end


sc = 0 ; % selected configuration

for i = 1:1:2
    if mRc == Rc(i)
        sc = i ; 
    end
end


chF = 1 ;


for e = 1:1:Ne
    
    eR = aeR(e,1);
    
    for i = 1:1:4
        EVcon(eR,i) = EVt(sc,1).m(e,i);
    end
    
end



end

