function [clF, connT, pNE, THC, MLT] = ei1645_CLCase ...
     (contaL, connT, pNE, THC, MLT, Spatches, pR, rTskin, agCurv, ILn, IP, ilR, atR, Nat, Xtol, DUtol, tolL, tolA, nd)

% RETURNS:
% clF = 1 if one common edge is inters'd, otherwise = 0
% connT, pNE, THC, MLT: updated if insertion happens


% 1.- DETECTS IF ilR BELONGS TO ALL THE TETS:

for k = 1:1:Nat
    
    tR = atR(k);
    
    deF = 1 ; % flag of element with diff lines refs
    for s = 1:1:6
        
        lR = connT.EL(tR,s);
        if lR == ilR
            deF = 0 ;
            break
        end
        
    end
    
    if deF==1
        
        clF = 0 ; % if one tet has not that line, this routine does not apply
        return
        
    end

end


% 2.- PROJECTS THE INTERSECTION ON THE MLT:

[eTHC] = ts1603_mPpp (contaL, Spatches, pR, rTskin, agCurv, ILn, IP, THC, Xtol, DUtol);



% 3.- CHECKS IT THE PROJECTD POINT STILL LIES WITHIN THE AFF'D TETS:

pudim = 3 ;

Ap = eTHC.Av;
Anod = zeros(4,pudim);

clF = 0 ; % if lies within one thet the process carry on

for k = 1:1:Nat
    
    eR = atR(k);
    
    for i = 1:1:4
        nR = connT.EV(eR,i);
        Anod(i,:) = THC.Av(nR,:);
    end
    
    %%%%%%%%% %%%%%%%%% %%%%%%%%%
    %{
    if contaL == 12
        
        figure(contaL)
        pt1373_pTetConn (eR, connT, THC.Av, contaL, 'k', 0.8, 1.25, 0);
        scatter3(Ap(1),Ap(2),Ap(3),'r'); hold on
        
    end
    %}
    
    [IN, ~, ~, ~, ~] = go2539_PinTet (Anod, Ap, nd);
    
    if IN > 0
        clF = 1 ; 
        break
    end
    
end

if clF == 0
    return
end
   

%%%%%%%%% %%%%%%%%% %%%%%%%%%
% plots tets and point
%{

fr = contaL ;
figure(fr);

for k = 1:1:Nat
    eR = atR(k);
    pt1373_pTetConn (eR, connT, THC.Av, fr, 'k', 0.8, 1.25, 0);
end

[rv, rP1, rP2] = ts1602_mLAspace (ILn, THC.Av);

x = [ rP1' ; rP2' ] ;

plot3 ( x(:,1) ,  x(:,2) , x(:,3) ,'r'); hold on

scatter3(IP(1), IP(2), IP(3), 'r'); hold on
scatter3(eTHC.Av(1), eTHC.Av(2), eTHC.Av(3), 'b'); hold on

%}



% 4.- Adds new point to tets:

THC.Bv = [THC.Bv ; eTHC.Bv];
THC.Uv = [THC.Uv ; eTHC.Uv'];
THC.Av = [THC.Av ; eTHC.Av'];
THC.Xv = [THC.Xv ; eTHC.Xv'];
THC.NCS = [THC.NCS ; eTHC.NCS];


% 5.- SPLITS AFF'D TETS INTO TWO, BY THE PROJECTED POINT AT EDGE:

meR = atR(1); % 'main' element ref (not adjacents), any of atR is valid

neR = [connT.LV(ilR,1) ; connT.LV(ilR,2)];

[llR] = ts1620_LedgeR (connT, neR, meR) ; % local ref of intersected line


%%%%%%%%% %%%%%%%%% %%%%%%%%%
%{

fr = contaL;
pt1373_pTetConn (meR, connT, THC.Av, fr, 'r', 0.2, 3, 0);

for i = 1:1:4
    
    nR = connT.EV(meR,i);
    text( THC.Av(nR,1), THC.Av(nR,2), THC.Av(nR,3), num2str(i)); hold on

end


%}


[pNE, connT] = ei1660_edgeInt (pNE, connT, THC, meR, llR);
  


%%%%%%%%% %%%%%%%%% %%%%%%%%%
% plots updated situation
%{

fr = contaL+1 ;
figure(fr);

OpNE = pNE - Nat ;

accE = 1 ;
for k = 1:1:Nat
    
    eR = atR(k);
    pt1373_pTetConn (eR, connT, THC.Av, fr, 'k', 0.8, 1.25, 0);
    
    eR = OpNE + accE;
    pt1373_pTetConn (eR, connT, THC.Av, fr, 'k', 0.8, 1.25, 0);
    
    accE = accE + 1 ;
end

scatter3(eTHC.Av(1), eTHC.Av(2), eTHC.Av(3), 'b'); hold on

if gg==1
end

%}




% 6.- UPDATES MLT:

eAt = eTHC.At ;

[MLT] = um0660_inNodMLT (MLT, eTHC, eAt, tolL, tolA, nd);



end

