function [eTHC] = ts1603_mPppmod ...
(contaL, Spatches, pR, rTskin, agCurv, THC, csM, ...
 At, ILn, mP, Xtol, DUtol)









cudim = 1 ;
sudim = 2 ;
pudim = 3 ;
xdim  = 3 ;

pDegree = Spatches(pR).INS(1).mDegree;
pNcp    = Spatches(pR).INS(1).mNcp;
pKnotV  = Spatches(pR).INS(1).mKnotV;
pP      = Spatches(pR).INS(1).mP;
pw      = Spatches(pR).INS(1).mw;
pUsize  = Spatches(pR).INS(1).mUsize;
pULims  = [0 1 ; 0 1 ; 0 1 ];
pEP     = Spatches(pR).INS(1).mEP;
pEw     = Spatches(pR).INS(1).mEw;
pCD     = [0 0 0 ];

eTHC = struct ...
('Xv',[], 'Av',[], 'Uv',[], 'Bv',[], 'NCS',[], 'ANv',[], 'At',[]);

% Note: eTHC.At(pudim,1) are the coords of the point before propjection
% ontro MLT. eTHC.At is used to localize the triangle of MLT to update

% X.- CURVES AND SURFACES ATTACHED: 
%{
tn = [ ILn(1,1) ; ILn(2,1) ] ; % nodes involved, in tets refs

cs = zeros(2,2); % T-curves and T-surfaces attached to these tet nodes

for v = 1:1:2
    cs(v,1) = THC.NCS(tn(v),1); 
    cs(v,2) = THC.NCS(tn(v),2);
end

sR = THC.NCS(tn(1),2); % surface ref
  
%}  

sR = csM(1,2);

sDegree = rTskin(sR).mDegree;
sNcp    = rTskin(sR).mNcp;
sKnotV  = rTskin(sR).mKnotV;
sP      = rTskin(sR).mP;
sw      = rTskin(sR).mw;
sUsize  = rTskin(sR).mUsize;
sCD     = rTskin(sR).mCS;
[sEw,sEP] = GEN_12_ExpandBw (sw, sP, xdim, sudim, sNcp);
sULims  = [ 0 1 ; 0 1 ];
    
    
% 3.1.- MISSING LINE BELONGS TO ONE SURFACE OF MLT:
    
if cs(1,1) > 0 && cs(2,1) > 0

        % -.- Belongs to a contour curve 'cR'

        tnm = min(tn);
        
        cR  = THC.NCS(tnm,1);

        cDegree = agCurv(cR).Degree;
        cNcp    = agCurv(cR).Ncp;
        cKnotV  = agCurv(cR).KnotV;
        cP      = agCurv(cR).P;
        cw      = agCurv(cR).w;
        cUsize  = agCurv(cR).Usize;
        cCD     = agCurv(cR).CD;
        cULims  = [ 0 1 ];
        

            At = mP;
            Xt = b2601_BNURBS_Xcoord (At, pKnotV, pNcp, pDegree, pUsize, pEw, pEP, pudim, xdim);
            
            % pp from Xt to curve, using B0 as starting point
            B0 = (THC.Bv(tn(1),1) + THC.Bv(tn(2),1)) / 2 ;
            [B,~] = c2815b_onePoint (Xt, B0, cDegree, cNcp, cKnotV, cP ,cw, cULims, cCD, xdim, Xtol, DUtol);

            % physical coordinates:
            X = b2601_BNURBS_Xcoord (B, cKnotV, cNcp, cDegree, cUsize, cw, cP, cudim, xdim);
            
            % pp from X to surface:
            U0 = (THC.Uv(tn(1),:) + THC.Uv(tn(2),:)) / 2 ;
            [U, ~] = s2835b_onePoint (X, U0, sDegree, sNcp, sKnotV, sUsize, sP ,sw, sEP ,sEw, sCD, sULims, xdim, Xtol, DUtol);
            U = U';
            
         	% pp from X to patch:
            A0 = At' ;
            [A, ~] = v2865b_onePoint (X, A0, pDegree, pNcp, pKnotV, pUsize, pP ,pw, pEP ,pEw, pCD, pULims, xdim, Xtol, DUtol);
            A = A';
            

else
        
        % -.- Belongs to a trimming surface 'sR':

            cR = 0 ;
        
            B = 0 ;
        
            At = mP;
            Xt = b2601_BNURBS_Xcoord (At, pKnotV, pNcp, pDegree, pUsize, pEw, pEP, pudim, xdim);
            
            % pp from X to surface:
            U0 = (THC.Uv(tn(1),:) + THC.Uv(tn(2),:)) / 2 ;
            [U, ~] = s2835b_onePoint (Xt, U0, sDegree, sNcp, sKnotV, sUsize, sP ,sw, sEP ,sEw, sCD, sULims, xdim, Xtol, DUtol);
            U = U';
            
          	% physical coordinates:
            X = b2601_BNURBS_Xcoord (U, sKnotV, sNcp, sDegree, sUsize, sEw, sEP, sudim, xdim);
            
        	% pp from X to patch:
            A0 = At' ;
            [A, ~] = v2865b_onePoint (X, A0, pDegree, pNcp, pKnotV, pUsize, pP ,pw, pEP ,pEw, pCD, pULims, xdim, Xtol, DUtol);
            A = A';
            
end
   

% allocates:
            
eTHC.Bv = B ;
eTHC.Uv = U ;
eTHC.Av = A ;
eTHC.Xv = X ;
eTHC.NCS = [cR sR];

eTHC.At = At ;

end

