function [MLT, THC, pNE, connT] = ts1620_Linsert...
         (contaL, pR, Spatches, rTskin, agCurv, MLT, ILn, ieR, Nte, teR, THC, pNE, connT, Xtol, DUtol)
    
% RETURNS:
% updates MLT, THC, pNE, connT to account for new end-node


% 1.- NEW NODE TO BE INSERTED:

[eTHC, mltF] = th1321_iCoords (pR, Spatches, rTskin, agCurv, ILn, THC, Xtol, DUtol);


% 2.- ADDS THE NEW END-NODE (AT THE END):

THC.Bv = [ THC.Bv ; eTHC.Bv ] ;
THC.Uv = [ THC.Uv ; eTHC.Uv ] ;
THC.Av = [ THC.Av ; eTHC.Av ] ;
THC.Xv = [ THC.Xv ; eTHC.Xv ] ;

THC.NCS = [ THC.NCS ; eTHC.NCS ] ;
THC.ANv = [ THC.ANv ; eTHC.ANv ] ; % is computed afterwards in MLT

% [connT, Av, Xv, nr] = th1322_upAX (connT, Av, Xv, eAv, eXv, ILn, mnF, pNE);


% 3.- INSERTS WITHIN TET-MESH:

% - all involved tets are halved
% - the line liR is removed, the others are kept
% - connT.EV is updated and then rest of connT

[connT, pNE, uNte, uteR] = th1323_upTet (THC.Av, connT, pNE, teR, Nte, ieR);


% plots updated tets:
%{
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  %%%%%%%%%%%%%%%%%%%%%


pudim = 3 ;

fr = contaL ;

figure(fr)

for e = 1:1:uNte
        
	eR = uteR(e,1);
        
	Anod = zeros(4,pudim);
        
 	for k = 1:1:4
    	nR = connT.EV(eR,k);
      	Anod(k,:) = THC.Av(nR,:);
    end
        
	pt1362_pTet (Anod, pudim, fr, 0.9, 0.1); 
        
end
    
axis equal



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  %%%%%%%%%%%%%%%%%%%%%

%}


% 4.- UPDATES MLT: in case of new node lies on MLT

pudim = 3 ;

if mltF == 1
    
    [MLT] = um0621_upMLT (MLT, ILn, eTHC);
    
    NV = size(THC.ANv,1);
    tNV = MLT.tNV;
    
    for di = 1:1:pudim
        THC.ANv(NV,di) = MLT.tANv(tNV,di) ;
    end
   
end




end

