function [connT] = ts1630_AxisFlip (connT, MLT, meR, Av)

% RETURNS:
% connT: updated in case 4 tets axis is flipped to improve regularity of the tets

% INPUTS:
% connT, connS, MLT: just after insertion
% aeR(x,1): affected TETS elements refs


% new arrangement cannot change a line from TETs that is already contained in MLT


% 1.- IDENTIFIES IF IS SUSCEPTIBLE:
% There are 4 No. elements surrounding one line

n = size(aeR,1); % No. affected elements

if n ~= 4
    return
end


% 2.- IF 4 ELEMES, CHECK ARRANGEMENT:

% There must be four shared sides.

asr = zeros(4,1);
conta = 0 ;

for e = 1:1:n

    fF = 0 ;
    em = aeR(e,1);

    for s1 = 1:1:4

        sR1 = connT.ES(em,s1);

        for k = 1:1:n

            eR = aeR(k,1);

            if eR ~= em

                for s2 = 1:1:4

                    sR2 = connT.ES(eR,s2);

                    if sR1 == sR2
                        
                        conta = conta + 1 ;
                        
                        asr(conta,1) = sR1 ;
                        
                        fF = 1 ;
                        break
                    end

                end

            end

            if fF==1
               break 
            end
            
        end

        if fF==1
            break 
        end
        
    end
end


if conta < 4
    return
end

if hh==0
end

% 3.- FINDS THE THREE AXIS:
% Two nodes ref per axis.

[connS,~,~] = th1381_connS (pNE, connT);

xnR = zeros(3,2); % three axis

% axis 1 nodes (first placed) are shared by asr

contaP = 0 ;
for i = 1:1:3
    
    nR1 = connS.SV(asr(1),i);
    
    conta = 0 ;
    
    for s = 2:1:4
        
        for k = 1:1:3
            
            nR2 = connS.SV(asr(s),k);
            
            if nR1 == nR2
                conta = conta + 1;
            end
            
        end
    end
    
    if conta == 3
        
        % axis 1 node:
        
        contaP = contaP + 1 ;
        xnR(1,contaP) = nR1;

    end
    
end


% axis 2 and 3 nodes (the free nodes of axis 1)

tm = zeros(4,1);

for s = 1:1:4
    
    for i = 1:1:3
        
        nR = connS.SV(asr(s),i);
        
        if nR~=xnR(1,1) && nR~=xnR(1,2)
            tm(s,1) = nR;
            break
        end
    end
    
end


xnR(2,1) = tm(1,1);
xnR(2,2) = tm(1,3);

xnR(3,1) = tm(1,2);
xnR(3,2) = tm(1,4);



% 4.- CHECKS THE AXIS 1 IS NOT A MLT LINE.

if jj==0
end


% 5.- CHECKS THE THREE ARRANGEMENTS:




% 6.- SELECTS THE ARRANGEMENT WITH THE HIGHEST MINIMUM R:


% measures regularity:

[Rt] = ts1606_Rtets (n, aeR, connT, Av);



end

