function [tsF] = ts1631_TtsF (pR, connT, MLT, THC)

% RETURNS:
% tsF(NL,1) = 1 if the tet line lies on MLT also


NL = size(connT.LV,1);

tsF = zeros(NL,1);

rL = [1:1:MLT.tNL]'; % remaining MLT lines to search

for i = 1:1:NL

    % candidate nodes of TET line:
    n1 = connT.LV(i,1);
    n2 = connT.LV(i,2);

    % searches and updates tsF:
    [tsF, rL] = ts1635_find1 (i, THC, MLT, n1, n2, tsF, rL);

end


% plots (only for checking purposes:

%{
if pR==2

    for i = 1:1:NL
    if tsF(i,1) > 0

    pt1375_pLinConn (i, connT, THC.Av, 2, 'r', 0.8, 1.2);

    end
    end

    if kk==0
    end

end
%}



end

