function [tsF] = ts1632_upTtsF (connT, THC, MLT, Nat, atR)

% RETURNS:
% tsF updated with integrated MLT missing line mLR

% INPUTS:
% atR(Nat,1): affected tets in the update


% 1.- UPDATES THE tsF SIZE:

tsF = connT.tsF;


s = size(tsF,1);

NL = size(connT.LV,1);


if NL > s

    a = NL-s;
    tsF = [ tsF ; [1:1:a]' ];

end



% 2.- GATHERS ALL THE AFFECTED LINES:

alR = zeros(1,1);
conta = 0;

for e = 1:1:Nat
    
    eR = atR(e,1);
    
    for i = 1:1:6
        conta = conta + 1 ;
        alR(conta,1) = connT.EL(eR,i);
    end
 

    
end

[alR,~] = GEN_16_RemoveRepeatedRows (alR, 1, 0.1);

NaL = size(alR,1);




% 3.- SEARCHES:

rL = [1:1:MLT.tNL]'; % remaining MLT lines to search

for i = 1:1:NaL

    lR = alR(i,1);
    
    % candidate nodes of TET line:
    n1 = connT.LV(lR,1);
    n2 = connT.LV(lR,2);

    % searches and updates tsF:
    [tsF, rL] = ts1635_find1 (lR, THC, MLT, n1, n2, tsF, rL);

end



end

