function [pNE, connT, THC, MLT] = ts1651_splitSide (contaL, ILn, ipS, uNip, uip, teR, pNE, connT, connS, THC, MLT)


pudim = 3 ;

eTHC = struct('Xv',[], 'Av',[], 'Uv',[], 'Bv',[], 'NCS',[], 'ANv',[]);

eTHC.Xv = uip(1).Xi' ;
eTHC.Av = uip(1).Ai' ;
eTHC.Uv = uip(1).Ui' ;
eTHC.Bv = uip(1).Bi' ;
eTHC.NCS = uip(1).NCSi ;

% 1.- FINDS THE SIDE WHERE INT-POINT LIES IN (in global ref):
    
ctR = teR(uNip+2);  % current tet 
cLsR = ipS(2);       % local ref of the side of current tet where the intermediate node lies in
    
% 1.1.- Nodes of the side in global reference:
[nsR] = ts1652_LsideGnodes (cLsR, ctR, connT);
    
% 1.2.- Side ref (global ref, i.e. ref in connS and connT):
[sR] = ts1617_GsideR (connT, connS, nsR, ctR);



% 2.- FINDS ADJACENT TET (in global ref):

atR = 0 ;

for k = 1:1:2
        
    if connS.SE(sR,k)~= ctR
        atR = connS.SE(sR,k);
    end

end
    
%%%%%%%%%%%%%%%%%% %%%%%%%%%%%%%%%%%%%%%%
% plots side
%{

fr = contaL ;  
pt1374_pSidConn (sR, connS, THC.Av, fr, 'm', 1, 2.2);

%}

% 3.- SPLIT BOTH TETS (ctR & atR) INTO THREE (each into 3) :
% Updates THC, connT and MLT

% 3.1.- THC:

THC.Xv = [ THC.Xv ; uip(1).Xi' ] ;
THC.Av = [ THC.Av ; uip(1).Ai' ] ;
THC.Uv = [ THC.Uv ; uip(1).Ui' ] ;
THC.Bv = [ THC.Bv ; uip(1).Bi' ] ;
THC.NCS = [ THC.NCS ; uip(1).NCSi ] ;

nnR = size(THC.Xv,1); % new node ref.

% normal to node is computed averaging the adjacent nodes, weighted with
% distances:

THC.ANv = [ THC.ANv ; zeros(1,pudim) ] ; % updated after MLT

%{
if THC.NCS(nnR,2) > 0
    
    ANi = zeros(1,pudim);
    accd = 0 ;
    
    for k = 1:1:3
        
        r = nsR(k);
        
        if THC.NCS(r,2) > 0 % only computes nodes at surface
            
            d = norm(THC.Av(nnR,:) - THC.Av(r,:));
            accd = accd + d ;
            
            for di = 1:1:pudim
                ANi(1,di) = ANi(1,di) + THC.ANv(r,di) * d ;
            end
        end
    end

    ANi = ANi / accd ;
    THC.ANv(nnR,:) = ANi(1,:);

end
%}

% 3.2.- Connectivity matrix connT and No. elements:

% -.- Current element (recall that lsR is the side to split):

[pNE, connT] = ts1652_TetDiv3 (pNE, connT, ctR, nnR, cLsR);



% -.- Adjacent element:

[aLsR] = ts1618_LsideR (connT, nsR, atR); % local side ref in adjacent tet

[pNE, connT] = ts1652_TetDiv3 (pNE, connT, atR, nnR, aLsR);

 
% 3.3.- Updates MLT:

[MLT] = um0621_upMLT (MLT, ILn, eTHC);
    
NV = size(THC.ANv,1);
tNV = MLT.tNV;
    
for di = 1:1:pudim
	THC.ANv(NV,di) = MLT.tANv(tNV,di) ;
end
    

end

