function [eTHC, Ne, eR, neR] = ts1696_CorrCS ...
    (deR, THC, MLT, connT, gN, gL, CPp, Spatches, pR, rTskin, agCurv, Xtol, DUtol)

% SLIVER SUB-CASE:

pudim = 3 ;
xdim = 3 ;

pDegree = Spatches(pR).INS(1).mDegree;
pNcp    = Spatches(pR).INS(1).mNcp;
pKnotV  = Spatches(pR).INS(1).mKnotV;
pP      = Spatches(pR).INS(1).mP;
pw      = Spatches(pR).INS(1).mw;
pUsize  = Spatches(pR).INS(1).mUsize;
pULims  = [0 1 ; 0 1 ; 0 1 ];
pEP     = Spatches(pR).INS(1).mEP;
pEw     = Spatches(pR).INS(1).mEw;
pCD     = [ 0 0 0 ];


% 1.- SELECTION OF LINE TO REMOVE:

sLR = 0 ; % selected line to remove, and to stay, in local refs (1 or 2)
sLS = 0 ;

nGR = zeros(2,1); % nodes to remove and to stay in global ref.
nGS = zeros(2,1);

% 1.1.- Chooses to remove the line with both nodes not in MLT:

if (THC.rm(gN(1)) > 0 && THC.rm(gN(2)) > 0) && (THC.rm(gN(3)) == 0 && THC.rm(gN(4)) == 0)
    
    sLR = 1 ;
    sLS = 2 ;
    
    nGR = [ gN(1); gN(2)];
    nGS = [ gN(3); gN(4)];
    
elseif (THC.rm(gN(1)) == 0 && THC.rm(gN(2)) == 0) && (THC.rm(gN(3)) > 0 && THC.rm(gN(4)) > 0)
    
    sLR = 2 ;
    sLS = 1 ;
    
    nGR = [ gN(3); gN(4)];
    nGS = [ gN(1); gN(2)];
    
end


% 1.2.- If the pair of lines are in or OUT the MLT, removes the longest:

if sLR==0
    
    L1 = zeros(2,pudim);
    L2 = zeros(2,pudim);
    
    for i = 1:1:2
        L1(i,:) = THC.Av(gN(0+i),:);
        L2(i,:) = THC.Av(gN(2+i),:);
    end
    
    L1 = norm( L1(2,:) - L1(1,:) );
    L2 = norm( L2(2,:) - L2(1,:) );

    if L1 > L2
        sLR = 1 ;
        sLS = 2 ;

        nGR = [ gN(1); gN(2)];
        nGS = [ gN(3); gN(4)];
    else
        sLR = 2 ;
        sLS = 1 ;

        nGR = [ gN(3); gN(4)];
        nGS = [ gN(1); gN(2)];
    end
end

% nodes of involved lines, first line to stay, then line to remove

neR = [ nGS(1), nGS(2);
        nGR(1), nGR(2)];
    

% 2.- NEW NODE COORD: eTHC

% 2.1.- Proportion from nodes 1 and 2:

d1 = THC.Av(nGS(1),:) - CPp(sLS,:);
d2 = THC.Av(nGS(2),:) - CPp(sLS,:);

d1 = norm(d1);
d2 = norm(d2);

N1 = d2 / (d1+d2);
N2 = d1 / (d1+d2);




% 2.2.- Check if line to stay is MLT:

rm = [ THC.rm(nGS(1)) ; THC.rm(nGS(2)) ];

mLR = 0 ; % ref of MLT line

if rm(1) > 0 && rm(2) > 0
    
    % searches a MLT line with both nodes:

    for i = 1:1:size(MLT.tVLcon,2)
        
        r = MLT.tVLcon(rm(1),i);
        if r > 0
            
            if MLT.tLVcon(r,1) == rm(2) || MLT.tLVcon(r,2) == rm(2)
                mLR = r ;
                break
            end
        end
    end
end


% 2.3.- Case mLR exists:

if mLR > 0

    ILn = [ nGS(1) rm(1) ;
            nGS(2) rm(2) ];

    [mn, B0, U0, A0, csM] = ts1615_info2proj (ILn, THC);

    B0(:,1) = N1 * THC.Bv(nGS(1),:) +  N2 * THC.Bv(nGS(2),:);
    U0(:,1) = N1 * THC.Uv(nGS(1),:) +  N2 * THC.Uv(nGS(2),:);
    A0(:,1) = N1 * THC.Av(nGS(1),:) +  N2 * THC.Av(nGS(2),:);
    
    eTHC = ts1614_inMidU (0, Spatches, pR, mLR, mn, rTskin, agCurv, csM, MLT, U0, A0, Xtol, DUtol);

end


% 2.4.- Case mLR does not exist: just at selected A-location:

if mLR == 0 
    
    eTHC = struct...
    ('Xv',[], 'Av',[], 'Uv',[], 'Bv',[], 'NCS',[], 'rm', 0 );
    
    A0(:,1) = N1 * THC.Av(nGS(1),:) +  N2 * THC.Av(nGS(2),:);
    eTHC.Av = A0;
    
   	X = b2601_BNURBS_Xcoord (A0 , pKnotV, pNcp, pDegree, pUsize, pEw, pEP, pudim, xdim);
    eTHC.Xv = X ;
    
    eTHC.Bv = 0 ;
    eTHC.Uv = [0 0]' ;
    
    eTHC.NCS = [0 0];
    eTHC.rm = 0 ;
    
end


% 3.- ELEMENTS TO SPLIT:
% all elements attached to line gL(sLR) and line gL(sLS)
% First elemns attached to line that stays, and second to the line that is
% to be removed.

Ne = zeros(2,1);
eR = zeros(2,1);

tmp = [ gL(sLS) gL(sLR) ] ;

for k = 1:1:2

    rL = tmp(k); % ref. of line

    for i = 1:1:size(connT.LE,2)

        r = connT.LE(rL,i);

        if r > 0 && r ~= deR
            Ne(k) = Ne(k)  + 1 ;
            eR(k,Ne(k)) = r ; 
        end
    end

end

end

