function [u0] = s2833b_FindsUinterval (x, Nks, Ntp, tpu, Degree,Ncp, KnotV, Usize, EP, Ew, CD, xdim)

% RETURNS:
% u0; closes point of trials

% INPUTS:
% Ntp(Nks): No. trial points per span
% tpu(Nks,Ntp,udim)): trial points
% x(xdim): point to be localized
% NURBS features

udim = 2 ;

% 1.- Computes distance from each tp to x

Dx = zeros(sum(Ntp),2); % cols: order and distance
j = 0 ;
for s = 1:1:Nks
for i = 1:1:Ntp(s)
    
    j = j+1;
    ut = [tpu(s,i,1) tpu(s,i,2)];
    xt = b2601_BNURBS_Xcoord (ut, KnotV, Ncp,Degree, Usize, Ew,EP, udim, xdim);
    
    Dx(j,1) = s ;
    Dx(j,2) = i ;
    Dx(j,3) = norm(xt-x);
end
end



% 2.- Sorts by distance and selects u0:

sDx = sortrows(Dx,3);

s1 = sDx(1,1);
i1 = sDx(1,2);
u0 = [ tpu(s1,i1,1) tpu(s1,i1,2) ];

end