function [lUc, lXc] = li2902_AddCurveP (lUc, lXc, u, cKnotV, cNcp,cDegree,cUsize, cw,cB, cUdim, cXdim)

% RETURNS:
% lXc with point correspondant to 'u' paremeter in case is not already included

% INPUTS:
% lXc: original array of points
% u: parameter where we want the point. It can be the first or the last point.


% computes point in physical space correspondant to 'u':

[x] = b2601_BNURBS_Xcoord (u, cKnotV, cNcp,cDegree, cUsize, cw,cB, cUdim,cXdim);


% read stored point in lXc, first and last ponts:

fx = zeros(cXdim,1);
lx = zeros(cXdim,1);

for di=1:1:cXdim
    fx(di) = lXc(1,di);
    lx(di) = lXc(end,di);
end


% compares with x, chooses fx or lx depending on u:

if u == cKnotV(1) 
    
 	[CO] = go2542_coincidentP (x, fx, cXdim, 4);
    
    if size(x,1)>1
        x = x';
    end
    
    % adds at the begining
    if CO==0
        lUc = [ u ; lUc ];
        lXc = [ x ; lXc ];
    end
    
elseif u == cKnotV(end)  
    
    [CO] = go2542_coincidentP (x, lx, cXdim, 4); 
 	
    if size(x,1)>1
        x = x';
    end
    
    % adds at the end
    if CO==0
        lUc = [ lUc ; u ];
        lXc = [ lXc ; x ];
    end
    
end


end

