function [Eskin] = so2932_SeSkins (Eskin, bePa, Nbe, bEnti, gPatch, pCou, xdim)

% RETURNS: only the coupled slaves of
% Eskin(Nbe): skins correspondant to bEntis

for bR = 1:1:Nbe

    cR = bEnti(bR).cou; % coupling ref.
    paR = bePa(bR,1); % patch ref

    if (cR>0 && paR == pCou(cR,2)) % finds if is slave B.E

        % declares skin:
        
        skin = GenSkin ;
        
        
        % finds correspondant master couple: MbR
        % and transfers to Mskin:
        
        for MbR = 1:1:Nbe
            if bEnti(MbR).cou== pCou(cR,1)
            break
            end
        end

        %Mskin = GenSkin;
        Mskin = Eskin(MbR);
        
        
        % copy NURBS from bEnti:

        skin.mNcp = bEnti(bR).Ncp;
        skin.mDegree = bEnti(bR).Degree;
        skin.mUsize = bEnti(bR).Usize;
        skin.mKnotV = bEnti(bR).KnotV;
        skin.mB = bEnti(bR).P;
        skin.mw = bEnti(bR).w;
        skin.sPL = bEnti(bR).PL;
        skin.sCD = bEnti(bR).CS;
        skin.xdim = bEnti(bR).Xdim;
        skin.udim = bEnti(bR).Udim;

        
        % copy master B.E. features:

        nP   = Mskin.nP;
        conM = Mskin.conM;
        mP   = Mskin.mP;
        nGP  = Mskin.nGP;

        skin.nP   = nP;
        skin.conM = conM;
        skin.mP   = mP;
       	skin.nGP  = nGP;


        % re-computes mAcoor for mP and mGP in terms 
        % of slave patch param. space:

        mGPt(nGP,1) = GenPoint;
        
        for po=1:1:nGP
            
            mGPt(po).mUcoor = Mskin.mGP(po).mUcoor ;
            mGPt(po).mXcoor = Mskin.mGP(po).mXcoor ;
            
            mGPt(po).dJ1 = Mskin.mGP(po).dJ1 ;
            mGPt(po).dJ2 = Mskin.mGP(po).dJ2 ;
            mGPt(po).mw = Mskin.mGP(po).mw ;
        end
        
        pudim = gPatch(paR).Xdim;
        Degree = gPatch(paR).Degree ;
        Ncp = gPatch(paR).Ncp ;
        KnotV = gPatch(paR).KnotV ;
        Usize = gPatch(paR).Usize ;
        P = gPatch(paR).P  ;
        w = gPatch(paR).w ;
        CD = zeros(pudim,1) ;

        for g=1:1:nGP 
            x = mGPt(g).mXcoor;
            u = b2811_PPonePoint (x, Degree, Ncp, KnotV, Usize, P ,w, CD, xdim, pudim);
            mGPt(g).mAcoor = u ;
        end

        skin.mGP = mGPt;
        skin.mPa = paR ;

        % transfers skin to correspondant bR position in Eskin:
        Eskin(bR,1) = skin ;

        clearvars skin Mskin;
        
    end
end
    


end

