function [Eskin, bePa] = so2932_eSkins (Npa, Nbe, bEnti, bCurv, gPatch, pCou, repI, NGPe, xdim)

% RETURNS:
% Eskin(Nbe): skins correspondant to bEntis



% 1.- DECLARES Eskin:

Eskin(Nbe,1) = GenSkinBE;


% 2.- LEADING GEOMETRICAL DATA: e.g. spacing between points
    
% 2.1.- Steps for prelim. points for surface and contours:
    
sstp = [0.05 0.05]; 
cstp = 0.02 ;
    
% 2.2.- Desired skin points separation and number:
    
stam = zeros(xdim,1); 

for di=1:1:xdim
    stam(di) = repI(2,1)/1;
end
   
ctam = repI(1,1)/1;

sNmin = repI(2,2)*1;
cNmin = repI(1,2)*1;
    

% LOOP ON B.E.'s TO COMPUTE SKIN FOR EACH ONE:
% computes all except the slave coupled skins (it does it afterwards)

wb = waitbar(0,'B.E. skin definition');
set(wb,'Name','B.E. skin definition');
wbPos = [10 250 300 70]; % left bottom wide height
set(wb,'position', wbPos);


% 3.- COMPUTES MASTER COUPLING SKINS FIRST:

bePa = zeros(Nbe,1);


for bR = 1:1:Nbe %%%%%%%%%%%%%%%% AQUI !!! inicio = 1, not 2

    cR = bEnti(bR).cou; % coupling ref.
 
    % 3.- FINDS WHICH PATCH THE B.E. BELONS TO.
    % that is required to localize which patch use during skin definition
    % stores in bePa matrix

    paR = 0 ;
    for pa = 1:1:Npa
        
        for be = 1:1:gPatch(pa).nbe
            
            bb = gPatch(pa).Rbe(be);
            if bb == bR
                paR = pa;
                break
            end
        end
        
        if paR~=0
        	bePa(bR,1)= paR;
            break 
        end
    end

    if (cR>0 && paR == pCou(cR,1)) || cR==0 % finds if is master B.E. or not coupling

        % 4.- COMPUTES THE SKIN:

        % 4.1.- Extraction from bEnti

        % extracts bEnti surface features:
        sNcp    = bEnti(bR).Ncp;
        sDegree = bEnti(bR).Degree;
        sUsize  = bEnti(bR).Usize;
        sKnotV  = bEnti(bR).KnotV;
        sB      = bEnti(bR).P;
        sw      = bEnti(bR).w;
        sPL     = bEnti(bR).PL;
        sXdim   = bEnti(bR).Xdim;
        sUdim	= bEnti(bR).Udim;
        [sEw,sEB] = GEN_12_ExpandBw (sw, sB,sXdim, sUdim, sNcp);

        % extracts contour loop curves ref's.:
        nlo = bEnti(bR).nlo;
        ncu = bEnti(bR).ncu;
        Rcu = bEnti(bR).Rcu;
        CS  = bEnti(bR).CS;


        % 4.2.- works out skin:

        contoured = 1 ;
        [skin] = su2911_Skin ...
        (paR, gPatch,sstp, stam, sNmin, sNcp, sDegree, sUsize, sKnotV, sEB,sEw, sB,sw, sPL, sXdim, sUdim, ...
        cstp, ctam, cNmin, contoured, nlo, ncu, Rcu, CS, bCurv);

        skin.mPa = bePa(bR);
        skin.mTr = bEnti(bR).Tr ; % trimming flag


        % 4.3.- computes Gauss points: coordinates, jacobians and weights

        [skin] = su2917_GP (skin, NGPe, gPatch, paR, sUdim, xdim);

        
     	% 4.4.- Allocates and clear variables_

        Eskin(bR,1) = skin;
        clearvars skin ;
        
    end

    waitbar(bR/Nbe,wb, strcat('B.E.= ',num2str(bR+1))) ; 
    
end
    
delete (wb);
    


end

