function [Spatches, bEnti] = so2933_bSkins (Npa, bFace, bEnti, bCurv, gPatch, Spatches, Eskin, NGPe, repI)

% RETURNS:
% Spatches with bBskin(nF): bounded skins objects (to allocate to mRefin)
% bEnti's with Bskin reference


for pa = 1:1:Npa
    
    % 1.- mSskin DECLARATION & BASIC DATA EXTRACTION:
    
    
    % 1.1.- Information extraction:
    
    Rbe = gPatch(pa).Rbe; % allocated bentis to that patch
    xdim = bFace(pa).mSur(1).Xdim;
    
    
    % 1.2.- Count No. skins:
    
    nBF = bFace(pa).nF;
    nBEtotal= gPatch(pa).nbe;
    
    % counts only trimming entities:
    nBEtrim = 0 ;
    for b = 1:1:nBEtotal
        bR = Rbe(b);
        if bEnti(bR).Tr==1
            nBEtrim = nBEtrim + 1 ;
        end
    end

    nF  = nBF+nBEtrim ;
    
    
    % 1.3.- Declares Bskin:
    
    Bskin(nF,1) = GenSkin;



    % 2.- COMPUTES POINTS OF EACH skin & ALLOCATES TO Spatches():
    
    % 2.1.- Steps for prelim. points for surface and contours:
    
    sstp = [0.05 0.05]; 
    cstp = 0.02 ;
    
    
    % 2.2.- Desired skin points separation and number:
    
    stam = zeros(xdim,1); 
    ctam = zeros(xdim,1);
    for di=1:1:xdim
        stam(di) = repI(2,1);
        ctam(di) = repI(1,1);
    end
    
    sNmin = repI(2,2);
    cNmin = repI(1,2);
    
    
    % 2.3.- Loop on bounded faces to compute skin points:

    wb = waitbar(0,strcat('bounded patch ' ,num2str(pa), ' skin definition'));
    set(wb,'Name','bounded patches skin definition');
    wbPos = [10 250 300 70]; % left bottom wide height
    set(wb,'position', wbPos);
    
    %for fa = 4:1:4
    for fa = 1:1:nBF

        % 2.3.1.- Extracts information from bFace:
        
        % extracts surface features:
        
        sNcp    = bFace(pa).mSur(fa).Ncp;
        sDegree = bFace(pa).mSur(fa).Degree;
        sUsize  = bFace(pa).mSur(fa).Usize;
        sKnotV  = bFace(pa).mSur(fa).KnotV;
        sB      = bFace(pa).mSur(fa).P;
        sw      = bFace(pa).mSur(fa).w;
        sPL     = bFace(pa).mSur(fa).PL;
        sXdim   = bFace(pa).mSur(fa).Xdim;
        sUdim	= bFace(pa).mSur(fa).Udim;
        [sEw,sEB] = GEN_12_ExpandBw (sw, sB,sXdim, sUdim, sNcp);
        

        % extracts contour loop curves ref's.:
        
        nlo = bFace(pa).mSur(fa).nlo;
        ncu = bFace(pa).mSur(fa).ncu;
        Rcu = bFace(pa).mSur(fa).Rcu;
        CS = zeros(sUdim,1);

        % 2.3.2.- works out skin and allocates:
        
        contoured = 1 ;
        
        [skin] = su2911_Skin ...
       (pa, gPatch, sstp, stam, sNmin, sNcp, sDegree, sUsize, sKnotV, sEB,sEw, sB,sw, sPL, sXdim, sUdim, ...
        cstp, ctam, cNmin, contoured, nlo, ncu, Rcu, CS, bCurv);

        skin.mTr = 0 ; % trimming flag
    
        
        % 2.3.3.- computes Gauss points: coordinates, jacobians and weights

        [skin] = su2917_GP (skin, NGPe, gPatch, pa, sUdim, xdim);
        
        
        % 2.3.4.- Allocates and clearvars:
        
        Bskin(fa,1) = skin;

        clearvars skin ;
        
        waitbar(fa/nBF,wb, strcat('face= ',num2str(fa+1))) ; 
        

    end
    
    delete(wb);
    
    % 2.4.- Loop on boundary entities to transfers skin points:
    % (only for those entities that are trimming = 1)

    contab = 0 ;

    for b = 1 : 1 : nBEtotal

        % bEnti reference:
        bR = Rbe(b);
        
 
      	% allocates to Bskin only if trimming-shaping b-entities: 
        if bEnti(bR).Tr == 1
            
            contab = contab + 1 ;
            
            % allocates to bEnti the skin reference
            bEnti(bR).sr = fa+contab;
            
            
            % declares skin object:
            skin = GenSkin;
            
            
            % extracts skin features from Eskin
            
            exdim = Eskin(bR).xdim;
            eudim = Eskin(bR).udim;
            
            eDegree = Eskin(bR).mDegree;
            eKnotV = Eskin(bR).mKnotV;
            eUsize = Eskin(bR).mUsize;
            eNcp = Eskin(bR).mNcp;
            eB = Eskin(bR).mB;
            ew = Eskin(bR).mw;
            esPL = Eskin(bR).sPL;
            esCD = Eskin(bR).sCD;
            
            enlo = Eskin(bR).nlo;
            encu = Eskin(bR).ncu;
            eRcu = Eskin(bR).Rcu;
            
            enPL = Eskin(bR).nPL;
            emPL = Eskin(bR).mPL;
            
            eCLu = Eskin(bR).CLu;
            
           	enP = Eskin(bR).nP;
            emP = Eskin(bR).mP;
            econM = Eskin(bR).conM;
            
            enGP = Eskin(bR).nGP;
            emGP = Eskin(bR).mGP;
            
          
            
            
            skin.xdim = exdim;
            skin.udim = eudim;
            
            skin.mDegree = eDegree;
            skin.mKnotV = eKnotV;
            skin.mUsize = eUsize;
            skin.mNcp = eNcp;
            skin.mB = eB;
            skin.mw = ew;
            skin.sPL = esPL;
            skin.sCD = esCD;
            
            skin.nlo = enlo;
            skin.ncu = encu;
            skin.Rcu = eRcu;
            
            skin.nPL = enPL;
            skin.mPL = emPL;
            
            skin.CLu = eCLu;
            
           	skin.nP = enP;
            skin.mP = emP;
            skin.conM = econM;
            
            skin.nGP = enGP;
            skin.mGP = emGP;
            
            skin.mTr = bR ; % trimming flag
            
            
            
            
            % allocates and clears 'skin':
            Bskin(fa+contab,1) = skin;
            clearvars skin ;
            
        end
 
    end
    
    
    
    
    % 3.- ALLOCATES TO Spatches & CLEAR VARS:
    
    Spatches(pa).mRefin(1).mBskin = Bskin ;
    Spatches(pa).mRefin(1).nBS = size(Bskin,1);

    clearvars Bskin ;
    
end

end

