function [Eskin, Spatches, agCurvE, SCconE, ncuE, nloE, CPconE] = so2934_bSkins...
    (Nbe, bEnti, Npa, Spatches, gPatch, bFace, bCurv, tolRc, tolRs, tolD, Nvx, R, esw, eswP, ndig, wbF, DerC)


% No. dimensions

pudim = 3;
xdim  = 3;
eudim = 2 ;

% pp tolerances:

Xtol = 0.1 * R / 100;
DUtol = 0.001;
dmin = 3*R;



% 1.- B.E. SURFACES:

Eskin(Nbe,1) = cBskin;


% 1.1.- Groups all curves of B.E. (attaches to B.E. via SCcon) and computes vertexes.

[agCurvE, TNcuE, SCconE, ncuE, nloE, CPconE] = so2935_AgreCurves (Nbe, bEnti, bCurv, xdim);



% Computes curves vertexes in local curve physical/param's coord's:
[cLXvE, cLUvE, NcvE, ~] = ts3312_Cvertexes (agCurvE, TNcuE, R, Nvx, tolRc, xdim);


% computes contour curves solid patch param. coordinates:
[cAvE] = so2937_mAcon (TNcuE, NcvE, cLXvE, CPconE, gPatch, Xtol, DUtol, dmin, pudim, xdim);



% 1.2.- Assemblies B.E. surfaces object:

sf(Nbe,1) = struct('Ncp',[], 'Degree',[], 'Usize',[], 'KnotV',[], 'EP',[], 'Ew',[], 'P',[],'w',[], 'CS',[]);

for s = 1:1:Nbe

    sf(s).Ncp    = bEnti(s).Ncp;
    sf(s).Degree = bEnti(s).Degree;
    sf(s).Usize  = bEnti(s).Usize;
    sf(s).KnotV  = bEnti(s).KnotV;
    sf(s).CS     = bEnti(s).CS;
    
    Ncp = bEnti(s).Ncp;
    P = bEnti(s).P;
    w = bEnti(s).w;
    [Ew,EP] = GEN_12_ExpandBw (w, P,xdim, eudim, Ncp);
    
    sf(s).P = P;
    sf(s).w = w;
  	sf(s).EP = EP;
    sf(s).Ew = Ew;
    
end



% 1.3.- Triangulates them:

[QITst] = ts3330_QITst ...
(tolRc, tolRs, tolD, Nvx, R, esw, eswP, Nbe, sf, agCurvE, cLXvE, cLUvE, NcvE, nloE, ncuE, SCconE, xdim, ndig, 0,0,0, wbF, DerC);



% 1.4.- Allocates to Eskin & computes GP's:

for s = 1:1:Nbe
        
    Eskin(s,1).mNcp    = bEnti(s).Ncp;
    Eskin(s,1).mDegree = bEnti(s).Degree;
    Eskin(s,1).mUsize  = bEnti(s).Usize;
    Eskin(s,1).mKnotV  = bEnti(s).KnotV;
    Eskin(s,1).mP      = bEnti(s).P;
    Eskin(s,1).mw      = bEnti(s).w;

    Eskin(s,1).mCS = bEnti(s).CS;
    Eskin(s,1).mPN = bEnti(s).PL;
    
    Eskin(s,1).mNE = QITst(s).mNE ;
    Eskin(s,1).mNV = size(QITst(s).mXv,1) ;
    Eskin(s,1).mTVcon = QITst(s).mTVcon ;
    Eskin(s,1).mVTcon = QITst(s).mVTcon ;
    
  	Eskin(s,1).mLVcon = QITst(s).mLVcon ;
    Eskin(s,1).mVLcon = QITst(s).mVLcon ;
    
    Eskin(s,1).mTLcon = QITst(s).mTLcon ;
    
    Eskin(s,1).mRv = QITst(s).mRv ;
    Eskin(s,1).mUv = QITst(s).mUv ;
    Eskin(s,1).mXv = QITst(s).mXv ;
    %Eskin(s,1).mXv0 = QITst(s).mXv ;
    Eskin(s,1).mXNe = QITst(s).mXNe ;
    Eskin(s,1).mXNv = QITst(s).mXNv ;
    
    Eskin(s,1).mArea = QITst(s).mAe ;
    
    % Eskin(s,1).mNL = nloE(s,1) ;
    
    NCL = zeros(nloE(s,1),1);
    for lo = 1:1:nloE(s,1)
        NCL(lo,1) = ncuE(s,lo);
    end
    Eskin(s,1).mNCL = NCL ;
    
    Eskin(s,1).mNlo = QITst(s).mNlo ;
    Eskin(s,1).mNlv = QITst(s).mNlv ;
    Nlcv = QITst(s).mNlcv ;
    Eskin(s,1).mNlcv = Nlcv ;
    
    Eskin(s,1).mTr = bEnti(s).Tr;
    
    Eskin(s,1).mPa  = bEnti(s).Pa;
    Eskin(s,1).mCou = bEnti(s).Cou;

    % iem matrix
    NE = Eskin(s,1).mNE ;
    Eskin(s,1).iem = zeros(NE,3,3);


    % local edges curves parameter space coordiantes, and curve abs ref:
    
    NV = Eskin(s,1).mNV ;
    Ev = zeros(NV,1);
    ER = zeros(NV,1);
    
    conta = 0;
    for lo = 1:1:nloE(s,1)
    for cu = 1:1:ncuE(s,lo)
       
        cR = SCconE(s,lo,cu);
        
        for i = 1:1:Nlcv(lo,cu)-1
            
            conta = conta + 1 ;
            Ev(conta,1) = cLUvE(abs(cR),i);
            ER(conta,1) = cR ;
            
        end
        
    end
    end
    
    Eskin(s,1).mEv = Ev;
    Eskin(s,1).mER = ER;
    
    % 
   
	% plots skins
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%{
	fr = 99 ;
	Cv = QITst(s).mXv ;
        
	LVcon = QITst(s).mLVcon ;
	TVcon = QITst(s).mTVcon ;
        
	NLI = size(LVcon,1);
	NE = QITst(s).mNE ;
        
	pt1366_pTriLinMesh_nD...
	(Cv, NLI, LVcon, TVcon, xdim, fr, 'b', 0, NV, 0, 0, NE, 0, 0, 0, 0, 0, 0);
	%}
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
end



% 1.5.- Computes surface vertexes in terms of solid patch param. space:
%       Also normal vectors at triang's and vertexes:

[Eskin] = so2936_mAvN (Nbe, Eskin, nloE, ncuE, SCconE, NcvE, cAvE, cLXvE, CPconE, Spatches, Xtol, DUtol);


%{
for b = 1:1:2
    Av = Eskin(b).mAv ;
    NE = Eskin(b).mNE ;
    LVcon = Eskin(b).mLVcon ;
    TVcon = Eskin(b).mTVcon ;
    
    Eiem = zeros(NE,3,3);
    NLI = size(Eskin(b).mLVcon,1);
    
    vrF = 1 ;
    erF = 1 ;
    
    pt1369_TriMDMesh (0.5, 0.5, Av, NLI, NE, LVcon, TVcon, Eiem, b+10, 1, 0, 0, vrF, erF);
    
    for i = 1:1:3
       
        TVcon(123,i)
        
    end
    
end

%}


% for closed surfaces updates normals of vertexes of closing lines:
nd = 2 ;
for s = 1:1:Nbe 
    if sum(Eskin(s).mCS) > 0 
    [Eskin] = so2933_AmendNvtx (Eskin, s, s, ncuE, SCconE, NcvE, cLXvE, pudim, xdim, nd);
    end
end

clearvars sf QITst ;




% 2.- BOUNDED PATCHES:
% {
for pa = 1:1:Npa
    
    % 2.1- prepares surface object and declares skin object:
    
    Nbf = bFace(pa).Nfa;


    BPsf(Nbf,1) = struct('Ncp',[],'Degree',[],'Usize',[],'KnotV',[],...
                        'w',[],'P',[],'Ew',[],'EP',[], 'CS', [], ...
                        'Nol',[],'Noc',[],'Rcu',[], 'Pa', 0);
    
	Bskin(Nbf,1) = cBskin;
        

    for s = 1:1:Nbf
        
        % surface data

        BPsf(s).Ncp     = bFace(pa).mSur(s).Ncp ;
        BPsf(s).Degree  = bFace(pa).mSur(s).Degree ;
      	BPsf(s).Usize   = bFace(pa).mSur(s).Usize ;
        BPsf(s).KnotV   = bFace(pa).mSur(s).KnotV ;  
        BPsf(s).CS      = bFace(pa).mSur(s).CS;
        
        P = bFace(pa).mSur(s).P;
        w = bFace(pa).mSur(s).w ;
        
        [Ew,EP] = GEN_12_ExpandBw (w, P,xdim, 2, BPsf(s).Ncp);
        
        BPsf(s).P  = P;
        BPsf(s).w  = w ;
        BPsf(s).EP = EP ;
        BPsf(s).Ew = Ew ;
        
        BPsf(s).Nol = bFace(pa).mSur(s).Nol ;
        BPsf(s).Noc = bFace(pa).mSur(s).Noc ;
        BPsf(s).Rcu = bFace(pa).mSur(s).Rcu ;
  
        BPsf(s).Pa = pa ;
    end
    
    % 2.2.- Groups all curves of patch (attaches to patch via SCcon) and computes vertexes.
    % Note: computes vtx considering previous curves
    
    [agCurvP, TNcuP, SCconP, ncuP, nloP, CPconP] = so2935_AgreCurves (Nbf, BPsf, bCurv, xdim);

    qcfE = zeros(TNcuE,1);
    
    [cLXvP, cLUvP, NcvP, qcfP] = ts3322_CvtxsPrev ...
 	(TNcuP, agCurvP, TNcuE, agCurvE, cLUvE, cLXvE, NcvE, qcfE, R, Nvx, tolRc, xdim);
    


    % computes contour curves solid patch param. coordinates:
    
    [cAvP] = so2937_mAcon (TNcuP, NcvP, cLXvP, CPconP, gPatch , Xtol, DUtol, dmin, pudim, xdim);


    % 2.3.- Triangulates them:
    
    [QITst] = ts3330_QITst ...
    (tolRc, tolRs, tolD, Nvx, R, esw, eswP, Nbf, BPsf, agCurvP, cLXvP, cLUvP, NcvP, nloP, ncuP, SCconP, xdim, ndig, 0,0,0, wbF, DerC);


    % 2.4.- Allocates to 1st instance of patches:

    for s = 1:1:Nbf

        Bskin(s,1).mNcp    = bFace(pa).mSur(s).Ncp;
        Bskin(s,1).mDegree = bFace(pa).mSur(s).Degree;
        Bskin(s,1).mUsize  = bFace(pa).mSur(s).Usize;
        Bskin(s,1).mKnotV  = bFace(pa).mSur(s).KnotV;
        Bskin(s,1).mP      = bFace(pa).mSur(s).P;
        Bskin(s,1).mw      = bFace(pa).mSur(s).w;
        
        Bskin(s,1).mCS = bFace(pa).mSur(s).CS;
        Bskin(s,1).mPN = bFace(pa).mSur(s).PL;

        Bskin(s,1).mNE = QITst(s).mNE ;
        Bskin(s,1).mNV = size(QITst(s).mXv,1) ;
        Bskin(s,1).mTVcon = QITst(s).mTVcon ;
        Bskin(s,1).mVTcon = QITst(s).mVTcon ;
        
     	Bskin(s,1).mLVcon = QITst(s).mLVcon ;
        Bskin(s,1).mVLcon = QITst(s).mVLcon ;
        
        Bskin(s,1).mTLcon = QITst(s).mTLcon ;
        
        Bskin(s,1).mUv = QITst(s).mUv ;
        Bskin(s,1).mXv = QITst(s).mXv ;
        %Bskin(s,1).mXv0 = QITst(s).mXv ;
        Bskin(s,1).mXNe = QITst(s).mXNe ;
        Bskin(s,1).mXNv = QITst(s).mXNv ;
         
        Bskin(s,1).mArea = QITst(s).mAe ;
        
        Bskin(s,1).mNlo = QITst(s).mNlo ;
        Bskin(s,1).mNlv = QITst(s).mNlv ;
        
        Bskin(s,1).mPa = pa ;
        
        
        % iem matrix
        NE = Bskin(s,1).mNE ;
        Bskin(s,1).iem = zeros(NE,3,3);
        
        
     	% plots skins
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %{
        fr = pa ;
        Cv = QITst(s).mXv ;

        LVcon = QITst(s).mLVcon ;
        TVcon = QITst(s).mTVcon ;

        NLI = size(LVcon,1);
        NE = QITst(s).mNE ;

        pt1366_pTriLinMesh_nD...
        (Cv, NLI, LVcon, TVcon, xdim, fr, 'r', 0, NV, 0, 0, NE, 0, 0, 0, 0, 0, 0);
        %}
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    
        
    end

    
    
    % 2.5.- Computes surface vertexes in terms of solid patch param. space.
    %       Also normal vectors at triang's and vertexes and triangle physical area:

    [Bskin] = so2936_mAvN  (Nbf, Bskin, nloP, ncuP, SCconP, NcvP, cAvP, cLXvP, CPconP, Spatches, Xtol, DUtol);
 

    % 2.6.- Computes quadratic features for faces affected by quadratic curves (qcfE = 1).
    % Adds NVm and updates iem matrix:
    
    [Bskin] = so2939_quadFeatures (pa, Spatches, Bskin, Nbf, cLXvP, nloP, ncuP, SCconP, NcvP, qcfP, xdim, Xtol, DUtol);

    
    % plots all bf's
    %{
	for b = 1:1:Nbf
        
        fr = 10 ;
        
        stL = 0.50 ;
        stT = 0.25 ;
        
        Cv      = Bskin(b,1).mXv;
        LVcon   = Bskin(b,1).mLVcon;
        TVcon   = Bskin(b,1).mTVcon;
        Eiem    = Bskin(b,1).iem;
        NE      = Bskin(b,1).mNE;
        
        NLI = size(LVcon,1);
        
        eF = 1 ;
        sF = 1 ;
        
        pt1369_TriMDMesh (stL, stT, Cv, NLI, NE, LVcon, TVcon, Eiem, fr, eF, sF, 0, 0, 0);
        
        
    end
    %}
    
 
    
    % 2.7.- Allocates skins to patch: either Bskins and its trimming Eskins
    
    % Entity skins that are trimming:
    
    Nesk = 0 ;          % No.
    Resk = zeros(1,1);  % ref's
    
    for b = 1:1:Spatches(pa,1).nbe
        
        Tr = Eskin(b,1).mTr ;
        Pa = Eskin(b,1).mPa ;
        
        if (Tr(1)==1 && Pa(1)==pa) || (Tr(2)==1 && Pa(2)==pa)
            Nesk = Nesk + 1 ;
            Resk(Nesk,1) = b ;
        end
             
    end
    
    Nsk = Nbf + Nesk ; % total No. patch skins

    Pskin(Nsk,1) = cPskin ;
    
    % transfers from bounded faces:
    for i = 1:1:Nbf
        
        s = i ;
        
        Pskin(s,1).mNE = Bskin(s,1).mNE;
        Pskin(s,1).mNV = Bskin(s,1).mNV;
        
        Pskin(s,1).mTVcon = Bskin(s,1).mTVcon;
        Pskin(s,1).mVTcon = Bskin(s,1).mVTcon;
        Pskin(s,1).mLVcon = Bskin(s,1).mLVcon;
        Pskin(s,1).mVLcon = Bskin(s,1).mVLcon;
        Pskin(s,1).mTLcon = Bskin(s,1).mTLcon;
        
      	Pskin(s,1).mNlo = Bskin(s,1).mNlo; 
        Pskin(s,1).mNlv = Bskin(s,1).mNlv; 
        
        VP(Pskin(s,1).mNV,1) = cVP;
        
        for v = 1:1:Pskin(s,1).mNV
            
            for di = 1:1:xdim
                VP(v,1).mAcoor(di,1) = Bskin(s,1).mAv(v,di);
                VP(v,1).mXcoor(di,1) = Bskin(s,1).mXv(v,di); 
            end

            VP(v,1).mD  = zeros(6,6);
            VP(v,1).mSv = zeros(6,1);
            VP(v,1).mVM = 0;
            VP(v,1).mPst = zeros(3,1);
            VP(v,1).mPdi = zeros(3,3);
            
        end
        
        Pskin(s,1).mVP = VP ;
        clearvars 'VP'

    end
    
    
    % transfers from Trimming Eskins:
    
    s = Nbf ;

    for i = 1:1:Nesk
        
        eR = Resk(i,1);
        s = s+1;
        
        Pskin(s,1).mNE = Eskin(eR,1).mNE;
        Pskin(s,1).mNV = Eskin(eR,1).mNV;
        
        Pskin(s,1).mTVcon = Eskin(eR,1).mTVcon;
        Pskin(s,1).mVTcon = Eskin(eR,1).mVTcon;
        Pskin(s,1).mLVcon = Eskin(eR,1).mLVcon;
        Pskin(s,1).mVLcon = Eskin(eR,1).mVLcon;
        Pskin(s,1).mTLcon = Eskin(eR,1).mTLcon;
        
      	Pskin(s,1).mNlo = Eskin(eR,1).mNlo; 
        Pskin(s,1).mNlv = Eskin(eR,1).mNlv; 
        
        VP(Pskin(s,1).mNV,1) = cVP;
        
        for v = 1:1:Pskin(s,1).mNV
            
            for di = 1:1:xdim
                VP(v,1).mAcoor(di,1) = Eskin(eR,1).mAv(v,di);
                VP(v,1).mXcoor(di,1) = Eskin(eR,1).mXv(v,di);
            end
            
            VP(v,1).mD  = zeros(6,6);
            VP(v,1).mSv = zeros(6,1);
            VP(v,1).mVM = 0;
            VP(v,1).mPst = zeros(3,1);
            VP(v,1).mPdi = zeros(3,3);
            
        end
        
        Pskin(s,1).mVP = VP ;
        clearvars 'VP'
    end
    
    Spatches(pa,1).INS(1).mNsk = Nsk;
	Spatches(pa,1).INS(1).skin = Pskin ;
      
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %{
	s = 1;
      
    figure(33)
    
    Bskin(s,1).mKnotV
    Bskin(s,1).mNcp
    Bskin(s,1).mDegree
    Bskin(s,1).mUsize
    Bskin(s,1).mw
    Bskin(s,1).mP

	NV = Spatches(pa,1).INS(1).skin(s,1).mNV;
     
    for v = 1:1:NV
        Xv = Spatches(pa,1).INS(1).skin(s,1).mVP(v,1).mAcoor;
        scatter3( Xv(1), Xv(2),Xv(3),'b'); hold on
    end

	axis equal   
    %}
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        

    clearvars BPsf QITst Bskin ;
    

end



%}

end

