function [skins] = so2936_mAvN ...
        (Nsk, skins, nlo, ncu, SCcon, Ncv, cAv, cXv, CPcon, Spatches, Xtol, DUtol)
 
% RETURNS:
% skins with:
% mAv mAvS: coord's (in patch param. space) of surfaces vtxs, slave patch if applied
% mNAv, mNAe: normals in patch param. space


% INPUTS:

pudim = 3 ;
xdim = 3 ;


for s = 1:1:Nsk
  
    % 1.- PATCH FEATURES:
    
    [pR, pDegree, pNcp, pKnotV, pUsize, pP, pw, pCD, ~,~,~, ...
  	spR, spDegree, spNcp, spKnotV, spUsize, spP, spw, spCD, ~,~,~] = ...
  	so2938_patchNURBS (skins(s,1), Spatches, xdim);
    
    
    % 2.- SEPARATES VTX FROM CONTOURS AND SI-VTX, and computes for the latter:
    
    % 2.1.- Counts No. vtx that belong to contour curves of that surface 's':
    
    ccv = 0 ;
    
    for lo = 1:1:nlo(s)
    for c = 1:1:ncu(s,lo)
        
        cR = abs(SCcon(s,lo,c));

        ccv = ccv + Ncv(cR)-1;
        
    end
    end
    
    
    % 2.2.- No. vtx of surface but not contour curves: SI-vrtx:
    
    NV = skins(s,1).mNV ;
    nsp = NV - ccv;
    
    if nsp>0
    
        % 2.3.- Extracts SI-vtx phys. coordinates:
        sX = zeros(nsp,xdim); 
        for v = 1:1:nsp
            sX(v,:) = skins(s,1).mXv(ccv+v,:);  
        end

        % 2.4.- Works out point projection of sX:
        [sA] = v2861b_PPvol (sX, nsp, pDegree, pNcp, pKnotV, pUsize, pP, pw, pCD, xdim, Xtol, DUtol);
    end
   

    % 3.- ALLOCATES Acoor COORDINATES:
    
    % 3.1.- first contour curves vtx:
    
    % in case curve patch ref. (cpR) does not coincide with the skin patch (pR)  
    % needs to recalculate Av coordinates of curve (in terms of pR param. coordinates)
    
    contaV = 0;
    for lo = 1:1:nlo(s)
    for c = 1:1:ncu(s,lo)
        
        cR = SCcon(s,lo,c);
       
        sc = sign(cR);
        cR = abs(cR);
        
        cpR = CPcon(cR,1); % curve patch ref.
           
        
        % extracts relevant coordinates: Acoord's and Xcoord's, stored
        % already arranged to surface
        
        nv = Ncv(cR)-1;
        
        cAt = zeros(nv, pudim); % temporary coords storage
        cXt = zeros(nv, xdim); 
        
        if sc == 1
            v1 = 1 ;
            v2 = Ncv(cR)-1; % last point is not added !
        elseif sc==-1
            v1 = Ncv(cR) ;
            v2 = 2; % last point is not added !
        end
        
        i = 0 ;
        for v = v1:sc:v2
            i = i + 1 ;
            cAt(i,:) = cAv(cR,v,:);
           	cXt(i,:) = cXv(cR,v,:);
        end
        
        % diff. patches => recomputes Acoord's from Xcoord's (this happens
        % if the curve is shared by two surface, each of them in different patches)
        if cpR ~= pR 
            
            [cAt] = v2861b_PPvol (cXt, nv, pDegree, pNcp, pKnotV, pUsize, pP, pw, pCD, xdim, Xtol, DUtol);
            
        end
        
        % Allocates coordinates:
        for i = 1:1:nv
            
            contaV = contaV + 1 ;
            
            for di = 1:1:pudim
                skins(s,1).mAv(contaV,di) = cAt(i,di);
            end
            
        	%Av(s,contaV,:) = cAt(i,:);

        end
                  
        %{
        if sc == 1

            for v = 1:sc:Ncv(cR)-1 % last point is not added !

                contaV = contaV + 1 ;

                for di = 1:1:pudim
               	Av(s,contaV,di) = cAv(cR,v,di);
                end

            end

        elseif sc==-1

            for v = Ncv(cR):sc:2  % last point is not added !

                contaV = contaV + 1 ;

                for di = 1:1:pudim
              	Av(s,contaV,di) = cAv(cR,v,di);
                end
            end

        end
        %}
    end
    end
    

    % 3.2.- secondly the SI-vertexes:
    
    if nsp>0
        
        conta2 = contaV;

        for v = 1:1:nsp

            conta2 = conta2+1;

            for di = 1:1:pudim
                skins(s,1).mAv(contaV+v,di) = sA(v,di);
                % Av(s,contaV+v,di) = sA(v,di);
            end
        end
    end

    
    % 4.- NORMALS IN PATCH PARAM. SPACE AND PHYSICAL TRIANGLE AREA:
    
  	TV = skins(s,1).mTVcon;
	VT = skins(s,1).mVTcon;
	NV = skins(s,1).mNV;
 	NE = skins(s,1).mNE;
    
    
 	% vtx Acoord's:
 	Avi  = zeros(NV,pudim);
  	Avi(:,:) = skins(s,1).mAv(:,:);
    
   	% normals :
    spF = 0;
    [~, ANe, ANv] = tm1308_TmeshNA (spF, NE, NV, TV, VT, Avi, pudim);
    
    %{
  	ANe = zeros(NE,pudim);
 	Ae = zeros(NE,1);
    Aeph = zeros(NE,1);
    Xnod = zeros(3,xdim);
    
   	for e = 1:1:NE

        [At, nv] = tm1306_tArea_n (TV, e, Avi, 0, pudim);
        
      	ANe(e,:) = nv(:,1);
     	Ae(e,1) = At;
        
        for i = 1:1:3
            Xnod(i,:) = Xv(TV(e,i),:);
        end
        
        [At, ~] = tm1306_tArea_n (TV, 0, Avi, Xnod, xdim);
        Aeph(e,1) = At;
        
    end

  	% vtx normals:
  	ANv = zeros(NV,pudim);

  	for v = 1:1:NV
        [nvv] = i0106_nVtx (v, VT, Ae, ANe, pudim);
      	ANv(v,:) = nvv(:,1);
  	end 

    %}
    
    % allocates:
  	skins(s,1).mANe = ANe;
 	skins(s,1).mANv = ANv;

    
    
    
    % 5.- IN CASE OF SLAVE PATCH REPEAT COMPUTATIONS FOR IT:
    
    if spR > 0
        
        sX = zeros(NV,xdim); 
        
        for v = 1:1:NV
            sX(v,:) = skins(s,1).mXv(v,:);  
        end
        
        [AviS] = v2861b_PPvol (sX, NV, spDegree, spNcp, spKnotV, spUsize, spP, spw, spCD, xdim, Xtol, DUtol);
        
        for v = 1:1:NV 
            for di = 1:1:pudim
                skins(s,1).mAvS(v,di) = AviS(v,di);
            end
        end
        
        spF = 1;
        [~, ANeS, ANvS] = tm1308_TmeshNA (spF, NE, NV, TV, VT, AviS, pudim);
        
        % allocates:
        skins(s,1).mAvS = AviS;
        skins(s,1).mANeS = -ANeS;
        skins(s,1).mANvS = -ANvS;
        
    end
    
        
end




end

