function [skin] = so2938_Afeat (skin, Ns, Av, AvS, pudim)

% RETURNS:
% Coord's and normal to triangles/vertexes in patch param. space
% A triang in physicals space

xdim = 3 ;

for s = 1:1:Ns 
    
	TV = skin(s).mTVcon;
	VT = skin(s).mVTcon;
	NV = skin(s).mNV;
 	NE = skin(s).mNE;
    Xv = skin(s).mXv;
    
 	% vtx Acoord's:
 	Avi  = zeros(NV,pudim);
  	Avi(:,:) = Av(s,1:NV,:);
    
   	% triangles normals and area:
  	ANe = zeros(NE,pudim);
 	Ae = zeros(NE,1);
    Aeph = zeros(NE,1);
    Xnod = zeros(3,xdim);
    
   	for e = 1:1:NE

        %[nv, ~, At] = i0103_nTriang (TV, e, Avs, pudim);

        [At, nv] = tm1306_tArea_n (TV, e, Avi, 0, pudim);
        
      	ANe(e,:) = nv(:,1);
     	Ae(e,1) = At;
        
        for i = 1:1:3
            Xnod(i,:) = Xv(TV(e,i),:);
        end
        
        [At, ~] = tm1306_tArea_n (TV, 0, Avi, Xnod, xdim);
        Aeph(e,1) = At;
        
    end

  	% vtx normals:
  	ANv = zeros(NV,pudim);

  	for v = 1:1:NV

        [nvv] = i0106_nVtx (v, VT, Ae, ANe, pudim);
      	ANv(v,:) = nvv(:,1);
  	end 

    % allocates:
   	skin(s).mAv = Avi;
  	skin(s).mANe = ANe;
 	skin(s).mANv = ANv;
    skin(s).mArea = Aeph;
    
    
    % CASE OF SLAVE PATCH EXISTS:
    
    couR = skin(s).mCou;
    if couR > 0
        
        AviS = zeros(NV,pudim);
        AviS(:,:) = AvS(s,1:NV,:);
        
        ANeS = zeros(NE,pudim);
        ANvS = zeros(NV,pudim);
        
        for e = 1:1:NE
            ANeS(e,:) = -ANe(e,:); % NEEDS to RECALCUALTE !!
        end

        for v = 1:1:NV
            ANvS(v,:) = -ANv(v,:); % NEEDS to RECALCUALTE !!
        end 


        % allocates:
        skin(s).mAvS = AviS;
        skin(s).mANeS = ANeS;
        skin(s).mANvS = ANvS;
    end
    
    
    %{
    if s==6
        
        sc = 5 ;
        figure(10*s)
        
        scatter3(Avs(:,1),Avs(:,2),Avs(:,3),'k'); hold on
        
        for i=1:1:NV
            
            for di = 1:1:3
            a(1,di) = Avs(i,di);
            a(2,di) = Avs(i,di)+sc*ANv(i,di);
            end
            plot3(a(:,1),a(:,2),a(:,3),'r'); hold on
            
        end
        
        for e = 1:1:NE
            
            umid = zeros(3,1);
            unod = zeros(3,3);
            u = zeros(3,1);
            
            for i=1:1:3
                nr = TV(e,i);
                u(:,1) = Avs(nr,:);
                unod(i,:) = u(:,1);
                umid(:,1) = umid(:,1) + u(:,1)/3;
            end
            
            plot3(unod(:,1),unod(:,2),unod(:,3),'k'); hold on
            
            for di = 1:1:3
            a(1,di) = umid(di,1);
            a(2,di) = umid(di,1)+sc*ANe(e,di);
            end
            plot3(a(:,1),a(:,2),a(:,3),'b'); hold on
            
            text(umid(1),umid(2),umid(3),num2str(e)); hold on
            
        end
        
        
        axis equal
        
    end
    %}
end


end

