function [Bskin] = so2939_quadFeatures (pa, Spatches, Bskin, Nbf, cLXvP, nloP, ncuP, SCconP, NcvP, qcfP, xdim, Xtol, DUtol)

% RETURNS:
% Bskin: with mised degree elements if have quadratic contour curve attached



x = zeros(xdim,1);

for s = 1:1:Nbf
       
    % 1.- EXTRACTS INFO:
    
	bNcp	= Bskin(s,1).mNcp ;
	bDegree = Bskin(s,1).mDegree ;
    bUsize  = Bskin(s,1).mUsize ;
	bKnotV  = Bskin(s,1).mKnotV ;
 	bP      = Bskin(s,1).mP ;
 	bw      = Bskin(s,1).mw ;
 	bCS     = Bskin(s,1).mCS;  
	[bEw,bEP] = GEN_12_ExpandBw (bw, bP,xdim, 2, bNcp);  
	bULims = [0 1 ; 0 1 ] ;
        
	pNcp	= Spatches(pa,1).INS(1).mNcp ;
	pDegree = Spatches(pa,1).INS(1).mDegree ;
    pUsize  = Spatches(pa,1).INS(1).mUsize ;
	pKnotV  = Spatches(pa,1).INS(1).mKnotV ;
 	pP      = Spatches(pa,1).INS(1).mP ;
 	pw      = Spatches(pa,1).INS(1).mw ;
 	pCS     = [0 0 0];   
	[pEw,pEP] = GEN_12_ExpandBw (pw, pP, xdim, 3, pNcp);  
	pULims = [0 1 ; 0 1 ; 0 1 ] ;
    
	NE = Bskin(s,1).mNE ;
	NV = Bskin(s,1).mNV ;

    Av = Bskin(s,1).mAv ;
	Uv = Bskin(s,1).mUv ;
	Xv = Bskin(s,1).mXv ;

	TVcon = Bskin(s,1).mTVcon ; 
	LVcon = Bskin(s,1).mLVcon ;   
    TLcon = Bskin(s,1).mTLcon ;
        
	iem = Bskin(s,1).iem ;
        
	NVm = NV ;
	TVm = TVcon;
	LVm = LVcon;
       
    Avm = Av;
	Uvm = Uv;
	Xvm = Xv;
      
    
    % 2.- CHECKS IF ANY OF ITS CONTOUR CURVES IS QUADRATIC:
    % if so, inserted mid-vtx in the affected triangles
    
	vR = 0 ; % accumulated vtx ref.
        
	for lo = 1:1:nloP(s,1)
	for cu = 1:1:ncuP(s,lo)
        
        cR = SCconP(s,lo,cu);
        sg = sign(cR);
        cR = abs(cR);
            
        if qcfP(cR,1)==1
                
            tvR = vR; % temporary acc. vtx ref
                
            N = NcvP(cR,1)-1; % No. segments due to that contoru curve
                
            % 2.1.- Extracts corner-vtx refs correspondent to that segment:
                
            cvr = zeros(N,2);
                
            for i = 1:1:N
                    
                tvR = tvR + 1 ;
                cvr(i,1) = tvR;
                cvr(i,2) = tvR+1;
                    
                if cu==ncuP(s,lo) && i==N
                    cvr(i,2) = vR+1;
              	end
            end
                
                
            % 2.2.- Finds the element that have those cvr => eR.
            % transforms eR iem and uptades: Xv, Uv, TVcon, LVcon
                
            for i = 1:1:N
                    
                cr1 = cvr(i,1);
                cr2 = cvr(i,2);
                    
                ivF = 0 ; % inserted vtx flag
                    
                
                for e = 1:1:NE

                    % iem current situation of the element
                    tiem = zeros(3,3);
                    tiem(:,:) = iem(e,:,:);
                        
                    % sets, if any, max mid-vtx inserted previously
                 	conta = max(max(tiem)); 
                    if conta == 0
                        conta = 3;
                    end
                        
                    % 2.2.a.- Finds tthe element and updates its iem:
                    
                    r = [1 2; 2 3 ; 3 1];

                    for j = 1:1:3

                        v1 = TVcon(e,r(j,1));
                        v2 = TVcon(e,r(j,2));

                        if (v1==cr1 && v2==cr2) || (v1==cr2 && v2==cr1)
                                
                            conta = conta+1;
                            iem(e,r(j,1),r(j,2)) = conta ;
                         	iem(e,r(j,2),r(j,1)) = conta ;
                            ivF = 1 ;
                          	eR = e ;
                          	break  
                        end
                        
                    end

                        
                    % 2.2.b.- updates rest of vbles involved:
                        
                    if ivF == 1

                        NVm = NVm + 1 ;
                            
                        TVm(eR,conta) = NVm;
                            
                    	lR = TLcon(eR,j); % aff'd line ref
                            
                    	LVm(lR,1) = LVcon(lR,1);
                    	LVm(lR,2) = NVm;
                     	LVm(lR,3) = LVcon(lR,2);
                            
                     	Xvm(NVm,:) = cLXvP(cR,N+1+i,:);
                            
                      	x(:,1) = cLXvP(cR,N+1+i,:);
                            
                     	umid =  (Uv(v1,:)+Uv(v2,:))/2;
                       	[u,~] = s2835b_onePoint (x, umid, bDegree, bNcp, bKnotV, bUsize, bP ,bw, bEP ,bEw, bCS, bULims, xdim, Xtol, DUtol);
                        Uvm(NVm,:) = u(1,:);  
                        
                        amid =  (Av(v1,:)+Av(v2,:))/2;
                        [a,~] = v2865b_onePoint (x, amid, pDegree, pNcp, pKnotV, pUsize, pP ,pw, pEP ,pEw, pCS, pULims, xdim, Xtol, DUtol);
                        Avm(NVm,:) = a(1,:);
                      	
                            
                     	break
                    end

                end
                    
            end
       
        end
            
        vR = vR + NcvP(cR,1)-1; % accumulated vtx ref (considering contour loop vtx)
            
	end
	end
      
    % 3.- RE-ALLOCATES TO Bskin:
    
	Bskin(s,1).iem = iem ;
        
	Bskin(s,1).mNVm   = NVm ;
	Bskin(s,1).mTVcon = TVm;
	Bskin(s,1).mLVcon = LVm;
      
    Bskin(s,1).mAv = Avm;
	Bskin(s,1).mUv = Uvm;
	Bskin(s,1).mXv = Xvm; 
    
    

end
    
    
end

