function [Eskin] = su2918_GPicp (Spatches, Npa, insR, Eskin)

% RETURNS:
% Eskin.mGP with patches icp's and correspondant basis function values

for pa = 1:1:Npa
    
    pudim   = Spatches(pa).Udim;
    pnbe    = Spatches(pa).nbe;
    pRbe    = Spatches(pa).Rbe;
    mA      = Spatches(pa).mRefin(insR).mA;
    nAN     = Spatches(pa).mRefin(insR).nAN;
    Degree  = Spatches(pa).mRefin(insR).mDegree;
     
    
    
    for b = 1:1:pnbe

        bR = pRbe(b);
      	nGP = Eskin(bR).nGP;
     	esGP = Eskin(bR).mGP;

        for g = 1:1:nGP
            
            %Eskin(bR).mGP(g).mNicp  = 0 ;
            %Eskin(bR).mGP(g).mRicpA = zeros(1,1);
            %Eskin(bR).mGP(g).Rrel   = zeros(1,1);
            
            tNicp = 0 ;
            tRicpA = zeros(1,1);
            
            u = esGP(g).mAcoor;
            
            % 1.- stores all anchors influencing on that gp in temporary vbles:
            % they are candidate anchors
            
            for a = 1:1:nAN
                
                % only carries on if the anchor contains that B.E.
                EskR = mA(a).mEskR;
                NEsk = mA(a).mNEsk;
                [alreadyIN,~] = GEN_21_alreadyIN_tol (EskR, NEsk, 1, bR, 1);
                
                if alreadyIN == 1
                    
                    aULims = mA(a).mPcoLi;
                    IN = GEN_08_Orthodom_Pin_ndec (u, aULims, pudim, 'closed', 9);
                    if IN==1
                        tNicp = tNicp + 1 ;
                        tRicpA(tNicp,1) = a ;
                    end
                end
            end
            
            
            % 2.- computes bf values of candidate anchors:
            
            Ta = t2606_TNURBS_at_u (tNicp, tRicpA, mA, Degree, u, pudim); % T-NURBS values at u
            
            
            % 3.- only transfers those anchors that have value > 0
            
            Nicp = 0;
            
            for a=1:1:tNicp
            if round(Ta(a),9)>0
                
                Nicp = Nicp + 1 ;
                
                aR = tRicpA(a);
                
                %Eskin(bR).mGP(g).mRicpA(Nicp,1) = aR ;
                %Eskin(bR).mGP(g).Rrel(Nicp,1) = Ta(a);
                
                esGP(g).mRicpA(Nicp,1) = aR ;
                esGP(g).Rrel(Nicp,1) = Ta(a);
            end
            end
            
            %Eskin(bR).mGP(g).mNicp = Nicp ;
            esGP(g).mNicp = Nicp ;            

        end 
        
        
        Eskin(bR).mGP = esGP;
        
        Spatches(1).mRefin(1).mBskin(7).mGP(514).mNicp
        
    end

    
  
    
end

end

