function [L,l,avL] = sf3157_stretchesL (Nos, XP, dir, a)

% RETURNS:
% L:    total length of a concatenation of stretches
% l(i): length of each stretch
% avL: average length
    
% INPUTS:
% Nos: No. stretches
% XP(i,j,xdim): points coord's, a tensor products of 2 param. directions
% dir: paremeter direction of movement: 1 or 2
% a: index of fixed direction (opp. to dir)

L = 0 ;
l = zeros(Nos,1);
xdim = 2 ;

for b = 1:1:Nos
    
    if dir==1
        i1 = b ;    i2 = b+1 ;
        j1 = a ;    j2 = a ;
    elseif dir==2
     	i1 = a ;    i2 = a ;
        j1 = b ;    j2 = b+1 ;
    end
     
    l(b) = 0 ;
    for di=1:1:xdim
        l(b) = l(b) + (XP(i2,j2,di) - XP(i1,j1,di))^2;
    end
    l(b) = (l(b))^0.5;

    L = L + l(b);
end

avL = L / Nos;

end

