function [s, vert, D] = sf3158_stretchesS (Nos, XP, dir, a)

% RETURNS:
% s(i): slope of each stretch
% D(i,xdim): increment of coordinates in each stretch
% vert: 1 /-1 / 0 for infinite, minus infinite, others
    
% INPUTS:
% Nos: No. stretches
% XP(i,j,xdim): points coord's, a tensor products of 2 param. directions
% dir: paremeter direction of movement: 1 or 2
% a: index of fixed direction (opp. to dir)

xdim = 2;

s = zeros(Nos,1);
vert = 0 ;
D = zeros(Nos,xdim);


for b = 1:1:Nos
    
    if dir==1
        i1 = b ;    i2 = b+1 ;
        j1 = a ;    j2 = a ;
    elseif dir==2
     	i1 = a ;    i2 = a ;
        j1 = b ;    j2 = b+1 ;
    end
     
    for di=1:1:xdim
        D(b,di) = (XP(i2,j2,di) - XP(i1,j1,di));
    end
    
    s(b) = (XP(i2,j2,2) - XP(i1,j1,2)) / (XP(i2,j2,1) - XP(i1,j1,1)) ;

    if (XP(i2,j2,1) - XP(i1,j1,1))==0
        
        if (XP(i2,j2,2) - XP(i1,j1,2))>0
            vert=1;
        else
            vert=-1;
        end
    end
    
end



end

