function [Ls] = rs3344_LsegmTitaWithGP ...
            (ua,ub, NGP, ULims, NE,NEt, ULimEr, ULimEpr, fpeR,fceR, conM,conMp,conMc, grEp,vDirp, nUcoor, dSu, dSv, xdim)

% RETURNS:
% Ls: length of segment in NURBS surface between ua and ub, that forms tita
% angle w.r.t. horizontal in parameter space

[GPpc, Wg] = ip2301_GP_1D (NGP);

unp = [0 ; norm(ub-ua)];

tita = atan2((ub(2)-ua(2)),(ub(1)-ua(1)));

Ls = 0 ;

udim = 1 ;
[dJ2] = j2313_Jac2_elem (2, udim, 0, unp');

for g = 1:1:NGP
    
    uG = GPpc(g);
    Du = m2321_parentMapping (uG, unp, 1,2);
    
    u = [ua(1)+Du*cos(tita) , ua(2)+Du*sin(tita)];
    
    %[dS] = rs3352_dSdir ...
    %(u, tita, ULims, NE, NEt, ULimEr, ULimEpr, fpeR,fceR, conM,conMp,conMc, grEp,vDirp, nUcoor, dSu,dSv, xdim);
    %dJ1 = norm(dS);    

    [NeR, eR] = rs3346_FindRele (ULims, NE, NEt, grEp, ULimEr, ULimEpr, fpeR, u);
    [mdC] = rs3366_BiLmdCtita (u, tita,  NeR, eR, fpeR, fceR, conM, conMp, conMc, nUcoor,vDirp, dSu, dSv, xdim);
    dJ1 = mdC;
    
    
    Ls = Ls + dJ2 * dJ1 * Wg(g)  ;
end





end

