function [eLs] = rs3345_LsegmTitaWithdCu ...
                (uar,ubr, ULims, NE, NEt, ULimEr, ULimEpr,fpeR,fceR,conM,conMp,conMc, grEp, vDirp, nUcoor, dSu,dSv, xdim,nd)                
% RETURNS:
% L: estimated using integral of derivative of surface in tita direction

% INPUTS:
% uar,ubr: param. coordinates rounded up

tita = atan2((ubr(2)-uar(2)),(ubr(1)-uar(1)));


% 1.- Determines if both points lie in same element:
    
[nEa, eRa, nEb, eRb, seF] = rs3357_elemsInfo ...
(ULims, NE, NEt, grEp, ULimEr, ULimEpr, fpeR, uar, ubr);

% 2.- Computes derivatives at each location:

%{
[dSsg] = rs3352_dSdir ...
(uar, tita, ULims, NE, NEt, ULimEr, ULimEpr, fpeR,fceR, conM, conMp, conMc, grEp,vDirp, nUcoor, dSu,dSv, xdim);
mSa = norm(dSsg); 

[dSsg] = rs3352_dSdir ...
(ubr, tita, ULims, NE, NEt, ULimEr, ULimEpr, fpeR,fceR, conM, conMp, conMc, grEp,vDirp, nUcoor, dSu,dSv, xdim);
mSb = norm(dSsg); 
%}

[NeR, eR] = rs3346_FindRele (ULims, NE, NEt, grEp, ULimEr, ULimEpr, fpeR, uar);
[mSa] = rs3366_BiLmdCtita (uar, tita, NeR, eR, fpeR, fceR, conM, conMp, conMc, nUcoor,vDirp, dSu, dSv, xdim);

[NeR, eR] = rs3346_FindRele (ULims, NE, NEt, grEp, ULimEr, ULimEpr, fpeR, ubr);
[mSb] = rs3366_BiLmdCtita (ubr, tita, NeR, eR, fpeR, fceR, conM, conMp, conMc, nUcoor,vDirp, dSu, dSv, xdim);

% 3.- In case of same element integrates directly:
   
if seF == 1
    eLs  = rs3358_distXinSgU (uar, ubr, mSa, mSb);
end
    
   

% 4.- In case of different elements integrates by segments:
    
if seF == 0
    
    [NU, uSg, mSg, NieR, ieR] = rs3359_intersecDuEls ...
   	(tita, uar, ubr, nEa, nEb, eRa, eRb, ULims, NE, NEt, ULimEr, ULimEpr,fpeR,fceR,conM,conMp,conMc, grEp, vDirp, nUcoor, dSu,dSv, nd); 

   	eLs = 0 ;
   	for po = 1:1:NU-1

        u1 = [uSg(po,1) uSg(po,2)];
        u2 = [uSg(po+1,1) uSg(po+1,2)];
        eLspo  = rs3358_distXinSgU (u1, u2, mSg(po), mSg(po+1));
        
      	eLs = eLs + eLspo;
   	end
end


end

