function [dSdir] = rs3352_dSdirR ...
         (u, tita, ULims, NE, NEt, ULimE, ULimEp, fpeR,fceR, conM, conMp, conMc, grEp,vDirp, nUcoor, dSu,dSv, xdim)

% RETURNS:
% dSdir(xdim,1): derivative of surface in direction tita (angle in radians
% in param. direction w.r.t. horizontal)

% INPUTS:
% u(2): location where compute derivative
% tita: angle in rads
% NE, ULimE, conM: rect-mesh features


% finds element and sets limits:
[~, eR] = rs3346_FindRele (ULims, NE, NEt, grEp, ULimE, ULimEp, fpeR, u);


% interpolates derivatives: assumes rect elemetns
[dSui, dSvi] = rs3354_BiLinInterp (u, eR(1), fpeR, fceR, conM, conMp, conMc, vDirp, nUcoor, dSu, dSv, xdim);


% directional derivative
dSdir = zeros(xdim,1);
for di=1:1:xdim
    dSdir(di) = dSui(di)*cos(tita) + dSvi(di)*sin(tita);
end




end

