function [dSdir] = rs3353_dSdir_eRR (u, tita, NeR, eR, fpeR, fceR, conM, conMp, conMc, vDirp, nUcoor, dSu,dSv, xdim)

% RETURNS:
% dSdir(xdim,1): derivative of surface in direction tita (angle in radians
% in param. direction w.r.t. horizontal), given element refernce eR where
% the point lies in

% INPUTS:
% u(2): location where compute derivative
% tita: angle in rads
% NE, ULimE, conM: rect-mesh features


% 1.- Computes for each of the elements references the 
% derivatives and then the averages:

dSui = zeros(xdim,1);
dSvi = zeros(xdim,1);

for e = 1:1:NeR

    
    
    % 1.1.- interpolates derivatives:
    [dSuie, dSvie] = rs3354_BiLinInterp (u, eR(e), fpeR, fceR, conM, conMp, conMc, vDirp, nUcoor, dSu, dSv, xdim);
                                        
    
    % 1.2.- sums to accumulated:
    dSui = dSui + dSuie;
    dSvi = dSvi + dSvie;
    
end

% 1.3.- Computes average:
dSui = dSui / NeR ;
dSvi = dSvi / NeR ;



% 2.- Computes directional derivative:

dSdir = zeros(xdim,1);
for di=1:1:xdim
    dSdir(di) = dSui(di)*cos(tita) + dSvi(di)*sin(tita);
end


end

