function [dSui, dSvi] = rs3356_BiLinInterpPeER (u1,u2, u, conMp, eReff, dSu, dSv, xdim)

% RETURNS:
% dSui, dSvi: interpolated vectors using linear interpolation, for 'Perimeter Elements'

L = (u2-u1);

N(1) = (u2-u) / L ;
N(2) = (u-u1) / L ;

dSui = zeros(xdim,1);
dSvi = zeros(xdim,1);

for nod = 1:1:2
    
    nR = conMp(eReff,nod);
    
    for di=1:1:xdim
        dSui(di) = dSui(di) + N(nod)*dSu(nR,di) ;
        dSvi(di) = dSvi(di) + N(nod)*dSv(nR,di) ;
    end

end

end

