function [nEa, eRa, nEb, eRb, seF, nEs, eRs] = rs3357_elemsInfo ...
                                                (ULims, NE, NEt, grEp, ULimEr, ULimEpr, fpeR, uar, ubr)

% RETURNS:
% nEa, nEb: No. elements where ua and ub lie (can multiple if u at edge)
% eRa, eRb: elements references, where ua and ub lie
% seF: same element flag (seF = 1 if ua and ub lie in the same element)
% nEs: No. shared elements
% eRs: shared element reference, in case points are in the same element


% 1.- ELEMENTS WHERE ua & ub LIE IN: eRa/eRb stores elements by ascending area

[nEa, eRa] = rs3346_FindRele (ULims, NE, NEt, grEp, ULimEr, ULimEpr, fpeR, uar);
[nEb, eRb] = rs3346_FindRele (ULims, NE, NEt, grEp, ULimEr, ULimEpr, fpeR, ubr);


% 2.- DETERMINES IF ua & ub LIE IN THE SAME ELEMENT:

seF = 0 ;
nEs = 0 ;
eRs = zeros(1,1);

for a = 1:1:nEa
    for b = 1:1:nEb
        if eRa(a)== eRb(b)
            nEs = nEs + 1;
            eRs(nEs,1) = eRa(a);
        end
    end
end

if nEs > 0
   seF = 1 ; 
end


end

