function [ui, uj, NneR, neR, riF] = rs3363_intersecNextEl ...
                 (upi, tita, NceR, ceR, fpeR,fceR, ULims, NE, NEt, grEp, vDirp, ULimE,ULimEp, conM,conMp,conMc, nUcoor, nd, Ttol)

% RETURNS:
% ui:   param. coord's of intersection between line and next element (inlet)
% uj:   param. coord's of outlet point
% neR:  NEXT element reference that intersects with the line
% riF:  'Rmax is infinte' flag, turns to 0 if ray comes into perim. or
%       corner elemnt in the infinite direction

% INPUTS:
% upi:  point of current element. Is the initial 'pivot' the segment starts from
% tita: direction of line in param. space
% ceR:  current element reference (where up lies in)


% 1.- FINDS NEXT POINT IN CURRENT ELEMENTS 'ceR', which is ui.
%     Condition for ui is that ui <> upi

[ui] = rs3364_rayEleInts ...
        (NceR, ceR, upi, tita, conM,conMp,conMc, nUcoor, fpeR,fceR, grEp, vDirp, nd, Ttol);
        
    
% 2.- FINDS OTHER ELEMENTs THAN ceR THAT CONTAINS ui (finds elements neR):

% 2.1.- Search elements that contains ui:
uir = round(ui,nd);
[NneRt, neRt] = rs3346_FindRele (ULims, NE, NEt, grEp, ULimE, ULimEp, fpeR, uir);

% 2.2.- Select the ones different from ceR:
NneR = 0 ;
neR = zeros(1,1);

for e2 = 1:1:NneRt
    
    nrF = 1 ; % non-repeated flag
    
    for e1 = 1:1:NceR 
        if ceR(e1)==neRt(e2)
            nrF = 0 ;
            break
        end
    end
    
    if nrF==1 
        NneR = NneR+1;
        neR(1,NneR) = neRt(e2);
    end
end



% 3.- CHECKS IF IS IN THE INFINITE DIRECTION:

% 3.1.- checks it:
[riF] = rs3362_RmaxInf (ui, tita, ULims, nd, Ttol);

% 3.2.- If infinite direction stops function:
if riF == 1
    uj = 0 ;
    return
end


% 4.- IN CASE OF NON-INFINITE DIRECTION => FINDS NEXT POINT IN neR (uj):

[uj] = rs3364_rayEleInts ...
        (NneR, neR, ui, tita, conM,conMp,conMc, nUcoor, fpeR,fceR, grEp, vDirp, nd, Ttol);
        


end

