function [mdCu2] = rs3386_mdCu2 (dCu, mdCu, dCu1, dCu2, xdim)

% RETURNS:
% mdCu2(2): first and second derivative of mdCu

% INPUTS:
% dCu1, dCu2: frist and second derivatives (vectors) in tita direction of surface
% dCu: vector
% mdCu: modulus of dCu

% A and B coefficients: 

A = 0 ;
B = 0 ;

for di = 1:1:xdim
    A = A + dCu(di) * dCu1(di);
    B = B + dCu1(di) * dCu1(di) + dCu(di) * dCu2(di) ;
end


% computes first and second derivative of mdCu, and allocates:

d1 = A / mdCu ;
d2 = (B * mdCu - A * d1) / mdCu^2 ;

mdCu2 = [d1 ; d2];





end

