function [ub] = rs3390_bscU (csw,enR, ua, ed, refAngle, dSu, dSv, dCmesh, Dumax, ULims, xdim, nd)

% RETURNS:
% ub(2): U-coordinates estiamted for a X-distance csw from the
% patch edge forming 90 dgrees in X-space

% INPUTS:
% enR: node ref. origin of segment 
% ua: Ucoord's of the node
% ed: edge

dSl = zeros(xdim,1); % paralel and perp. deriv. vectors to edge considered
dSr = zeros(xdim,1);
vn   = zeros(xdim,1); % normal vector to dSl in plane of surface

% 1.- ESTIMATES ANGLE IN PARAM. SPACE CORRESPONDANT TO 90 W.R.T. PARALLEL
% DIRECTION TO EDGE IN PHYSICAL SPACE:

% parameter paral. and perp. vectors in physical space:
if ed<=2
    dSl(:,1) = dSv(enR,:);
    dSr(:,1) = dSu(enR,:);
else
    dSl(:,1) = dSu(enR,:);
    dSr(:,1) = dSv(enR,:);
end

% checks paralelism at dSl and dSr:
[PV] = go2509_ParallelVectors (dSl, dSr, xdim, nd);

if PV == 0 % non -parallel vectors

    % vp = dSr x dSl  & vn = vp x dSl 
    vp = cross(dSr,dSl);
    vn = cross(dSl,vp);

    % B angle from vn to dSl & from dSr to dSl
    Bnl = acos(  dot(vn, dSl) / (norm(vn)* norm(dSl)) );
    Brl = acos( dot(dSr,dSl) / (norm(dSr)*norm(dSl)) );

    % B angle from vn to dSr (with sign) and estimed tita in param. space
    % note scales by Brl/90 factor

    Bnr = Bnl - Brl;

    if Brl < 90/57.3
        Afactor = Brl*57.3 / 90 ;
    else
        Afactor = (180-Brl*57.3) / 90 ;
    end

elseif PV==1 % special case of parallel
    
    Bnr = 45/57.3;
    Afactor=1;
    
end

tita = refAngle(ed) - Bnr * Afactor;
    





% 2.- COMPUTES POSITION:

[ub] = rs3350bb_DuForDx (csw, tita, ua, dCmesh, Dumax, ULims, xdim, nd);
    

end

