function [escF] = sv3343_eswIN_NT (u, Nesc, Uesc, UescM)

% RETURNS:
% escF = 1 if the point is inside the edge strip contour (point to be considered)

% for non-trimmed surfaces

% initially assumes is IN:

escF = 1 ;

% first checks if is candidate point, if so carries out a more detailed check
% recall edges start at 0,0 and move clockwise


% 1.- LOOP ON EDGES: to detect if is out

Mfd = [2 1 2 1];    % fixed direction
Mvd = [1 2 1 2];    % vble. direction
Msg = [1 -1 -1 1];  % sign matrix

for edR = 1:1:4
    
    % 1.1.- Establishes fixed/vble dirs and sign to compare:
    
    fd = Mfd(edR) ;
    vd = Mvd(edR) ;
    sg = Msg(edR);

    
    % 1.2.- If u is below envelope threshold continues:
    
    if sg*u(fd) < sg*UescM(edR)
        
        % 1.3.- Searches relevant segment of edge edR:
        
        for po = 1:1:Nesc(edR)-1

            ua = [ Uesc(edR,po,1)    Uesc(edR,po,2)];
            ub = [ Uesc(edR,po+1,1)  Uesc(edR,po+1,2)];

            % finds segment at the same position
            if (ua(vd) <= u(vd) && u(vd) <= ub(vd)) || (ub(vd) <= u(vd) && u(vd) <= ua(vd))

                % if u it is at RHS of ua-ub => OUT
                % ( ua-u x ua-ub > 0 )
                
                vab = [ [ub-ua] 0 ];
                vau = [ [u-ua]  0 ];
                v3 = cross(vau,vab);

                if v3(3) > 0
                    escF = 0 ;
                end

                break
            end 
        end
        
    end

end


end

