function [connT, THC, MLT] = ds3561_CorrSL ...
    (deR, connT, THC, MLT, gN, gL, CPp, Spatches, pR, rTskin, agCurv, Xtol, DUtol)

% RETURNS: updated tets and MLT with SLIVER tet removed.
% The remaining tets, affected, are split coz new node is inserted in the
% 'crossing point' of the sliver tet


% 1.- SELECTION OF LINE TO STAY and TO REMOVE:
% Re-arranges gN, gL and CPp to place first line to stay and second line to remove:

[ugN, ugL, uCPp] = ds3562_idenfLines (THC, gN, gL, CPp);

   
% 2.- NEW NODE COORD: eTHC

[eTHC, mLR] = ds3563_eTHC (ugN, ugL, uCPp, Spatches, pR, THC, MLT, rTskin, agCurv, Xtol, DUtol);


% 3.- UPDATES TETS:

oconnT = connT ;

[connT, THC, Ne, eR] = ds3564_upTets (connT, THC, ugN, ugL, deR, eTHC);

   
% 4.- UPDATES MLT (if applies):

if mLR > 0
    [MLT] = ds3565_upMLT (pR, Spatches, MLT, eTHC, mLR);
end



        
        
% Prints for checking:
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%{
     
if deR == 0

    fr = deR ;
    figure(fr)

    % orginial element to delete
    pt1373_pTetConn (deR, oconnT, THC.Av, fr, 'r', 0.33, 3.2, 0, 0); 



    for k = 1:1:2
        for i = 1:1:Ne(k)

        pt1373_pTetConn (eR(k,i), oconnT, THC.Av, fr, 'k', 1, 0.55, 0, 0);
        pt1373_pTetConn (eR(k,i),  connT, THC.Av, 100+fr, 'k', 1, 0.55, 0, 0);

        end
    end

    pNE = size(connT.EV,1);  
    eR = [ [pNE-sum(Ne)+2:1:pNE]' ;  deR] ;



    for i = 1:1:sum(Ne)
        pt1373_pTetConn (eR(i), connT, THC.Av, 100+fr, 'k', 1, 0.55, 0, 0);
    end

    scatter3 ( eTHC.Av(1),  eTHC.Av(2), eTHC.Av(3), 'r'); hold on

    pt1373_pTetConn (deR, connT, THC.Av, 100+fr, 'g', 0.33, 2, 0, 0);

    axis equal


    %if JJ==0
    %end

end


if deR > 0
    
    fr = deR ;
    figure(fr)
    
    pm0650_plotMLT (MLT, fr, 'k', 1, 0, 0, 0, 0, 0, 0, 0, 0)
    
    scatter3 ( eTHC.Av(1),  eTHC.Av(2), eTHC.Av(3), 'r'); hold on

    axis equal
    
end



%}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        



end

