function [ugN, ugL, uCPp] = ds3562_idenfLines (THC, gN, gL, CPp)


pudim = 3 ;

ugL = zeros(2,1);
ugN = zeros(2,2);
uCPp = zeros(2,pudim);

% 1.- The line with both nodes in MLT stays, if the other has both nodes not in MLT:

if (THC.rm(gN(1,1)) > 0 && THC.rm(gN(1,2)) > 0) && (THC.rm(gN(2,1)) == 0 && THC.rm(gN(2,2)) == 0)
     
    si = 1 ;
    ri = 2 ;

elseif (THC.rm(gN(1,1)) == 0 && THC.rm(gN(1,2)) == 0) && (THC.rm(gN(2,1)) > 0 && THC.rm(gN(2,2)) > 0)
    
    si = 2 ;
    ri = 1 ;
    
end


% 2.- If the pair of lines are in or OUT the MLT, removes the longest:

if ugL(1,1) == 0
    
    L1 = zeros(2,pudim);
    L2 = zeros(2,pudim);
    
    for i = 1:1:2
        L1(i,:) = THC.Av(gN(i,1),:);
        L2(i,:) = THC.Av(gN(i,2),:);
    end
    
    L1 = norm( L1(2,:) - L1(1,:) );
    L2 = norm( L2(2,:) - L2(1,:) );

    if L2 > L1 
        si = 1 ;
        ri = 2 ;
    else
        si = 2 ;
        ri = 1 ;
    end
    
end


% 3.- Allocates:

ugL(1) = gL(si) ;
ugL(2) = gL(ri) ;

ugN(1,:) = gN(si,:);
ugN(2,:) = gN(ri,:);
    
uCPp(1,:) = CPp(si,:);
uCPp(2,:) = CPp(ri,:);


end

