function [eTHC, mLR] = ds3563_eTHC (ugN, ugL, uCPp, Spatches, pR, THC, MLT, rTskin, agCurv, Xtol, DUtol)

% RETURNS:
% eTHC: new node to insert
% mLR : line of MLT where the new node is to insert. mLR = 0 if MTL is not involved



pudim = 3 ;
xdim = 3 ;

pDegree = Spatches(pR).INS(1).mDegree;
pNcp    = Spatches(pR).INS(1).mNcp;
pKnotV  = Spatches(pR).INS(1).mKnotV;
pP      = Spatches(pR).INS(1).mP;
pw      = Spatches(pR).INS(1).mw;
pUsize  = Spatches(pR).INS(1).mUsize;
pULims  = [0 1 ; 0 1 ; 0 1 ];
pEP     = Spatches(pR).INS(1).mEP;
pEw     = Spatches(pR).INS(1).mEw;
pCD     = [ 0 0 0 ];

n1 = ugN(1,1);
n2 = ugN(1,2);

% 2.1.- Proportion from nodes 1 and 2:

d1 = THC.Av(n1,:) - uCPp(1,:);
d2 = THC.Av(n2,:) - uCPp(1,:);

d1 = norm(d1);
d2 = norm(d2);

N1 = d2 / (d1+d2);
N2 = d1 / (d1+d2);


% 2.2.- Check if line is to stay is MLT:

rm = [ THC.rm(n1) ; THC.rm(n2) ];

mLR = 0 ; % ref of MLT line

if rm(1) > 0 && rm(2) > 0
    
    % searches a MLT line with both nodes:

    for i = 1:1:size(MLT.tVLcon,2)
        
        r = MLT.tVLcon(rm(1),i);
        if r > 0
            
            if MLT.tLVcon(r,1) == rm(2) || MLT.tLVcon(r,2) == rm(2)
                mLR = r ;
                break
            end
        end
    end
end


% 2.3.- Case mLR exists:

if mLR > 0

    ILn = [ n1 rm(1) ;
            n2 rm(2) ];

    [mn, B0, U0, A0, csM] = ts1615_info2projN (ILn, THC, [N1,N2]);

    eTHC = ts1614_inU0 (0, Spatches, pR, rTskin, agCurv, csM, MLT, B0, U0, A0, Xtol, DUtol);

end


% 2.4.- Case mLR does not exist: just at selected A-location:

if mLR == 0 
    
    eTHC = struct...
    ('Xv',[], 'Av',[], 'Uv',[], 'Bv',[], 'NCS',[], 'rm', 0 );
    
    A0(:,1) = N1 * THC.Av(n1,:) +  N2 * THC.Av(n2,:);
    eTHC.Av = A0;
    
   	X = b2601_BNURBS_Xcoord (A0 , pKnotV, pNcp, pDegree, pUsize, pEw, pEP, pudim, xdim);
    eTHC.Xv = X ;
    
    eTHC.Bv = 0 ;
    eTHC.Uv = [0 0]' ;
    
    eTHC.NCS = [0 0];
    eTHC.rm = 0 ;
    
end



end

