function [connT, THC, Ne, eR] = ds3564_upTets (connT, THC, ugN, ugL, deR, eTHC)


% 1.- UPDATES VERTEXES:

pNV = size(THC.Av,1) + 1; 
nnR = pNV ;
    
THC.Bv = [ THC.Bv ; eTHC.Bv ];
THC.Uv = [ THC.Uv ; eTHC.Uv' ];
THC.Av = [ THC.Av ; eTHC.Av' ];
THC.Xv = [ THC.Xv ; eTHC.Xv' ];
        
THC.NCS = [ THC.NCS ; eTHC.NCS ];
THC.rm  = [ THC.rm ; eTHC.rm ];
     

% 2.- IDENTIFIES ELEMENTS TO SPLIT and NODES OF LINES
% First elemns attached to line that stays, and second to the line that is
% to be removed.

Ne = zeros(2,1);
eR = zeros(2,1);

for k = 1:1:2

    rL = ugL(k); % ref. of line

    for i = 1:1:size(connT.LE,2)

        r = connT.LE(rL,i);

        if r > 0 && r ~= deR
            Ne(k) = Ne(k)  + 1 ;
            eR(k,Ne(k)) = r ; 
        end
    end

end


    
% 3.- UPDATES CONN. AND No. ELEMS:

oconnT = connT ;
pNE = size(connT.EV,1);

% 3.1.- Splits nodes attached to affected lines

for k = 1:1:2 
    
	nR = [ ugN(k,1) , ugN(k,2) ] ;
        
	LeRd = zeros(Ne(k),2);

    for i = 1:1:Ne(k)
        leR = ts1620_LedgeR (oconnT, nR, eR(k,i));
        LeRd(i,1) = leR(1);
        LeRd(i,2) = leR(2);    
    end
        
	ieR = [eR(k,1:Ne(k))]';
        
	[pNE, connT] = ei1663_TetDiv2 (THC, pNE, connT, Ne(k), ieR, nnR, LeRd);
        
end
    
% 3.2.- Deletes element deR:

[pNE, connT.EV] = th1322_remTetNS (pNE, connT.EV, deR); 
  

% 3.3.- Updates rest of conn. matrices:

[connT] = th1333_OtherConnLin (pNE, pNV, connT.EV);


end

