classdef CouplingConditions < Conditions

% Coupling conditions: describes which patches are coupled
    
    
properties
    
    mPatches ; % array with patches that are connected by the coupling
                % the first reference in mSurfaces vector is the master
                % surface
    
end
    



methods
    
    function obj = CouplingConditions()
        % constructor by default 
        obj.mPatches = zeros(1,1);
    end   
    
    function Patches(obj,pat, Npat)
        
        % stores involved patches in mPatches
        % INPUTS:
        % pat:  array with patches references
        % Npat: No. patches involved
        
        obj.mPatches = zeros(Npat,1);
        
        for s = 1:1:Npat
            obj.mPatches(s) = pat(s); % 1st patch ref. is the master patch
        end
        
    end
    
    
end
    



end

