classdef Mesh < handle

% Stores mesh data of one patch
    
properties

    nELp;           % No. non-void elelemnts, parameter mesh
    nNOp;            % No. nodes of the mesh

    mE = GenElem();	% elements object, each element is GenElem
    
    mNp = GenGeomPoint();  	% (nNO), nodes in param. / physical space
    
    nWIp;             % No. wires
    mWp = GenWire();  % wires object
    
    % wires connectivity matrices
    conENp;  % (nELp, corner nodes per element)
    conENSp; % (nELp, side nodes per element)
    
    conEWp; % (nELp, wires per element)
    conWEp; % (nWIp, elements per wire)
    conWNp; % (nWIp, 2) nodes from mNp at the end of the wire
    
end
    
methods
    
    function obj = Mesh()
    % constructor by default 
       
        %obj.mW = WIRE(); 
      
    end
    
    
    
    
    function allocates_nodCoor(obj,Nonod,nodesP, uD,xD, KnotV, w,B, Ncp, Degree,Usize )
        % provides nodes coordinates matrices
        
        % INPUTS:
        % Nonod:    No. nodes
        % nodesP:   matrix with nodes param. coordinates
        % uD,xD:    dims in parameter and physical space
        % uD,... :  patch features
        
        
        % 1.- Provides sizes:
        obj.nodU = zeros (Nonod,uD);
        obj.nodX = zeros (Nonod,xD);
        P = zeros(uD,1);
        
        
        % 2.- Expand cp's coord's:
        [Ew,EB] = GEN_12_ExpandBw( w,B,xD, Ncp );
        
        
        % 3.- Populates:
        for node = 1:1:Nonod
            
            for di=1:1:uD
                obj.nodU (node,di) = nodesP(node,di);
                P(di) = nodesP(node,di);
            end
            
            [X] = GEN_03_01_Solid_Surf_phys_coord( P, KnotV, Ncp,Degree,Usize, Ew,EB, uD,xD);
            
            for di=1:1:xD
                obj.nodX (node,di) = X(di);
            end  
        end
        
        
        
    end
    
    
    function allocates_conM(obj,Nne,nE, conn)
       % allocates connectivity matrix (nE, nodesRef) 
        
       % INPUTS:
       % Nne:   No. nodes per element
       % nE:    No. elements
       % conn:  connectivity matrix
       
       % 1.- Provides size:
       obj.conM = zeros(nE,Nne);
       
       % 2.- Populates matrix:
       obj.conM = conn ;
       
    end
    
    
    function allocates_elems(obj)
        % inizializtes element matrix and values for them
        obj.mE(obj.nEL) = TriangleTwoDimsElement();
    end
    
end
    
end

