classdef NEW_INSERTION < handle
    
    % new insertion in the T-mesh
    % always composed by a cross of two lines (parallels to xi and ita)
    
    properties
        
        %{
        %mNlin;  % No. lines
        %mLim;   % index limits of each line (mNlin, 2, udim)
        %emLim;  % index limits of each line (mNlin, 2, udim) for updated index basis
        %mDir;   % direction of each line (mNlin), 1 parallel to xi, 2 to ita
        
        %mLimP ; % param. limits of each line (mNlin, 2, udim)
        
        %nna;    % No. new anchors
        %mNaI;   % new anchors indexes (nna, udim) in terms of extg. mesh
        %}
        
        nNO;    % No. nodes of the partition (all new knots intersections)
        nPA;    % No. partitions (Partition)
        mNp;    % nodes object (GeomPoint)
        mP;     % partitions object
        conM;   % connetion matrix (nPA,Ncor), Ncor = 2^(udim-1)

    end
    
    
    
    
    methods

         
        function obj = NEW_INSERTION
            
            % constructor:
            obj.nNO = 0 ;
            obj.nPA = 0 ;
            obj.mNp = GenGeomPoint() ;
            obj.mP  = GenPartition() ;
            obj.conM = zeros(1,4);
            
        end
        
        
        function [IL, PL] = ExtractLims(obj, LR, pri, udim)
        
            % extracts limits of each line and prints if desired
            % INPUTS:
            
            % LR:   line reference to extract
            % pri:  'yes': prints , 'no': don't print
            
            
            IL = zeros(2,udim);
            PL = zeros(2,udim);

            for lim =1:1:2
            for di = 1:1:udim

                IL(lim,di) = obj.mLim(LR,lim, di);
                PL(lim,di) = obj.mLimP(LR,lim, di);
            end
            end
            
            % display info:
            if strcmp(pri,'yes')== 1
                disp( [ 'Line: ' , num2str(LR) ] ); 
                disp( [ 'Index - from ' , num2str(IL(1,1)) , ',' , num2str(IL(1,2)), '  to  ' , num2str(IL(2,1)) , ',' , num2str(IL(2,2))  ] ); 
                disp( [ 'Para. - from ' , num2str(PL(1,1)) , ',' , num2str(PL(1,2)), '  to  ' , num2str(PL(2,1)) , ',' , num2str(PL(2,2))  ] ); 
            end
           
        
        end
        
        
        
        
    end

    
end

