classdef cEskin

    properties
        
        % skin %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        % NURBS surface features:
        
        mDegree ;
        mKnotV ;
        mUsize ;
        mNcp ;
        mP ;
        mw ;
        
        mCS ; % closed surface flag
        mPN ; % plane surface flag
        
        % triangulation variables:
        
        mNE ;   % No. triangles or elements
        mNV ;   % No. vertexes (with no mid-edges vtx)
        %mNVm;   % No. vertexes with mid-edge vtx, for quadratic triangles
        
        mRv ;   % Vertexes pattern space coordinates
        mAv ;   % Vertexes param. space coordinates (in terms of solid space)
        mAvS ;  % Vertexes param. space coordinates (in terms of solid space), for slave patch, in case of coupling
        mUv ;   % Vertexes param. space coordinates (in terms of surface space)
        
        mNec;   % number of edge curves (migh be 2 for corner vertexes)
        mEv ;   % (Nec,1) Vertexes param. space coordinates (in terms of edge curve space, in case it applies)
        mER;    % (Nec,1) curve edge ref (local), in case it applies
        
        
        mXv ;   % Vertexes phys. space coordinates
        %mXv0 ;  % original undeformed
        %mXv2 ;  %  undeformed
        
        mTVcon; % connectiviy matrix (triangle to vertexes)
        mVTcon; % (vertex to triangles)
        
    	mLVcon; % connectiviy matrix (edge lines to vertexes)
        mVLcon; % 
        
        mTLcon; % triangle-line edge
        
        iem; % inserted edges matrix, for mixed degree triangles
        
        % derivatives at nodes and triangle centers (w.r.t. xi and ita)
        mArea ; % (NE,1) in phys. space
        
        % normal vectors in patch param. and phys spaces, for vtx and triangles:
        
        mANv ;
        mANe ;
        mXNv ;
        mXNe ;
        
    	mANvS ; % for slave patch
        mANeS ;
        mXNvS ;
        mXNeS ;
        
        % No. loops and points per loop:
        mNlo;    % No. loops
        mNCL;   % (mNlo,1) No. curves per loop
        % mNL;
        mNlv; % (Nlo,1) , from 1 to the last, but not the first again!
        mNlcv; % (Nlo,NCL)
        
        
     	% Integration points %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        mNgp ;
        mGP ;     
        
        % Others %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        % trimming flag
        mTr ; % 0 /0.5 / 1  = not-trim / trim no-shap / trim & shap
        
        % patch where the skin belongs to and coupling reference
        mPa; 
        mCou; % 0 if not coupling , otherwise it is the cupling reference
        
    end
    
    methods
    end
    
end

