function [rEskin, NcvE, cLUvE, cLXvE, qcfE] = st0301_rTskin ...
    (Spatches, Npa, Eskin, Nbe, agCurvE, CPcon, nloE, SCconE, ncuE, tolRc, tolRs, Xtol, DUtol, ndig, tolD, DerC)



% RETUNRS:
% rEskin: refinement of Eskin for integration-tet-mesh:

TNcuE = size(agCurvE,1);


% 1.- TARGET DISTANCE FOR INITIAL TRIANGULATION OF SKINS:

[sRt, pRt] = st0302_skinRt (Spatches, Npa, Eskin, Nbe, DUtol);



% 2.- INITIAL TRIANGULATION Eskins (all of them):

[rEskin, NcvE, cLUvE, cLXvE] = st0303_iniTriang ...
(Spatches, Eskin, agCurvE, Nbe, pRt, sRt, CPcon, nloE, SCconE, ncuE, tolRc, tolRs, Xtol, DUtol, ndig, tolD, DerC);



% 3.- SKINS APPROX. FOR T-SURFACES: 
%     Approximates Q to T-surfaces

K = 5 ;
tolS = 100 * K * DUtol / 1.73   ; % rEskin surface error (in patch parameter space), is K times greater than DUtol

[rEskin, NcvE, cLUvE, cLXvE, qcfE] = fs0700_fit2surf ...
(Spatches, rEskin, Nbe, agCurvE, tolS, Xtol, DUtol, TNcuE, NcvE, cLUvE, cLXvE, ncuE, nloE, SCconE);


% 4.- COMPUTES GP'S OF THE B.E.:

NGPe  = 3;
[rEskin] = st0304_GPEskin(Nbe, rEskin, NGPe, Spatches, Xtol, DUtol);



end