function [Bentities] = st0304_GPEskin ( Nbe, Bentities, NGPe, Spatches, Xtol, DUtol )

eudim = 2;
pudim = 3;
xdim  = 3;

for b = 1:1:Nbe 
    
    % 1.- PRELIMINARIES:
    
    skin = Bentities(b,1).INS(1,1).skin ;
    
    % 1.1.- Coupling flag = coup. ref. If not couling BE couR = 0
    
	couR = skin.mCou; 
    
    % 1.2.- Patches features:

    [pR, pDegree,  pNcp,  pKnotV,  pUsize,  pP,  pw,  pCD , pEw,  pEP, pULims, ...
    spR, spDegree, spNcp, spKnotV, spUsize, spP, spw, spCD, spEw, spEP, spULims] = ...
    so2938_patchNURBS (skin, Spatches, xdim);
    


    % 2.- COMPUTES Ngp, COORDINATES IN SURFACE PARAMETER SPACE 
    % AND AGREGATED JACOBIAN FOR EACH GAUSS POINT:
    
    [Ngp, Ug, aJ2, Amid, AmidS] = st0398_aJ2Ucoor (skin, NGPe, pudim, eudim, DUtol);

    
    % 3.- COMPUTES JACOBIAN_1 and COORDINATES (Xcoor and Acoor):
    
    aJ1 = zeros(Ngp,1);
    Xg  = zeros(Ngp,xdim);
    Ag  = zeros(Ngp,pudim);
    sAg = zeros(Ngp,pudim);
    
    eKnotV  = skin.mKnotV ;
    eNcp    = skin.mNcp ;
    eDegree = skin.mDegree ;
    eUsize  = skin.mUsize ;
    eP      = skin.mP ;
    ew      = skin.mw ;

    [eEw,eEP] = GEN_12_ExpandBw (ew, eP,xdim, eudim, eNcp);
    
    for g = 1:1:Ngp
        
        u(:,1) = Ug(g,:);
        
        Am(:,1) = Amid(g,:);
        AmS = zeros(xdim,1);
        
        if couR>0
            AmS(:,1) = AmidS(g,:);
        end
        
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        % needs to be done in analysis:
        % [~, detJ1] = j2315_J1_Bspline (u, eKnotV, eNcp, eDegree, eUsize, eP, ew, eudim, xdim);
        % aJ1(g,1) = detJ1;
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        
        [X, A, sA] = su2925_XAcoords ...
        (u, eKnotV, eNcp, eDegree, eUsize, eEw,eEP,...
        Am,   pDegree,  pNcp,  pKnotV,  pUsize,  pP , pw, pEP , pEw,  pCD,  pULims,...
        AmS, spDegree, spNcp, spKnotV, spUsize, spP ,spw, spEP ,spEw, spCD, spULims, ...
        couR, eudim, xdim, Xtol, DUtol);
        
        
        for di = 1:1:xdim
            Xg(g,di) = X(di);
            Ag(g,di) = A(di);
        end
    
        if couR>0
            sAg(g,:) = sA(1,:);
        end 
        
    end
    

    % 4.- ICP's and BASIS FUNCTIONS:
    
    Nacp = Spatches(pR).INS(1).mNacp;
    CP = Spatches(pR).INS(1).mCP;

    if couR > 0
        sNacp = Spatches(spR).INS(1).mNacp;
        sCP =  Spatches(spR).INS(1).mCP;
    end


    % 4.2.- Icp's from patch and Bf's values:
    
    gNicp = zeros(Ngp,1);
    gRicp = zeros(Ngp,1);
    gRrel = zeros(Ngp,1);
    
  	gNicpS = zeros(Ngp,1);
    gRicpS = zeros(Ngp,1);
    gRrelS = zeros(Ngp,1);
    
    a = zeros(pudim,1);
    
    for g = 1:1:Ngp
    
        a(:,1) = Ag(g,:);
        
        [Nicp, Ricp, ~, Rrel, ~] = su2926_IcpBf (a, pNcp, pKnotV, pUsize, Nacp, CP, pDegree, pudim);

        gNicp(g,1)  = Nicp;
        
        for i = 1:1:Nicp
            gRicp(g,i) = Ricp(i);
            gRrel(g,i) = Rrel(i);
        end
        

        if couR > 0

            a(:,1) = sAg(g,:);
            
            [Nicp, Ricp, ~, Rrel, ~] = su2926_IcpBf (a, spNcp, spKnotV, spUsize, sNacp, sCP, spDegree, pudim);

            gNicpS(g,1)  = Nicp;
            
            for i = 1:1:Nicp
                gRicpS(g,i) = Ricp(i);
                gRrelS(g,i) = Rrel(i);
            end
            
        end
    
    end
    
   
    
    
    % 4.- ALLOCATES GAUSS POINTS TO Bentities.INS.skin:

    Bentities(b,1).INS(1,1).skin.mNgp = Ngp ;
    
    GP(Ngp,1) = cGPbe; 

    for g = 1:1:Ngp
        
        GP(g,1).mUcoor = zeros(eudim,1);
        GP(g,1).mXcoor = zeros(xdim,1);
        
        GP(g,1).mUcoor(:,1) = Ug(g,:);
        GP(g,1).mXcoor(:,1) = Xg(g,:);
        
        GP(g,1).mAcoor(:,1) = Ag(g,:);
        
        if couR>0
            GP(g,1).mAcoorS(:,1) = sAg(g,:);
        end
        
        GP(g,1).dJ1 = aJ1(g,1);
        GP(g,1).dJ2a = aJ2(g,1);
        
        GP(g,1).mNicp = gNicp(g,1);
        
        
        for i = 1:1:gNicp(g,1)
         	GP(g,1).mRicp(i,1) = gRicp(g,i);
            GP(g,1).Rrel(i,1)  = gRrel(g,i);
        end
              
        
        if couR > 0
            
            GP(g,1).mNicpS = gNicpS(g,1);
            
            for i = 1:1:gNicpS(g,1)
                GP(g,1).mRicpS(i,1) = gRicpS(g,i);
                GP(g,1).RrelS(i,1)  = gRrelS(g,i);
            end
            
        end

    end
 
    Bentities(b,1).INS(1,1).skin.mGP = GP ;
    
    clearvars 'Ngp' 'GP'

    
end


end

