function [LVcon, ELcon, Avm, Xvm, NVm, Eiem, EVcon, Nve] = th1337_upQuad ...
    (agCurvE, Eskin, Spatches, pR, trpF, NE, NV, EVcon, Av, Xv, TTR, Xtol, DUtol)

% RETURNS: features including mid-vtx where line lies in shaping-surface
% flagET(NE,1) = 1 if element has at least one edge quadratic
% NVE(NE,1): No. vertexes per element

% NLI(3): No. lines: TTR, bounded surfaces and the rest

% 1.- PRELIMINARIES:

Nve = ones(NE,1)*4;
EVcon = [EVcon, zeros(NE,6)]; % extended conn. matrix, to account for mid-edge vertexes


r = [ 1 2 3 4 4 4 ; 
      2 3 1 1 2 3 ]'; % edges nodes references


NVm = NV ;
Avm = Av ;
Xvm = Xv ;


% 2.- UPDATES FEATURES OF LINES AND ELEMENTS RELATED TO QUADRATIC EDGES:
% (LINES-VTX-ELEMS conn. matrices)

LVcon = zeros(1,3); % might be linear or quadratic, the latter with the mid-nod in 2nd position of LVcon
ELcon = zeros(NE,6); % element - line connectivity

NLI = 0 ;


% 2.1.- first element:
 
e = 1 ;
for i = 1:1:6
    
    NLI = NLI + 1 ;
    ELcon(e,i) = NLI;
    
    n1 = EVcon(e,r(i,1));
    n2 = EVcon(e,r(i,2));

    [Nve, EVcon, LVcon, Xvm, Avm, NVm] = th1339_upQuadL ...
 	(trpF, e, Nve, EVcon, LVcon, Xvm, Avm, NVm, NLI, agCurvE, Eskin, n1,n2, TTR, Spatches, pR, Xtol, DUtol);

end


% 2.2.- rest of the elements:

for e = 2:1:NE
    for i = 1:1:6
        
        % candidate couple of nodes:
        
        n1 = EVcon(e,r(i,1));
        n2 = EVcon(e,r(i,2));
        
        
        % check if they're IN already (aIN=1)
        
        cpF = 0 ; % line is computed previously - flag
        lqF = 0 ; % line quadratic - flag
        lR  = 0 ; % line reference
        
        for j = 1:1:NLI

            % extg. nodes refs
            if LVcon(j,3)==0
                
                e1 = LVcon(j,1); 
                e2 = LVcon(j,2);
                lqF = 0;
                
            else
                e1 = LVcon(j,1);
                e2 = LVcon(j,3);
                lqF = 1;
                
            end
            
            if (e1==n1 && e2==n2) || (e2==n1 && e1==n2) 
                
                cpF = 1;
                lR = j ;
                ELcon(e,i) = j;
                break
                
            end
            
        end
        
        
        % case "line" is computed previously => updates element features:
        
        if cpF == 1
            
            ELcon(e,i) = lR ;
            
            if lqF == 1
                Nve(e,1) = Nve(e,1)+1 ;
                mvR = LVcon(lR,2); % mid-vertex ref.
                EVcon(e,Nve(e,1)) = mvR ;
            end
            
        end
        
        % case "line" is NOT computed previously => updates element and adds line:
        
        if cpF == 0
            
            NLI = NLI + 1 ;
            ELcon(e,i) = NLI;

            [Nve, EVcon, LVcon, Xvm, Avm, NVm] = th1339_upQuadL ...
            (trpF, e, Nve, EVcon, LVcon, Xvm, Avm, NVm, NLI, agCurvE, Eskin, n1,n2, TTR, Spatches, pR, Xtol, DUtol);
        
        end
        
        

    end
end



% 3.- MATRIX Eiem:

Eiem = zeros(NE,4,4);

if trpF == 1

    for e = 1:1:NE

        conta = 4 ;
        for i = 1:1:6

            lR = ELcon(e,i);
            if LVcon(lR,3)>0

                conta = conta + 1;

                Eiem(e,r(i,1), r(i,2)) = conta ;
                Eiem(e,r(i,2), r(i,1)) = conta ;
            end
        end
    end

end


end