function [Nve, EVcon, LVcon, Xvm, Avm, NVm] = th1339_upQuadL ...
    (trpF, eR, Nve, EVcon, LVcon, Xvm, Avm, NVm, NLI, agCurvE, Eskin, n1,n2, TTR, Spatches, pR, Xtol, DUtol)



% RETURNS:
% Nve, EVcon, LVcon, Xvm, Avm, NVm: updated with mid-point if applies

pudim = 3 ;
xdim  = 3 ;

if trpF == 1 

    % 1.- TRIMMED PATCHES:
    
    % 1.1.- Extracts patch and TTR features:

    pNcp     = Spatches(pR,1).INS(1).mNcp ;
    pDegree  = Spatches(pR,1).INS(1).mDegree ;
    pUsize   = Spatches(pR,1).INS(1).mUsize ;
    pKnotV   = Spatches(pR,1).INS(1).mKnotV ;
    pP       = Spatches(pR,1).INS(1).mP ;
    pw       = Spatches(pR,1).INS(1).mw ;

    pEP      = Spatches(pR,1).INS(1).mEP ;
    pEw      = Spatches(pR,1).INS(1).mEw ;

    pULims = zeros(pudim,2);

    for di = 1:1:pudim
        pULims(di,1) = pKnotV(di,1);
        pULims(di,2) = pKnotV(di,pUsize(di));
    end


    tNV = TTR.tNV ;

    tSR  = TTR.tSR ;
    tCR  = TTR.tCR ;

    tNS  = TTR.tNS ;
    tNC  = TTR.tNC ;

    tUs  = TTR.tUs ;
    tUc  = TTR.tUc ;



    % 1.2.- Checks if it is quadratic edge:

    [qlF, Xmc] = th1338_quadrLine (agCurvE, Eskin, n1,n2, tNV, tNC, tNS, tCR, tSR, tUc, tUs, Xvm, xdim, Xtol, DUtol);


    % 1.3.- Adds mid-node if required:

    if qlF == 0

        LVcon(NLI,1) = n1;
        LVcon(NLI,2) = n2;

    elseif qlF == 1

        NVm = NVm+1;

        Nve(eR,1) = Nve(eR,1)+1;
        EVcon(eR,Nve(eR,1)) = NVm ;

        LVcon(NLI,1) = n1;
        LVcon(NLI,2) = NVm;
        LVcon(NLI,3) = n2;

        Xvm(NVm,:) = Xmc(:,1);

        Amid = zeros(1,pudim);
        Amid(1,:) = (Avm(n1,:)+ Avm(n2,:))/2;

        %{
        [n1 n2]
        Avm(n1,:)
        Avm(n2,:)
        
        Xvm(n1,:)
        Xvm(n2,:)
        
        Xmc
        Amid
        
        %}
        
        [Amc, ~] = v2865b_onePoint (Xmc, Amid, pDegree, pNcp, pKnotV, pUsize, pP ,pw, pEP ,pEw, [0 0 0], pULims, xdim, Xtol, DUtol);
        Avm(NVm,:) = Amc(1,:);

    end

        
elseif trpF == 0 
        
    % 2.- UN-TRIMMED PATCHES:
    %  there are not mid-edge nodes
    
	LVcon(NLI,1) = n1;
	LVcon(NLI,2) = n2;
    
    
end



end

