function [n] = tm1304_TcondN (Cnod, dim)

% RETURNS:
% n: condition number based on triangle inequality

% INPUTS:
% Cnod(3,dim): nodes coordinates


% In the best case (equilateral), n = 2, otherwise is higher.
% Only for linear triangles.


% 1.- Measures the tree sides:

r = [ 1 2; 2 3 ; 3 1 ];

L = zeros(3,1);
v = zeros(dim,1);

for s = 1:1:3
    v(:,1) = Cnod(r(s,2),:) - Cnod(r(s,1),:) ;
    L(s,1) = norm(v);
end

% 2.- Orders:

L = sortrows(L,1);


% 3.- Computes condition number:

n =  (L(2) + L(3)) / L(1)  ;



end

