function [aD] = avT (D, T, ts, t0, f1, f2)

% RETURNS:
% aD: array that contains averaged D considering period T

% also plots aD and D in different graphs

% INPUTS:
% D(t,x): information of x parameter with time t as abscises
% T: period
% ts: time step
% t0: inital time to start to consider

% figures indexes: f1, f2 for average and all periods in one plot
% if they are 0 does not plot

% assumes all the time steps are same value


% 0.- PRELIMINAREIES:

finF = 0; % finished flag

Ns = round(T/ts,0) ;         % No. steps per period
aD = zeros(Ns,2);
tempD = zeros(1,Ns,2);

tnd = size(D,1); % total No. data


% 1.- STORES IN tempD EACH PERIOD SEPARATELY:

t = D(1,1);
j = 1 ;

while (finF==0)
    
    % finds starting point
    if (t-ts/2)<t0 && t0<(t+ts/2)
    
        % loops to store each period separately:
        contaT = 0 ;
        while(finF==0)
                    
            % stores in tempD each period separately:
            
            contaT = contaT+1;
            tt = 0;
            
            for i = 1:1:Ns
                tempD(contaT,i,1) = tt;
                tempD(contaT,i,2) = D(j,2);
                tt = tt+ts;
                j = j+1 ;
            end
        

            % evaluates if rest of data reaches the period T No. steps:
            
            rnd = tnd-j;
            if rnd < Ns
          	finF = 1 ;
            end
        end
        
        finF = 1 ; % finished flag
    end
    
    t = t+ts;
    j = j+1;
end


% 2.- COMPUTES AVERAGE:


acct = 0 ;
for i = 1:1:Ns
    
    % time:
    
    aD(i,1) = acct;
    
    acct = acct+ts;
    
    
    % x parameter:
    
    accx = 0 ;
    for j = 1:1:contaT
        accx = accx + tempD(j,i,2);
    end
    
    aD(i,2) = accx/contaT; 
    
end
    
    
    
% 3.- PLOTS:

if f1>0
    
    figure(f1)
    plot(aD(:,1), aD(:,2), 'b'); hold on; 
    axis equal
    
end


if f2>0
    
    figure(f2)
    
    for j = 1:1:contaT
        plot(tempD(j,:,1), tempD(j,:,2), 'r'); hold on; 
        axis equal
    end

end


end

